"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.find-index.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _AccordionProvider = _interopRequireDefault(require("./AccordionProvider"));

var _AccordionHeader = _interopRequireDefault(require("./AccordionHeader"));

var _AccordionContent = _interopRequireDefault(require("./AccordionContent"));

var _AccordionContext = _interopRequireDefault(require("./AccordionContext"));

var _AccordionProviderContext = _interopRequireDefault(require("./AccordionProviderContext"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _AccordionPropTypes = require("./AccordionPropTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var AccordionStore = function () {
  function AccordionStore(id) {
    _classCallCheck(this, AccordionStore);

    this._id = id;
    this._instances = [];
  }

  _createClass(AccordionStore, [{
    key: "onChange",
    value: function onChange(_ref) {
      var id = _ref.id;

      this._instances.forEach(function (inst) {
        if (inst._id !== id) {
          inst.close();
        }
      });
    }
  }, {
    key: "addInstance",
    value: function addInstance(instance) {
      this._instances.push(instance);
    }
  }, {
    key: "removeInstance",
    value: function removeInstance(instance) {
      this._instances = this._instances.filter(function (inst) {
        return inst !== instance;
      });
    }
  }]);

  return AccordionStore;
}();

var _ref3 = _react.default.createElement(_AccordionHeader.default, null);

var Accordion = function (_React$PureComponent) {
  _inherits(Accordion, _React$PureComponent);

  var _super = _createSuper(Accordion);

  function Accordion(props, context) {
    var _this;

    _classCallCheck(this, Accordion);

    _this = _super.call(this, props);

    _this.handleDisabledClick = function (e) {
      e.preventDefault();
      return false;
    };

    _this.callOnChangeHandler = function () {
      var _this2, _this$context;

      for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
        params[_key] = arguments[_key];
      }

      (_this2 = _this).callOnChange.apply(_this2, params);

      if ((_this$context = _this.context) !== null && _this$context !== void 0 && _this$context.onChange) {
        var _this$context2;

        (_this$context2 = _this.context) === null || _this$context2 === void 0 ? void 0 : _this$context2.onChange.apply(_this$context2, params);
      }

      if (_this.state.group && typeof window !== 'undefined') {
        var _window, _window$__dnbAccordio;

        (_window = window) === null || _window === void 0 ? void 0 : (_window$__dnbAccordio = _window.__dnbAccordion[_this.state.group]) === null || _window$__dnbAccordio === void 0 ? void 0 : _window$__dnbAccordio.onChange.apply(_window$__dnbAccordio, params);
      }
    };

    _this.callOnChange = function (_ref2) {
      var expanded = _ref2.expanded,
          event = _ref2.event;

      _this.changeOpened(expanded, event);

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        expanded: expanded,
        event: event
      });
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this.state = {
      _expanded: props.expanded,
      expanded: props.expanded !== null ? (0, _componentHelper.isTrue)(props.expanded) : (0, _componentHelper.isTrue)(context === null || context === void 0 ? void 0 : context.expanded),
      group: props.group || (context === null || context === void 0 ? void 0 : context.group),
      no_animation: (0, _componentHelper.isTrue)(props.no_animation || (context === null || context === void 0 ? void 0 : context.no_animation)),
      _listenForPropChanges: false
    };

    if (typeof window === 'undefined' && (0, _componentHelper.isTrue)(props.expanded_ssr || (context === null || context === void 0 ? void 0 : context.expanded_ssr))) {
      _this.state.expanded = true;
    }

    if (_this.state.group && typeof window !== 'undefined') {
      window.__dnbAccordion = window.__dnbAccordion || {};
      window.__dnbAccordion[_this.state.group] = window.__dnbAccordion[_this.state.group] || new AccordionStore(_this.state.group);

      window.__dnbAccordion[_this.state.group].addInstance(_assertThisInitialized(_this));
    }

    _this.store = new Store({
      id: props.id,
      group: _this.state.group
    });

    if ((0, _componentHelper.isTrue)(props.remember_state || context.remember_state) && (0, _componentHelper.isTrue)(props.expanded)) {
      var expanded = _this.store.getState();

      if (expanded === false) {
        _this.state.expanded = false;
      }
    }

    if (context && typeof (context === null || context === void 0 ? void 0 : context.onInit) === 'function') {
      context.onInit(_assertThisInitialized(_this));
    }

    if (typeof window !== 'undefined' && (0, _componentHelper.isTrue)(props.expanded_ssr || (context === null || context === void 0 ? void 0 : context.expanded_ssr))) {
      _this.state.expanded = false;
    }

    if ((0, _componentHelper.isTrue)(_this.props.remember_state || context.remember_state)) {
      var _expanded2 = _this.store.getState();

      if (_expanded2) {
        _this.state.expanded = true;
      }
    }

    return _this;
  }

  _createClass(Accordion, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
      clearTimeout(this._animationState);
      clearTimeout(this._openTimeout);
      clearTimeout(this._changeOpenState);

      if (this.state.group && typeof window !== 'undefined') {
        var _window2, _window2$__dnbAccordi;

        (_window2 = window) === null || _window2 === void 0 ? void 0 : (_window2$__dnbAccordi = _window2.__dnbAccordion[this.state.group]) === null || _window2$__dnbAccordi === void 0 ? void 0 : _window2$__dnbAccordi.removeInstance(this);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(props) {
      var _this$context3;

      if ((0, _componentHelper.isTrue)(this.context.flush_remembered_state)) {
        this.store.flush();
        this.setState({
          expanded: (0, _componentHelper.isTrue)(this.props.expanded)
        });
      }

      if ((_this$context3 = this.context) !== null && _this$context3 !== void 0 && _this$context3.expanded_id && this.context.expanded_id === props.id) {
        this.setState({
          expanded: true
        });
      }
    }
  }, {
    key: "setExpandedState",
    value: function setExpandedState(expanded) {
      this.setState({
        expanded: expanded,
        _listenForPropChanges: false
      });
    }
  }, {
    key: "close",
    value: function close() {
      this.changeOpened(false);
    }
  }, {
    key: "changeOpened",
    value: function changeOpened(expanded) {
      if (!this._isMounted) {
        return;
      }

      this.setState({
        expanded: expanded,
        _listenForPropChanges: false
      });

      if ((0, _componentHelper.isTrue)(this.props.remember_state) || (0, _componentHelper.isTrue)(this.context.remember_state)) {
        this.store.saveState(expanded);
      }
    }
  }, {
    key: "hasAccordionHeader",
    value: function hasAccordionHeader(children) {
      if (!Array.isArray(children)) {
        children = [children];
      }

      return children.findIndex(function (cur) {
        return _react.default.isValidElement(cur) && cur.type === _AccordionHeader.default;
      }) !== -1;
    }
  }, {
    key: "hasAccordionContent",
    value: function hasAccordionContent(children) {
      if (!Array.isArray(children)) {
        children = [children];
      }

      return children.findIndex(function (cur) {
        return _react.default.isValidElement(cur) && cur.type === _AccordionContent.default;
      }) !== -1;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react.default.createElement(_Context.default.Consumer, null, function (globalContext) {
        return _react.default.createElement(_AccordionContext.default.Consumer, null, function (nestedContext) {
          var no_animation = _this3.state.no_animation;
          var expanded = _this3.state.expanded;
          var props = (0, _componentHelper.extendPropsWithContext)(_this3.props, Accordion.defaultProps, _this3.context, nestedContext, {
            skeleton: globalContext === null || globalContext === void 0 ? void 0 : globalContext.skeleton
          }, globalContext.accordion, globalContext.translation.Accordion);

          if (expanded === null && globalContext.accordion) {
            if (globalContext.accordion.expanded) {
              expanded = (0, _componentHelper.isTrue)(props.expanded);
            }
          }

          var variant = props.variant,
              className = props.className,
              _className = props.class,
              prerender = props.prerender,
              prevent_rerender = props.prevent_rerender,
              prevent_rerender_conditional = props.prevent_rerender_conditional,
              single_container = props.single_container,
              remember_state = props.remember_state,
              disabled = props.disabled,
              skeleton = props.skeleton,
              _no_animation = props.no_animation,
              _expanded_ssr = props.expanded_ssr,
              children = props.children,
              _id = props.id,
              _group = props.group,
              _expanded = props.expanded,
              title = props.title,
              description = props.description,
              left_component = props.left_component,
              icon = props.icon,
              icon_position = props.icon_position,
              icon_size = props.icon_size,
              attributes = props.attributes,
              on_change = props.on_change,
              on_state_update = props.on_state_update,
              custom_method = props.custom_method,
              custom_element = props.custom_element,
              rest = _objectWithoutProperties(props, ["variant", "className", "class", "prerender", "prevent_rerender", "prevent_rerender_conditional", "single_container", "remember_state", "disabled", "skeleton", "no_animation", "expanded_ssr", "children", "id", "group", "expanded", "title", "description", "left_component", "icon", "icon_position", "icon_size", "attributes", "on_change", "on_state_update", "custom_method", "custom_element"]);

          var id = _this3._id;
          var mainParams = {
            id: id,
            className: (0, _classnames.default)('dnb-accordion', (0, _SpacingHelper.createSpacingClasses)(props), className, _className, expanded && 'dnb-accordion--expanded', no_animation && 'dnb-accordion--no-animation', variant && "dnb-accordion__variant--".concat(variant), (0, _componentHelper.isTrue)(prerender) && 'dnb-accordion--prerender')
          };

          if (_this3.state.open) {
            mainParams.open = true;
          }

          (0, _componentHelper.validateDOMAttributes)(_this3.props, rest);
          var extendProps = (0, _componentHelper.extendPropsWithContext)(_this3.props, Accordion.defaultProps, _this3.state, _this3.context);

          var context = _extends({}, extendProps, {
            id: id,
            expanded: expanded,
            prerender: (0, _componentHelper.isTrue)(prerender),
            prevent_rerender: (0, _componentHelper.isTrue)(prevent_rerender),
            prevent_rerender_conditional: (0, _componentHelper.isTrue)(prevent_rerender_conditional),
            single_container: (0, _componentHelper.isTrue)(single_container),
            remember_state: (0, _componentHelper.isTrue)(remember_state),
            disabled: (0, _componentHelper.isTrue)(disabled),
            skeleton: (0, _componentHelper.isTrue)(skeleton),
            callOnChange: _this3.callOnChangeHandler
          });

          if ((0, _componentHelper.isTrue)(disabled)) {
            mainParams.onClick = _this3.handleDisabledClick;
          }

          return _react.default.createElement(_AccordionContext.default.Provider, {
            value: context
          }, _react.default.createElement("div", mainParams, _this3.hasAccordionHeader(children) ? null : _ref3, _this3.hasAccordionContent(children) ? children : _react.default.createElement(_AccordionContent.default, null, children)));
        });
      });
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Accordion.tagName, Accordion, Accordion.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.expanded !== state._expanded) {
          state.expanded = (0, _componentHelper.isTrue)(props.expanded);
          state._expanded = props.expanded;
        }

        if (props.group && !state.group) {
          state.group = props.group;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return Accordion;
}(_react.default.PureComponent);

exports.default = Accordion;
Accordion.tagName = 'dnb-accordion';
Accordion.contextType = _AccordionProviderContext.default;
Accordion.Provider = _AccordionProvider.default;
Accordion.Header = _AccordionHeader.default;
Accordion.Content = _AccordionContent.default;
Accordion.defaultProps = _extends({}, _AccordionPropTypes.accordionDefaultProps);
process.env.NODE_ENV !== "production" ? Accordion.propTypes = _extends({}, _AccordionPropTypes.accordionPropTypes) : void 0;

var Group = function (_React$PureComponent2) {
  _inherits(Group, _React$PureComponent2);

  var _super2 = _createSuper(Group);

  function Group(props) {
    var _this4;

    _classCallCheck(this, Group);

    _this4 = _super2.call(this, props);
    _this4.state = {};

    _this4.onInit = function (instance) {
      if (instance.props.id && !_this4._IDs.includes(instance.props.id)) {
        _this4._IDs.push(instance.props.id);
      }
    };

    var group;

    if (props.id) {
      group = props.id;
    } else if (!props.group) {
      group = '#' + (0, _componentHelper.makeUniqueId)();
    }

    _this4.state.group = group;
    _this4.store = new Store({
      group: group
    });
    _this4._IDs = [];

    if ((0, _componentHelper.isTrue)(props.remember_state) && !props.id) {
      rememberWarning('accordion group');
    }

    return _this4;
  }

  _createClass(Group, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this5 = this;

      var storedData = this.store.getData();

      if (storedData !== null && storedData !== void 0 && storedData.id) {
        if (!this._IDs.includes(storedData.id)) {
          var expanded_id = this._IDs[0];

          if (expanded_id) {
            this.setState({
              expanded_id: expanded_id
            }, function () {
              _this5.store.saveState(true, expanded_id);

              _this5.setState({
                expanded_id: null
              });
            });
          }
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_AccordionProvider.default, _extends({
        onInit: this.onInit
      }, this.props, this.state));
    }
  }]);

  return Group;
}(_react.default.PureComponent);

Group.defaultProps = {
  id: null,
  group: null,
  remember_state: null
};
process.env.NODE_ENV !== "production" ? Group.propTypes = {
  id: _propTypes.default.string,
  group: _propTypes.default.string,
  remember_state: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
} : void 0;
Accordion.Group = Group;

Accordion.Group.Store = function (group) {
  var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  return new Store({
    group: group,
    id: id
  });
};

Accordion.Store = function (id) {
  return new Store({
    id: id
  });
};

function rememberWarning() {
  var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'accordion';
  (0, _componentHelper.warn)("Missing \"id\" prop the ".concat(type, "! \"remember_state\" is enabled."));
}

var Store = function () {
  function Store(_ref4) {
    var id = _ref4.id,
        group = _ref4.group;

    _classCallCheck(this, Store);

    this.id = id;
    this.group = group;
    return this;
  }

  _createClass(Store, [{
    key: "storeId",
    value: function storeId() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.id;

      if (this.group) {
        if (this.group[0] === '#') {
          return null;
        }

        id = this.group;
      }

      return "dnb-accordion-".concat(id);
    }
  }, {
    key: "saveState",
    value: function saveState(expanded) {
      var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.id;
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (id) {
        try {
          var store = this.getData() || {};

          if (this.group) {
            if (expanded) {
              store.id = id;
            } else if (opts && opts.force) {
              store.id = null;
            }
          } else {
            store.expanded = expanded;
          }

          var storeId = this.storeId(id);

          if (storeId) {
            window.localStorage.setItem(storeId, JSON.stringify(store));
          }
        } catch (e) {}
      } else {
        rememberWarning();
      }
    }
  }, {
    key: "getData",
    value: function getData() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.id;
      var storeId = this.storeId(id);

      if (storeId) {
        try {
          if (Object.prototype.hasOwnProperty.call(window.localStorage, storeId)) {
            return JSON.parse(window.localStorage.getItem(storeId));
          }
        } catch (e) {}
      }

      return null;
    }
  }, {
    key: "getState",
    value: function getState() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.id;
      var state = null;
      var store = this.getData(id);

      if (store) {
        if (typeof store.id !== 'undefined') {
          state = id === store.id;
        } else if (store.expanded !== 'undefined') {
          state = (0, _componentHelper.isTrue)(store.expanded);
        }
      }

      return state;
    }
  }, {
    key: "flush",
    value: function flush() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.id;

      if (id) {
        try {
          var storeId = this.storeId(id);

          if (storeId) {
            window.localStorage.setItem(storeId, null);
          }
        } catch (e) {}
      }
    }
  }]);

  return Store;
}();