"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _componentHelper = require("../../shared/component-helper");

var _classnames = _interopRequireDefault(require("classnames"));

var _AccordionContext = _interopRequireDefault(require("./AccordionContext"));

var _SpacingHelper = require("../space/SpacingHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var AccordionContent = function (_React$PureComponent) {
  _inherits(AccordionContent, _React$PureComponent);

  var _super = _createSuper(AccordionContent);

  function AccordionContent(props, context) {
    var _this;

    _classCallCheck(this, AccordionContent);

    _this = _super.call(this, props);
    _this._ref = _react.default.createRef();
    _this.state = {
      isInitial: !context.expanded,
      isAnimating: false,
      keepContentInDom: null
    };
    _this.anim = new _componentHelper.AnimateHeight();

    _this.anim.onStart(function () {
      _this.setState({
        isAnimating: true
      });
    });

    _this.anim.onEnd(function () {
      _this.setState({
        isAnimating: false
      });

      _this.setState({
        keepContentInDom: _this.context.expanded
      });
    });

    if (props.instance && Object.prototype.hasOwnProperty.call(props.instance, 'current')) {
      props.instance.current = _assertThisInitialized(_this);
    }

    return _this;
  }

  _createClass(AccordionContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.anim.setElem(this._ref.current, (0, _componentHelper.getPreviousSibling)('dnb-accordion-group--single-container', this._ref.current));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.anim.remove();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      var _this$context = this.context,
          expanded = _this$context.expanded,
          single_container = _this$context.single_container;

      if (expanded !== this.state._expanded) {
        var isInitial = !expanded && this.state.isInitial;
        this.setState({
          _expanded: expanded,
          isInitial: false,
          keepContentInDom: true
        }, function () {
          if (expanded) {
            _this2.anim.open({
              animate: !isInitial
            });
          } else {
            _this2.anim.close({
              animate: !isInitial
            });
          }
        });
      }

      if ((0, _componentHelper.isTrue)(single_container) && AccordionContent.getContent(prevProps) !== AccordionContent.getContent(this.props)) {
        this.anim.setContainerHeight();
      }
    }
  }, {
    key: "setContainerHeight",
    value: function setContainerHeight() {
      var _this$anim;

      (_this$anim = this.anim) === null || _this$anim === void 0 ? void 0 : _this$anim.setContainerHeight();
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var children = AccordionContent.getContent(this.props);
      var _this$context2 = this.context,
          expanded = _this$context2.expanded,
          prerender = _this$context2.prerender,
          prevent_rerender = _this$context2.prevent_rerender,
          prevent_rerender_conditional = _this$context2.prevent_rerender_conditional;
      var content = children;

      if (typeof content === 'string') {
        content = _react.default.createElement("p", {
          className: "dnb-p"
        }, content);
      }

      content = expanded || prerender || this.state.keepContentInDom || this.state.isAnimating ? children : null;

      if ((0, _componentHelper.isTrue)(prevent_rerender)) {
        if ((0, _componentHelper.isTrue)(prevent_rerender_conditional) && this._cache !== content) {
          this._cache = content;
        }

        if (this._cache) {
          content = this._cache;
        } else {
          this._cache = content;
        }
      }

      return content;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          instance = _this$props.instance,
          rest = _objectWithoutProperties(_this$props, ["className", "instance"]);

      var _this$state = this.state,
          keepContentInDom = _this$state.keepContentInDom,
          isAnimating = _this$state.isAnimating;
      var _this$context3 = this.context,
          id = _this$context3.id,
          expanded = _this$context3.expanded,
          disabled = _this$context3.disabled;
      var content = this.renderContent();

      var wrapperParams = _extends({
        className: (0, _classnames.default)('dnb-accordion__content', className, !expanded && !keepContentInDom && 'dnb-accordion__content--hidden', isAnimating && 'dnb-accordion__content--is-animating')
      }, rest);

      var innerParams = {
        id: "".concat(id, "-content"),
        role: 'region',
        'aria-labelledby': "".concat(id, "-header"),
        className: (0, _classnames.default)('dnb-accordion__content__inner', (0, _SpacingHelper.createSpacingClasses)(rest), keepContentInDom === false && 'dnb-accordion__content__inner--remove-content')
      };

      if (expanded) {
        innerParams['aria-expanded'] = true;
      }

      if (!expanded || disabled) {
        innerParams.disabled = true;
        innerParams['aria-hidden'] = true;
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, wrapperParams);
      (0, _componentHelper.validateDOMAttributes)(null, innerParams);
      return _react.default.createElement("div", _extends({}, wrapperParams, {
        ref: this._ref
      }), _react.default.createElement("div", innerParams, content));
    }
  }], [{
    key: "getContent",
    value: function getContent(props) {
      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return AccordionContent;
}(_react.default.PureComponent);

exports.default = AccordionContent;
AccordionContent.contextType = _AccordionContext.default;
AccordionContent.defaultProps = {
  instance: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? AccordionContent.propTypes = _extends({
  instance: _propTypes.default.object
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
}) : void 0;