"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.accordionDefaultProps = exports.accordionPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SpacingHelper = require("../space/SpacingHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var accordionPropTypes = _extends({
  label: _propTypes.default.node,
  title: _propTypes.default.string,
  expanded: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  expanded_ssr: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prerender: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_rerender: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_rerender_conditional: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  remember_state: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  flush_remembered_state: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  single_container: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  variant: _propTypes.default.oneOf(['default', 'outlined', 'filled']),
  left_component: _propTypes.default.node,
  allow_close_all: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  id: _propTypes.default.string,
  group: _propTypes.default.string,
  element: _propTypes.default.node,
  heading: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.node]),
  heading_level: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  icon: _propTypes.default.node,
  icon_position: _propTypes.default.oneOf(['left', 'right']),
  icon_size: _propTypes.default.string,
  attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.node
}, _SpacingHelper.spacingPropTypes, {
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_state_update: _propTypes.default.func
});

exports.accordionPropTypes = accordionPropTypes;
var accordionDefaultProps = {
  label: null,
  title: null,
  expanded: null,
  no_animation: null,
  expanded_ssr: null,
  prerender: null,
  prevent_rerender: null,
  prevent_rerender_conditional: null,
  remember_state: null,
  flush_remembered_state: null,
  single_container: null,
  variant: 'outlined',
  left_component: null,
  allow_close_all: null,
  disabled: null,
  skeleton: null,
  id: null,
  group: null,
  element: null,
  heading: null,
  heading_level: null,
  icon: null,
  icon_position: null,
  icon_size: 'medium',
  attributes: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_state_update: null
};
exports.accordionDefaultProps = accordionDefaultProps;