"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _AccordionPropTypes = require("./AccordionPropTypes");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _AccordionProviderContext = _interopRequireDefault(require("./AccordionProviderContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var AccordionGroup = function (_React$PureComponent) {
  _inherits(AccordionGroup, _React$PureComponent);

  var _super = _createSuper(AccordionGroup);

  function AccordionGroup(props) {
    var _this;

    _classCallCheck(this, AccordionGroup);

    _this = _super.call(this, props);

    _this.onChangeHandler = function (event) {
      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        id: event.id,
        expanded: event.expanded,
        event: event
      });
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(AccordionGroup, [{
    key: "render",
    value: function render() {
      var props = (0, _componentHelper.extendPropsWithContext)(this.props, AccordionGroup.defaultProps, this.context.FormRow, this.context.Accordion, this.context.getTranslation(this.props).Accordion);

      var expanded = props.expanded,
          expanded_id = props.expanded_id,
          prerender = props.prerender,
          prevent_rerender = props.prevent_rerender,
          single_container = props.single_container,
          allow_close_all = props.allow_close_all,
          remember_state = props.remember_state,
          flush_remembered_state = props.flush_remembered_state,
          disabled = props.disabled,
          group = props.group,
          onInit = props.onInit,
          className = props.className,
          _className = props.class,
          _id = props.id,
          children = props.children,
          rest = _objectWithoutProperties(props, ["expanded", "expanded_id", "prerender", "prevent_rerender", "single_container", "allow_close_all", "remember_state", "flush_remembered_state", "disabled", "group", "onInit", "className", "class", "id", "children"]);

      var id = this._id;
      var classes = (0, _classnames.default)('dnb-accordion-group', (0, _SpacingHelper.createSpacingClasses)(props), className, _className, (0, _componentHelper.isTrue)(single_container) && 'dnb-accordion-group--single-container');

      var params = _extends({}, rest);

      (0, _componentHelper.validateDOMAttributes)(this.props, params);

      if (!props.group && (0, _componentHelper.isTrue)(props.single_container)) {
        props.group = (0, _componentHelper.makeUniqueId)();
      }

      var context = _extends({}, props, {
        id: id,
        onChange: this.onChangeHandler
      });

      return _react.default.createElement(_AccordionProviderContext.default.Provider, {
        value: context
      }, _react.default.createElement("div", {
        className: classes
      }, _react.default.createElement("span", _extends({
        id: id,
        className: "dnb-accordion-group__shell",
        role: "group"
      }, params), _react.default.createElement("span", {
        className: "dnb-accordion-group__children"
      }, children))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(AccordionGroup.tagName, AccordionGroup, AccordionGroup.defaultProps);
    }
  }]);

  return AccordionGroup;
}(_react.default.PureComponent);

exports.default = AccordionGroup;
AccordionGroup.tagName = 'dnb-accordion-group';
AccordionGroup.contextType = _Context.default;
AccordionGroup.defaultProps = _extends({}, _AccordionPropTypes.accordionDefaultProps, {
  expanded_id: null,
  onInit: null
});
process.env.NODE_ENV !== "production" ? AccordionGroup.propTypes = _extends({}, _AccordionPropTypes.accordionPropTypes, {
  expanded_id: _propTypes.default.string,
  onInit: _propTypes.default.func
}) : void 0;