"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.buttonPropTypes = exports.buttonVariantPropType = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _IconPrimary = _interopRequireDefault(require("../icon-primary/IconPrimary"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _Tooltip = _interopRequireDefault(require("../tooltip/Tooltip"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var buttonVariantPropType = {
  variant: _propTypes.default.oneOf(['primary', 'secondary', 'tertiary', 'signal'])
};
exports.buttonVariantPropType = buttonVariantPropType;

var buttonPropTypes = _extends({
  text: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  type: _propTypes.default.string,
  title: _propTypes.default.string,
  variant: buttonVariantPropType.variant,
  size: _propTypes.default.oneOf(['default', 'small', 'medium', 'large']),
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_position: _propTypes.default.oneOf(['left', 'right']),
  icon_size: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  tooltip: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  id: _propTypes.default.string,
  class: _propTypes.default.string,
  href: _propTypes.default.string,
  wrap: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  bounding: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  inner_ref: _propTypes.default.object,
  className: _propTypes.default.string,
  innerRef: _propTypes.default.object,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  element: _propTypes.default.node
}, _SpacingHelper.spacingPropTypes, {
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  onClick: _propTypes.default.func,
  on_click: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func])
});

exports.buttonPropTypes = buttonPropTypes;

var Button = function (_React$PureComponent) {
  _inherits(Button, _React$PureComponent);

  var _super = _createSuper(Button);

  function Button(props) {
    var _this;

    _classCallCheck(this, Button);

    _this = _super.call(this, props);

    _this.onClickHandler = function (event) {
      var afterContent = (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_click', {
        event: event
      });

      if (afterContent && _react.default.isValidElement(afterContent)) {
        _this.setState({
          afterContent: afterContent
        });
      }
    };

    _this._id = props.id || (props.status || props.tooltip) && (0, _componentHelper.makeUniqueId)();
    _this._ref = _react.default.createRef();
    _this.state = {
      afterContent: null
    };
    return _this;
  }

  _createClass(Button, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.innerRef) {
        this.props.innerRef.current = this._ref.current;
      }

      if (this.props.inner_ref) {
        this.props.inner_ref.current = this._ref.current;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Button.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.FormRow, this.context.Button);

      var class_name = props.class,
          className = props.className,
          type = props.type,
          variant = props.variant,
          size = props.size,
          title = props.title,
          tooltip = props.tooltip,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          id = props.id,
          disabled = props.disabled,
          _text = props.text,
          _icon = props.icon,
          _icon_position = props.icon_position,
          icon_size = props.icon_size,
          href = props.href,
          wrap = props.wrap,
          bounding = props.bounding,
          skeleton = props.skeleton,
          element = props.element,
          inner_ref = props.inner_ref,
          innerRef = props.innerRef,
          attributes = _objectWithoutProperties(props, ["class", "className", "type", "variant", "size", "title", "tooltip", "status", "status_state", "status_animation", "global_status_id", "id", "disabled", "text", "icon", "icon_position", "icon_size", "href", "wrap", "bounding", "skeleton", "element", "inner_ref", "innerRef"]);

      var showStatus = (0, _componentHelper.getStatusState)(status);
      var text = props.text,
          icon = props.icon,
          iconPosition = props.icon_position;
      var usedVariant = variant;
      var usedSize = size;
      var iconSize = icon_size;
      var content = Button.getContent(this.props);

      if (variant === 'tertiary' && (content || text) && !icon && icon !== false) {
        (0, _componentHelper.warn)("A Tertiary Button requires an icon. Please declare an icon to: ".concat(content));
      }

      var isIconOnly = Boolean(!text && !content && icon);

      if (isIconOnly) {
        if (!usedVariant) {
          usedVariant = 'secondary';
        }

        if (!iconSize && (usedSize === 'default' || usedSize === 'large')) {
          iconSize = 'medium';
        }

        if (!usedSize) {
          usedSize = 'medium';
        }
      } else if (content) {
        if (!usedVariant) {
          usedVariant = 'primary';
        }

        if (!usedSize) {
          usedSize = 'default';
        }
      }

      var classes = (0, _classnames.default)("dnb-button dnb-button--".concat(usedVariant || 'primary'), (text || content) && 'dnb-button--has-text', (0, _SkeletonHelper.createSkeletonClass)(variant === 'tertiary' ? 'font' : 'shape', skeleton, this.context), (0, _SpacingHelper.createSpacingClasses)(props), class_name, className, icon && "dnb-button--icon-position-".concat(iconPosition, " dnb-button--has-icon") + (iconSize ? " dnb-button--icon-size-".concat(iconSize) : ""), usedSize && usedSize !== 'default' && "dnb-button--size-".concat(usedSize), wrap && 'dnb-button--wrap', status && "dnb-button__status--".concat(status_state));

      var params = _extends({
        className: classes,
        type: type,
        title: title,
        id: this._id,
        disabled: (0, _componentHelper.isTrue)(disabled)
      }, attributes, {
        onClick: this.onClickHandler
      });

      if (href) {
        params.href = href;
      }

      (0, _SkeletonHelper.skeletonDOMAttributes)(params, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      var Element = element ? element : href ? 'a' : 'button';
      return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(Element, _extends({
        ref: this._ref
      }, params), _react.default.createElement(Content, _extends({}, this.props, {
        icon: icon,
        text: text,
        icon_size: iconSize,
        content: content,
        isIconOnly: isIconOnly,
        skeleton: (0, _componentHelper.isTrue)(skeleton)
      }))), this.state.afterContent, showStatus && _react.default.createElement(_FormStatus.default, {
        id: this._id + '-form-status',
        global_status_id: global_status_id,
        label: text,
        text: status,
        status: status_state,
        text_id: this._id + '-status',
        animation: status_animation,
        skeleton: skeleton
      }), tooltip && this._ref && _react.default.createElement(_Tooltip.default, _extends({
        id: this._id + '-tooltip',
        component: this._ref
      }, _react.default.isValidElement(tooltip) && tooltip.props ? tooltip.props : {
        children: tooltip
      })));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Button.tagName, Button, Button.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return Button;
}(_react.default.PureComponent);

exports.default = Button;
Button.tagName = 'dnb-button';
Button.contextType = _Context.default;
Button.defaultProps = {
  type: 'button',
  text: null,
  variant: null,
  size: null,
  title: null,
  icon: null,
  icon_position: 'right',
  icon_size: null,
  href: null,
  id: null,
  class: null,
  wrap: false,
  bounding: false,
  skeleton: null,
  disabled: null,
  tooltip: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  inner_ref: null,
  className: null,
  innerRef: null,
  children: null,
  element: null,
  custom_element: null,
  custom_method: null,
  onClick: null,
  on_click: null
};
process.env.NODE_ENV !== "production" ? Button.propTypes = _extends({}, buttonPropTypes) : void 0;

var _ref = _react.default.createElement("span", {
  key: "button-bounding",
  className: "dnb-button__bounding"
});

var _ref2 = _react.default.createElement("span", {
  key: "button-text-empty",
  className: "dnb-button__alignment"
}, "\u200C");

var _ref3 = _react.default.createElement("span", {
  key: "button-text-empty",
  className: "dnb-button__alignment"
}, "\u200C");

var Content = function (_React$PureComponent2) {
  _inherits(Content, _React$PureComponent2);

  var _super2 = _createSuper(Content);

  function Content() {
    _classCallCheck(this, Content);

    return _super2.apply(this, arguments);
  }

  _createClass(Content, [{
    key: "render",
    value: function render() {
      var text = this.props.text;
      var _this$props = this.props,
          title = _this$props.title,
          content = _this$props.content,
          icon = _this$props.icon,
          icon_size = _this$props.icon_size,
          bounding = _this$props.bounding,
          skeleton = _this$props.skeleton,
          isIconOnly = _this$props.isIconOnly;
      var ret = [];

      if ((0, _componentHelper.isTrue)(bounding)) {
        ret.push(_ref);
      }

      if (typeof content === 'string') {
        text = content;
      } else if (content) {
        ret.push(content);
      }

      if (text) {
        ret.push(_ref2, _react.default.createElement("span", {
          key: "button-text",
          className: "dnb-button__text dnb-skeleton--show-font"
        }, text));
      } else if (icon) {
        ret.push(_ref3);
      }

      if (icon) {
        ret.push(_react.default.isValidElement(icon) && /Icon/i.test(String(icon.type)) ? _react.default.cloneElement(icon, {
          key: 'button-icon',
          className: "dnb-button__icon ".concat(icon.props.className || '')
        }) : _react.default.createElement(_IconPrimary.default, {
          key: "button-icon",
          className: "dnb-button__icon",
          icon: icon,
          size: icon_size,
          "aria-hidden": isIconOnly && !title ? null : true,
          skeleton: skeleton
        }));
      }

      return ret;
    }
  }]);

  return Content;
}(_react.default.PureComponent);

Content.defaultProps = {
  text: null,
  title: null,
  content: null,
  icon: null,
  icon_size: 'default',
  bounding: false,
  skeleton: null,
  isIconOnly: null
};
process.env.NODE_ENV !== "production" ? Content.propTypes = {
  title: _propTypes.default.string,
  text: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.array]),
  content: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_size: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  bounding: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.bool,
  isIconOnly: _propTypes.default.bool
} : void 0;