"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/es.string.link.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _format = _interopRequireDefault(require("date-fns/format"));

var _nb = _interopRequireDefault(require("date-fns/locale/nb"));

var _enGB = _interopRequireDefault(require("date-fns/locale/en-GB"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _DatePickerProvider = _interopRequireDefault(require("./DatePickerProvider"));

var _DatePickerRange = _interopRequireDefault(require("./DatePickerRange"));

var _DatePickerInput = _interopRequireDefault(require("./DatePickerInput"));

var _DatePickerAddon = _interopRequireDefault(require("./DatePickerAddon"));

var _DatePickerFooter = _interopRequireDefault(require("./DatePickerFooter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref2 = _react.default.createElement(_AlignmentHelper.default, null);

var DatePicker = function (_React$PureComponent) {
  _inherits(DatePicker, _React$PureComponent);

  var _super = _createSuper(DatePicker);

  function DatePicker(props) {
    var _this;

    _classCallCheck(this, DatePicker);

    _this = _super.call(this, props);

    _this.setTrianglePosition = function () {
      var _this$props = _this.props,
          show_input = _this$props.show_input,
          align_picker = _this$props.align_picker;

      if ((0, _componentHelper.isTrue)(show_input) && _this._triangleRef.current && _this._innerRef.current) {
        try {
          var shellWidth = _this._innerRef.current.querySelector('.dnb-input__shell').getBoundingClientRect().width;

          var buttonWidth = _this._innerRef.current.querySelector('.dnb-input__submit-button__button').getBoundingClientRect().width;

          if (align_picker === 'right') {
            var distance = buttonWidth / 2 - 8;
            _this._triangleRef.current.style.marginRight = "".concat(distance / 16, "rem");
          } else {
            var _distance = shellWidth - buttonWidth / 2 - 8;

            _this._triangleRef.current.style.marginLeft = "".concat(_distance / 16, "rem");
          }
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }
    };

    _this.setOutsideClickHandler = function () {
      _this.outsideClick = (0, _componentHelper.detectOutsideClick)(_this._innerRef.current, _this.hidePicker);
    };

    _this.onPickerChange = function (_ref) {
      var _ref$hidePicker = _ref.hidePicker,
          hidePicker = _ref$hidePicker === void 0 ? true : _ref$hidePicker,
          args = _objectWithoutProperties(_ref, ["hidePicker"]);

      if (hidePicker && !(0, _componentHelper.isTrue)(_this.props.show_submit_button) && !(0, _componentHelper.isTrue)(_this.props.show_cancel_button)) {
        _this.hidePicker(args);
      }
    };

    _this.onSubmitHandler = function (args) {
      _this.hidePicker(args);

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_submit', _this.getReturnObject(args));
    };

    _this.onCancelHandler = function (args) {
      _this.hidePicker(args);

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_cancel', _this.getReturnObject(args));
    };

    _this.onResetHandler = function (args) {
      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_reset', _this.getReturnObject(args));
    };

    _this.showPicker = function (args) {
      if (_this._hideTimeout) {
        clearTimeout(_this._hideTimeout);
      }

      _this.setState({
        opened: true,
        hidden: false,
        _listenForPropChanges: false
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_show', _this.getReturnObject(args));

      _this.setTrianglePosition();

      _this.setOutsideClickHandler();
    };

    _this.hidePicker = function (args) {
      if ((0, _componentHelper.isTrue)(_this.props.prevent_close)) {
        return;
      }

      if (args && args.event && args.event.persist) {
        args.event.persist();
      }

      _this.setState({
        opened: false,
        _listenForPropChanges: false
      }, function () {
        return (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_hide', _this.getReturnObject(args));
      });

      _this._hideTimeout = setTimeout(function () {
        _this.setState({
          hidden: true,
          _listenForPropChanges: false
        }, function () {
          try {
            _this._submitButtonRef.current.focus({
              preventScroll: true
            });
          } catch (e) {
            (0, _componentHelper.warn)(e);
          }
        });
      }, (0, _componentHelper.isTrue)(_this.props.no_animation) ? 1 : DatePicker.blurDelay);

      _this.removeOutsideClickHandler();
    };

    _this.togglePicker = function (args) {
      !_this.state.opened ? _this.showPicker(args && args.event || args) : _this.hidePicker(args && args.event || args);
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    var opened = (0, _componentHelper.isTrue)(props.opened);
    _this.state = {
      showInput: (0, _componentHelper.isTrue)(props.show_input),
      opened: opened,
      hidden: !opened,
      direction: props.direction,
      _listenForPropChanges: true
    };

    if (props.end_date && !(0, _componentHelper.isTrue)(props.range)) {
      (0, _componentHelper.warn)("The DatePicker got a \"end_date\". You have to set range={true} as well!.");
    }

    _this._innerRef = _react.default.createRef();
    _this._triangleRef = _react.default.createRef();
    _this._submitButtonRef = _react.default.createRef();
    return _this;
  }

  _createClass(DatePicker, [{
    key: "removeOutsideClickHandler",
    value: function removeOutsideClickHandler() {
      if (this.outsideClick) {
        this.outsideClick.remove();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._hideTimeout);
      this.removeOutsideClickHandler();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if ((0, _componentHelper.isTrue)(this.props.opened)) {
        this.showPicker();
      }
    }
  }, {
    key: "formatSelectedDateTitle",
    value: function formatSelectedDateTitle() {
      var range = this.props.range;
      var _this$state = this.state,
          startDate = _this$state.startDate,
          endDate = _this$state.endDate;
      var _this$context$getTran = this.context.getTranslation(this.props).DatePicker,
          selected_date = _this$context$getTran.selected_date,
          start = _this$context$getTran.start,
          end = _this$context$getTran.end;
      var currentDate = startDate ? (0, _format.default)(startDate, 'PPPP') : null;

      if ((0, _componentHelper.isTrue)(range) && startDate && endDate) {
        currentDate = "".concat(start, " ").concat(currentDate, " - ").concat(end, " ").concat((0, _format.default)(endDate, 'PPPP'));
      }

      return currentDate ? selected_date.replace(/%s/, currentDate) : '';
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context,
          _submitParams,
          _this2 = this;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, DatePicker.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).DatePicker, this.context.FormRow, this.context.DatePicker);

      if (props.locale !== _enGB.default && /en-/.test(this.context.locale)) {
        props.locale = _enGB.default;
      }

      var label = props.label,
          title = props.title,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          only_month = props.only_month,
          hide_last_week = props.hide_last_week,
          disable_autofocus = props.disable_autofocus,
          enable_keyboard_nav = props.enable_keyboard_nav,
          hide_navigation_buttons = props.hide_navigation_buttons,
          show_input = props.show_input,
          range = props.range,
          first_day = props.first_day,
          reset_date = props.reset_date,
          locale = props.locale,
          link = props.link,
          sync = props.sync,
          input_element = props.input_element,
          addon_element = props.addon_element,
          shortcuts = props.shortcuts,
          disabled = props.disabled,
          stretch = props.stretch,
          skeleton = props.skeleton,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          mask_order = props.mask_order,
          mask_placeholder = props.mask_placeholder,
          align_picker = props.align_picker,
          _hide_navigation = props.hide_navigation,
          _return_format = props.return_format,
          _date_format = props.date_format,
          _hide_days = props.hide_days,
          _month = props.month,
          _date = props.date,
          _start_date = props.start_date,
          _end_date = props.end_date,
          _min_date = props.min_date,
          _max_date = props.max_date,
          _correct_invalid_date = props.correct_invalid_date,
          _opened = props.opened,
          _direction = props.direction,
          _id = props.id,
          className = props.className,
          _className = props.class,
          show_submit_button = props.show_submit_button,
          show_cancel_button = props.show_cancel_button,
          show_reset_button = props.show_reset_button,
          attributes = _objectWithoutProperties(props, ["label", "title", "label_direction", "label_sr_only", "only_month", "hide_last_week", "disable_autofocus", "enable_keyboard_nav", "hide_navigation_buttons", "show_input", "range", "first_day", "reset_date", "locale", "link", "sync", "input_element", "addon_element", "shortcuts", "disabled", "stretch", "skeleton", "status", "status_state", "status_animation", "global_status_id", "suffix", "mask_order", "mask_placeholder", "align_picker", "hide_navigation", "return_format", "date_format", "hide_days", "month", "date", "start_date", "end_date", "min_date", "max_date", "correct_invalid_date", "opened", "direction", "id", "className", "class", "show_submit_button", "show_cancel_button", "show_reset_button"]);

      var _this$props2 = this.props,
          hide_navigation = _this$props2.hide_navigation,
          hide_days = _this$props2.hide_days;

      if ((0, _componentHelper.isTrue)(only_month)) {
        hide_days = true;
        hide_navigation = (0, _componentHelper.isTrue)(hide_navigation_buttons) ? false : true;
      }

      var _this$state2 = this.state,
          opened = _this$state2.opened,
          hidden = _this$state2.hidden,
          showInput = _this$state2.showInput;
      var id = this._id;
      var showStatus = (0, _componentHelper.getStatusState)(status);
      var pickerParams = {};

      if (showStatus || suffix) {
        pickerParams['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(pickerParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      var submitParams = (_submitParams = {}, _defineProperty(_submitParams, 'aria-expanded', opened), _defineProperty(_submitParams, "ref", this._submitButtonRef), _submitParams);
      var selectedDateTitle = this.formatSelectedDateTitle();
      var mainParams = {
        className: (0, _classnames.default)("dnb-date-picker dnb-form-component", ((0, _componentHelper.isTrue)(range) || (0, _componentHelper.isTrue)(show_submit_button) || (0, _componentHelper.isTrue)(show_cancel_button) || (0, _componentHelper.isTrue)(show_reset_button)) && 'dnb-date-picker--show-footer', (0, _SpacingHelper.createSpacingClasses)(props), _className, className, status && "dnb-date-picker__status--".concat(status_state), label_direction && "dnb-date-picker--".concat(label_direction), opened && 'dnb-date-picker--opened', hidden && 'dnb-date-picker--hidden', showInput && 'dnb-date-picker--show-input', align_picker && "dnb-date-picker--".concat(align_picker), (0, _componentHelper.isTrue)(stretch) && "dnb-date-picker--stretch")
      };

      if (locale !== null && locale !== void 0 && locale.code) {
        mainParams.lang = locale.code;
      }

      (0, _SkeletonHelper.skeletonDOMAttributes)(pickerParams, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, attributes);
      (0, _componentHelper.validateDOMAttributes)(null, submitParams);
      (0, _componentHelper.validateDOMAttributes)(null, pickerParams);
      return _react.default.createElement(_DatePickerProvider.default, _extends({}, this.props, {
        attributes: attributes,
        setReturnObject: function setReturnObject(fn) {
          return _this2.getReturnObject = fn;
        },
        enhanceWithMethods: {
          hidePicker: this.hidePicker
        }
      }), _react.default.createElement("span", mainParams, label && _react.default.createElement(_FormLabel.default, {
        id: id + '-label',
        for_id: id,
        text: label,
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton
      }), _react.default.createElement("span", _extends({
        className: "dnb-date-picker__inner",
        ref: this._innerRef
      }, pickerParams), _ref2, showStatus && _react.default.createElement(_FormStatus.default, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        width_selector: id + '-input',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), _react.default.createElement("span", {
        className: "dnb-date-picker__row"
      }, _react.default.createElement("span", {
        className: "dnb-date-picker__shell"
      }, _react.default.createElement(_DatePickerInput.default, _extends({
        id: id,
        title: title,
        disabled: (0, _componentHelper.isTrue)(disabled),
        stretch: (0, _componentHelper.isTrue)(stretch),
        skeleton: (0, _componentHelper.isTrue)(skeleton),
        maskOrder: mask_order,
        maskPlaceholder: mask_placeholder,
        isRange: (0, _componentHelper.isTrue)(range),
        showInput: showInput,
        selectedDateTitle: selectedDateTitle,
        input_element: input_element,
        opened: opened,
        hidden: hidden,
        status: status ? 'error' : null,
        status_state: status_state,
        locale: locale
      }, attributes, {
        submitAttributes: submitParams,
        onFocus: this.showPicker,
        onSubmit: this.togglePicker
      })), _react.default.createElement("span", {
        className: "dnb-date-picker__container"
      }, _react.default.createElement("span", {
        className: "dnb-date-picker__triangle",
        ref: this._triangleRef
      }), !hidden && _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_DatePickerRange.default, {
        id: id,
        firstDayOfWeek: first_day,
        locale: locale,
        resetDate: (0, _componentHelper.isTrue)(reset_date),
        isRange: (0, _componentHelper.isTrue)(range),
        isLink: (0, _componentHelper.isTrue)(link),
        isSync: (0, _componentHelper.isTrue)(sync),
        hideDays: (0, _componentHelper.isTrue)(hide_days),
        hideNav: (0, _componentHelper.isTrue)(hide_navigation),
        views: (0, _componentHelper.isTrue)(hide_navigation_buttons) ? [{
          nextBtn: false,
          prevBtn: false
        }] : null,
        onlyMonth: (0, _componentHelper.isTrue)(only_month),
        hideNextMonthWeek: (0, _componentHelper.isTrue)(hide_last_week),
        noAutofocus: (0, _componentHelper.isTrue)(disable_autofocus),
        onChange: this.onPickerChange
      }), (addon_element || shortcuts) && _react.default.createElement(_DatePickerAddon.default, _extends({}, props, {
        renderElement: addon_element,
        shortcuts: shortcuts
      })), _react.default.createElement(_DatePickerFooter.default, {
        isRange: (0, _componentHelper.isTrue)(range),
        onSubmit: this.onSubmitHandler,
        onCancel: this.onCancelHandler,
        onReset: this.onResetHandler
      })))), suffix && _react.default.createElement(_Suffix.default, {
        className: "dnb-date-picker__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))), _react.default.createElement("p", {
        className: "dnb-sr-only",
        "aria-live": "assertive"
      }, selectedDateTitle)));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(DatePicker.tagName, DatePicker, DatePicker.defaultProps);
    }
  }]);

  return DatePicker;
}(_react.default.PureComponent);

exports.default = DatePicker;
DatePicker.tagName = 'dnb-date-picker';
DatePicker.contextType = _Context.default;
DatePicker.defaultProps = {
  id: null,
  title: null,
  date: undefined,
  start_date: undefined,
  end_date: undefined,
  month: undefined,
  start_month: undefined,
  end_month: undefined,
  mask_order: 'dd/mm/yyyy',
  mask_placeholder: 'dd/mm/åååå',
  date_format: 'yyyy-MM-dd',
  return_format: 'yyyy-MM-dd',
  hide_navigation: false,
  hide_navigation_buttons: false,
  hide_days: false,
  only_month: false,
  hide_last_week: false,
  disable_autofocus: false,
  enable_keyboard_nav: false,
  show_input: false,
  show_submit_button: null,
  show_cancel_button: null,
  show_reset_button: null,
  submit_button_text: 'Ok',
  cancel_button_text: 'Avbryt',
  reset_button_text: 'Tilbakestill',
  reset_date: true,
  first_day: 'monday',
  min_date: undefined,
  max_date: undefined,
  correct_invalid_date: null,
  locale: _nb.default,
  range: false,
  link: false,
  sync: true,
  label: null,
  label_direction: null,
  label_sr_only: null,
  input_element: null,
  addon_element: null,
  shortcuts: null,
  disabled: null,
  stretch: null,
  skeleton: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  opened: false,
  prevent_close: null,
  no_animation: false,
  direction: 'auto',
  align_picker: null,
  class: null,
  className: null,
  custom_element: null,
  custom_method: null,
  on_days_render: null,
  on_change: null,
  on_type: null,
  on_show: null,
  on_hide: null,
  on_submit: null,
  on_cancel: null,
  on_reset: null
};
DatePicker.blurDelay = 201;
process.env.NODE_ENV !== "production" ? DatePicker.propTypes = _extends({
  id: _propTypes.default.string,
  title: _propTypes.default.string,
  date: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  start_date: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  end_date: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  month: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  start_month: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  end_month: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  min_date: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  max_date: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  correct_invalid_date: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  mask_order: _propTypes.default.string,
  mask_placeholder: _propTypes.default.string,
  date_format: _propTypes.default.string,
  return_format: _propTypes.default.string,
  hide_navigation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  hide_navigation_buttons: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  hide_days: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  only_month: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  hide_last_week: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disable_autofocus: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  enable_keyboard_nav: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  show_input: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  show_submit_button: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  show_cancel_button: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  show_reset_button: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  submit_button_text: _propTypes.default.string,
  cancel_button_text: _propTypes.default.string,
  reset_button_text: _propTypes.default.string,
  reset_date: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  first_day: _propTypes.default.string,
  locale: _propTypes.default.object,
  range: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  link: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  sync: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['horizontal', 'vertical']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  input_element: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  addon_element: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  shortcuts: _propTypes.default.oneOfType([_propTypes.default.array, _propTypes.default.func]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  stretch: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  opened: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_close: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  direction: _propTypes.default.oneOf(['auto', 'top', 'bottom']),
  align_picker: _propTypes.default.oneOf(['auto', 'left', 'right']),
  class: _propTypes.default.string,
  className: _propTypes.default.string
}, _SpacingHelper.spacingPropTypes, {
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_days_render: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_type: _propTypes.default.func,
  on_show: _propTypes.default.func,
  on_hide: _propTypes.default.func,
  on_submit: _propTypes.default.func,
  on_cancel: _propTypes.default.func,
  on_reset: _propTypes.default.func
}) : void 0;