"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _DatePickerCalc = require("./DatePickerCalc");

var _ToggleButton = _interopRequireDefault(require("../toggle-button/ToggleButton"));

var _DatePickerContext = _interopRequireDefault(require("./DatePickerContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DatePickerAddon = function (_React$PureComponent) {
  _inherits(DatePickerAddon, _React$PureComponent);

  var _super = _createSuper(DatePickerAddon);

  function DatePickerAddon() {
    var _this;

    _classCallCheck(this, DatePickerAddon);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      currentShortcut: null,
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(DatePickerAddon, [{
    key: "setDate",
    value: function setDate(_ref) {
      var value = _ref.value,
          event = _ref.event;
      this.setState({
        currentShortcut: value,
        _listenForPropChanges: false
      });
      var start_date = value.date || value.start_date;
      var end_date = value.end_date;
      var startDate = typeof start_date === 'function' ? start_date(this.getCurrentDates()) : start_date ? (0, _DatePickerCalc.convertStringToDate)(start_date) : null;
      var endDate = typeof end_date === 'function' ? end_date(this.getCurrentDates()) : end_date ? (0, _DatePickerCalc.convertStringToDate)(end_date) : null;
      this.callOnChange({
        startDate: startDate,
        endDate: endDate || startDate,
        event: event
      });

      if (value.close_on_select) {
        this.context.hidePicker(event);
      }
    }
  }, {
    key: "getCurrentDates",
    value: function getCurrentDates() {
      var _this$context = this.context,
          startDate = _this$context.startDate,
          endDate = _this$context.endDate;
      return {
        date: startDate,
        start_date: startDate,
        end_date: endDate
      };
    }
  }, {
    key: "callOnChange",
    value: function callOnChange() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          startDate = _ref2.startDate,
          endDate = _ref2.endDate,
          _ref2$event = _ref2.event,
          event = _ref2$event === void 0 ? null : _ref2$event;

      this.context.setDate({
        startDate: startDate,
        endDate: endDate,
        changeMonthViews: true
      });
      this.context.callOnChangeHandler({
        startDate: startDate,
        endDate: endDate,
        event: event
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          shortcuts = _this$props.shortcuts,
          renderElement = _this$props.renderElement;
      var shortcutsArray = shortcuts ? typeof shortcuts === 'string' ? JSON.parse(shortcuts) : shortcuts : [];
      var hasShortcuts = shortcutsArray && shortcutsArray.length > 0;

      if (!hasShortcuts && !renderElement) {
        return _react.default.createElement(_react.default.Fragment, null);
      }

      var shortcutElements = hasShortcuts && _react.default.createElement(_ToggleButton.default.Group, {
        value: this.state.currentShortcut,
        on_change: function on_change(_ref3) {
          var value = _ref3.value,
              event = _ref3.event;
          return _this2.setDate({
            value: value,
            event: event
          });
        }
      }, shortcutsArray.map(function (_ref4, i) {
        var title = _ref4.title,
            rest = _objectWithoutProperties(_ref4, ["title"]);

        return _react.default.createElement(_ToggleButton.default, {
          key: i,
          text: title,
          value: rest
        });
      }));

      return _react.default.createElement("div", {
        className: "dnb-date-picker__addon"
      }, renderElement, shortcutElements);
    }
  }]);

  return DatePickerAddon;
}(_react.default.PureComponent);

exports.default = DatePickerAddon;
DatePickerAddon.contextType = _DatePickerContext.default;
DatePickerAddon.defaultProps = {
  shortcuts: null,
  renderElement: null
};
process.env.NODE_ENV !== "production" ? DatePickerAddon.propTypes = {
  shortcuts: _propTypes.default.oneOfType([_propTypes.default.array, _propTypes.default.func]),
  renderElement: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
} : void 0;