"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.find.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.object.values.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _format = _interopRequireDefault(require("date-fns/format"));

var _subMonths = _interopRequireDefault(require("date-fns/subMonths"));

var _addMonths = _interopRequireDefault(require("date-fns/addMonths"));

var _addWeeks = _interopRequireDefault(require("date-fns/addWeeks"));

var _addDays = _interopRequireDefault(require("date-fns/addDays"));

var _isSameDay = _interopRequireDefault(require("date-fns/isSameDay"));

var _isSameMonth = _interopRequireDefault(require("date-fns/isSameMonth"));

var _startOfDay = _interopRequireDefault(require("date-fns/startOfDay"));

var _endOfDay = _interopRequireDefault(require("date-fns/endOfDay"));

var _differenceInCalendarDays = _interopRequireDefault(require("date-fns/differenceInCalendarDays"));

var _differenceInMonths = _interopRequireDefault(require("date-fns/differenceInMonths"));

var _lastDayOfMonth = _interopRequireDefault(require("date-fns/lastDayOfMonth"));

var _setDate = _interopRequireDefault(require("date-fns/setDate"));

var _keycode = _interopRequireDefault(require("keycode"));

var _nb = _interopRequireDefault(require("date-fns/locale/nb"));

var _DatePickerCalc = require("./DatePickerCalc");

var _Button = _interopRequireDefault(require("../button/Button"));

var _DatePickerContext = _interopRequireDefault(require("./DatePickerContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DatePickerCalendar = function (_React$PureComponent) {
  _inherits(DatePickerCalendar, _React$PureComponent);

  var _super = _createSuper(DatePickerCalendar);

  function DatePickerCalendar(props) {
    var _this;

    _classCallCheck(this, DatePickerCalendar);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      var _event$target;

      if (String(event === null || event === void 0 ? void 0 : (_event$target = event.target) === null || _event$target === void 0 ? void 0 : _event$target.nodeName).toLowerCase() === 'td') {
        try {
          _this._listRef.current.focus({
            preventScroll: true
          });
        } catch (e) {}
      }

      var _this$props = _this.props,
          nr = _this$props.nr,
          isRange = _this$props.isRange,
          onlyMonth = _this$props.onlyMonth,
          hideNav = _this$props.hideNav,
          onKeyDown = _this$props.onKeyDown;

      if (typeof onKeyDown === 'function') {
        return onKeyDown(event, _this._listRef, nr);
      }

      var keyCode = (0, _keycode.default)(event);

      switch (keyCode) {
        case 'enter':
        case 'space':
        case 'left':
        case 'right':
        case 'up':
        case 'down':
          event.preventDefault();
          event.persist();
          break;

        default:
          return;
      }

      var type = nr === 0 ? 'start' : 'end';

      if (!isRange) {
        type = 'start';
      }

      var newDate = _this.context["".concat(type, "Date")];

      if (newDate) {
        newDate = _this.keyNavCalc(newDate, keyCode);
      } else {
        newDate = _this.context["".concat(type, "Month")] || (isRange && nr === 1 ? (0, _addMonths.default)(new Date(), 1) : new Date());
      }

      if (newDate === _this.context["".concat(type, "Date")]) {
        switch (keyCode) {
          case 'enter':
          case 'space':
            _this.callOnSelect({
              event: event,
              nr: nr,
              hidePicker: true
            });

            break;
        }
      } else {
        var state = {};

        var currentMonth = _this.context["".concat(type, "Month")];

        if (currentMonth && !_this.context["".concat(type, "Date")] || currentMonth && Math.abs((0, _differenceInMonths.default)(newDate, currentMonth)) > 1) {
          if (!isRange) {
            newDate = currentMonth;
          } else {
            newDate = nr === 0 ? (0, _setDate.default)(currentMonth, 1) : (0, _lastDayOfMonth.default)(currentMonth);
          }
        } else if (currentMonth && !(0, _isSameMonth.default)(_this.context["".concat(type, "Date")], currentMonth)) {
          state["".concat(type, "Month")] = newDate;
        }

        newDate = _this.findValid(newDate, keyCode);

        if (_this.hasReachedEnd(newDate)) {
          return;
        }

        state["".concat(type, "Date")] = newDate;

        if (!isRange) {
          state.endDate = newDate;
        } else {
          if (!_this.context.startDate) {
            state.startDate = newDate;
          }

          if (!_this.context.endDate) {
            state.endDate = newDate;
          }
        }

        if (onlyMonth || hideNav) {
          if (!(0, _isSameMonth.default)(state.startDate, _this.context.startDate) || !(0, _isSameMonth.default)(state.endDate, _this.context.startDate)) {
              return;
            }
        }

        state.changeMonthViews = true;

        _this.context.setDate(state, function () {
          _this.callOnSelect({
            event: event,
            nr: nr,
            hidePicker: false
          });

          if (_this._listRef && _this._listRef.current) {
            _this._listRef.current.focus({
              preventScroll: true
            });
          }
        });
      }
    };

    _this.hasReachedEnd = function (date) {
      return (0, _DatePickerCalc.isDisabled)(date, _this.context.minDate, _this.context.maxDate);
    };

    _this.buildClassNames = function (day) {
      return (0, _classnames.default)(day.className, day.isStartDate && 'dnb-date-picker__day--start-date', day.isEndDate && 'dnb-date-picker__day--end-date', day.isPreview && 'dnb-date-picker__day--preview', day.isWithinSelection && 'dnb-date-picker__day--within-selection', day.isSelectable && 'dnb-date-picker__day--selectable', day.isInactive && 'dnb-date-picker__day--inactive', day.isDisabled && 'dnb-date-picker__day--disabled', day.isToday && 'dnb-date-picker__day--today');
    };

    _this._listRef = _react.default.createRef();
    _this._labelRef = _react.default.createRef();
    _this._days = {};
    _this._cache = {};
    return _this;
  }

  _createClass(DatePickerCalendar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.props.noAutofocus && this.props.nr === 0) {
        if (this._listRef.current) {
          this._listRef.current.focus({
            preventScroll: true
          });
        }
      }
    }
  }, {
    key: "callOnSelect",
    value: function callOnSelect(args) {
      this.props.onSelect && this.props.onSelect(args);
    }
  }, {
    key: "keyNavCalc",
    value: function keyNavCalc(date, keyCode) {
      switch (keyCode) {
        case 'left':
          date = (0, _addDays.default)(date, -1);
          break;

        case 'right':
          date = (0, _addDays.default)(date, 1);
          break;

        case 'up':
          date = (0, _addWeeks.default)(date, -1);
          break;

        case 'down':
          date = (0, _addWeeks.default)(date, 1);
          break;
      }

      return date;
    }
  }, {
    key: "findValid",
    value: function findValid(date, keyCode) {
      if (this.context.props.on_days_render) {
        var month = (0, _format.default)(date, 'yyyy-MM');

        if (!this._days) {
          return date;
        }

        if (!this._days[month]) {
          this.getDays(date);
        }

        if (Array.isArray(this._days[month])) {
          var foundDate = this._days[month].find(function (cur) {
            return (0, _isSameDay.default)(cur.date, date);
          });

          if (foundDate && foundDate.date && (foundDate.isDisabled || foundDate.isSelectable === false || foundDate.isInactive)) {
            var nextDate = this.keyNavCalc(foundDate.date, keyCode);
            foundDate.date = this.findValid(nextDate, keyCode);
          }

          if (foundDate && foundDate.date) {
            return foundDate.date;
          }
        }
      }

      return date;
    }
  }, {
    key: "getCacheKey",
    value: function getCacheKey() {
      var _this$props2 = this.props,
          nr = _this$props2.nr,
          month = _this$props2.month,
          firstDayOfWeek = _this$props2.firstDayOfWeek,
          onlyMonth = _this$props2.onlyMonth,
          hideNextMonthWeek = _this$props2.hideNextMonthWeek;
      var _this$context = this.context,
          startDate = _this$context.startDate,
          endDate = _this$context.endDate,
          hoverDate = _this$context.hoverDate,
          maxDate = _this$context.maxDate,
          minDate = _this$context.minDate;
      return [nr, month, firstDayOfWeek, onlyMonth, hideNextMonthWeek, startDate, endDate, hoverDate, maxDate, minDate].join('|');
    }
  }, {
    key: "getMemorizedDays",
    value: function getMemorizedDays(month) {
      var key = this.getCacheKey();

      if (this._cache[key]) {
        return this._cache[key];
      } else {
        var count = 0;
        return this._cache[key] = Object.values(this.getDays(month).reduce(function (acc, cur, i) {
          acc[count] = acc[count] || [];
          acc[count].push(cur);

          if (i % 7 === 6) {
            count++;
          }

          return acc;
        }, {}));
      }
    }
  }, {
    key: "getDays",
    value: function getDays(month) {
      var _this$props3 = this.props,
          nr = _this$props3.nr,
          firstDayOfWeek = _this$props3.firstDayOfWeek,
          onlyMonth = _this$props3.onlyMonth,
          hideNextMonthWeek = _this$props3.hideNextMonthWeek;
      var _this$context2 = this.context,
          startDate = _this$context2.startDate,
          endDate = _this$context2.endDate,
          hoverDate = _this$context2.hoverDate,
          maxDate = _this$context2.maxDate,
          minDate = _this$context2.minDate;
      var days = (0, _DatePickerCalc.getCalendar)(month || new Date(), (0, _DatePickerCalc.dayOffset)(firstDayOfWeek), {
        onlyMonth: onlyMonth,
        hideNextMonthWeek: hideNextMonthWeek
      }).map(function (date) {
        return (0, _DatePickerCalc.makeDayObject)(date, {
          startDate: startDate,
          endDate: endDate,
          hoverDate: hoverDate,
          minDate: minDate,
          maxDate: maxDate,
          month: month
        });
      });

      if (this.context.props.on_days_render) {
        var changedDays = this.context.props.on_days_render(days, nr);

        if (Array.isArray(changedDays)) {
          days = changedDays;
        }
      }

      this._days[(0, _format.default)(month, 'yyyy-MM')] = days;
      return days;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          id = _this$props4.id,
          nr = _this$props4.nr,
          rtl = _this$props4.rtl,
          month = _this$props4.month,
          isRange = _this$props4.isRange,
          titleFormat = _this$props4.titleFormat,
          locale = _this$props4.locale,
          firstDayOfWeek = _this$props4.firstDayOfWeek,
          dayOfWeekFormat = _this$props4.dayOfWeekFormat,
          hideNav = _this$props4.hideNav,
          hideDays = _this$props4.hideDays,
          onPrev = _this$props4.onPrev,
          onNext = _this$props4.onNext,
          resetDate = _this$props4.resetDate,
          onHover = _this$props4.onHover,
          prevBtn = _this$props4.prevBtn,
          nextBtn = _this$props4.nextBtn;
      var _this$context3 = this.context,
          startDate = _this$context3.startDate,
          endDate = _this$context3.endDate,
          hoverDate = _this$context3.hoverDate,
          maxDate = _this$context3.maxDate,
          minDate = _this$context3.minDate,
          selected_month = _this$context3.translation.DatePicker.selected_month;
      var weekDays = this.getMemorizedDays(month);
      return _react.default.createElement("div", {
        className: 'dnb-date-picker__calendar' + (rtl ? " rtl" : ""),
        lang: locale === null || locale === void 0 ? void 0 : locale.code
      }, !hideNav && _react.default.createElement("div", {
        className: "dnb-date-picker__header"
      }, _react.default.createElement("div", {
        className: "dnb-date-picker__header__nav"
      }, _react.default.createElement(PrevButton, {
        nr: nr,
        minDate: minDate,
        month: month,
        locale: locale,
        context: this.context,
        prevBtn: prevBtn,
        onPrev: onPrev
      })), _react.default.createElement("label", {
        id: "".concat(id, "--title"),
        className: "dnb-date-picker__header__title dnb-no-focus",
        title: selected_month.replace(/%s/, (0, _format.default)(month, titleFormat, {
          locale: locale
        })),
        tabIndex: "-1",
        ref: this._labelRef
      }, (0, _format.default)(month, titleFormat, {
        locale: locale
      })), _react.default.createElement("div", {
        className: "dnb-date-picker__header__nav"
      }, _react.default.createElement(NextButton, {
        nr: nr,
        maxDate: maxDate,
        month: month,
        locale: locale,
        context: this.context,
        nextBtn: nextBtn,
        onNext: onNext
      }))), _react.default.createElement("table", {
        role: "grid",
        className: "dnb-no-focus",
        tabIndex: "0",
        "aria-labelledby": "".concat(id, "--title"),
        onKeyDown: this.onKeyDownHandler,
        ref: this._listRef
      }, !hideDays && _react.default.createElement("thead", {
        "aria-hidden": true
      }, _react.default.createElement("tr", {
        role: "row",
        className: "dnb-date-picker__labels"
      }, (0, _DatePickerCalc.getWeek)((0, _DatePickerCalc.dayOffset)(firstDayOfWeek)).map(function (day, i) {
        return _react.default.createElement("th", {
          key: i,
          role: "columnheader",
          scope: "col",
          className: "dnb-date-picker__labels__day dnb-date-picker__labels__day--".concat((0, _format.default)(day, 'i', {
            locale: locale
          })),
          "aria-label": (0, _format.default)(day, 'EEEE', {
            locale: locale
          })
        }, (0, _format.default)(day, dayOfWeekFormat, {
          locale: locale
        }));
      }))), _react.default.createElement("tbody", null, weekDays.map(function (week, i) {
        return _react.default.createElement("tr", {
          key: 'week' + i,
          role: "row",
          className: "dnb-date-picker__days"
        }, week.map(function (day, i) {
          var title = (0, _format.default)(day.date, 'PPPP', {
            locale: locale
          });
          var handleAsDisabled = day.isLastMonth || day.isNextMonth || day.isDisabled || day.isInactive;
          var paramsCell = {};
          paramsCell.tabIndex = '-1';

          if (day.isStartDate) {
            paramsCell.id = id + '--button-start';
          } else if (day.isEndDate) {
            paramsCell.id = id + '--button-end';
          }

          var paramsButton = {};

          if (nr === 0 ? day.isStartDate : day.isEndDate) {
            paramsButton['aria-current'] = 'date';
            paramsCell['aria-selected'] = true;
          }

          return _react.default.createElement("td", _extends({
            key: 'day' + i,
            role: "gridcell",
            className: (0, _classnames.default)("dnb-date-picker__day dnb-no-focus", _this2.buildClassNames(day)),
            onFocus: _this2.onKeyDownHandler
          }, paramsCell), _react.default.createElement(_Button.default, _extends({
            size: "medium",
            variant: "secondary",
            text: (0, _format.default)(day.date, 'd', {
              locale: locale
            }),
            bounding: true,
            disabled: handleAsDisabled,
            tabIndex: handleAsDisabled ? '0' : '-1',
            "aria-disabled": handleAsDisabled,
            "aria-label": title
          }, paramsButton, {
            onClick: handleAsDisabled ? undefined : function (_ref) {
              var event = _ref.event;
              return onSelectRange({
                day: day,
                isRange: isRange,
                startDate: startDate,
                endDate: endDate,
                resetDate: resetDate,
                event: event,
                onSelect: function onSelect(state) {
                  return _this2.context.setDate(state, function () {
                    return _this2.callOnSelect({
                      event: event,
                      nr: nr,
                      hidePicker: !isRange
                    });
                  });
                }
              });
            },
            onMouseOver: handleAsDisabled ? undefined : function () {
              return onHoverDay({
                day: day,
                hoverDate: hoverDate,
                onHover: onHover
              });
            },
            onFocus: handleAsDisabled ? undefined : function () {
              return onHoverDay({
                day: day,
                hoverDate: hoverDate,
                onHover: onHover
              });
            }
          })));
        }));
      }))));
    }
  }]);

  return DatePickerCalendar;
}(_react.default.PureComponent);

exports.default = DatePickerCalendar;
DatePickerCalendar.contextType = _DatePickerContext.default;
DatePickerCalendar.defaultProps = {
  id: null,
  nr: null,
  month: null,
  prevBtn: true,
  nextBtn: true,
  titleFormat: 'MMMM yyyy',
  dayOfWeekFormat: 'EEEEEE',
  firstDayOfWeek: 'monday',
  hideNav: false,
  hideDays: false,
  onlyMonth: false,
  hideNextMonthWeek: false,
  noAutofocus: false,
  locale: _nb.default,
  rtl: false,
  onHover: null,
  onSelect: null,
  onPrev: null,
  onNext: null,
  isRange: null,
  resetDate: true,
  onKeyDown: null
};
process.env.NODE_ENV !== "production" ? DatePickerCalendar.propTypes = {
  id: _propTypes.default.string,
  nr: _propTypes.default.number,
  month: _propTypes.default.instanceOf(Date),
  prevBtn: _propTypes.default.bool,
  nextBtn: _propTypes.default.bool,
  titleFormat: _propTypes.default.string,
  dayOfWeekFormat: _propTypes.default.string,
  firstDayOfWeek: _propTypes.default.string,
  hideNav: _propTypes.default.bool,
  hideDays: _propTypes.default.bool,
  onlyMonth: _propTypes.default.bool,
  hideNextMonthWeek: _propTypes.default.bool,
  noAutofocus: _propTypes.default.bool,
  onHover: _propTypes.default.func,
  onSelect: _propTypes.default.func,
  onPrev: _propTypes.default.func,
  onNext: _propTypes.default.func,
  locale: _propTypes.default.object,
  rtl: _propTypes.default.bool,
  isRange: _propTypes.default.bool,
  resetDate: _propTypes.default.bool,
  onKeyDown: _propTypes.default.func
} : void 0;

var PrevButton = function PrevButton(_ref2) {
  var nr = _ref2.nr,
      minDate = _ref2.minDate,
      month = _ref2.month,
      locale = _ref2.locale,
      context = _ref2.context,
      prevBtn = _ref2.prevBtn,
      onPrev = _ref2.onPrev,
      onKeyDown = _ref2.onKeyDown;

  if (!prevBtn) {
    return _react.default.createElement(_react.default.Fragment, null);
  }

  var disabled = minDate && (0, _isSameMonth.default)(month, minDate);

  var onClick = function onClick() {
    return onPrev && !disabled && onPrev({
      nr: nr
    });
  };

  var prev_month = context.translation.DatePicker.prev_month;
  var title = prev_month.replace(/%s/, (0, _format.default)((0, _subMonths.default)(month, 1), 'MMMM yyyy', {
    locale: locale
  }));
  return _react.default.createElement(_Button.default, {
    className: 'dnb-date-picker__prev' + (disabled ? " disabled" : ""),
    icon: "chevron_left",
    size: "small",
    "aria-label": title,
    onClick: onClick,
    onKeyDown: onKeyDown
  });
};

process.env.NODE_ENV !== "production" ? PrevButton.propTypes = {
  nr: _propTypes.default.number.isRequired,
  minDate: _propTypes.default.instanceOf(Date),
  month: _propTypes.default.object.isRequired,
  locale: _propTypes.default.object.isRequired,
  context: _propTypes.default.object.isRequired,
  prevBtn: _propTypes.default.bool.isRequired,
  onPrev: _propTypes.default.func.isRequired,
  onKeyDown: _propTypes.default.func
} : void 0;
PrevButton.defaultProps = {
  minDate: null,
  onKeyDown: null
};

var NextButton = function NextButton(_ref3) {
  var nr = _ref3.nr,
      maxDate = _ref3.maxDate,
      month = _ref3.month,
      locale = _ref3.locale,
      context = _ref3.context,
      nextBtn = _ref3.nextBtn,
      onNext = _ref3.onNext,
      onKeyDown = _ref3.onKeyDown;

  if (!nextBtn) {
    return _react.default.createElement(_react.default.Fragment, null);
  }

  var disabled = maxDate && (0, _isSameMonth.default)(month, maxDate);

  var onClick = function onClick() {
    return onNext && !disabled && onNext({
      nr: nr
    });
  };

  var next_month = context.translation.DatePicker.next_month;
  var title = next_month.replace(/%s/, (0, _format.default)((0, _addMonths.default)(month, 1), 'MMMM yyyy', {
    locale: locale
  }));
  return nextBtn && _react.default.createElement(_Button.default, {
    className: 'dnb-date-picker__next' + (disabled ? " disabled" : ""),
    icon: "chevron_right",
    size: "small",
    "aria-label": title,
    onClick: onClick,
    onKeyDown: onKeyDown
  });
};

process.env.NODE_ENV !== "production" ? NextButton.propTypes = {
  nr: _propTypes.default.number.isRequired,
  maxDate: _propTypes.default.instanceOf(Date),
  month: _propTypes.default.object.isRequired,
  locale: _propTypes.default.object.isRequired,
  context: _propTypes.default.object.isRequired,
  nextBtn: _propTypes.default.bool.isRequired,
  onNext: _propTypes.default.func.isRequired,
  onKeyDown: _propTypes.default.func
} : void 0;
NextButton.defaultProps = {
  maxDate: null,
  onKeyDown: null
};

var onSelectRange = function onSelectRange(_ref4) {
  var day = _ref4.day,
      isRange = _ref4.isRange,
      startDate = _ref4.startDate,
      endDate = _ref4.endDate,
      onSelect = _ref4.onSelect,
      resetDate = _ref4.resetDate,
      event = _ref4.event;
  event.persist();

  if (!isRange) {
    onSelect({
      startDate: (0, _startOfDay.default)(day.date),
      endDate: (0, _endOfDay.default)(day.date),
      event: event
    });
  } else if (!startDate || resetDate && startDate && endDate) {
    onSelect({
      startDate: (0, _startOfDay.default)(day.date),
      endDate: undefined,
      event: event
    });
  } else {
    var hasEndDate = endDate;
    var daysToStartDate = Math.abs((0, _differenceInCalendarDays.default)(startDate, day.date));
    var daysToEndDate = Math.abs((0, _differenceInCalendarDays.default)(endDate, day.date));
    var range = (0, _DatePickerCalc.toRange)(startDate, day.date);

    if (hasEndDate && !resetDate && daysToStartDate < daysToEndDate) {
      range = (0, _DatePickerCalc.toRange)(endDate, day.date);
    }

    onSelect({
      startDate: (0, _startOfDay.default)(range.startDate),
      endDate: (0, _endOfDay.default)(range.endDate),
      event: event
    });
  }
};

var onHoverDay = function onHoverDay(_ref5) {
  var day = _ref5.day,
      hoverDate = _ref5.hoverDate,
      onHover = _ref5.onHover;

  if (!(0, _isSameDay.default)(day.date, hoverDate)) {
    onHover && onHover(day.date);
  }
};