"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("../button/Button"));

var _DatePickerContext = _interopRequireDefault(require("./DatePickerContext"));

var _componentHelper = require("../../shared/component-helper");

var _DatePickerCalc = require("./DatePickerCalc");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref = _react.default.createElement("span", null);

var _ref2 = _react.default.createElement("span", null);

var _ref3 = _react.default.createElement("span", null);

var DatePickerFooter = function (_React$PureComponent) {
  _inherits(DatePickerFooter, _React$PureComponent);

  var _super = _createSuper(DatePickerFooter);

  function DatePickerFooter() {
    var _this;

    _classCallCheck(this, DatePickerFooter);

    for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
      _args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(_args));

    _this.onSubmitHandler = function (args) {
      var onSubmit = _this.props.onSubmit;

      if (onSubmit) {
        onSubmit(args);
      }
    };

    _this.onCancelHandler = function (args) {
      var date_format = _this.context.props.date_format;
      var startDate = _this.context._startDate ? (0, _DatePickerCalc.convertStringToDate)(_this.context._startDate, {
        date_format: date_format
      }) : null;
      var endDate = _this.context._endDate ? (0, _DatePickerCalc.convertStringToDate)(_this.context._endDate, {
        date_format: date_format
      }) : startDate;

      if (args && args.event) {
        args.event.persist();
      }

      _this.context.setDate({
        startDate: startDate,
        endDate: endDate
      }, function () {
        var onCancel = _this.props.onCancel;

        if (onCancel) {
          onCancel(args);
        }
      });
    };

    _this.onResetHandler = function (args) {
      if (args && args.event) {
        args.event.persist();
      }

      _this.context.setDate({
        date: undefined,
        startDate: undefined,
        endDate: undefined
      }, function () {
        var onReset = _this.props.onReset;

        if (onReset) {
          onReset(args);
        }
      });
    };

    return _this;
  }

  _createClass(DatePickerFooter, [{
    key: "render",
    value: function render() {
      var isRange = this.props.isRange;
      var _this$context$props = this.context.props,
          show_reset_button = _this$context$props.show_reset_button,
          show_cancel_button = _this$context$props.show_cancel_button,
          show_submit_button = _this$context$props.show_submit_button;

      if (!isRange && !(0, _componentHelper.isTrue)(show_submit_button) && !(0, _componentHelper.isTrue)(show_cancel_button)) {
        return _react.default.createElement(_react.default.Fragment, null);
      }

      var _this$context$transla = this.context.translation.DatePicker,
          submit_button_text = _this$context$transla.submit_button_text,
          cancel_button_text = _this$context$transla.cancel_button_text,
          reset_button_text = _this$context$transla.reset_button_text;
      return _react.default.createElement("div", {
        className: "dnb-date-picker__footer"
      }, (isRange || (0, _componentHelper.isTrue)(show_submit_button)) && _react.default.createElement(_Button.default, {
        text: submit_button_text,
        onClick: this.onSubmitHandler
      }) || _ref, _react.default.createElement("span", null, (0, _componentHelper.isTrue)(show_reset_button) && _react.default.createElement(_Button.default, {
        text: reset_button_text,
        icon: "reset",
        icon_position: "left",
        variant: "tertiary",
        onClick: this.onResetHandler
      }) || _ref2, (isRange || (0, _componentHelper.isTrue)(show_cancel_button)) && _react.default.createElement(_Button.default, {
        text: cancel_button_text,
        icon: "close",
        icon_position: "left",
        variant: "tertiary",
        onClick: this.onCancelHandler
      }) || _ref3));
    }
  }]);

  return DatePickerFooter;
}(_react.default.PureComponent);

exports.default = DatePickerFooter;
DatePickerFooter.contextType = _DatePickerContext.default;
DatePickerFooter.defaultProps = {
  onSubmit: null,
  onCancel: null,
  onReset: null
};
process.env.NODE_ENV !== "production" ? DatePickerFooter.propTypes = {
  isRange: _propTypes.default.bool.isRequired,
  onSubmit: _propTypes.default.func,
  onCancel: _propTypes.default.func,
  onReset: _propTypes.default.func
} : void 0;