"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pad = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isSameMonth = _interopRequireDefault(require("date-fns/isSameMonth"));

var _isValid = _interopRequireDefault(require("date-fns/isValid"));

var _format = _interopRequireDefault(require("date-fns/format"));

var _differenceInCalendarDays = _interopRequireDefault(require("date-fns/differenceInCalendarDays"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _DatePickerCalc = require("./DatePickerCalc");

var _DatePickerContext = _interopRequireDefault(require("./DatePickerContext"));

var _DatePickerRange = require("./DatePickerRange");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DatePickerProvider = function (_React$PureComponent) {
  _inherits(DatePickerProvider, _React$PureComponent);

  var _super = _createSuper(DatePickerProvider);

  function DatePickerProvider(props) {
    var _this;

    _classCallCheck(this, DatePickerProvider);

    _this = _super.call(this, props);
    _this.state = {
      _listenForPropChanges: true,
      changeMonthViews: false
    };

    _this.setViews = function (views) {
      var cb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.setState({
        views: views,
        _listenForPropChanges: false
      }, cb);
    };

    _this.updateState = function (state) {
      var cb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.setState(_extends({}, state, {
        _listenForPropChanges: false
      }), cb);
    };

    _this.setDate = function (state) {
      var cb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.setState(_extends({}, state, {
        _listenForPropChanges: false
      }), cb);

      var startDateIsValid = Boolean(state.startDate && (0, _isValid.default)(state.startDate));
      var endDateIsValid = Boolean(state.endDate && (0, _isValid.default)(state.endDate));

      _this.setState({
        hasHadValidDate: startDateIsValid || endDateIsValid
      });
    };

    _this.callOnChangeHandler = function (args) {
      var eventData = _this.getReturnObject(args);

      if (_this.eventData) {
        if ((0, _componentHelper.isTrue)(_this.props.range)) {
          if (_this.eventData.start_date === eventData.start_date && _this.eventData.end_date === eventData.end_date) {
            return;
          }
        } else {
          if (_this.eventData.date === eventData.date) {
            return;
          }
        }
      }

      _this.eventData = eventData;
      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', eventData);
    };

    _this.getReturnObject = function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var _ref$event = _ref.event,
          event = _ref$event === void 0 ? null : _ref$event,
          rest = _objectWithoutProperties(_ref, ["event"]);

      var _this$state$rest = _extends({}, _this.state, rest),
          startDate = _this$state$rest.startDate,
          endDate = _this$state$rest.endDate;

      var attributes = _this.props.attributes || {};
      var returnFormat = (0, _DatePickerCalc.correctV1Format)(_this.props.return_format);
      var startDateIsValid = Boolean(startDate && (0, _isValid.default)(startDate));
      var endDateIsValid = Boolean(endDate && (0, _isValid.default)(endDate));
      var ret = null;

      if ((0, _componentHelper.isTrue)(_this.props.range)) {
        ret = {
          event: event,
          attributes: attributes,
          days_between: startDateIsValid && endDateIsValid ? (0, _differenceInCalendarDays.default)(endDate, startDate) : null,
          start_date: startDateIsValid ? (0, _format.default)(startDate, returnFormat) : null,
          end_date: endDateIsValid ? (0, _format.default)(endDate, returnFormat) : null,
          is_valid_start_date: startDateIsValid,
          is_valid_end_date: endDateIsValid
        };
      } else {
        ret = {
          event: event,
          attributes: attributes,
          date: startDateIsValid ? (0, _format.default)(startDate, returnFormat) : null,
          is_valid: startDateIsValid
        };
      }

      if (_this.props.min_date || _this.props.max_date) {
        if ((0, _componentHelper.isTrue)(_this.props.range)) {
          if (startDateIsValid && (0, _DatePickerCalc.isDisabled)(startDate, _this.state.minDate, _this.state.maxDate)) {
            ret.is_valid_start_date = false;
          }

          if (endDateIsValid && (0, _DatePickerCalc.isDisabled)(endDate, _this.state.minDate, _this.state.maxDate)) {
            ret.is_valid_end_date = false;
          }
        } else {
          if (startDateIsValid && (0, _DatePickerCalc.isDisabled)(startDate, _this.state.minDate, _this.state.maxDate)) {
            ret.is_valid = false;
          }
        }
      }

      return ret;
    };

    if (typeof props.setReturnObject === 'function') {
      props.setReturnObject(_this.getReturnObject);
    }

    return _this;
  }

  _createClass(DatePickerProvider, [{
    key: "render",
    value: function render() {
      var children = this.props.children;
      return _react.default.createElement(_DatePickerContext.default.Provider, {
        value: _extends({
          translation: this.context.translation,
          setViews: this.setViews,
          setDate: this.setDate,
          updateState: this.updateState,
          getReturnObject: this.getReturnObject,
          callOnChangeHandler: this.callOnChangeHandler,
          props: this.props
        }, this.props.enhanceWithMethods, this.state)
      }, children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var isRange = (0, _componentHelper.isTrue)(props.range);

      if (state._listenForPropChanges) {
        var startDate = undefined;
        var date_format = props.date_format;

        if (typeof props.date !== 'undefined' && props.date !== state._date) {
          startDate = props.date;
        }

        if (typeof props.start_date !== 'undefined' && props.start_date !== state._startDate) {
          startDate = props.start_date;
        }

        if (typeof startDate !== 'undefined' && startDate !== state.startDate) {
          state.startDate = (0, _DatePickerCalc.convertStringToDate)(startDate, {
            date_format: date_format
          }) || undefined;

          if (!(0, _componentHelper.isTrue)(props.range)) {
            state.endDate = state.startDate;
          }
        }

        if (typeof props.end_date !== 'undefined' && (0, _componentHelper.isTrue)(props.range) && props.end_date !== state._endDate) {
          state.endDate = (0, _DatePickerCalc.convertStringToDate)(props.end_date, {
            date_format: date_format
          }) || undefined;
        }

        if (typeof props.start_month !== 'undefined' && props.start_month !== state._startMonth) {
          state.startMonth = (0, _DatePickerCalc.convertStringToDate)(props.start_month, {
            date_format: date_format
          });
        }

        if (typeof props.end_month !== 'undefined' && props.end_month !== state._endMonth) {
          state.endMonth = (0, _DatePickerCalc.convertStringToDate)(props.end_month, {
            date_format: date_format
          });
        }

        if (typeof props.min_date !== 'undefined' && props.min_date !== state._minDate) {
          state.minDate = (0, _DatePickerCalc.convertStringToDate)(props.min_date, {
            date_format: date_format
          });
        }

        if (typeof props.max_date !== 'undefined' && props.max_date !== state._maxDate) {
          state.maxDate = (0, _DatePickerCalc.convertStringToDate)(props.max_date, {
            date_format: date_format
          });
        }

        if ((0, _componentHelper.isTrue)(props.correct_invalid_date)) {
          if ((0, _DatePickerCalc.isDisabled)(state.startDate, state.minDate, state.maxDate)) {
            state.startDate = state.minDate;
          }

          if ((0, _DatePickerCalc.isDisabled)(state.endDate, state.minDate, state.maxDate)) {
            state.endDate = state.maxDate;
          }
        }
      }

      if ((0, _isValid.default)(state.startDate)) {
        state.__startDay = pad((0, _format.default)(state.startDate, 'dd'), 2);
        state.__startMonth = pad((0, _format.default)(state.startDate, 'MM'), 2);
        state.__startYear = (0, _format.default)(state.startDate, 'yyyy');
      } else if (state.startDate === undefined) {
        state.__startDay = null;
        state.__startMonth = null;
        state.__startYear = null;
      }

      if ((0, _isValid.default)(state.endDate)) {
        state.__endDay = pad((0, _format.default)(state.endDate, 'dd'), 2);
        state.__endMonth = pad((0, _format.default)(state.endDate, 'MM'), 2);
        state.__endYear = (0, _format.default)(state.endDate, 'yyyy');
      } else if (state.endDate === undefined) {
        state.__endDay = null;
        state.__endMonth = null;
        state.__endYear = null;
      }

      if (!state.startMonth || state.changeMonthViews && !(0, _isSameMonth.default)(state.startMonth, state.startDate)) {
        state.startMonth = state.startDate;
      }

      if (!state.endMonth || isRange && state.changeMonthViews && !(0, _isSameMonth.default)(state.endMonth, state.endDate)) {
        state.endMonth = state.endDate || state.startMonth;
      }

      state.views = (0, _DatePickerRange.getViews)(state, isRange);

      if (!state.startMonth) {
        state.startMonth = state.views[0].month;

        if (isRange && !state.endMonth && typeof state.views[1] !== 'undefined') {
          state.endMonth = state.views[1].month;
        }
      }

      state.changeMonthViews = false;
      state._listenForPropChanges = true;
      state._date = props.date;
      state._startDate = props.start_date || props.date;
      state._endDate = props.end_date;
      state._startMonth = props.start_month;
      state._endMonth = props.end_month;
      state._month = props.month;
      state._minDate = props.min_date;
      state._maxDate = props.max_date;
      return state;
    }
  }]);

  return DatePickerProvider;
}(_react.default.PureComponent);

exports.default = DatePickerProvider;
DatePickerProvider.contextType = _Context.default;
DatePickerProvider.defaultProps = {
  min_date: null,
  max_date: null,
  return_format: 'yyyy-MM-dd',
  attributes: null,
  enhanceWithMethods: null
};
process.env.NODE_ENV !== "production" ? DatePickerProvider.propTypes = {
  min_date: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  max_date: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]),
  return_format: _propTypes.default.string,
  range: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.string]).isRequired,
  setReturnObject: _propTypes.default.func.isRequired,
  enhanceWithMethods: _propTypes.default.object,
  attributes: _propTypes.default.object,
  children: _propTypes.default.node.isRequired
} : void 0;

var pad = function pad(num, size) {
  return ('000000000' + num).substr(-size);
};

exports.pad = pad;