"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _SpacingHelper = require("../space/SpacingHelper");

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

var _IconPrimary = _interopRequireDefault(require("../icon-primary/IconPrimary"));

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _Button = _interopRequireDefault(require("../button/Button"));

var _DrawerList = _interopRequireDefault(require("../../fragments/drawer-list/DrawerList"));

var _DrawerListContext = _interopRequireDefault(require("../../fragments/drawer-list/DrawerListContext"));

var _DrawerListProvider = _interopRequireDefault(require("../../fragments/drawer-list/DrawerListProvider"));

var _DrawerListHelpers = require("../../fragments/drawer-list/DrawerListHelpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Dropdown = function (_React$PureComponent) {
  _inherits(Dropdown, _React$PureComponent);

  var _super = _createSuper(Dropdown);

  function Dropdown() {
    _classCallCheck(this, Dropdown);

    return _super.apply(this, arguments);
  }

  _createClass(Dropdown, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          more_menu = _this$props.more_menu,
          action_menu = _this$props.action_menu,
          prevent_selection = _this$props.prevent_selection,
          children = _this$props.children,
          data = _this$props.data;
      return _react.default.createElement(_DrawerListProvider.default, _extends({}, this.props, {
        data: data || children,
        opened: null,
        tagName: "dnb-dropdown",
        ignore_events: false,
        prevent_selection: (0, _componentHelper.isTrue)(more_menu) || (0, _componentHelper.isTrue)(action_menu) || (0, _componentHelper.isTrue)(prevent_selection)
      }), _react.default.createElement(DropdownInstance, this.props));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Dropdown.tagName, Dropdown, Dropdown.defaultProps);
    }
  }]);

  return Dropdown;
}(_react.default.PureComponent);

exports.default = Dropdown;
Dropdown.tagName = 'dnb-dropdown';
Dropdown.defaultProps = {
  id: null,
  title: 'Option Menu',
  icon: null,
  icon_size: null,
  icon_position: null,
  triangle_position: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  scrollable: true,
  focusable: false,
  max_height: null,
  direction: 'auto',
  skip_portal: null,
  no_animation: false,
  no_scroll_animation: false,
  prevent_selection: false,
  more_menu: false,
  action_menu: false,
  independent_width: false,
  size: 'default',
  align_dropdown: null,
  trigger_component: null,
  data: null,
  default_value: null,
  value: 'initval',
  open_on_focus: false,
  prevent_close: false,
  keep_open: false,
  opened: false,
  disabled: null,
  stretch: null,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_show: null,
  on_hide: null,
  on_change: null,
  on_select: null,
  on_state_update: null
};
process.env.NODE_ENV !== "production" ? Dropdown.propTypes = _extends({
  id: _propTypes.default.string,
  title: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_size: _propTypes.default.string,
  icon_position: _propTypes.default.oneOf(['left', 'right']),
  triangle_position: _propTypes.default.oneOf(['left', 'right']),
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['horizontal', 'vertical']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  scrollable: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  focusable: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  direction: _propTypes.default.oneOf(['auto', 'top', 'bottom']),
  max_height: _propTypes.default.number,
  skip_portal: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_scroll_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_selection: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  more_menu: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  action_menu: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  independent_width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  size: _propTypes.default.oneOf(['default', 'small', 'medium', 'large']),
  align_dropdown: _propTypes.default.oneOf(['left', 'right']),
  trigger_component: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node]),
  data: _propTypes.default.oneOfType([_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node, _propTypes.default.object]), _propTypes.default.arrayOf(_propTypes.default.oneOfType([_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]), _propTypes.default.shape({
    selected_value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
    content: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.arrayOf(_propTypes.default.string)])
  })]))]),
  default_value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  open_on_focus: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_close: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  keep_open: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  opened: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  stretch: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  class: _propTypes.default.string
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node, _propTypes.default.object, _propTypes.default.array]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_show: _propTypes.default.func,
  on_hide: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_select: _propTypes.default.func,
  on_state_update: _propTypes.default.func
}) : void 0;

var _ref = _react.default.createElement(_AlignmentHelper.default, null);

var DropdownInstance = function (_React$PureComponent2) {
  _inherits(DropdownInstance, _React$PureComponent2);

  var _super2 = _createSuper(DropdownInstance);

  function DropdownInstance(props) {
    var _this;

    _classCallCheck(this, DropdownInstance);

    _this = _super2.call(this, props);

    _this.setVisible = function () {
      _this.context.drawerList.setWrapperElement(_this._refShell.current).setVisible();
    };

    _this.setHidden = function () {
      var _this$context$drawerL;

      (_this$context$drawerL = _this.context.drawerList).setHidden.apply(_this$context$drawerL, arguments);
    };

    _this.onFocusHandler = function () {
      if ((0, _componentHelper.isTrue)(_this.props.open_on_focus)) {
        _this.setVisible();
      }
    };

    _this.onBlurHandler = function () {
      if ((0, _componentHelper.isTrue)(_this.props.open_on_focus)) {
        _this.setHidden();
      }
    };

    _this.toggleVisible = function () {
      if (!_this.context.drawerList.hidden && _this.context.drawerList.opened) {
        _this.setHidden();
      } else {
        _this.setVisible();
      }
    };

    _this.onMouseDownHandler = function () {
      if (!_this.context.drawerList.hidden && _this.context.drawerList.opened) {
        _this.setHidden();
      } else {
        _this.setVisible();
      }
    };

    _this.onTriggerKeyDownHandler = function (e) {
      switch ((0, _keycode.default)(e)) {
        case 'enter':
        case 'space':
        case 'up':
        case 'down':
          e.preventDefault();

          _this.setVisible();

          break;

        case 'esc':
          _this.setHidden();

          break;

        case 'home':
        case 'end':
        case 'page down':
        case 'page up':
          e.preventDefault();
          break;
      }
    };

    _this.onHideHandler = function () {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var attributes = _this.attributes || {};
      var res = (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_hide', _extends({}, args, {
        attributes: attributes
      }));

      if (res !== false) {
        clearTimeout(_this._focusTimeout);
        _this._focusTimeout = setTimeout(function () {
          try {
            var element = _this._refButton.current._ref.current;

            if (element && typeof element.focus === 'function') {
              element.focus({
                preventScroll: true
              });
              (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_hide_focus', {
                element: element
              });
            }
          } catch (e) {}
        }, 1);
      }

      return res;
    };

    _this.onSelectHandler = function (args) {
      if (parseFloat(args.active_item) > -1) {
        var attributes = _this.attributes || {};
        (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_select', _extends({}, args, {
          attributes: attributes
        }));
      }
    };

    _this.onChangeHandler = function (args) {
      var attributes = _this.attributes || {};
      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', _extends({}, args, {
        attributes: attributes
      }));
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this.attributes = {};
    _this.state = _this.state || {};
    _this._ref = _react.default.createRef();
    _this._refShell = _react.default.createRef();
    _this._refButton = _react.default.createRef();
    var dep = 'selected_item';

    if (typeof props[dep] !== 'undefined') {
      (0, _componentHelper.warn)("Dropdown: Please use \"value\" instead of \"".concat(dep, "\"."));
    }

    return _this;
  }

  _createClass(DropdownInstance, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if ((0, _componentHelper.isTrue)(this.props.opened)) {
        this.setVisible();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.setHidden();
      clearTimeout(this._hideTimeout);
      clearTimeout(this._focusTimeout);
    }
  }, {
    key: "getTitle",
    value: function getTitle() {
      var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var data = this.context.drawerList.data;

      if (data && data.length > 0) {
        var currentOptionData = (0, _DrawerListHelpers.getCurrentData)(this.context.drawerList.selected_item, data);

        if (currentOptionData) {
          title = currentOptionData.selected_value || (0, _DrawerListHelpers.parseContentTitle)(currentOptionData);
        }
      }

      return title;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Dropdown.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Dropdown, this.context.FormRow, this.context.Dropdown);

      var label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          icon_size = props.icon_size,
          size = props.size,
          fixed_position = props.fixed_position,
          use_drawer_on_mobile = props.use_drawer_on_mobile,
          enable_body_lock = props.enable_body_lock,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          scrollable = props.scrollable,
          focusable = props.focusable,
          keep_open = props.keep_open,
          prevent_close = props.prevent_close,
          no_animation = props.no_animation,
          no_scroll_animation = props.no_scroll_animation,
          triangle_position = props.triangle_position,
          skip_portal = props.skip_portal,
          CustomTrigger = props.trigger_component,
          more_menu = props.more_menu,
          action_menu = props.action_menu,
          independent_width = props.independent_width,
          prevent_selection = props.prevent_selection,
          max_height = props.max_height,
          default_value = props.default_value,
          className = props.className,
          _className = props.class,
          disabled = props.disabled,
          stretch = props.stretch,
          skeleton = props.skeleton,
          _title = props.title,
          _icon = props.icon,
          _align_dropdown = props.align_dropdown,
          _icon_position = props.icon_position,
          _data = props.data,
          _children = props.children,
          _direction = props.direction,
          _id = props.id,
          _opened = props.opened,
          _value = props.value,
          attributes = _objectWithoutProperties(props, ["label", "label_direction", "label_sr_only", "icon_size", "size", "fixed_position", "use_drawer_on_mobile", "enable_body_lock", "status", "status_state", "status_animation", "global_status_id", "suffix", "scrollable", "focusable", "keep_open", "prevent_close", "no_animation", "no_scroll_animation", "triangle_position", "skip_portal", "trigger_component", "more_menu", "action_menu", "independent_width", "prevent_selection", "max_height", "default_value", "className", "class", "disabled", "stretch", "skeleton", "title", "icon", "align_dropdown", "icon_position", "data", "children", "direction", "id", "opened", "value"]);

      var icon = props.icon,
          icon_position = props.icon_position,
          align_dropdown = props.align_dropdown;
      var id = this._id;
      var handleAsMenu = (0, _componentHelper.isTrue)(action_menu) || (0, _componentHelper.isTrue)(more_menu) || (0, _componentHelper.isTrue)(prevent_selection);
      var isPopupMenu = (0, _componentHelper.isTrue)(more_menu) || !(_title && _title.length > 0);

      if (isPopupMenu) {
        icon = icon || ((0, _componentHelper.isTrue)(more_menu) ? 'more' : 'chevron_down');
      }

      if (isPopupMenu || (0, _componentHelper.isTrue)(action_menu)) {
        if (icon_position !== 'right' && align_dropdown !== 'right') {
          icon_position = 'left';
          align_dropdown = 'left';
        }
      }

      var _this$context$drawerL2 = this.context.drawerList,
          selected_item = _this$context$drawerL2.selected_item,
          direction = _this$context$drawerL2.direction,
          opened = _this$context$drawerL2.opened;
      var showStatus = (0, _componentHelper.getStatusState)(status);
      var title = this.getTitle(_title);

      _extends(this.context.drawerList.attributes, (0, _componentHelper.validateDOMAttributes)(null, attributes));

      var mainParams = {
        className: (0, _classnames.default)("dnb-dropdown dnb-dropdown--".concat(direction, " dnb-dropdown--icon-position-").concat(icon_position || 'right', " dnb-dropdown--").concat(align_dropdown || 'right', " dnb-form-component"), ((0, _componentHelper.isTrue)(independent_width) || (0, _componentHelper.isTrue)(action_menu)) && 'dnb-dropdown--independent-width', (0, _SpacingHelper.createSpacingClasses)(props), _className, className, opened && 'dnb-dropdown--opened', label_direction && "dnb-dropdown--".concat(label_direction), isPopupMenu && 'dnb-dropdown--is-popup', (0, _componentHelper.isTrue)(action_menu) && "dnb-dropdown--action-menu", size && "dnb-dropdown--".concat(size), (0, _componentHelper.isTrue)(stretch) && "dnb-dropdown--stretch", status && "dnb-dropdown__status--".concat(status_state), showStatus && 'dnb-dropdown__form-status')
      };

      var triggerParams = _extends({
        className: 'dnb-dropdown__trigger' + (opened ? " dnb-button--active" : ""),
        id: id,
        disabled: disabled,
        'aria-haspopup': handleAsMenu ? true : 'listbox',
        'aria-expanded': opened
      }, attributes, {
        onFocus: this.onFocusHandler,
        onBlur: this.onBlurHandler,
        onMouseDown: this.onMouseDownHandler,
        onKeyDown: this.onTriggerKeyDownHandler
      });

      if (opened) {
        triggerParams['aria-controls'] = "".concat(id, "-drawer-list");
      }

      if (showStatus || suffix) {
        triggerParams['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(triggerParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (label) {
        triggerParams['aria-labelledby'] = [triggerParams['aria-labelledby'], id + '-label', id].filter(Boolean).join(' ');
      }

      (0, _componentHelper.validateDOMAttributes)(null, mainParams);
      (0, _componentHelper.validateDOMAttributes)(this.props, triggerParams);
      this.attributes = (0, _componentHelper.validateDOMAttributes)(null, attributes);
      return _react.default.createElement("span", mainParams, label && _react.default.createElement(_FormLabel.default, {
        id: id + '-label',
        for_id: id,
        text: label,
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton,
        onMouseDown: this.toggleVisible
      }), _react.default.createElement("span", {
        className: "dnb-dropdown__inner",
        ref: this._ref
      }, _ref, showStatus && _react.default.createElement(_FormStatus.default, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), _react.default.createElement("span", {
        className: "dnb-dropdown__row"
      }, _react.default.createElement("span", {
        className: "dnb-dropdown__shell",
        ref: this._refShell
      }, CustomTrigger ? _react.default.createElement(CustomTrigger, triggerParams) : _react.default.createElement(_Button.default, _extends({
        variant: "secondary",
        icon: false,
        size: size === 'default' ? 'medium' : size,
        ref: this._refButton
      }, triggerParams), !isPopupMenu && _react.default.createElement("span", {
        className: "dnb-dropdown__text dnb-button__text"
      }, _react.default.createElement("span", {
        className: "dnb-dropdown__text__inner"
      }, title)), _react.default.createElement("span", {
        "aria-hidden": true,
        className: 'dnb-dropdown__icon' + (parseFloat(selected_item) === 0 ? " dnb-dropdown__icon--first" : "")
      }, icon !== false && _react.default.createElement(_IconPrimary.default, {
        icon: icon || 'chevron_down',
        size: icon_size || (size === 'large' ? 'medium' : 'default')
      }))), _react.default.createElement(_DrawerList.default, {
        id: id,
        role: handleAsMenu ? 'menu' : 'listbox',
        inner_class: "dnb-dropdown__list",
        value: selected_item,
        default_value: default_value,
        scrollable: scrollable,
        focusable: focusable,
        no_animation: no_animation,
        no_scroll_animation: no_scroll_animation,
        skip_portal: skip_portal,
        prevent_selection: handleAsMenu,
        action_menu: action_menu,
        triangle_position: triangle_position || icon_position || 'right',
        keep_open: keep_open,
        prevent_close: prevent_close,
        independent_width: (0, _componentHelper.isTrue)(independent_width) || isPopupMenu || action_menu,
        is_popup: isPopupMenu || action_menu,
        align_drawer: align_dropdown || 'right',
        fixed_position: fixed_position,
        use_drawer_on_mobile: use_drawer_on_mobile || action_menu,
        enable_body_lock: enable_body_lock,
        disabled: disabled,
        max_height: max_height,
        direction: direction,
        size: size,
        on_change: this.onChangeHandler,
        on_select: this.onSelectHandler,
        on_hide: this.onHideHandler
      })), suffix && _react.default.createElement(_Suffix.default, {
        className: "dnb-dropdown__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))));
    }
  }]);

  return DropdownInstance;
}(_react.default.PureComponent);

DropdownInstance.defaultProps = Dropdown.defaultProps;
DropdownInstance.contextType = _DrawerListContext.default;
process.env.NODE_ENV !== "production" ? DropdownInstance.propTypes = Dropdown.propTypes : void 0;
Dropdown.HorizontalItem = _DrawerList.default.HorizontalItem;