import * as React from 'react';
export type FormLabelText =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type FormLabelDisabled = string | boolean;
export type FormLabelSkeleton = string | boolean;
export type FormLabelLabelDirection = 'vertical' | 'horizontal';
export type FormLabelVertical = string | boolean;
export type FormLabelSrOnly = string | boolean;
export type FormLabelSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type FormLabelTop = string | number | boolean;
export type FormLabelRight = string | number | boolean;
export type FormLabelBottom = string | number | boolean;
export type FormLabelLeft = string | number | boolean;
export type FormLabelChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface FormLabelProps extends React.HTMLProps<HTMLElement> {
  for_id?: string;
  element?: string;
  title?: string;
  text?: FormLabelText;
  id?: string;
  class?: string;
  disabled?: FormLabelDisabled;
  skeleton?: FormLabelSkeleton;
  label_direction?: FormLabelLabelDirection;
  vertical?: FormLabelVertical;
  sr_only?: FormLabelSrOnly;
  space?: FormLabelSpace;
  top?: FormLabelTop;
  right?: FormLabelRight;
  bottom?: FormLabelBottom;
  left?: FormLabelLeft;
  className?: string;
  children?: FormLabelChildren;
}
export default class FormLabel extends React.Component<
  FormLabelProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
