"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var FormLabel = function (_React$PureComponent) {
  _inherits(FormLabel, _React$PureComponent);

  var _super = _createSuper(FormLabel);

  function FormLabel() {
    _classCallCheck(this, FormLabel);

    return _super.apply(this, arguments);
  }

  _createClass(FormLabel, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, FormLabel.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.FormRow, this.context.FormLabel);

      var for_id = props.for_id,
          element = props.element,
          title = props.title,
          className = props.className,
          id = props.id,
          disabled = props.disabled,
          skeleton = props.skeleton,
          label_direction = props.label_direction,
          vertical = props.vertical,
          sr_only = props.sr_only,
          _className = props.class,
          _text = props.text,
          attributes = _objectWithoutProperties(props, ["for_id", "element", "title", "className", "id", "disabled", "skeleton", "label_direction", "vertical", "sr_only", "class", "text"]);

      var content = FormLabel.getContent(this.props);

      var params = _extends({
        className: (0, _classnames.default)('dnb-form-label', ((0, _componentHelper.isTrue)(vertical) || label_direction === 'vertical') && "dnb-form-label--vertical", (0, _SkeletonHelper.createSkeletonClass)('font', skeleton, this.context), (0, _SpacingHelper.createSpacingClasses)(props), className, _className, (0, _componentHelper.isTrue)(sr_only) && 'dnb-form-label--sr-only'),
        htmlFor: for_id,
        id: id,
        title: title,
        disabled: (0, _componentHelper.isTrue)(disabled)
      }, attributes);

      if (disabled) {
        params.disabled = true;
      }

      (0, _SkeletonHelper.skeletonDOMAttributes)(params, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      params.children = content;
      var Element = element;
      return _react.default.createElement(Element, params);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(FormLabel.tagName, FormLabel, FormLabel.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.text) return props.text;
      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return FormLabel;
}(_react.default.PureComponent);

exports.default = FormLabel;
FormLabel.tagName = 'dnb-form-label';
FormLabel.contextType = _Context.default;
FormLabel.defaultProps = {
  for_id: null,
  element: 'label',
  title: null,
  text: null,
  id: null,
  class: null,
  disabled: null,
  skeleton: null,
  label_direction: null,
  vertical: null,
  sr_only: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? FormLabel.propTypes = _extends({
  for_id: _propTypes.default.string,
  element: _propTypes.default.string,
  title: _propTypes.default.string,
  text: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  id: _propTypes.default.string,
  class: _propTypes.default.string,
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  label_direction: _propTypes.default.oneOf(['vertical', 'horizontal']),
  vertical: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node])
}) : void 0;