"use strict";

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.entries.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ = require("../");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _ref4 = _react.default.createElement(_.ToggleButton, {
  text: "Toggle A",
  value: "a"
});

var _ref5 = _react.default.createElement(_.ToggleButton, {
  text: "Toggle B",
  value: "b"
});

var AllComponents = function AllComponents(_ref) {
  var horizontal = _ref.horizontal,
      vertical = _ref.vertical,
      showText = _ref.showText,
      hideLabel = _ref.hideLabel;
  var params = {
    left: horizontal ? 'small' : null,
    top: !horizontal || vertical ? 'small' : null
  };
  var labels = {
    datePicker: 'DatePicker:',
    dropdown: 'Dropdown:',
    autocomplete: 'Autocomplete:',
    checkbox: 'Checkbox',
    radio: 'Radio',
    radioGroup: 'Radio Group:',
    toggleButton: 'Toggle:',
    toggleButtonGroup: 'Toggle Group:',
    switch: 'Switch',
    input: 'Input:',
    textarea: 'Textarea:',
    slider: 'Slider:'
  };

  if (hideLabel) {
    labels = Object.entries(labels).reduce(function (acc, _ref2) {
      var _ref3 = _slicedToArray(_ref2, 1),
          k = _ref3[0];

      acc[k] = '';
      return acc;
    }, {});
  }

  return _react.default.createElement(_react.default.Fragment, null, showText && _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_.Space, _extends({}, params, {
    inline: true
  }), _react.default.createElement("p", {
    className: "dnb-p"
  }, "paragraph", ' ', _react.default.createElement(_.IconPrimary, _extends({
    icon: "bell",
    size: "medium"
  }, params, {
    style: {
      margin: 0
    }
  })))), "text"), _react.default.createElement(_.Button, _extends({
    text: "Button"
  }, params)), _react.default.createElement(_.Button, _extends({
    icon: "add"
  }, params)), _react.default.createElement(_.Input, _extends({
    label: labels.input
  }, params)), _react.default.createElement(_.Input, _extends({
    label: labels.input
  }, params)), _react.default.createElement(_.Dropdown, _extends({
    label: labels.dropdown,
    data: ['Item A', 'Item B', 'Item C']
  }, params)), _react.default.createElement(_.Autocomplete, _extends({
    label: labels.autocomplete,
    data: ['Item A', 'Item B', 'Item C']
  }, params)), _react.default.createElement(_.DatePicker, _extends({
    label: labels.datePicker
  }, params)), _react.default.createElement(_.IconPrimary, _extends({
    icon: "bell",
    size: "medium"
  }, params, {
    style: {
      marginTop: 0
    }
  })), _react.default.createElement(_.Checkbox, _extends({
    label: labels.checkbox
  }, params)), _react.default.createElement(_.Radio, _extends({
    label: labels.radio
  }, params)), _react.default.createElement(_.Radio.Group, _extends({
    label: labels.radioGroup
  }, params), _react.default.createElement(_.Radio, {
    label: labels.radio,
    value: "a"
  }), _react.default.createElement(_.Radio, {
    label: labels.radio,
    value: "b"
  })), _react.default.createElement(_.ToggleButton, _extends({
    label: labels.toggleButton,
    text: "Toggle"
  }, params)), _react.default.createElement(_.ToggleButton.Group, _extends({
    label: labels.toggleButtonGroup
  }, params), _ref4, _ref5), _react.default.createElement(_.Switch, _extends({
    label: labels.switch
  }, params)), _react.default.createElement(_.Textarea, _extends({
    label: labels.textarea,
    rows: "5"
  }, params)), _react.default.createElement(_.Textarea, _extends({
    label: labels.textarea,
    rows: "5"
  }, params)), _react.default.createElement(_.Slider, _extends({
    label: labels.slider,
    value: 50
  }, params)));
};

process.env.NODE_ENV !== "production" ? AllComponents.propTypes = {
  horizontal: _propTypes.default.bool,
  vertical: _propTypes.default.bool,
  showText: _propTypes.default.bool,
  hideLabel: _propTypes.default.bool
} : void 0;
AllComponents.defaultProps = {
  horizontal: null,
  vertical: null,
  showText: null,
  hideLabel: null
};
var _default = AllComponents;
exports.default = _default;