"use strict";

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.object.keys.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = AllStretchComponents;
exports.Box = void 0;

var _react = _interopRequireDefault(require("react"));

var _styled = _interopRequireDefault(require("@emotion/styled"));

var _ = require("../");

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function AllStretchComponents() {
  return _ref;
}

function StretchTemplate(_ref2) {
  var Comp = _ref2.element,
      props = _objectWithoutProperties(_ref2, ["element"]);

  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(Box, null, _react.default.createElement(_.FormSet, {
    direction: "vertical"
  }, _react.default.createElement(_.FormRow, null, _react.default.createElement(Comp, _extends({
    label: "FormSet direction=\"vertical\"",
    stretch: true
  }, props))))), _react.default.createElement(Box, null, _react.default.createElement(_.FormSet, {
    vertical: true
  }, _react.default.createElement(_.FormRow, null, _react.default.createElement(Comp, _extends({
    label: "FormSet vertical",
    stretch: true
  }, props))))), _react.default.createElement(Box, null, _react.default.createElement(_.FormRow, {
    direction: "horizontal"
  }, _react.default.createElement(Comp, _extends({
    label: "FormRow direction=\"horizontal\"",
    stretch: true
  }, props)))), _react.default.createElement(Box, null, _react.default.createElement(Comp, _extends({
    label: "label_direction=\"vertical\"",
    label_direction: "vertical",
    stretch: true
  }, props))));
}

var _ref = React.createElement(Wrapper, null, React.createElement(StretchTemplate, {
  element: _.Input
}), React.createElement(StretchTemplate, {
  element: _.Textarea
}), React.createElement(StretchTemplate, {
  element: _.Autocomplete
}), React.createElement(StretchTemplate, {
  element: _.DatePicker,
  show_input: true
}), React.createElement(StretchTemplate, {
  element: _.Dropdown
}), React.createElement(StretchTemplate, {
  element: _.Slider
}));

var Box = (0, _styled.default)(_.Space)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  position: relative;\n\n  margin: 0;\n  padding: 1rem;\n\n  @media screen and (min-width: 40em) {\n    padding: 1rem;\n  }\n\n  &::after {\n    content: '';\n    position: absolute;\n    left: -50vw;\n    right: -50vw;\n    bottom: -1px;\n    width: 200vw;\n    border-bottom: dashed 1px rgb(0, 200, 200);\n  }\n"])));
exports.Box = Box;

var Wrapper = _styled.default.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  display: block;\n"])));