import * as React from 'react';
export type FormSetNoForm = string | boolean;
export type FormSetPreventSubmit = string | boolean;
export type FormSetLabel =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type FormSetLabelDirection = 'vertical' | 'horizontal';
export type FormSetLabelSrOnly = string | boolean;
export type FormSetNoLabel = string | boolean;
export type FormSetNoFieldset = string | boolean;
export type FormSetIndent = string | boolean;
export type FormSetWrap = string | boolean;
export type FormSetDirection = 'vertical' | 'horizontal';
export type FormSetVertical = string | boolean;
export type FormSetCentered = string | boolean;
export type FormSetSectionSpacing = string | boolean;
export type FormSetResponsive = string | boolean;
export type FormSetDisabled = string | boolean;
export type FormSetSkeleton = string | boolean;
export type FormSetSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type FormSetTop = string | number | boolean;
export type FormSetRight = string | number | boolean;
export type FormSetBottom = string | number | boolean;
export type FormSetLeft = string | number | boolean;
export type FormSetChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface FormSetProps extends React.HTMLProps<HTMLElement> {
  element?: string;
  no_form?: FormSetNoForm;
  prevent_submit?: FormSetPreventSubmit;
  id?: string;
  label?: FormSetLabel;
  label_direction?: FormSetLabelDirection;
  label_sr_only?: FormSetLabelSrOnly;
  label_id?: string;
  label_class?: string;
  no_label?: FormSetNoLabel;
  no_fieldset?: FormSetNoFieldset;
  indent?: FormSetIndent;
  wrap?: FormSetWrap;
  direction?: FormSetDirection;
  vertical?: FormSetVertical;
  centered?: FormSetCentered;
  indent_offset?: string;
  section_style?: string;
  section_spacing?: FormSetSectionSpacing;
  global_status_id?: string;
  responsive?: FormSetResponsive;
  disabled?: FormSetDisabled;
  skeleton?: FormSetSkeleton;
  class?: string;
  skipContentWrapperIfNested?: boolean;
  space?: FormSetSpace;
  top?: FormSetTop;
  right?: FormSetRight;
  bottom?: FormSetBottom;
  left?: FormSetLeft;
  className?: string;
  children?: FormSetChildren;
  on_submit?: (...args: any[]) => any;
  custom_element?: Object;
  custom_method?: (...args: any[]) => any;
}
export default class FormSet extends React.Component<FormSetProps, any> {
  static defaultProps: object;
  render(): JSX.Element;
}
