"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GlobalStatusRemove = exports.default = exports.GlobalStatusInterceptor = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _GlobalStatusProvider = _interopRequireDefault(require("./GlobalStatusProvider"));

var _componentHelper = require("../../shared/component-helper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var GlobalStatusInterceptor = function () {
  function GlobalStatusInterceptor(props) {
    var _this = this;

    _classCallCheck(this, GlobalStatusInterceptor);

    var GSP = null;

    try {
      GSP = _GlobalStatusProvider.default;
    } catch (e) {}

    if (!GSP && typeof window !== 'undefined') {
      GSP = window.GlobalStatusProvider;
    }

    this.provider = GSP.init(props.id || 'main', function (provider) {
      var _provider$add = provider.add(props),
          status_id = _provider$add.status_id;

      _this.status_id = status_id;
    });
    return this;
  }

  _createClass(GlobalStatusInterceptor, [{
    key: "add",
    value: function add(props) {
      return this.provider.add(_extends({
        status_id: this.status_id
      }, props));
    }
  }, {
    key: "update",
    value: function update(props) {
      return this.provider.update(this.status_id, props);
    }
  }, {
    key: "remove",
    value: function remove() {
      return this.provider.remove(this.status_id);
    }
  }]);

  return GlobalStatusInterceptor;
}();

exports.GlobalStatusInterceptor = GlobalStatusInterceptor;

var GlobalStatusController = function (_React$PureComponent) {
  _inherits(GlobalStatusController, _React$PureComponent);

  var _super = _createSuper(GlobalStatusController);

  function GlobalStatusController(props) {
    var _this2;

    _classCallCheck(this, GlobalStatusController);

    _this2 = _super.call(this, props);
    _this2.state = {};
    var GSP = null;

    try {
      GSP = _GlobalStatusProvider.default;
    } catch (e) {}

    if (!GSP && typeof window !== 'undefined') {
      GSP = window.GlobalStatusProvider;
    }

    _this2.state.provider = GSP.init(props.id);
    _this2.state._props = props;
    return _possibleConstructorReturn(_this2, _assertThisInitialized(_this2));
  }

  _createClass(GlobalStatusController, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$state$provider$ = this.state.provider.add(this.props),
          status_id = _this$state$provider$.status_id;

      this.setState({
        status_id: status_id
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.state.provider && (0, _componentHelper.isTrue)(this.props.remove_on_unmount)) {
        this.state.provider.remove(this.state.status_id);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._props !== props) {
        state.provider.update(state.status_id, props);
      }

      return state;
    }
  }]);

  return GlobalStatusController;
}(_react.default.PureComponent);

GlobalStatusController.defaultProps = {
  id: 'main',
  status_id: null,
  remove_on_unmount: false
};
process.env.NODE_ENV !== "production" ? GlobalStatusController.propTypes = {
  id: _propTypes.default.string,
  status_id: _propTypes.default.string,
  remove_on_unmount: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
} : void 0;

var GlobalStatusRemove = function (_React$PureComponent2) {
  _inherits(GlobalStatusRemove, _React$PureComponent2);

  var _super2 = _createSuper(GlobalStatusRemove);

  function GlobalStatusRemove(props) {
    var _this3;

    _classCallCheck(this, GlobalStatusRemove);

    _this3 = _super2.call(this, props);
    _this3.state = {};
    var GSP = null;

    try {
      GSP = _GlobalStatusProvider.default;
    } catch (e) {}

    if (!GSP && typeof window !== 'undefined') {
      GSP = window.GlobalStatusProvider;
    }

    _this3.state.provider = GSP.init(props.id);
    _this3.state._props = props;
    return _this3;
  }

  _createClass(GlobalStatusRemove, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.state.provider.remove(this.props.status_id, this.props);
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._props !== props) {
        state.provider.update(props.status_id, props);
      }

      return state;
    }
  }]);

  return GlobalStatusRemove;
}(_react.default.PureComponent);

exports.GlobalStatusRemove = GlobalStatusRemove;
GlobalStatusRemove.defaultProps = {
  id: 'main'
};
process.env.NODE_ENV !== "production" ? GlobalStatusRemove.propTypes = {
  id: _propTypes.default.string,
  status_id: _propTypes.default.string.isRequired
} : void 0;
GlobalStatusController.Remove = GlobalStatusRemove;
GlobalStatusController.Update = GlobalStatusController;
var _default = GlobalStatusController;
exports.default = _default;