"use strict";

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.find.js");

require("core-js/modules/es.array.find-index.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _componentHelper = require("../../shared/component-helper");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var GlobalStatusProvider = function () {
  function GlobalStatusProvider() {
    _classCallCheck(this, GlobalStatusProvider);
  }

  _createClass(GlobalStatusProvider, null, [{
    key: "init",
    value: function init() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'main';
      var onReady = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var existingStatus = GlobalStatusProvider.get(id);

      if (existingStatus) {
        if (props) {
          existingStatus.add(props);
        }

        if (typeof onReady === 'function') {
          onReady(existingStatus);
        }

        return existingStatus;
      }

      var newStatus = GlobalStatusProvider.create(id, props);

      if (onReady) {
        newStatus.addOnReady(newStatus, onReady);
      }

      if (id !== 'main') {
        (0, _componentHelper.warn)("No <GlobalStatus ".concat("id=\"".concat(id, "\""), " /> found."));
      }

      return newStatus;
    }
  }, {
    key: "get",
    value: function get() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'main';
      return GlobalStatusProvider.providers[id] || null;
    }
  }, {
    key: "remove",
    value: function remove() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'main';

      if (GlobalStatusProvider.providers[id]) {
        delete GlobalStatusProvider.providers[id];
      }
    }
  }, {
    key: "prepareItemWithStatusId",
    value: function prepareItemWithStatusId(item) {
      var status_id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (typeof item === 'string') {
        item = {
          text: item
        };
      }

      if (!item.status_id) {
        item.status_id = status_id && status_id !== 'status-main' ? status_id : slugify(JSON.stringify(item));
      }

      return item;
    }
  }, {
    key: "combineMessages",
    value: function combineMessages(stack) {
      var globalStatus = stack.reduce(function (acc, _cur) {
        var cur = _extends({}, _cur);

        if (typeof cur.items === 'string' && cur.items[0] === '[') {
          cur.items = JSON.parse(cur.items);
        }

        if (cur.item) {
          if (typeof cur.item === 'string' && cur.item[0] === '{') {
            cur.item = JSON.parse(cur.item);
          }

          cur.items = cur.items || [];
          cur.items.push(cur.item);
        }

        if (cur.items) {
          cur.items = cur.items.reduce(function (acc, item) {
            item = GlobalStatusProvider.prepareItemWithStatusId(item);
            var foundAtIndex = acc.findIndex(function (_ref) {
              var status_id = _ref.status_id;
              return status_id === item.status_id;
            });

            if (foundAtIndex > -1) {
              acc[foundAtIndex] = item;
            } else {
              acc.push(item);
            }

            return acc;
          }, acc.items || []);
        }

        _extends(acc, cur);

        return acc;
      }, {});
      return globalStatus;
    }
  }]);

  return GlobalStatusProvider;
}();

GlobalStatusProvider.providers = {};

GlobalStatusProvider.create = function () {
  var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'main';
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  return GlobalStatusProvider.providers[id] = new GlobalStatusProviderItem(id, props);
};

var GlobalStatusProviderItem = function () {
  function GlobalStatusProviderItem(id) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    _classCallCheck(this, GlobalStatusProviderItem);

    this.stack = [];
    this.globalStatus = {};
    this._onUpdateEvents = [];
    this._onReadyEvents = [];
    this.internal_id = id;

    if (props) {
      this.add(props);
    }
  }

  _createClass(GlobalStatusProviderItem, [{
    key: "onUpdate",
    value: function onUpdate(event) {
      if (this._onUpdateEvents.filter(function (cb) {
        return cb === event;
      }).length === 0) {
        this._onUpdateEvents.push(event);
      }
    }
  }, {
    key: "forceRerender",
    value: function forceRerender(globalStatus, props) {
      var _this = this;

      var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
          _ref2$buffer_delay = _ref2.buffer_delay,
          buffer_delay = _ref2$buffer_delay === void 0 ? 0 : _ref2$buffer_delay,
          _ref2$isEmpty = _ref2.isEmpty,
          isEmpty = _ref2$isEmpty === void 0 ? false : _ref2$isEmpty;

      var run = function run() {
        _this._onUpdateEvents.forEach(function (event) {
          if (typeof event === 'function') {
            event(globalStatus, props, {
              isEmpty: isEmpty
            });
          }
        });
      };

      if (buffer_delay > 0) {
        clearTimeout(this._bufferDelayId);
        this._bufferDelayId = setTimeout(run, buffer_delay);
      } else {
        run();
      }
    }
  }, {
    key: "init",
    value: function init(props) {
      return this.add(props, {
        preventRerender: true
      });
    }
  }, {
    key: "add",
    value: function add(props) {
      var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      this.remove('internal-close', {
        preventRerender: true
      });

      var newProps = _extends({}, props);

      if (!newProps.status_id) {
        newProps.status_id = (0, _componentHelper.makeUniqueId)();
      }

      if (typeof newProps.show === 'undefined') {
        newProps.show = true;
      }

      if (newProps.children) {
        newProps.text = newProps.children;
        delete newProps.children;
      }

      var stackIndex = this.stack.findIndex(function (cur) {
        return cur.status_id === newProps.status_id;
      });

      if (stackIndex > -1) {
        this.stack[stackIndex] = newProps;
      } else {
        this.stack.push(newProps);
      }

      var globalStatus = GlobalStatusProvider.combineMessages(this.stack);

      if (!(opts !== null && opts !== void 0 && opts.preventRerender)) {
        this.forceRerender(globalStatus, props, {
          buffer_delay: (props === null || props === void 0 ? void 0 : props.buffer_delay) > -1 ? props.buffer_delay : 0
        });
      }

      return globalStatus;
    }
  }, {
    key: "get",
    value: function get(status_id) {
      return this.stack.find(function (cur) {
        return cur.status_id === status_id;
      });
    }
  }, {
    key: "update",
    value: function update(status_id, newProps) {
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (status_id) {
        var item = this.get(status_id);

        if (!item) {
          this.add(newProps);
        }
      }

      this.stack = this.stack.map(function (cur, i, arr) {
        if (!status_id ? i === arr.length - 1 : cur.status_id === status_id) {
          if (!status_id) {
            newProps = _extends({}, newProps);
            delete newProps.status_id;
          }

          return _extends({}, cur, newProps);
        }

        return cur;
      });

      if (!(opts !== null && opts !== void 0 && opts.preventRestack)) {
        this.restack(status_id);
      }

      var globalStatus = GlobalStatusProvider.combineMessages(this.stack);

      if (!(opts !== null && opts !== void 0 && opts.preventRerender)) {
        var _newProps;

        this.forceRerender(globalStatus, null, {
          buffer_delay: ((_newProps = newProps) === null || _newProps === void 0 ? void 0 : _newProps.buffer_delay) > -1 ? newProps.buffer_delay : 0
        });
      }
    }
  }, {
    key: "restack",
    value: function restack(status_id) {
      var item = this.get(status_id);

      if (item) {
        this.stack = this.stack.filter(function (cur) {
          return cur.status_id !== status_id;
        });
        this.stack.push(item);
      }
    }
  }, {
    key: "remove",
    value: function remove(status_id) {
      var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (status_id) {
        this.stack = this.stack.filter(function (cur) {
          return cur.status_id !== status_id;
        });
        var globalStatus = GlobalStatusProvider.combineMessages(this.stack);

        if (!(opts !== null && opts !== void 0 && opts.preventRerender)) {
          this.forceRerender(globalStatus, null, {
            buffer_delay: (opts === null || opts === void 0 ? void 0 : opts.buffer_delay) > -1 ? opts.buffer_delay : 10
          });
        }
      }
    }
  }, {
    key: "empty",
    value: function empty() {
      var _this2 = this;

      this._onUpdateEvents.forEach(function (cb, i) {
        _this2._onUpdateEvents[i] = null;
      });

      this._onUpdateEvents = [];

      this._onReadyEvents.forEach(function (cb, i) {
        _this2._onReadyEvents[i] = null;
      });

      this._onReadyEvents = [];
    }
  }, {
    key: "unbind",
    value: function unbind() {
      this.empty();
      GlobalStatusProvider.remove(this.internal_id);
    }
  }, {
    key: "isReady",
    value: function isReady() {
      var _this3 = this;

      this._onReadyEvents = this._onReadyEvents.filter(function (_ref3, i) {
        var status = _ref3.status,
            cb = _ref3.cb;

        if (typeof cb === 'function') {
          cb(status);
        }

        _this3._onReadyEvents[i] = null;
        return false;
      });
      return true;
    }
  }, {
    key: "addOnReady",
    value: function addOnReady(status, cb) {
      this._onReadyEvents.push({
        status: status,
        cb: cb
      });
    }
  }]);

  return GlobalStatusProviderItem;
}();

if (typeof window !== 'undefined') {
  window.GlobalStatusProvider = GlobalStatusProvider;
}

var _default = GlobalStatusProvider;
exports.default = _default;

var slugify = function slugify(s) {
  return s.toLowerCase().replace(/[^\w\s-]/g, '').replace(/[\s_-]+/g, '-').replace(/^-+|-+$/g, '');
};