"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "resetLevels", {
  enumerable: true,
  get: function get() {
    return _HeadingHelpers.resetLevels;
  }
});
Object.defineProperty(exports, "resetAllLevels", {
  enumerable: true,
  get: function get() {
    return _HeadingHelpers.resetAllLevels;
  }
});
Object.defineProperty(exports, "setNextLevel", {
  enumerable: true,
  get: function get() {
    return _HeadingHelpers.setNextLevel;
  }
});
exports.default = exports.levelResolution = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

require("../../shared/helpers");

var _SpacingHelper = require("../space/SpacingHelper");

var _HeadingContext = _interopRequireDefault(require("./HeadingContext"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _HeadingProvider = _interopRequireDefault(require("./HeadingProvider"));

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _HeadingHelpers = require("./HeadingHelpers");

var _HeadingCounter = require("./HeadingCounter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var levelResolution = {
  1: 'xx-large',
  2: 'large',
  3: 'medium',
  4: 'basis',
  5: 'small',
  6: 'x-small'
};
exports.levelResolution = levelResolution;

var Heading = function (_React$PureComponent) {
  _inherits(Heading, _React$PureComponent);

  var _super = _createSuper(Heading);

  function Heading(props, context) {
    var _context$heading, _state$context$headin, _state$context$headin2;

    var _this;

    _classCallCheck(this, Heading);

    _this = _super.call(this, props);
    _this._ref = _react.default.createRef();
    var state = {
      context: context,
      _listenForPropChanges: true
    };

    if ((_context$heading = context.heading) !== null && _context$heading !== void 0 && _context$heading.counter) {
      state.counter = (0, _HeadingCounter.initCounter)(props);
      state.counter.setContextCounter(context.heading.counter);
      state.counter.isHeading = true;
    } else {
      state.counter = (0, _HeadingCounter.initCounter)(props);
      state.counter.setContextCounter(_HeadingHelpers.globalHeadingCounter.current);
      state.counter.isHeading = true;
    }

    state.counter = (0, _HeadingHelpers.correctHeadingLevel)({
      ref: props,
      counter: state.counter,
      level: parseFloat(props.level),
      inherit: (0, _componentHelper.isTrue)(props.inherit),
      reset: props.reset,
      increase: (0, _componentHelper.isTrue)(props.increase) || (0, _componentHelper.isTrue)(props.up),
      decrease: (0, _componentHelper.isTrue)(props.decrease) || (0, _componentHelper.isTrue)(props.down),
      bypassChecks: (0, _componentHelper.isTrue)(props.skip_correction) || (0, _componentHelper.isTrue)((_state$context$headin = state.context.heading) === null || _state$context$headin === void 0 ? void 0 : _state$context$headin.skip_correction),
      source: props.text || props.children,
      debug: props.debug || ((_state$context$headin2 = state.context.heading) === null || _state$context$headin2 === void 0 ? void 0 : _state$context$headin2.debug)
    });
    _HeadingHelpers.globalSyncCounter.current = state.counter;
    state.level = state.counter.level;
    state.prevLevel = props.level;
    _this.state = state;
    return _this;
  }

  _createClass(Heading, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      (0, _HeadingHelpers.windupHeadings)();
      this.state.counter.windup();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _HeadingHelpers.teardownHeadings)();
      this.state.counter.teardown();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context$heading,
          _this$context$heading2,
          _this2 = this;

      var _this$props = this.props,
          text = _this$props.text,
          _relevel = _this$props.relevel,
          _group = _this$props.group,
          _debug = _this$props.debug,
          _debug_counter = _this$props.debug_counter,
          _reset = _this$props.reset,
          _skip_correction = _this$props.skip_correction,
          _increase = _this$props.increase,
          _decrease = _this$props.decrease,
          _up = _this$props.up,
          _down = _this$props.down,
          _inherit = _this$props.inherit,
          _level = _this$props.level,
          _size = _this$props.size,
          _skeleton = _this$props.skeleton,
          _element = _this$props.element,
          _className = _this$props.class,
          className = _this$props.className,
          children = _this$props.children,
          rest = _objectWithoutProperties(_this$props, ["text", "relevel", "group", "debug", "debug_counter", "reset", "skip_correction", "increase", "decrease", "up", "down", "inherit", "level", "size", "skeleton", "element", "class", "className", "children"]);

      var _this$props2 = this.props,
          size = _this$props2.size,
          element = _this$props2.element,
          skeleton = _this$props2.skeleton;
      var level = this.state.level;
      var debug = _debug || ((_this$context$heading = this.context.heading) === null || _this$context$heading === void 0 ? void 0 : _this$context$heading.debug);
      var debug_counter = _debug_counter || ((_this$context$heading2 = this.context.heading) === null || _this$context$heading2 === void 0 ? void 0 : _this$context$heading2.debug_counter);

      var attributes = _extends({}, rest);

      if (element === 'auto' || element === null) {
        element = "h".concat(level || '6');

        if (_size === 'auto' || _size === null) {
          size = levelResolution[level || '6'];
        }
      } else {
        if (!attributes.role) {
          attributes.role = 'heading';
        }

        if (!attributes['aria-level']) {
          attributes['aria-level'] = String(level);
        }
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, attributes);
      var Element = element;
      return _react.default.createElement(_Context.default.Consumer, null, function (context) {
        if (typeof (context === null || context === void 0 ? void 0 : context.skeleton) !== 'undefined') {
          skeleton = context.skeleton;
        }

        attributes.className = (0, _classnames.default)("dnb-heading dnb-h--".concat(size), (0, _SkeletonHelper.createSkeletonClass)('font', skeleton, _this2.context), className, _className, (0, _SpacingHelper.createSpacingClasses)(_this2.props));
        attributes.children = _react.default.createElement(_react.default.Fragment, null, debug && _react.default.createElement("span", {
          className: "dnb-heading__debug"
        }, "[h".concat(level || '6', "] "), debug_counter && _react.default.createElement(_react.default.Fragment, null, ' ', _react.default.createElement("span", {
          className: "dnb-code"
        }, (0, _HeadingHelpers.debugCounter)(_this2.state.counter)))), text || children);
        return _react.default.createElement(Element, _extends({
          ref: _this2._ref
        }, attributes));
      });
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Heading.tagName, Heading, Heading.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        var level = parseFloat(props.level);

        if (state.prevLevel !== props.level && level > 0 && level !== state.level || props.relevel) {
          var _state$context$headin3, _state$context$headin4;

          state.counter.skipMakeMeReady();

          var _correctHeadingLevel = (0, _HeadingHelpers.correctHeadingLevel)({
            counter: state.counter,
            level: level,
            bypassChecks: (0, _componentHelper.isTrue)(props.skip_correction) || (0, _componentHelper.isTrue)((_state$context$headin3 = state.context.heading) === null || _state$context$headin3 === void 0 ? void 0 : _state$context$headin3.skip_correction),
            source: props.text || props.children,
            debug: props.debug || ((_state$context$headin4 = state.context.heading) === null || _state$context$headin4 === void 0 ? void 0 : _state$context$headin4.debug)
          }),
              newLevel = _correctHeadingLevel.level;

          state.level = state.prevLevel = newLevel;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return Heading;
}(_react.default.PureComponent);

exports.default = Heading;
Heading.tagName = 'dnb-heading';
Heading.contextType = _HeadingContext.default;
Heading.defaultProps = {
  id: null,
  group: null,
  text: null,
  size: 'auto',
  level: null,
  increase: null,
  decrease: null,
  up: null,
  down: null,
  skip_correction: null,
  debug: null,
  debug_counter: null,
  counter: null,
  reset: null,
  inherit: null,
  skeleton: null,
  element: 'auto',
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Heading.propTypes = _extends({
  id: _propTypes.default.string,
  group: _propTypes.default.string,
  text: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  size: _propTypes.default.oneOf(['auto', 'xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  level: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  increase: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  decrease: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  up: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  down: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skip_correction: _propTypes.default.bool,
  debug: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.func]),
  debug_counter: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.func]),
  counter: _propTypes.default.any,
  inherit: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  reset: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  element: _propTypes.default.string
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
}) : void 0;
Heading.Level = _HeadingProvider.default;

Heading.Increase = function (props) {
  return _react.default.createElement(_HeadingProvider.default, _extends({
    increase: true
  }, props));
};

Heading.Decrease = function (props) {
  return _react.default.createElement(_HeadingProvider.default, _extends({
    decrease: true
  }, props));
};

Heading.Up = function (props) {
  return _react.default.createElement(_HeadingProvider.default, _extends({
    increase: true
  }, props));
};

Heading.Down = function (props) {
  return _react.default.createElement(_HeadingProvider.default, _extends({
    decrease: true
  }, props));
};

Heading.Reset = function (props) {
  var _globalHeadingCounter;

  (_globalHeadingCounter = _HeadingHelpers.globalHeadingCounter.current) === null || _globalHeadingCounter === void 0 ? void 0 : _globalHeadingCounter.reset();
  return _react.default.createElement(_HeadingProvider.default, props);
};

Heading.resetLevels = _HeadingHelpers.resetLevels;
Heading.setNextLevel = _HeadingHelpers.setNextLevel;