"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _componentHelper = require("../../shared/component-helper");

var _HeadingContext = _interopRequireDefault(require("./HeadingContext"));

var _HeadingHelpers = require("./HeadingHelpers");

var _HeadingCounter = require("./HeadingCounter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var HeadingProvider = function (_React$PureComponent) {
  _inherits(HeadingProvider, _React$PureComponent);

  var _super = _createSuper(HeadingProvider);

  function HeadingProvider(props, context) {
    var _this;

    _classCallCheck(this, HeadingProvider);

    _this = _super.call(this, props);
    var state = {
      context: context,
      _listenForPropChanges: true
    };
    var existingContext = context.heading;
    state.counter = (0, _HeadingCounter.initCounter)(props);
    state.newProps = props;

    if (existingContext) {
      state.newProps = _extends({}, existingContext, props);
    }

    if (existingContext) {
      state.counter.setContextCounter(existingContext.counter);
    } else {
      state.counter.setContextCounter(_HeadingHelpers.globalHeadingCounter.current);
    }

    state.counter = (0, _HeadingHelpers.correctHeadingLevel)({
      ref: props,
      counter: state.counter,
      level: parseFloat(props.level),
      inherit: (0, _componentHelper.isTrue)(props.inherit),
      reset: props.reset,
      increase: (0, _componentHelper.isTrue)(props.increase) || (0, _componentHelper.isTrue)(props.up),
      decrease: (0, _componentHelper.isTrue)(props.decrease) || (0, _componentHelper.isTrue)(props.down),
      bypassChecks: (0, _componentHelper.isTrue)(state.newProps.skip_correction),
      source: props.text || props.children,
      debug: state.newProps.debug
    });
    _HeadingHelpers.globalSyncCounter.current = state.counter;
    state.level = state.counter.level;
    state.prevLevel = state.newProps.level || state.counter.level;
    _this.state = state;
    return _this;
  }

  _createClass(HeadingProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      (0, _HeadingHelpers.windupHeadings)();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _HeadingHelpers.teardownHeadings)();
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_HeadingContext.default.Provider, {
        value: {
          heading: _extends({}, this.state.newProps, this.state)
        }
      }, this.state.newProps.debug_counter && _react.default.createElement("span", {
        className: "dnb-heading__context"
      }, _react.default.createElement("span", {
        className: "dnb-heading__debug"
      }, "Context:", ' ', _react.default.createElement("span", {
        className: "dnb-code"
      }, (0, _HeadingHelpers.debugCounter)(this.state.counter))), this.props.children) || this.props.children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        var level = parseFloat(props.level);

        if (state.prevLevel !== props.level && level > 0 && level !== state.level || props.relevel) {
          var _state$context$headin, _state$context$headin2;

          var _correctHeadingLevel = (0, _HeadingHelpers.correctHeadingLevel)({
            counter: state.counter,
            level: level,
            bypassChecks: (0, _componentHelper.isTrue)(props.skip_correction) || (0, _componentHelper.isTrue)((_state$context$headin = state.context.heading) === null || _state$context$headin === void 0 ? void 0 : _state$context$headin.skip_correction),
            source: props.text || props.children,
            debug: props.debug || ((_state$context$headin2 = state.context.heading) === null || _state$context$headin2 === void 0 ? void 0 : _state$context$headin2.debug)
          }),
              newLevel = _correctHeadingLevel.level;

          state.level = state.prevLevel = newLevel;
        }

        state._listenForPropChanges = true;
        return state;
      }
    }
  }]);

  return HeadingProvider;
}(_react.default.PureComponent);

exports.default = HeadingProvider;
HeadingProvider.contextType = _HeadingContext.default;
HeadingProvider.defaultProps = {
  id: null,
  group: null,
  level: null,
  increase: null,
  decrease: null,
  up: null,
  down: null,
  inherit: null,
  counter: null,
  reset: null,
  text: null,
  children: null
};
process.env.NODE_ENV !== "production" ? HeadingProvider.propTypes = {
  id: _propTypes.default.string,
  group: _propTypes.default.string,
  level: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  increase: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  decrease: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  up: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  down: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  inherit: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  counter: _propTypes.default.any,
  reset: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string, _propTypes.default.bool]),
  text: _propTypes.default.any,
  children: _propTypes.default.any
} : void 0;