"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _componentHelper = require("../../shared/component-helper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Modal = _interopRequireDefault(require("../modal/Modal"));

var _HelpButtonInstance = _interopRequireDefault(require("./HelpButtonInstance"));

var _Button = require("../button/Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var HelpButton = function (_React$PureComponent) {
  _inherits(HelpButton, _React$PureComponent);

  var _super = _createSuper(HelpButton);

  function HelpButton() {
    _classCallCheck(this, HelpButton);

    return _super.apply(this, arguments);
  }

  _createClass(HelpButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          modal_content = _this$props.modal_content,
          children = _this$props.children,
          modal_props = _this$props.modal_props,
          params = _objectWithoutProperties(_this$props, ["modal_content", "children", "modal_props"]);

      var content = HelpButton.getContent(this.props);

      if (params.icon === null) {
        params.icon = 'question';
      }

      if (content) {
        if (!params.title) {
          params.title = this.context.getTranslation(this.props).HelpButton.title;
        }

        return _react.default.createElement(_Modal.default, _extends({
          trigger_attributes: params
        }, modal_props), content);
      }

      return _react.default.createElement(_HelpButtonInstance.default, params);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(HelpButton.tagName, HelpButton, HelpButton.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.modal_content) {
        return props.modal_content;
      }

      return typeof props.children === 'function' ? props.children(props) : props.children;
    }
  }]);

  return HelpButton;
}(_react.default.PureComponent);

exports.default = HelpButton;
HelpButton.contextType = _Context.default;
HelpButton.tagName = 'dnb-help-button';
HelpButton.defaultProps = {
  variant: 'secondary',
  icon: null,
  icon_position: 'left',
  modal_content: null,
  modal_props: null
};
process.env.NODE_ENV !== "production" ? HelpButton.propTypes = _extends({}, _Button.buttonPropTypes, {
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_position: _propTypes.default.oneOf(['left', 'right']),
  modal_content: _propTypes.default.node,
  modal_props: _propTypes.default.object
}) : void 0;