"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _SpacingHelper = require("../space/SpacingHelper");

var _Button = _interopRequireWildcard(require("../button/Button"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var HelpButtonInstance = function (_React$PureComponent) {
  _inherits(HelpButtonInstance, _React$PureComponent);

  var _super = _createSuper(HelpButtonInstance);

  function HelpButtonInstance() {
    _classCallCheck(this, HelpButtonInstance);

    return _super.apply(this, arguments);
  }

  _createClass(HelpButtonInstance, [{
    key: "render",
    value: function render() {
      var props = (0, _componentHelper.extendPropsWithContext)(this.props, HelpButtonInstance.defaultProps, this.context.FormRow, this.context.HelpButton);

      var size = props.size,
          icon = props.icon,
          on_click = props.on_click,
          className = props.className,
          _className = props.class,
          attributes = props.attributes,
          rest = _objectWithoutProperties(props, ["size", "icon", "on_click", "className", "class", "attributes"]);

      var params = _extends({
        className: (0, _classnames.default)('dnb-help-button', (0, _SpacingHelper.createSpacingClasses)(props), className, _className),
        size: size,
        'aria-label': props.title ? (0, _componentHelper.convertJsxToString)(props.title) : this.context.getTranslation(this.props).HelpButton.title,
        icon: icon
      }, attributes, rest);

      if (typeof params['aria-roledescription'] === 'undefined') {
        params['aria-roledescription'] = this.context.getTranslation(this.props).HelpButton.aria_role;
      }

      if ((!params.text || params.variant === 'tertiary') && params.icon === null) {
        params.icon = 'question';
      }

      if (icon === 'information' && !size) {
        params.icon_size = 'medium';
      }

      return _react.default.createElement(_Button.default, _extends({
        on_click: on_click
      }, params));
    }
  }]);

  return HelpButtonInstance;
}(_react.default.PureComponent);

exports.default = HelpButtonInstance;
HelpButtonInstance.contextType = _Context.default;
HelpButtonInstance.defaultProps = {
  id: null,
  variant: 'secondary',
  icon: null,
  icon_position: 'left',
  className: null,
  class: null
};
process.env.NODE_ENV !== "production" ? HelpButtonInstance.propTypes = _extends({
  id: _propTypes.default.string
}, _Button.buttonVariantPropType, {
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_position: _propTypes.default.oneOf(['left', 'right'])
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  class: _propTypes.default.string
}) : void 0;