"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fixPositionIssue = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Input = _interopRequireWildcard(require("../input/Input"));

var _componentHelper = require("../../shared/component-helper");

var _reactTextMask = _interopRequireDefault(require("react-text-mask"));

var _createNumberMask = _interopRequireDefault(require("./addons/createNumberMask"));

var _classnames = _interopRequireDefault(require("classnames"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var InputMasked = function (_React$PureComponent) {
  _inherits(InputMasked, _React$PureComponent);

  var _super = _createSuper(InputMasked);

  function InputMasked() {
    _classCallCheck(this, InputMasked);

    return _super.apply(this, arguments);
  }

  _createClass(InputMasked, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._selectionTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          mask = _this$props.mask,
          number_mask = _this$props.number_mask,
          currency_mask = _this$props.currency_mask,
          show_mask = _this$props.show_mask,
          show_guide = _this$props.show_guide,
          pipe = _this$props.pipe,
          keep_char_positions = _this$props.keep_char_positions,
          placeholderChar = _this$props.placeholder_char,
          props = _objectWithoutProperties(_this$props, ["mask", "number_mask", "currency_mask", "show_mask", "show_guide", "pipe", "keep_char_positions", "placeholder_char"]);

      if (number_mask) {
        if ((0, _componentHelper.isTrue)(number_mask)) {
          number_mask = {};
        } else {
          if (typeof number_mask === 'string' && number_mask[0] === '{') {
            number_mask = JSON.parse(number_mask);
          }
        }

        mask = (0, _createNumberMask.default)(number_mask);
      } else if (currency_mask) {
        if ((0, _componentHelper.isTrue)(currency_mask)) {
          currency_mask = {};
        } else {
          if (typeof number_mask === 'string' && number_mask[0] === '{') {
            number_mask = JSON.parse(number_mask);
          }
        }

        show_mask = true;
        placeholderChar = null;
        props.align = props.align || 'right';

        var maskParams = _extends({
          allowDecimal: true
        }, currency_mask);

        var fix = typeof currency_mask === 'string' ? currency_mask : typeof currency_mask.currency === 'string' ? currency_mask.currency : 'kr';

        if (props.align === 'left') {
          maskParams.prefix = "".concat(fix, " ");
        } else {
          maskParams.suffix = " ".concat(fix);
        }

        mask = (0, _createNumberMask.default)(maskParams);
      }

      if (!props.input_element) {
        if (placeholderChar === '' || placeholderChar === null) {
          placeholderChar = "\u200B";
        }

        if (mask.instanceOf === 'createNumberMask') {
          var callEvent = function callEvent(_ref, name) {
            var event = _ref.event,
                value = _ref.value;
            value = value || event.target.value;
            var cleaned_value = clean(value);
            return (0, _componentHelper.dispatchCustomElementEvent)(_this, name, {
              event: event,
              value: value,
              cleaned_value: cleaned_value
            });
          };

          props.onMouseUp = function (event) {
            fixPositionIssue(event.target, props);
            callEvent({
              event: event
            }, 'on_mouse_up');
          };

          props.onTouchEnd = function (event) {
            fixPositionIssue(event.target, props);
            callEvent({
              event: event
            }, 'on_touch_end');
          };

          props.on_focus = function (params) {
            fixPositionIssue(params.event.target, props);
            callEvent(params, 'on_focus');
          };

          props.on_key_down = function (params) {
            return callEvent(params, 'on_key_down');
          };

          props.on_submit = function (params) {
            return callEvent(params, 'on_submit');
          };

          props.on_blur = function (params) {
            return callEvent(params, 'on_blur');
          };

          props.on_change = function (params) {
            return callEvent(params, 'on_change');
          };
        }

        props.input_element = function (params, innerRef) {
          params = _extends({}, params, {
            pipe: pipe,
            mask: mask,
            showMask: (0, _componentHelper.isTrue)(show_mask),
            guide: (0, _componentHelper.isTrue)(show_guide),
            keepCharPositions: (0, _componentHelper.isTrue)(keep_char_positions),
            placeholderChar: placeholderChar
          });
          return _react.default.createElement(_reactTextMask.default, _extends({
            render: function render(setRef, props) {
              return _react.default.createElement("input", _extends({
                ref: function ref(_ref2) {
                  return setRef(innerRef.current = _ref2);
                }
              }, props));
            }
          }, params));
        };
      }

      props.className = (0, _classnames.default)('dnb-input-masked', props.className, show_mask && show_guide && placeholderChar === '_' && 'dnb-input-masked--guide');
      return _react.default.createElement(_Input.default, props);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(InputMasked.tagName, InputMasked, InputMasked.defaultProps);
    }
  }]);

  return InputMasked;
}(_react.default.PureComponent);

exports.default = InputMasked;
InputMasked.tagName = 'dnb-input-masked';
InputMasked.defaultProps = _extends({}, _Input.default.defaultProps, {
  mask: [],
  number_mask: null,
  currency_mask: null,
  show_mask: false,
  show_guide: true,
  pipe: null,
  keep_char_positions: false,
  placeholder_char: '_',
  on_change: null,
  on_submit: null,
  on_focus: null,
  on_blur: null,
  on_submit_focus: null,
  on_submit_blur: null
});
process.env.NODE_ENV !== "production" ? InputMasked.propTypes = _extends({
  mask: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.array, _propTypes.default.func]),
  number_mask: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.object]),
  currency_mask: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.object]),
  show_mask: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  show_guide: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  pipe: _propTypes.default.func,
  keep_char_positions: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  placeholder_char: _propTypes.default.string,
  on_change: _propTypes.default.func,
  on_submit: _propTypes.default.func,
  on_focus: _propTypes.default.func,
  on_blur: _propTypes.default.func,
  on_submit_focus: _propTypes.default.func,
  on_submit_blur: _propTypes.default.func
}, _Input.inputPropTypes) : void 0;

var clean = function clean(v) {
  return String(v).replace(new RegExp('[^\\d,.-]', 'g'), '');
};

var _selectionTimeout;

var fixPositionIssue = function fixPositionIssue(elem) {
  var _ref3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref3$align = _ref3.align,
      align = _ref3$align === void 0 ? 'right' : _ref3$align;

  clearTimeout(_selectionTimeout);
  _selectionTimeout = setTimeout(function () {
    var cleaned_value = clean(elem.value);

    if (cleaned_value.length > 0) {
      return;
    }

    try {
      var end = elem.selectionEnd;

      if (elem.selectionStart === end && end === elem.value.length) {
        var pos = 0;

        if (align === 'left') {
          pos = end - 1;
        }

        elem.setSelectionRange(pos, pos);
      }
    } catch (e) {}
  }, 1);
};

exports.fixPositionIssue = fixPositionIssue;