"use strict";

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SubmitButton = exports.default = exports.inputPropTypes = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _Button = _interopRequireWildcard(require("../button/Button"));

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _IconPrimary = _interopRequireDefault(require("../icon-primary/IconPrimary"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var inputPropTypes = _extends({
  type: _propTypes.default.string,
  size: _propTypes.default.oneOfType([_propTypes.default.oneOf(['default', 'small', 'medium', 'large']), _propTypes.default.number]),
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  id: _propTypes.default.string,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['horizontal', 'vertical']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  input_state: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  autocomplete: _propTypes.default.string,
  submit_button_title: _propTypes.default.string,
  placeholder: _propTypes.default.string,
  keep_placeholder: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  align: _propTypes.default.oneOf(['left', 'center', 'right']),
  selectall: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  stretch: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  class: _propTypes.default.string,
  input_class: _propTypes.default.string,
  input_attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  input_element: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node]),
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_size: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  icon_position: _propTypes.default.oneOf(['left', 'right']),
  inner_ref: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.object]),
  readOnly: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  submit_element: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node]),
  submit_button_variant: _Button.buttonVariantPropType.variant,
  submit_button_icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  submit_button_status: _propTypes.default.string
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_submit: _propTypes.default.func,
  on_focus: _propTypes.default.func,
  on_blur: _propTypes.default.func,
  on_submit_focus: _propTypes.default.func,
  on_submit_blur: _propTypes.default.func,
  on_state_update: _propTypes.default.func
});

exports.inputPropTypes = inputPropTypes;

var _ref = _react.default.createElement(_AlignmentHelper.default, null);

var Input = function (_React$PureComponent) {
  _inherits(Input, _React$PureComponent);

  var _super = _createSuper(Input);

  function Input(props, context) {
    var _this;

    _classCallCheck(this, Input);

    _this = _super.call(this, props);
    _this.state = {
      inputState: 'virgin',
      value: null,
      _value: null
    };

    _this.onFocusHandler = function (event) {
      var value = event.target.value;

      _this.setState({
        inputState: 'focus',
        _listenForPropChanges: false
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_focus', {
        value: value,
        event: event
      });

      if ((0, _componentHelper.isTrue)(_this.props.selectall) && _this._ref.current) {
        clearTimeout(_this._selectallTimeout);
        _this._selectallTimeout = setTimeout(function () {
          try {
            _this._ref.current.select();
          } catch (e) {
            (0, _componentHelper.warn)(e);
          }
        }, 1);
      }
    };

    _this.onBlurHandler = function (event) {
      var value = event.target.value;

      _this.setState({
        inputState: Input.hasValue(value) && value !== _this.state._value ? 'dirty' : 'initial',
        _listenForPropChanges: false
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_blur', {
        value: value,
        event: event
      });
    };

    _this.onChangeHandler = function (event) {
      var value = event.target.value;

      _this.setState({
        value: value,
        _listenForPropChanges: false
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        value: value,
        event: event
      });
    };

    _this.onKeyDownHandler = function (event) {
      var value = event.target.value;
      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_key_down', {
        value: value,
        event: event
      });

      if (event.key === 'Enter') {
        (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_submit', {
          value: value,
          event: event
        });
      }
    };

    _this._ref = props.inner_ref || _react.default.createRef();
    _this._id = props.id || context.FormRow && typeof context.FormRow.useId === 'function' && context.FormRow.useId() || (0, _componentHelper.makeUniqueId)();
    _this.state._listenForPropChanges = true;
    _this.state._value = props.value;
    return _this;
  }

  _createClass(Input, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._selectallTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Input.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Input, this.context.FormRow, this.context.Input);

      var type = props.type,
          size = props.size,
          label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          disabled = props.disabled,
          skeleton = props.skeleton,
          placeholder = props.placeholder,
          keep_placeholder = props.keep_placeholder,
          suffix = props.suffix,
          align = props.align,
          input_class = props.input_class,
          submit_button_title = props.submit_button_title,
          submit_button_variant = props.submit_button_variant,
          submit_button_icon = props.submit_button_icon,
          submit_button_status = props.submit_button_status,
          submit_element = props.submit_element,
          autocomplete = props.autocomplete,
          readOnly = props.readOnly,
          stretch = props.stretch,
          input_attributes = props.input_attributes,
          icon = props.icon,
          icon_position = props.icon_position,
          icon_size = props.icon_size,
          _className = props.class,
          className = props.className,
          _id = props.id,
          children = props.children,
          _value = props.value,
          selectall = props.selectall,
          on_submit = props.on_submit,
          _input_element = props.input_element,
          attributes = _objectWithoutProperties(props, ["type", "size", "label", "label_direction", "label_sr_only", "status", "status_state", "status_animation", "global_status_id", "disabled", "skeleton", "placeholder", "keep_placeholder", "suffix", "align", "input_class", "submit_button_title", "submit_button_variant", "submit_button_icon", "submit_button_status", "submit_element", "autocomplete", "readOnly", "stretch", "input_attributes", "icon", "icon_position", "icon_size", "class", "className", "id", "children", "value", "selectall", "on_submit", "input_element"]);

      var _this$state = this.state,
          value = _this$state.value,
          focusState = _this$state.focusState,
          inputState = _this$state.inputState;

      if ((0, _componentHelper.isTrue)(disabled) || (0, _componentHelper.isTrue)(skeleton)) {
        inputState = 'disabled';
      }

      var sizeIsNumber = parseFloat(size) > 0;
      var id = this._id;
      var showStatus = (0, _componentHelper.getStatusState)(status);
      var hasSubmitButton = submit_element || submit_element !== false && type === 'search';
      var hasValue = Input.hasValue(value);
      var iconSize = size === 'large' && (icon_size === 'default' || !icon_size) ? 'medium' : icon_size;
      var mainParams = {
        className: (0, _classnames.default)("dnb-input dnb-input--".concat(type, " dnb-form-component"), (0, _SpacingHelper.createSpacingClasses)(props), _className, className, icon && "dnb-input--icon-position-".concat(icon_position, " dnb-input--has-icon") + (iconSize ? " dnb-input--icon-size-".concat(iconSize) : ""), size && !sizeIsNumber && "dnb-input--".concat(size), hasSubmitButton && 'dnb-input--has-submit-element', align && "dnb-input__align--".concat(align), status && "dnb-input__status--".concat(status_state), label_direction && "dnb-input--".concat(label_direction), (0, _componentHelper.isTrue)(stretch) && "dnb-input--stretch", (0, _componentHelper.isTrue)(keep_placeholder) && "dnb-input--keep-placeholder")
      };
      var innerParams = {
        className: 'dnb-input__inner'
      };
      var InputElement = props.input_element;
      var inputAttributes = input_attributes ? typeof input_attributes === 'string' ? JSON.parse(input_attributes) : input_attributes : {};

      var inputParams = _extends({
        className: (0, _classnames.default)('dnb-input__input', input_class),
        autoComplete: autocomplete,
        value: hasValue ? value : '',
        type: type,
        id: id,
        disabled: (0, _componentHelper.isTrue)(disabled),
        name: id,
        'aria-placeholder': placeholder
      }, attributes, inputAttributes, {
        onChange: this.onChangeHandler,
        onKeyDown: this.onKeyDownHandler,
        onFocus: this.onFocusHandler,
        onBlur: this.onBlurHandler
      });

      if (sizeIsNumber) {
        inputParams.size = size;
      }

      if (showStatus || suffix || hasSubmitButton) {
        inputParams['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(inputParams, hasSubmitButton && !submit_element ? id + '-submit-button' : null, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (readOnly) {
        inputParams['aria-readonly'] = inputParams.readOnly = true;
      }

      if (!hasValue && placeholder && focusState !== 'focus') {
        inputParams['aria-labelledby'] = id + '-placeholder';
      }

      var shellParams = {
        className: (0, _classnames.default)('dnb-input__shell', (0, _SkeletonHelper.createSkeletonClass)('shape', skeleton, this.context)),
        'data-input-state': inputState,
        'data-has-content': hasValue ? 'true' : 'false'
      };
      (0, _SkeletonHelper.skeletonDOMAttributes)(inputParams, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, inputParams);
      (0, _componentHelper.validateDOMAttributes)(null, shellParams);

      if (InputElement && typeof InputElement === 'function') {
        InputElement = InputElement(inputParams, this._ref);
      } else if (!InputElement && _input_element) {
        InputElement = _input_element;
      }

      return _react.default.createElement("span", mainParams, label && _react.default.createElement(_FormLabel.default, {
        id: id + '-label',
        for_id: id,
        text: label,
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton
      }), _react.default.createElement("span", innerParams, _ref, showStatus && _react.default.createElement(_FormStatus.default, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text: status,
        status: status_state,
        text_id: id + '-status',
        animation: status_animation,
        skeleton: skeleton
      }), _react.default.createElement("span", {
        className: "dnb-input__row"
      }, _react.default.createElement("span", shellParams, InputElement || _react.default.createElement("input", _extends({
        ref: this._ref
      }, inputParams)), icon && _react.default.createElement(InputIcon, {
        className: "dnb-input__icon",
        icon: icon,
        size: iconSize
      }), !hasValue && placeholder && focusState !== 'focus' && _react.default.createElement("span", {
        id: id + '-placeholder',
        className: 'dnb-input__placeholder' + (align ? " dnb-input__align--".concat(align) : ""),
        role: "presentation",
        "aria-hidden": true
      }, placeholder)), hasSubmitButton && _react.default.createElement("span", {
        className: "dnb-input__submit-element"
      }, submit_element ? submit_element : _react.default.createElement(SubmitButton, _extends({}, attributes, {
        id: id + '-submit-button',
        value: inputParams.value,
        icon: submit_button_icon,
        status: (0, _componentHelper.convertStatusToStateOnly)(submit_button_status || status, status_state),
        status_state: status_state,
        icon_size: size === 'medium' || size === 'large' ? 'medium' : 'default',
        title: submit_button_title,
        variant: submit_button_variant,
        disabled: (0, _componentHelper.isTrue)(disabled),
        skeleton: (0, _componentHelper.isTrue)(skeleton),
        size: size,
        on_submit: on_submit
      }))), suffix && _react.default.createElement(_Suffix.default, {
        className: "dnb-input__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Input.tagName, Input, Input.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = Input.getValue(props);

      if (state._listenForPropChanges && value !== 'initval' && value !== state.value) {
        if (value !== state.value && value !== state._value && typeof props.on_state_update === 'function') {
          (0, _componentHelper.dispatchCustomElementEvent)({
            props: props
          }, 'on_state_update', {
            value: value
          });
        }

        state.value = value;
      }

      if (props.input_state) {
        state.inputState = props.input_state;
      }

      state._listenForPropChanges = true;
      return state;
    }
  }, {
    key: "hasValue",
    value: function hasValue(value) {
      return (typeof value === 'string' || typeof value === 'number') && String(value).length > 0 || false;
    }
  }, {
    key: "getValue",
    value: function getValue(props) {
      var value = (0, _componentHelper.processChildren)(props);

      if (value === '' || Input.hasValue(value)) {
        return value;
      }

      return props.value;
    }
  }]);

  return Input;
}(_react.default.PureComponent);

exports.default = Input;
Input.tagName = 'dnb-input';
Input.contextType = _Context.default;
Input.defaultProps = {
  type: 'text',
  size: null,
  value: 'initval',
  id: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  input_state: null,
  global_status_id: null,
  autocomplete: 'off',
  placeholder: null,
  keep_placeholder: null,
  suffix: null,
  align: null,
  selectall: null,
  stretch: null,
  disabled: null,
  skeleton: null,
  input_class: null,
  class: null,
  input_attributes: null,
  input_element: null,
  inner_ref: null,
  icon: null,
  icon_size: null,
  icon_position: 'left',
  readOnly: false,
  submit_element: null,
  submit_button_title: null,
  submit_button_variant: 'secondary',
  submit_button_icon: 'loupe',
  submit_button_status: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_submit: null,
  on_focus: null,
  on_blur: null,
  on_submit_focus: null,
  on_submit_blur: null,
  on_state_update: null
};
process.env.NODE_ENV !== "production" ? Input.propTypes = _extends({}, inputPropTypes) : void 0;

var InputSubmitButton = function (_React$PureComponent2) {
  _inherits(InputSubmitButton, _React$PureComponent2);

  var _super2 = _createSuper(InputSubmitButton);

  function InputSubmitButton() {
    var _this2;

    _classCallCheck(this, InputSubmitButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this2 = _super2.call.apply(_super2, [this].concat(args));
    _this2.state = {
      focusState: 'virgin'
    };

    _this2.onFocusHandler = function (event) {
      var value = _this2.props.value;

      _this2.setState({
        focusState: 'focus'
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this2), 'on_submit_focus', {
        value: value,
        event: event
      });
    };

    _this2.onBlurHandler = function (event) {
      var value = _this2.props.value;

      _this2.setState({
        focusState: 'dirty'
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this2), 'on_submit_blur', {
        value: value,
        event: event
      });
    };

    _this2.onSubmitHandler = function (event) {
      var value = _this2.props.value;
      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this2), 'on_submit', {
        value: value,
        event: event
      });
    };

    return _this2;
  }

  _createClass(InputSubmitButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          title = _this$props.title,
          disabled = _this$props.disabled,
          skeleton = _this$props.skeleton,
          variant = _this$props.variant,
          icon = _this$props.icon,
          icon_size = _this$props.icon_size,
          status = _this$props.status,
          status_state = _this$props.status_state,
          className = _this$props.className,
          rest = _objectWithoutProperties(_this$props, ["id", "title", "disabled", "skeleton", "variant", "icon", "icon_size", "status", "status_state", "className"]);

      var params = _extends({
        id: id,
        type: 'submit',
        'aria-label': title,
        disabled: disabled
      }, rest);

      (0, _SkeletonHelper.skeletonDOMAttributes)(params, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement("span", {
        className: "dnb-input__submit-button",
        "data-input-state": this.state.focusState
      }, _react.default.createElement(_Button.default, _extends({
        className: (0, _classnames.default)('dnb-input__submit-button__button', className),
        variant: variant,
        icon: icon,
        icon_size: icon_size,
        status: status,
        status_state: status_state,
        onClick: this.onSubmitHandler,
        onFocus: this.onFocusHandler,
        onBlur: this.onBlurHandler
      }, params)));
    }
  }]);

  return InputSubmitButton;
}(_react.default.PureComponent);

InputSubmitButton.defaultProps = {
  id: null,
  value: null,
  title: null,
  disabled: false,
  skeleton: false,
  variant: 'secondary',
  icon: 'loupe',
  icon_size: null,
  status: null,
  status_state: 'error',
  className: null,
  on_submit: null,
  on_submit_focus: null,
  on_submit_blur: null
};
process.env.NODE_ENV !== "production" ? InputSubmitButton.propTypes = {
  id: _propTypes.default.string,
  value: _propTypes.default.string,
  title: _propTypes.default.string,
  variant: _Button.buttonVariantPropType.variant,
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_size: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  className: _propTypes.default.string,
  on_submit: _propTypes.default.func,
  on_submit_focus: _propTypes.default.func,
  on_submit_blur: _propTypes.default.func
} : void 0;

var SubmitButton = _react.default.forwardRef(function (props, ref) {
  return _react.default.createElement(InputSubmitButton, _extends({
    innerRef: ref
  }, props));
});

exports.SubmitButton = SubmitButton;

var InputIcon = _react.default.memo(function (props) {
  return _react.default.createElement(_IconPrimary.default, props);
}, function (_ref2, _ref3) {
  var prev = _ref2.icon;
  var next = _ref3.icon;

  if (typeof prev === 'string' && typeof next === 'string') {
    return false;
  }

  return _typeof(prev) === _typeof(next);
});

InputIcon.propTypes = {
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]).isRequired
};