"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Input = _interopRequireWildcard(require("./Input"));

var _componentHelper = require("../../shared/component-helper");

var _view = _interopRequireDefault(require("../../icons/view"));

var _hide = _interopRequireDefault(require("../../icons/hide"));

var _view_medium = _interopRequireDefault(require("../../icons/view_medium"));

var _hide_medium = _interopRequireDefault(require("../../icons/hide_medium"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var InputPassword = function (_React$PureComponent) {
  _inherits(InputPassword, _React$PureComponent);

  var _super = _createSuper(InputPassword);

  function InputPassword(props) {
    var _this;

    _classCallCheck(this, InputPassword);

    _this = _super.call(this, props);
    _this.state = {
      hidden: true
    };

    _this.toggleVisibility = function (event) {
      var hidden = _this.state.hidden;

      _this.setState({
        hidden: !hidden
      }, function () {
        if (_this._ref.current) {
          _this._ref.current.focus();
        }
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), hidden ? 'on_show_password' : 'on_hide_password', {
        event: event
      });
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this._ref = props.inner_ref || _react.default.createRef();
    return _this;
  }

  _createClass(InputPassword, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, InputPassword.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Input, this.context.FormRow, this.context.Input, this.context.InputPassword);
      var id = this._id;
      var params = {};
      params['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(this.props, id + '-submit-button');
      return _react.default.createElement(_Input.default, _extends({
        id: id
      }, this.props, params, {
        className: (0, _classnames.default)('dnb-input--password', this.props.className),
        type: this.state.hidden ? 'password' : 'text',
        inner_ref: this._ref,
        submit_element: _react.default.createElement(_Input.SubmitButton, {
          id: id + '-submit-button',
          type: "button",
          variant: "secondary",
          "aria-controls": id,
          "aria-label": this.state.hidden ? props.show_password : props.hide_password,
          icon: props.size === 'large' ? this.state.hidden ? _view_medium.default : _hide_medium.default : this.state.hidden ? _view.default : _hide.default,
          skeleton: props.skeleton,
          status: (0, _componentHelper.convertStatusToStateOnly)(props.status, props.status_state),
          status_state: props.status_state,
          onClick: this.toggleVisibility
        })
      }));
    }
  }]);

  return InputPassword;
}(_react.default.PureComponent);

exports.default = InputPassword;
InputPassword.contextType = _Context.default;
InputPassword.defaultProps = _extends({
  show_password: null,
  hide_password: null,
  on_show_password: null,
  on_hide_password: null
}, _Input.default.defaultProps);
process.env.NODE_ENV !== "production" ? InputPassword.propTypes = _extends({
  show_password: _propTypes.default.string,
  hide_password: _propTypes.default.string,
  on_show_password: _propTypes.default.func,
  on_hide_password: _propTypes.default.func
}, _Input.default.propTypes) : void 0;