"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getListOfModalRoots = getListOfModalRoots;
exports.CloseButton = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _bodyScrollLock = require("../../shared/libs/bodyScrollLock");

var _componentHelper = require("../../shared/component-helper");

var _Button = _interopRequireDefault(require("../button/Button"));

var _ScrollView = _interopRequireDefault(require("../../fragments/scroll-view/ScrollView"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var ModalContent = function (_React$PureComponent) {
  _inherits(ModalContent, _React$PureComponent);

  var _super = _createSuper(ModalContent);

  function ModalContent(props) {
    var _this;

    _classCallCheck(this, ModalContent);

    _this = _super.call(this, props);
    _this.state = {
      triggeredBy: null,
      triggeredByEvent: null
    };

    _this._androidFocusHelper = function () {
      clearTimeout(_this._androidFocusTimeout);
      _this._androidFocusTimeout = setTimeout(function () {
        try {
          if (document.activeElement.tagName == 'INPUT' || document.activeElement.tagName == 'TEXTAREA') {
            document.activeElement.scrollIntoView();
          }
        } catch (e) {}
      }, 100);
    };

    _this.preventClick = function (e) {
      if (e) {
        e.stopPropagation();
      }
    };

    _this.onCloseClickHandler = function (e) {
      _this.closeModal(e, {
        triggeredBy: 'button'
      });
    };

    _this.onContentClickHandler = function (e) {
      _this.closeModal(e, {
        triggeredBy: 'overlay',
        ifIsLatest: false
      });
    };

    _this.onKeyDownHandler = function (e) {
      switch ((0, _keycode.default)(e)) {
        case 'esc':
          {
            var mostCurrent = _toConsumableArray(getListOfModalRoots()).pop();

            if (mostCurrent === _assertThisInitialized(_this)) {
              e.preventDefault();

              _this.closeModal(e, {
                triggeredBy: 'keyboard'
              });
            }

            break;
          }
      }
    };

    _this._contentRef = _react.default.createRef();
    _this._id = (0, _componentHelper.makeUniqueId)();
    _this._ii = new _componentHelper.InteractionInvalidation();

    _this._ii.setBypassSelector(['.dnb-modal__content', "#dnb-modal-".concat(props.root_id || 'root')]);

    return _this;
  }

  _createClass(ModalContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.addToIndex();
      var modalRoots = getListOfModalRoots();
      var firstLevel = modalRoots[0];

      if (firstLevel === this) {
        this.removeScrollPossibility();

        this._ii.activate();
      } else {
        modalRoots.forEach(function (modal) {
          if (modal !== _this2 && typeof modal._iiLocal === 'undefined' && typeof modal._contentRef !== 'undefined') {
            modal._iiLocal = new _componentHelper.InteractionInvalidation();

            modal._iiLocal.activate(modal._contentRef.current);
          }
        });
      }

      this.setAndroidFocusHelper();
      this.setFocus();
      var id = this.props.id;
      (0, _componentHelper.dispatchCustomElementEvent)(this, 'on_open', {
        id: id
      });

      if (typeof document !== 'undefined') {
        document.addEventListener('keydown', this.onKeyDownHandler);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._focusTimeout);
      var modalRoots = getListOfModalRoots();
      var firstLevel = modalRoots[0];
      this.removeFromIndex();

      if (firstLevel === this) {
        this._ii.revert();

        this.revertScrollPossibility();
      } else {
        try {
          var modal = modalRoots[modalRoots.length - 2];

          if (modal !== this && modal._iiLocal) {
            modal._iiLocal.revert();

            delete modal._iiLocal;
          }
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }

      this.removeAndroidFocusHelper();
      var id = this.props.id;
      var _this$state = this.state,
          triggeredBy = _this$state.triggeredBy,
          triggeredByEvent = _this$state.triggeredByEvent;
      (0, _componentHelper.dispatchCustomElementEvent)(this, 'on_close', {
        id: id,
        event: triggeredByEvent,
        triggeredBy: triggeredBy || 'unmount'
      });

      if (typeof document !== 'undefined') {
        document.removeEventListener('keydown', this.onKeyDownHandler);
      }
    }
  }, {
    key: "setAndroidFocusHelper",
    value: function setAndroidFocusHelper() {
      if (typeof window !== 'undefined' && typeof navigator !== 'undefined' && /Android/.test(navigator.appVersion)) {
        window.addEventListener('resize', this._androidFocusHelper);
      }
    }
  }, {
    key: "removeAndroidFocusHelper",
    value: function removeAndroidFocusHelper() {
      window.removeEventListener('resize', this._androidFocusHelper);
      clearTimeout(this._androidFocusTimeout);
    }
  }, {
    key: "addToIndex",
    value: function addToIndex() {
      if (typeof window !== 'undefined') {
        try {
          window.__modalStack = window.__modalStack || [];

          window.__modalStack.push(this);
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }
    }
  }, {
    key: "removeFromIndex",
    value: function removeFromIndex() {
      var _this3 = this;

      if (typeof window !== 'undefined') {
        try {
          window.__modalStack = window.__modalStack || [];
          window.__modalStack = window.__modalStack.filter(function (cur) {
            return cur !== _this3;
          });

          if (!window.__modalStack.length) {
            delete window.__modalStack;
          }
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }
    }
  }, {
    key: "setFocus",
    value: function setFocus() {
      var _this$props = this.props,
          focus_selector = _this$props.focus_selector,
          animation_duration = _this$props.animation_duration;
      var elem = this._contentRef.current;

      if (elem) {
        clearTimeout(this._focusTimeout);
        this._focusTimeout = setTimeout(function () {
          try {
            var focusElement;

            if (typeof focus_selector === 'string') {
              focusElement = elem.querySelector(focus_selector);
            } else if (focus_selector === false) {
              return;
            }

            if (!focusElement) {
              focusElement = elem.querySelector('h1:first-of-type, h2:first-of-type, .dnb-modal__close-button:not([disabled])');
            }

            if (!focusElement) {
              focusElement = elem;
            }

            if (focusElement) {
              focusElement.focus();
            }
          } catch (e) {
            (0, _componentHelper.warn)(e);
          }
        }, parseFloat(animation_duration));
      }
    }
  }, {
    key: "removeScrollPossibility",
    value: function removeScrollPossibility() {
      if (this._contentRef.current) {
        (0, _bodyScrollLock.disableBodyScroll)(this._contentRef.current);
      }
    }
  }, {
    key: "revertScrollPossibility",
    value: function revertScrollPossibility() {
      (0, _bodyScrollLock.enableBodyScroll)(this._contentRef.current);
      (0, _bodyScrollLock.clearAllBodyScrollLocks)();
    }
  }, {
    key: "closeModal",
    value: function closeModal(event, _ref) {
      var _event$persist,
          _this4 = this;

      var triggeredBy = _ref.triggeredBy,
          params = _objectWithoutProperties(_ref, ["triggeredBy"]);

      event === null || event === void 0 ? void 0 : (_event$persist = event.persist) === null || _event$persist === void 0 ? void 0 : _event$persist.call(event);
      this.setState({
        triggeredBy: triggeredBy,
        triggeredByEvent: event
      }, function () {
        _this4.props.closeModal(event, _extends({
          triggeredBy: triggeredBy
        }, params));
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          mode = _this$props2.mode,
          hide = _this$props2.hide,
          title = _this$props2.title,
          labelled_by = _this$props2.labelled_by,
          modal_content = _this$props2.modal_content,
          close_title = _this$props2.close_title,
          hide_close_button = _this$props2.hide_close_button,
          spacing = _this$props2.spacing,
          prevent_close = _this$props2.prevent_close,
          open_delay = _this$props2.open_delay,
          prevent_core_style = _this$props2.prevent_core_style,
          animation_duration = _this$props2.animation_duration,
          no_animation = _this$props2.no_animation,
          no_animation_on_mobile = _this$props2.no_animation_on_mobile,
          min_width = _this$props2.min_width,
          max_width = _this$props2.max_width,
          fullscreen = _this$props2.fullscreen,
          align_content = _this$props2.align_content,
          container_placement = _this$props2.container_placement,
          closeModal = _this$props2.closeModal,
          className = _this$props2.className,
          _className = _this$props2.class,
          content_class = _this$props2.content_class,
          overlay_class = _this$props2.overlay_class,
          content_id = _this$props2.content_id,
          toggleOpenClose = _this$props2.toggleOpenClose,
          children = _this$props2.children,
          rest = _objectWithoutProperties(_this$props2, ["mode", "hide", "title", "labelled_by", "modal_content", "close_title", "hide_close_button", "spacing", "prevent_close", "open_delay", "prevent_core_style", "animation_duration", "no_animation", "no_animation_on_mobile", "min_width", "max_width", "fullscreen", "align_content", "container_placement", "closeModal", "className", "class", "content_class", "overlay_class", "content_id", "toggleOpenClose", "children"]);

      var id = content_id || this._id;
      var minWidth = min_width;
      var maxWidth = max_width;

      if (minWidth && !maxWidth && parseFloat(minWidth) > 0) {
        maxWidth = 0;
      } else if (maxWidth && !minWidth && parseFloat(maxWidth) > 0) {
        minWidth = 0;
      }

      var contentParams = {
        role: 'main',
        'aria-modal': 'true',
        'aria-labelledby': (0, _componentHelper.combineLabelledBy)(this.props, title ? id + '-title' : null, labelled_by),
        'aria-describedby': (0, _componentHelper.combineDescribedBy)(this.props, id + '-content'),
        className: (0, _classnames.default)('dnb-modal__content', (container_placement || mode === 'drawer') && "dnb-modal__content--".concat(container_placement || 'right'), (0, _componentHelper.isTrue)(fullscreen) ? 'dnb-modal__content--fullscreen' : fullscreen === 'auto' && 'dnb-modal__content--auto-fullscreen', content_class, mode && "dnb-modal__content--".concat(mode), (0, _componentHelper.isTrue)(hide) && 'dnb-modal__content--hide', (0, _componentHelper.isTrue)(spacing) && 'dnb-modal__content--spacing', align_content && "dnb-modal__content__align--".concat(align_content), (0, _componentHelper.isTrue)(no_animation) && 'dnb-modal__content--no-animation', (0, _componentHelper.isTrue)(no_animation_on_mobile) && 'dnb-modal__content--no-animation-on-mobile'),
        onClick: this.onContentClickHandler
      };

      var innerParams = _extends({
        className: (0, _classnames.default)('dnb-modal__content__inner', className, _className, !(0, _componentHelper.isTrue)(prevent_core_style) && 'dnb-core-style'),
        style: (minWidth || maxWidth) && {
          minWidth: minWidth,
          maxWidth: maxWidth
        },
        onClick: this.preventClick,
        onTouchStart: this.preventClick,
        onKeyDown: this.onKeyDownHandler
      }, rest);

      var spacingParams = {
        tabIndex: -1,
        className: "dnb-modal__content__spacing dnb-no-focus"
      };
      var overlayParams = {
        className: (0, _classnames.default)('dnb-modal__overlay', overlay_class, hide && 'dnb-modal__overlay--hide', mode && "dnb-modal__overlay--".concat(mode), (0, _componentHelper.isTrue)(no_animation) && 'dnb-modal__overlay--no-animation', (0, _componentHelper.isTrue)(no_animation_on_mobile) && 'dnb-modal__overlay--no-animation-on-mobile')
      };
      (0, _componentHelper.validateDOMAttributes)(this.props, innerParams);
      return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement("div", _extends({
        id: id
      }, contentParams), _react.default.createElement(_ScrollView.default, innerParams, _react.default.createElement("div", _extends({}, spacingParams, {
        ref: this._contentRef
      }), title && _react.default.createElement("h1", {
        id: id + '-title',
        className: "dnb-modal__title " + (mode === 'drawer' ? 'dnb-h--x-large' : 'dnb-h--large')
      }, title), !(0, _componentHelper.isTrue)(hide_close_button) && _react.default.createElement(CloseButton, {
        on_click: this.onCloseClickHandler,
        close_title: close_title
      }), _react.default.createElement("div", {
        id: id + '-content',
        className: "dnb-modal__wrapper"
      }, modal_content)))), _react.default.createElement("span", _extends({}, overlayParams, {
        "aria-hidden": "true"
      })));
    }
  }]);

  return ModalContent;
}(_react.default.PureComponent);

exports.default = ModalContent;
ModalContent.defaultProps = {
  mode: null,
  hide: null,
  id: null,
  root_id: null,
  labelled_by: null,
  focus_selector: null,
  content_id: null,
  title: null,
  close_title: null,
  hide_close_button: null,
  spacing: null,
  prevent_close: null,
  prevent_core_style: null,
  animation_duration: null,
  no_animation: null,
  no_animation_on_mobile: null,
  min_width: null,
  max_width: null,
  fullscreen: null,
  align_content: null,
  container_placement: null,
  class: null,
  overlay_class: null,
  content_class: null,
  closeModal: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? ModalContent.propTypes = {
  modal_content: _propTypes.default.node.isRequired,
  mode: _propTypes.default.oneOf(['modal', 'drawer']),
  hide: _propTypes.default.bool,
  id: _propTypes.default.string,
  root_id: _propTypes.default.string,
  labelled_by: _propTypes.default.string,
  focus_selector: _propTypes.default.string,
  content_id: _propTypes.default.string,
  title: _propTypes.default.node,
  close_title: _propTypes.default.string,
  hide_close_button: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  spacing: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_close: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_core_style: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  animation_duration: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_animation_on_mobile: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  min_width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  max_width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  fullscreen: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  align_content: _propTypes.default.string,
  container_placement: _propTypes.default.string,
  class: _propTypes.default.string,
  content_class: _propTypes.default.string,
  overlay_class: _propTypes.default.string,
  closeModal: _propTypes.default.func.isRequired,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func])
} : void 0;

var CloseButton = function (_React$PureComponent2) {
  _inherits(CloseButton, _React$PureComponent2);

  var _super2 = _createSuper(CloseButton);

  function CloseButton() {
    _classCallCheck(this, CloseButton);

    return _super2.apply(this, arguments);
  }

  _createClass(CloseButton, [{
    key: "render",
    value: function render() {
      var _extendPropsWithConte = (0, _componentHelper.extendPropsWithContext)(this.props, CloseButton.defaultProps, this.context.getTranslation(this.props).Modal, this.context.FormRow, this.context.ModalContent),
          on_click = _extendPropsWithConte.on_click,
          style_type = _extendPropsWithConte.style_type,
          close_title = _extendPropsWithConte.close_title,
          _extendPropsWithConte2 = _extendPropsWithConte.className,
          className = _extendPropsWithConte2 === void 0 ? null : _extendPropsWithConte2,
          rest = _objectWithoutProperties(_extendPropsWithConte, ["on_click", "style_type", "close_title", "className"]);

      if (style_type === 'cross') {
        rest.icon_size = 'medium';
      } else {
        rest.size = 'large';
        rest.icon_size = 'basis';
        rest.text = close_title;
      }

      return _react.default.createElement(_Button.default, _extends({
        type: "button",
        variant: "secondary",
        className: (0, _classnames.default)('dnb-modal__close-button', className, style_type && "dnb-modal__close-button--".concat(style_type)),
        icon: "close",
        on_click: on_click
      }, rest));
    }
  }]);

  return CloseButton;
}(_react.default.PureComponent);

exports.CloseButton = CloseButton;
CloseButton.contextType = _Context.default;
CloseButton.defaultProps = {
  style_type: null,
  close_title: null,
  className: null
};
process.env.NODE_ENV !== "production" ? CloseButton.propTypes = {
  style_type: _propTypes.default.oneOf(['button', 'cross']),
  on_click: _propTypes.default.func.isRequired,
  close_title: _propTypes.default.string,
  className: _propTypes.default.string
} : void 0;

function getListOfModalRoots() {
  var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

  if (typeof window !== 'undefined') {
    try {
      var stack = window.__modalStack || [];

      if (index !== null) {
        if (index === -1 && stack.length) {
          return stack[stack.length - 1];
        } else if (index > -1) {
          return stack[index];
        }
      }

      return stack;
    } catch (e) {
      (0, _componentHelper.warn)(e);
    }
  }

  return [];
}