"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/es.string.trim.js");

require("core-js/modules/es.string.link.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cleanNumber = cleanNumber;
exports.runIOSSelectionFix = runIOSSelectionFix;
exports.copyWithEffect = copyWithEffect;
exports.createSelectionFX = createSelectionFX;
exports.formatNIN = exports.formatORG = exports.formatBAN = exports.formatPhone = exports.formatNumber = exports.format = exports.default = void 0;

require("regenerator-runtime/runtime.js");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _defaults = require("../../shared/defaults");

var _componentHelper = require("../../shared/component-helper");

var _helpers = require("../../shared/helpers");

var _SpacingHelper = require("../space/SpacingHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var NUMBER_CHARS = '-0-9,.';

var Number = function (_React$PureComponent) {
  _inherits(Number, _React$PureComponent);

  var _super = _createSuper(Number);

  function Number(props) {
    var _this;

    _classCallCheck(this, Number);

    _this = _super.call(this, props);

    _this.shortcutHandler = function () {
      var fx = createSelectionFX(_this.cleanedValue);
      fx.run();
    };

    _this.onBlurHandler = function () {
      _this.setState({
        selected: false
      });
    };

    _this.onContextMenuHandler = function () {
      if (!(0, _helpers.hasSelectedText)()) {
        clearTimeout(_this._selectAllTimeout);
        _this._selectAllTimeout = setTimeout(function () {
          _this.setFocus();
        }, 1);
      }
    };

    _this.onClickHandler = function () {
      if (!(0, _helpers.hasSelectedText)()) {
        _this.setFocus();
      }
    };

    _this._ref = _react.default.createRef();
    _this._selectionRef = _react.default.createRef();
    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this.state = {
      selected: false
    };
    return _this;
  }

  _createClass(Number, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      clearTimeout(this._selectAllTimeout);

      if (_helpers.IS_IOS && !hasiOSFix) {
        hasiOSFix = true;
        runIOSSelectionFix();
      }
    }
  }, {
    key: "setFocus",
    value: function setFocus() {
      var _this2 = this;

      this.setState({
        selected: true
      }, function () {
        if (_this2._selectionRef.current) {
          _this2._selectionRef.current.focus();
        }

        _this2.selectAll();
      });
    }
  }, {
    key: "selectAll",
    value: function selectAll() {
      try {
        var elem = this._selectionRef.current || this._ref.current;

        if (elem) {
          var selection = window.getSelection();
          var range = document.createRange();
          range.selectNodeContents(elem);
          selection.removeAllRanges();
          selection.addRange(range);
        }
      } catch (e) {
        (0, _componentHelper.warn)(e);
      }
    }
  }, {
    key: "runFix",
    value: function runFix(comp, className) {
      if (typeof comp === 'function') {
        comp = comp();
      }

      if (_react.default.isValidElement(comp)) {
        return _react.default.cloneElement(comp, {
          className: (0, _classnames.default)(comp.props.className, className)
        });
      }

      return _react.default.createElement("span", {
        className: className
      }, comp);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          _value = _this$props.value,
          prefix = _this$props.prefix,
          suffix = _this$props.suffix,
          children = _this$props.children,
          currency = _this$props.currency,
          currency_display = _this$props.currency_display,
          currency_position = _this$props.currency_position,
          ban = _this$props.ban,
          nin = _this$props.nin,
          phone = _this$props.phone,
          org = _this$props.org,
          _link = _this$props.link,
          options = _this$props.options,
          locale = _this$props.locale,
          decimals = _this$props.decimals,
          omit_rounding = _this$props.omit_rounding,
          clean = _this$props.clean,
          selectall = _this$props.selectall,
          copy_selection = _this$props.copy_selection,
          element = _this$props.element,
          _className = _this$props.class,
          className = _this$props.className,
          rest = _objectWithoutProperties(_this$props, ["id", "value", "prefix", "suffix", "children", "currency", "currency_display", "currency_position", "ban", "nin", "phone", "org", "link", "options", "locale", "decimals", "omit_rounding", "clean", "selectall", "copy_selection", "element", "class", "className"]);

      var link = _link;
      var value = _value;

      if (children !== null) {
        value = children;
      }

      var formatOptions = {
        locale: locale,
        currency: currency,
        currency_display: currency_display,
        currency_position: currency_position,
        ban: ban,
        nin: nin,
        phone: phone,
        org: org,
        decimals: decimals,
        omit_rounding: (0, _componentHelper.isTrue)(omit_rounding),
        options: options,
        clean: (0, _componentHelper.isTrue)(clean),
        returnAria: true
      };

      if (this.context) {
        var useContext = (0, _componentHelper.extend)(true, {
          locale: null,
          currency: null
        }, this.context, this.context.getTranslation(this.props).Number);

        if (useContext) {
          if (useContext.locale && !locale) {
            formatOptions.locale = useContext.locale;
          }

          if (useContext.currency && (0, _componentHelper.isTrue)(currency)) {
            formatOptions.options = formatOptions.options ? _extends({}, formatOptions.options) : {};
            formatOptions.options.currency = useContext.currency;
          }
        }
      }

      var _format = format(value, formatOptions),
          cleanedValue = _format.cleanedValue,
          display = _format.number,
          aria = _format.aria,
          lang = _format.locale;

      this.cleanedValue = cleanedValue;

      var attributes = _extends({
        ref: this._ref,
        className: (0, _classnames.default)('dnb-number', className, _className, ((0, _componentHelper.isTrue)(currency) || typeof currency === 'string') && 'dnb-number--currency', (0, _SpacingHelper.createSpacingClasses)(this.props), (0, _componentHelper.isTrue)(selectall) && 'dnb-number--selectall', this.state.selected && 'dnb-number--selected', link && 'dnb-anchor')
      }, rest);

      attributes['role'] = 'text';
      var displayParams = {};

      if ((0, _componentHelper.isTrue)(selectall) || (0, _componentHelper.isTrue)(copy_selection)) {
        displayParams.onClick = this.onClickHandler;
        displayParams.onContextMenu = this.onContextMenuHandler;
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, attributes);

      if (prefix) {
        display = _react.default.createElement(_react.default.Fragment, null, this.runFix(prefix, 'dnb-number__prefix'), " ", display);
        aria = String("".concat((0, _componentHelper.convertJsxToString)(this.runFix(prefix, 'dnb-number__prefix')), " ").concat(aria));
      }

      if (suffix) {
        display = _react.default.createElement(_react.default.Fragment, null, display, " ", this.runFix(suffix, 'dnb-number__suffix'));
        aria = "".concat(aria, " ").concat((0, _componentHelper.convertJsxToString)(this.runFix(suffix, 'dnb-number__suffix')));
      }

      if (link) {
        if ((0, _componentHelper.isTrue)(link)) {
          link = 'tel';
        }

        return _react.default.createElement("a", _extends({
          href: "".concat(link, ":").concat(display)
        }, attributes), display);
      }

      var Element = element;
      return _react.default.createElement(Element, _extends({
        lang: lang
      }, attributes), _react.default.createElement("span", _extends({
        className: "dnb-number__visible",
        "aria-describedby": this._id,
        "aria-hidden": true
      }, displayParams), display), _react.default.createElement("span", {
        id: this._id,
        className: "dnb-number__sr-only dnb-sr-only--inline"
      }, aria), (0, _componentHelper.isTrue)(copy_selection) && _react.default.createElement("span", {
        className: "dnb-number__selection dnb-no-focus",
        ref: this._selectionRef,
        tabIndex: -1,
        onBlur: this.onBlurHandler,
        onCopy: this.shortcutHandler,
        "aria-hidden": true
      }, cleanedValue));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Number.tagName, Number, Number.defaultProps);
    }
  }]);

  return Number;
}(_react.default.PureComponent);

exports.default = Number;
Number.tagName = 'dnb-number';
Number.contextType = _Context.default;
Number.defaultProps = {
  id: null,
  value: null,
  locale: null,
  prefix: null,
  suffix: null,
  currency: null,
  currency_display: null,
  currency_position: null,
  ban: null,
  nin: null,
  phone: null,
  org: null,
  link: null,
  options: null,
  decimals: null,
  selectall: true,
  copy_selection: true,
  omit_rounding: null,
  clean: null,
  element: 'span',
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Number.propTypes = _extends({
  id: _propTypes.default.string,
  value: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  locale: _propTypes.default.string,
  prefix: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  suffix: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  currency: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  currency_display: _propTypes.default.string,
  currency_position: _propTypes.default.oneOf(['auto', 'before', 'after']),
  ban: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  nin: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  phone: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  org: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  link: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  options: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.string]),
  decimals: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  selectall: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  copy_selection: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  omit_rounding: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  clean: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  element: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
}) : void 0;

var format = function format(value) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$locale = _ref.locale,
      locale = _ref$locale === void 0 ? null : _ref$locale,
      _ref$clean = _ref.clean,
      clean = _ref$clean === void 0 ? false : _ref$clean,
      _ref$phone = _ref.phone,
      phone = _ref$phone === void 0 ? null : _ref$phone,
      _ref$org = _ref.org,
      org = _ref$org === void 0 ? null : _ref$org,
      _ref$ban = _ref.ban,
      ban = _ref$ban === void 0 ? null : _ref$ban,
      _ref$nin = _ref.nin,
      nin = _ref$nin === void 0 ? null : _ref$nin,
      _ref$currency = _ref.currency,
      currency = _ref$currency === void 0 ? null : _ref$currency,
      _ref$currency_display = _ref.currency_display,
      currency_display = _ref$currency_display === void 0 ? _defaults.CURRENCY_DISPLAY : _ref$currency_display,
      _ref$currency_positio = _ref.currency_position,
      currency_position = _ref$currency_positio === void 0 ? null : _ref$currency_positio,
      _ref$decimals = _ref.decimals,
      decimals = _ref$decimals === void 0 ? null : _ref$decimals,
      _ref$omit_rounding = _ref.omit_rounding,
      omit_rounding = _ref$omit_rounding === void 0 ? null : _ref$omit_rounding,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? null : _ref$options,
      _ref$returnAria = _ref.returnAria,
      returnAria = _ref$returnAria === void 0 ? false : _ref$returnAria;

  var display = value;
  var aria = null;
  var type = 'number';
  var isCurrency = (0, _componentHelper.isTrue)(currency) || typeof currency === 'string';

  if (!locale) {
    locale = _defaults.LOCALE;
  } else if (locale === 'auto') {
    try {
      locale = window.navigator.language;
    } catch (e) {
      (0, _componentHelper.warn)(e);
    }
  }

  var opts = (typeof options === 'string' && options[0] === '{' ? JSON.parse(options) : options) || {};
  var deci = parseFloat(decimals);

  if (isCurrency && isNaN(deci)) {
    deci = 2;
  }

  if (deci >= 0) {
    var isNumber = typeof value === 'number';
    opts.minimumFractionDigits = deci;
    opts.maximumFractionDigits = deci;
    value = String(clean ? cleanNumber(value) : value);
    var pos = value.indexOf('.');

    if (pos > 0 && omit_rounding === true) {
      value = String(value).substr(0, pos + 1 + deci);
    }

    if (isNumber) {
      value = parseFloat(value);
    }
  } else {
    opts.maximumFractionDigits = 20;
  }

  if ((0, _componentHelper.isTrue)(phone)) {
    type = 'phone';

    var _formatPhone = formatPhone(value, locale),
        _number = _formatPhone.number,
        _aria = _formatPhone.aria;

    value = cleanNumber(value);
    display = _number;
    aria = _aria;
  } else if ((0, _componentHelper.isTrue)(ban)) {
    type = 'ban';

    var _formatBAN = formatBAN(value, locale),
        _number2 = _formatBAN.number,
        _aria2 = _formatBAN.aria;

    display = _number2;
    aria = _aria2;
  } else if ((0, _componentHelper.isTrue)(nin)) {
    type = 'nin';

    var _formatNIN = formatNIN(value, locale),
        _number3 = _formatNIN.number,
        _aria3 = _formatNIN.aria;

    display = _number3;
    aria = _aria3;
  } else if ((0, _componentHelper.isTrue)(org)) {
    type = 'org';

    var _formatORG = formatORG(value, locale),
        _number4 = _formatORG.number,
        _aria4 = _formatORG.aria;

    display = _number4;
    aria = _aria4;
  } else if (isCurrency) {
    type = 'currency';
    var cleanedNumber = deci >= 0 ? value : clean ? cleanNumber(value) : value;
    opts.currency = opts.currency || ((0, _componentHelper.isTrue)(currency) ? _defaults.CURRENCY : currency);
    opts.style = 'currency';
    opts.currencyDisplay = opts.currencyDisplay || currency_display || _defaults.CURRENCY_DISPLAY;

    if (typeof opts.minimumFractionDigits === 'undefined' && String(value).indexOf('.') === -1 && cleanedNumber % 1 === 0) {
      opts.minimumFractionDigits = 0;
    }

    display = formatNumber(cleanedNumber, locale, opts);
    display = cleanupMinus(display);
    display = prepareCurrencyPosition(display, currency_position, locale);
    aria = formatNumber(cleanedNumber, locale, _extends({
      minimumFractionDigits: 0,
      maximumFractionDigits: 2
    }, opts, {
      currencyDisplay: 'name'
    }));
    aria = enhanceSR(cleanedNumber, aria, locale);

    if (_helpers.IS_IE11) {
      display = display.replace(/^\((.*)\)$/, '-$1');
      aria = aria.replace(/^\((.*)\)$/, '-$1');
      display = cleanupMinus(display);
      aria = cleanupMinus(aria);
    }
  } else {
    display = formatNumber(value, locale, opts);
    display = cleanupMinus(display);
    aria = formatNumber(value, locale, _extends({}, opts, {
      minimumFractionDigits: 1,
      maximumFractionDigits: 20
    }));
    aria = enhanceSR(value, aria, locale);
  }

  if (aria === null) {
    aria = display;
  }

  var cleanedValue = formatNumber(value, locale, opts, function (_ref2) {
    var type = _ref2.type,
        value = _ref2.value;

    switch (type) {
      case 'currency':
      case 'group':
      case 'literal':
        return '';

      default:
        return value;
    }
  });
  return returnAria ? {
    value: value,
    cleanedValue: cleanedValue,
    number: display,
    aria: aria,
    locale: locale,
    type: type
  } : display;
};

exports.format = format;

var prepareCurrencyPosition = function prepareCurrencyPosition(display) {
  var position = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var locale = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (!position && locale && /no$/i.test(locale)) {
    position = 'after';
  }

  if (position) {
    var sign = String(display).replace(new RegExp("([".concat(NUMBER_CHARS, "])"), 'g'), '').trim();
    var signPos = String(display).indexOf(sign);
    var start = 0;
    var end = 0;

    if (signPos === 0) {
      start = sign.length;
      end = display.length;
    } else {
        end = signPos;
      }

    if (!(end > 0)) {
      return display;
    }

    var num = String(display).substr(start, end).trim();

    switch (position) {
      case 'before':
        display = "".concat(sign, " ").concat(num);
        break;

      case 'after':
        display = "".concat(num, " ").concat(sign);
        break;
    }
  }

  return display;
};

var cleanupMinus = function cleanupMinus(display) {
  var reg = '^(-|−|‐|‒|–|—|―)';
  var first = display[0];
  var second = display[1];

  if (new RegExp(reg).test(first)) {
    if (parseFloat(second) > 0) {
      display = display.replace(new RegExp(reg + '(.*)'), '-$2');
    } else {
      display = display.replace(new RegExp(reg + '([^0-9]+)(.*)'), '$2-$3');
    }
  }

  return display;
};

var enhanceSR = function enhanceSR(value, aria) {
  if (_helpers.IS_MAC && Math.abs(parseFloat(value)) <= 99999) {
    aria = String(aria).replace(/\s([0-9])/g, '$1');
  }

  aria = cleanupMinus(aria);
  return aria;
};

var formatNumber = function formatNumber(number, locale) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var formatter = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

  try {
    if (typeof Intl !== 'undefined' && typeof Intl.NumberFormat === 'function') {
      var inst = Intl.NumberFormat(locale, options);

      if (formatter) {
        return inst.formatToParts(number).map(function (val) {
          return formatter(val);
        }).reduce(function (str, part) {
          return str + part;
        });
      } else {
        return inst.format(number);
      }
    } else if (typeof Number !== 'undefined' && typeof Number.toLocaleString === 'function') {
      return parseFloat(number).toLocaleString(locale, options);
    }
  } catch (e) {
    (0, _componentHelper.warn)("Number could not be formatted: ".concat(JSON.stringify([number, locale, options])), e);
  }

  return number;
};

exports.formatNumber = formatNumber;

var formatPhone = function formatPhone(number) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var display = number;
  var aria = null;

  switch (locale) {
    default:
      {
        number = String(number).replace(/[^+0-9]/g, '');
        var code = '';

        if (number.length > 8 && number.substr(0, 2) !== '00') {
          number = '+' + number;
          number = number.replace(/^\+{2,}/, '+');
        }

        if (number[0] === '+') {
          code = number.substr(0, 3) + ' ';
          number = number.substr(3);
        } else if (number.substr(0, 2) === '00') {
          code = number.substr(0, 4) + ' ';
          number = number.substr(4);
        }

        code = code.replace('+', '00');
        var length = number.length;

        if (length === 8 && number[0] === '8') {
          display = code + number.split(/([0-9]{3})([0-9]{2})/).filter(function (s) {
            return s;
          }).join(' ');
        } else {
          if (length < 6) {
            display = code + number;
          } else {
            display = code + number.split(length === 6 ? /^(\+[0-9]{2})|([0-9]{3})/ : /^(\+[0-9]{2})|([0-9]{2})/).filter(function (s) {
              return s;
            }).join(' ');
          }
        }

        aria = code + number.split(/([0-9]{2})/).filter(function (s) {
          return s;
        }).join(' ');
      }
  }

  if (aria === null) {
    aria = display;
  }

  return {
    number: display,
    aria: aria
  };
};

exports.formatPhone = formatPhone;

var formatBAN = function formatBAN(number) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  number = String(number).replace(/[^0-9]/g, '');
  var display = number;
  var aria = null;

  switch (locale) {
    default:
      {
        display = number.split(/([0-9]{4})([0-9]{2})([0-9]{1,})/).filter(function (s) {
          return s;
        }).join(' ');
        aria = number.split(/([0-9]{2})/).filter(function (s) {
          return s;
        }).join(' ');
      }
  }

  if (aria === null) {
    aria = display;
  }

  return {
    number: display,
    aria: aria
  };
};

exports.formatBAN = formatBAN;

var formatORG = function formatORG(number) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  number = String(number).replace(/[^0-9]/g, '');
  var display = number;
  var aria = null;

  switch (locale) {
    default:
      {
        display = number.split(/([0-9]{3})/).filter(function (s) {
          return s;
        }).join(' ');
        aria = number.split(/([0-9]{1})/).filter(function (s) {
          return s;
        }).join(' ');
      }
  }

  if (aria === null) {
    aria = display;
  }

  return {
    number: display,
    aria: aria
  };
};

exports.formatORG = formatORG;

var formatNIN = function formatNIN(number) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  number = String(number).replace(/[^0-9]/g, '');
  var display = number;
  var aria = null;

  switch (locale) {
    default:
      {
        display = number.split(/([0-9]{6})/).filter(function (s) {
          return s;
        }).join(' ');
        aria = display.split(/([0-9]{2})([0-9]{2})([0-9]{2}) ([0-9]{1})([0-9]{1})([0-9]{1})([0-9]{1})([0-9]{1})/).filter(function (s) {
          return s;
        }).join(_helpers.IS_WIN ? '. ' : ' ');
      }
  }

  if (aria === null) {
    aria = display;
  }

  return {
    number: display,
    aria: aria
  };
};

exports.formatNIN = formatNIN;

function cleanNumber(num) {
  if (typeof num === 'number') {
    return num;
  }

  num = String(num).trim();

  if (/^[^0-9-]/.test(num)) {
    num.replace(/^(^[^0-9-]+)/, '');
  }

  var usesThousand = ',';
  var usesDecimal = '\\.';

  if (/(\s)([0-9]{3})/.test(num)) {
    usesThousand = '\\s';
    usesDecimal = ',';
  } else if (/(\.)([0-9]{3})/.test(num) && !/([,'][0-9]{3})(\.)([0-9]{3})/.test(num)) {
        usesThousand = '\\.';
        usesDecimal = ",|·|'";
      } else if (/(,)([0-9]{3})/.test(num)) {
        usesThousand = ',';
        usesDecimal = '\\.|·';
      } else if (/(')([0-9]{3})/.test(num)) {
          usesThousand = "'";
          usesDecimal = '\\.|,';
        }

  var thousandReg = new RegExp("([0-9]|)(".concat(usesThousand, ")([0-9]{3})"), 'g');

  if (thousandReg.test(num)) {
    num = num.replace(thousandReg, '$1$3');
  }

  var decimalReg = new RegExp("(".concat(usesDecimal, ")([0-9]{1,2})"), 'g');

  if (decimalReg.test(num)) {
    num = num.replace(decimalReg, '.$2');
  }

  var decimalBackup = new RegExp("(".concat(usesDecimal, ")([0-9]{3,})"), 'g');

  if (decimalBackup.test(num)) {
    num = num.replace(decimalBackup, '.$2');
  }

  return num.replace(new RegExp("([^".concat(NUMBER_CHARS, "])"), 'g'), '');
}

var hasiOSFix = false;

function runIOSSelectionFix() {
  try {
    var selection = window.getSelection();
    var range = document.createRange();
    selection.removeAllRanges();
    selection.addRange(range);
  } catch (e) {}
}

function copyWithEffect(_x) {
  return _copyWithEffect.apply(this, arguments);
}

function _copyWithEffect() {
  _copyWithEffect = _asyncToGenerator(regeneratorRuntime.mark(function _callee(string) {
    var success, fx;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            success = null;

            if (!string) {
              _context.next = 14;
              break;
            }

            _context.prev = 2;
            fx = createSelectionFX(string);
            _context.next = 6;
            return (0, _helpers.copyToClipboard)(string);

          case 6:
            success = _context.sent;

            if (success === true) {
              fx.run();
            }

            _context.next = 14;
            break;

          case 10:
            _context.prev = 10;
            _context.t0 = _context["catch"](2);
            (0, _componentHelper.warn)(_context.t0);
            success = _context.t0;

          case 14:
            return _context.abrupt("return", success);

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[2, 10]]);
  }));
  return _copyWithEffect.apply(this, arguments);
}

function createSelectionFX(string) {
  var height = 32;
  var left = 0;
  var top = 0;
  var elem;

  try {
    var _cR$, _cR$2, _cR$3;

    var cR = window.getSelection().getRangeAt(0).getClientRects();
    height = (_cR$ = cR[0]) === null || _cR$ === void 0 ? void 0 : _cR$.height;
    left = (_cR$2 = cR[0]) === null || _cR$2 === void 0 ? void 0 : _cR$2.left;
    top = (_cR$3 = cR[0]) === null || _cR$3 === void 0 ? void 0 : _cR$3.top;
  } catch (e) {}

  try {
    if (!(top > 0) && !(left > 0)) {
      var posElem = document.createElement('span');
      posElem.setAttribute('class', 'dnb-number__fx__selection');
      (0, _helpers.insertElementBeforeSelection)(posElem);

      var _posElem$getBoundingC = posElem.getBoundingClientRect();

      top = _posElem$getBoundingC.top;
      left = _posElem$getBoundingC.left;
      top -= height / 1.333;
      posElem.parentElement.removeChild(posElem);
    }

    elem = document.createElement('span');
    elem.textContent = String(string);
    elem.setAttribute('class', 'dnb-number__fx dnb-core-style');
    elem.style.top = "".concat(top, "px");
    elem.style.left = "".concat(left + (0, _helpers.getSelectedText)().length / 2, "px");
  } catch (e) {
    (0, _componentHelper.warn)(e);
  }

  return new (function () {
    function SelectionFx() {
      _classCallCheck(this, SelectionFx);
    }

    _createClass(SelectionFx, [{
      key: "remove",
      value: function remove() {
        try {
          document.body.removeChild(elem);
        } catch (e) {}
      }
    }, {
      key: "run",
      value: function run() {
        try {
          document.body.appendChild(elem);
          setTimeout(this.remove, 800);
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }
    }]);

    return SelectionFx;
  }())();
}