"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.find.js");

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPagination = exports.InfinityMarker = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PaginationContext = _interopRequireDefault(require("./PaginationContext"));

var _PaginationProvider = _interopRequireDefault(require("./PaginationProvider"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _PaginationHelpers = require("./PaginationHelpers");

var _PaginationInfinity = _interopRequireDefault(require("./PaginationInfinity"));

var _PaginationBar = _interopRequireDefault(require("./PaginationBar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var paginationPropTypes = process.env.NODE_ENV !== "production" ? _extends({
  startup_page: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  current_page: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  page_count: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  startup_count: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  parallel_load_count: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  place_maker_before_content: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  min_wait_time: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  mode: _propTypes.default.oneOf(['pagination', 'infinity']),
  use_load_button: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  items: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array]),
  hide_progress_indicator: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  set_content_handler: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  reset_content_handler: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  reset_pagination_handler: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  end_infinity_handler: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  page_element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func, _propTypes.default.string]),
  fallback_element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func, _propTypes.default.string]),
  marker_element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func, _propTypes.default.string]),
  indicator_element: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func, _propTypes.default.string]),
  align: _propTypes.default.string,
  button_title: _propTypes.default.string,
  prev_title: _propTypes.default.string,
  next_title: _propTypes.default.string,
  more_pages: _propTypes.default.string,
  is_loading_text: _propTypes.default.string,
  load_button_text: _propTypes.default.string
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  on_change: _propTypes.default.func,
  on_startup: _propTypes.default.func,
  on_load: _propTypes.default.func,
  on_end: _propTypes.default.func
}) : {};
var paginationDefaultProps = {
  startup_page: null,
  current_page: null,
  page_count: null,
  mode: 'pagination',
  use_load_button: false,
  items: null,
  hide_progress_indicator: false,
  set_content_handler: null,
  reset_content_handler: null,
  page_element: undefined,
  fallback_element: undefined,
  marker_element: undefined,
  indicator_element: undefined,
  align: 'left',
  button_title: null,
  prev_title: null,
  next_title: null,
  more_pages: null,
  is_loading_text: null,
  load_button_text: null,
  startup_count: 1,
  parallel_load_count: 1,
  place_maker_before_content: false,
  min_wait_time: 400,
  class: null,
  className: null,
  children: null,
  on_change: null,
  on_startup: null,
  on_load: null,
  on_end: null
};

var Pagination = function (_React$PureComponent) {
  _inherits(Pagination, _React$PureComponent);

  var _super = _createSuper(Pagination);

  function Pagination() {
    _classCallCheck(this, Pagination);

    return _super.apply(this, arguments);
  }

  _createClass(Pagination, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_PaginationProvider.default, _extends({
        tagName: Pagination.tagName
      }, this.props), _react.default.createElement(PaginationInstance, this.props));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Pagination.tagName, Pagination, paginationDefaultProps);
    }
  }]);

  return Pagination;
}(_react.default.PureComponent);

exports.default = Pagination;
Pagination.tagName = 'dnb-pagination';
Pagination.defaultProps = paginationDefaultProps;
process.env.NODE_ENV !== "production" ? Pagination.propTypes = _extends({}, paginationPropTypes) : void 0;

var _ref2 = _react.default.createElement(_PaginationInfinity.default, null);

var PaginationInstance = function (_React$PureComponent2) {
  _inherits(PaginationInstance, _React$PureComponent2);

  var _super2 = _createSuper(PaginationInstance);

  function PaginationInstance(props) {
    var _this;

    _classCallCheck(this, PaginationInstance);

    _this = _super2.call(this, props);
    _this._contentRef = _react.default.createRef();
    return _this;
  }

  _createClass(PaginationInstance, [{
    key: "render",
    value: function render() {
      var props = (0, _componentHelper.extendPropsWithContext)(this.props, paginationDefaultProps, this.context.getTranslation(this.props).Pagination, this.context.FormRow, this.context.Pagination);

      var align = props.align,
          children = props.children,
          className = props.className,
          _className = props.class,
          _tagName = props.tagName,
          _page_count = props.page_count,
          _current_page = props.current_page,
          _startup_page = props.startup_page,
          _mode = props.mode,
          _hide_progress_indicator = props.hide_progress_indicator,
          _use_load_button = props.use_load_button,
          attributes = _objectWithoutProperties(props, ["align", "children", "className", "class", "tagName", "page_count", "current_page", "startup_page", "mode", "hide_progress_indicator", "use_load_button"]);

      var _this$context$paginat = this.context.pagination,
          currentPage = _this$context$paginat.currentPage,
          items = _this$context$paginat.items,
          fallback_element = _this$context$paginat.fallback_element,
          indicator_element = _this$context$paginat.indicator_element;

      if (this.context.pagination.mode === 'pagination') {
        var _items$find;

        var mainParams = _extends({
          className: (0, _classnames.default)('dnb-pagination', (0, _SpacingHelper.createSpacingClasses)(props), className, _className, align && "dnb-pagination--".concat(align))
        }, attributes);

        (0, _componentHelper.validateDOMAttributes)(props, mainParams);
        var content = (_items$find = items.find(function (_ref) {
          var pageNo = _ref.pageNo;
          return pageNo === currentPage;
        })) === null || _items$find === void 0 ? void 0 : _items$find.content;
        return _react.default.createElement(_react.default.Fragment, null, this.context.pagination.mode === 'infinity' && typeof children !== 'function' && children, _react.default.createElement("div", mainParams, _react.default.createElement(_PaginationBar.default, {
          contentRef: this._contentRef
        }, children), items.length > 0 && _react.default.createElement(PaginationContent, {
          ref: this._contentRef
        }, content || _react.default.createElement(_PaginationHelpers.PaginationIndicator, {
          indicator_element: indicator_element || fallback_element
        }))));
      }

      return _ref2;
    }
  }]);

  return PaginationInstance;
}(_react.default.PureComponent);

PaginationInstance.defaultProps = paginationDefaultProps;
PaginationInstance.contextType = _PaginationContext.default;
process.env.NODE_ENV !== "production" ? PaginationInstance.propTypes = _extends({}, paginationPropTypes) : void 0;

var InfinityMarker = function (_React$PureComponent3) {
  _inherits(InfinityMarker, _React$PureComponent3);

  var _super3 = _createSuper(InfinityMarker);

  function InfinityMarker() {
    _classCallCheck(this, InfinityMarker);

    return _super3.apply(this, arguments);
  }

  _createClass(InfinityMarker, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          props = _objectWithoutProperties(_this$props, ["children"]);

      return _react.default.createElement(_PaginationProvider.default, _extends({
        useMarkerOnly: true,
        tagName: InfinityMarker.tagName
      }, props), _react.default.createElement(_PaginationInfinity.default, props, children));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(InfinityMarker.tagName, InfinityMarker, paginationDefaultProps);
    }
  }]);

  return InfinityMarker;
}(_react.default.PureComponent);

exports.InfinityMarker = InfinityMarker;
InfinityMarker.tagName = 'dnb-infinity-marker';
InfinityMarker.defaultProps = paginationDefaultProps;
process.env.NODE_ENV !== "production" ? InfinityMarker.propTypes = _extends({}, paginationPropTypes) : void 0;

var PaginationContent = _react.default.forwardRef(function (_ref3, ref) {
  var children = _ref3.children,
      props = _objectWithoutProperties(_ref3, ["children"]);

  return _react.default.createElement("div", _extends({
    className: "dnb-pagination__content dnb-no-focus",
    tabIndex: "-1"
  }, props, {
    ref: ref
  }), children);
});

process.env.NODE_ENV !== "production" ? PaginationContent.propTypes = {
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]).isRequired
} : void 0;
Pagination.Bar = _PaginationBar.default;
Pagination.Content = PaginationContent;
var PaginationWrapper = Pagination;
var InfinityMarkerWrapper = InfinityMarker;

var createPagination = function createPagination() {
  var initProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var store = _react.default.createRef({});

  var rerender = _react.default.createRef(null);

  var _setContent = _react.default.createRef(null);

  var _resetContent = _react.default.createRef(null);

  var _resetInfinity = _react.default.createRef(null);

  var _endInfinity = _react.default.createRef(null);

  var setContent = function setContent(pageNo, content) {
    if (pageNo > 0) {
      store.current = _extends({}, store.current, {
        pageNo: pageNo,
        content: content
      });
      rerender.current && rerender.current(store);
    }
  };

  var resetContent = function resetContent() {
    _resetContent.current && _resetContent.current();
  };

  var resetInfinity = function resetInfinity() {
    _resetInfinity.current && _resetInfinity.current();
  };

  var endInfinity = function endInfinity() {
    _endInfinity.current && _endInfinity.current();
  };

  var args = function args(props) {
    return _extends({}, _extends({}, initProps, props), {
      store: store,
      rerender: rerender,
      set_content_handler: function set_content_handler(fn) {
        return _setContent.current = fn;
      },
      reset_content_handler: function reset_content_handler(fn) {
        return _resetContent.current = fn;
      },
      reset_pagination_handler: function reset_pagination_handler(fn) {
        return _resetInfinity.current = fn;
      },
      end_infinity_handler: function end_infinity_handler(fn) {
        return _endInfinity.current = fn;
      }
    });
  };

  var Pagination = function Pagination(props) {
    return _react.default.createElement(PaginationWrapper, _extends({
      tagName: PaginationWrapper.tagName
    }, args(props)));
  };

  var InfinityMarker = function InfinityMarker(props) {
    return _react.default.createElement(InfinityMarkerWrapper, _extends({
      tagName: InfinityMarkerWrapper.tagName
    }, args(props)));
  };

  return {
    Pagination: Pagination,
    InfinityMarker: InfinityMarker,
    setContent: setContent,
    resetContent: resetContent,
    resetInfinity: resetInfinity,
    endInfinity: endInfinity
  };
};

exports.createPagination = createPagination;