"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _componentHelper = require("../../shared/component-helper");

var _PaginationCalculation = require("./PaginationCalculation");

var _PaginationContext = _interopRequireDefault(require("./PaginationContext"));

var _Button = _interopRequireDefault(require("../button/Button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref3 = _react.default.createElement("div", {
  key: "dot-1"
});

var _ref4 = _react.default.createElement("div", {
  key: "dot-2"
});

var _ref5 = _react.default.createElement("div", {
  key: "dot-3"
});

var PaginationBar = function (_React$PureComponent) {
  _inherits(PaginationBar, _React$PureComponent);

  var _super = _createSuper(PaginationBar);

  function PaginationBar() {
    var _this;

    _classCallCheck(this, PaginationBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.setPage = function (currentPage) {
      var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.keepPageHeight();

      _this.focusPage();

      _this.context.pagination.setState({
        currentPage: currentPage
      });

      _this.preparePageContent(currentPage);

      (0, _componentHelper.dispatchCustomElementEvent)(_this.context.pagination, 'on_change', _extends({
        page: currentPage,
        pageNo: currentPage
      }, _this.context.pagination, {
        event: event
      }));
    };

    _this.setPrevPage = function () {
      _this.setPage(_this.context.pagination.currentPage - 1);
    };

    _this.setNextPage = function () {
      _this.setPage(_this.context.pagination.currentPage + 1);
    };

    _this.clickHandler = function (_ref) {
      var pageNo = _ref.pageNo,
          event = _ref.event;

      _this.setPage(pageNo, event);
    };

    return _this;
  }

  _createClass(PaginationBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var pgn = this.context.pagination;
      var currentPage = pgn.startupPage || pgn.currentPage;
      pgn.setState({
        currentPage: currentPage
      }, function () {
        return _this2.preparePageContent(currentPage);
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(_ref2) {
      var children = _ref2.children;

      if (this.props.children !== children) {
        this.updatePageContent();
      }
    }
  }, {
    key: "hasChildrenCallabck",
    value: function hasChildrenCallabck() {
      return typeof this.props.children === 'function';
    }
  }, {
    key: "preparePageContent",
    value: function preparePageContent(pageNo) {
      var potentialElement = this.props.children;
      var items = this.context.pagination.prefillItems(this.context.pagination.currentPage, {
        skipObserver: true
      });
      this.context.pagination.setState({
        items: items
      });

      if (this.hasChildrenCallabck()) {
        potentialElement = this.props.children(_extends({
          pageNo: pageNo,
          page: pageNo
        }, this.context.pagination));
      }

      if (potentialElement && _react.default.isValidElement(potentialElement)) {
        this.context.pagination.setContent([pageNo, potentialElement]);
      }
    }
  }, {
    key: "updatePageContent",
    value: function updatePageContent() {
      var pageNo = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.context.pagination.currentPage;
      var potentialElement = this.props.children;

      if (this.hasChildrenCallabck()) {
        potentialElement = this.props.children(_extends({
          pageNo: pageNo,
          page: pageNo
        }, this.context.pagination));
      }

      if (potentialElement && _react.default.isValidElement(potentialElement)) {
        this.context.pagination.setContent([pageNo, potentialElement]);
      }
    }
  }, {
    key: "focusPage",
    value: function focusPage() {
      var _this3 = this;

      this.context.pagination.onPageUpdate(function () {
        try {
          var elem = _this3.props.contentRef.current;
          elem.focus();
        } catch (e) {}
      });
    }
  }, {
    key: "keepPageHeight",
    value: function keepPageHeight() {
      var _this4 = this;

      try {
        var elem = this.props.contentRef.current;
        var pageHeight = elem.offsetHeight;
        elem.style.height = "".concat(pageHeight / 16, "rem");
        elem.style.minHeight = elem.style.height;
      } catch (e) {}

      this.context.pagination.onPageUpdate(function () {
        try {
          var _elem = _this4.props.contentRef.current;
          _elem.style.height = 'auto';
          _elem.style.minHeight = _elem.style.height;
        } catch (e) {}
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, PaginationBar.defaultProps, this.context.getTranslation(this.props).Pagination);
      var button_title = props.button_title,
          prev_title = props.prev_title,
          next_title = props.next_title,
          more_pages = props.more_pages;
      var _this$context$paginat = this.context.pagination,
          pageCount = _this$context$paginat.pageCount,
          currentPage = _this$context$paginat.currentPage;
      var prevIsDisabled = currentPage === 1;
      var nextIsDisabled = currentPage === pageCount || pageCount === 0;
      var pages = (0, _PaginationCalculation.calculatePagination)(pageCount, currentPage);
      return _react.default.createElement("div", {
        className: 'dnb-pagination__bar' + (pageCount >= 8 ? " dnb-pagination--many-pages" : "")
      }, _react.default.createElement(_Button.default, {
        key: "left-arrow",
        className: "dnb-pagination__button",
        disabled: prevIsDisabled,
        size: "small",
        icon: "chevron_left",
        on_click: this.setPrevPage,
        title: prevIsDisabled ? null : prev_title
      }), _react.default.createElement("div", {
        className: "dnb-pagination__bar__inner"
      }, pages[0].map(function (pageNo) {
        return _react.default.createElement(_Button.default, {
          key: pageNo,
          className: "dnb-pagination__button",
          size: "medium",
          text: String(pageNo),
          "aria-label": button_title.replace('%s', pageNo),
          variant: pageNo === currentPage ? 'primary' : 'secondary',
          "aria-current": pageNo === currentPage ? 'page' : null,
          on_click: function on_click(event) {
            return _this5.clickHandler({
              pageNo: pageNo,
              event: event
            });
          }
        });
      }), pages.slice(1).map(function (list, idx) {
        return _react.default.createElement(_react.default.Fragment, {
          key: idx
        }, _react.default.createElement("div", {
          key: "dots-".concat(idx),
          className: "dnb-pagination__dots",
          "aria-label": (0, _PaginationCalculation.getDotsAriaLabel)({
            more_pages: more_pages,
            list: list,
            pages: pages
          })
        }, _ref3, _ref4, _ref5), list.map(function (pageNo) {
          return _react.default.createElement(_Button.default, {
            key: pageNo,
            className: "dnb-pagination__button",
            size: "medium",
            text: String(pageNo),
            "aria-label": button_title.replace('%s', pageNo),
            variant: pageNo === currentPage ? 'primary' : 'secondary',
            "aria-current": pageNo === currentPage ? 'page' : null,
            on_click: function on_click(event) {
              return _this5.clickHandler({
                pageNo: pageNo,
                event: event
              });
            }
          });
        }));
      })), _react.default.createElement(_Button.default, {
        key: "right-arrow",
        className: "dnb-pagination__button",
        disabled: nextIsDisabled,
        size: "small",
        icon: "chevron_right",
        on_click: this.setNextPage,
        title: nextIsDisabled ? null : next_title
      }));
    }
  }]);

  return PaginationBar;
}(_react.default.PureComponent);

exports.default = PaginationBar;
PaginationBar.contextType = _PaginationContext.default;
PaginationBar.defaultProps = {
  button_title: null,
  prev_title: null,
  next_title: null,
  more_pages: null,
  contentRef: null,
  children: null
};
process.env.NODE_ENV !== "production" ? PaginationBar.propTypes = {
  button_title: _propTypes.default.string,
  prev_title: _propTypes.default.string,
  next_title: _propTypes.default.string,
  more_pages: _propTypes.default.string,
  contentRef: _propTypes.default.object,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
} : void 0;