"use strict";

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getDotsAriaLabel = exports.calculatePagination = void 0;

var calculatePagination = function calculatePagination(page_count, current_page) {
  if (page_count === 1) return [[1]];
  var start = Math.max.apply(Math, [1, current_page + 2 > page_count ? current_page - 4 + (Math.min.apply(Math, [page_count, current_page - 2 < 1 ? current_page + 4 - (current_page - 1) : current_page + 2]) - current_page) : current_page - 2]);
  var end = Math.min.apply(Math, [page_count, current_page - 2 < 1 ? current_page + 4 - (current_page - start) : current_page + 2]);
  var middle = [];

  for (var i = start; i <= end; i++) {
    middle.push(i);
  }

  var pages = [];

  if (start > 2) {
    pages.push([1]);
  } else if (start === 2) {
    middle = [1].concat(middle);
  }

  pages.push(middle);

  if (end <= page_count - 2) {
    pages.push([page_count]);
  } else if (end === page_count - 1) {
    middle.push(page_count);
  }

  return pages;
};

exports.calculatePagination = calculatePagination;

var getDotsAriaLabel = function getDotsAriaLabel(_ref) {
  var more_pages = _ref.more_pages,
      list = _ref.list,
      pages = _ref.pages;
  var count = 0;

  try {
    if (list.length === 1) {
      count = list[0] - (pages.length === 2 ? pages[0][pages[0].length - 1] : pages[1][pages[1].length - 1]);
    } else if (list.length > 1) {
      count = list[0] - pages[0] - 1;
    }
  } catch (e) {}

  return count > 0 ? more_pages.replace('%s', count) : null;
};

exports.getDotsAriaLabel = getDotsAriaLabel;
var _default = {
  calculatePagination: calculatePagination
};
exports.default = _default;