"use strict";

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isTrElement = isTrElement;
exports.preparePageElement = preparePageElement;
exports.ContentObject = exports.PaginationIndicator = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _ProgressIndicator = _interopRequireDefault(require("../progress-indicator/ProgressIndicator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref = _react.default.createElement(_ProgressIndicator.default, null);

var PaginationIndicator = function (_React$PureComponent) {
  _inherits(PaginationIndicator, _React$PureComponent);

  var _super = _createSuper(PaginationIndicator);

  function PaginationIndicator() {
    _classCallCheck(this, PaginationIndicator);

    return _super.apply(this, arguments);
  }

  _createClass(PaginationIndicator, [{
    key: "render",
    value: function render() {
      var indicator_element = this.props.indicator_element;
      var Element = preparePageElement(indicator_element);
      var ElementChild = isTrElement(Element) ? 'td' : 'div';
      return _react.default.createElement(Element, null, _react.default.createElement(ElementChild, {
        className: "dnb-pagination__indicator"
      }, _react.default.createElement("div", {
        className: "dnb-pagination__indicator__inner"
      }, _ref, this.context.getTranslation(this.props).Pagination.is_loading_text)));
    }
  }]);

  return PaginationIndicator;
}(_react.default.PureComponent);

exports.PaginationIndicator = PaginationIndicator;
PaginationIndicator.contextType = _Context.default;
PaginationIndicator.defaultProps = {
  indicator_element: 'div'
};
process.env.NODE_ENV !== "production" ? PaginationIndicator.propTypes = {
  indicator_element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func, _propTypes.default.string])
} : void 0;

var ContentObject = function () {
  function ContentObject(_ref2) {
    var pageNo = _ref2.pageNo,
        props = _objectWithoutProperties(_ref2, ["pageNo"]);

    _classCallCheck(this, ContentObject);

    this.content = null;
    this.pageNo = pageNo;
    this.hasContent = false;

    for (var k in props) {
      this[k] = props[k];
    }
  }

  _createClass(ContentObject, [{
    key: "insert",
    value: function insert(content) {
      this.hasContent = true;
      this.content = content;

      if (typeof this.onInsert === 'function') {
        this.onInsert(this);
      }

      return this;
    }
  }, {
    key: "update",
    value: function update(content) {
      this.hasContent = true;
      this.content = content;

      if (typeof this.onUpdate === 'function') {
        this.onUpdate(this);
      }

      return this;
    }
  }]);

  return ContentObject;
}();

exports.ContentObject = ContentObject;

function isTrElement(Element) {
  var isTr = false;

  if (Element === 'tr') {
    isTr = true;
  } else if (Element && (_typeof(Element) === 'object' || _react.default.isValidElement(Element))) {
    if ((Element.__emotion_base || Element.target) === 'tr') {
      isTr = true;
    }
  }

  return isTr;
}

function preparePageElement(Element) {
  var includeClassName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'dnb-pagination__page';

  if (String(Element) === 'Symbol(react.fragment)') {
    return Element;
  }

  if (includeClassName) {
    var isTr = isTrElement(Element);
    return _react.default.forwardRef(function (_ref3, ref) {
      var className = _ref3.className,
          children = _ref3.children,
          props = _objectWithoutProperties(_ref3, ["className", "children"]);

      var params = _extends({}, props, {
        className: (0, _classnames.default)(includeClassName, className),
        ref: ref
      });

      return isTr ? _react.default.createElement("td", null, _react.default.createElement("div", params, children)) : _react.default.createElement(Element, params, children);
    });
  }

  return Element;
}