import * as React from 'react';
export type ProgressIndicatorVisible = string | boolean;
export type ProgressIndicatorType = 'circular';
export type ProgressIndicatorNoAnimation = string | boolean;
export type ProgressIndicatorSize =
  | 'default'
  | 'small'
  | 'medium'
  | 'large'
  | 'huge';
export type ProgressIndicatorProgress = string | number;
export type ProgressIndicatorShowLabel = string | boolean;
export type ProgressIndicatorSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type ProgressIndicatorTop = string | number | boolean;
export type ProgressIndicatorRight = string | number | boolean;
export type ProgressIndicatorBottom = string | number | boolean;
export type ProgressIndicatorLeft = string | number | boolean;
export type ProgressIndicatorChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ProgressIndicatorProps
  extends React.HTMLProps<HTMLElement> {
  visible?: ProgressIndicatorVisible;
  type?: ProgressIndicatorType;
  no_animation?: ProgressIndicatorNoAnimation;
  size?: ProgressIndicatorSize;
  progress?: ProgressIndicatorProgress;
  label?: React.ReactNode;
  label_direction?: string;
  show_label?: ProgressIndicatorShowLabel;
  indicator_label?: string;
  section_style?: string;
  section_spacing?: string;
  space?: ProgressIndicatorSpace;
  top?: ProgressIndicatorTop;
  right?: ProgressIndicatorRight;
  bottom?: ProgressIndicatorBottom;
  left?: ProgressIndicatorLeft;
  class?: string;
  className?: string;
  children?: ProgressIndicatorChildren;
  on_complete?: (...args: any[]) => any;
}
export default class ProgressIndicator extends React.Component<
  ProgressIndicatorProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
