"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _ProgressIndicatorCircular = _interopRequireDefault(require("./ProgressIndicatorCircular"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var ProgressIndicator = function (_React$PureComponent) {
  _inherits(ProgressIndicator, _React$PureComponent);

  var _super = _createSuper(ProgressIndicator);

  function ProgressIndicator() {
    var _this;

    _classCallCheck(this, ProgressIndicator);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      _listenForPropChanges: true
    };

    _this.callOnCompleteHandler = function () {
      _this.completeTimeout = setTimeout(function () {
        _this.setState({
          complete: true
        });

        if (typeof _this.props.on_complete === 'function') {
          _this.fadeOutTimeout = setTimeout(function () {
            (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_complete');
          }, 600);
        }
      }, 200);
    };

    return _this;
  }

  _createClass(ProgressIndicator, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.completeTimeout);
      clearTimeout(this.fadeOutTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var props = (0, _componentHelper.extendPropsWithContext)(this.props, ProgressIndicator.defaultProps, this.context.getTranslation(this.props).ProgressIndicator, this.context.FormRow, this.context.ProgressIndicator);

      var type = props.type,
          size = props.size,
          no_animation = props.no_animation,
          on_complete = props.on_complete,
          label = props.label,
          indicator_label = props.indicator_label,
          label_direction = props.label_direction,
          show_label = props.show_label,
          className = props.className,
          _className = props.class,
          children = props.children,
          _progress = props.progress,
          _visible = props.visible,
          _complete = props.complete,
          attributes = _objectWithoutProperties(props, ["type", "size", "no_animation", "on_complete", "label", "indicator_label", "label_direction", "show_label", "className", "class", "children", "progress", "visible", "complete"]);

      var _this$state = this.state,
          progress = _this$state.progress,
          visible = _this$state.visible,
          complete = _this$state.complete;

      var params = _extends({}, attributes);

      var hasProgressIndicator = parseFloat(progress) > -1;

      if (visible && !hasProgressIndicator) {
        params.role = 'alert';
        params['aria-busy'] = true;
      }

      var indicatorLabel = label || children || (0, _componentHelper.isTrue)(show_label) && indicator_label;
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement("div", _extends({
        className: (0, _classnames.default)('dnb-progress-indicator', (0, _SpacingHelper.createSpacingClasses)(props), className, _className, visible && 'dnb-progress-indicator--visible', complete && 'dnb-progress-indicator--complete', label_direction && "dnb-progress-indicator--".concat(label_direction), (0, _componentHelper.isTrue)(no_animation) && 'dnb-progress-indicator--no-animation')
      }, params), type === 'circular' && _react.default.createElement(_ProgressIndicatorCircular.default, {
        size: size,
        progress: progress,
        visible: visible,
        complete: complete,
        onComplete: on_complete,
        callOnCompleteHandler: this.callOnCompleteHandler
      }), indicatorLabel && _react.default.createElement("div", {
        className: "dnb-progress-indicator__label"
      }, _react.default.createElement("p", {
        className: "dnb-p"
      }, indicatorLabel)));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(ProgressIndicator.tagName, ProgressIndicator, ProgressIndicator.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        state.visible = (0, _componentHelper.isTrue)(props.visible);

        if (state.visible) {
          state.complete = false;
        }

        if (parseFloat(props.progress) > -1) {
          state.progress = props.progress;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return ProgressIndicator;
}(_react.default.PureComponent);

exports.default = ProgressIndicator;
ProgressIndicator.tagName = 'dnb-progress-indicator';
ProgressIndicator.contextType = _Context.default;
ProgressIndicator.defaultProps = {
  visible: true,
  type: 'circular',
  no_animation: false,
  size: 'default',
  progress: null,
  label: null,
  label_direction: 'horizontal',
  show_label: false,
  indicator_label: null,
  section_style: null,
  section_spacing: null,
  class: null,
  className: null,
  children: null,
  on_complete: null
};
process.env.NODE_ENV !== "production" ? ProgressIndicator.propTypes = _extends({
  visible: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  type: _propTypes.default.oneOf(['circular']),
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  size: _propTypes.default.oneOf(['default', 'small', 'medium', 'large', 'huge']),
  progress: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  label: _propTypes.default.node,
  label_direction: _propTypes.default.string,
  show_label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  indicator_label: _propTypes.default.string,
  section_style: _propTypes.default.string,
  section_spacing: _propTypes.default.string
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  on_complete: _propTypes.default.func
}) : void 0;