"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _helpers = require("../../shared/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var ProgressIndicatorCircular = function (_React$PureComponent) {
  _inherits(ProgressIndicatorCircular, _React$PureComponent);

  var _super = _createSuper(ProgressIndicatorCircular);

  function ProgressIndicatorCircular(props) {
    var _this;

    _classCallCheck(this, ProgressIndicatorCircular);

    _this = _super.call(this, props);
    _this.useAnimationFrame = typeof props.onComplete === 'function' || _helpers.IS_IE11 || _helpers.IS_EDGE;
    _this._refDark = _react.default.createRef();
    _this._refLight = _react.default.createRef();
    _this.state = {
      animate: false
    };
    return _this;
  }

  _createClass(ProgressIndicatorCircular, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.useAnimationFrame) {
        this.startAnimationFirstTime();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.stopAnimation();
    }
  }, {
    key: "stopAnimation",
    value: function stopAnimation() {
      this.setState({
        animate: false
      });

      if (this.startupTimeout) {
        clearTimeout(this.startupTimeout);
      }
    }
  }, {
    key: "startAnimationFirstTime",
    value: function startAnimationFirstTime() {
      var _this2 = this;

      this.setState({
        animate: false
      });
      this.startupTimeout = setTimeout(function () {
        return _this2.startAnimation();
      }, 300);
    }
  }, {
    key: "startAnimation",
    value: function startAnimation() {
      var _this3 = this;

      this.setState({
        animate: true
      }, function () {
        if (_this3._refDark.current) {
          _this3.animate(_this3._refDark.current, true, _this3.props.callOnCompleteHandler);
        }

        if (_this3._refLight.current) {
          _this3.animate(_this3._refLight.current, false);
        }
      });
    }
  }, {
    key: "animate",
    value: function animate(element) {
      var _this4 = this;

      var animateOnStart = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var min = 1;
      var max = 88;
      var start = 0,
          ms = 0,
          prog = max,
          setProg = animateOnStart,
          animate = true,
          completeCalled = false,
          stopNextRound = false;

      var step = function step(timestamp) {
        if (!start) {
          start = timestamp;
        }

        ms = timestamp - start;

        if (animate) {
          if (!_this4.state.visible && prog < 5) {
            prog = min;
          }

          if (setProg) {
            element.style['stroke-dashoffset'] = prog;
          } else if (!animateOnStart) {
            element.style['stroke-dashoffset'] = max;
          }
        }

        if (stopNextRound) {
          animate = false;

          if (!completeCalled) {
            completeCalled = true;

            if (animateOnStart && typeof callback === 'function') {
              callback();
            }
          } else if (_this4.state.visible && ms % 1e3 > 950) {
            stopNextRound = false;
          }
        } else {
          stopNextRound = !_this4.state.visible && prog === min;
          animate = true;
          completeCalled = false;
        }

        prog = Math.round(max - max / 1e3 * (ms % 1e3));
        setProg = animateOnStart ? Math.ceil(ms / 1e3) % 2 === 1 || ms === 0 : Math.ceil(ms / 1e3) % 2 === 0 && ms !== 0;

        if (_this4.state.animate) {
          window.requestAnimationFrame(step);
        }
      };

      if (typeof window !== 'undefined' && window.requestAnimationFrame) {
        window.requestAnimationFrame(step);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          size = _this$props.size,
          maxOffset = _this$props.maxOffset,
          _progress = _this$props.progress,
          visible = _this$props.visible,
          complete = _this$props.complete,
          onComplete = _this$props.onComplete,
          callOnCompleteHandler = _this$props.callOnCompleteHandler,
          rest = _objectWithoutProperties(_this$props, ["size", "maxOffset", "progress", "visible", "complete", "onComplete", "callOnCompleteHandler"]);

      var progress = this.state.progress;
      var strokeDashoffset = maxOffset - maxOffset / 100 * progress;
      var hasProgressIndicator = parseFloat(progress) > -1;

      var params = _extends({}, rest);

      if (hasProgressIndicator) {
        params['title'] = "".concat(progress, "%");
        params['aria-label'] = "".concat(progress, "%");
      } else {
        params['aria-hidden'] = true;
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement("div", _extends({
        className: (0, _classnames.default)('dnb-progress-indicator__circular', size && "dnb-progress-indicator__circular--".concat(size), hasProgressIndicator && 'dnb-progress-indicator__circular--has-progress-indicator')
      }, params), _ref, _react.default.createElement(Circle, {
        className: "dnb-progress-indicator__circular__line dark dark" + (hasProgressIndicator || this.useAnimationFrame ? " paused" : ""),
        style: hasProgressIndicator ? {
          strokeDashoffset: strokeDashoffset
        } : {},
        ref: this._refDark
      }), !hasProgressIndicator && _react.default.createElement(Circle, {
        className: "dnb-progress-indicator__circular__line light" + (this.useAnimationFrame ? " paused" : ""),
        ref: this._refLight
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      state.progress = parseFloat(props.progress);
      state.visible = props.visible;
      state.complete = props.complete;
      return state;
    }
  }]);

  return ProgressIndicatorCircular;
}(_react.default.PureComponent);

exports.default = ProgressIndicatorCircular;
ProgressIndicatorCircular.defaultProps = {
  size: null,
  visible: true,
  complete: false,
  progress: null,
  maxOffset: 88,
  onComplete: null,
  callOnCompleteHandler: null
};
process.env.NODE_ENV !== "production" ? ProgressIndicatorCircular.propTypes = {
  size: _propTypes.default.string,
  visible: _propTypes.default.bool,
  complete: _propTypes.default.bool,
  progress: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  maxOffset: _propTypes.default.number,
  onComplete: _propTypes.default.func,
  callOnCompleteHandler: _propTypes.default.func
} : void 0;

var _ref3 = _react.default.createElement("circle", {
  className: "dnb-progress-indicator__circular__circle",
  fill: "none",
  strokeWidth: "4",
  cx: "16",
  cy: "16",
  r: "14"
});

var Circle = _react.default.forwardRef(function (_ref2, ref) {
  var className = _ref2.className,
      rest = _objectWithoutProperties(_ref2, ["className"]);

  return _react.default.createElement("svg", _extends({
    className: className,
    viewBox: "0 0 32 32",
    shapeRendering: "geometricPrecision",
    ref: ref
  }, rest), _ref3);
}),
    _ref = _react.default.createElement(Circle, {
  className: "dnb-progress-indicator__circular__line light paused"
});

process.env.NODE_ENV !== "production" ? Circle.propTypes = {
  className: _propTypes.default.string.isRequired
} : void 0;