"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _RadioGroup = _interopRequireDefault(require("./RadioGroup"));

var _RadioGroupContext = _interopRequireDefault(require("./RadioGroupContext"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref2 = _react.default.createElement(_AlignmentHelper.default, null);

var _ref3 = _react.default.createElement("span", {
  className: "dnb-radio__focus",
  "aria-hidden": true
});

var _ref4 = _react.default.createElement("span", {
  className: "dnb-radio__dot",
  "aria-hidden": true
});

var Radio = function (_React$PureComponent) {
  _inherits(Radio, _React$PureComponent);

  var _super = _createSuper(Radio);

  function Radio(props) {
    var _this;

    _classCallCheck(this, Radio);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      var key = (0, _keycode.default)(event);

      if (_this.isInNoGroup()) {
        switch (key) {
          case 'enter':
            _this.onChangeHandler(event);

            break;
        }
      } else if (_this.isContextGroupOrSingle()) {
        switch (key) {
          case 'space':
          case 'enter':
            {
              var value = _this.context.value;

              if (value !== null && typeof value !== 'undefined') {
                event.preventDefault();
              }

              if (key === 'enter') {
                var checked = !_this.state.checked;

                _this.setState({
                  checked: checked,
                  _listenForPropChanges: false
                });
              }

              break;
            }
        }
      } else {
        switch (key) {
          case 'space':
            {
              event.preventDefault();
              break;
            }
        }
      }

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_key_down', {
        event: event
      });
    };

    _this.onChangeHandler = function (_event) {
      var event = _event;

      if ((0, _componentHelper.isTrue)(_this.props.readOnly)) {
        return event.preventDefault();
      }

      var value = event.target.value;
      var checked = !_this.state.checked;

      if (_this.isPlainGroup()) {
        setTimeout(function () {
          _this.setState({
            checked: checked,
            _listenForPropChanges: false
          }, function () {
            return _this.callOnChange({
              value: value,
              checked: checked,
              event: event
            });
          });
        }, 1);
      } else {
        _this.setState({
          checked: checked,
          _listenForPropChanges: false
        });

        _this.callOnChange({
          value: value,
          checked: checked,
          event: event
        });
      }
    };

    _this.isContextGroupOrSingle = function () {
      return typeof _this.context.value !== 'undefined' && !_this.props.group;
    };

    _this.isPlainGroup = function () {
      return typeof _this.context.value === 'undefined' && _this.props.group;
    };

    _this.isInNoGroup = function () {
      return typeof _this.context.value === 'undefined' && !_this.props.group;
    };

    _this.onClickHandler = function (event) {
      if ((0, _componentHelper.isTrue)(_this.props.readOnly)) {
        return event.preventDefault();
      }

      if (!_this.isPlainGroup()) {
        return;
      }

      var value = event.target.value;
      var checked = event.target.checked;

      _this.callOnChange({
        value: value,
        checked: checked,
        event: event
      });
    };

    _this.callOnChange = function (_ref) {
      var value = _ref.value,
          checked = _ref.checked,
          event = _ref.event;
      var group = _this.props.group;

      if (_this.context.onChange) {
        _this.context.onChange({
          value: value
        });
      }

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        group: group,
        checked: checked,
        value: value,
        event: event
      });

      if (_this._refInput.current) {
        _this._refInput.current.focus();
      }
    };

    _this._refInput = _react.default.createRef();
    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(Radio, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement(_Context.default.Consumer, null, function (context) {
        var props = (0, _componentHelper.extendPropsWithContext)(_this2.props, Radio.defaultProps, _this2.context, {
          skeleton: context === null || context === void 0 ? void 0 : context.skeleton
        }, context.FormRow, context.Radio);

        var status = props.status,
            status_state = props.status_state,
            status_animation = props.status_animation,
            global_status_id = props.global_status_id,
            suffix = props.suffix,
            label = props.label,
            label_sr_only = props.label_sr_only,
            label_position = props.label_position,
            size = props.size,
            readOnly = props.readOnly,
            skeleton = props.skeleton,
            className = props.className,
            _className = props.class,
            _id = props.id,
            _group = props.group,
            _value = props.value,
            _checked = props.checked,
            _disabled = props.disabled,
            attributes = props.attributes,
            children = props.children,
            on_change = props.on_change,
            on_state_update = props.on_state_update,
            custom_method = props.custom_method,
            custom_element = props.custom_element,
            rest = _objectWithoutProperties(props, ["status", "status_state", "status_animation", "global_status_id", "suffix", "label", "label_sr_only", "label_position", "size", "readOnly", "skeleton", "className", "class", "id", "group", "value", "checked", "disabled", "attributes", "children", "on_change", "on_state_update", "custom_method", "custom_element"]);

        var checked = _this2.state.checked;
        var value = props.value,
            group = props.group,
            disabled = props.disabled;
        var hasContext = typeof _this2.context.name !== 'undefined';

        if (hasContext) {
          if (typeof _this2.context.value !== 'undefined') {
            checked = _this2.context.value === value;
          }

          group = _this2.context.name;
          disabled = (0, _componentHelper.isTrue)(_this2.context.disabled);
        } else if (typeof rest.name !== 'undefined') {
          group = rest.name;
        }

        var id = _this2._id;
        var showStatus = (0, _componentHelper.getStatusState)(status);
        var mainParams = {
          className: (0, _classnames.default)('dnb-radio', (0, _SpacingHelper.createSpacingClasses)(props), className, _className, status && "dnb-radio__status--".concat(status_state), size && "dnb-radio--".concat(size), label && "dnb-radio--label-position-".concat(label_position || 'right'))
        };

        var inputParams = _extends({
          role: hasContext || group ? 'radio' : null,
          type: hasContext || group ? 'radio' : 'checkbox'
        }, rest);

        if (showStatus || suffix) {
          inputParams['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(inputParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
        }

        if (readOnly) {
          inputParams['aria-readonly'] = inputParams.readOnly = true;
        }

        if (!group) {
          inputParams.type = 'checkbox';
          inputParams.role = 'radio';
        }

        (0, _SkeletonHelper.skeletonDOMAttributes)(inputParams, skeleton, _this2.context);
        (0, _componentHelper.validateDOMAttributes)(_this2.props, inputParams);

        var labelComp = label && _react.default.createElement(_FormLabel.default, {
          id: id + '-label',
          for_id: id,
          text: label,
          disabled: disabled,
          skeleton: skeleton,
          sr_only: label_sr_only
        });

        return _react.default.createElement("span", mainParams, _react.default.createElement("span", {
          className: "dnb-radio__order"
        }, label_position === 'left' && labelComp, _react.default.createElement("span", {
          className: "dnb-radio__inner"
        }, _ref2, showStatus && _react.default.createElement(_FormStatus.default, {
          id: id + '-form-status',
          global_status_id: global_status_id,
          label: label,
          text_id: id + '-status',
          width_selector: id + ', ' + id + '-label',
          text: status,
          status: status_state,
          animation: status_animation,
          skeleton: skeleton
        }), _react.default.createElement("span", {
          className: "dnb-radio__row"
        }, _react.default.createElement("span", {
          className: "dnb-radio__shell"
        }, _react.default.createElement("input", _extends({
          type: "radio",
          value: value,
          id: id,
          name: group,
          className: "dnb-radio__input",
          checked: checked,
          "aria-checked": checked,
          disabled: (0, _componentHelper.isTrue)(disabled),
          ref: _this2._refInput
        }, inputParams, {
          onChange: _this2.onChangeHandler,
          onClick: _this2.onClickHandler,
          onKeyDown: _this2.onKeyDownHandler
        })), _react.default.createElement("span", {
          className: (0, _classnames.default)('dnb-radio__button', (0, _SkeletonHelper.createSkeletonClass)('shape', skeleton, _this2.context)),
          "aria-hidden": true
        }), _ref3, _ref4), label_position !== 'left' && labelComp, suffix && _react.default.createElement(_Suffix.default, {
          className: "dnb-radio__suffix",
          id: id + '-suffix',
          context: props
        }, suffix)))));
      });
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Radio.tagName, Radio, Radio.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.checked !== state._checked) {
          state.checked = Radio.parseChecked(props.checked);
        }
      }

      state._listenForPropChanges = true;

      if (state.checked !== state.__checked) {
        (0, _componentHelper.dispatchCustomElementEvent)({
          props: props
        }, 'on_state_update', {
          checked: state.checked
        });
      }

      state._checked = props.checked;
      state.__checked = state.checked;
      return state;
    }
  }]);

  return Radio;
}(_react.default.PureComponent);

exports.default = Radio;
Radio.tagName = 'dnb-radio';
Radio.contextType = _RadioGroupContext.default;
Radio.defaultProps = {
  label: null,
  label_sr_only: null,
  label_position: null,
  checked: null,
  disabled: false,
  id: null,
  size: null,
  group: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  value: '',
  attributes: null,
  readOnly: false,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_state_update: null
};
Radio.Group = _RadioGroup.default;

Radio.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

process.env.NODE_ENV !== "production" ? Radio.propTypes = _extends({
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  label_position: _propTypes.default.oneOf(['left', 'right']),
  checked: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  id: _propTypes.default.string,
  group: _propTypes.default.string,
  size: _propTypes.default.oneOf(['default', 'medium', 'large']),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  value: _propTypes.default.string,
  attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  readOnly: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_state_update: _propTypes.default.func
}) : void 0;