"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _FormRow = _interopRequireDefault(require("../form-row/FormRow"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

var _RadioGroupContext = _interopRequireDefault(require("./RadioGroupContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var RadioGroup = function (_React$PureComponent) {
  _inherits(RadioGroup, _React$PureComponent);

  var _super = _createSuper(RadioGroup);

  function RadioGroup(props) {
    var _this;

    _classCallCheck(this, RadioGroup);

    _this = _super.call(this, props);

    _this.onChangeHandler = function (_ref) {
      var value = _ref.value,
          event = _ref.event;

      _this.setState({
        value: value,
        _listenForPropChanges: false
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        value: value,
        event: event
      });
    };

    _this._refInput = _react.default.createRef();
    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this._name = props.name || _this._id;
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(RadioGroup, [{
    key: "render",
    value: function render() {
      var props = (0, _componentHelper.extendPropsWithContext)(this.props, RadioGroup.defaultProps, this.context.FormRow, this.context.RadioGroup);

      var status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          label_position = props.label_position,
          vertical = props.vertical,
          layout_direction = props.layout_direction,
          no_fieldset = props.no_fieldset,
          size = props.size,
          disabled = props.disabled,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _id = props.id,
          _name = props.name,
          _value = props.value,
          attributes = props.attributes,
          children = props.children,
          on_change = props.on_change,
          custom_method = props.custom_method,
          custom_element = props.custom_element,
          rest = _objectWithoutProperties(props, ["status", "status_state", "status_animation", "global_status_id", "suffix", "label", "label_direction", "label_sr_only", "label_position", "vertical", "layout_direction", "no_fieldset", "size", "disabled", "skeleton", "className", "class", "id", "name", "value", "attributes", "children", "on_change", "custom_method", "custom_element"]);

      var value = this.state.value;
      var id = this._id;
      var showStatus = (0, _componentHelper.getStatusState)(status);
      var classes = (0, _classnames.default)("dnb-radio-group dnb-radio-group--".concat(layout_direction, " dnb-form-component"), (0, _SpacingHelper.createSpacingClasses)(props), className, _className, status && "dnb-radio-group__status--".concat(status_state));

      var params = _extends({}, rest);

      if (showStatus || suffix) {
        params['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(params, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (label) {
        params['aria-labelledby'] = id + '-label';
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      var context = {
        name: this._name,
        value: value,
        size: size,
        disabled: disabled,
        label_position: label_position,
        onChange: this.onChangeHandler
      };
      var formRowParams = {
        id: id,
        label: label,
        label_id: id + '-label',
        label_direction: label_direction,
        label_sr_only: label_sr_only,
        direction: label_direction,
        vertical: vertical,
        disabled: disabled,
        skeleton: skeleton,
        no_fieldset: no_fieldset,
        skipContentWrapperIfNested: true
      };
      return _react.default.createElement(_RadioGroupContext.default.Provider, {
        value: context
      }, _react.default.createElement("div", {
        className: classes
      }, _react.default.createElement(_FormRow.default, formRowParams, _react.default.createElement("span", _extends({
        id: id,
        className: "dnb-radio-group__shell",
        role: "radiogroup"
      }, params), children, suffix && _react.default.createElement(_Suffix.default, {
        className: "dnb-radio-group__suffix",
        id: id + '-suffix',
        context: props
      }, suffix), showStatus && _react.default.createElement(_FormStatus.default, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text: status,
        status: status_state,
        text_id: id + '-status',
        width_selector: id + ', ' + id + '-label',
        animation: status_animation,
        skeleton: skeleton
      })))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(RadioGroup.tagName, RadioGroup, RadioGroup.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.value !== state._value) {
          state.value = props.value;
        }

        if (typeof props.value !== 'undefined') {
          state._value = props.value;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return RadioGroup;
}(_react.default.PureComponent);

exports.default = RadioGroup;
RadioGroup.tagName = 'dnb-radio-group';
RadioGroup.contextType = _Context.default;
RadioGroup.defaultProps = {
  label: null,
  label_direction: null,
  label_sr_only: null,
  label_position: null,
  title: null,
  no_fieldset: null,
  disabled: null,
  skeleton: null,
  id: null,
  name: null,
  size: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  vertical: null,
  layout_direction: 'row',
  value: undefined,
  attributes: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null
};

RadioGroup.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

process.env.NODE_ENV !== "production" ? RadioGroup.propTypes = _extends({
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['horizontal', 'vertical']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  label_position: _propTypes.default.oneOf(['left', 'right']),
  title: _propTypes.default.string,
  no_fieldset: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  id: _propTypes.default.string,
  name: _propTypes.default.string,
  size: _propTypes.default.oneOf(['default', 'medium', 'large']),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  layout_direction: _propTypes.default.oneOf(['column', 'row']),
  vertical: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  value: _propTypes.default.string,
  attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_change: _propTypes.default.func
}) : void 0;