"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _defaults = require("../../shared/defaults");

var _Space = _interopRequireDefault(require("../space/Space"));

var _SpacingHelper = require("../space/SpacingHelper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Provider = _interopRequireDefault(require("../../shared/Provider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Skeleton = function (_React$PureComponent) {
  _inherits(Skeleton, _React$PureComponent);

  var _super = _createSuper(Skeleton);

  function Skeleton(props) {
    var _this;

    _classCallCheck(this, Skeleton);

    _this = _super.call(this, props);
    _this.state = {
      ariaLiveUpdate: null
    };
    return _this;
  }

  _createClass(Skeleton, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._ariaLiveUpdateTiemout);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.show !== this.props.show) {
        this.setAriaLiveUpdate();
      }
    }
  }, {
    key: "getProps",
    value: function getProps() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.context;
      return (0, _componentHelper.extendPropsWithContext)(props, Skeleton.defaultProps, {
        skeleton: context.Skeleton || context.skeleton,
        style_type: context.skeleton_style_type,
        no_animation: context.skeleton_no_animation
      }, context.getTranslation(props).Skeleton);
    }
  }, {
    key: "setAriaLiveUpdate",
    value: function setAriaLiveUpdate() {
      var _this2 = this;

      clearTimeout(this._ariaLiveUpdateTiemout);
      this._ariaLiveUpdateTiemout = setTimeout(function () {
        var _this2$getProps = _this2.getProps(),
            aria_bussy = _this2$getProps.aria_bussy,
            aria_ready = _this2$getProps.aria_ready;

        var newString = null;

        if ((0, _componentHelper.isTrue)(_this2.props.show)) {
          newString = aria_bussy;
        } else {
          newString = aria_ready;
        }

        if (newString) {
          _this2.setState({
            ariaLiveUpdate: newString
          });

          _this2._ariaLiveUpdateTiemout = setTimeout(function () {
            _this2.setState({
              ariaLiveUpdate: null
            });
          }, 1e3);
        }
      }, 1e3);
    }
  }, {
    key: "render",
    value: function render() {
      var props = this.getProps();

      var show = props.show,
          style_type = props.style_type,
          no_animation = props.no_animation,
          figure = props.figure,
          skeleton = props.skeleton,
          aria_bussy = props.aria_bussy,
          aria_ready = props.aria_ready,
          className = props.className,
          _className = props.class,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["show", "style_type", "no_animation", "figure", "skeleton", "aria_bussy", "aria_ready", "className", "class", "children"]);

      var ariaLiveUpdate = this.state.ariaLiveUpdate;
      var showSkeleton = typeof show === 'boolean' || typeof show === 'string' ? (0, _componentHelper.isTrue)(show) : skeleton;

      var params = _extends({
        className: (0, _classnames.default)(figure ? 'dnb-skeleton__figure' : 'dnb-skeleton__root', (0, _SpacingHelper.createSpacingClasses)(props), className, _className, (0, _componentHelper.isTrue)(showSkeleton) && 'dnb-skeleton', showSkeleton && style_type && "dnb-skeleton--".concat(style_type), (0, _componentHelper.isTrue)(no_animation) && 'dnb-skeleton--no-animation'),
        'aria-busy': showSkeleton,
        'aria-label': showSkeleton ? aria_bussy : undefined,
        lang: this.context.locale || _defaults.LOCALE
      }, attributes);

      (0, _componentHelper.validateDOMAttributes)(props, params);
      return _react.default.createElement(_Space.default, params, figure ? showSkeleton ? typeof figure === 'function' ? figure() : figure : children : _react.default.createElement(_Provider.default, {
        skeleton: showSkeleton,
        skeleton_style_type: style_type,
        skeleton_no_animation: no_animation
      }, children), _react.default.createElement("span", {
        className: "dnb-sr-only",
        "aria-live": "assertive"
      }, ariaLiveUpdate));
    }
  }]);

  return Skeleton;
}(_react.default.PureComponent);

exports.default = Skeleton;
Skeleton.contextType = _Context.default;
Skeleton.defaultProps = {
  show: null,
  skeleton: null,
  style_type: null,
  no_animation: null,
  figure: null,
  aria_bussy: null,
  aria_ready: null,
  element: null,
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Skeleton.propTypes = _extends({
  show: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  style_type: _propTypes.default.oneOfType([_propTypes.default.oneOf(['lines']), _propTypes.default.string]),
  figure: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  element: _propTypes.default.node
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node])
}) : void 0;

function Exclude(props) {
  return _react.default.createElement(_Provider.default, _extends({
    skeleton: false
  }, props));
}

Skeleton.Exclude = Exclude;