"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.string.trim.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AutoSize = exports.createSkeletonClass = exports.skeletonDOMAttributes = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _componentHelper = require("../../shared/component-helper");

var _classnames = _interopRequireDefault(require("classnames"));

var _helpers = require("../../shared/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var skeletonDOMAttributes = function skeletonDOMAttributes(params, skeleton) {
  var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if ((0, _componentHelper.isTrue)(skeleton) || context !== null && context !== void 0 && context.skeleton) {
    var _context$translation, _context$translation$;

    params.disabled = true;
    params['aria-disabled'] = true;
    params['aria-label'] = context === null || context === void 0 ? void 0 : (_context$translation = context.translation) === null || _context$translation === void 0 ? void 0 : (_context$translation$ = _context$translation.Skeleton) === null || _context$translation$ === void 0 ? void 0 : _context$translation$.aria_bussy;
  }

  return params;
};

exports.skeletonDOMAttributes = skeletonDOMAttributes;

var createSkeletonClass = function createSkeletonClass(method, skeleton) {
  var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if ((0, _componentHelper.isTrue)(skeleton) || context !== null && context !== void 0 && context.skeleton) {
    return 'dnb-skeleton' + (method ? " dnb-skeleton--".concat(method) : "");
  }

  return null;
};

exports.createSkeletonClass = createSkeletonClass;

var AutoSize = function (_React$PureComponent) {
  _inherits(AutoSize, _React$PureComponent);

  var _super = _createSuper(AutoSize);

  function AutoSize() {
    _classCallCheck(this, AutoSize);

    return _super.apply(this, arguments);
  }

  _createClass(AutoSize, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          children = _this$props.children,
          Comp = _this$props.__element,
          style = _this$props.style,
          props = _objectWithoutProperties(_this$props, ["className", "children", "__element", "style"]);

      var string = (0, _componentHelper.convertJsxToString)(children);

      if (typeof string === 'string') {
        var countChars = string.trim().length;

        if (countChars > 0) {
          return _react.default.createElement(Comp, _extends({
            className: (0, _classnames.default)("dnb-skeleton dnb-skeleton--font", className),
            'data-skeleton-chars': String(countChars),
            style: _extends({}, style || {}, _defineProperty({}, _helpers.IS_IE11 ? 'maxWidth' : '--skeleton-chars', "".concat(countChars, "ch")))
          }, props), children);
        }
      }

      return _react.default.createElement(Comp, _extends({}, props, {
        className: className,
        style: style
      }));
    }
  }]);

  return AutoSize;
}(_react.default.PureComponent);

exports.AutoSize = AutoSize;
AutoSize.defaultProps = {
  __element: null,
  children: null,
  className: null,
  style: null
};
process.env.NODE_ENV !== "production" ? AutoSize.propTypes = {
  __element: _propTypes.default.node,
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  style: _propTypes.default.object
} : void 0;