"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.reverse.js");

require("core-js/modules/es.number.to-fixed.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _SpacingHelper = require("../space/SpacingHelper");

var _Number = require("../number/Number");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

var _Button = _interopRequireDefault(require("../button/Button"));

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref = _react.default.createElement(_AlignmentHelper.default, null);

var _ref2 = _react.default.createElement("span", {
  className: "dnb-slider__line dnb-slider__line__after"
});

var Slider = function (_React$PureComponent) {
  _inherits(Slider, _React$PureComponent);

  var _super = _createSuper(Slider);

  function Slider(props) {
    var _this;

    _classCallCheck(this, Slider);

    _this = _super.call(this, props);
    _this.state = {
      currentState: 'initial',
      value: null
    };

    _this.onFocusHandler = function () {
      _this.setState({
        _listenForPropChanges: false,
        currentState: 'focused'
      });
    };

    _this.onBlurHandler = function () {
      _this.setState({
        _listenForPropChanges: false,
        currentState: 'normal'
      });
    };

    _this.onClickHandler = function (event) {
      var _this$state = _this.state,
          min = _this$state.min,
          max = _this$state.max,
          reverse = _this$state.reverse,
          vertical = _this$state.vertical;
      var percent = calculatePercent(_this._trackRef.current, event, vertical, reverse);
      var value = percentToValue(percent, min, max);

      _this.emitChange(event, value);

      _this.setJumpedState();
    };

    _this.onSubtractClickHandler = function (event) {
      var step = _this.props.step;
      var _this$state2 = _this.state,
          min = _this$state2.min,
          max = _this$state2.max,
          value = _this$state2.value;

      _this.emitChange(event, clamp(value - (step || 1), min, max));
    };

    _this.onAddClickHandler = function (event) {
      var step = _this.props.step;
      var _this$state3 = _this.state,
          min = _this$state3.min,
          max = _this$state3.max,
          value = _this$state3.value;

      _this.emitChange(event, clamp(value + (step || 1), min, max));
    };

    _this.onMouseDownHandler = function (event) {
      if (typeof document !== 'undefined') {
        try {
          document.body.addEventListener('touchmove', _this.onTouchMoveHandler);
          document.body.addEventListener('touchend', _this.onTouchEndHandler);
          document.body.addEventListener('mousemove', _this.onMouseMoveHandler);
          document.body.addEventListener('mouseup', _this.onMouseUpHandler);
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }

      _this.setState({
        _listenForPropChanges: false,
        currentState: 'activated'
      });

      if (typeof _this.props.on_drag_start === 'function') {
        (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_drag_start', {
          event: event
        });
      }
    };

    _this.onTouchEndHandler = function (event) {
      return _this.onMouseUpHandler(event);
    };

    _this.onMouseUpHandler = function (event) {
      if (typeof document !== 'undefined') {
        try {
          document.body.removeEventListener('touchmove', _this.onTouchMoveHandler);
          document.body.removeEventListener('touchend', _this.onTouchEndHandler);
          document.body.removeEventListener('mousemove', _this.onMouseMoveHandler);
          document.body.removeEventListener('mouseup', _this.onMouseUpHandler);
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }

      _this.setState({
        _listenForPropChanges: false,
        currentState: 'normal'
      });

      if (typeof _this.props.on_drag_end === 'function') {
        (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_drag_end', {
          event: event
        });
      }
    };

    _this.onRangeChangeHandler = function (event) {
      var value = parseFloat(event.currentTarget.value);

      _this.setState({
        value: value,
        _listenForPropChanges: false
      }, function () {});

      _this.emitChange(event, value);
    };

    _this.onTouchMoveHandler = function (event) {
      return _this.onMouseMoveHandler(event);
    };

    _this.onMouseMoveHandler = function (event) {
      var elem = _this._trackRef.current;

      if (event && event.detail && typeof event.detail.height !== 'undefined') {
        elem = createMockDiv(event.detail);
        event = event.detail;
      }

      var _this$state4 = _this.state,
          min = _this$state4.min,
          max = _this$state4.max,
          vertical = _this$state4.vertical,
          reverse = _this$state4.reverse;
      var percent = calculatePercent(elem, event, vertical, reverse);
      var value = percentToValue(percent, min, max);

      _this.emitChange(event, value);
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this._trackRef = _react.default.createRef();

    var _value2 = Slider.getValue(props);

    _this.state = {
      _listenForPropChanges: true,
      value: _value2,
      _value: _value2,
      __value: _value2
    };
    return _this;
  }

  _createClass(Slider, [{
    key: "roundValue",
    value: function roundValue(value) {
      var step = this.props.step;
      return parseFloat(step) > 0 ? roundToStep(value, step) : parseFloat(value).toFixed(3);
    }
  }, {
    key: "emitChange",
    value: function emitChange(event, rawValue, callback) {
      var _this$context;

      var _this$state5 = this.state,
          previousValue = _this$state5.value,
          disabled = _this$state5.disabled;

      if (disabled || (0, _componentHelper.isTrue)(this.props.skeleton) || (0, _componentHelper.isTrue)((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton)) {
        return;
      }

      var value = this.roundValue(rawValue);

      if (value > -1) {
        if (typeof this.props.on_change === 'function' && value !== this.roundValue(previousValue)) {
          var obj = {
            value: value,
            rawValue: rawValue,
            raw_value: rawValue,
            event: event
          };

          if (this.props.number_format) {
            obj.number = formatNumber(value, this.props.number_format);
          }

          (0, _componentHelper.dispatchCustomElementEvent)(this, 'on_change', obj);

          if (typeof callback === 'function') {
            callback();
          }
        }

        this.setState({
          value: rawValue,
          _listenForPropChanges: false
        });
      }
    }
  }, {
    key: "setJumpedState",
    value: function setJumpedState() {
      var _this2 = this;

      this.setState({
        currentState: 'jumped',
        _listenForPropChanges: false
      }, function () {
        clearTimeout(_this2.jumpedTimeout);
        _this2.jumpedTimeout = setTimeout(function () {
          return _this2.setState({
            currentState: 'normal',
            _listenForPropChanges: false
          });
        }, 100);
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;

      if (this._trackRef.current) {
        if ((0, _componentHelper.isTrue)(this.props.use_scrollwheel)) {
          var _this$state6 = this.state,
              min = _this$state6.min,
              max = _this$state6.max,
              reverse = _this$state6.reverse,
              vertical = _this$state6.vertical;

          this._trackRef.current.addEventListener('wheel', function (event) {
            event.preventDefault();

            _this3.emitChange(event, clamp(_this3.state.value + (!vertical && reverse || vertical && !reverse ? -event.deltaY / 10 : event.deltaY / 10), min, max));
          });
        }
      }

      if (typeof this.props.on_init === 'function') {
        var value = this.state.value;
        var obj = {
          value: value
        };

        if (this.props.number_format) {
          obj.number = formatNumber(value, this.props.number_format);
        }

        (0, _componentHelper.dispatchCustomElementEvent)(this, 'on_init', obj);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (typeof document !== 'undefined') {
        try {
          document.body.removeEventListener('touchmove', this.onTouchMoveHandler);
          document.body.removeEventListener('touchend', this.onTouchEndHandler);
          document.body.removeEventListener('mousemove', this.onMouseMoveHandler);
          document.body.removeEventListener('mouseup', this.onMouseUpHandler);
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }

      clearTimeout(this.jumpedTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context2;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Slider.defaultProps, {
        skeleton: (_this$context2 = this.context) === null || _this$context2 === void 0 ? void 0 : _this$context2.skeleton
      }, this.context.getTranslation(this.props).Slider, this.context.FormRow, this.context.Slider);

      var label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          stretch = props.stretch,
          suffix = props.suffix,
          title = props.thump_title,
          subtract_title = props.subtract_title,
          add_title = props.add_title,
          hide_buttons = props.hide_buttons,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _max = props.max,
          _min = props.min,
          _disabled = props.disabled,
          _reverse = props.reverse,
          _vertical = props.vertical,
          _id = props.id,
          _step = props.step,
          _value = props.value,
          _children = props.children,
          _use_scrollwheel = props.use_scrollwheel,
          attributes = _objectWithoutProperties(props, ["label", "label_direction", "label_sr_only", "status", "status_state", "status_animation", "global_status_id", "stretch", "suffix", "thump_title", "subtract_title", "add_title", "hide_buttons", "skeleton", "className", "class", "max", "min", "disabled", "reverse", "vertical", "id", "step", "value", "children", "use_scrollwheel"]);

      var _this$state7 = this.state,
          min = _this$state7.min,
          max = _this$state7.max,
          reverse = _this$state7.reverse,
          vertical = _this$state7.vertical,
          value = _this$state7.value,
          currentState = _this$state7.currentState,
          disabled = _this$state7.disabled;
      var showStatus = (0, _componentHelper.getStatusState)(status);
      var showButtons = !(0, _componentHelper.isTrue)(hide_buttons);
      var id = this._id;
      var mainParams = {
        className: (0, _classnames.default)("dnb-slider dnb-form-component", (0, _SkeletonHelper.createSkeletonClass)(null, skeleton), (0, _SpacingHelper.createSpacingClasses)(props), className, _className, reverse && 'dnb-slider--reverse', vertical && 'dnb-slider--vertical', (0, _componentHelper.isTrue)(stretch) && 'dnb-slider--stretch', label && label_direction && "dnb-slider__label--".concat(label_direction), showStatus && 'dnb-slider__form-status', status && "dnb-slider__status--".concat(status_state))
      };
      var percent = clamp((value - min) * 100 / (max - min));

      var _formatNumber = formatNumber(value, _extends({
        returnAria: true
      }, this.props.number_format)),
          humanNumber = _formatNumber.aria;

      var hasHumanNumber = value !== humanNumber;

      var inlineStyleBefore = _defineProperty({}, "".concat(vertical ? 'height' : 'width'), "".concat(percent, "%"));

      var inlineThumbStyles = _defineProperty({}, "".concat(vertical ? 'top' : 'left'), "".concat(percent, "%"));

      (0, _SkeletonHelper.skeletonDOMAttributes)(mainParams, skeleton, this.context);
      var helperParams = {};
      var trackParams = {
        className: 'dnb-slider__track' + (currentState ? " dnb-slider__state--".concat(currentState) : ""),
        onTouchStart: this.onClickHandler,
        onTouchStartCapture: this.onMouseDownHandler,
        onMouseDown: this.onClickHandler,
        onMouseDownCapture: this.onMouseDownHandler
      };

      var thumbParams = _extends({
        title: title
      }, attributes, {
        onBlur: this.onBlurHandler,
        onFocus: this.onFocusHandler
      });

      if (label || hasHumanNumber) {
        helperParams['aria-labelledby'] = (0, _componentHelper.combineLabelledBy)(helperParams, hasHumanNumber ? id + '-human' : null, label ? id + '-label' : null);
      }

      if (showStatus || suffix) {
        helperParams['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(helperParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      var subtractParams = {};
      var addParams = {};

      if (typeof thumbParams['aria-hidden'] !== 'undefined') {
        helperParams['aria-hidden'] = addParams['aria-hidden'] = subtractParams['aria-hidden'] = thumbParams['aria-hidden'];
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, thumbParams);
      (0, _componentHelper.validateDOMAttributes)(null, trackParams);
      (0, _componentHelper.validateDOMAttributes)(null, helperParams);

      var subtractButton = _react.default.createElement(_Button.default, {
        className: "dnb-slider__button dnb-slider__button--subtract",
        variant: "secondary",
        icon: "subtract",
        size: "small",
        "aria-label": subtract_title.replace('%s', humanNumber),
        on_click: this.onSubtractClickHandler,
        disabled: disabled,
        skeleton: skeleton
      });

      var addButton = _react.default.createElement(_Button.default, {
        className: "dnb-slider__button dnb-slider__button--add",
        variant: "secondary",
        icon: "add",
        size: "small",
        "aria-label": add_title.replace('%s', humanNumber),
        on_click: this.onAddClickHandler,
        disabled: disabled,
        skeleton: skeleton
      });

      return _react.default.createElement("span", mainParams, label && _react.default.createElement(_FormLabel.default, {
        id: id + '-label',
        text: label,
        disabled: disabled,
        skeleton: skeleton,
        label_direction: label_direction,
        sr_only: label_sr_only
      }), _react.default.createElement("span", {
        className: "dnb-slider__wrapper"
      }, _ref, showStatus && _react.default.createElement(_FormStatus.default, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), _react.default.createElement("span", {
        className: "dnb-slider__inner"
      }, showButtons && (reverse ? addButton : subtractButton), _react.default.createElement("span", _extends({
        id: this._id,
        ref: this._trackRef
      }, trackParams), _react.default.createElement("span", {
        className: "dnb-slider__thumb",
        style: inlineThumbStyles
      }, _react.default.createElement("input", _extends({
        type: "range",
        className: "dnb-slider__button-helper",
        min: min,
        max: max,
        step: _step,
        value: value,
        disabled: disabled,
        orientation: vertical ? 'vertical' : 'horizontal',
        onChange: this.onRangeChangeHandler
      }, helperParams)), _react.default.createElement(_Button.default, _extends({
        tabIndex: "-1",
        "aria-hidden": true,
        variant: "secondary",
        disabled: disabled,
        skeleton: skeleton,
        onMouseDown: this.onMouseDownHandler
      }, thumbParams))), _react.default.createElement("span", {
        className: "dnb-slider__line dnb-slider__line__before",
        style: inlineStyleBefore
      }), _ref2, hasHumanNumber && _react.default.createElement("span", {
        id: id + '-human',
        className: "dnb-sr-only",
        "aria-hidden": true
      }, humanNumber)), showButtons && (reverse ? subtractButton : addButton), suffix && _react.default.createElement(_Suffix.default, {
        className: "dnb-slider__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Slider.tagName, Slider, Slider.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        state.reverse = (0, _componentHelper.isTrue)(props.reverse);

        if ((0, _componentHelper.isTrue)(props.vertical)) {
          state.reverse = !state.reverse;
        }

        state.vertical = (0, _componentHelper.isTrue)(props.vertical);
        state.min = parseFloat(props.min);
        state.max = parseFloat(props.max);
        var value = Slider.getValue(props);

        if (value !== state._value && value >= -1) {
          state.value = value;

          if (typeof props.on_state_update === 'function') {
            var obj = {
              value: value
            };

            if (props.number_format) {
              obj.number = formatNumber(value, props.number_format);
            }

            (0, _componentHelper.dispatchCustomElementEvent)(_extends({}, props), 'on_state_update', obj);
          }
        }

        state._value = value;
      }

      state._listenForPropChanges = true;
      state.disabled = (0, _componentHelper.isTrue)(props.disabled);

      if ((0, _componentHelper.isTrue)(props.skeleton)) {
        state.disabled = true;
      }

      if (state.disabled) {
        state.currentState = 'disabled';
      } else if (state.currentState === 'disabled') {
        state.currentState = 'normal';
      }

      return state;
    }
  }, {
    key: "getValue",
    value: function getValue(props) {
      if (props.value >= -1) {
        return props.value;
      }

      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return Slider;
}(_react.default.PureComponent);

exports.default = Slider;
Slider.tagName = 'dnb-slider';
Slider.contextType = _Context.default;
Slider.defaultProps = {
  id: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  thump_title: null,
  add_title: '+',
  subtract_title: '−',
  min: 0,
  max: 100,
  value: -1,
  step: null,
  vertical: false,
  reverse: false,
  stretch: false,
  number_format: null,
  disabled: false,
  hide_buttons: false,
  use_scrollwheel: false,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  on_init: null,
  on_change: null,
  on_drag_start: null,
  on_drag_end: null,
  on_state_update: null
};
process.env.NODE_ENV !== "production" ? Slider.propTypes = _extends({
  id: _propTypes.default.string,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['horizontal', 'vertical']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  thump_title: _propTypes.default.string,
  add_title: _propTypes.default.string,
  subtract_title: _propTypes.default.string,
  min: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  max: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  step: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  vertical: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  reverse: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  stretch: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  number_format: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  hide_buttons: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  use_scrollwheel: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  on_init: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_drag_start: _propTypes.default.func,
  on_drag_end: _propTypes.default.func,
  on_state_update: _propTypes.default.func
}) : void 0;

var percentToValue = function percentToValue(percent, min, max) {
  return (max - min) * percent / 100 + min;
};

var roundToStep = function roundToStep(number, step) {
  return Math.round(number / step) * step;
};

var getOffset = function getOffset(node) {
  var _global = global,
      pageYOffset = _global.pageYOffset,
      pageXOffset = _global.pageXOffset;

  var _node$getBoundingClie = node.getBoundingClientRect(),
      left = _node$getBoundingClie.left,
      top = _node$getBoundingClie.top;

  return {
    top: top + pageYOffset,
    left: left + pageXOffset
  };
};

var getMousePosition = function getMousePosition(event) {
  if (event.changedTouches && event.changedTouches[0]) {
    return {
      x: event.changedTouches[0].pageX,
      y: event.changedTouches[0].pageY
    };
  }

  return {
    x: event.pageX,
    y: event.pageY
  };
};

var calculatePercent = function calculatePercent(node, event, isVertical, isReverted) {
  var _node$getBoundingClie2 = node.getBoundingClientRect(),
      width = _node$getBoundingClie2.width,
      height = _node$getBoundingClie2.height;

  var _getOffset = getOffset(node),
      top = _getOffset.top,
      left = _getOffset.left;

  var _getMousePosition = getMousePosition(event),
      x = _getMousePosition.x,
      y = _getMousePosition.y;

  var value = isVertical ? y - top : x - left;
  var onePercent = (isVertical ? height : width) / 100;
  return isReverted ? 100 - clamp(value / onePercent) : clamp(value / onePercent);
};

var clamp = function clamp(value) {
  var min = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var max = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 100;
  return Math.min(Math.max(value, min), max);
};

var createMockDiv = function createMockDiv(_ref3) {
  var width = _ref3.width,
      height = _ref3.height;
  var div = document.createElement('div');

  _extends(div.style, {
    width: "".concat(width, "px"),
    height: "".concat(height, "px")
  });

  div.getBoundingClientRect = function () {
    return {
      width: width,
      height: height,
      top: 0,
      left: 0,
      right: width,
      bottom: height
    };
  };

  return div;
};

function formatNumber(value) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  if (opts) {
    return (0, _Number.format)(value, opts);
  }

  return value;
}