"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "spacingPropTypes", {
  enumerable: true,
  get: function get() {
    return _SpacingHelper.spacingPropTypes;
  }
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _SpacingHelper = require("./SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Space = function (_React$PureComponent) {
  _inherits(Space, _React$PureComponent);

  var _super = _createSuper(Space);

  function Space() {
    _classCallCheck(this, Space);

    return _super.apply(this, arguments);
  }

  _createClass(Space, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = this.context.space ? (0, _componentHelper.extendPropsWithContext)(this.props, Space.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.space) : this.props;

      var element = props.element,
          inline = props.inline,
          no_collapse = props.no_collapse,
          top = props.top,
          right = props.right,
          bottom = props.bottom,
          left = props.left,
          space = props.space,
          skeleton = props.skeleton,
          _id = props.id,
          className = props.className,
          _className = props.class,
          attributes = _objectWithoutProperties(props, ["element", "inline", "no_collapse", "top", "right", "bottom", "left", "space", "skeleton", "id", "className", "class"]);

      var children = Space.getContent(this.props);

      var params = _extends({
        className: (0, _classnames.default)('dnb-space', (0, _SkeletonHelper.createSkeletonClass)(null, skeleton), (0, _SpacingHelper.createSpacingClasses)({
          top: top,
          right: right,
          bottom: bottom,
          left: left,
          space: space
        }), className, _className, (0, _componentHelper.isTrue)(inline) && 'dnb-space--inline')
      }, attributes);

      (0, _SkeletonHelper.skeletonDOMAttributes)(params, skeleton);
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement(Element, _extends({
        element: element,
        no_collapse: no_collapse
      }, params), children);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Space.tagName, Space, Space.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return Space;
}(_react.default.PureComponent);

exports.default = Space;
Space.tagName = 'dnb-space';
Space.contextType = _Context.default;
Space.defaultProps = _extends({
  id: null,
  element: 'div',
  inline: null,
  no_collapse: null
}, _SpacingHelper.spacingDefaultProps, {
  skeleton: null,
  class: null,
  className: null,
  children: null
});
process.env.NODE_ENV !== "production" ? Space.propTypes = _extends({
  id: _propTypes.default.string,
  element: _propTypes.default.string,
  inline: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_collapse: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node])
}) : void 0;

var Element = function Element(_ref) {
  var E = _ref.element,
      no_collapse = _ref.no_collapse,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ["element", "no_collapse", "children"]);

  if ((0, _componentHelper.isTrue)(no_collapse)) {
    var R = E === 'span' || (0, _SpacingHelper.isInline)(Element) ? 'span' : 'div';
    return _react.default.createElement(R, {
      className: 'dnb-space--no-collapse' + ((0, _SpacingHelper.isInline)(Element) ? " dnb-space--inline" : "")
    }, _react.default.createElement(E, props, children));
  }

  return _react.default.createElement(E, props, children);
};

process.env.NODE_ENV !== "production" ? Element.propTypes = {
  children: _propTypes.default.node,
  element: _propTypes.default.string,
  no_collapse: _propTypes.default.bool
} : void 0;
Element.defaultProps = {
  children: null,
  element: 'div',
  no_collapse: true
};