"use strict";

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.find.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.array.reverse.js");

require("core-js/modules/es.object.entries.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isInline = exports.createStyleObject = exports.createSpacingClasses = exports.removeSpaceProps = exports.isValidSpaceProp = exports.findNearestTypes = exports.findType = exports.createTypeModifyers = exports.sumTypes = exports.splitTypes = exports.translateSpace = exports.spacePatterns = exports.spacingDefaultProps = exports.spacingPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _componentHelper = require("../../shared/component-helper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var spacingPropTypes = {
  space: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool, _propTypes.default.shape({
    top: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool]),
    right: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool]),
    bottom: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool]),
    left: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool])
  })]),
  top: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool]),
  right: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool]),
  bottom: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool]),
  left: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool])
};
exports.spacingPropTypes = spacingPropTypes;
var spacingDefaultProps = {
  space: null,
  top: null,
  right: null,
  bottom: null,
  left: null
};
exports.spacingDefaultProps = spacingDefaultProps;
var spacePatterns = {
  'xx-small': 0.25,
  'x-small': 0.5,
  small: 1,
  medium: 1.5,
  large: 2,
  'x-large': 3,
  'xx-large': 3.5,
  'xx-large-x2': 7
};
exports.spacePatterns = spacePatterns;

var translateSpace = function translateSpace(type) {
  if (/-x2$/.test(type)) {
    return spacePatterns[type.replace(/-x2$/, '')] * 2;
  }

  return spacePatterns[type] || 0;
};

exports.translateSpace = translateSpace;

var splitTypes = function splitTypes(types) {
  if (typeof types === 'string') {
    types = types.split(/ /g);
  } else if (typeof types === 'boolean') {
    return ['small'];
  } else if (typeof types === 'number') {
    return [types];
  }

  return types ? types.filter(function (r) {
    return r && r.length > 0;
  }) : null;
};

exports.splitTypes = splitTypes;

var sumTypes = function sumTypes(types) {
  return splitTypes(types).map(function (type) {
    return translateSpace(type);
  }).reduce(function (acc, cur) {
    if (cur > 0) {
      acc += cur;
    } else if (cur < 0) {
      acc -= cur;
    }

    return acc;
  }, 0);
};

exports.sumTypes = sumTypes;

var createTypeModifyers = function createTypeModifyers(types) {
  if (typeof types === 'number') {
    types = String(types);
  }

  return (splitTypes(types) || []).reduce(function (acc, type) {
    if (type) {
      var firstLetter = type[0];

      if (parseFloat(firstLetter) > -1) {
        var num = parseFloat(type);

        if (num >= 8 && /[0-9]px/.test(type)) {
          num = num / 16;
        }

        var foundType = findType(num);

        if (foundType) {
          type = foundType;
        } else {
          findNearestTypes(num).forEach(function (type) {
            if (type) {
              acc.push(type);
            }
          });
        }
      }

      if (!(parseFloat(type) > 0)) {
        acc.push(type);
      }
    }

    return acc;
  }, []);
};

exports.createTypeModifyers = createTypeModifyers;

var findType = function findType(num) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$returnObject = _ref.returnObject,
      returnObject = _ref$returnObject === void 0 ? false : _ref$returnObject;

  var found = Object.entries(spacePatterns).find(function (_ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
        k = _ref3[0],
        v = _ref3[1];

    return k && v === num;
  }) || null;

  if (returnObject) {
    return found;
  }

  if (found) {
    return found[0];
  }

  return found;
};

exports.findType = findType;

var findNearestTypes = function findNearestTypes(num) {
  var res = [];
  var near = Object.entries(spacePatterns).reverse().find(function (_ref4) {
    var _ref5 = _slicedToArray(_ref4, 2),
        k = _ref5[0],
        v = _ref5[1];

    return k && num >= v;
  });
  var nearNum = near && near[1] || num;
  var typeObject = findType(nearNum, {
    returnObject: true
  });

  if (typeObject) {
    var nearType = typeObject[0];
    res.push(nearType);
    var leftOver = num - parseFloat(typeObject[1]);
    var foundMoreTypes = findNearestTypes(leftOver);
    foundMoreTypes.forEach(function (type) {
      var index = res.indexOf(type);

      if (index !== -1) {
        res[index] = "".concat(type, "-x2");
      }
    });
    res = [].concat(_toConsumableArray(res), _toConsumableArray(foundMoreTypes));
  }

  return res;
};

exports.findNearestTypes = findNearestTypes;

var isValidSpaceProp = function isValidSpaceProp(prop) {
  return prop && ['top', 'right', 'bottom', 'left'].includes(prop);
};

exports.isValidSpaceProp = isValidSpaceProp;

var removeSpaceProps = function removeSpaceProps(_ref6) {
  var props = _extends({}, _ref6);

  for (var i in props) {
    if (isValidSpaceProp(i)) {
      delete props[i];
    }
  }

  return props;
};

exports.removeSpaceProps = removeSpaceProps;

var createSpacingClasses = function createSpacingClasses(props) {
  var Element = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  if (typeof props.space !== 'undefined') {
    if (typeof props.space === 'string' || typeof props.space === 'number' || typeof props.space === 'boolean' && props.space) {
      props.top = props.right = props.bottom = props.left = props.space;
    }

    for (var i in props.space) {
      if (!props[i] && isValidSpaceProp(i)) {
        props[i] = props.space[i];
      }

      delete props.space;
    }
  }

  return Object.entries(props).reduce(function (acc, _ref7) {
    var _ref8 = _slicedToArray(_ref7, 2),
        direction = _ref8[0],
        cur = _ref8[1];

    if (isValidSpaceProp(direction)) {
      if (String(cur) === '0' || String(cur) === 'false') {
        acc.push("dnb-space__".concat(direction, "--zero"));
      } else if (cur) {
        var typeModifyers = createTypeModifyers(cur);
        var sum = sumTypes(typeModifyers);

        if (sum > 10) {
          (0, _componentHelper.warn)("Spacing of more than 10rem is not supported! You used ".concat(sum, " / (").concat(typeModifyers.join(','), ")"));
        } else {
          var nearestTypes = findNearestTypes(sum);
          acc = [].concat(_toConsumableArray(acc), _toConsumableArray(nearestTypes.map(function (type) {
            return "dnb-space__".concat(direction, "--").concat(type);
          })));
        }
      }
    } else if (direction === 'no_collapse') {
      acc.push('dnb-space--no-collapse');

      if (Element && isInline(Element)) {
        acc.push('dnb-space--inline');
      }
    }

    return acc;
  }, []);
};

exports.createSpacingClasses = createSpacingClasses;

var createStyleObject = function createStyleObject(props) {
  if (props.top && !(parseFloat(props.top) > 0)) {
    props.top = sumTypes(props.top);
  }

  if (props.bottom && !(parseFloat(props.bottom) > 0)) {
    props.bottom = sumTypes(props.bottom);
  }

  if (props.left && !(parseFloat(props.left) > 0)) {
    props.left = sumTypes(props.left);
  }

  if (props.right && !(parseFloat(props.right) > 0)) {
    props.right = sumTypes(props.right);
  }

  return Object.entries({
    marginTop: props.top && "".concat(props.top, "rem"),
    marginBottom: props.bottom && "".concat(props.bottom, "rem"),
    maxWidth: props.maxWidth && "".concat(props.maxWidth, "rem"),
    maxHeight: props.maxHeight && "".concat(props.maxHeight, "rem"),
    width: props.width && "".concat(props.width, "rem"),
    height: props.height && "".concat(props.height, "rem")
  }).reduce(function (acc, _ref9) {
    var _ref10 = _slicedToArray(_ref9, 2),
        key = _ref10[0],
        val = _ref10[1];

    if (typeof val !== 'undefined') {
      acc[key] = val;
    }

    return acc;
  }, {});
};

exports.createStyleObject = createStyleObject;

var isInline = function isInline(Element) {
  var inline = false;

  switch (Element) {
    case 'h1':
    case 'h2':
    case 'h3':
    case 'h4':
    case 'h5':
    case 'h6':
    case 'p':
      inline = true;
      break;
  }

  return inline;
};

exports.isInline = isInline;