"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.string.includes.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _StepIndicatorItem = _interopRequireDefault(require("./StepIndicatorItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var StepIndicator = function (_React$PureComponent) {
  _inherits(StepIndicator, _React$PureComponent);

  var _super = _createSuper(StepIndicator);

  function StepIndicator(props) {
    var _this;

    _classCallCheck(this, StepIndicator);

    _this = _super.call(this, props);

    _this.setActimeItem = function (activeItem) {
      _this.setState({
        activeItem: activeItem,
        _listenForPropChanges: false
      });
    };

    _this.state = {
      hasReached: [],
      _listenForPropChanges: true
    };
    var sn = 'show_numbers';

    if (typeof props[sn] !== 'undefined') {
      (0, _componentHelper.warn)('StepIndicator: "show_numbers" is deprecated. Use "hide_numbers" instead.');
    }

    return _this;
  }

  _createClass(StepIndicator, [{
    key: "render",
    value: function render() {
      var _this$context,
          _this2 = this;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, StepIndicator.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).StepIndicator, this.context.FormRow, this.context.StepIndicator);

      var active_item = props.active_item,
          active_url = props.active_url,
          hide_numbers = props.hide_numbers,
          use_navigation = props.use_navigation,
          on_item_render = props.on_item_render,
          step_title = props.step_title,
          on_change = props.on_change,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _data = props.data,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["active_item", "active_url", "hide_numbers", "use_navigation", "on_item_render", "step_title", "on_change", "skeleton", "className", "class", "data", "children"]);

      var data = StepIndicator.getData(this.props);
      var activeItem = this.state.activeItem;

      var params = _extends({
        'aria-label': 'progress',
        className: (0, _classnames.default)('dnb-step-indicator', (0, _SkeletonHelper.createSkeletonClass)('font', skeleton, this.context), (0, _SpacingHelper.createSpacingClasses)(props), className, _className)
      }, attributes);

      (0, _SkeletonHelper.skeletonDOMAttributes)(params, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, params);

      if (!this.state.hasReached.includes(activeItem)) {
        this.state.hasReached.push(activeItem);
      }

      var countSteps = data.length;
      return _react.default.createElement("nav", params, countSteps > 0 && _react.default.createElement("ol", {
        className: "dnb-step-indicator__list"
      }, data.map(function (props, i) {
        if (typeof props === 'string') {
          props = {
            title: props
          };
        }

        var params = _extends({
          countSteps: countSteps,
          currentItem: i,
          activeItem: activeItem,
          hide_numbers: hide_numbers,
          use_navigation: use_navigation,
          on_item_render: on_item_render,
          step_title: step_title,
          on_change: on_change
        }, props);

        return _react.default.createElement(_StepIndicatorItem.default, _extends({
          key: i
        }, params, {
          setActimeItem: _this2.setActimeItem,
          hasReached: _this2.state.hasReached
        }));
      })));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(StepIndicator.tagName, StepIndicator, StepIndicator.defaultProps);
    }
  }, {
    key: "getData",
    value: function getData(props) {
      var res = [];
      if (props.data) res = props.data;else res = (0, _componentHelper.processChildren)(props);
      if (typeof res === 'string') return res[0] === '[' ? JSON.parse(res) : [];
      return res || [];
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.data) {
          if (state._data !== props.data) {
            state._data = props.data;
            state.data = StepIndicator.getData(props);
          }
        }

        if (state.activeItem !== props.active_item) {
          state.activeItem = parseFloat(props.active_item);
        }

        if (props.active_url && state.activeUrl !== props.active_url) {
          state.activeUrl = props.active_url;
        }

        if ((state.activeUrl || !(parseFloat(state.activeItem) > 0)) && state.data.length > 0) {
          state.activeItem = state.data.reduce(function (acc, _ref, i) {
            var url = _ref.url;
            return url && (url === state.activeItem || url === state.activeUrl) ? i : acc;
          }, parseFloat(props.active_item));

          if (!(state.activeItem > -1)) {
            state.activeItem = null;
          }
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return StepIndicator;
}(_react.default.PureComponent);

exports.default = StepIndicator;
StepIndicator.tagName = 'dnb-step-indicator';
StepIndicator.contextType = _Context.default;
StepIndicator.defaultProps = {
  data: [],
  step_title: '%step',
  active_item: null,
  active_url: null,
  hide_numbers: false,
  use_navigation: false,
  on_item_render: null,
  skeleton: false,
  class: null,
  className: null,
  children: null,
  on_change: null
};
process.env.NODE_ENV !== "production" ? StepIndicator.propTypes = _extends({
  data: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.arrayOf(_propTypes.default.string), _propTypes.default.arrayOf(_propTypes.default.shape({
    title: _propTypes.default.string.isRequired,
    url: _propTypes.default.string,
    is_active: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
    is_current: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
    url_future: _propTypes.default.string,
    url_passed: _propTypes.default.string,
    on_click: _propTypes.default.func,
    on_render: _propTypes.default.func
  }))]).isRequired,
  step_title: _propTypes.default.string,
  active_item: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  active_url: _propTypes.default.string,
  hide_numbers: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  use_navigation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  on_item_render: _propTypes.default.func,
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  on_change: _propTypes.default.func
}) : void 0;