"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref = _react.default.createElement(_AlignmentHelper.default, null);

var _ref2 = _react.default.createElement("span", {
  className: "dnb-switch__focus"
}, _react.default.createElement("span", {
  className: "dnb-switch__focus__inner"
}));

var Switch = function (_React$PureComponent) {
  _inherits(Switch, _React$PureComponent);

  var _super = _createSuper(Switch);

  function Switch(props) {
    var _this;

    _classCallCheck(this, Switch);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      switch ((0, _keycode.default)(event)) {
        case 'enter':
          _this.onChangeHandler(event);

          break;
      }
    };

    _this.onChangeHandler = function (event) {
      if ((0, _componentHelper.isTrue)(_this.props.readOnly)) {
        return event.preventDefault();
      }

      var checked = !_this.state.checked;

      _this.setState({
        checked: checked,
        _listenForPropChanges: false
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        checked: checked,
        event: event
      });

      if (_this.props.on_change_end) {
        clearTimeout(_this._onChangeEndId);

        if (event && event.persist) {
          event.persist();
        }

        _this._onChangeEndId = setTimeout(function () {
          return (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change_end', {
            checked: checked,
            event: event
          });
        }, 500);
      }

      if (_this._refInput.current) {
        _this._refInput.current.focus();
      }
    };

    _this._refInput = _react.default.createRef();
    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this.state = {
      _listenForPropChanges: true
    };
    _this.helperParams = {
      onMouseDown: function onMouseDown(e) {
        return e.preventDefault();
      }
    };
    return _this;
  }

  _createClass(Switch, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._onChangeEndId);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Switch.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Switch, this.context.FormRow, this.context.Switch);

      var value = props.value,
          size = props.size,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          label = props.label,
          label_position = props.label_position,
          label_sr_only = props.label_sr_only,
          title = props.title,
          disabled = props.disabled,
          readOnly = props.readOnly,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _id = props.id,
          _checked = props.checked,
          attributes = props.attributes,
          children = props.children,
          on_change = props.on_change,
          on_state_update = props.on_state_update,
          custom_method = props.custom_method,
          custom_element = props.custom_element,
          rest = _objectWithoutProperties(props, ["value", "size", "status", "status_state", "status_animation", "global_status_id", "suffix", "label", "label_position", "label_sr_only", "title", "disabled", "readOnly", "skeleton", "className", "class", "id", "checked", "attributes", "children", "on_change", "on_state_update", "custom_method", "custom_element"]);

      var checked = this.state.checked;
      var id = this._id;
      var showStatus = (0, _componentHelper.getStatusState)(status);
      var mainParams = {
        className: (0, _classnames.default)("dnb-switch dnb-switch--label-position-".concat(label_position || 'right', " dnb-form-component"), (0, _SkeletonHelper.createSkeletonClass)(null, skeleton), (0, _SpacingHelper.createSpacingClasses)(props), className, _className, size && "dnb-switch--".concat(size), status && "dnb-switch__status--".concat(status_state))
      };

      var inputParams = _extends({
        disabled: (0, _componentHelper.isTrue)(disabled),
        checked: checked
      }, rest);

      (0, _SkeletonHelper.skeletonDOMAttributes)(inputParams, skeleton, this.context);

      if (showStatus || suffix) {
        inputParams['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(inputParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (readOnly) {
        inputParams['aria-readonly'] = inputParams.readOnly = true;
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, inputParams);

      var labelComp = label && _react.default.createElement(_FormLabel.default, {
        id: id + '-label',
        for_id: id,
        text: label,
        disabled: disabled,
        skeleton: skeleton,
        sr_only: label_sr_only
      });

      return _react.default.createElement("span", mainParams, _react.default.createElement("span", {
        className: "dnb-switch__order"
      }, label_position === 'left' && labelComp, _react.default.createElement("span", {
        className: "dnb-switch__inner"
      }, _ref, showStatus && _react.default.createElement(_FormStatus.default, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        width_selector: id + ', ' + id + '-label',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), _react.default.createElement("span", {
        className: "dnb-switch__shell"
      }, (label_position === 'right' || !label_position) && labelComp, _react.default.createElement("span", {
        className: "dnb-switch__row"
      }, _react.default.createElement("input", _extends({
        id: id,
        name: id,
        type: "checkbox",
        role: "switch",
        title: title,
        "aria-checked": checked,
        className: "dnb-switch__input",
        value: checked ? value || '' : '',
        ref: this._refInput
      }, inputParams, {
        onChange: this.onChangeHandler,
        onKeyDown: this.onKeyDownHandler
      })), _react.default.createElement("span", _extends({
        draggable: true,
        "aria-hidden": true,
        className: "dnb-switch__background",
        onDragStart: this.onChangeHandler
      }, this.helperParams)), _react.default.createElement("span", {
        className: (0, _classnames.default)('dnb-switch__button', (0, _SkeletonHelper.createSkeletonClass)('shape', skeleton, this.context)),
        "aria-hidden": true
      }, _ref2)), suffix && _react.default.createElement(_Suffix.default, {
        className: "dnb-switch__suffix",
        id: id + '-suffix',
        context: props
      }, suffix)))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Switch.tagName, Switch, Switch.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.checked !== state._checked) {
          if (props.default_state !== null && typeof state.checked === 'undefined') {
            state.checked = Switch.parseChecked(props.default_state);
          } else {
            state.checked = Switch.parseChecked(props.checked);
          }
        }
      }

      state._listenForPropChanges = true;

      if (state.checked !== state.__checked) {
        (0, _componentHelper.dispatchCustomElementEvent)({
          props: props
        }, 'on_state_update', {
          checked: state.checked
        });
      }

      state._checked = props.checked;
      state.__checked = state.checked;
      return state;
    }
  }]);

  return Switch;
}(_react.default.PureComponent);

exports.default = Switch;
Switch.tagName = 'dnb-switch';
Switch.contextType = _Context.default;
Switch.defaultProps = {
  label: null,
  label_position: null,
  title: null,
  default_state: null,
  checked: null,
  disabled: null,
  id: null,
  size: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  value: null,
  attributes: null,
  readOnly: false,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_change_end: null,
  on_state_update: null
};

Switch.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

process.env.NODE_ENV !== "production" ? Switch.propTypes = _extends({
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_position: _propTypes.default.oneOf(['left', 'right']),
  title: _propTypes.default.string,
  default_state: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  checked: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  id: _propTypes.default.string,
  size: _propTypes.default.oneOf(['default', 'medium', 'large']),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  value: _propTypes.default.string,
  attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  readOnly: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_change_end: _propTypes.default.func,
  on_state_update: _propTypes.default.func
}) : void 0;