"use strict";

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.find-index.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.entries.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dummy = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _Button = _interopRequireDefault(require("../button/Button"));

var _whatInput = _interopRequireDefault(require("what-input"));

var _TabsCustomContent = _interopRequireDefault(require("./TabsCustomContent"));

var _TabsContentWrapper = _interopRequireDefault(require("./TabsContentWrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref7 = _react.default.createElement("span", null, "Tab content not found");

var Tabs = function (_React$PureComponent) {
  _inherits(Tabs, _React$PureComponent);

  var _super = _createSuper(Tabs);

  function Tabs(props) {
    var _this;

    _classCallCheck(this, Tabs);

    _this = _super.call(this, props);

    _this.init = function () {
      if (_this._isMounted) {
        _this.addScrollBehaviour();

        _this.scrollToLastPosition();

        _this.scrollToTab('selected');

        if (_this.getLastUsedTab() !== null) {
          _this.setState(null, _this.setFocusOnTab);
        }
      }
    };

    _this.onResizeHandler = function () {
      var hasScrollbar = _this._hasScrollbar = _this.hasScrollbar();

      if (hasScrollbar !== _this.state.hasScrollbar) {
        _this.setState({
          hasScrollbar: hasScrollbar
        });
      }

      if (_this._hasScrollbar) {
        try {
          if (Math.ceil(window.innerWidth / 16) <= 40 || _this.isAtEdge()) {
            if (!_this._tabsRef.current.style.marginLeft) {
              var style = window.getComputedStyle(_this._tabsRef.current);

              if (!(Math.abs(parseFloat(style.marginLeft)) > 0)) {
                var diff = window.innerWidth - _this._tabsRef.current.offsetWidth;
                var val = Math.round(diff / 16) / 2 * 16;
                _this._tabsRef.current.style.marginLeft = "-".concat(val, "px");
                _this._tabsRef.current.style.marginRight = "-".concat(val, "px");

                if (val < 32) {
                  val = 32;
                }

                _this._tablistRef.current.style.paddingLeft = "".concat(val, "px");
                _this._tablistRef.current.style.paddingRight = "".concat(val, "px");
              }
            }
          } else {
            _this._tabsRef.current.style.marginLeft = '';
            _this._tabsRef.current.style.marginRight = '';
            _this._tablistRef.current.style.paddingLeft = '';
            _this._tablistRef.current.style.paddingRight = '';
          }
        } catch (e) {}
      }

      _this.setState({
        atEdge: _this.isAtEdge()
      });

      if (hasScrollbar) {
        _this.scrollToTab('selected');
      }
    };

    _this.onTablistKeyDownHandler = function (e) {
      switch ((0, _keycode.default)(e)) {
        case 'up':
        case 'page up':
        case 'left':
          e.preventDefault();

          _this.focusPrevTab(e);

          break;

        case 'down':
        case 'page down':
        case 'right':
          e.preventDefault();

          _this.focusNextTab(e);

          break;

        case 'home':
          e.preventDefault();

          _this.focusFirstTab(e);

          break;

        case 'end':
          e.preventDefault();

          _this.focusLastTab(e);

          break;
      }
    };

    _this.focusFirstTab = function (e) {
      var key = _this.state.data[0].key;

      _this.focusTab(key, e, 'step');

      _this.scrollToTab('focus');
    };

    _this.focusLastTab = function (e) {
      var key = _this.state.data[_this.state.data.length - 1].key;

      _this.focusTab(key, e, 'step');

      _this.scrollToTab('focus');
    };

    _this.focusPrevTab = function (e) {
      _this.focusTab(-1, e, 'step');

      _this.scrollToTab('focus');
    };

    _this.focusNextTab = function (e) {
      _this.focusTab(+1, e, 'step');

      _this.scrollToTab('focus');
    };

    _this.openPrevTab = function (e) {
      _this.openTab(-1, e, 'step');

      _this.scrollToTab('selected');
    };

    _this.openNextTab = function (e) {
      _this.openTab(+1, e, 'step');

      _this.scrollToTab('selected');
    };

    _this.handleVerticalScroll = function () {
      if ((0, _componentHelper.isTrue)(_this.props.scroll) && _this._tablistRef.current && typeof _this._tablistRef.current.scrollIntoView === 'function') {
        _this._tablistRef.current.scrollIntoView({
          block: 'start',
          behavior: 'smooth'
        });
      }
    };

    _this.onClickHandler = function (event) {
      var selected_key;

      try {
        selected_key = function (elem) {
          return (0, _componentHelper.getPreviousSibling)('dnb-tabs__button', elem) || {
            dataset: {}
          };
        }(event.target).dataset.tabKey;
      } catch (e) {
        (0, _componentHelper.warn)('Tabs Error:', e);
      }

      if (selected_key) {
        var ret = (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_click', _this.getEventArgs({
          event: event,
          selected_key: selected_key
        }));

        if (ret !== false) {
          _this.openTab(selected_key, event);

          _this.scrollToTab('selected');
        }
      }
    };

    _this.getCurrentTitle = function () {
      var selected_key = _this.state.selected_key;

      var current = _this.state.data.filter(function (_ref) {
        var key = _ref.key;
        return key == selected_key;
      })[0];

      return current && current.title || null;
    };

    _this.focusTab = function (focus_key) {
      var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var mode = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      if (mode === 'step' && parseFloat(focus_key)) {
        focus_key = _this.getStepKey(focus_key, _this.state.focus_key);
      }

      _this.setState({
        focus_key: focus_key,
        _listenForPropChanges: false
      }, _this.setFocusOnTab);

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_focus', _this.getEventArgs({
        event: event,
        focus_key: focus_key
      }));

      _this.setWhatInput();
    };

    _this.setFocusOnTab = function () {
      try {
        var elem = _this._tablistRef.current.querySelector('.dnb-tabs__button.focus');

        elem.focus();

        if (!document.getElementById("".concat(_this._id, "-content")) && process.env.NODE_ENV !== 'test') {
          (0, _componentHelper.warn)("Could not find the required <Tabs.Content id=\"".concat(_this._id, "-content\" ... /> that provides role=\"tabpanel\""));
        }
      } catch (e) {
        (0, _componentHelper.warn)(e);
      }
    };

    _this.openTab = function (selected_key) {
      var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var mode = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      _this.saveLastPosition();

      _this.saveLastUsedTab();

      _this.resetWhatInput();

      if (mode === 'step' && parseFloat(selected_key)) {
        selected_key = _this.getStepKey(selected_key, _this.state.selected_key);
      }

      if (typeof selected_key !== 'undefined') {
        _this.setState({
          selected_key: selected_key,
          focus_key: selected_key,
          _listenForPropChanges: false
        }, _this.handleVerticalScroll);
      }

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', _this.getEventArgs({
        event: event,
        selected_key: selected_key
      }));

      if (_this.props.use_hash && typeof window !== 'undefined') {
        try {
          window.history.replaceState(undefined, undefined, "#".concat(selected_key));
        } catch (e) {
          (0, _componentHelper.warn)('Tabs Error:', e);
        }
      }
    };

    _this.getContent = function (selected_key) {
      var _this$props = _this.props,
          children = _this$props.children,
          _content = _this$props.content;
      var contentToRender = children || _content;
      var content = null;

      if (contentToRender) {
        if (_typeof(contentToRender) === 'object' && contentToRender[selected_key]) {
          content = contentToRender[selected_key];
        } else if (typeof contentToRender === 'function') {
          content = contentToRender.apply(_assertThisInitialized(_this), [selected_key]);
        } else if (_react.default.isValidElement(contentToRender)) {
          content = contentToRender;
        }
      }

      if (!content) {
        var items = [];

        if (Array.isArray(_this.state.data)) {
          items = _this.state.data;
        } else if (Array.isArray(contentToRender)) {
          items = contentToRender;
        }

        if (items) {
          content = items.filter(function (_ref2) {
            var key = _ref2.key;
            return key && selected_key && key == selected_key;
          }).reduce(function (acc, _ref3) {
            var content = _ref3.content;
            return content || acc;
          }, null);
        }
      }

      if (typeof content === 'function') {
        var Component = content;
        content = _react.default.createElement(Component, null);
      }

      return content;
    };

    _this.TabsWrapperHandler = function (_ref4) {
      var children = _ref4.children,
          rest = _objectWithoutProperties(_ref4, ["children"]);

      var _this$props2 = _this.props,
          className = _this$props2.className,
          _className = _this$props2.class;

      var _filterProps = (0, _componentHelper.filterProps)(_this.props, Tabs.defaultProps),
          attributes = _extends({}, _filterProps);

      var params = _extends({}, attributes, {
        className: (0, _classnames.default)('dnb-tabs', (0, _SpacingHelper.createSpacingClasses)(_this.props), className, _className)
      });

      (0, _componentHelper.validateDOMAttributes)(_this.props, params);
      return _react.default.createElement("div", _extends({}, params, rest), children);
    };

    _this.TabsListHandler = function (_ref5) {
      var children = _ref5.children,
          className = _ref5.className;
      var _this$props3 = _this.props,
          align = _this$props3.align,
          section_style = _this$props3.section_style,
          section_spacing = _this$props3.section_spacing;
      var _this$state = _this.state,
          hasScrollbar = _this$state.hasScrollbar,
          atEdge = _this$state.atEdge;
      return _react.default.createElement("div", {
        className: (0, _classnames.default)('dnb-tabs__tabs', className, align && "dnb-tabs__tabs--".concat(align), section_style && "dnb-section dnb-section--".concat(section_style), section_spacing && "dnb-section--spacing-".concat((0, _componentHelper.isTrue)(section_spacing) ? 'default' : section_spacing), hasScrollbar && 'dnb-tabs--has-scrollbar', atEdge && 'dnb-tabs--at-edge'),
        ref: _this._tabsRef
      }, _react.default.createElement(ScrollNavButton, {
        onMouseDown: _this.openPrevTab,
        icon: "chevron_left",
        className: (0, _classnames.default)(hasScrollbar && 'dnb-tabs__scroll-nav-button--visible', _this.state.isFirst && 'dnb-tabs__scroll-nav-button--hide')
      }), children, _react.default.createElement(ScrollNavButton, {
        onMouseDown: _this.openNextTab,
        icon: "chevron_right",
        className: (0, _classnames.default)(hasScrollbar && 'dnb-tabs__scroll-nav-button--visible', _this.state.isLast && 'dnb-tabs__scroll-nav-button--hide')
      }));
    };

    _this.TabContentHandler = function () {
      var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref6$showEmptyMessag = _ref6.showEmptyMessage,
          showEmptyMessage = _ref6$showEmptyMessag === void 0 ? false : _ref6$showEmptyMessag;

      var selected_key = _this.state.selected_key;

      var content = _this.renderContent();

      return _react.default.createElement(_TabsContentWrapper.default, {
        id: _this._id,
        selected_key: selected_key
      }, content || showEmptyMessage && _ref7);
    };

    _this.TabsHandler = function () {
      var _this$_props = _this._props,
          label = _this$_props.label,
          skeleton = _this$_props.skeleton;
      var selected_key = _this.state.selected_key;

      var tabs = _this.state.data.map(function (_ref8) {
        var title = _ref8.title,
            key = _ref8.key,
            _ref8$disabled = _ref8.disabled,
            disabled = _ref8$disabled === void 0 ? false : _ref8$disabled;
        var itemParams = {};

        var isFocus = _this.isFocus(key);

        var isSelected = _this.isSelected(key);

        if (isSelected) {
          itemParams['aria-controls'] = "".concat(_this._id, "-content");
        }

        if ((0, _componentHelper.isTrue)(disabled)) {
          itemParams.disabled = true;
          itemParams['aria-disabled'] = true;
        }

        (0, _SkeletonHelper.skeletonDOMAttributes)(itemParams, skeleton, _this.context);
        return _react.default.createElement("div", {
          className: (0, _classnames.default)('dnb-tabs__button__snap', isFocus && 'focus', isSelected && 'selected'),
          key: "tab-".concat(key)
        }, _react.default.createElement("button", _extends({
          type: "button",
          role: "tab",
          tabIndex: "-1",
          id: "".concat(_this._id, "-tab-").concat(key),
          "aria-selected": isSelected,
          className: (0, _classnames.default)('dnb-tabs__button', isFocus && 'focus', isSelected && 'selected'),
          onClick: _this.onClickHandler,
          "data-tab-key": key
        }, itemParams), _react.default.createElement("span", {
          className: (0, _classnames.default)('dnb-tabs__button__title', (0, _SkeletonHelper.createSkeletonClass)('font', skeleton, _this.context))
        }, title), _react.default.createElement(Dummy, null, title)));
      });

      var params = {};

      if (label) {
        params['aria-label'] = label;
      }

      if (selected_key) {
        params['aria-labelledby'] = "".concat(_this._id, "-tab-").concat(selected_key);
      }

      return _react.default.createElement("div", _extends({
        role: "tablist",
        className: "dnb-tabs__tabs__tablist",
        tabIndex: "0",
        onKeyDown: _this.onTablistKeyDownHandler,
        ref: _this._tablistRef
      }, params), tabs);
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    var data = Tabs.getData(props);

    var _selected_key = Tabs.getSelectedKeyOrFallback(props.selected_key, data);

    if (props.use_hash && typeof window !== 'undefined') {
      try {
        var useHashKey = String(window.location.hash).replace('#', '');

        if (useHashKey && String(useHashKey).length > 0) {
          _selected_key = Tabs.getSelectedKeyOrFallback(useHashKey, data);
        }
      } catch (e) {}
    }

    var lastPosition = _this.getLastPosition();

    _this.state = {
      data: data,
      lastPosition: lastPosition,
      selected_key: _selected_key,
      focus_key: _selected_key,
      atEdge: false,
      hasScrollbar: lastPosition > -1,
      _selected_key: _selected_key,
      _data: props.data || props.children,
      _listenForPropChanges: true
    };
    _this._tabsRef = _react.default.createRef();
    _this._tablistRef = _react.default.createRef();
    return _this;
  }

  _createClass(Tabs, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;

      if (document.readyState === 'complete') {
        this.init();
      } else if (typeof window !== 'undefined') {
        window.addEventListener('load', this.init);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
      this.resetWhatInput();
      clearTimeout(this._scrollToTabTimeout);

      if (typeof window !== 'undefined') {
        window.removeEventListener('resize', this.onResizeHandler);
        window.removeEventListener('load', this.init);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.onResizeHandler();
    }
  }, {
    key: "getLastPosition",
    value: function getLastPosition() {
      if (typeof window !== 'undefined') {
        try {
          var pos = parseFloat(window.localStorage.getItem('tmp-tabs-pos')) || -1;
          window.localStorage.removeItem('tmp-tabs-pos');
          return pos;
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }

      return -1;
    }
  }, {
    key: "getLastUsedTab",
    value: function getLastUsedTab() {
      if (typeof window !== 'undefined') {
        try {
          var key = window.localStorage.getItem('tmp-tabs-last') || null;
          window.localStorage.removeItem('tmp-tabs-last');
          return key;
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }

      return -1;
    }
  }, {
    key: "saveLastUsedTab",
    value: function saveLastUsedTab() {
      if (typeof window !== 'undefined') {
        try {
          window.localStorage.setItem('tmp-tabs-last', this.state.selected_key);
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }
    }
  }, {
    key: "saveLastPosition",
    value: function saveLastPosition() {
      var pos = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this._tablistRef.current.scrollLeft;

      if (typeof window !== 'undefined') {
        try {
          window.localStorage.setItem('tmp-tabs-pos', pos);
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }
    }
  }, {
    key: "hasScrollbar",
    value: function hasScrollbar() {
      return this._tablistRef.current.scrollWidth - 1 > this._tablistRef.current.offsetWidth;
    }
  }, {
    key: "isAtEdge",
    value: function isAtEdge() {
      if (!this._hasScrollbar || typeof window === 'undefined') {
        return false;
      }

      try {
        var padding = parseFloat(window.getComputedStyle(this._tablistRef.current).paddingLeft);
        var width = this._tablistRef.current.offsetWidth + 2 + 64 - padding;
        var screenWidth = window.innerWidth;
        return width >= screenWidth;
      } catch (e) {}

      return false;
    }
  }, {
    key: "addScrollBehaviour",
    value: function addScrollBehaviour() {
      this.onResizeHandler();

      if (typeof window !== 'undefined') {
        window.addEventListener('resize', this.onResizeHandler);
      }
    }
  }, {
    key: "scrollToLastPosition",
    value: function scrollToLastPosition() {
      try {
        this._tablistRef.current.style.scrollBehavior = 'auto';
        this._tablistRef.current.scrollLeft = this.state.lastPosition;
        this._tablistRef.current.style.scrollBehavior = 'smooth';
      } catch (e) {}
    }
  }, {
    key: "scrollToTab",
    value: function scrollToTab(type) {
      var _this2 = this;

      if (typeof window === 'undefined') {
        return;
      }

      clearTimeout(this._scrollToTabTimeout);
      this._scrollToTabTimeout = setTimeout(function () {
        try {
          if ((_this2._hasScrollbar || _this2.state.hasScrollbar) && _this2._tablistRef.current) {
            var first = _this2._tablistRef.current.querySelector('.dnb-tabs__button__snap:first-of-type');

            var isFirst = first.classList.contains(type);

            var last = _this2._tablistRef.current.querySelector('.dnb-tabs__button__snap:last-of-type');

            var isLast = last.classList.contains(type);

            var elem = _this2._tablistRef.current.querySelector(".dnb-tabs__button.".concat(type));

            var style = window.getComputedStyle(_this2._tabsRef.current);
            var margin = parseFloat(style.marginLeft);
            var padding = margin < 0 ? parseFloat(style.paddingLeft) : 0;

            if (!isFirst && _this2.state.atEdge && parseFloat(style.paddingLeft) < 16) {
              var navButton = _this2._tabsRef.current.querySelector('.dnb-tabs__scroll-nav-button:first-of-type');

              padding = parseFloat(window.getComputedStyle(navButton).width);
            }

            var leftPadding = (margin < 0 ? Math.abs(margin) : 0) + padding + parseFloat(window.getComputedStyle(first).paddingLeft);
            var left = elem && !isFirst ? elem.offsetLeft - leftPadding : 0;

            _this2._tablistRef.current.scrollTo({
              left: left,
              behavior: window.IS_TEST ? 'auto' : 'smooth'
            });

            _this2.setState({
              isFirst: isFirst,
              isLast: isLast
            });
          }
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }, window.IS_TEST ? 0 : 100);
    }
  }, {
    key: "getStepKey",
    value: function getStepKey(useKey, stateKey) {
      var currentData = this.state.data.filter(function (_ref9) {
        var disabled = _ref9.disabled;
        return !disabled;
      });
      var currentIndex = currentData.reduce(function (acc, _ref10, i) {
        var key = _ref10.key;
        return key == stateKey ? i : acc;
      }, -1);
      var nextIndex = currentIndex + useKey;

      if (nextIndex < 0) {
        nextIndex = currentData.length - 1;
      }

      if (nextIndex >= currentData.length) {
        nextIndex = 0;
      }

      return currentData.reduce(function (acc, _ref11, i) {
        var key = _ref11.key;
        return i === nextIndex ? key : acc;
      }, null);
    }
  }, {
    key: "setWhatInput",
    value: function setWhatInput() {
      _whatInput.default.specificKeys([9, 37, 39, 33, 34, 35, 36]);
    }
  }, {
    key: "resetWhatInput",
    value: function resetWhatInput() {
      _whatInput.default.specificKeys([9]);
    }
  }, {
    key: "getEventArgs",
    value: function getEventArgs(args) {
      var _this$state2 = this.state,
          selected_key = _this$state2.selected_key,
          focus_key = _this$state2.focus_key;
      return _extends({
        key: typeof args.selected_key !== 'undefined' ? args.selected_key : selected_key,
        selected_key: selected_key,
        focus_key: focus_key
      }, args);
    }
  }, {
    key: "isFocus",
    value: function isFocus(tabKey) {
      return this.state.focus_key == tabKey;
    }
  }, {
    key: "isSelected",
    value: function isSelected(tabKey) {
      return this.state.selected_key == tabKey;
    }
  }, {
    key: "renderCachedContent",
    value: function renderCachedContent() {
      var _this3 = this;

      var _this$state3 = this.state,
          selected_key = _this$state3.selected_key,
          data = _this$state3.data;
      var _this$props4 = this.props,
          prevent_rerender = _this$props4.prevent_rerender,
          prerender = _this$props4.prerender;

      if ((0, _componentHelper.isTrue)(prerender)) {
        this._cache = Object.entries(data).reduce(function (acc, _ref12) {
          var _ref13 = _slicedToArray(_ref12, 2),
              idx = _ref13[0],
              cur = _ref13[1];

          acc[cur.key] = _extends({}, cur, {
            content: _this3.getContent(cur.key)
          });
          return acc;
        }, {});
      } else if ((0, _componentHelper.isTrue)(prevent_rerender)) {
        this._cache = _extends({}, this._cache || {}, _defineProperty({}, selected_key, {
          content: this.getContent(selected_key)
        }));
      }

      var cachedContent = Object.entries(this._cache).map(function (_ref14) {
        var _ref15 = _slicedToArray(_ref14, 2),
            key = _ref15[0],
            content = _ref15[1].content;

        var params = {};

        if (key !== String(selected_key)) {
          params.hidden = true;
          params['aria-hidden'] = true;
        }

        return _react.default.createElement("div", _extends({
          key: key,
          className: "dnb-tabs__cached"
        }, params), content);
      });
      return cachedContent;
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _this$props5 = this.props,
          prevent_rerender = _this$props5.prevent_rerender,
          prerender = _this$props5.prerender;

      if ((0, _componentHelper.isTrue)(prevent_rerender) || (0, _componentHelper.isTrue)(prerender)) {
        return this.renderCachedContent();
      }

      return this.getContent(this.state.selected_key);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = this._props = (0, _componentHelper.extendPropsWithContext)(this.props, Tabs.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      });
      var customRenderer = props.render;
      var TabItems = this.TabsHandler;
      TabItems.displayName = 'Tabs';
      var TabsList = this.TabsListHandler;
      TabsList.displayName = 'TabsList';
      var Wrapper = this.TabsWrapperHandler;
      Wrapper.displayName = 'TabsWrapper';
      var Content = this.TabContentHandler;
      Content.displayName = 'TabContent';

      if (typeof customRenderer === 'function') {
        return customRenderer({
          Wrapper: Wrapper,
          Content: Content,
          TabsList: TabsList,
          Tabs: TabItems
        });
      }

      return _react.default.createElement(Wrapper, null, _react.default.createElement(TabsList, null, _react.default.createElement(TabItems, null)), _react.default.createElement(Content, {
        showEmptyMessage: true
      }));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Tabs.tagName, Tabs, Tabs.defaultProps);
    }
  }, {
    key: "getSelectedKeyOrFallback",
    value: function getSelectedKeyOrFallback(selected_key, data) {
      var useKey = selected_key;

      if (!useKey) {
        useKey = data.reduce(function (acc, _ref16) {
          var selected = _ref16.selected,
              key = _ref16.key;
          return selected ? key : acc;
        }, null) || data[0] && data[0].key;
      } else {
        var keyExists = data.findIndex(function (_ref17) {
          var key = _ref17.key;
          return key == selected_key;
        });

        if (keyExists === -1) {
          useKey = data[0] && data[0].key;
        }
      }

      return useKey;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.data) {
          if (state._data !== props.data) {
            state._data = props.data;
            state.data = Tabs.getData(props);
          }
        } else if (props.children) {
          if (state._data !== props.children) {
            state._data = props.children;
            state.data = Tabs.getData(props);
          }
        }

        if (props.selected_key && state._selected_key !== props.selected_key) {
          state.selected_key = state._selected_key = Tabs.getSelectedKeyOrFallback(props.selected_key, state.data);
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }, {
    key: "getData",
    value: function getData(props) {
      var res = [];
      var data = !props.data && props.children ? props.children : props.data;

      if (Array.isArray(props.children) && (typeof props.children[0] === 'function' || _react.default.isValidElement(props.children[0]))) {
        res = props.children.reduce(function (acc, content, i) {
          if (content.props && content.props.displayName === 'CustomContent') {
              var dataProps = props.tabs && Array.isArray(props.tabs) && props.tabs[i] || {};

              var componentProps = _extends({}, content.props);

              if (componentProps.title === null) {
                delete componentProps.title;
              }

              var _dataProps$componentP = _extends({}, dataProps, componentProps, {
                children: null
              }),
                  title = _dataProps$componentP.title,
                  _key = _dataProps$componentP.key,
                  hash = _dataProps$componentP.hash,
                  rest = _objectWithoutProperties(_dataProps$componentP, ["title", "key", "hash"]);

              acc.push(_extends({
                title: title,
                key: (!_key && hash ? hash : _key) || (0, _componentHelper.slugify)(title),
                content: content
              }, rest));
            }

          return acc;
        }, []);
      }

      if (!(res && res.length > 0)) {
        if (props.data && Array.isArray(data)) {
          res = data;
        } else if (typeof data === 'string') {
          res = data[0] === '[' ? JSON.parse(data) : [];
        } else if (data && _typeof(data) === 'object') {
          res = Object.entries(data).reduce(function (acc, _ref18) {
            var _ref19 = _slicedToArray(_ref18, 2),
                key = _ref19[0],
                obj = _ref19[1];

            if (obj) {
              acc.push(_extends({
                key: key
              }, obj));
            }

            return acc;
          }, []);
        }
      }

      return res || [];
    }
  }]);

  return Tabs;
}(_react.default.PureComponent);

exports.default = Tabs;
Tabs.tagName = 'dnb-tabs';
Tabs.contextType = _Context.default;
Tabs.defaultProps = {
  data: null,
  content: null,
  label: null,
  selected_key: null,
  align: 'left',
  section_style: null,
  section_spacing: null,
  use_hash: false,
  prerender: false,
  prevent_rerender: false,
  scroll: null,
  skeleton: null,
  id: null,
  class: null,
  className: null,
  children: null,
  render: null,
  on_change: null,
  on_click: null,
  on_focus: null
};
Tabs.Content = _TabsCustomContent.default;
Tabs.ContentWrapper = _TabsContentWrapper.default;
process.env.NODE_ENV !== "production" ? Tabs.propTypes = _extends({
  data: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.arrayOf(_propTypes.default.shape({
    title: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]).isRequired,
    key: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]).isRequired,
    selected: _propTypes.default.bool,
    disabled: _propTypes.default.bool
  })), _propTypes.default.objectOf(_propTypes.default.shape({
    title: _propTypes.default.string.isRequired,
    selected: _propTypes.default.bool,
    disabled: _propTypes.default.bool
  }))]),
  content: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func]),
  label: _propTypes.default.string,
  selected_key: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  align: _propTypes.default.oneOf(['left', 'center', 'right']),
  section_style: _propTypes.default.string,
  section_spacing: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  use_hash: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prerender: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_rerender: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  scroll: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  id: _propTypes.default.string
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func]),
  render: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_click: _propTypes.default.func,
  on_focus: _propTypes.default.func
}) : void 0;

var Dummy = function Dummy(_ref20) {
  var children = _ref20.children;
  return _react.default.createElement("span", {
    "aria-hidden": true,
    hidden: true,
    className: "dnb-dummy"
  }, children);
};

exports.Dummy = Dummy;
process.env.NODE_ENV !== "production" ? Dummy.propTypes = {
  children: _propTypes.default.node.isRequired
} : void 0;

var ScrollNavButton = function ScrollNavButton(props) {
  return _react.default.createElement(_Button.default, _extends({
    size: "medium",
    variant: "primary",
    tabIndex: "-1",
    bounding: true,
    "aria-hidden": true,
    icon_size: "medium"
  }, props, {
    className: (0, _classnames.default)('dnb-tabs__scroll-nav-button', props.className)
  }));
};

process.env.NODE_ENV !== "production" ? ScrollNavButton.propTypes = {
  className: _propTypes.default.node.isRequired
} : void 0;