import * as React from 'react';
export type ContentWrapperSelectedKey = string | number;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ContentWrapperProps extends React.HTMLProps<HTMLElement> {
  id: string;

  /**
   * In case one of the tabs should be opened by a `key`.
   */
  selected_key?: ContentWrapperSelectedKey;

  /**
   * The content to render. Can be a function, returning the current tab content `(key) => (&#39;Current tab&#39;)`, a React Component or an object with the keys and content `{key1: &#39;Current tab&#39;}`.
   */
  children: React.ReactNode;
}
export default class ContentWrapper extends React.Component<
  ContentWrapperProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
