"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref = _react.default.createElement(_AlignmentHelper.default, null);

var Textarea = function (_React$PureComponent) {
  _inherits(Textarea, _React$PureComponent);

  var _super = _createSuper(Textarea);

  function Textarea(props) {
    var _this;

    _classCallCheck(this, Textarea);

    _this = _super.call(this, props);
    _this.state = {
      textareaState: 'virgin',
      value: null,
      _value: null
    };

    _this.onFocusHandler = function (event) {
      var value = _this._ref.current.value;

      _this.setState({
        value: value,
        _listenForPropChanges: false,
        textareaState: 'focus'
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_focus', {
        value: value,
        event: event
      });
    };

    _this.onBlurHandler = function (event) {
      var value = event.target.value;

      _this.setState({
        value: value,
        _listenForPropChanges: false,
        textareaState: Textarea.hasValue(value) ? 'dirty' : 'initial'
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_blur', {
        value: value,
        event: event
      });
    };

    _this.onChangeHandler = function (event) {
      var value = event.target.value;

      var rows = _this.getRows(value);

      var ret = (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        value: value,
        rows: rows,
        event: event
      });

      if (ret !== false) {
        _this.setState({
          value: value,
          _listenForPropChanges: false
        });

        if ((0, _componentHelper.isTrue)(_this.props.autoresize)) {
          _this.setAutosize(rows);
        }
      }
    };

    _this.onKeyDownHandler = function (event) {
      var rows = _this.getRows();

      var value = event.target.value;
      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_key_down', {
        value: value,
        rows: rows,
        event: event
      });
    };

    _this.setAutosize = function () {
      var rows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var elem = _this._ref.current;

      if (!elem) {
        return;
      }

      rows = typeof rows === 'number' ? rows : _this.getRows();

      try {
        if (typeof _this._heightOffset === 'undefined') {
          _this._heightOffset = elem.offsetHeight - elem.clientHeight;
        }

        elem.style.height = 'auto';
        var newHeight = elem.scrollHeight + _this._heightOffset;
        var maxRows = parseFloat(_this.props.autoresize_max_rows);

        if (maxRows > 0) {
          var maxHeight = maxRows * _this.getLineHeight();

          if (rows > maxRows || newHeight > maxHeight) {
            newHeight = maxHeight;
          }
        }

        elem.style.height = newHeight + 'px';
      } catch (e) {
        (0, _componentHelper.warn)(e);
      }
    };

    _this._ref = props.inner_ref || _react.default.createRef();
    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this.state._listenForPropChanges = true;

    if (props.textarea_state) {
      _this.state.textareaState = props.textarea_state;
    }

    _this.state._value = props.value;
    return _this;
  }

  _createClass(Textarea, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if ((0, _componentHelper.isTrue)(this.props.autoresize) && typeof window !== 'undefined') {
        this.setAutosize();
        window.addEventListener('resize', this.setAutosize);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if ((0, _componentHelper.isTrue)(this.props.autoresize) && typeof window !== 'undefined') {
        window.removeEventListener('resize', this.setAutosize);
      }
    }
  }, {
    key: "getRows",
    value: function getRows() {
      return Math.floor(this._ref.current.scrollHeight / this.getLineHeight()) || 1;
    }
  }, {
    key: "getLineHeight",
    value: function getLineHeight() {
      return parseFloat(getComputedStyle(this._ref.current).lineHeight) || 0;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Textarea.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Textarea, this.context.FormRow, this.context.Textarea);

      var label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          disabled = props.disabled,
          skeleton = props.skeleton,
          stretch = props.stretch,
          placeholder = props.placeholder,
          align = props.align,
          textarea_class = props.textarea_class,
          readOnly = props.readOnly,
          textarea_attributes = props.textarea_attributes,
          _className = props.class,
          className = props.className,
          autoresize = props.autoresize,
          autoresize_max_rows = props.autoresize_max_rows,
          _id = props.id,
          children = props.children,
          _value = props.value,
          _textarea_element = props.textarea_element,
          attributes = _objectWithoutProperties(props, ["label", "label_direction", "label_sr_only", "status", "status_state", "status_animation", "global_status_id", "suffix", "disabled", "skeleton", "stretch", "placeholder", "align", "textarea_class", "readOnly", "textarea_attributes", "class", "className", "autoresize", "autoresize_max_rows", "id", "children", "value", "textarea_element"]);

      var _this$state = this.state,
          value = _this$state.value,
          textareaState = _this$state.textareaState;
      var id = this._id;
      var showStatus = (0, _componentHelper.getStatusState)(status);
      var hasValue = Textarea.hasValue(value);
      var TextareaElement = props.textarea_element;
      var textareaAttributes = textarea_attributes ? typeof textarea_attributes === 'string' ? JSON.parse(textarea_attributes) : textarea_attributes : {};

      var textareaParams = _extends({
        className: (0, _classnames.default)('dnb-textarea__textarea', textarea_class),
        role: 'textbox',
        value: hasValue ? value : '',
        id: id,
        disabled: (0, _componentHelper.isTrue)(disabled) || (0, _componentHelper.isTrue)(skeleton),
        name: id,
        'aria-placeholder': placeholder
      }, attributes, textareaAttributes, {
        onChange: this.onChangeHandler,
        onFocus: this.onFocusHandler,
        onBlur: this.onBlurHandler,
        onKeyDown: this.onKeyDownHandler
      });

      if (showStatus || suffix) {
        textareaParams['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(textareaParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (readOnly) {
        textareaParams['aria-readonly'] = textareaParams.readOnly = true;
      }

      var mainParams = {
        className: (0, _classnames.default)("dnb-textarea dnb-textarea--".concat(textareaState, " dnb-form-component"), (0, _SkeletonHelper.createSkeletonClass)(null, skeleton), (0, _SpacingHelper.createSpacingClasses)(props), _className, className, hasValue && 'dnb-textarea--has-content', align && "dnb-textarea__align--".concat(align), status && "dnb-textarea__status--".concat(status_state), autoresize && 'dnb-textarea__autoresize', label_direction && "dnb-textarea--".concat(label_direction), (0, _componentHelper.isTrue)(stretch) && "dnb-textarea--stretch")
      };
      var innerParams = {
        className: (0, _classnames.default)('dnb-textarea__inner', (0, _SkeletonHelper.createSkeletonClass)('shape', skeleton, this.context))
      };
      var shellParams = {
        className: 'dnb-textarea__shell'
      };

      if ((0, _componentHelper.isTrue)(disabled) || (0, _componentHelper.isTrue)(skeleton)) {
        shellParams['aria-disabled'] = true;
      }

      var placeholderStyle = parseFloat(this.props.rows) > 0 ? {
        '--textarea-rows': parseFloat(this.props.rows)
      } : null;
      (0, _SkeletonHelper.skeletonDOMAttributes)(innerParams, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, textareaParams);
      (0, _componentHelper.validateDOMAttributes)(null, innerParams);
      (0, _componentHelper.validateDOMAttributes)(null, shellParams);

      if (TextareaElement && typeof TextareaElement === 'function') {
        TextareaElement = TextareaElement(textareaParams, this._ref);
      } else if (!TextareaElement && _textarea_element) {
        TextareaElement = _textarea_element;
      }

      return _react.default.createElement("span", mainParams, label && _react.default.createElement(_FormLabel.default, {
        id: id + '-label',
        for_id: id,
        text: label,
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton
      }), _react.default.createElement("span", innerParams, _ref, showStatus && _react.default.createElement(_FormStatus.default, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), _react.default.createElement("span", {
        className: "dnb-textarea__row"
      }, _react.default.createElement("span", shellParams, TextareaElement || _react.default.createElement("textarea", _extends({
        ref: this._ref
      }, textareaParams)), placeholder && _react.default.createElement("span", {
        "aria-hidden": true,
        className: 'dnb-textarea__placeholder' + (align ? " dnb-textarea__align--".concat(align) : ""),
        style: placeholderStyle
      }, placeholder)), suffix && _react.default.createElement(_Suffix.default, {
        className: "dnb-textarea__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Textarea.tagName, Textarea, Textarea.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = Textarea.getValue(props);

      if (state._listenForPropChanges && value !== 'initval' && value !== state.value) {
        if (value !== state.value && value !== state._value && typeof props.on_state_update === 'function') {
          (0, _componentHelper.dispatchCustomElementEvent)({
            props: props
          }, 'on_state_update', {
            value: value
          });
        }

        state.value = value;
      }

      if (props.textarea_state) {
        state.textareaState = props.textarea_state;
      }

      state._listenForPropChanges = true;
      return state;
    }
  }, {
    key: "hasValue",
    value: function hasValue(value) {
      return (typeof value === 'string' || typeof value === 'number') && String(value).length > 0 || false;
    }
  }, {
    key: "getValue",
    value: function getValue(props) {
      var value = (0, _componentHelper.processChildren)(props);

      if (value === '' || Textarea.hasValue(value)) {
        return value;
      }

      return props.value;
    }
  }]);

  return Textarea;
}(_react.default.PureComponent);

exports.default = Textarea;
Textarea.tagName = 'dnb-textarea';
Textarea.contextType = _Context.default;
Textarea.defaultProps = {
  value: 'initval',
  id: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  status: null,
  textarea_state: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  placeholder: null,
  align: null,
  stretch: null,
  disabled: null,
  skeleton: null,
  autoresize: null,
  autoresize_max_rows: null,
  textarea_class: null,
  class: null,
  textarea_attributes: null,
  readOnly: false,
  rows: null,
  cols: null,
  inner_ref: null,
  className: null,
  textarea_element: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_focus: null,
  on_blur: null,
  on_key_down: null,
  on_state_update: null
};
process.env.NODE_ENV !== "production" ? Textarea.propTypes = _extends({
  value: _propTypes.default.string,
  id: _propTypes.default.string,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['horizontal', 'vertical']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  textarea_state: _propTypes.default.string,
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  placeholder: _propTypes.default.string,
  align: _propTypes.default.oneOf(['left', 'right']),
  stretch: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  autoresize: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  autoresize_max_rows: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  class: _propTypes.default.string,
  textarea_class: _propTypes.default.string,
  textarea_attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  readOnly: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  rows: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  cols: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  inner_ref: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.object])
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  textarea_element: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node]),
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_focus: _propTypes.default.func,
  on_blur: _propTypes.default.func,
  on_key_down: _propTypes.default.func,
  on_state_update: _propTypes.default.func
}) : void 0;