import * as React from 'react';
import ToggleButtonGroup from './ToggleButtonGroup';
export type ToggleButtonLabel =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type ToggleButtonLabelDirection = 'horizontal' | 'vertical';
export type ToggleButtonLabelSrOnly = string | boolean;
export type ToggleButtonChecked = string | boolean;
export type ToggleButtonVariant = 'default' | 'checkbox' | 'radio';
export type ToggleButtonDisabled = string | boolean;
export type ToggleButtonSkeleton = string | boolean;
export type ToggleButtonStatus =
  | string
  | boolean
  | ((...args: any[]) => any)
  | React.ReactNode;
export type ToggleButtonSuffix =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type ToggleButtonValue = string | number | Object | any[];
export type ToggleButtonIcon =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type ToggleButtonIconPosition = 'left' | 'right';
export type ToggleButtonAttributes = string | Object;
export type ToggleButtonReadOnly = string | boolean;
export type ToggleButtonSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type ToggleButtonTop = string | number | boolean;
export type ToggleButtonRight = string | number | boolean;
export type ToggleButtonBottom = string | number | boolean;
export type ToggleButtonLeft = string | number | boolean;
export type ToggleButtonChildren = string | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ToggleButtonProps extends React.HTMLProps<HTMLElement> {
  text?: string;
  label?: ToggleButtonLabel;
  label_direction?: ToggleButtonLabelDirection;
  label_sr_only?: ToggleButtonLabelSrOnly;
  title?: string;
  checked?: ToggleButtonChecked;
  variant?: ToggleButtonVariant;
  left_component?: React.ReactNode;
  disabled?: ToggleButtonDisabled;
  skeleton?: ToggleButtonSkeleton;
  id?: string;
  status?: ToggleButtonStatus;
  status_state?: string;
  status_animation?: string;
  global_status_id?: string;
  suffix?: ToggleButtonSuffix;
  value?: ToggleButtonValue;
  icon?: ToggleButtonIcon;
  icon_position?: ToggleButtonIconPosition;
  icon_size?: string;
  attributes?: ToggleButtonAttributes;
  readOnly?: ToggleButtonReadOnly;
  space?: ToggleButtonSpace;
  top?: ToggleButtonTop;
  right?: ToggleButtonRight;
  bottom?: ToggleButtonBottom;
  left?: ToggleButtonLeft;
  class?: string;
  className?: string;
  children?: ToggleButtonChildren;
  custom_element?: Object;
  custom_method?: (...args: any[]) => any;
  on_change?: (...args: any[]) => any;
  on_state_update?: (...args: any[]) => any;
}
export default class ToggleButton extends React.Component<
  ToggleButtonProps,
  any
> {
  static defaultProps: object;
  static Group = ToggleButtonGroup;
  render(): JSX.Element;
}
