"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.array.splice.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _FormRow = _interopRequireDefault(require("../form-row/FormRow"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

var _ToggleButtonGroupContext = _interopRequireDefault(require("./ToggleButtonGroupContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var ToggleButtonGroup = function (_React$PureComponent) {
  _inherits(ToggleButtonGroup, _React$PureComponent);

  var _super = _createSuper(ToggleButtonGroup);

  function ToggleButtonGroup(props) {
    var _this;

    _classCallCheck(this, ToggleButtonGroup);

    _this = _super.call(this, props);

    _this.onChangeHandler = function (_ref) {
      var value = _ref.value,
          event = _ref.event;
      var multiselect = _this.props.multiselect;
      var values = _this.state.values || [];

      if ((0, _componentHelper.isTrue)(multiselect)) {
        if (!values.includes(value)) {
          values.push(value);
        } else {
          values.splice(values.indexOf(value), 1);
        }
      }

      _this.setState({
        value: value,
        values: values,
        _listenForPropChanges: false
      });

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        value: value,
        values: values,
        event: event
      });
    };

    _this._refInput = _react.default.createRef();
    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this._name = props.name || (0, _componentHelper.makeUniqueId)();
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(ToggleButtonGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, ToggleButtonGroup.defaultProps, this.context.getTranslation(this.props).ToggleButton, this.context.FormRow, this.context.ToggleButtonGroup);

      var status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          vertical = props.vertical,
          layout_direction = props.layout_direction,
          label = props.label,
          variant = props.variant,
          left_component = props.left_component,
          no_fieldset = props.no_fieldset,
          disabled = props.disabled,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          multiselect = props.multiselect,
          _id = props.id,
          _name = props.name,
          _value = props.value,
          _values = props.values,
          attributes = props.attributes,
          children = props.children,
          on_change = props.on_change,
          custom_method = props.custom_method,
          custom_element = props.custom_element,
          rest = _objectWithoutProperties(props, ["status", "status_state", "status_animation", "global_status_id", "suffix", "label_direction", "label_sr_only", "vertical", "layout_direction", "label", "variant", "left_component", "no_fieldset", "disabled", "skeleton", "className", "class", "multiselect", "id", "name", "value", "values", "attributes", "children", "on_change", "custom_method", "custom_element"]);

      var _this$state = this.state,
          value = _this$state.value,
          values = _this$state.values;
      var id = this._id;
      var showStatus = (0, _componentHelper.getStatusState)(status);
      var classes = (0, _classnames.default)("dnb-toggle-button-group dnb-toggle-button-group--".concat(layout_direction, " dnb-form-component"), (0, _SpacingHelper.createSpacingClasses)(props), className, _className, status && "dnb-toggle-button-group__status--".concat(status_state), !label && 'dnb-toggle-button-group--no-label');

      var params = _extends({}, rest);

      if (showStatus || suffix) {
        params['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(params, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (label) {
        params['aria-labelledby'] = id + '-label';
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      var context = {
        name: this._name,
        value: value,
        values: values,
        multiselect: (0, _componentHelper.isTrue)(multiselect),
        variant: variant,
        left_component: left_component,
        disabled: disabled,
        skeleton: skeleton,
        setContext: function setContext(context) {
          if (typeof context === 'function') {
            context = context(_this2._tmp);
          }

          _this2._tmp = _extends({}, _this2._tmp, context);

          _this2.setState(_extends({}, context, {
            _listenForPropChanges: false
          }));
        },
        onChange: this.onChangeHandler
      };
      var formRowParams = {
        id: id,
        label: label,
        label_id: id + '-label',
        label_direction: label_direction,
        label_sr_only: label_sr_only,
        direction: label_direction,
        vertical: vertical,
        disabled: disabled,
        skeleton: skeleton,
        no_fieldset: no_fieldset,
        skipContentWrapperIfNested: true
      };
      return _react.default.createElement(_ToggleButtonGroupContext.default.Provider, {
        value: context
      }, _react.default.createElement("div", {
        className: classes
      }, _react.default.createElement(_FormRow.default, formRowParams, _react.default.createElement("span", _extends({
        id: id,
        className: "dnb-toggle-button-group__shell",
        role: "group"
      }, params), showStatus && _react.default.createElement(_FormStatus.default, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), _react.default.createElement("span", {
        className: "dnb-toggle-button-group__children"
      }, children, suffix && _react.default.createElement(_Suffix.default, {
        className: "dnb-toggle-button-group__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(ToggleButtonGroup.tagName, ToggleButtonGroup, ToggleButtonGroup.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (typeof props.value !== 'undefined' && props.value !== state.value) {
          state.value = props.value;
        }

        if (typeof props.values !== 'undefined' && props.values !== state.values) {
          state.values = ToggleButtonGroup.getValues(props);
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }, {
    key: "getValues",
    value: function getValues(props) {
      if (typeof props.values === 'string' && props.values[0] === '[') {
        return JSON.parse(props.values);
      }

      return props.values;
    }
  }]);

  return ToggleButtonGroup;
}(_react.default.PureComponent);

exports.default = ToggleButtonGroup;
ToggleButtonGroup.tagName = 'dnb-toggle-button-group';
ToggleButtonGroup.contextType = _Context.default;
ToggleButtonGroup.defaultProps = {
  label: null,
  label_direction: null,
  label_sr_only: null,
  title: null,
  multiselect: null,
  variant: null,
  left_component: null,
  no_fieldset: null,
  disabled: null,
  skeleton: null,
  id: null,
  name: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  vertical: null,
  layout_direction: 'row',
  value: undefined,
  values: undefined,
  attributes: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null
};
process.env.NODE_ENV !== "production" ? ToggleButtonGroup.propTypes = _extends({
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['horizontal', 'vertical']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  title: _propTypes.default.string,
  multiselect: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  variant: _propTypes.default.oneOf(['default', 'checkbox', 'radio']),
  left_component: _propTypes.default.node,
  no_fieldset: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  id: _propTypes.default.string,
  name: _propTypes.default.string,
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  vertical: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  layout_direction: _propTypes.default.oneOf(['column', 'row']),
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.object, _propTypes.default.array]),
  values: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array]),
  attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_change: _propTypes.default.func
}) : void 0;