"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _TooltipWithEvents = _interopRequireDefault(require("./TooltipWithEvents"));

var _TooltipPortal = _interopRequireDefault(require("./TooltipPortal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Tooltip = function (_React$PureComponent) {
  _inherits(Tooltip, _React$PureComponent);

  var _super = _createSuper(Tooltip);

  function Tooltip(props) {
    var _this;

    _classCallCheck(this, Tooltip);

    _this = _super.call(this, props);
    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    return _this;
  }

  _createClass(Tooltip, [{
    key: "render",
    value: function render() {
      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Tooltip.defaultProps, this.context.getTranslation(this.props).Tooltip, this.context.FormRow, this.context.Tooltip);

      var component = props.component,
          target = props.target,
          class_name = props.class,
          className = props.className,
          group = props.group,
          animate_position = props.animate_position,
          show_delay = props.show_delay,
          hide_delay = props.hide_delay,
          active = props.active,
          position = props.position,
          arrow = props.arrow,
          align = props.align,
          params = _objectWithoutProperties(props, ["component", "target", "class", "className", "group", "animate_position", "show_delay", "hide_delay", "active", "position", "arrow", "align"]);

      var content = Tooltip.getContent(this.props);
      var classes = (0, _classnames.default)("dnb-tooltip dnb-core-style", (0, _SpacingHelper.createSpacingClasses)(props), class_name, className);

      var attributes = _extends({
        className: classes
      }, params);

      (0, _componentHelper.validateDOMAttributes)(this.props, attributes);

      var newProps = _extends({}, this.props, {
        internal_id: this._id,
        group: this.props.id || group
      });

      if (typeof newProps.active === 'undefined') {
        delete newProps.active;
      }

      return _react.default.createElement(_react.default.Fragment, null, component ? _react.default.createElement(_TooltipWithEvents.default, _extends({
        target: component,
        attributes: attributes
      }, newProps), content) : target && _react.default.createElement(_TooltipPortal.default, _extends({
        target: target,
        attributes: attributes
      }, newProps), content));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Tooltip.tagName, Tooltip, Tooltip.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return Tooltip;
}(_react.default.PureComponent);

exports.default = Tooltip;
Tooltip.tagName = 'dnb-tooltip';
Tooltip.contextType = _Context.default;
Tooltip.defaultProps = {
  id: null,
  group: 'main',
  active: undefined,
  position: 'top',
  arrow: 'center',
  align: null,
  animate_position: false,
  show_delay: 300,
  hide_delay: 500,
  class: null,
  className: null,
  children: null,
  onClick: null,
  on_click: null
};
process.env.NODE_ENV !== "production" ? Tooltip.propTypes = _extends({
  id: _propTypes.default.string,
  group: _propTypes.default.string,
  active: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  position: _propTypes.default.oneOf(['top', 'right', 'bottom', 'left']),
  arrow: _propTypes.default.oneOf([null, 'center', 'top', 'right', 'bottom', 'left']),
  align: _propTypes.default.oneOf([null, 'center', 'right', 'left']),
  animate_position: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  show_delay: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  hide_delay: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  onClick: _propTypes.default.func,
  on_click: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func])
}) : void 0;