"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _componentHelper = require("../../shared/component-helper");

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var TooltipContainer = function (_React$PureComponent) {
  _inherits(TooltipContainer, _React$PureComponent);

  var _super = _createSuper(TooltipContainer);

  function TooltipContainer() {
    var _this;

    _classCallCheck(this, TooltipContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this._rootRef = _react.default.createRef();
    _this.offset = 16;
    _this.state = {
      hide: null,
      hover: null,
      width: 0,
      height: 0
    };

    _this.handleMouseEnter = function () {
      (0, _componentHelper.isTrue)(_this.props.active) && _this.props.useHover && _this.setState({
        hover: true
      });
    };

    _this.handleMouseLeave = function () {
      _this.props.useHover && _this.setState({
        hover: false
      });
    };

    return _this;
  }

  _createClass(TooltipContainer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if ((0, _componentHelper.isTrue)(this.props.active)) {
        this.updateSize();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props !== prevProps) {
        this.updateSize();
      }
    }
  }, {
    key: "getGlobalStyle",
    value: function getGlobalStyle() {
      if (!this.props.targetElement) {
        return {
          display: 'none'
        };
      }

      var style = _extends({}, this.makeStyle(this.props.position, this.props.arrow));

      return style;
    }
  }, {
    key: "makeStyle",
    value: function makeStyle(position, arrow) {
      var _this2 = this;

      if (typeof window === 'undefined') {
        return {};
      }

      var alignOffset = 0;
      var target = this.props.targetElement;
      var align = this.props.align;
      var tooltipPosition = target.getBoundingClientRect();
      var scrollY = window.scrollY !== undefined ? window.scrollY : window.pageYOffset;
      var scrollX = window.scrollX !== undefined ? window.scrollX : window.pageXOffset;

      var _top = scrollY + tooltipPosition.top;

      var _left = scrollX + tooltipPosition.left;

      var style = {};
      var targetSize = {
        width: target.offsetWidth,
        height: target.offsetHeight
      };

      if (!target.offsetHeight && target.getBoundingClientRect) {
        targetSize.width = target.getBoundingClientRect().width;
        targetSize.height = target.getBoundingClientRect().height;
      }

      if (align === 'left') {
        alignOffset = -targetSize.width / 2;
      } else if (align === 'right') {
        alignOffset = targetSize.width / 2;
      }

      var stylesFromPosition = {
        left: function left() {
          style.top = _top + targetSize.height / 2 - _this2.state.height / 2;
          style.left = _left - _this2.state.width - _this2.offset;
        },
        right: function right() {
          style.top = _top + targetSize.height / 2 - _this2.state.height / 2;
          style.left = _left + targetSize.width + _this2.offset;
        },
        top: function top() {
          style.left = _left - _this2.state.width / 2 + targetSize.width / 2 + alignOffset;
          style.top = _top - _this2.state.height - _this2.offset;
        },
        bottom: function bottom() {
          style.left = _left - _this2.state.width / 2 + targetSize.width / 2 + alignOffset;
          style.top = _top + targetSize.height + _this2.offset;
        }
      };
      var stylesFromArrow = {
        left: function left() {
          style.left = _left + targetSize.width / 2 - _this2.offset + alignOffset;
        },
        right: function right() {
          style.left = _left - _this2.state.width + targetSize.width / 2 + _this2.offset + alignOffset;
        },
        top: function top() {
          style.top = _top + targetSize.height / 2 - _this2.offset;
        },
        bottom: function bottom() {
          style.top = _top + targetSize.height / 2 - _this2.state.height + _this2.offset;
        }
      };

      if (stylesFromPosition[position]) {
        stylesFromPosition[position]();
      }

      if (stylesFromArrow[arrow]) {
        stylesFromArrow[arrow]();
      }

      return style;
    }
  }, {
    key: "checkWindowPosition",
    value: function checkWindowPosition(style) {
      if (style.left < 0) {
        style.left = this.offset;
      } else {
        try {
          var rightOffset = style.left + this.state.width - window.innerWidth;

          if (rightOffset > 0) {
            style.left = window.innerWidth - this.state.width - this.offset;
          }
        } catch (e) {}
      }

      return style;
    }
  }, {
    key: "updateSize",
    value: function updateSize() {
      var width = this._rootRef.current.offsetWidth;
      var height = this._rootRef.current.offsetHeight;

      if (width !== this.state.width || height !== this.state.height) {
        this.setState({
          width: width,
          height: height,
          _listenForPropChanges: false
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          internal_id = _this$props.internal_id,
          active = _this$props.active,
          attributes = _this$props.attributes,
          arrow = _this$props.arrow,
          position = _this$props.position,
          animate_position = _this$props.animate_position,
          children = _this$props.children;
      var _this$state = this.state,
          hover = _this$state.hover,
          hide = _this$state.hide;
      var style = this.checkWindowPosition(this.getGlobalStyle());
      var isActive = (0, _componentHelper.isTrue)(active) || hover;
      return _react.default.createElement("div", _extends({
        role: "tooltip",
        "aria-hidden": true,
        style: style,
        ref: this._rootRef,
        onMouseEnter: this.handleMouseEnter,
        onMouseLeave: this.handleMouseLeave
      }, attributes, {
        className: (0, _classnames.default)(attributes.className, isActive ? 'dnb-tooltip--active' : hide && 'dnb-tooltip--hide', (0, _componentHelper.isTrue)(animate_position) && 'dnb-tooltip--animate_position')
      }), arrow && _react.default.createElement("span", {
        className: "dnb-tooltip__arrow dnb-tooltip__arrow__arrow--".concat(arrow, " dnb-tooltip__arrow__position--").concat(position)
      }), _react.default.createElement("div", {
        id: internal_id,
        className: "dnb-tooltip__content"
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (state.wasActive && !props.active && !state.hover) {
          state.hide = true;
        }

        if (props.active || state.hover) {
          state.wasActive = true;
          state.hide = false;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return TooltipContainer;
}(_react.default.PureComponent);

exports.default = TooltipContainer;
TooltipContainer.defaultProps = {
  internal_id: null,
  targetElement: null,
  active: false,
  position: 'center',
  arrow: null,
  align: null,
  animate_position: null,
  useHover: true,
  attributes: null,
  children: null
};
process.env.NODE_ENV !== "production" ? TooltipContainer.propTypes = {
  internal_id: _propTypes.default.string,
  targetElement: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.object, _propTypes.default.node]),
  active: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  position: _propTypes.default.string,
  arrow: _propTypes.default.string,
  align: _propTypes.default.string,
  animate_position: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  useHover: _propTypes.default.bool,
  attributes: _propTypes.default.object,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node])
} : void 0;