"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.split.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TooltipContainer = _interopRequireDefault(require("./TooltipContainer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var tooltipPortal;

if (typeof window !== 'undefined') {
  window.tooltipPortal = window.tooltipPortal || {};
  tooltipPortal = window.tooltipPortal;
} else {
  tooltipPortal = {};
}

var TooltipPortal = function (_React$PureComponent) {
  _inherits(TooltipPortal, _React$PureComponent);

  var _super = _createSuper(TooltipPortal);

  function TooltipPortal() {
    _classCallCheck(this, TooltipPortal);

    return _super.apply(this, arguments);
  }

  _createClass(TooltipPortal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.renderPortal();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(props) {
      if (!tooltipPortal[this.props.group] || this.props.active && props.active) {
        return;
      }

      this.renderPortal({
        active: true
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (tooltipPortal[this.props.group]) {
        _reactDom.default.unmountComponentAtNode(tooltipPortal[this.props.group].node);

        clearTimeout(tooltipPortal[this.props.group].timeout);

        try {
          document.body.removeChild(tooltipPortal[this.props.group].node);
        } catch (e) {}

        tooltipPortal[this.props.group] = null;
      }
    }
  }, {
    key: "createPortal",
    value: function createPortal() {
      if (typeof document !== 'undefined') {
        try {
          tooltipPortal[this.props.group] = {
            node: document.createElement('div'),
            timeout: null
          };
          tooltipPortal[this.props.group].node.className = 'TooltipPortal';
          document.body.insertBefore(tooltipPortal[this.props.group].node, document.body.firstChild);
        } catch (e) {
          console.warn('Could not create TooltipPortal!', e);
        }
      }
    }
  }, {
    key: "handleAria",
    value: function handleAria(elem) {
      if (elem && this.props.internal_id) {
        try {
          var describedby = makeArrayUnique(String(elem.getAttribute('aria-describedby') || '').split(' '));
          describedby.push(this.props.internal_id);
          elem.setAttribute('aria-describedby', describedby.join(' '));
        } catch (e) {}
      }
    }
  }, {
    key: "renderPortal",
    value: function renderPortal() {
      var _this = this;

      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (typeof document === 'undefined') {
        return;
      }

      if (!tooltipPortal[this.props.group]) {
        this.createPortal();
      }

      var _this$props = this.props,
          group = _this$props.group,
          target = _this$props.target;
      var targetElement = typeof target === 'string' ? document.querySelector(target) : target;

      if (tooltipPortal[group].timeout) {
        clearTimeout(tooltipPortal[group].timeout);
      }

      if (!this.props.active && props.active) {
        tooltipPortal[group].timeout = setTimeout(function () {
          _this.renderPortal({
            active: false
          });
        }, parseFloat(this.props.hide_delay));
      }

      _reactDom.default.render(_react.default.createElement(_TooltipContainer.default, _extends({
        targetElement: targetElement
      }, this.props, props)), tooltipPortal[this.props.group].node);

      this.handleAria(targetElement);
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return TooltipPortal;
}(_react.default.PureComponent);

exports.default = TooltipPortal;
TooltipPortal.defaultProps = {
  internal_id: null,
  active: false,
  group: 'main',
  hide_delay: 500
};
process.env.NODE_ENV !== "production" ? TooltipPortal.propTypes = {
  internal_id: _propTypes.default.string,
  target: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]).isRequired,
  active: _propTypes.default.bool,
  group: _propTypes.default.string,
  hide_delay: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])
} : void 0;

var makeArrayUnique = function makeArrayUnique(array) {
  return array.filter(Boolean).filter(function (value, index, self) {
    return self.indexOf(value) === index;
  });
};