"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TooltipPortal = _interopRequireDefault(require("./TooltipPortal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var TooltipWithEvents = function (_React$PureComponent) {
  _inherits(TooltipWithEvents, _React$PureComponent);

  var _super = _createSuper(TooltipWithEvents);

  function TooltipWithEvents() {
    var _this;

    _classCallCheck(this, TooltipWithEvents);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      isActive: false
    };

    _this.onMouseEnter = function () {
      clearTimeout(_this._onEnterTimeout);
      _this._onEnterTimeout = setTimeout(function () {
        _this.setState({
          isActive: true
        });
      }, _this.props.show_delay || 1);
    };

    _this.onMouseLeave = function () {
      clearTimeout(_this._onEnterTimeout);

      _this.setState({
        isActive: false
      });
    };

    return _this;
  }

  _createClass(TooltipWithEvents, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._onEnterTimeout);
      clearTimeout(this._targetTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          target = _this$props.target,
          props = _objectWithoutProperties(_this$props, ["children", "className", "target"]);

      if (!this.state.target && typeof target.current !== 'undefined') {
        this._targetTimeout = setTimeout(function () {
          if (!target.current) return;

          try {
            var elem = target.current;
            elem.addEventListener('mouseenter', _this2.onMouseEnter);
            elem.addEventListener('mouseleave', _this2.onMouseLeave);
            var describedby = [_this2.props.internal_id];
            var db = elem.getAttribute('aria-describedby');

            if (db) {
              describedby.unshift(db);
            }

            elem.setAttribute('aria-describedby', describedby.join(' '));
          } catch (e) {
            console.warn('Tooltip: Could not add event listeners', e);
          }

          _this2.setState({
            target: target.current
          });
        }, 1);
        return null;
      }

      var componentWrapper;

      if (_react.default.isValidElement(target)) {
        var describedby = [this.props.internal_id];

        if (target.props && target.props['aria-describedby']) {
          describedby.unshift(target.props['aria-describedby']);
        }

        componentWrapper = _react.default.createElement("span", {
          key: "target-wrapper",
          ref: function ref(target) {
            return _this2.setState({
              target: target
            });
          },
          className: className,
          onMouseEnter: this.onMouseEnter,
          onMouseLeave: this.onMouseLeave
        }, _react.default.cloneElement(target, {
          'aria-describedby': describedby.join(' ')
        }));
      }

      return _react.default.createElement(_react.default.Fragment, null, componentWrapper, this.state.target && _react.default.createElement(_TooltipPortal.default, _extends({
        key: "tooltip",
        active: this.state.isActive,
        target: this.state.target
      }, props), children));
    }
  }]);

  return TooltipWithEvents;
}(_react.default.PureComponent);

exports.default = TooltipWithEvents;
TooltipWithEvents.defaultProps = {
  className: '',
  internal_id: null,
  show_delay: 1,
  target: null,
  children: null
};
process.env.NODE_ENV !== "production" ? TooltipWithEvents.propTypes = {
  className: _propTypes.default.string,
  internal_id: _propTypes.default.string,
  show_delay: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  target: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object, _propTypes.default.func, _propTypes.default.node]),
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node])
} : void 0;