"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _Element = _interopRequireDefault(require("./Element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Anchor = _react.default.forwardRef(function (_ref, ref) {
  var props = _extends({}, _ref);

  if (props.target === '_blank' && typeof props.children !== 'string') {
    props.className = (0, _classnames.default)(props.className, 'dnb-anchor--no-icon');
  }

  return _react.default.createElement(_Element.default, _extends({
    ref: ref,
    is: "a",
    class: "dnb-anchor",
    className: props.className
  }, props));
});

process.env.NODE_ENV !== "production" ? Anchor.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  href: _propTypes.default.string,
  target: _propTypes.default.string,
  className: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object, _propTypes.default.array]),
  children: _propTypes.default.node
}) : void 0;
Anchor.defaultProps = {
  href: null,
  target: null,
  className: null,
  children: null
};
Anchor.tagName = 'dnb-anchor';
var _default = Anchor;
exports.default = _default;