import * as React from 'react';
export type DdSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type DdTop = string | number | boolean;
export type DdRight = string | number | boolean;
export type DdBottom = string | number | boolean;
export type DdLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DdProps extends React.HTMLProps<HTMLElement> {
  space?: DdSpace;
  top?: DdTop;
  right?: DdRight;
  bottom?: DdBottom;
  left?: DdLeft;
  children?: React.ReactNode;
}
declare const Dd: React.FC<DdProps>;
export default Dd;
