"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.to-string.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../shared/Context"));

var _componentHelper = require("../shared/component-helper");

var _SpacingHelper = require("../components/space/SpacingHelper");

var _SkeletonHelper = require("../components/skeleton/SkeletonHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Elem = function (_React$PureComponent) {
  _inherits(Elem, _React$PureComponent);

  var _super = _createSuper(Elem);

  function Elem(props) {
    _classCallCheck(this, Elem);

    return _super.call(this, props);
  }

  _createClass(Elem, [{
    key: "render",
    value: function render() {
      var _this$context, _this$context2;

      var props = this.props.skeleton !== false && typeof ((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton) !== 'undefined' ? (0, _componentHelper.extendPropsWithContext)(this.props, Elem.defaultProps, {
        skeleton: (_this$context2 = this.context) === null || _this$context2 === void 0 ? void 0 : _this$context2.skeleton
      }) : this.props;

      var className = props.className,
          _className = props.class,
          internalClass = props.internalClass,
          css = props.css,
          Tag = props.is,
          _ref = props._ref,
          skeleton = props.skeleton,
          skeleton_method = props.skeleton_method,
          rest = _objectWithoutProperties(props, ["className", "class", "internalClass", "css", "is", "_ref", "skeleton", "skeleton_method"]);

      var tagClass = internalClass || "dnb-".concat(Tag);
      rest.className = (0, _classnames.default)(className, _className, css, (0, _SkeletonHelper.createSkeletonClass)(skeleton_method, skeleton, this.context), (0, _SpacingHelper.createSpacingClasses)(rest, Tag), !new RegExp("".concat(tagClass, "(\\s|$)")).test(String(className)) && tagClass);
      (0, _componentHelper.validateDOMAttributes)(null, rest);
      (0, _SkeletonHelper.skeletonDOMAttributes)(rest, skeleton, this.context);
      return _react.default.createElement(Tag, _extends({
        ref: _ref
      }, rest));
    }
  }]);

  return Elem;
}(_react.default.PureComponent);

Elem.contextType = _Context.default;
Elem.defaultProps = {
  skeleton: null,
  skeleton_method: 'font',
  className: null,
  class: null,
  internalClass: null,
  css: null,
  _ref: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Elem.propTypes = _extends({
  is: _propTypes.default.string.isRequired,
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton_method: _propTypes.default.string
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object, _propTypes.default.array]),
  class: _propTypes.default.string,
  internalClass: _propTypes.default.string,
  css: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  _ref: _propTypes.default.object,
  children: _propTypes.default.node
}) : void 0;

var Element = _react.default.forwardRef(function (props, ref) {
  return _react.default.createElement(Elem, _extends({
    _ref: ref
  }, props));
});

process.env.NODE_ENV !== "production" ? Element.propTypes = Elem.propTypes : void 0;
Element.defaultProps = Elem.defaultProps;
var _default = Element;
exports.default = _default;