"use strict";

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.object.keys.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _Element = _interopRequireDefault(require("./Element"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Hr = function Hr() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var fullscreen = _ref.fullscreen,
      light = _ref.light,
      medium = _ref.medium,
      props = _objectWithoutProperties(_ref, ["fullscreen", "light", "medium"]);

  if (fullscreen) {
    props.className = (0, _classnames.default)(props.className, 'dnb-hr--fullscreen');
  }

  if (light) {
    props.className = (0, _classnames.default)(props.className, 'dnb-hr--light');
  }

  if (medium) {
    props.className = (0, _classnames.default)(props.className, 'dnb-hr--medium');
  }

  return _react.default.createElement(_Element.default, _extends({
    is: "hr"
  }, props));
};

Hr.tagName = 'dnb-hr';
process.env.NODE_ENV !== "production" ? Hr.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  light: _propTypes.default.bool,
  medium: _propTypes.default.bool,
  fullscreen: _propTypes.default.bool
}) : void 0;
Hr.defaultProps = {
  className: null,
  light: null,
  medium: null,
  fullscreen: null
};
var _default = Hr;
exports.default = _default;