"use strict";

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.object.keys.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Element = _interopRequireDefault(require("./Element"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Img = function Img(_ref) {
  var caption = _ref.caption,
      alt = _ref.alt,
      element = _ref.element,
      skeleton = _ref.skeleton,
      img_class = _ref.img_class,
      className = _ref.className,
      _class = _ref.class,
      p = _objectWithoutProperties(_ref, ["caption", "alt", "element", "skeleton", "img_class", "className", "class"]);

  return _react.default.createElement(_Element.default, {
    is: element,
    internalClass: "dnb-img",
    className: (0, _classnames.default)(className, _class, (0, _SpacingHelper.createSpacingClasses)(p, p.is)),
    skeleton: skeleton,
    skeleton_method: "shape"
  }, _react.default.createElement(_Element.default, _extends({
    is: "img",
    alt: alt,
    internalClass: "dnb-img__img",
    className: img_class,
    skeleton: skeleton
  }, (0, _SpacingHelper.removeSpaceProps)(p))), caption && _react.default.createElement("figcaption", null, caption));
};

Img.tagName = 'dnb-img';
process.env.NODE_ENV !== "production" ? Img.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  src: _propTypes.default.string.isRequired,
  alt: _propTypes.default.string.isRequired,
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  className: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object, _propTypes.default.array]),
  class: _propTypes.default.string,
  img_class: _propTypes.default.string,
  element: _propTypes.default.node,
  caption: _propTypes.default.string,
  children: _propTypes.default.node
}) : void 0;
Img.defaultProps = {
  skeleton: null,
  className: null,
  class: null,
  img_class: null,
  element: 'figure',
  css: null,
  caption: null,
  children: null
};
var _default = Img;
exports.default = _default;