import * as React from 'react';
export type OlSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type OlTop = string | number | boolean;
export type OlRight = string | number | boolean;
export type OlBottom = string | number | boolean;
export type OlLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface OlProps extends React.HTMLProps<HTMLElement> {
  space?: OlSpace;
  top?: OlTop;
  right?: OlRight;
  bottom?: OlBottom;
  left?: OlLeft;
  className?: string;
  inside?: boolean;
  outside?: boolean;
  nested?: boolean;
}
declare const Ol: React.FC<OlProps>;
export default Ol;
