"use strict";

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.object.keys.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _Element = _interopRequireDefault(require("./Element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Ol = function Ol() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var nested = _ref.nested,
      inside = _ref.inside,
      outside = _ref.outside,
      p = _objectWithoutProperties(_ref, ["nested", "inside", "outside"]);

  if (nested) {
    p.className = (0, _classnames.default)(p.className, 'dnb-ol--nested');
  }

  if (inside) {
    p.className = (0, _classnames.default)(p.className, 'dnb-ol--inside');
  }

  if (outside) {
    p.className = (0, _classnames.default)(p.className, 'dnb-ol--outside');
  }

  return _react.default.createElement(_Element.default, _extends({
    is: "ol"
  }, p, {
    skeleton: false
  }));
};

Ol.tagName = 'dnb-ol';
process.env.NODE_ENV !== "production" ? Ol.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  inside: _propTypes.default.bool,
  outside: _propTypes.default.bool,
  nested: _propTypes.default.bool
}) : void 0;
Ol.defaultProps = {
  className: null,
  inside: null,
  outside: null,
  nested: null
};
var _default = Ol;
exports.default = _default;