"use strict";

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/es.string.bold.js");

require("core-js/modules/es.string.small.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _Element = _interopRequireDefault(require("./Element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var P = function P(_ref) {
  var style_type = _ref.style_type,
      modifier = _ref.modifier,
      element = _ref.element,
      className = _ref.className,
      small = _ref.small,
      medium = _ref.medium,
      bold = _ref.bold,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ["style_type", "modifier", "element", "className", "small", "medium", "bold", "size"]);

  if (typeof modifier === 'string' && / /.test(modifier)) {
    modifier = modifier.split(/ /g);
  } else if (!Array.isArray(modifier)) {
    modifier = [modifier];
  }

  if (style_type) {
    modifier.push(style_type);
  }

  if (medium === true) {
    modifier.push('medium');
  } else if (bold === true) {
    modifier.push('bold');
  }

  modifier = modifier.filter(Boolean).reduce(function (acc, cur) {
    if (['x-small', 'small'].includes(cur)) {
      return "".concat(acc, " dnb-p__size--").concat(cur);
    }

    return "".concat(acc, " dnb-p--").concat(cur);
  }, '');

  if (size) {
    className = (0, _classnames.default)(className, "dnb-p__size--".concat(size));
  } else if (small === true) {
    className = (0, _classnames.default)(className, 'dnb-p__size--small');
  }

  return _react.default.createElement(_Element.default, _extends({
    is: element
  }, props, {
    className: (0, _classnames.default)('dnb-p', modifier, className)
  }));
};

P.tagName = 'dnb-p';
process.env.NODE_ENV !== "production" ? P.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  element: _propTypes.default.node,
  className: _propTypes.default.string,
  small: _propTypes.default.bool,
  medium: _propTypes.default.bool,
  bold: _propTypes.default.bool,
  size: _propTypes.default.oneOf(['x-small', 'small', 'basis', 'medium', 'large', 'x-large', 'xx-large']),
  style_type: _propTypes.default.string,
  modifier: _propTypes.default.string,
  children: _propTypes.default.node
}) : void 0;
P.defaultProps = {
  element: 'p',
  className: null,
  small: null,
  medium: null,
  bold: null,
  size: null,
  style_type: null,
  modifier: null,
  children: null
};
var _default = P;
exports.default = _default;