import * as React from 'react';
export type TableSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type TableTop = string | number | boolean;
export type TableRight = string | number | boolean;
export type TableBottom = string | number | boolean;
export type TableLeft = string | number | boolean;
export type TableSticky = string | boolean;
export type TableStickyOffset = string | number;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface TableProps extends React.HTMLProps<HTMLElement> {
  space?: TableSpace;
  top?: TableTop;
  right?: TableRight;
  bottom?: TableBottom;
  left?: TableLeft;
  sticky?: TableSticky;
  sticky_offset?: TableStickyOffset;
  children?: React.ReactNode;
}
export default class Table extends React.Component<TableProps, any> {
  static defaultProps: object;
  render(): JSX.Element;
}
