"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var drawerListPortal;

if (typeof window !== 'undefined') {
  window.drawerListPortal = window.drawerListPortal || {};
  drawerListPortal = window.drawerListPortal;
} else {
  drawerListPortal = {};
}

var DrawerListPortal = function (_React$PureComponent) {
  _inherits(DrawerListPortal, _React$PureComponent);

  var _super = _createSuper(DrawerListPortal);

  function DrawerListPortal(props) {
    var _this;

    _classCallCheck(this, DrawerListPortal);

    _this = _super.call(this, props);

    _this.init = function () {
      if (_this._isMounted && !_this.props.inactive) {
        _this.renderPortal();
      }
    };

    _this.ref = props.innerRef || _react.default.createRef();
    return _this;
  }

  _createClass(DrawerListPortal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;

      if (document.readyState === 'complete') {
        this.init();
      } else if (typeof window !== 'undefined') {
        window.addEventListener('load', this.init);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;

      if (typeof window !== 'undefined') {
        window.removeEventListener('load', this.init);
      }

      var id = this.props.id;

      if (drawerListPortal[id]) {
        _reactDom.default.unmountComponentAtNode(drawerListPortal[id].node);

        try {
          document.body.removeChild(drawerListPortal[id].node);
        } catch (e) {}

        drawerListPortal[id] = null;
      }

      this.removePositionObserver();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props !== prevProps) {
        this.renderPortal();
      }
    }
  }, {
    key: "createPortal",
    value: function createPortal() {
      if (typeof document !== 'undefined') {
        try {
          var elem = drawerListPortal[this.props.id] = {
            node: document.createElement('div')
          };
          elem.node.setAttribute('role', 'presentation');
          elem.node.className = 'dnb-drawer-list__portal dnb-core-style';
          document.body.insertBefore(elem.node, document.body.firstChild);
        } catch (e) {
          (0, _componentHelper.warn)('Could not create DrawerListPortal!', e);
        }
      }
    }
  }, {
    key: "makeStyle",
    value: function makeStyle() {
      if (typeof window === 'undefined') {
        return;
      }

      try {
        var _this$props = this.props,
            rootRef = _this$props.rootRef,
            include_owner_width = _this$props.include_owner_width,
            independent_width = _this$props.independent_width,
            fixed_position = _this$props.fixed_position;
        var rootElem = rootRef.current;
        var ownerElem = rootElem.parentElement;
        var width = 64;
        var ownerWidth = window.getComputedStyle(ownerElem).width;

        if (independent_width || parseFloat(ownerWidth) < 64) {
          var minWidth = parseFloat(window.getComputedStyle(document.documentElement).getPropertyValue('--drawer-list-width'));
          width = minWidth * 16;
        }

        var customWidth = rootElem.getBoundingClientRect().width;

        if (parseFloat(customWidth || 0) >= 64) {
          width = customWidth;
        }

        var rect = rootElem.getBoundingClientRect();
        var scrollY = fixed_position ? 0 : window.scrollY !== undefined ? window.scrollY : window.pageYOffset;
        var scrollX = fixed_position ? 0 : window.scrollX !== undefined ? window.scrollX : window.pageXOffset;
        var top = scrollY + rect.top;
        var left = scrollX + rect.left + (include_owner_width ? parseFloat(ownerWidth || 0) : 0);

        if (width > window.innerWidth) {
          width = window.innerWidth;
        }

        var style = {
          width: width,
          '--drawer-list-width': "".concat(width / 16, "rem"),
          top: top,
          left: left
        };
        return style;
      } catch (e) {
        (0, _componentHelper.warn)('Could not create makeStyle in DrawerListPortal!', e);
      }
    }
  }, {
    key: "addPositionObserver",
    value: function addPositionObserver() {
      var _this2 = this;

      if (typeof window === 'undefined' || this.setPosition) {
        return;
      }

      var renderPosition = function renderPosition() {
        _this2.renderPortal();
      };

      this.setPosition = function () {
        clearTimeout(_this2._ddt);
        _this2._ddt = setTimeout(renderPosition, 30);
      };

      window.addEventListener('resize', this.setPosition);
      this.customElem = (0, _componentHelper.isInsideScrollView)(this.props.rootRef.current, true);

      if (this.customElem) {
        this.customElem.addEventListener('scroll', this.setPosition);
      }
    }
  }, {
    key: "removePositionObserver",
    value: function removePositionObserver() {
      clearTimeout(this._ddt);

      if (typeof window !== 'undefined' && this.setPosition) {
        if (this.customElem) {
          this.customElem.addEventListener('scroll', this.setPosition);
        }

        window.removeEventListener('resize', this.setPosition);
      }
    }
  }, {
    key: "renderPortal",
    value: function renderPortal() {
      var _this$props2 = this.props,
          inactive = _this$props2.inactive,
          id = _this$props2.id,
          opened = _this$props2.opened,
          fixed_position = _this$props2.fixed_position,
          use_drawer_on_mobile = _this$props2.use_drawer_on_mobile,
          children = _this$props2.children;

      if (inactive) {
        return;
      }

      if (!drawerListPortal[id]) {
        this.createPortal();
      }

      if (opened) {
        this.addPositionObserver();
      }

      var style = opened ? this.makeStyle() : {};

      _reactDom.default.render(_react.default.createElement("span", {
        className: (0, _classnames.default)('dnb-drawer-list__portal__style', fixed_position && 'dnb-drawer-list__portal__style--fixed', use_drawer_on_mobile && 'dnb-drawer-list__portal__style--mobile-view'),
        style: style,
        ref: this.ref
      }, children), drawerListPortal[id].node);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          inactive = _this$props3.inactive,
          children = _this$props3.children;
      return inactive ? children : null;
    }
  }]);

  return DrawerListPortal;
}(_react.default.PureComponent);

DrawerListPortal.defaultProps = {
  rootRef: {
    current: null
  },
  innerRef: null,
  include_owner_width: false,
  independent_width: false,
  fixed_position: false,
  use_drawer_on_mobile: false,
  inactive: false
};
process.env.NODE_ENV !== "production" ? DrawerListPortal.propTypes = {
  id: _propTypes.default.string.isRequired,
  children: _propTypes.default.node.isRequired,
  opened: _propTypes.default.bool.isRequired,
  innerRef: _propTypes.default.shape({
    current: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.object])
  }),
  rootRef: _propTypes.default.shape({
    current: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.object])
  }).isRequired,
  include_owner_width: _propTypes.default.bool,
  independent_width: _propTypes.default.bool,
  fixed_position: _propTypes.default.bool,
  use_drawer_on_mobile: _propTypes.default.bool,
  inactive: _propTypes.default.bool
} : void 0;

var _default = _react.default.forwardRef(function DrawerListPortalRef(props, ref) {
  return _react.default.createElement(DrawerListPortal, _extends({
    innerRef: ref
  }, props));
});

exports.default = _default;