import * as React from 'react';
export type DrawerListProviderNoAnimation = string | boolean;
export type DrawerListProviderPreventSelection = string | boolean;
export type DrawerListProviderDirection = 'auto' | 'top' | 'bottom';
export type DrawerListProviderWrapperElement =
  | Object
  | ((...args: any[]) => any)
  | React.ReactNode;
export type DrawerListProviderPreventClose = string | boolean;
export type DrawerListProviderKeepOpen = string | boolean;
export type DrawerListProviderPreventFocus = string | boolean;
export type DrawerListProviderSkipKeysearch = string | boolean;
export type DrawerListProviderUseDrawerOnMobile = string | boolean;
export type DrawerListProviderEnableBodyLock = string | boolean;
export type DrawerListProviderPageOffset = string | number;
export type DrawerListProviderObserverElement = string | React.ReactNode;
export type DrawerListProviderEnableClosestObserver = string | boolean;
export type DrawerListProviderOpened = string | boolean;
export type DrawerListProviderScrollable = string | boolean;
export type DrawerListProviderMinHeight = string | number;
export type DrawerListProviderMaxHeight = string | number;
export type DrawerListProviderChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode
  | Object
  | any[];

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DrawerListProviderProps
  extends React.HTMLProps<HTMLElement> {
  no_animation?: DrawerListProviderNoAnimation;
  prevent_selection?: DrawerListProviderPreventSelection;
  direction?: DrawerListProviderDirection;
  wrapper_element?: DrawerListProviderWrapperElement;
  prevent_close?: DrawerListProviderPreventClose;
  keep_open?: DrawerListProviderKeepOpen;
  prevent_focus?: DrawerListProviderPreventFocus;
  skip_keysearch?: DrawerListProviderSkipKeysearch;
  use_drawer_on_mobile?: DrawerListProviderUseDrawerOnMobile;
  enable_body_lock?: DrawerListProviderEnableBodyLock;
  page_offset?: DrawerListProviderPageOffset;
  observer_element?: DrawerListProviderObserverElement;
  enable_closest_observer?: DrawerListProviderEnableClosestObserver;
  opened?: DrawerListProviderOpened;
  scrollable?: DrawerListProviderScrollable;
  min_height?: DrawerListProviderMinHeight;
  max_height?: DrawerListProviderMaxHeight;
  on_resize?: (...args: any[]) => any;
  children?: DrawerListProviderChildren;
}
export default class DrawerListProvider extends React.Component<
  DrawerListProviderProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
