"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.object.keys.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _keycode = _interopRequireDefault(require("keycode"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _helpers = require("../../shared/helpers");

var _DrawerListHelpers = require("./DrawerListHelpers");

var _DrawerListContext = _interopRequireDefault(require("./DrawerListContext"));

var _bodyScrollLock = require("../../shared/libs/bodyScrollLock");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DrawerListProvider = function (_React$PureComponent) {
  _inherits(DrawerListProvider, _React$PureComponent);

  var _super = _createSuper(DrawerListProvider);

  function DrawerListProvider(props) {
    var _this;

    _classCallCheck(this, DrawerListProvider);

    _this = _super.call(this, props);

    _this.enableBodyLock = function () {
      if (_this._refUl.current) {
        _this._bodyLockIsEnabled = true;
        (0, _bodyScrollLock.disableBodyScroll)(_this._refUl.current);
      }
    };

    _this.disableBodyLock = function () {
      if (_this._bodyLockIsEnabled && _this._refUl.current) {
        _this._bodyLockIsEnabled = null;
        (0, _bodyScrollLock.enableBodyScroll)(_this._refUl.current);
      }
    };

    _this.scrollToItem = function (active_item) {
      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref$scrollTo = _ref.scrollTo,
          scrollTo = _ref$scrollTo === void 0 ? true : _ref$scrollTo;

      clearTimeout(_this._scrollTimeout);
      _this._scrollTimeout = setTimeout(function () {
        if (_this._refUl.current && parseFloat(active_item) > -1) {
          try {
            var ulElement = _this._refUl.current;

            var liElement = _this.getActiveElement();

            if (liElement) {
              var top = liElement.offsetTop;

              if (ulElement.scrollTo) {
                if (scrollTo === false || window.IS_TEST) {
                  ulElement.style.scrollBehavior = 'auto';
                }

                ulElement.scrollTo({
                  top: top,
                  behavior: scrollTo ? 'smooth' : 'auto'
                });

                if (scrollTo === false) {
                  ulElement.style.scrollBehavior = 'smooth';
                }
              } else if (ulElement.scrollTop) {
                ulElement.scrollTop = top;
              }

              if (!(0, _componentHelper.isTrue)(_this.props.prevent_focus) && liElement) {
                liElement.focus();
                (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_show_focus', {
                  element: liElement
                });
              }
            }
          } catch (e) {
            (0, _componentHelper.warn)('List could not scroll into element:', e);
          }
        }
      }, 1);
    };

    _this.scrollToAndSetActiveItem = function (active_item) {
      var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref2$fireSelectEvent = _ref2.fireSelectEvent,
          fireSelectEvent = _ref2$fireSelectEvent === void 0 ? false : _ref2$fireSelectEvent,
          _ref2$scrollTo = _ref2.scrollTo,
          scrollTo = _ref2$scrollTo === void 0 ? true : _ref2$scrollTo,
          _ref2$event = _ref2.event,
          event = _ref2$event === void 0 ? null : _ref2$event;

      if (parseFloat(active_item) > -1) {
        _this.setState({
          active_item: active_item,
          _listenForPropChanges: false
        }, function () {
          var selected_item = _this.state.selected_item;

          if (fireSelectEvent) {
            var attributes = _this.attributes;
            var ret = (0, _componentHelper.dispatchCustomElementEvent)(_this.state, 'on_select', {
              active_item: active_item,
              value: (0, _DrawerListHelpers.getSelectedItemValue)(selected_item, _this.state),
              data: (0, _DrawerListHelpers.getEventData)(active_item, _this.state.data),
              event: event,
              attributes: attributes
            });

            if (ret === false) {
              return;
            }
          }

          _this.scrollToItem(active_item, {
            scrollTo: scrollTo
          });
        });
      } else if (!(0, _componentHelper.isTrue)(_this.props.prevent_focus)) {
        if (_this._refUl.current) {
          _this._refUl.current.focus({
            preventScroll: true
          });

          (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_show_focus', {
            element: _this._refUl.current
          });
        }
      }
    };

    _this.setWrapperElement = function () {
      var wrapper_element = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.wrapper_element;

      if (typeof wrapper_element === 'string' && typeof document !== 'undefined') {
        wrapper_element = document.querySelector(wrapper_element);
      }

      if (wrapper_element) {
        _this.setState({
          wrapper_element: wrapper_element,
          _listenForPropChanges: false
        });
      }

      return _assertThisInitialized(_this);
    };

    _this.anchorKeyDownHandler = function (e) {
      var key = (0, _keycode.default)(e);

      switch (key) {
        case 'tab':
          try {
            var nextEl = _this.meta.shift ? e.target.previousSibling : e.target.nextSibling;
            e.stopPropagation();
            e.preventDefault();

            if (nextEl) {
              _this.focusAnchorElem(nextEl);
            } else {
              _this.getActiveElement().focus();
            }
          } catch (e) {}

          break;

        case 'enter':
        case 'space':
          e.stopPropagation();
          break;

        default:
          break;
      }
    };

    _this.setMetaKey = function (e) {
      var we = typeof window !== 'undefined' && window.event ? window.event : e;
      _this.meta = {
        cmd: we.metaKey,
        ctrl: we.ctrlKey,
        shift: we.shiftKey,
        alt: we.altKey
      };
    };

    _this.onKeyUpHandler = function (e) {
      _this.setMetaKey(e);
    };

    _this.onKeyDownHandler = function (e) {
      var key = (0, _keycode.default)(e);

      if (/command|alt|shift|ctrl/.test(key)) {
        _this.setMetaKey(e);
      }

      if ((0, _componentHelper.isTrue)(_this.props.prevent_close)) {
          var isSameDrawer = false;

          try {
            isSameDrawer = typeof document !== 'undefined' && "".concat(document.activeElement.getAttribute('id'), "-ul") === _this._refUl.current.getAttribute('id');
          } catch (e) {
            (0, _componentHelper.warn)(e);
          }

          if (!isSameDrawer || key === 'tab') {
            return;
          }
        }

      if ((0, _componentHelper.isTrue)(_this.state.ignore_events) && key !== 'tab') {
        return;
      }

      if (!_this.state.isOpen) {
        return;
      }

      var active_item = parseFloat(_this.state.active_item);

      if (isNaN(active_item)) {
        active_item = -1;
      }

      var total = _this.state.data && _this.state.data.length - 1;

      switch (key) {
        case 'up':
          {
            e.preventDefault();
            active_item = _this.getPrevActiveItem();

            if (isNaN(active_item)) {
              active_item = _this.getFirstItem() || 0;
            }
          }
          break;

        case 'down':
          {
            e.preventDefault();

            var activeItem = _this.getCurrentActiveItem();

            if (active_item === -1 || isNaN(activeItem)) {
              active_item = _this.getFirstItem() || 0;
            } else {
              active_item = _this.getNextActiveItem();
            }
          }
          break;

        case 'page up':
        case 'home':
          {
            e.preventDefault();
            active_item = _this.getFirstItem() || 0;
          }
          break;

        case 'page down':
        case 'end':
          {
            e.preventDefault();
            active_item = _this.getLastItem();

            if (isNaN(active_item)) {
              active_item = total;
            }
          }
          break;

        case 'enter':
        case 'space':
          {
            active_item = _this.getCurrentActiveItem();

            if ((0, _componentHelper.isTrue)(_this.props.skip_keysearch) ? active_item > -1 && key !== 'space' : true) {
              e.preventDefault();

              _this.selectItem(active_item, {
                fireSelectEvent: true,
                event: e
              });
            }
          }
          break;

        case 'esc':
          {
            _this.setHidden({
              event: e
            });

            e.preventDefault();
          }
          break;

        case 'tab':
          {
            if (active_item > -1) {
              var anchorElem = _this.getAnchorElem();

              if (anchorElem) {
                e.preventDefault();

                _this.focusAnchorElem(anchorElem);

                return;
              }
            }

            _this.setHidden({
              event: e
            });
          }
          break;

        default:
          active_item = _this.findItemByValue((0, _keycode.default)(e));
          break;
      }

      if (parseFloat(active_item) > -1 && active_item !== _this.state.active_item) {
        _this.scrollToAndSetActiveItem(active_item, {
          fireSelectEvent: true,
          event: e
        });
      }
    };

    _this.getSelectedElement = function () {
      var _this$_refUl$current;

      return ((_this$_refUl$current = _this._refUl.current) === null || _this$_refUl$current === void 0 ? void 0 : _this$_refUl$current.querySelector('li.dnb-drawer-list__option--selected')) || _this._refUl.current || {
        getAttribute: function getAttribute() {
          return null;
        }
      };
    };

    _this.getCurrentSelectedItem = function () {
      var elem = _this.getSelectedElement();

      return parseFloat(elem && elem.getAttribute('data-item'));
    };

    _this.getActiveElement = function () {
      var _this$_refUl$current2;

      return ((_this$_refUl$current2 = _this._refUl.current) === null || _this$_refUl$current2 === void 0 ? void 0 : _this$_refUl$current2.querySelector('li.dnb-drawer-list__option--focus')) || _this.getSelectedElement();
    };

    _this.getCurrentActiveItem = function () {
      var elem = _this.getActiveElement();

      return parseFloat(elem && elem.getAttribute('data-item'));
    };

    _this.getNextActiveItem = function () {
      var elem = _this.getActiveElement().nextSibling;

      return parseFloat(elem && elem.getAttribute('data-item'));
    };

    _this.getPrevActiveItem = function () {
      var elem = _this.getActiveElement().previousSibling;

      return parseFloat(elem && elem.getAttribute('data-item'));
    };

    _this.getFirstItem = function () {
      var _this$_refUl$current3;

      var elem = (_this$_refUl$current3 = _this._refUl.current) === null || _this$_refUl$current3 === void 0 ? void 0 : _this$_refUl$current3.querySelector('li.dnb-drawer-list__option.first-of-type');
      return parseFloat(elem && elem.getAttribute('data-item'));
    };

    _this.getLastItem = function () {
      var _this$_refUl$current4;

      var elem = (_this$_refUl$current4 = _this._refUl.current) === null || _this$_refUl$current4 === void 0 ? void 0 : _this$_refUl$current4.querySelector('li.dnb-drawer-list__option.last-of-type');
      return parseFloat(elem && elem.getAttribute('data-item'));
    };

    _this.setOutsideClickObserver = function () {
      _this.removeOutsideClickObserver();

      _this.outsideClick = (0, _componentHelper.detectOutsideClick)([_this.state.wrapper_element, _this._refRoot.current, _this._refUl.current], _this.setHidden);

      if (typeof document !== 'undefined') {
        document.addEventListener('keydown', _this.onKeyDownHandler);
        document.addEventListener('keyup', _this.onKeyUpHandler);
      }
    };

    _this.assignObservers = function () {
      _this.setDirectionObserver();

      _this.setScrollObserver();

      _this.setOutsideClickObserver();
    };

    _this.setVisible = function () {
      clearTimeout(_this._hideTimeout);

      if (_this.state.opened && _this.state.hidden === false) {
        return;
      }

      _this.searchCache = null;

      _this.setState({
        hidden: false,
        opened: true,
        _listenForPropChanges: false
      }, _this.assignObservers);

      var delayHandler = function delayHandler() {
        _this.setState({
          isOpen: true,
          _listenForPropChanges: false
        });
      };

      if ((0, _componentHelper.isTrue)(_this.props.no_animation)) {
        delayHandler();
      } else {
        _this._hideTimeout = setTimeout(delayHandler, DrawerListProvider.blurDelay);
      }

      var _this$state = _this.state,
          selected_item = _this$state.selected_item,
          active_item = _this$state.active_item;
      (0, _componentHelper.dispatchCustomElementEvent)(_this.state, 'on_show', {
        data: (0, _DrawerListHelpers.getEventData)(parseFloat(selected_item) > -1 ? selected_item : active_item, _this.state.data),
        attributes: _this.attributes,
        ulElement: _this._refUl.current
      });
    };

    _this.setHidden = function () {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var onStateComplete = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (!_this.state.opened || (0, _componentHelper.isTrue)(_this.props.prevent_close)) {
        if (typeof onStateComplete === 'function') {
          onStateComplete();
        }

        return;
      }

      clearTimeout(_this._hideTimeout);
      var _this$state2 = _this.state,
          selected_item = _this$state2.selected_item,
          active_item = _this$state2.active_item;
      var res = (0, _componentHelper.dispatchCustomElementEvent)(_this.state, 'on_hide', _extends({}, args, {
        data: (0, _DrawerListHelpers.getEventData)(parseFloat(selected_item) > -1 ? selected_item : active_item, _this.state.data),
        attributes: _this.attributes
      }));

      if (res !== false) {
        _this.setState({
          opened: false,
          _listenForPropChanges: false
        });

        var delayHandler = function delayHandler() {
          _this.setState({
            hidden: true,
            isOpen: false,
            _listenForPropChanges: false
          });

          if (typeof onStateComplete === 'function') {
            onStateComplete();
          }
        };

        if ((0, _componentHelper.isTrue)(_this.props.no_animation)) {
          delayHandler();
        } else {
          _this._hideTimeout = setTimeout(delayHandler, DrawerListProvider.blurDelay);
        }

        _this.waitUntilUlIsReady = false;

        _this.removeDirectionObserver();

        _this.removeScrollObserver();

        _this.removeOutsideClickObserver();
      }
    };

    _this.setDataHandler = function (data) {
      var cb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      var _ref3 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
          _ref3$overwriteOrigin = _ref3.overwriteOriginalData,
          overwriteOriginalData = _ref3$overwriteOrigin === void 0 ? false : _ref3$overwriteOrigin;

      if (!data) {
        return;
      }

      if (typeof data === 'function') {
        data = (0, _DrawerListHelpers.getData)(data);
      }

      data = (0, _DrawerListHelpers.normalizeData)(data);

      _this.setState({
        data: data,
        original_data: overwriteOriginalData ? data : _this.state.original_data,
        _listenForPropChanges: false
      }, function () {
        _this.refreshScrollObserver();

        typeof cb === 'function' && cb(data);
      });

      return _assertThisInitialized(_this);
    };

    _this.setStateHandler = function (state) {
      var cb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.setState(_extends({}, state, {
        _listenForPropChanges: false
      }), cb);

      return _assertThisInitialized(_this);
    };

    _this.selectItem = function (itemToSelect) {
      var _ref4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref4$fireSelectEvent = _ref4.fireSelectEvent,
          fireSelectEvent = _ref4$fireSelectEvent === void 0 ? false : _ref4$fireSelectEvent,
          _ref4$event = _ref4.event,
          event = _ref4$event === void 0 ? null : _ref4$event;

      if (event && typeof event.persist === 'function') {
        event.persist();
      }

      if (itemToSelect === -1) {
        itemToSelect = null;
      }

      var data = (0, _DrawerListHelpers.getEventData)(itemToSelect, _this.state.data) || null;
      var value = (0, _DrawerListHelpers.getSelectedItemValue)(itemToSelect, _this.state);
      var attributes = _this.attributes;
      var attr = {
        selected_item: itemToSelect,
        value: value,
        data: data,
        event: event,
        attributes: attributes
      };
      var res = (0, _componentHelper.dispatchCustomElementEvent)(_this.state, 'on_pre_change', attr);

      if (res === false || (0, _helpers.hasSelectedText)()) {
        return;
      }

      var _this$props = _this.props,
          keep_open = _this$props.keep_open,
          no_animation = _this$props.no_animation,
          prevent_selection = _this$props.prevent_selection;
      var doCallOnChange = _this.state.selected_item !== itemToSelect;

      var onSelectionIsComplete = function onSelectionIsComplete() {
        var delayHandler = function delayHandler() {
          if (doCallOnChange) {
            (0, _componentHelper.dispatchCustomElementEvent)(_this.state, 'on_change', attr);
          }

          if (fireSelectEvent) {
            (0, _componentHelper.dispatchCustomElementEvent)(_this.state, 'on_select', _extends({}, attr, {
              active_item: itemToSelect
            }));
          }

          if (!(0, _componentHelper.isTrue)(keep_open)) {
            _this.setHidden();
          }
        };

        if ((0, _componentHelper.isTrue)(no_animation)) {
          delayHandler();
        } else {
          clearTimeout(_this._selectTimeout);
          _this._selectTimeout = setTimeout(delayHandler, DrawerListProvider.blurDelay / 2);
        }
      };

      if ((0, _componentHelper.isTrue)(prevent_selection)) {
        onSelectionIsComplete();
      } else {
        _this.setState({
          _listenForPropChanges: false,
          selected_item: itemToSelect,
          active_item: itemToSelect
        }, onSelectionIsComplete);
      }
    };

    _this.attributes = {};
    _this.state = _extends({
      tagName: 'dnb-drawer-list',
      cache_hash: '',
      active_item: null,
      selected_item: null,
      ignore_events: false
    }, (0, _DrawerListHelpers.prepareStartupState)(props), {
      _listenForPropChanges: true
    });
    _this._refRoot = _react.default.createRef();
    _this._refShell = _react.default.createRef();
    _this._refUl = _react.default.createRef();
    _this._refTriangle = _react.default.createRef();
    return _this;
  }

  _createClass(DrawerListProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if ((0, _componentHelper.isTrue)(this.props.opened)) {
        this.setVisible();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.opened !== null && this.props.opened !== prevProps.opened) {
        if ((0, _componentHelper.isTrue)(this.props.opened)) {
          this.setVisible();
        } else if ((0, _componentHelper.isTrue)(this.props.opened) === false) {
          this.setHidden();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this._outsideClickTimeout);
      clearTimeout(this._hideTimeout);
      clearTimeout(this._selectTimeout);
      clearTimeout(this._scrollTimeout);
      clearTimeout(this._ddTimeout);
      clearTimeout(this._doTimeout);
      this.setState({
        opened: false,
        _listenForPropChanges: false
      });
      this.removeDirectionObserver();
      this.removeScrollObserver();
      this.removeOutsideClickObserver();
    }
  }, {
    key: "refreshScrollObserver",
    value: function refreshScrollObserver() {
      var _this2 = this;

      if (typeof window === 'undefined' || !this._refUl.current) {
        return;
      }

      this.itemSpots = this.state.data.reduce(function (acc, cur, i) {
        var _this2$_refUl$current;

        var element = (_this2$_refUl$current = _this2._refUl.current) === null || _this2$_refUl$current === void 0 ? void 0 : _this2$_refUl$current.querySelector("li.dnb-drawer-list__option:nth-of-type(".concat(i + 1, ")"));

        if (element) {
          acc[element.offsetTop] = {
            i: i
          };
        }

        return acc;
      }, {});
      this.itemSpotsCount = Object.keys(this.itemSpots).length;
    }
  }, {
    key: "setScrollObserver",
    value: function setScrollObserver() {
      var _this3 = this;

      if (!(0, _componentHelper.isTrue)(this.props.enable_closest_observer) || typeof window === 'undefined' || !this._refUl.current) {
        return;
      }

      this.removeScrollObserver();
      this.itemSpotsCount = 1;

      try {
        var closestToTop = null,
            closestToBottom = null,
            tmpToTop,
            tmpToBottom;

        this.setOnScroll = function () {
          if (!_this3._refUl.current) {
            return;
          }

          if (_this3.itemSpotsCount <= 1) {
            _this3.refreshScrollObserver();
          }

          var counts = Object.keys(_this3.itemSpots);
          closestToBottom = (0, _DrawerListHelpers.findClosest)(counts, _this3._refUl.current.scrollTop + _this3._refUl.current.offsetHeight);
          closestToTop = (0, _DrawerListHelpers.findClosest)(counts, _this3._refUl.current.scrollTop);

          if (_this3.itemSpots[closestToTop] && closestToTop !== tmpToTop) {
            _this3.setState({
              closestToTop: _this3.itemSpots[closestToTop].i,
              _listenForPropChanges: false
            });
          }

          if (closestToBottom !== tmpToBottom && _this3.itemSpots[closestToBottom]) {
            _this3.setState({
              closestToBottom: _this3.itemSpots[closestToBottom].i,
              _listenForPropChanges: false
            });
          }

          tmpToTop = closestToTop;
          tmpToBottom = closestToBottom;
        };

        this._refUl.current.addEventListener('scroll', this.setOnScroll);

        this.setOnScroll();
      } catch (e) {
        (0, _componentHelper.warn)('List could not set onScroll:', e);
      }
    }
  }, {
    key: "removeScrollObserver",
    value: function removeScrollObserver() {
      if (typeof window !== 'undefined' && this.setOnScroll) {
        window.removeEventListener('resize', this.setOnScroll);
        this.setOnScroll = null;
      }
    }
  }, {
    key: "setDirectionObserver",
    value: function setDirectionObserver() {
      var _this4 = this;

      if (typeof window === 'undefined' || typeof document === 'undefined' || !(this.state.wrapper_element || this._refRoot.current)) {
        return;
      }

      var _this$props2 = this.props,
          enable_body_lock = _this$props2.enable_body_lock,
          use_drawer_on_mobile = _this$props2.use_drawer_on_mobile,
          scrollable = _this$props2.scrollable,
          min_height = _this$props2.min_height,
          max_height = _this$props2.max_height,
          on_resize = _this$props2.on_resize,
          page_offset = _this$props2.page_offset,
          observer_element = _this$props2.observer_element;
      var useBodyLock = (0, _componentHelper.isTrue)(enable_body_lock);
      var useDrawer = (0, _componentHelper.isTrue)(use_drawer_on_mobile);
      var isScrollable = (0, _componentHelper.isTrue)(scrollable);
      var customMinHeight = parseFloat(min_height) * 16;
      var customMaxHeight = parseFloat(max_height) || 0;
      var customElem = typeof observer_element === 'string' ? document.querySelector(observer_element) : null;

      if (!customElem) {
        customElem = (0, _componentHelper.isInsideScrollView)(this._refRoot.current, true);
      }

      this.removeDirectionObserver();
      var directionOffset = 96;
      var spaceToTopOffset = 2 * 16;
      var spaceToBottomOffset = 2 * 16;
      var elem = this.state.wrapper_element || this._refRoot.current;

      var renderDirection = function renderDirection() {
        try {
          var rootElem = customElem || document.documentElement;
          var pageYOffset = !isNaN(parseFloat(page_offset)) ? parseFloat(page_offset) : rootElem.scrollTop;
          var spaceToTop = (0, _helpers.getOffsetTop)(elem) + elem.offsetHeight - pageYOffset;
          var spaceToBottom = rootElem.clientHeight - ((0, _helpers.getOffsetTop)(elem) + elem.offsetHeight) + pageYOffset;
          var direction = Math.max(spaceToBottom - directionOffset, directionOffset) < customMinHeight && spaceToTop > customMinHeight ? 'top' : 'bottom';
          var _max_height = customMaxHeight;

          if (!(_max_height > 0)) {
            _max_height = direction === 'top' ? spaceToTop - ((_this4.state.wrapper_element || _this4._refRoot.current).offsetHeight || 0) - spaceToTopOffset : spaceToBottom - spaceToBottomOffset;
            var vh = 0;

            if (typeof window.visualViewport !== 'undefined') {
              vh = window.visualViewport.height;
            } else {
              vh = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
            }

            vh = vh * (isScrollable ? 0.7 : 0.9);

            if (_max_height > vh) {
              _max_height = vh;
            }

            _max_height = (0, _componentHelper.roundToNearest)(_max_height, 8) / 16;
          }

          if (_this4.props.direction === 'auto') {
            _this4.setState({
              direction: direction,
              _listenForPropChanges: false
            });
          }

          _this4.setState({
            max_height: _max_height,
            _listenForPropChanges: false
          });

          if (on_resize) {
            (0, _componentHelper.dispatchCustomElementEvent)(_this4.state, 'on_resize', {
              direction: direction,
              max_height: _max_height
            });
          }
        } catch (e) {
          (0, _componentHelper.warn)('List could not set onResize:', e);
        }
      };

      this.setDirection = function (e) {
        clearTimeout(_this4._ddTimeout);
        _this4._ddTimeout = setTimeout(renderDirection, 30);

        if (useDrawer && e.type === 'resize') {
          if (!_this4._bodyLockIsEnabled && (window.innerWidth / 16 <= 40 || window.innerHeight / 16 <= 40)) {
            _this4.enableBodyLock();
          } else if (_this4._bodyLockIsEnabled && !useBodyLock) {
            _this4.disableBodyLock();
          }
        }

        if (e.type === 'resize') {
          _this4.correctHiddenView();
        }
      };

      this._rootElem = customElem || window;

      this._rootElem.addEventListener('scroll', this.setDirection);

      if (typeof window.visualViewport !== 'undefined') {
        window.visualViewport.addEventListener('scroll', this.setDirection);
        window.visualViewport.addEventListener('resize', this.setDirection);
      } else {
        window.addEventListener('resize', this.setDirection);
      }

      clearTimeout(this._doTimeout);
      this._doTimeout = setTimeout(function () {
        if (useBodyLock || useDrawer && (window.innerWidth / 16 <= 40 || window.innerHeight / 16 <= 40)) {
          _this4.enableBodyLock();
        }

        _this4.correctHiddenView();

        _this4.refreshScrollObserver();

        var _this4$state = _this4.state,
            selected_item = _this4$state.selected_item,
            active_item = _this4$state.active_item;

        _this4.scrollToAndSetActiveItem(parseFloat(active_item) > -1 ? active_item : selected_item, {
          scrollTo: false
        });
      }, 1);
      renderDirection();
    }
  }, {
    key: "correctHiddenView",
    value: function correctHiddenView() {
      try {
        var ui = this._refUl.current;
        var spaceToLeft = (0, _helpers.getOffsetLeft)(ui);
        var spaceToRight = window.innerWidth - ((0, _helpers.getOffsetLeft)(ui) + ui.offsetWidth);
        var tri = this._refTriangle.current.style;
        var shell = this._refShell.current.style;

        if (spaceToLeft < 0) {
          shell.transform = "translateX(".concat(Math.abs(spaceToLeft), "px)");
          tri.right = "".concat(Math.abs(spaceToLeft), "px");
        } else if (spaceToRight < 0) {
          shell.transform = "translateX(".concat(spaceToRight, "px)");
          tri.left = "".concat(Math.abs(spaceToRight), "px");
        } else {
          if (shell.transform) {
            shell.transform = '';
            tri.left = 'auto';
            tri.right = 'auto';
          }
        }
      } catch (e) {}
    }
  }, {
    key: "findItemByValue",
    value: function findItemByValue(value) {
      if ((0, _componentHelper.isTrue)(this.props.skip_keysearch)) {
        return;
      }

      var index = -1;

      try {
        value = String(value).toLowerCase();

        if (this.changedOrderFor !== value) {
          this.searchCache = null;
          this.changedOrderFor = null;
        }

        this.searchCache = this.searchCache || this.state.data.reduce(function (acc, itemData, i) {
          var str = String((0, _DrawerListHelpers.parseContentTitle)(itemData, {
            separator: ' ',
            removeNumericOnlyValues: true
          }));
          var firstLetter = String(str[0]).toLowerCase();
          acc[firstLetter] = acc[firstLetter] || [];
          acc[firstLetter].push({
            i: i
          });
          return acc;
        }, {});
        var found = this.searchCache[value];
        index = found && found[0] && found[0].i > -1 ? found[0].i : -1;

        if (found && found.length > 1) {
          found.push(found.shift());
          this.changedOrderFor = value;
        }
      } catch (e) {
        (0, _componentHelper.warn)('List could not findItemByValue:', e);
      }

      return index;
    }
  }, {
    key: "removeDirectionObserver",
    value: function removeDirectionObserver() {
      this.disableBodyLock();
      clearTimeout(this._ddTimeout);

      if (typeof window !== 'undefined' && this.setDirection) {
        var _this$_rootElem;

        (_this$_rootElem = this._rootElem) === null || _this$_rootElem === void 0 ? void 0 : _this$_rootElem.removeEventListener('scroll', this.setDirection);

        if (typeof window.visualViewport !== 'undefined') {
          window.visualViewport.removeEventListener('scroll', this.setDirection);
          window.visualViewport.removeEventListener('resize', this.setDirection);
        } else {
          window.removeEventListener('resize', this.setDirection);
        }

        this.setDirection = null;
      }
    }
  }, {
    key: "getAnchorElem",
    value: function getAnchorElem() {
      try {
        return this.getActiveElement().querySelector('a:not(:focus):first-of-type');
      } catch (e) {
        return null;
      }
    }
  }, {
    key: "focusAnchorElem",
    value: function focusAnchorElem(elem) {
      if (elem) {
        elem.focus({
          preventScroll: true
        });

        if (!elem._hkh) {
          elem._hkh = true;
          elem.addEventListener('keydown', this.anchorKeyDownHandler);
        }
      }
    }
  }, {
    key: "removeOutsideClickObserver",
    value: function removeOutsideClickObserver() {
      if (this.outsideClick) {
        this.outsideClick.remove();
      }

      if (typeof document !== 'undefined') {
        document.removeEventListener('keydown', this.onKeyDownHandler);
        document.removeEventListener('keyup', this.onKeyUpHandler);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_DrawerListContext.default.Provider, {
        value: _extends({}, this.context, {
          drawerList: _extends({
            attributes: this.attributes,
            _refRoot: this._refRoot,
            _refShell: this._refShell,
            _refUl: this._refUl,
            _refTriangle: this._refTriangle,
            _rootElem: this._rootElem,
            getActiveElement: this.getActiveElement,
            setData: this.setDataHandler,
            setState: this.setStateHandler,
            setWrapperElement: this.setWrapperElement,
            assignObservers: this.assignObservers,
            setVisible: this.setVisible,
            setHidden: this.setHidden,
            selectItem: this.selectItem,
            scrollToItem: this.scrollToItem,
            scrollToAndSetActiveItem: this.scrollToAndSetActiveItem
          }, this.state)
        })
      }, this.props.children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return (0, _DrawerListHelpers.prepareDerivedState)(props, state);
    }
  }]);

  return DrawerListProvider;
}(_react.default.PureComponent);

exports.default = DrawerListProvider;
DrawerListProvider.contextType = _Context.default;
DrawerListProvider.defaultProps = {
  no_animation: false,
  prevent_selection: false,
  direction: 'auto',
  wrapper_element: null,
  prevent_close: false,
  keep_open: false,
  prevent_focus: false,
  skip_keysearch: false,
  use_drawer_on_mobile: null,
  enable_body_lock: null,
  page_offset: null,
  observer_element: null,
  enable_closest_observer: null,
  opened: null,
  scrollable: null,
  min_height: 10,
  max_height: null,
  on_resize: null,
  children: null
};
DrawerListProvider.blurDelay = 201;
process.env.NODE_ENV !== "production" ? DrawerListProvider.propTypes = {
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_selection: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  direction: _propTypes.default.oneOf(['auto', 'top', 'bottom']),
  wrapper_element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.func, _propTypes.default.node]),
  prevent_close: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  keep_open: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_focus: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skip_keysearch: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  use_drawer_on_mobile: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  enable_body_lock: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  page_offset: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  observer_element: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  enable_closest_observer: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  opened: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  scrollable: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  min_height: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  max_height: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  on_resize: _propTypes.default.func,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node, _propTypes.default.object, _propTypes.default.array])
} : void 0;