"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "DrawerList", {
  enumerable: true,
  get: function get() {
    return _DrawerList.default;
  }
});
Object.defineProperty(exports, "ScrollView", {
  enumerable: true,
  get: function get() {
    return _ScrollView.default;
  }
});
exports.default = exports.enableWebFragments = exports.getFragments = void 0;

var _componentHelper = require("../shared/component-helper");

var _DrawerList = _interopRequireDefault(require("./drawer-list/DrawerList"));

var _ScrollView = _interopRequireDefault(require("./scroll-view/ScrollView"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getFragments = function getFragments() {
  return {
    DrawerList: _DrawerList.default,
    ScrollView: _ScrollView.default
  };
};

exports.getFragments = getFragments;
var webFragmentsAreEnabled = false;

var enableWebFragments = function enableWebFragments() {
  if (webFragmentsAreEnabled) return false;
  webFragmentsAreEnabled = true;
  var fragments = getFragments();

  for (var c in fragments) {
    if (fragments[c] && fragments[c].tagName) {
      (0, _componentHelper.registerElement)(fragments[c].tagName, fragments[c], fragments[c].defaultProps);
    }
  }
};

exports.enableWebFragments = enableWebFragments;
var _default = {
  enableWebFragments: enableWebFragments
};
exports.default = _default;