"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _Button = _interopRequireDefault(require("../../components/button/Button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var ActionNav = function (_React$PureComponent) {
  _inherits(ActionNav, _React$PureComponent);

  var _super = _createSuper(ActionNav);

  function ActionNav() {
    _classCallCheck(this, ActionNav);

    return _super.apply(this, arguments);
  }

  _createClass(ActionNav, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          prev_href = _this$props.prev_href,
          next_href = _this$props.next_href,
          prev_text = _this$props.prev_text,
          next_text = _this$props.next_text,
          prev_title = _this$props.prev_title,
          next_title = _this$props.next_title,
          className = _this$props.className,
          _className = _this$props.class;
      var params = {
        className: (0, _classnames.default)("dnb-action-nav dnb-belt", className, _className)
      };
      var hasNavAttributes = prev_href && next_href;
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement("div", params, _react.default.createElement("div", {
        className: "dnb-width-limit"
      }, _react.default.createElement("div", {
        className: "dnb-action-nav__inner"
      }, hasNavAttributes && _react.default.createElement(_react.default.Fragment, null, _react.default.createElement("div", {
        className: "dnb-action-nav__left"
      }, prev_href && _react.default.createElement("div", {
        className: "dnb-action-nav__item"
      }, _react.default.createElement(_Button.default, {
        type: "button",
        text: prev_text,
        title: prev_title,
        variant: "secondary",
        icon_position: "left",
        icon: "chevron_left",
        href: prev_href
      })), next_href && _react.default.createElement("div", {
        className: "dnb-action-nav__item"
      }, _react.default.createElement(_Button.default, {
        text: next_text,
        title: next_title,
        variant: "primary",
        icon: "chevron_right",
        href: next_href
      }))), _react.default.createElement("div", {
        className: "dnb-action-nav__right"
      }, children)) || children)));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(ActionNav.tagName, ActionNav, ActionNav.defaultProps);
    }
  }]);

  return ActionNav;
}(_react.default.PureComponent);

exports.default = ActionNav;
ActionNav.tagName = 'dnb-action-nav';
ActionNav.defaultProps = {
  prev_href: null,
  next_href: null,
  prev_text: 'Back',
  next_text: 'Next',
  prev_title: 'Go back',
  next_title: 'Go next',
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? ActionNav.propTypes = {
  prev_href: _propTypes.default.string,
  next_href: _propTypes.default.string,
  prev_text: _propTypes.default.string,
  next_text: _propTypes.default.string,
  prev_title: _propTypes.default.string,
  next_title: _propTypes.default.string,
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
} : void 0;