"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DescriptionList = function (_React$PureComponent) {
  _inherits(DescriptionList, _React$PureComponent);

  var _super = _createSuper(DescriptionList);

  function DescriptionList(props) {
    var _this;

    _classCallCheck(this, DescriptionList);

    _this = _super.call(this, props);
    _this.state = {
      _listenForPropChanges: true,
      _data: props.data || props.children,
      data: DescriptionList.getData(props)
    };
    return _this;
  }

  _createClass(DescriptionList, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          info = _this$props.info,
          className = _this$props.className,
          _className = _this$props.class;
      var data = DescriptionList.getData(this.props);
      var params = {
        className: (0, _classnames.default)('dnb-description-list', className, _className)
      };
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement("div", params, data.length > 0 && _react.default.createElement("dl", {
        className: "dnb-description-list__dl typo-light"
      }, data.map(function (_ref, i) {
        var title = _ref.title,
            value = _ref.value;
        return _react.default.createElement(_react.default.Fragment, {
          key: "dl".concat(i)
        }, _react.default.createElement("dt", {
          className: "dnb-description-list__dt"
        }, title), _react.default.createElement("dd", {
          className: "dnb-description-list__dd"
        }, value));
      })), info && _react.default.createElement("p", {
        className: "dnb-description-list__info dnb-typo-regular"
      }, info));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(DescriptionList.tagName, DescriptionList, DescriptionList.defaultProps);
    }
  }, {
    key: "getData",
    value: function getData(props) {
      var res = [];
      if (props.data) res = props.data;else res = (0, _componentHelper.processChildren)(props);
      if (typeof res === 'string') return res[0] === '[' ? JSON.parse(res) : [];
      return res || [];
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.data) {
          if (state._data !== props.data) {
            state._data = props.data;
            state.data = DescriptionList.getData(props);
          }
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return DescriptionList;
}(_react.default.PureComponent);

exports.default = DescriptionList;
DescriptionList.tagName = 'dnb-description-list';
DescriptionList.defaultProps = {
  data: [],
  info: null,
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? DescriptionList.propTypes = {
  data: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.arrayOf(_propTypes.default.exact({
    title: _propTypes.default.string.isRequired,
    value: _propTypes.default.string.isRequired
  }))]).isRequired,
  info: _propTypes.default.string,
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
} : void 0;