"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.find.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "ProductType", {
  enumerable: true,
  get: function get() {
    return _Types.ProductType;
  }
});
Object.defineProperty(exports, "CardType", {
  enumerable: true,
  get: function get() {
    return _Types.CardType;
  }
});
Object.defineProperty(exports, "Designs", {
  enumerable: true,
  get: function get() {
    return _CardDesigns.default;
  }
});
exports.getCardData = exports.formatCardNumber = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Provider = _interopRequireDefault(require("../../shared/Provider"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../../components/space/SpacingHelper");

var _SkeletonHelper = require("../../components/skeleton/SkeletonHelper");

var _P = _interopRequireDefault(require("../../elements/P"));

var _Types = require("./utils/Types");

var _CardDesigns = _interopRequireWildcard(require("./utils/CardDesigns"));

var _cardProducts = _interopRequireDefault(require("./utils/cardProducts"));

var _icons = require("./icons");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var cardDataTypes = process.env.NODE_ENV !== "production" ? _propTypes.default.shape({
  productCode: _propTypes.default.string.isRequired,
  productName: _propTypes.default.string.isRequired,
  displayName: _propTypes.default.string.isRequired,
  cardDesign: _propTypes.default.shape.isRequired,
  cardType: _propTypes.default.shape.isRequired,
  productType: _propTypes.default.shape.isRequired
}) : {};
var translationDefaultPropsProps = {
  text_card_number: null,
  text_expired: null,
  text_blocked: null
};

var PaymentCard = function (_React$PureComponent) {
  _inherits(PaymentCard, _React$PureComponent);

  var _super = _createSuper(PaymentCard);

  function PaymentCard() {
    _classCallCheck(this, PaymentCard);

    return _super.apply(this, arguments);
  }

  _createClass(PaymentCard, [{
    key: "render",
    value: function render() {
      var _this$context,
          _this = this;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, PaymentCard.defaultProps, {
        locale: this.context.locale
      }, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      });

      var product_code = props.product_code,
          card_number = props.card_number,
          card_status = props.card_status,
          variant = props.variant,
          digits = props.digits,
          id = props.id,
          raw_data = props.raw_data,
          locale = props.locale,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["product_code", "card_number", "card_status", "variant", "digits", "id", "raw_data", "locale", "skeleton", "className", "class", "children"]);

      var cardData = raw_data || getCardData(product_code);

      var params = _extends({
        className: (0, _classnames.default)("dnb-payment-card dnb-payment-card--".concat(variant), (0, _SkeletonHelper.createSkeletonClass)(null, skeleton, this.context), (0, _SpacingHelper.createSpacingClasses)(props), className, _className)
      }, attributes);

      (0, _SkeletonHelper.skeletonDOMAttributes)(params, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement(_Provider.default, {
        locale: locale
      }, _react.default.createElement(_Context.default.Consumer, null, function (_ref) {
        var translation = _ref.translation;
        var translations = (0, _componentHelper.extendPropsWithContext)(_this.props, translationDefaultPropsProps, translation.PaymentCard);
        return _react.default.createElement("figure", params, _react.default.createElement("figcaption", {
          className: "dnb-sr-only dnb-payment-card__figcaption"
        }, cardData.productName), _react.default.createElement(NormalCard, {
          id: id,
          skeleton: (0, _componentHelper.isTrue)(skeleton),
          data: cardData,
          cardStatus: card_status,
          cardNumber: formatCardNumber(card_number, parseFloat(digits)),
          translations: translations
        }));
      }));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(PaymentCard.tagName, PaymentCard, PaymentCard.defaultProps);
    }
  }]);

  return PaymentCard;
}(_react.default.PureComponent);

exports.default = PaymentCard;
PaymentCard.tagName = 'dnb-payment-card';
PaymentCard.contextType = _Context.default;
PaymentCard.defaultProps = _extends({
  digits: 8,
  locale: null,
  card_status: 'active',
  variant: 'normal',
  id: null,
  raw_data: null,
  skeleton: false,
  class: null,
  className: null,
  children: null
}, translationDefaultPropsProps);
process.env.NODE_ENV !== "production" ? PaymentCard.propTypes = _extends({
  product_code: _propTypes.default.string.isRequired,
  card_number: _propTypes.default.string.isRequired,
  card_status: _propTypes.default.oneOf(['active', 'blocked', 'expired']),
  variant: _propTypes.default.oneOf(['normal', 'compact']),
  digits: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  raw_data: cardDataTypes,
  id: _propTypes.default.string,
  locale: _propTypes.default.string,
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func])
}) : void 0;
var formatCardNumberRegex = /(?=(?:....)*$)/g;

var formatCardNumber = function formatCardNumber(cardNumber, digits) {
  return digits ? cardNumber.slice(cardNumber.length - digits, cardNumber.length).replace(formatCardNumberRegex, ' ') : cardNumber.replace(formatCardNumberRegex, ' ');
};

exports.formatCardNumber = formatCardNumber;

var getCardData = function getCardData(productCode) {
  var card = _cardProducts.default.find(function (item) {
    return item.productCode === productCode;
  });

  return card || defaultCard(productCode);
};

exports.getCardData = getCardData;

var defaultCard = function defaultCard(productCode) {
  return {
    productCode: productCode,
    productName: '',
    displayName: '',
    cardDesign: _CardDesigns.defaultDesign,
    cardType: _Types.CardType.None,
    productType: _Types.ProductType.None
  };
};

process.env.NODE_ENV !== "production" ? StatusOverlay.propTypes = {
  cardStatus: _propTypes.default.string.isRequired,
  translations: _propTypes.default.object.isRequired,
  skeleton: _propTypes.default.bool
} : void 0;
StatusOverlay.defaultProps = {
  skeleton: false
};

function StatusOverlay(_ref2) {
  var cardStatus = _ref2.cardStatus,
      translations = _ref2.translations,
      skeleton = _ref2.skeleton;

  switch (cardStatus) {
    case 'blocked':
      return _react.default.createElement("div", {
        className: (0, _classnames.default)('dnb-payment-card__blocking__overlay', (0, _SkeletonHelper.createSkeletonClass)('font', skeleton))
      }, _react.default.createElement("div", {
        className: "dnb-payment-card__blocking__center"
      }, _react.default.createElement(_icons.StatusIcon, {
        status: cardStatus
      }), _react.default.createElement(_P.default, {
        top: "xx-small"
      }, translations.text_blocked)));

    case 'expired':
      return _react.default.createElement("div", {
        className: (0, _classnames.default)('dnb-payment-card__blocking__overlay', (0, _SkeletonHelper.createSkeletonClass)('font', skeleton))
      }, _react.default.createElement("div", {
        className: "dnb-payment-card__blocking__center"
      }, _react.default.createElement(_icons.StatusIcon, {
        status: cardStatus
      }), _react.default.createElement(_P.default, {
        top: "xx-small"
      }, translations.text_expired)));

    case 'active':
    default:
      return null;
  }
}

process.env.NODE_ENV !== "production" ? CardText.propTypes = {
  cardNumber: _propTypes.default.string.isRequired,
  translations: _propTypes.default.object.isRequired,
  skeleton: _propTypes.default.bool.isRequired
} : void 0;

function CardText(_ref3) {
  var cardNumber = _ref3.cardNumber,
      translations = _ref3.translations,
      skeleton = _ref3.skeleton;
  return _react.default.createElement("span", {
    className: (0, _classnames.default)('dnb-payment-card__card__wrapper', (0, _SkeletonHelper.createSkeletonClass)('font', skeleton))
  }, _react.default.createElement(_P.default, {
    className: "dnb-payment-card__card__holder",
    modifier: "x-small bold"
  }, translations.text_card_number), _react.default.createElement(_P.default, {
    className: "dnb-payment-card__card__numbers"
  }, cardNumber));
}

process.env.NODE_ENV !== "production" ? NormalCard.propTypes = {
  id: _propTypes.default.string,
  skeleton: _propTypes.default.bool,
  data: cardDataTypes.isRequired,
  cardStatus: _propTypes.default.string.isRequired,
  cardNumber: _propTypes.default.string.isRequired,
  translations: _propTypes.default.object.isRequired
} : void 0;
NormalCard.defaultProps = {
  id: null,
  skeleton: null
};

function NormalCard(_ref4) {
  var data = _ref4.data,
      cardStatus = _ref4.cardStatus,
      cardNumber = _ref4.cardNumber,
      id = _ref4.id,
      skeleton = _ref4.skeleton,
      translations = _ref4.translations;
  return _react.default.createElement("div", {
    id: id,
    className: "dnb-payment-card__card dnb-payment-card__".concat(data.cardDesign.cardStyle)
  }, _react.default.createElement("div", {
    className: "dnb-payment-card__card__content"
  }, _react.default.createElement("div", {
    className: "dnb-payment-card__card__top"
  }, _react.default.createElement(_icons.BankLogo, {
    logoType: data.cardDesign.bankLogo
  }), _react.default.createElement(_icons.ProductLogo, {
    productType: data.productType,
    cardDesign: data.cardDesign
  })), _react.default.createElement("div", {
    className: "dnb-payment-card__card__bottom"
  }, _react.default.createElement(CardText, {
    cardNumber: cardNumber,
    displayName: data.displayName,
    translations: translations,
    skeleton: skeleton
  }), _react.default.createElement(_icons.TypeLogo, {
    cardType: data.cardType,
    cardDesign: data.cardDesign
  }))), _react.default.createElement(StatusOverlay, {
    skeleton: skeleton,
    cardStatus: cardStatus,
    translations: translations
  }));
}