"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypeLogo = exports.StatusIcon = exports.ProductLogo = exports.BankLogo = void 0;

var _react = _interopRequireDefault(require("react"));

var _BankAxept2 = _interopRequireDefault(require("./BankAxept"));

var _DNB = _interopRequireDefault(require("./DNB"));

var _DNBMetalic = _interopRequireDefault(require("./DNBMetalic"));

var _Clock = _interopRequireDefault(require("./Clock"));

var _Padlock = _interopRequireDefault(require("./Padlock"));

var _MastercardDefault = _interopRequireDefault(require("./MastercardDefault"));

var _MastercardMetalic = _interopRequireDefault(require("./MastercardMetalic"));

var _MastercardMetalicBlack = _interopRequireDefault(require("./MastercardMetalicBlack"));

var _Pluss2 = _interopRequireDefault(require("./Pluss"));

var _PB = _interopRequireDefault(require("./PB"));

var _PBPlatinum = _interopRequireDefault(require("./PBPlatinum"));

var _SagaGold = _interopRequireDefault(require("./SagaGold"));

var _SagaPlatinum = _interopRequireDefault(require("./SagaPlatinum"));

var _SagaVisaPlatinum = _interopRequireDefault(require("./SagaVisaPlatinum"));

var _VisaDefault = _interopRequireDefault(require("./VisaDefault"));

var _VisaMetalic = _interopRequireDefault(require("./VisaMetalic"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BankLogo = function BankLogo(_ref) {
  var logoType = _ref.logoType,
      height = _ref.height;

  var _ref2 = _react.default.createElement(_DNBMetalic.default, {
    height: height,
    className: "dnb-payment-card__card__bank-logo"
  });

  return logoType.cata({
    Colored: function Colored(color) {
      return _react.default.createElement(_DNB.default, {
        height: height,
        fill: color,
        className: "dnb-payment-card__card__bank-logo"
      });
    },
    Metalic: function Metalic() {
      return _ref2;
    }
  });
};

exports.BankLogo = BankLogo;

var ProductLogo = function ProductLogo(_ref3) {
  var productType = _ref3.productType,
      cardDesign = _ref3.cardDesign;
  var id = 'dnb-payment-card__card__product-type';

  var _ref4 = _react.default.createElement(_BankAxept2.default, {
    className: id,
    fill: "#ffffff"
  });

  var _ref5 = _react.default.createElement(_BankAxept2.default, {
    className: id,
    fill: "#757575"
  });

  var _ref6 = _react.default.createElement(_SagaGold.default, {
    className: id
  });

  var _ref7 = _react.default.createElement(_SagaPlatinum.default, {
    className: id
  });

  var _ref8 = _react.default.createElement(_SagaVisaPlatinum.default, {
    className: id
  });

  var _ref9 = _react.default.createElement(_Pluss2.default, {
    className: id,
    fill: "#A5E1D2"
  });

  var _ref10 = _react.default.createElement(_PB.default, {
    className: id
  });

  var _ref11 = _react.default.createElement(_PBPlatinum.default, {
    className: id
  });

  return productType.cata({
    BankAxept: function BankAxept() {
      return cardDesign.bankAxept.cata({
        White: function White() {
          return _ref4;
        },
        Black: function Black() {
          return _ref5;
        }
      });
    },
    Saga: function Saga() {
      return cardDesign.saga.cata({
        Gold: function Gold() {
          return _ref6;
        },
        Platinum: function Platinum() {
          return _ref7;
        },
        VisaPlatinum: function VisaPlatinum() {
          return _ref8;
        },
        None: function None() {
          return null;
        }
      });
    },
    Pluss: function Pluss() {
      return _ref9;
    },
    PrivateBanking: function PrivateBanking() {
      return cardDesign.privateBanking.cata({
        Default: function Default() {
          return _ref10;
        },
        Platinum: function Platinum() {
          return _ref11;
        },
        None: function None() {
          return null;
        }
      });
    },
    None: function None() {
      return null;
    }
  });
};

exports.ProductLogo = ProductLogo;

var _ref13 = _react.default.createElement(_Clock.default, null);

var _ref14 = _react.default.createElement(_Padlock.default, null);

var StatusIcon = function StatusIcon(_ref12) {
  var status = _ref12.status;

  switch (status) {
    case 'expired':
      return _ref13;

    case 'blocked':
      return _ref14;

    case 'active':
    default:
      return null;
  }
};

exports.StatusIcon = StatusIcon;

var TypeLogo = function TypeLogo(_ref15) {
  var cardType = _ref15.cardType,
      cardDesign = _ref15.cardDesign;
  var id = 'dnb-payment-card__card__credit-type';

  var _ref16 = _react.default.createElement(_VisaMetalic.default, {
    className: id
  });

  var _ref17 = _react.default.createElement(_MastercardDefault.default, {
    className: id
  });

  var _ref18 = _react.default.createElement(_MastercardDefault.default, {
    className: id,
    textFill: "#ffffff"
  });

  var _ref19 = _react.default.createElement(_MastercardMetalic.default, {
    className: id
  });

  var _ref20 = _react.default.createElement(_MastercardMetalicBlack.default, {
    className: id
  });

  return cardType.cata({
    Visa: function Visa() {
      return cardDesign.visa.cata({
        Colored: function Colored(color) {
          return _react.default.createElement(_VisaDefault.default, {
            className: id,
            fill: color
          });
        },
        Metalic: function Metalic() {
          return _ref16;
        }
      });
    },
    Mastercard: function Mastercard() {
      return cardDesign.mastercard.cata({
        Default: function Default() {
          return _ref17;
        },
        DefaultWhite: function DefaultWhite() {
          return _ref18;
        },
        Metalic: function Metalic() {
          return _ref19;
        },
        BlackMetalic: function BlackMetalic() {
          return _ref20;
        }
      });
    },
    None: function None() {
      return null;
    }
  });
};

exports.TypeLogo = TypeLogo;