"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.businessWithVisa = exports.businessNoVisa = exports.mcBlack = exports.privateBanking = exports.sagaPlatinum = exports.saga = exports.gold = exports.silver = exports.youth = exports.myFirst = exports.white = exports.pluss = exports.defaultDesign = exports.default = void 0;

var _properties = _interopRequireDefault(require("../../../style/properties"));

var _Types = require("./Types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultDesign = {
  name: 'Default',
  cardStyle: 'card--design-default',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-white']),
  visa: _Types.Visa.Colored(_properties.default['--color-white']),
  mastercard: _Types.Mastercard.DefaultWhite,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.defaultDesign = defaultDesign;
var pluss = {
  name: 'Pluss',
  cardStyle: 'card--design-pluss',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-mint-green']),
  visa: _Types.Visa.Colored(_properties.default['--color-white']),
  mastercard: _Types.Mastercard.DefaultWhite,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.pluss = pluss;
var white = {
  name: 'White',
  cardStyle: 'card--design-white',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-black-55']),
  visa: _Types.Visa.Colored(_properties.default['--color-black-55']),
  mastercard: _Types.Mastercard.Default,
  bankAxept: _Types.BankAxept.Black,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.white = white;
var myFirst = {
  name: 'My first',
  cardStyle: 'card--design-white',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-emerald-green']),
  visa: _Types.Visa.Colored(_properties.default['--color-black-55']),
  mastercard: _Types.Mastercard.Default,
  bankAxept: _Types.BankAxept.Black,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.myFirst = myFirst;
var youth = {
  name: 'Youth',
  cardStyle: 'card--design-white',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-summer-green']),
  visa: _Types.Visa.Colored(_properties.default['--color-black-55']),
  mastercard: _Types.Mastercard.Default,
  bankAxept: _Types.BankAxept.Black,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.youth = youth;
var silver = {
  name: 'Silver',
  cardStyle: 'card--design-silver',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-black-55']),
  visa: _Types.Visa.Colored(_properties.default['--color-black-55']),
  mastercard: _Types.Mastercard.Default,
  bankAxept: _Types.BankAxept.Black,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.silver = silver;
var gold = {
  name: 'Gold',
  cardStyle: 'card--design-gold',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-white']),
  visa: _Types.Visa.Colored(_properties.default['--color-white']),
  mastercard: _Types.Mastercard.DefaultWhite,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.gold = gold;
var saga = {
  name: 'Saga',
  cardStyle: 'card--design-saga',
  bankLogo: _Types.DNB.Colored('#CFAD88'),
  visa: _Types.Visa.Colored('#CFAD8899'),
  mastercard: _Types.Mastercard.DefaultWhite,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.Gold,
  privateBanking: _Types.PB.None
};
exports.saga = saga;
var sagaPlatinum = {
  name: 'Saga platinum',
  cardStyle: 'card--design-saga',
  bankLogo: _Types.DNB.Colored('#8C9091'),
  visa: _Types.Visa.Colored('#8C909199'),
  mastercard: _Types.Mastercard.DefaultWhite,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.Platinum,
  privateBanking: _Types.PB.None
};
exports.sagaPlatinum = sagaPlatinum;
var privateBanking = {
  name: 'Private Banking',
  cardStyle: 'card--design-private',
  bankLogo: _Types.DNB.Metalic,
  visa: _Types.Visa.Metalic,
  mastercard: _Types.Mastercard.Metalic,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.Default
};
exports.privateBanking = privateBanking;
var mcBlack = {
  name: 'Mastercard Black',
  cardStyle: 'card--design-black',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-black-80']),
  visa: _Types.Visa.Metalic,
  mastercard: _Types.Mastercard.BlackMetalic,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.mcBlack = mcBlack;
var businessNoVisa = {
  name: 'Bedriftskort BankAxept',
  cardStyle: 'card--design-business-no-visa',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-white']),
  visa: _Types.Visa.Colored(_properties.default['--color-white']),
  mastercard: _Types.Mastercard.DefaultWhite,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.businessNoVisa = businessNoVisa;
var businessWithVisa = {
  name: 'Bedriftskort Visa',
  cardStyle: 'card--design-business-with-visa',
  bankLogo: _Types.DNB.Colored(_properties.default['--color-white']),
  visa: _Types.Visa.Colored(_properties.default['--color-white']),
  mastercard: _Types.Mastercard.DefaultWhite,
  bankAxept: _Types.BankAxept.White,
  saga: _Types.Saga.None,
  privateBanking: _Types.PB.None
};
exports.businessWithVisa = businessWithVisa;
var Designs = {
  defaultDesign: defaultDesign,
  white: white,
  myFirst: myFirst,
  youth: youth,
  silver: silver,
  pluss: pluss,
  gold: gold,
  saga: saga,
  sagaPlatinum: sagaPlatinum,
  privateBanking: privateBanking,
  mcBlack: mcBlack,
  businessNoVisa: businessNoVisa,
  businessWithVisa: businessWithVisa
};
var _default = Designs;
exports.default = _default;