"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _CardDesigns = require("./CardDesigns");

var _Types = require("./Types");

var cardData = [{
  productCode: 'NK1',
  productName: 'DNB Kortet',
  displayName: 'DNB Kortet',
  cardDesign: _CardDesigns.defaultDesign,
  cardType: _Types.CardType.None,
  productType: _Types.ProductType.BankAxept
}, {
  productCode: 'NK4',
  productName: 'DNB Kortet',
  displayName: 'DNB Kortet',
  cardDesign: _CardDesigns.defaultDesign,
  cardType: _Types.CardType.None,
  productType: _Types.ProductType.BankAxept
}, {
  productCode: 'NK5',
  productName: 'DNB Kortet',
  displayName: 'DNB Kortet',
  cardDesign: _CardDesigns.defaultDesign,
  cardType: _Types.CardType.None,
  productType: _Types.ProductType.BankAxept
}, {
  productCode: 'VE1',
  productName: 'DNB Electron',
  displayName: 'DNB Electron',
  cardDesign: _CardDesigns.defaultDesign,
  cardType: _Types.CardType.Visa,
  productType: _Types.ProductType.None
}, {
  productCode: 'VE2',
  productName: 'DNB Electron u/leg',
  displayName: 'DNB Electron',
  cardDesign: _CardDesigns.defaultDesign,
  cardType: _Types.CardType.Visa,
  productType: _Types.ProductType.None
}, {
  productCode: 'VG1',
  productName: 'SAGA Gull Visa',
  displayName: 'SAGA Gull',
  cardDesign: _CardDesigns.saga,
  cardType: _Types.CardType.Visa,
  productType: _Types.ProductType.Saga
}, {
  productCode: 'VG4',
  productName: 'SAGA Gull Visa u/leg',
  displayName: 'SAGA Gull',
  cardDesign: _CardDesigns.saga,
  cardType: _Types.CardType.Visa,
  productType: _Types.ProductType.Saga
}, {
  productCode: 'VK2',
  productName: 'DNB Visa',
  displayName: 'DNB Visa',
  cardDesign: _CardDesigns.defaultDesign,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VK4',
  productName: 'DNB Visa',
  displayName: 'DNB Visa',
  cardDesign: _CardDesigns.defaultDesign,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VL1',
  productName: 'Sølv Visa',
  displayName: 'Pluss Visa',
  cardDesign: _CardDesigns.pluss,
  productType: _Types.ProductType.Pluss,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VL2',
  productName: 'Hvitt Visa',
  displayName: 'Hvitt kort',
  cardDesign: _CardDesigns.white,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VL3',
  productName: 'Sølv Visa',
  displayName: 'Pluss Visa',
  cardDesign: _CardDesigns.pluss,
  productType: _Types.ProductType.Pluss,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VL4',
  productName: 'DNB Visa u/leg',
  displayName: 'DNB Visa',
  cardDesign: _CardDesigns.silver,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VL6',
  productName: 'Hvitt Visa u/leg',
  displayName: 'Hvitt kort',
  cardDesign: _CardDesigns.white,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VO1',
  productName: 'DNB Visa Online',
  displayName: 'DNB Visa Online',
  cardDesign: _CardDesigns.defaultDesign,
  cardType: _Types.CardType.Visa,
  productType: _Types.ProductType.None
}, {
  productCode: 'VP2',
  productName: 'SAGA Platinum Visa',
  displayName: 'SAGA Platinum',
  cardDesign: _CardDesigns.sagaPlatinum,
  productType: _Types.ProductType.Saga,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VP3',
  productName: 'Private Banking Visa',
  displayName: 'Private Banking',
  cardDesign: _CardDesigns.privateBanking,
  productType: _Types.ProductType.PrivateBanking,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VP4',
  productName: 'SAGA Platinum Visa u/leg',
  displayName: 'SAGA Platinum',
  cardDesign: _CardDesigns.sagaPlatinum,
  productType: _Types.ProductType.Saga,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VP5',
  productName: 'Private Banking Visa u/leg',
  displayName: 'Private Banking',
  cardDesign: _CardDesigns.privateBanking,
  productType: _Types.ProductType.PrivateBanking,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VX1',
  productName: 'Mitt første kort',
  displayName: 'Mitt første kort',
  cardDesign: _CardDesigns.myFirst,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VX3',
  productName: 'Ungdomskortet',
  displayName: 'Ungdomskort',
  cardDesign: _CardDesigns.youth,
  productType: _Types.ProductType.BankAxept,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VX4',
  productName: 'Mitt første kort u/leg',
  displayName: 'Mitt første kort',
  cardDesign: _CardDesigns.myFirst,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VX5',
  productName: 'Ungdomskortet u/leg',
  displayName: 'Ungdomskort',
  cardDesign: _CardDesigns.youth,
  productType: _Types.ProductType.BankAxept,
  cardType: _Types.CardType.Visa
}, {
  productCode: '096',
  productName: 'DNB Mastercard',
  displayName: 'DNB Mastercard',
  cardDesign: _CardDesigns.gold,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Mastercard
}, {
  productCode: '044',
  productName: 'Hvitt Mastercard',
  displayName: 'Student',
  cardDesign: _CardDesigns.white,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Mastercard
}, {
  productCode: '043',
  productName: 'Sølv MasterCard',
  displayName: 'Pluss Mastercard',
  cardDesign: _CardDesigns.pluss,
  productType: _Types.ProductType.Pluss,
  cardType: _Types.CardType.Mastercard
}, {
  productCode: '098',
  productName: 'SAGA Gull Mastercard',
  displayName: 'SAGA Gull',
  cardDesign: _CardDesigns.saga,
  productType: _Types.ProductType.Saga,
  cardType: _Types.CardType.Mastercard
}, {
  productCode: '074',
  productName: 'SAGA Platinum Mastercard',
  displayName: 'SAGA Platinum',
  cardDesign: _CardDesigns.sagaPlatinum,
  productType: _Types.ProductType.Saga,
  cardType: _Types.CardType.Mastercard
}, {
  productCode: '062',
  productName: 'Private Banking Mastercard',
  displayName: 'Private Banking',
  cardDesign: _CardDesigns.privateBanking,
  productType: _Types.ProductType.PrivateBanking,
  cardType: _Types.CardType.Mastercard
}, {
  productCode: 'BK1',
  productName: 'Bedriftskort (småkjøpskort)',
  displayName: 'Bedriftskort (småkjøpskort)',
  cardDesign: _CardDesigns.businessNoVisa,
  productType: _Types.ProductType.BankAxept,
  cardType: _Types.CardType.None
}, {
  productCode: 'BP1',
  productName: 'Bedriftskort (småkjøpskort)',
  displayName: 'Bedriftskort (småkjøpskort)',
  cardDesign: _CardDesigns.businessNoVisa,
  productType: _Types.ProductType.BankAxept,
  cardType: _Types.CardType.None
}, {
  productCode: 'VB1',
  productName: 'Bedriftskort med Visa',
  displayName: 'Bedriftskort med Visa',
  cardDesign: _CardDesigns.businessWithVisa,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'VB2',
  productName: 'Bedriftskort med Visa',
  displayName: 'Bedriftskort med Visa',
  cardDesign: _CardDesigns.businessWithVisa,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Visa
}, {
  productCode: 'P101',
  productName: '?',
  displayName: 'Black Mastercard',
  cardDesign: _CardDesigns.mcBlack,
  productType: _Types.ProductType.None,
  cardType: _Types.CardType.Mastercard
}];
var _default = cardData;
exports.default = _default;