"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _Slider = _interopRequireDefault(require("../../components/slider/Slider"));

var _Input = _interopRequireDefault(require("../../components/input/Input"));

var _Modal = _interopRequireDefault(require("../../components/modal/Modal"));

var _FormLabel = _interopRequireDefault(require("../../components/form-label/FormLabel"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var RangeSlider = function (_React$PureComponent) {
  _inherits(RangeSlider, _React$PureComponent);

  var _super = _createSuper(RangeSlider);

  function RangeSlider(props) {
    var _this;

    _classCallCheck(this, RangeSlider);

    _this = _super.call(this, props);
    _this.state = {
      value: null
    };
    _this.state.value = props.range_val;
    return _this;
  }

  _createClass(RangeSlider, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          range_min = _this$props.range_min,
          range_max = _this$props.range_max,
          range_step = _this$props.range_step,
          label_text = _this$props.label_text,
          range_output_description = _this$props.range_output_description,
          range_output_extra_information = _this$props.range_output_extra_information,
          range_trigger_text = _this$props.range_trigger_text,
          range_modal_text = _this$props.range_modal_text,
          className = _this$props.className,
          _className = _this$props.class;
      var params = {
        className: (0, _classnames.default)('dnb-range-slider', className, _className)
      };
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement("div", params, _react.default.createElement("div", {
        className: "dnb-range-slider__label"
      }, _react.default.createElement("div", {
        className: "dnb-range-slider__label__inner"
      }, _react.default.createElement(_FormLabel.default, {
        for_id: "range-slider",
        text: label_text
      }))), _react.default.createElement("div", {
        className: "dnb-range-slider__slider"
      }, _react.default.createElement("div", {
        className: "dnb-range-slider__input-container"
      }, _react.default.createElement(_Slider.default, {
        id: "range-slider",
        min: range_min,
        max: range_max,
        value: this.state.value,
        step: range_step,
        on_init: function on_init(_ref) {
          var value = _ref.value;

          _this2.setState({
            value: value
          });
        },
        on_change: function on_change(_ref2) {
          var value = _ref2.value;

          _this2.setState({
            value: value
          });
        }
      })), _react.default.createElement("div", {
        className: "dnb-range-slider__output-container"
      }, _react.default.createElement(_Input.default, {
        type: "text",
        size: "large",
        value: this.state.value,
        description: range_output_description,
        status: range_output_extra_information,
        status_state: "info",
        on_change: function on_change(_ref3) {
          var value = _ref3.value;

          _this2.setState({
            value: parseFloat(value)
          });
        }
      })), _react.default.createElement("div", {
        className: "dnb-range-slider__slider__modal"
      }, _react.default.createElement(_Modal.default, {
        type: "button",
        trigger_text: range_trigger_text,
        modal_content: range_modal_text
      }))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(RangeSlider.tagName, RangeSlider, RangeSlider.defaultProps);
    }
  }]);

  return RangeSlider;
}(_react.default.PureComponent);

exports.default = RangeSlider;
RangeSlider.tagName = 'dnb-range-slider';
RangeSlider.defaultProps = {
  title: null,
  text: null,
  descriptionListData: null,
  descriptionListInfo: null,
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? RangeSlider.propTypes = {
  label_text: _propTypes.default.string.isRequired,
  range_min: _propTypes.default.number.isRequired,
  range_max: _propTypes.default.number.isRequired,
  range_val: _propTypes.default.number.isRequired,
  range_step: _propTypes.default.number.isRequired,
  range_output_description: _propTypes.default.string.isRequired,
  range_output_extra_information: _propTypes.default.string.isRequired,
  range_trigger_text: _propTypes.default.string.isRequired,
  range_modal_text: _propTypes.default.string.isRequired,
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
} : void 0;