"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports.default = void 0;

var _vuera = require("vuera");

var _lib = require("./components/lib");

var _index = require("./index");

Object.keys(_index).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _index[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _index[key];
    }
  });
});
var _default = {
  getComponents: function getComponents(Vue) {
    Vue.use(_vuera.VuePlugin);
    var ret = {};
    var components = (0, _lib.getComponents)();

    for (var c in components) {
      if (components[c] && components[c].tagName) {
        ret[components[c].tagName] = components[c];
      }
    }

    return ret;
  },
  setIgnoredPatterns: function setIgnoredPatterns(Vue) {
    var customPatterns = [];
    var components = (0, _lib.getComponents)();

    for (var c in components) {
      if (components[c] && components[c].tagName) {
        customPatterns.push(components[c].tagName);
      }
    }

    try {
      Vue.config.ignoredPatterns = customPatterns;
    } catch (e) {
      console.log('setIgnoredPatterns failed on trying to set the "Vue.config.ignoredPatterns"', e);
    }

    return Vue;
  }
};
exports.default = _default;