"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Context = _interopRequireWildcard(require("./Context"));

var _componentHelper = require("./component-helper");

var _FormRow = require("../components/form-row/FormRow");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Provider = function (_React$PureComponent) {
  _inherits(Provider, _React$PureComponent);

  var _super = _createSuper(Provider);

  function Provider(props, context) {
    var _this;

    _classCallCheck(this, Provider);

    _this = _super.call(this, props);

    var children = props.children,
        value = props.value,
        startupProps = _objectWithoutProperties(props, ["children", "value"]);

    if (typeof startupProps.formRow !== 'undefined') {
      startupProps.FormRow = startupProps.formRow;
    }

    var newContext = _extends({}, value, context, startupProps);

    var isRoot = !(newContext && newContext.__providerId);
    newContext.__providerId = (0, _componentHelper.makeUniqueId)();
    var pC = isRoot ? (0, _Context.prepareContext)(newContext) : newContext;

    pC.updateCurrent = function (props) {
      return _this.setNewContext(props);
    };

    pC.setCurrentLocale = function (locale) {
      return _this.setNewContext({
        locale: locale
      });
    };

    pC.update = function (props) {
      if (typeof context.update === 'function') {
        context.update(props);
      }

      _this.setNewContext(props);
    };

    pC.setLocale = function (locale) {
      if (typeof context.update === 'function') {
        context.update({
          locale: locale
        });
      }

      _this.setNewContext({
        locale: locale
      });
    };

    _this.state = pC;
    _this.state.isRoot = isRoot;
    _this.state._listenForPropChanges = true;
    _this.state._startupProps = startupProps;
    return _this;
  }

  _createClass(Provider, [{
    key: "setNewContext",
    value: function setNewContext(__newContext) {
      this.setState({
        _listenForPropChanges: false
      });
      this.setState({
        __newContext: __newContext
      });
    }
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      var context = !this.state.isRoot ? _extends({}, this.context, this.state) : this.state;
      this.context.updateTranslation(context.locale, context.translation);
      return _react.default.createElement(_Context.default.Provider, {
        value: context
      }, children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        var children = props.children,
            updatedProps = _objectWithoutProperties(props, ["children"]);

        var newContext = state;

        if (state._startupProps !== updatedProps) {
          var hasChanges = false;

          for (var i in updatedProps) {
            if (state._startupProps[i] !== updatedProps[i] || typeof updatedProps[i] === 'boolean') {
              hasChanges = true;
              break;
            }
          }

          if (hasChanges) {
            newContext = _extends(state, updatedProps);
            state._startupProps = updatedProps;
          }
        }

        if (newContext.FormRow) {
          newContext.FormRow = (0, _FormRow.prepareFormRowContext)(newContext.FormRow);
        }

        state = newContext;
      }

      state._listenForPropChanges = true;
      return (0, _Context.prepareContext)(state);
    }
  }]);

  return Provider;
}(_react.default.PureComponent);

exports.default = Provider;
Provider.contextType = _Context.default;
Provider.defaultProps = {};
process.env.NODE_ENV !== "production" ? Provider.propTypes = {
  value: _propTypes.default.object,
  locale: _propTypes.default.string,
  skeleton: _propTypes.default.bool,
  children: _propTypes.default.node.isRequired
} : void 0;