"use strict";

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setPageFocusElement = setPageFocusElement;
exports.applyPageFocus = applyPageFocus;
exports.getOffsetTop = getOffsetTop;
exports.getOffsetLeft = getOffsetLeft;
exports.scrollToLocationHashId = scrollToLocationHashId;
exports.debounce = debounce;
exports.insertElementBeforeSelection = insertElementBeforeSelection;
exports.getSelectedText = getSelectedText;
exports.hasSelectedText = hasSelectedText;
exports.getSelectedElement = getSelectedElement;
exports.copyToClipboard = copyToClipboard;
exports.isEdge = exports.isIE11 = exports.isSafari = exports.isiOS = exports.isLinux = exports.isWin = exports.isMac = exports.IS_LINUX = exports.IS_MAC = exports.IS_WIN = exports.IS_SAFARI = exports.IS_IOS = exports.IS_EDGE = exports.IS_IE11 = void 0;

require("regenerator-runtime/runtime.js");

var _componentHelper = require("./component-helper");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var IS_IE11 = false;
exports.IS_IE11 = IS_IE11;
var IS_EDGE = false;
exports.IS_EDGE = IS_EDGE;
var IS_IOS = false;
exports.IS_IOS = IS_IOS;
var IS_SAFARI = false;
exports.IS_SAFARI = IS_SAFARI;
var IS_WIN = false;
exports.IS_WIN = IS_WIN;
var IS_MAC = false;
exports.IS_MAC = IS_MAC;
var IS_LINUX = false;
exports.IS_LINUX = IS_LINUX;

var isMac = function isMac() {
  var _navigator;

  return exports.IS_MAC = IS_MAC = typeof navigator !== 'undefined' && new RegExp(_componentHelper.PLATFORM_MAC, 'i').test((_navigator = navigator) === null || _navigator === void 0 ? void 0 : _navigator.platform);
};

exports.isMac = isMac;

var isWin = function isWin() {
  var _navigator2;

  return exports.IS_WIN = IS_WIN = typeof navigator !== 'undefined' && new RegExp(_componentHelper.PLATFORM_WIN, 'i').test((_navigator2 = navigator) === null || _navigator2 === void 0 ? void 0 : _navigator2.platform);
};

exports.isWin = isWin;

var isLinux = function isLinux() {
  var _navigator3;

  return exports.IS_LINUX = IS_LINUX = typeof navigator !== 'undefined' && new RegExp(_componentHelper.PLATFORM_LINUX, 'i').test((_navigator3 = navigator) === null || _navigator3 === void 0 ? void 0 : _navigator3.platform);
};

exports.isLinux = isLinux;

var isiOS = function isiOS() {
  var _navigator4;

  return exports.IS_IOS = IS_IOS = typeof navigator !== 'undefined' && new RegExp(_componentHelper.PLATFORM_IOS, 'i').test((_navigator4 = navigator) === null || _navigator4 === void 0 ? void 0 : _navigator4.platform);
};

exports.isiOS = isiOS;

var isSafari = function isSafari() {
  var _navigator5, _navigator6;

  return exports.IS_SAFARI = IS_SAFARI = typeof navigator !== 'undefined' && /safari/i.test((_navigator5 = navigator) === null || _navigator5 === void 0 ? void 0 : _navigator5.userAgent) && !/chrome/i.test((_navigator6 = navigator) === null || _navigator6 === void 0 ? void 0 : _navigator6.userAgent);
};

exports.isSafari = isSafari;

var isIE11 = function isIE11() {
  return exports.IS_IE11 = IS_IE11 = typeof window !== 'undefined' && typeof document !== 'undefined' ? !!window.MSInputMethodContext && !!document.documentMode : false;
};

exports.isIE11 = isIE11;

var isEdge = function isEdge() {
  var _navigator7;

  return exports.IS_EDGE = IS_EDGE = typeof navigator !== 'undefined' && /edge/i.test((_navigator7 = navigator) === null || _navigator7 === void 0 ? void 0 : _navigator7.userAgent);
};

exports.isEdge = isEdge;
isIE11();
isEdge();
isiOS();
isSafari();
isWin();
isMac();
isLinux();
var pageFocusElements = {};

function setPageFocusElement(selectorOrElement) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'default';
  return pageFocusElements[key] = selectorOrElement;
}

function applyPageFocus() {
  var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';
  var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  try {
    var element = pageFocusElements[key];

    if (typeof element === 'string' && typeof document !== 'undefined') {
      element = document.querySelector(element);
    } else if (!element && typeof document !== 'undefined') {
      element = document.querySelector('.dnb-no-focus');
    }

    if (element instanceof HTMLElement) {
      if (['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'p', 'div', 'main', 'nav', 'header', 'footer', 'aside', 'section', 'article'].includes(String(element.nodeName).toLowerCase())) {
        if (!element.hasAttribute('tabindex')) {
          element.setAttribute('tabindex', '-1');
        }

        if (element.classList && !element.classList.contains('dnb-no-focus')) {
          element.classList.add('dnb-no-focus');
        }
      }

      element.focus({
        preventScroll: true
      });

      if (typeof callback === 'function') {
        callback(element);
      }
    }
  } catch (e) {
    (0, _componentHelper.warn)('Error on applyPageFocus:', e);
  }
}

function getOffsetTop(elem) {
  var offsetTop = 0;

  do {
    if (!isNaN(elem.offsetTop)) {
      offsetTop += elem.offsetTop;
    }
  } while (elem = elem.offsetParent);

  return offsetTop;
}

function getOffsetLeft(elem) {
  var offsetLeft = 0;

  do {
    if (!isNaN(elem.offsetLeft)) {
      offsetLeft += elem.offsetLeft;
    }
  } while (elem = elem.offsetParent);

  return offsetLeft;
}

function scrollToLocationHashId() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$offset = _ref.offset,
      offset = _ref$offset === void 0 ? 0 : _ref$offset,
      _ref$delay = _ref.delay,
      delay = _ref$delay === void 0 ? null : _ref$delay,
      _ref$onCompletion = _ref.onCompletion,
      onCompletion = _ref$onCompletion === void 0 ? null : _ref$onCompletion;

  if (typeof document !== 'undefined' && typeof window !== 'undefined' && window.location) {
    try {
      var _timeout;

      var id = String(window.location.hash).replace('#', '');

      if (id.length > 0) {
        var handleScroll = function handleScroll() {
          var runScroll = function runScroll() {
            var top = getOffsetTop(elem) - offset;

            try {
              if (typeof IntersectionObserver !== 'undefined') {
                var intersectionObserver = new IntersectionObserver(function (entries) {
                  var _entries = _slicedToArray(entries, 1),
                      entry = _entries[0];

                  if (entry.isIntersecting) {
                    intersectionObserver.unobserve(elem);

                    if (typeof onCompletion === 'function') {
                      onCompletion(elem);
                    }
                  }
                });
                intersectionObserver.observe(elem);
              }

              if (window.scrollTo) {
                window.scrollTo({
                  top: top,
                  behavior: 'smooth'
                });
              } else {
                window.scrollTop = top;
              }
            } catch (e) {
              (0, _componentHelper.warn)('Error on scrollToLocationHashId:', e);
            }
          };

          if (delay > 0) {
            clearTimeout(_timeout);
            _timeout = setTimeout(runScroll, delay);
          } else {
            runScroll();
          }
        };

        var elem = document.getElementById(id);

        if (elem instanceof HTMLElement) {
          window.addEventListener('beforeunload', function () {
            return clearTimeout(_timeout);
          });

          if (document.readyState === 'loading') {
            document.addEventListener('DOMContentLoaded', handleScroll);
          } else {
            handleScroll();
          }
        }

        return elem;
      }
    } catch (e) {
      (0, _componentHelper.warn)('Error on scrollToLocationHashId:', e);
    }
  }
}

function debounce(func) {
  var wait = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 250;

  var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      _ref2$immediate = _ref2.immediate,
      immediate = _ref2$immediate === void 0 ? false : _ref2$immediate,
      _ref2$context = _ref2.context,
      context = _ref2$context === void 0 ? null : _ref2$context;

  var timeout;
  var recall;
  return function executedFunction() {
    var ctx = context || this;
    var args = arguments;

    if (typeof recall === 'function') {
      recall();
    }

    var later = function later() {
      timeout = null;

      if (!immediate) {
        recall = func.apply(ctx, args);
      }
    };

    var callNow = immediate && !timeout;
    clearTimeout(timeout);
    timeout = setTimeout(later, wait);

    if (callNow) {
      recall = func.apply(ctx, args);
    }
  };
}

function insertElementBeforeSelection(elem) {
  try {
    var selection = window.getSelection();
    var range = selection.getRangeAt(0);
    range.cloneRange().insertNode(elem);
    selection.addRange(range);
  } catch (e) {}
}

function getSelectedText() {
  try {
    return window.getSelection().toString();
  } catch (e) {}

  return '';
}

function hasSelectedText() {
  return getSelectedText().length > 0;
}

function getSelectedElement() {
  try {
    var selection = window.getSelection();

    if (selection.rangeCount > 0) {
      var elem = selection.getRangeAt(0).startContainer;

      if (elem && _typeof(elem) === 'object') {
        elem = elem.parentNode;
      }

      return elem;
    }
  } catch (e) {}

  return null;
}

function copyToClipboard(_x) {
  return _copyToClipboard.apply(this, arguments);
}

function _copyToClipboard() {
  _copyToClipboard = _asyncToGenerator(regeneratorRuntime.mark(function _callee(string) {
    var _navigator8;

    var selection, range, resetSelection, copyFallback, success, newTry;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(typeof window === 'undefined' || typeof document === 'undefined')) {
              _context.next = 2;
              break;
            }

            return _context.abrupt("return", false);

          case 2:
            selection = window.getSelection();
            range = selection.rangeCount > 0 ? selection.getRangeAt(0) : false;

            resetSelection = function resetSelection() {
              try {
                selection.removeAllRanges();
                selection.addRange(range);
              } catch (e) {}
            };

            copyFallback = function copyFallback() {
              try {
                var elem = document.createElement('textarea');
                elem.value = String(string);
                elem.contentEditable = true;
                elem.readOnly = false;
                elem.style.position = 'fixed';
                elem.style.top = '-1000px';
                document.body.appendChild(elem);

                var _success = document.execCommand('copy');

                document.body.removeChild(elem);
                resetSelection();

                if (_success) {
                  return true;
                }
              } catch (e) {
                return e;
              }

              return "Could not copy! Unknown reason. ".concat(string);
            };

            if (!(typeof navigator !== 'undefined' && (_navigator8 = navigator) !== null && _navigator8 !== void 0 && _navigator8.clipboard)) {
              _context.next = 21;
              break;
            }

            _context.prev = 7;
            _context.next = 10;
            return navigator.clipboard.writeText(String(string));

          case 10:
            success = true;
            resetSelection();
            _context.next = 19;
            break;

          case 14:
            _context.prev = 14;
            _context.t0 = _context["catch"](7);
            success = _context.t0;
            newTry = copyFallback();

            if (newTry === true) {
              success = newTry;
            }

          case 19:
            _context.next = 22;
            break;

          case 21:
            success = copyFallback();

          case 22:
            return _context.abrupt("return", success);

          case 23:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[7, 14]]);
  }));
  return _copyToClipboard.apply(this, arguments);
}