"use strict";

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createShortcut = void 0;

var _keycode = _interopRequireDefault(require("keycode"));

var _componentHelper = require("../component-helper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var createShortcut = function () {
  function createShortcut() {
    _classCallCheck(this, createShortcut);

    this.eventTracker = [];
    this.shortcutExists = [];
  }

  _createClass(createShortcut, [{
    key: "add",
    value: function add(shortcut, callback, onDone) {
      var element = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

      if (typeof window === 'undefined' || typeof document === 'undefined' || this.shortcutExists[shortcut] === true) {
        return;
      }

      try {
        element = element || document;
        var timeout = {
          id: null
        };

        var keyDown = function keyDown(e) {
          try {
            var event = e || window.event;
            var code = (0, _keycode.default)(event);
            var shortcuts = shortcut.split('+');
            var metaWanted = {
              cmd: false,
              ctrl: false,
              shift: false,
              alt: false
            };
            var metaPressed = {
              cmd: event.metaKey,
              ctrl: event.ctrlKey,
              shift: event.shiftKey,
              alt: event.altKey
            };
            var matches = 0;
            shortcuts.forEach(function (cut) {
              switch (cut) {
                case 'cmd':
                case 'ctrl':
                case 'shift':
                case 'alt':
                  {
                    metaWanted[cut] = true;
                    matches++;
                  }
                  break;

                default:
                  {
                    if (cut === code) {
                      matches++;
                    }
                  }
                  break;
              }
            });

            if (matches === shortcuts.length && metaWanted.cmd === metaPressed.cmd && metaWanted.ctrl === metaPressed.ctrl && metaWanted.shift === metaPressed.shift && metaWanted.alt === metaPressed.alt) {
              callback(event);

              if (typeof onDone === 'function') {
                clearTimeout(timeout.id);
                timeout.id = setTimeout(onDone, 10);
              }
            }
          } catch (e) {
            (0, _componentHelper.warn)(e);
          }
        };

        var keyUp = function keyUp(e) {
          if (typeof onDone === 'function') {
            onDone(e);
          }
        };

        element.addEventListener('keydown', keyDown);
        element.addEventListener('keyup', keyUp);
        this.eventTracker[shortcut] = {
          timeout: timeout,
          element: element,
          keyDown: keyDown,
          keyUp: keyUp
        };
        this.shortcutExists[shortcut] = true;
      } catch (e) {
        (0, _componentHelper.warn)(e);
      }
    }
  }, {
    key: "remove",
    value: function remove(shortcut) {
      try {
        shortcut = shortcut.toLowerCase();

        if (this.eventTracker[shortcut]) {
          var _this$eventTracker$sh = this.eventTracker[shortcut],
              timeout = _this$eventTracker$sh.timeout,
              element = _this$eventTracker$sh.element,
              keyDown = _this$eventTracker$sh.keyDown,
              keyUp = _this$eventTracker$sh.keyUp;
          element.removeEventListener('keydown', keyDown, false);
          element.removeEventListener('keyup', keyUp, false);
          clearTimeout(timeout.id);
          delete this.eventTracker[shortcut];
          this.shortcutExists[shortcut] = false;
        }
      } catch (e) {}
    }
  }]);

  return createShortcut;
}();

exports.createShortcut = createShortcut;