"use strict";

require("core-js/modules/es.array.from.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.entries.js");

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withProperties = exports.default = void 0;

var _componentHelper = require("../shared/component-helper");

var _properties = _interopRequireDefault(require("./properties"));

var _helpers = require("../shared/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var findRegExp = /var\(([^)]*)\)/g;

var stylisPlugin = function stylisPlugin(context, content) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (context !== 1 || props === null && !_helpers.IS_IE11) {
    return false;
  }

  var matches = (0, _componentHelper.matchAll)(content, findRegExp);
  var varsToFill = Array.from(matches).reduce(function (acc, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        k = _ref2[0],
        v = _ref2[1];

    if (props && props[v]) {
      acc[v] = props[v];
    } else if (_properties.default[v]) {
      acc[v] = _properties.default[v];
    }

    return acc;
  }, {});
  return Object.entries(varsToFill).reduce(function (acc, _ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        k = _ref4[0],
        v = _ref4[1];

    return acc.replace(new RegExp("var\\(".concat(k, "\\)"), 'g'), v);
  }, content);
};

var _default = stylisPlugin;
exports.default = _default;

var withProperties = function withProperties(properties) {
  return function (context, content) {
    return stylisPlugin(context, content, properties);
  };
};

exports.withProperties = withProperties;