"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports.default = void 0;

var _vuera = require("vuera");

var componentsIndex = _interopRequireWildcard(require("./components/lib"));

var elementsIndex = _interopRequireWildcard(require("./elements/lib"));

var _index = require("./index");

Object.keys(_index).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _index[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _index[key];
    }
  });
});

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _default = {
  getComponents: function getComponents(Vue) {
    Vue.use(_vuera.VuePlugin);
    var ret = {};

    var components = _extends({}, componentsIndex, elementsIndex);

    for (var c in components) {
      if (components[c] && components[c].tagName) {
        ret[components[c].tagName] = components[c];
      }
    }

    return ret;
  },
  setIgnoredPatterns: function setIgnoredPatterns(Vue) {
    var customPatterns = [];

    var components = _extends({}, componentsIndex, elementsIndex);

    for (var c in components) {
      if (components[c] && components[c].tagName) {
        customPatterns.push(components[c].tagName);
      }
    }

    try {
      Vue.config.ignoredPatterns = customPatterns;
    } catch (e) {
      console.log('setIgnoredPatterns failed on trying to set the "Vue.config.ignoredPatterns"', e);
    }

    return Vue;
  }
};
exports.default = _default;