import "core-js/modules/es.symbol.js";
import "core-js/modules/es.symbol.description.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.find.js";
import "core-js/modules/es.array.find-index.js";
import "core-js/modules/es.array.for-each.js";
import "core-js/modules/es.array.splice.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { isTrue, validateDOMAttributes, extendPropsWithContext } from '../../shared/component-helper';
import IconPrimary from '../../components/icon-primary/IconPrimary';
import classnames from 'classnames';
import keycode from 'keycode';
import AccordionContext from './AccordionContext';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';

function AccordionHeaderTitle(_ref) {
  var children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["children"]);

  return React.createElement("span", {
    className: classnames('dnb-accordion__header__title', createSpacingClasses(rest))
  }, children);
}

process.env.NODE_ENV !== "production" ? AccordionHeaderTitle.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
AccordionHeaderTitle.defaultProps = {
  children: null
};

function AccordionHeaderDescription(_ref2) {
  var children = _ref2.children,
      rest = _objectWithoutProperties(_ref2, ["children"]);

  return children ? React.createElement("span", {
    className: classnames('dnb-accordion__header__description', createSpacingClasses(rest))
  }, children) : null;
}

process.env.NODE_ENV !== "production" ? AccordionHeaderDescription.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
AccordionHeaderDescription.defaultProps = {
  children: null
};

function AccordionHeaderContainer(_ref3) {
  var children = _ref3.children,
      rest = _objectWithoutProperties(_ref3, ["children"]);

  return children ? React.createElement("span", {
    className: classnames('dnb-accordion__header__container', createSpacingClasses(rest))
  }, children) : null;
}

process.env.NODE_ENV !== "production" ? AccordionHeaderContainer.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
AccordionHeaderContainer.defaultProps = {
  children: null
};

function AccordionHeaderIcon(_ref4) {
  var icon = _ref4.icon,
      rest = _objectWithoutProperties(_ref4, ["icon"]);

  return React.createElement("span", {
    className: "dnb-accordion__header__icon"
  }, React.createElement(IconPrimary, _extends({}, rest, {
    icon: icon || 'chevron-down',
    "aria-hidden": true
  })));
}

process.env.NODE_ENV !== "production" ? AccordionHeaderIcon.propTypes = {
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  size: PropTypes.string
} : void 0;
AccordionHeaderIcon.defaultProps = {
  icon: null,
  size: 'medium'
};

var AccordionHeader = function (_React$PureComponent) {
  _inherits(AccordionHeader, _React$PureComponent);

  var _super = _createSuper(AccordionHeader);

  function AccordionHeader(props) {
    var _this;

    _classCallCheck(this, AccordionHeader);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      switch (keycode(event)) {
        case 'enter':
        case 'space':
          event.preventDefault();

          _this.onClickHandler(event);

          break;
      }
    };

    _this.onClickHandler = function (event) {
      var _this$context = _this.context,
          id = _this$context.id,
          group = _this$context.group;

      if (_this.canClick()) {
        var expanded = !_this.context.expanded;

        _this.context.callOnChange({
          id: id,
          group: group,
          expanded: expanded,
          event: event
        });

        _this.setState({
          hadClick: true
        });
      }
    };

    _this.onMouseOverHandler = function () {
      _this.setState({
        hover: true
      });
    };

    _this.onMouseOutHander = function () {
      _this.setState({
        hover: false,
        hadClick: false
      });
    };

    _this.state = {};
    return _this;
  }

  _createClass(AccordionHeader, [{
    key: "canClick",
    value: function canClick() {
      var _this$context2 = this.context,
          expanded = _this$context2.expanded,
          allow_close_all = _this$context2.allow_close_all,
          group = _this$context2.group;
      return !group || group && !expanded || isTrue(allow_close_all);
    }
  }, {
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, AccordionHeader.defaultProps, this.context);
      var id = props.id,
          left_component = props.left_component,
          expanded = props.expanded,
          title = props.title,
          description = props.description,
          element = props.element,
          heading = props.heading,
          heading_level = props.heading_level,
          icon = props.icon,
          icon_size = props.icon_size,
          disabled = props.disabled,
          skeleton = props.skeleton;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          _left_component = _this$props.left_component,
          _expanded = _this$props.expanded,
          _title = _this$props.title,
          _description = _this$props.description,
          _icon = _this$props.icon,
          _icon_size = _this$props.icon_size,
          _disabled = _this$props.disabled,
          rest = _objectWithoutProperties(_this$props, ["children", "className", "left_component", "expanded", "title", "description", "icon", "icon_size", "disabled"]);

      var _this$state = this.state,
          hover = _this$state.hover,
          hadClick = _this$state.hadClick;
      var icon_position = props.icon_position;
      var defaultParts = [React.createElement(AccordionHeaderIcon, {
        key: "icon",
        icon: icon,
        size: icon_size
      }), React.createElement(AccordionHeaderContainer, {
        key: "container"
      }, left_component), React.createElement(AccordionHeaderTitle, {
        key: "title"
      }, title || (Array.isArray(children) ? children.filter(function (cur) {
        return !React.isValidElement(cur);
      }) : children)), React.createElement(AccordionHeaderDescription, {
        key: "description"
      }, description)];

      if (Array.isArray(children)) {
        var removeParts = [];
        children.forEach(function (cur) {
          if (React.isValidElement(cur)) {
            var part = defaultParts.find(function (c) {
              return c.type === cur.type;
            });

            if (part) {
              removeParts.push(part);
            }

            defaultParts.push(cur);
          }
        });
        removeParts.forEach(function (part) {
          var index = defaultParts.findIndex(function (c) {
            return c === part;
          });

          if (index > -1) {
            defaultParts.splice(index, 1);
          }
        });
      }

      var partsToRender = [];
      var wrapperParts = [];
      var wrapperComp = React.createElement("span", {
        className: "dnb-accordion__header__wrapper",
        key: "wrapper"
      }, wrapperParts);
      defaultParts.forEach(function (part) {
        if (React.isValidElement(part) && (part.type === AccordionHeaderTitle || part.type === AccordionHeaderDescription)) {
          wrapperParts.push(part);

          if (partsToRender.findIndex(function (c) {
            return c === wrapperComp;
          }) === -1) {
            partsToRender.push(wrapperComp);
          }
        } else {
          partsToRender.push(part);
        }
      });

      if (icon_position === null) {
        var iconIndex = partsToRender.findIndex(function (c) {
          return c.type === AccordionHeaderIcon;
        });

        if (iconIndex > 1) {
          icon_position = 'right';
        }

        if (left_component) {
          icon_position = 'right';
        }
      }

      var headerParams = _extends({
        id: "".concat(id, "-header"),
        'aria-controls': "".concat(id, "-content"),
        'aria-expanded': this.context.expanded,
        role: 'button',
        tabIndex: '0',
        className: classnames('dnb-accordion__header', createSkeletonClass('font', skeleton, this.context), createSpacingClasses(rest), className, icon_position && "dnb-accordion__header__icon--".concat(icon_position), hover && hadClick && 'dnb-accordion--hover', !this.canClick() && 'dnb-accordion__header--prevent-click', description && 'dnb-accordion__header--description'),
        disabled: disabled
      }, rest);

      if (disabled || isTrue(skeleton)) {
        headerParams.tabIndex = '-1';
        headerParams.disabled = true;
        headerParams['aria-disabled'] = true;
      } else {
        headerParams.onClick = this.onClickHandler;
        headerParams.onKeyDown = this.onKeyDownHandler;
        headerParams.onMouseOver = this.onMouseOverHandler;
        headerParams.onMouseOut = this.onMouseOutHander;
      }

      skeletonDOMAttributes(headerParams, skeleton, this.context);
      validateDOMAttributes(this.props, headerParams);
      var Element = 'div';

      if (isTrue(heading)) {
        headerParams.role = 'heading';
        headerParams['aria-level'] = heading_level ? String(heading_level) : 'h2';
      } else if (heading) {
        headerParams.role = null;
        Element = heading;
      } else if (element) {
        headerParams.role = null;
        Element = element;
      }

      return React.createElement(Element, headerParams, partsToRender);
    }
  }]);

  return AccordionHeader;
}(React.PureComponent);

AccordionHeader.contextType = AccordionContext;
AccordionHeader.defaultProps = {
  id: null,
  title: null,
  description: null,
  left_component: null,
  element: null,
  heading: null,
  heading_level: null,
  icon: null,
  icon_position: null,
  icon_size: 'medium',
  disabled: null,
  skeleton: null,
  className: null,
  children: null
};
AccordionHeader.Container = AccordionHeaderContainer;
AccordionHeader.Icon = AccordionHeaderIcon;
AccordionHeader.Title = AccordionHeaderTitle;
AccordionHeader.Description = AccordionHeaderDescription;
export { AccordionHeader as default };
process.env.NODE_ENV !== "production" ? AccordionHeader.propTypes = _extends({
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  description: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  left_component: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  element: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  heading: PropTypes.oneOfType([PropTypes.bool, PropTypes.string, PropTypes.node, PropTypes.func]),
  heading_level: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  icon_position: PropTypes.oneOf(['left', 'right']),
  icon_size: PropTypes.string,
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
}) : void 0;