import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.map.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { convertStringToDate } from './DatePickerCalc';
import ToggleButton from '../toggle-button/ToggleButton';
import DatePickerContext from './DatePickerContext';

var DatePickerAddon = function (_React$PureComponent) {
  _inherits(DatePickerAddon, _React$PureComponent);

  var _super = _createSuper(DatePickerAddon);

  function DatePickerAddon() {
    var _this;

    _classCallCheck(this, DatePickerAddon);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      currentShortcut: null,
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(DatePickerAddon, [{
    key: "setDate",
    value: function setDate(_ref) {
      var value = _ref.value,
          event = _ref.event;
      this.setState({
        currentShortcut: value,
        _listenForPropChanges: false
      });
      var start_date = value.date || value.start_date;
      var end_date = value.end_date;
      var startDate = typeof start_date === 'function' ? start_date(this.getCurrentDates()) : start_date ? convertStringToDate(start_date) : null;
      var endDate = typeof end_date === 'function' ? end_date(this.getCurrentDates()) : end_date ? convertStringToDate(end_date) : null;
      this.callOnChange({
        startDate: startDate,
        endDate: endDate || startDate,
        event: event
      });

      if (value.close_on_select) {
        this.context.hidePicker(event);
      }
    }
  }, {
    key: "getCurrentDates",
    value: function getCurrentDates() {
      var _this$context = this.context,
          startDate = _this$context.startDate,
          endDate = _this$context.endDate;
      return {
        date: startDate,
        start_date: startDate,
        end_date: endDate
      };
    }
  }, {
    key: "callOnChange",
    value: function callOnChange() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          startDate = _ref2.startDate,
          endDate = _ref2.endDate,
          _ref2$event = _ref2.event,
          event = _ref2$event === void 0 ? null : _ref2$event;

      this.context.setDate({
        startDate: startDate,
        endDate: endDate,
        changeMonthViews: true
      });
      this.context.callOnChangeHandler({
        startDate: startDate,
        endDate: endDate,
        event: event
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          shortcuts = _this$props.shortcuts,
          renderElement = _this$props.renderElement;
      var shortcutsArray = shortcuts ? typeof shortcuts === 'string' ? JSON.parse(shortcuts) : shortcuts : [];
      var hasShortcuts = shortcutsArray && shortcutsArray.length > 0;

      if (!hasShortcuts && !renderElement) {
        return React.createElement(React.Fragment, null);
      }

      var shortcutElements = hasShortcuts && React.createElement(ToggleButton.Group, {
        value: this.state.currentShortcut,
        on_change: function on_change(_ref3) {
          var value = _ref3.value,
              event = _ref3.event;
          return _this2.setDate({
            value: value,
            event: event
          });
        }
      }, shortcutsArray.map(function (_ref4, i) {
        var title = _ref4.title,
            rest = _objectWithoutProperties(_ref4, ["title"]);

        return React.createElement(ToggleButton, {
          key: i,
          text: title,
          value: rest
        });
      }));
      return React.createElement("div", {
        className: "dnb-date-picker__addon"
      }, renderElement, shortcutElements);
    }
  }]);

  return DatePickerAddon;
}(React.PureComponent);

DatePickerAddon.contextType = DatePickerContext;
DatePickerAddon.defaultProps = {
  shortcuts: null,
  renderElement: null
};
export { DatePickerAddon as default };
process.env.NODE_ENV !== "production" ? DatePickerAddon.propTypes = {
  shortcuts: PropTypes.oneOfType([PropTypes.array, PropTypes.func]),
  renderElement: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
} : void 0;