import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { extendPropsWithContext, isTrue, registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { createSkeletonClass, skeletonDOMAttributes } from '../skeleton/SkeletonHelper';
import Context from '../../shared/Context';

var FormLabel = function (_React$PureComponent) {
  _inherits(FormLabel, _React$PureComponent);

  var _super = _createSuper(FormLabel);

  function FormLabel() {
    _classCallCheck(this, FormLabel);

    return _super.apply(this, arguments);
  }

  _createClass(FormLabel, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = extendPropsWithContext(this.props, FormLabel.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.FormRow, this.context.FormLabel);

      var for_id = props.for_id,
          element = props.element,
          title = props.title,
          className = props.className,
          id = props.id,
          disabled = props.disabled,
          skeleton = props.skeleton,
          label_direction = props.label_direction,
          vertical = props.vertical,
          sr_only = props.sr_only,
          _className = props.class,
          _text = props.text,
          attributes = _objectWithoutProperties(props, ["for_id", "element", "title", "className", "id", "disabled", "skeleton", "label_direction", "vertical", "sr_only", "class", "text"]);

      var content = FormLabel.getContent(this.props);

      var params = _extends({
        className: classnames('dnb-form-label', (isTrue(vertical) || label_direction === 'vertical') && "dnb-form-label--vertical", createSkeletonClass('font', skeleton, this.context), createSpacingClasses(props), className, _className, isTrue(sr_only) && 'dnb-form-label--sr-only'),
        htmlFor: for_id,
        id: id,
        title: title,
        disabled: isTrue(disabled)
      }, attributes);

      if (disabled) {
        params.disabled = true;
      }

      skeletonDOMAttributes(params, skeleton, this.context);
      validateDOMAttributes(this.props, params);
      params.children = content;
      var Element = element;
      return React.createElement(Element, params);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(FormLabel.tagName, FormLabel, FormLabel.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.text) return props.text;
      return processChildren(props);
    }
  }]);

  return FormLabel;
}(React.PureComponent);

FormLabel.tagName = 'dnb-form-label';
FormLabel.contextType = Context;
FormLabel.defaultProps = {
  for_id: null,
  element: 'label',
  title: null,
  text: null,
  id: null,
  class: null,
  disabled: null,
  skeleton: null,
  label_direction: null,
  vertical: null,
  sr_only: null,
  className: null,
  children: null
};
export { FormLabel as default };
process.env.NODE_ENV !== "production" ? FormLabel.propTypes = _extends({
  for_id: PropTypes.string,
  element: PropTypes.string,
  title: PropTypes.string,
  text: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  id: PropTypes.string,
  class: PropTypes.string,
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  label_direction: PropTypes.oneOf(['vertical', 'horizontal']),
  vertical: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node])
}) : void 0;