import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.function.name.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _extends from "@babel/runtime/helpers/esm/extends";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { extend, extendPropsWithContext, isTrue, makeUniqueId, registerElement, validateDOMAttributes } from '../../shared/component-helper';
import AlignmentHelper from '../../shared/AlignmentHelper';
import Context from '../../shared/Context';
import hashSum from '../../shared/libs/HashSum';
import FormLabel from '../form-label/FormLabel';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
export var formRowPropTypes = _extends({
  id: PropTypes.string,
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_direction: PropTypes.oneOf(['vertical', 'horizontal']),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  label_id: PropTypes.string,
  label_class: PropTypes.string,
  no_label: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_fieldset: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  indent: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  wrap: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  direction: PropTypes.oneOf(['vertical', 'horizontal']),
  vertical: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  centered: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  indent_offset: PropTypes.string,
  section_style: PropTypes.string,
  section_spacing: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  global_status_id: PropTypes.string,
  responsive: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  class: PropTypes.string,
  skipContentWrapperIfNested: PropTypes.bool
}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func
});
export var formRowDefaultProps = {
  id: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  label_id: null,
  label_class: null,
  no_label: false,
  no_fieldset: null,
  indent: null,
  wrap: null,
  direction: null,
  vertical: null,
  centered: null,
  indent_offset: null,
  section_style: null,
  section_spacing: null,
  global_status_id: null,
  responsive: null,
  disabled: null,
  skeleton: null,
  class: null,
  skipContentWrapperIfNested: false,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null
};

var _ref = React.createElement(AlignmentHelper, null);

var _ref2 = React.createElement("span", {
  className: "dnb-form-label dnb-form-row__label-dummy",
  "aria-hidden": true
});

var FormRow = function (_React$PureComponent) {
  _inherits(FormRow, _React$PureComponent);

  var _super = _createSuper(FormRow);

  function FormRow(props) {
    var _this;

    _classCallCheck(this, FormRow);

    _this = _super.call(this, props);
    _this._id = props.id || makeUniqueId();
    return _this;
  }

  _createClass(FormRow, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = extendPropsWithContext(this.props, FormRow.defaultProps, this.context.FormRow);

      var label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          label_id = props.label_id,
          label_class = props.label_class,
          no_fieldset = props.no_fieldset,
          no_label = props.no_label,
          indent = props.indent,
          direction = props.direction,
          vertical = props.vertical,
          centered = props.centered,
          indent_offset = props.indent_offset,
          section_style = props.section_style,
          section_spacing = props.section_spacing,
          global_status_id = props.global_status_id,
          responsive = props.responsive,
          disabled = props.disabled,
          skeleton = props.skeleton,
          wrap = props.wrap,
          _id = props.id,
          className = props.className,
          _className = props.class,
          skipContentWrapperIfNested = props.skipContentWrapperIfNested,
          attributes = _objectWithoutProperties(props, ["label", "label_direction", "label_sr_only", "label_id", "label_class", "no_fieldset", "no_label", "indent", "direction", "vertical", "centered", "indent_offset", "section_style", "section_spacing", "global_status_id", "responsive", "disabled", "skeleton", "wrap", "id", "className", "class", "skipContentWrapperIfNested"]);

      var isNested = this.context.FormRow && this.context.FormRow.itsMeAgain;

      var _FormRow$getContent = FormRow.getContent(this.props),
          nestedLabel = _FormRow$getContent.label,
          children = _FormRow$getContent.children;

      if (!label && nestedLabel) {
        label = nestedLabel;
      }

      var hasLabel = typeof label === 'string' && label.length > 0 || label ? true : false;
      var id = this._id;

      var params = _extends({
        className: classnames('dnb-form-row', (isTrue(vertical) || direction) && "dnb-form-row--".concat(isTrue(vertical) ? 'vertical' : direction), (isTrue(vertical) || label_direction) && "dnb-form-row--".concat(isTrue(vertical) ? 'vertical' : label_direction, "-label"), createSpacingClasses(props), className, _className, indent && !(isNested && this.context.FormRow.hasLabel && this.context.FormRow.indent) && "dnb-form-row__indent--".concat(isTrue(indent) ? 'default' : indent), centered && 'dnb-form-row--centered', isNested && 'dnb-form-row--nested', section_style && "dnb-section dnb-section--".concat(section_style), section_spacing && "dnb-section--spacing-".concat(isTrue(section_spacing) ? 'default' : section_spacing))
      }, attributes);

      validateDOMAttributes(this.props, params);

      if (this._cachedContext !== hashSum(this.context, false) || this._cachedProps !== hashSum(this.props, false)) {
        this._cachedContext = hashSum(this.context, false);
        this._cachedProps = hashSum(this.props, false);
        var _FormRow2 = {
          useId: function useId() {
            if (_this2.isIsUsed) {
              return makeUniqueId();
            }

            _this2.isIsUsed = true;
            return id;
          },
          itsMeAgain: true,
          hasLabel: hasLabel,
          indent: indent,
          global_status_id: global_status_id,
          direction: direction,
          vertical: vertical,
          label_direction: isTrue(vertical) ? 'vertical' : label_direction,
          responsive: responsive,
          disabled: disabled,
          skeleton: skeleton
        };
        this._contextWeUse = extend(this.context, {
          FormRow: _FormRow2
        });
      }

      var useFieldset = !isTrue(no_fieldset) && hasLabel;
      return React.createElement(Context.Provider, {
        value: this._contextWeUse
      }, React.createElement(Fieldset, {
        useFieldset: useFieldset
      }, React.createElement("div", params, _ref, label && React.createElement(FormLabel, {
        className: classnames('dnb-form-row__label', label_class),
        id: label_id ? label_id : id + '-label',
        for_id: useFieldset ? null : id,
        text: label,
        element: useFieldset ? 'legend' : 'label',
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton
      }), isTrue(no_label) && _ref2, isNested && skipContentWrapperIfNested ? children : React.createElement("div", {
        className: classnames('dnb-form-row__content', isTrue(wrap) && 'dnb-form-row__content--wrap', label && !isTrue(vertical) && direction !== 'vertical' && "dnb-form-row__content--".concat(indent_offset || 'default'), responsive && 'dnb-responsive-component'),
        ref: this._contentRef
      }, children))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(FormRow.tagName, FormRow, FormRow.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      var label = null;
      var children = typeof props.children === 'function' ? props.children(props) : props.children;

      if (Array.isArray(props.children)) {
        children = children.reduce(function (pV, cV) {
          if (cV && cV.type && cV.type.name === 'FormLabel') {
            label = cV.props.children;
          } else {
            pV.push(cV);
          }

          return pV;
        }, []);
      }

      return {
        label: label,
        children: children
      };
    }
  }]);

  return FormRow;
}(React.PureComponent);

FormRow.tagName = 'dnb-form-row';
FormRow.contextType = Context;
FormRow.defaultProps = _extends({}, formRowDefaultProps);
export { FormRow as default };
process.env.NODE_ENV !== "production" ? FormRow.propTypes = _extends({}, formRowPropTypes) : void 0;

var Fieldset = function Fieldset(_ref3) {
  var useFieldset = _ref3.useFieldset,
      className = _ref3.className,
      children = _ref3.children,
      props = _objectWithoutProperties(_ref3, ["useFieldset", "className", "children"]);

  if (useFieldset) {
    return React.createElement("fieldset", _extends({
      className: classnames('dnb-form-row__fieldset', className)
    }, props), children);
  }

  return React.createElement("div", _extends({
    className: classnames('dnb-form-row__fieldset', className)
  }, props), children);
};

process.env.NODE_ENV !== "production" ? Fieldset.propTypes = {
  children: PropTypes.node,
  useFieldset: PropTypes.bool,
  className: PropTypes.string
} : void 0;
Fieldset.defaultProps = {
  children: null,
  useFieldset: false,
  className: null
};
export var prepareFormRowContext = function prepareFormRowContext(props) {
  if (typeof props.label_direction === 'undefined') {
    props.label_direction = isTrue(props.vertical) ? 'vertical' : props.label_direction;
  }

  return props;
};