import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.object.entries.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { isTrue, makeUniqueId, extend, registerElement, validateDOMAttributes, processChildren, dispatchCustomElementEvent } from '../../shared/component-helper';
import { createSpacingClasses } from '../space/SpacingHelper';
import Context from '../../shared/Context';
import hashSum from '../../shared/libs/HashSum';
import { formRowDefaultProps, formRowPropTypes } from '../form-row/FormRow';

var FormSet = function (_React$PureComponent) {
  _inherits(FormSet, _React$PureComponent);

  var _super = _createSuper(FormSet);

  function FormSet(props) {
    var _this;

    _classCallCheck(this, FormSet);

    _this = _super.call(this, props);

    _this.onSubmitHandler = function (event) {
      var prevent_submit = _this.props.prevent_submit;

      if (isTrue(prevent_submit)) {
        event.preventDefault();
      }

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_submit', {
        event: event
      });
    };

    _this._id = props.id || makeUniqueId();
    return _this;
  }

  _createClass(FormSet, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          element = _this$props.element,
          no_form = _this$props.no_form,
          prevent_submit = _this$props.prevent_submit,
          disabled = _this$props.disabled,
          id = _this$props.id,
          className = _this$props.className,
          _className = _this$props.class,
          rest = _objectWithoutProperties(_this$props, ["element", "no_form", "prevent_submit", "disabled", "id", "className", "class"]);

      var formRowProps = Object.entries(rest).reduce(function (acc, _ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            k = _ref2[0],
            v = _ref2[1];

        if (typeof formRowDefaultProps[k] !== 'undefined' && k !== 'id' && k !== 'children' && k !== 'label') {
          acc[k] = v;
        }

        return acc;
      }, {});
      var attributes = Object.entries(rest).reduce(function (acc, _ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            k = _ref4[0],
            v = _ref4[1];

        if (typeof formRowProps[k] === 'undefined') {
          acc[k] = v;
        }

        return acc;
      }, {});

      var params = _extends({
        className: classnames('dnb-form-set', createSpacingClasses(this.props), className, _className)
      }, attributes);

      if (!isTrue(no_form)) {
        params.onSubmit = this.onSubmitHandler;
      }

      validateDOMAttributes(this.props, params);
      var content = FormSet.getContent(this.props);

      if (hashSum(this._cachedContext) !== hashSum(this.context)) {
        this._cachedContext = this.context;

        var FormRow = _extends({}, formRowProps, {
          disabled: disabled
        });

        this._contextWeUse = extend(this.context, {
          FormRow: FormRow
        });
      }

      var Element = isTrue(no_form) ? 'div' : element;
      return React.createElement(Context.Provider, {
        value: this._contextWeUse
      }, React.createElement(Element, params, content));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(FormSet.tagName, FormSet, FormSet.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      return processChildren(props);
    }
  }]);

  return FormSet;
}(React.PureComponent);

FormSet.tagName = 'dnb-form-set';
FormSet.contextType = Context;
FormSet.defaultProps = {
  element: 'form',
  no_form: false,
  prevent_submit: false,
  on_submit: null,
  custom_element: null,
  custom_method: null
};
export { FormSet as default };
process.env.NODE_ENV !== "production" ? FormSet.propTypes = _extends({
  element: PropTypes.string,
  no_form: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_submit: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, formRowPropTypes, {
  on_submit: PropTypes.func,
  custom_element: PropTypes.object,
  custom_method: PropTypes.func
}) : void 0;