import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.string.split.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import { isTrue, registerElement, makeUniqueId, validateDOMAttributes, processChildren, extendPropsWithContext } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import Icon from '../icon/Icon';
import GlobalStatusProvider from '../global-status/GlobalStatusProvider';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';

var FormStatus = function (_React$PureComponent) {
  _inherits(FormStatus, _React$PureComponent);

  var _super = _createSuper(FormStatus);

  function FormStatus(props) {
    var _this;

    _classCallCheck(this, FormStatus);

    _this = _super.call(this, props);
    _this.state = {
      id: null
    };

    _this.init = function () {
      if (_this._isMounted) {
        if (_this.gsProvider) {
          _this.gsProvider.isReady();
        }

        _this.updateWidth();
      }
    };

    _this.state.id = props.id || makeUniqueId();

    if (props.status !== 'info') {
      _this.gsProvider = GlobalStatusProvider.init(props.global_status_id || 'main', function (provider) {
        var _this$props = _this.props,
            state = _this$props.state,
            text = _this$props.text,
            label = _this$props.label;
        provider.add({
          state: state,
          status_id: "".concat(_this.state.id, "-gs"),
          item: {
            status_id: _this.state.id,
            text: text,
            status_anchor_label: label,
            status_anchor_url: true
          }
        });
      });
    }

    _this._ref = React.createRef();
    return _this;
  }

  _createClass(FormStatus, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;

      if (document.readyState === 'complete') {
        this.init();
      } else if (typeof window !== 'undefined') {
        window.addEventListener('load', this.init);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;

      if (this.gsProvider) {
        var status_id = "".concat(this.state.id, "-gs");
        this.gsProvider.remove(status_id);
      }

      if (typeof window !== 'undefined') {
        window.removeEventListener('load', this.init);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.gsProvider && (prevProps.text !== this.props.text || prevProps.state !== this.props.state)) {
        var _this$props2 = this.props,
            state = _this$props2.state,
            text = _this$props2.text,
            label = _this$props2.label;
        var status_id = "".concat(this.state.id, "-gs");
        this.gsProvider.update(status_id, {
          state: state,
          item: {
            status_id: this.state.id,
            text: text,
            status_anchor_label: label,
            status_anchor_url: true
          }
        }, {
          preventRestack: true
        });
      }

      this.updateWidth();
    }
  }, {
    key: "correctStatus",
    value: function correctStatus(state) {
      switch (state) {
        case 'information':
          state = 'info';
          break;

        case 'warning':
          state = 'warn';
          break;
      }

      return state;
    }
  }, {
    key: "updateWidth",
    value: function updateWidth() {
      if (this._ref.current) {
        var _this$props3 = this.props,
            width_element = _this$props3.width_element,
            width_selector = _this$props3.width_selector;
        setMaxWidthToElement({
          element: this._ref.current,
          widthElement: width_element && width_element.current,
          widthSelector: width_selector
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, FormStatus.defaultProps, {
        skeleton: this.context && this.context.skeleton
      }, this.context.FormRow, this.context.FormStatus);

      var title = props.title,
          rawStatus = props.status,
          rawState = props.state,
          size = props.size,
          variant = props.variant,
          hidden = props.hidden,
          className = props.className,
          animation = props.animation,
          _className = props.class,
          text_id = props.text_id,
          status_id = props.status_id,
          id = props.id,
          text = props.text,
          icon = props.icon,
          icon_size = props.icon_size,
          skeleton = props.skeleton,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["title", "status", "state", "size", "variant", "hidden", "className", "animation", "class", "text_id", "status_id", "id", "text", "icon", "icon_size", "skeleton", "children"]);

      var state = this.correctStatus(rawStatus || rawState);
      var iconToRender = FormStatus.getIcon({
        state: state,
        icon: icon,
        icon_size: icon_size
      });
      var contentToRender = FormStatus.getContent(this.props);

      if (contentToRender === null) {
        return React.createElement(React.Fragment, null);
      }

      var hasStringContent = typeof contentToRender === 'string' && contentToRender.length > 0;

      var params = _extends({
        id: this.state.id,
        hidden: hidden,
        className: classnames("dnb-form-status dnb-form-status--".concat(state, " dnb-form-status__size--").concat(size), createSpacingClasses(props), className, _className, variant && "dnb-form-status__variant--".concat(variant), animation && "dnb-form-status__animation--".concat(animation), hasStringContent && 'dnb-form-status--has-content'),
        title: title
      }, attributes);

      var textParams = {
        className: classnames('dnb-form-status__text', createSkeletonClass('font', skeleton, this.context)),
        id: text_id
      };

      if (hidden) {
        params['aria-hidden'] = hidden;
      }

      skeletonDOMAttributes(params, skeleton, this.context);
      validateDOMAttributes(this.props, params);
      validateDOMAttributes(null, textParams);
      return React.createElement("span", _extends({}, params, {
        ref: this._ref
      }), React.createElement("span", {
        className: "dnb-form-status__shell"
      }, iconToRender, React.createElement("span", textParams, contentToRender)));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(FormStatus.tagName, FormStatus, FormStatus.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.text) {
        if (isTrue(props.text)) {
          return null;
        }

        return props.text;
      }

      return processChildren(props);
    }
  }, {
    key: "getIcon",
    value: function getIcon(_ref) {
      var state = _ref.state,
          icon = _ref.icon,
          icon_size = _ref.icon_size;

      if (typeof icon === 'string') {
        var IconToLoad = icon;

        switch (state) {
          case 'info':
          case 'information':
            IconToLoad = InfoIcon;
            break;

          case 'warn':
          case 'warning':
            IconToLoad = WarnIcon;
            break;

          case 'error':
          default:
            IconToLoad = ErrorIcon;
        }

        icon = React.createElement(Icon, {
          icon: React.createElement(IconToLoad, {
            title: null
          }),
          size: icon_size,
          inherit_color: false
        });
      }

      return icon;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._id !== props.id) {
        state.id = props.id;
      }

      state._id = props.id;
      return state;
    }
  }]);

  return FormStatus;
}(React.PureComponent);

FormStatus.tagName = 'dnb-form-status';
FormStatus.contextType = Context;
FormStatus.defaultProps = {
  id: null,
  title: null,
  text: null,
  label: null,
  icon: 'error',
  icon_size: 'medium',
  size: 'default',
  variant: null,
  state: 'error',
  status: null,
  global_status_id: null,
  hidden: false,
  text_id: null,
  width_selector: null,
  width_element: null,
  class: null,
  animation: null,
  skeleton: null,
  className: null,
  children: null
};
export { FormStatus as default };
process.env.NODE_ENV !== "production" ? FormStatus.propTypes = _extends({
  id: PropTypes.string,
  title: PropTypes.string,
  text: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  label: PropTypes.node,
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  icon_size: PropTypes.string,
  state: PropTypes.oneOfType([PropTypes.bool, PropTypes.string, PropTypes.oneOf(['error', 'warn', 'info'])]),
  variant: PropTypes.oneOf(['flat', 'outlined']),
  size: PropTypes.oneOf(['default', 'large']),
  status: PropTypes.oneOfType([PropTypes.bool, PropTypes.string, PropTypes.oneOf(['error', 'warn', 'info'])]),
  global_status_id: PropTypes.string,
  hidden: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  text_id: PropTypes.string,
  width_selector: PropTypes.string,
  width_element: PropTypes.object,
  class: PropTypes.string,
  animation: PropTypes.string,
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node])
}) : void 0;

var _ref2 = React.createElement("path", {
  d: "M23.625 17.864A3.547 3.547 0 0120.45 23H3.548a3.546 3.546 0 01-3.172-5.136l8.45-14.902a3.548 3.548 0 016.347 0l8.452 14.902z",
  fill: "#DC2A2A"
});

var _ref3 = React.createElement("path", {
  d: "M12 16.286a1.286 1.286 0 100 2.572 1.286 1.286 0 000-2.572z",
  fill: "#fff"
});

var _ref4 = React.createElement("path", {
  d: "M12 13.818v-5",
  stroke: "#fff",
  strokeWidth: "1.5",
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

export var ErrorIcon = function ErrorIcon(props) {
  return React.createElement("svg", _extends({
    width: "24",
    height: "24",
    viewBox: "0 0 24 24",
    fill: "none",
    role: "presentation"
  }, props), props && props.title && React.createElement("title", null, props.title), _ref2, _ref3, _ref4);
};
process.env.NODE_ENV !== "production" ? ErrorIcon.propTypes = {
  title: PropTypes.string
} : void 0;
ErrorIcon.defaultProps = {
  title: 'error'
};

var _ref5 = React.createElement("path", {
  d: "M23.625 17.864A3.547 3.547 0 0120.45 23H3.548a3.546 3.546 0 01-3.172-5.136l8.45-14.902a3.548 3.548 0 016.347 0l8.452 14.902z",
  fill: "#FDBB31"
});

var _ref6 = React.createElement("path", {
  d: "M12 16.286a1.286 1.286 0 100 2.572 1.286 1.286 0 000-2.572z",
  fill: "#333"
});

var _ref7 = React.createElement("path", {
  d: "M12 13.818v-5",
  stroke: "#333",
  strokeWidth: "1.5",
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

export var WarnIcon = function WarnIcon(props) {
  return React.createElement("svg", _extends({
    width: "24",
    height: "24",
    viewBox: "0 0 24 24",
    fill: "none",
    role: "presentation"
  }, props), props && props.title && React.createElement("title", null, props.title), _ref5, _ref6, _ref7);
};
process.env.NODE_ENV !== "production" ? WarnIcon.propTypes = {
  title: PropTypes.string
} : void 0;
WarnIcon.defaultProps = {
  title: 'error'
};

var _ref8 = React.createElement("path", {
  fillRule: "evenodd",
  clipRule: "evenodd",
  d: "M11.268 0a11.25 11.25 0 105.566 21.017l6.112 2.91a.75.75 0 001-1l-2.911-6.112A11.234 11.234 0 0011.268 0z",
  fill: "#007272"
});

var _ref9 = React.createElement("circle", {
  cx: "11",
  cy: "6.5",
  r: ".5",
  fill: "#fff",
  stroke: "#fff"
});

var _ref10 = React.createElement("path", {
  d: "M13.75 16H13a1.5 1.5 0 01-1.5-1.5v-3.75a.75.75 0 00-.75-.75H10",
  stroke: "#fff",
  strokeWidth: "1.5",
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

export var InfoIcon = function InfoIcon(props) {
  return React.createElement("svg", _extends({
    width: "24",
    height: "24",
    viewBox: "0 0 24 24",
    fill: "none",
    role: "presentation"
  }, props), props && props.title && React.createElement("title", null, props.title), _ref8, _ref9, _ref10);
};
process.env.NODE_ENV !== "production" ? InfoIcon.propTypes = {
  title: PropTypes.string
} : void 0;
InfoIcon.defaultProps = {
  title: 'info'
};
export function setMaxWidthToElement(_ref11) {
  var element = _ref11.element,
      _ref11$id = _ref11.id,
      id = _ref11$id === void 0 ? null : _ref11$id,
      _ref11$widthElement = _ref11.widthElement,
      widthElement = _ref11$widthElement === void 0 ? null : _ref11$widthElement,
      _ref11$widthSelector = _ref11.widthSelector,
      widthSelector = _ref11$widthSelector === void 0 ? null : _ref11$widthSelector;

  if (!(element && typeof window !== 'undefined')) {
    return;
  }

  try {
    if (!id && !widthSelector) {
      id = element.getAttribute('id');
    }

    var width = sumElementWidth({
      widthElement: widthElement,
      widthSelector: widthSelector || id.replace('-form-status', '') || id
    });

    if (width > 40) {
      var minWidth = 12 * 16;

      if (width < minWidth) {
        width = minWidth;
      }

      var remWidth = "".concat(width / 16, "rem");
      var cS = window.getComputedStyle(element);
      var hasCustomWidth = element.style.maxWidth ? false : cS.minWidth !== '' && cS.minWidth !== 'auto' || cS.maxWidth !== '' && cS.maxWidth !== 'none';

      if (!hasCustomWidth) {
        element.style.maxWidth = remWidth;
      }
    }
  } catch (e) {}
}

function sumElementWidth(_ref12) {
  var widthElement = _ref12.widthElement,
      widthSelector = _ref12.widthSelector;
  var width = 0;

  if (typeof document === 'undefined') {
    return width;
  }

  try {
    var ids = widthElement ? [widthElement] : widthSelector.split(/, |,/g);
    width = ids.reduce(function (acc, cur) {
      var elem = typeof cur === 'string' ? cur[0] === '.' ? document.querySelector(cur) : document.getElementById(cur) : cur;
      var width = elem && elem.offsetWidth || window.getComputedStyle(elem).width;

      if (/em|rem/.test(width)) {
        width = parseFloat(width) * 16;
      }

      if (width > 0) {
        if (acc > 0) {
          acc += 16;
        }

        acc += width;
      }

      return acc;
    }, width);
  } catch (e) {}

  return width;
}