import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { isTrue, validateDOMAttributes, registerElement } from '../../shared/component-helper';
import '../../shared/helpers';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import HeadingContext from './HeadingContext';
import Context from '../../shared/Context';
import HeadingProvider from './HeadingProvider';
import { createSkeletonClass } from '../skeleton/SkeletonHelper';
import { correctHeadingLevel, resetLevels, resetAllLevels, setNextLevel, globalSyncCounter, globalHeadingCounter, windupHeadings, teardownHeadings, debugCounter } from './HeadingHelpers';
import { initCounter } from './HeadingCounter';
export var levelResolution = {
  1: 'xx-large',
  2: 'large',
  3: 'medium',
  4: 'basis',
  5: 'small',
  6: 'x-small'
};

var Heading = function (_React$PureComponent) {
  _inherits(Heading, _React$PureComponent);

  var _super = _createSuper(Heading);

  function Heading(props, context) {
    var _context$heading, _state$context$headin, _state$context$headin2;

    var _this;

    _classCallCheck(this, Heading);

    _this = _super.call(this, props);
    _this._ref = React.createRef();
    var state = {
      context: context,
      _listenForPropChanges: true
    };

    if ((_context$heading = context.heading) !== null && _context$heading !== void 0 && _context$heading.counter) {
      state.counter = initCounter(props);
      state.counter.setContextCounter(context.heading.counter);
      state.counter.isHeading = true;
    } else {
      state.counter = initCounter(props);
      state.counter.setContextCounter(globalHeadingCounter.current);
      state.counter.isHeading = true;
    }

    state.counter = correctHeadingLevel({
      ref: props,
      counter: state.counter,
      level: parseFloat(props.level),
      inherit: isTrue(props.inherit),
      reset: props.reset,
      increase: isTrue(props.increase) || isTrue(props.up),
      decrease: isTrue(props.decrease) || isTrue(props.down),
      bypassChecks: isTrue(props.skip_correction) || isTrue((_state$context$headin = state.context.heading) === null || _state$context$headin === void 0 ? void 0 : _state$context$headin.skip_correction),
      source: props.text || props.children,
      debug: props.debug || ((_state$context$headin2 = state.context.heading) === null || _state$context$headin2 === void 0 ? void 0 : _state$context$headin2.debug)
    });
    globalSyncCounter.current = state.counter;
    state.level = state.counter.level;
    state.prevLevel = props.level;
    _this.state = state;
    return _this;
  }

  _createClass(Heading, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      windupHeadings();
      this.state.counter.windup();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      teardownHeadings();
      this.state.counter.teardown();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context$heading,
          _this$context$heading2,
          _this2 = this;

      var _this$props = this.props,
          text = _this$props.text,
          _relevel = _this$props.relevel,
          _group = _this$props.group,
          _debug = _this$props.debug,
          _debug_counter = _this$props.debug_counter,
          _reset = _this$props.reset,
          _skip_correction = _this$props.skip_correction,
          _increase = _this$props.increase,
          _decrease = _this$props.decrease,
          _up = _this$props.up,
          _down = _this$props.down,
          _inherit = _this$props.inherit,
          _level = _this$props.level,
          _size = _this$props.size,
          _skeleton = _this$props.skeleton,
          _element = _this$props.element,
          _className = _this$props.class,
          className = _this$props.className,
          children = _this$props.children,
          rest = _objectWithoutProperties(_this$props, ["text", "relevel", "group", "debug", "debug_counter", "reset", "skip_correction", "increase", "decrease", "up", "down", "inherit", "level", "size", "skeleton", "element", "class", "className", "children"]);

      var _this$props2 = this.props,
          size = _this$props2.size,
          element = _this$props2.element,
          skeleton = _this$props2.skeleton;
      var level = this.state.level;
      var debug = _debug || ((_this$context$heading = this.context.heading) === null || _this$context$heading === void 0 ? void 0 : _this$context$heading.debug);
      var debug_counter = _debug_counter || ((_this$context$heading2 = this.context.heading) === null || _this$context$heading2 === void 0 ? void 0 : _this$context$heading2.debug_counter);

      var attributes = _extends({}, rest);

      if (element === 'auto' || element === null) {
        element = "h".concat(level || '6');

        if (_size === 'auto' || _size === null) {
          size = levelResolution[level || '6'];
        }
      } else {
        if (!attributes.role) {
          attributes.role = 'heading';
        }

        if (!attributes['aria-level']) {
          attributes['aria-level'] = String(level);
        }
      }

      validateDOMAttributes(this.props, attributes);
      var Element = element;
      return React.createElement(Context.Consumer, null, function (context) {
        if (typeof (context === null || context === void 0 ? void 0 : context.skeleton) !== 'undefined') {
          skeleton = context.skeleton;
        }

        attributes.className = classnames("dnb-heading dnb-h--".concat(size), createSkeletonClass('font', skeleton, _this2.context), className, _className, createSpacingClasses(_this2.props));
        attributes.children = React.createElement(React.Fragment, null, debug && React.createElement("span", {
          className: "dnb-heading__debug"
        }, "[h".concat(level || '6', "] "), debug_counter && React.createElement(React.Fragment, null, ' ', React.createElement("span", {
          className: "dnb-code"
        }, debugCounter(_this2.state.counter)))), text || children);
        return React.createElement(Element, _extends({
          ref: _this2._ref
        }, attributes));
      });
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Heading.tagName, Heading, Heading.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        var level = parseFloat(props.level);

        if (state.prevLevel !== props.level && level > 0 && level !== state.level || props.relevel) {
          var _state$context$headin3, _state$context$headin4;

          state.counter.skipMakeMeReady();

          var _correctHeadingLevel = correctHeadingLevel({
            counter: state.counter,
            level: level,
            bypassChecks: isTrue(props.skip_correction) || isTrue((_state$context$headin3 = state.context.heading) === null || _state$context$headin3 === void 0 ? void 0 : _state$context$headin3.skip_correction),
            source: props.text || props.children,
            debug: props.debug || ((_state$context$headin4 = state.context.heading) === null || _state$context$headin4 === void 0 ? void 0 : _state$context$headin4.debug)
          }),
              newLevel = _correctHeadingLevel.level;

          state.level = state.prevLevel = newLevel;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return Heading;
}(React.PureComponent);

Heading.tagName = 'dnb-heading';
Heading.contextType = HeadingContext;
Heading.defaultProps = {
  id: null,
  group: null,
  text: null,
  size: 'auto',
  level: null,
  increase: null,
  decrease: null,
  up: null,
  down: null,
  skip_correction: null,
  debug: null,
  debug_counter: null,
  counter: null,
  reset: null,
  inherit: null,
  skeleton: null,
  element: 'auto',
  class: null,
  className: null,
  children: null
};
export { Heading as default };
process.env.NODE_ENV !== "production" ? Heading.propTypes = _extends({
  id: PropTypes.string,
  group: PropTypes.string,
  text: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  size: PropTypes.oneOf(['auto', 'xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  level: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  increase: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  decrease: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  up: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  down: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skip_correction: PropTypes.bool,
  debug: PropTypes.oneOfType([PropTypes.bool, PropTypes.func]),
  debug_counter: PropTypes.oneOfType([PropTypes.bool, PropTypes.func]),
  counter: PropTypes.any,
  inherit: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  reset: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  element: PropTypes.string
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
}) : void 0;
Heading.Level = HeadingProvider;

Heading.Increase = function (props) {
  return React.createElement(HeadingProvider, _extends({
    increase: true
  }, props));
};

Heading.Decrease = function (props) {
  return React.createElement(HeadingProvider, _extends({
    decrease: true
  }, props));
};

Heading.Up = function (props) {
  return React.createElement(HeadingProvider, _extends({
    increase: true
  }, props));
};

Heading.Down = function (props) {
  return React.createElement(HeadingProvider, _extends({
    decrease: true
  }, props));
};

Heading.Reset = function (props) {
  var _globalHeadingCounter;

  (_globalHeadingCounter = globalHeadingCounter.current) === null || _globalHeadingCounter === void 0 ? void 0 : _globalHeadingCounter.reset();
  return React.createElement(HeadingProvider, props);
};

Heading.resetLevels = resetLevels;
Heading.setNextLevel = setNextLevel;
export { resetAllLevels, resetLevels, setNextLevel };