import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.last-index-of.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.slice.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.string.match.js";
import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.string.split.js";
import _typeof from "@babel/runtime/helpers/esm/typeof";
var emptyString = '';
export default function createNumberMask() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$prefix = _ref.prefix,
      prefix = _ref$prefix === void 0 ? emptyString : _ref$prefix,
      _ref$suffix = _ref.suffix,
      suffix = _ref$suffix === void 0 ? emptyString : _ref$suffix,
      _ref$includeThousands = _ref.includeThousandsSeparator,
      includeThousandsSeparator = _ref$includeThousands === void 0 ? true : _ref$includeThousands,
      _ref$thousandsSeparat = _ref.thousandsSeparatorSymbol,
      thousandsSeparatorSymbol = _ref$thousandsSeparat === void 0 ? ' ' : _ref$thousandsSeparat,
      _ref$allowDecimal = _ref.allowDecimal,
      allowDecimal = _ref$allowDecimal === void 0 ? false : _ref$allowDecimal,
      _ref$decimalSymbol = _ref.decimalSymbol,
      decimalSymbol = _ref$decimalSymbol === void 0 ? ',' : _ref$decimalSymbol,
      _ref$decimalLimit = _ref.decimalLimit,
      decimalLimit = _ref$decimalLimit === void 0 ? 2 : _ref$decimalLimit,
      _ref$requireDecimal = _ref.requireDecimal,
      requireDecimal = _ref$requireDecimal === void 0 ? false : _ref$requireDecimal,
      _ref$allowNegative = _ref.allowNegative,
      allowNegative = _ref$allowNegative === void 0 ? true : _ref$allowNegative,
      _ref$allowLeadingZero = _ref.allowLeadingZeroes,
      allowLeadingZeroes = _ref$allowLeadingZero === void 0 ? false : _ref$allowLeadingZero,
      _ref$integerLimit = _ref.integerLimit,
      integerLimit = _ref$integerLimit === void 0 ? null : _ref$integerLimit;

  var minus = '-';
  var minusRegExp = /-/;
  var nonDigitsRegExp = /\D+/g;
  var number = 'number';
  var caretTrap = '[]';
  var digitRegExp = /\d/;

  function convertToMask(strNumber) {
    return strNumber.split(emptyString).map(function (char) {
      return digitRegExp.test(char) ? digitRegExp : char;
    });
  }

  function addThousandsSeparator(n, thousandsSeparatorSymbol) {
    return n.replace(/\B(?=(\d{3})+(?!\d))/g, thousandsSeparatorSymbol);
  }

  var prefixLength = prefix && prefix.length || 0;
  var suffixLength = suffix && suffix.length || 0;
  var thousandsSeparatorSymbolLength = thousandsSeparatorSymbol && thousandsSeparatorSymbol.length || 0;

  function numberMask() {
    var rawValue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : emptyString;
    var rawValueLength = rawValue.length;

    if (rawValue === emptyString || rawValue[0] === prefix[0] && rawValueLength === 1) {
      return prefix.split(emptyString).concat([digitRegExp]).concat(suffix.split(emptyString));
    } else if (rawValue === decimalSymbol && allowDecimal) {
      return prefix.split(emptyString).concat(['0', decimalSymbol, digitRegExp]).concat(suffix.split(emptyString));
    }

    var isNegative = rawValue[0] === minus && allowNegative;

    if (isNegative) {
      rawValue = rawValue.toString().substr(1);
    }

    var indexOfLastDecimal = rawValue.lastIndexOf(decimalSymbol);
    var hasDecimal = indexOfLastDecimal !== -1;
    var integer;
    var fraction;
    var mask;

    if (rawValue.slice(suffixLength * -1) === suffix) {
      rawValue = rawValue.slice(0, suffixLength * -1);
    }

    if (hasDecimal && (allowDecimal || requireDecimal)) {
      integer = rawValue.slice(rawValue.slice(0, prefixLength) === prefix ? prefixLength : 0, indexOfLastDecimal);
      fraction = rawValue.slice(indexOfLastDecimal + 1, rawValueLength);
      fraction = convertToMask(fraction.replace(nonDigitsRegExp, emptyString));
    } else {
      if (rawValue.slice(0, prefixLength) === prefix) {
        integer = rawValue.slice(prefixLength);
      } else {
        integer = rawValue;
      }
    }

    if (integerLimit && _typeof(integerLimit) === number) {
      var thousandsSeparatorRegex = thousandsSeparatorSymbol === '.' ? '[.]' : "".concat(thousandsSeparatorSymbol);
      var numberOfThousandSeparators = (integer.match(new RegExp(thousandsSeparatorRegex, 'g')) || []).length;
      integer = integer.slice(0, integerLimit + numberOfThousandSeparators * thousandsSeparatorSymbolLength);
    }

    integer = integer.replace(nonDigitsRegExp, emptyString);

    if (!allowLeadingZeroes) {
      integer = integer.replace(/^0+(0$|[^0])/, '$1');
    }

    integer = includeThousandsSeparator ? addThousandsSeparator(integer, thousandsSeparatorSymbol) : integer;
    mask = convertToMask(integer);

    if (hasDecimal && allowDecimal || requireDecimal === true) {
      if (rawValue[indexOfLastDecimal - 1] !== decimalSymbol) {
        mask.push(caretTrap);
      }

      mask.push(decimalSymbol, caretTrap);

      if (fraction) {
        if (_typeof(decimalLimit) === number) {
          fraction = fraction.slice(0, decimalLimit);
        }

        mask = mask.concat(fraction);
      }

      if (requireDecimal === true && rawValue[indexOfLastDecimal - 1] === decimalSymbol) {
        mask.push(digitRegExp);
      }
    }

    if (prefixLength > 0) {
      mask = prefix.split(emptyString).concat(mask);
    }

    if (isNegative) {
      if (mask.length === prefixLength) {
        mask.push(digitRegExp);
      }

      mask = [minusRegExp].concat(mask);
    }

    if (suffix.length > 0) {
      mask = mask.concat(suffix.split(emptyString));
    }

    return mask;
  }

  numberMask.instanceOf = 'createNumberMask';
  return numberMask;
}