import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import Input, { SubmitButton } from './Input';
import { makeUniqueId, extendPropsWithContext, convertStatusToStateOnly, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import IconView from '../../icons/view';
import IconViewOff from '../../icons/hide';
import IconViewMedium from '../../icons/view_medium';
import IconViewOffMedium from '../../icons/hide_medium';

var InputPassword = function (_React$PureComponent) {
  _inherits(InputPassword, _React$PureComponent);

  var _super = _createSuper(InputPassword);

  function InputPassword(props) {
    var _this;

    _classCallCheck(this, InputPassword);

    _this = _super.call(this, props);
    _this.state = {
      hidden: true
    };

    _this.toggleVisibility = function (event) {
      var hidden = _this.state.hidden;

      _this.setState({
        hidden: !hidden
      }, function () {
        if (_this._ref.current) {
          _this._ref.current.focus();
        }
      });

      dispatchCustomElementEvent(_assertThisInitialized(_this), hidden ? 'on_show_password' : 'on_hide_password', {
        event: event
      });
    };

    _this._id = props.id || makeUniqueId();
    _this._ref = props.inner_ref || React.createRef();
    return _this;
  }

  _createClass(InputPassword, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = extendPropsWithContext(this.props, InputPassword.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Input, this.context.FormRow, this.context.Input, this.context.InputPassword);
      var id = this._id;
      var params = {};
      params['aria-describedby'] = combineDescribedBy(this.props, id + '-submit-button');
      return React.createElement(Input, _extends({
        id: id
      }, this.props, params, {
        className: classnames('dnb-input--password', this.props.className),
        type: this.state.hidden ? 'password' : 'text',
        inner_ref: this._ref,
        submit_element: React.createElement(SubmitButton, {
          id: id + '-submit-button',
          type: "button",
          variant: "secondary",
          "aria-controls": id,
          "aria-label": this.state.hidden ? props.show_password : props.hide_password,
          icon: props.size === 'large' ? this.state.hidden ? IconViewMedium : IconViewOffMedium : this.state.hidden ? IconView : IconViewOff,
          skeleton: props.skeleton,
          status: convertStatusToStateOnly(props.status, props.status_state),
          status_state: props.status_state,
          onClick: this.toggleVisibility
        })
      }));
    }
  }]);

  return InputPassword;
}(React.PureComponent);

InputPassword.contextType = Context;
InputPassword.defaultProps = _extends({
  show_password: null,
  hide_password: null,
  on_show_password: null,
  on_hide_password: null
}, Input.defaultProps);
export { InputPassword as default };
process.env.NODE_ENV !== "production" ? InputPassword.propTypes = _extends({
  show_password: PropTypes.string,
  hide_password: PropTypes.string,
  on_show_password: PropTypes.func,
  on_hide_password: PropTypes.func
}, Input.propTypes) : void 0;