import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.for-each.js";
import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.object.freeze.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.includes.js";
import "core-js/modules/es.string.replace.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { SuffixContext } from '../../shared/helpers/Suffix';
import Context from '../../shared/Context';
import { warn, isTrue, makeUniqueId, extendPropsWithContext, registerElement, processChildren, dispatchCustomElementEvent } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { buttonVariantPropType } from '../button/Button';
import HelpButtonInstance from '../help-button/HelpButtonInstance';
import ModalContent, { CloseButton, getListOfModalRoots } from './ModalContent';
import ModalInner from './ModalInner';

var Modal = function (_React$PureComponent) {
  _inherits(Modal, _React$PureComponent);

  var _super = _createSuper(Modal);

  function Modal(props) {
    var _this;

    _classCallCheck(this, Modal);

    _this = _super.call(this, props);
    _this.state = {
      hide: false,
      modalActive: false,
      _listenForPropChanges: true
    };

    _this.toggleOpenClose = function () {
      var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var showModal = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (event && event.preventDefault) {
        event.preventDefault();
      }

      var toggleNow = function toggleNow() {
        var modalActive = typeof showModal === 'boolean' ? showModal : !_this.state.modalActive;
        _this.isInTransition = true;

        var doItNow = function doItNow() {
          _this.setState({
            hide: false,
            modalActive: modalActive,
            _listenForPropChanges: false
          }, function () {
            _this.isInTransition = false;

            _this.handleSideEffects();
          });
        };

        if (modalActive === false && !isTrue(_this.props.no_animation)) {
          _this.setState({
            hide: true,
            _listenForPropChanges: false
          });

          clearTimeout(_this._closeTimeout);
          _this._closeTimeout = setTimeout(doItNow, parseFloat(_this.props.animation_duration));
        } else {
          doItNow();
        }
      };

      var waitBeforeOpen = function waitBeforeOpen() {
        var delay = parseFloat(_this.props.open_delay);

        if (delay > 0 && !isTrue(_this.props.no_animation)) {
          clearTimeout(_this._openTimeout);
          _this._openTimeout = setTimeout(toggleNow, delay);
        } else {
          toggleNow();
        }
      };

      var open_modal = _this.props.open_modal;

      if (typeof open_modal === 'function') {
        var fn = open_modal(waitBeforeOpen, _assertThisInitialized(_this));

        if (fn) {
          _this._onUnmount.push(fn);
        }
      } else {
        waitBeforeOpen();
      }
    };

    _this.handleSideEffects = function () {
      var modalActive = _this.state.modalActive;

      if (typeof document !== 'undefined') {
        try {
          document.body.setAttribute('data-dnb-modal-active', modalActive ? 'true' : 'false');
        } catch (e) {
          warn('Modal: Error on set "data-dnb-modal-active" by using element.setAttribute()', e);
        }
      }

      if (modalActive) {
        if (typeof _this.props.close_modal === 'function') {
          var fn = _this.props.close_modal(function () {
            _this.toggleOpenClose(null, false);
          }, _assertThisInitialized(_this));

          if (fn) {
            _this._onUnmount.push(fn);
          }
        }
      } else if (modalActive === false) {
        if (_this._triggerRef && _this._triggerRef.current) {
          _this._triggerRef.current.focus({
            preventScroll: true
          });
        }

        if ((_this.props.open_state === 'opened' || _this.props.open_state === true) && _this.activeElement) {
          try {
            _this.activeElement.focus({
              preventScroll: true
            });

            _this.activeElement = null;
          } catch (e) {}
        }
      }
    };

    _this.open = function (e) {
      _this.toggleOpenClose(e, true);
    };

    _this.close = function (event) {
      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        ifIsLatest: true
      },
          ifIsLatest = _ref.ifIsLatest,
          triggeredBy = _ref.triggeredBy;

      var prevent_close = _this.props.prevent_close;

      if (isTrue(prevent_close)) {
        var id = _this._id;
        dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_close_prevent', {
          id: id,
          event: event,
          triggeredBy: triggeredBy,
          close: function close(e) {
            _this.toggleOpenClose(e, false);
          }
        });
      } else {
        if (ifIsLatest) {
          var list = getListOfModalRoots();

          if (list.length > 1) {
            var last = getListOfModalRoots(-1);

            if (last !== _assertThisInitialized(_this)) {
              return;
            }
          }
        }

        _this.toggleOpenClose(event, false);
      }
    };

    _this._id = props.id || makeUniqueId();
    _this._triggerRef = React.createRef();
    _this._onUnmount = [];
    return _this;
  }

  _createClass(Modal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.openBasedOnStateUpdate();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._onUnmount.forEach(function (fn) {
        if (typeof fn === 'function') {
          fn();
        }
      });

      clearTimeout(this._openTimeout);
      clearTimeout(this._closeTimeout);
      clearTimeout(this._sideEffectsTimeout);
      clearTimeout(this._tryToOpenTimeout);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.openBasedOnStateUpdate();
    }
  }, {
    key: "openBasedOnStateUpdate",
    value: function openBasedOnStateUpdate() {
      var _this$state = this.state,
          hide = _this$state.hide,
          modalActive = _this$state.modalActive;

      if (!this.activeElement && typeof document !== 'undefined') {
        this.activeElement = document.activeElement;
      }

      if (!this.isInTransition && !hide && !modalActive && (this.props.open_state === 'opened' || this.props.open_state === true)) {
        this.toggleOpenClose(null, true);
      } else if (!this.isInTransition && hide && modalActive && (this.props.open_state === 'closed' || this.props.open_state === false)) {
        this.toggleOpenClose(null, false);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = extendPropsWithContext(this.props, Modal.defaultProps, this.context.getTranslation(this.props).Modal, this.context.FormRow, this.context.Modal);

      var root_id = props.root_id,
          content_id = props.content_id,
          id = props.id,
          open_state = props.open_state,
          open_delay = props.open_delay,
          disabled = props.disabled,
          spacing = props.spacing,
          labelled_by = props.labelled_by,
          focus_selector = props.focus_selector,
          trigger = props.trigger,
          trigger_attributes = props.trigger_attributes,
          trigger_hidden = props.trigger_hidden,
          trigger_disabled = props.trigger_disabled,
          trigger_variant = props.trigger_variant,
          trigger_text = props.trigger_text,
          trigger_title = props.trigger_title,
          trigger_size = props.trigger_size,
          trigger_icon = props.trigger_icon,
          trigger_icon_position = props.trigger_icon_position,
          trigger_class = props.trigger_class,
          rest = _objectWithoutProperties(props, ["root_id", "content_id", "id", "open_state", "open_delay", "disabled", "spacing", "labelled_by", "focus_selector", "trigger", "trigger_attributes", "trigger_hidden", "trigger_disabled", "trigger_variant", "trigger_text", "trigger_title", "trigger_size", "trigger_icon", "trigger_icon_position", "trigger_class"]);

      var _this$state2 = this.state,
          hide = _this$state2.hide,
          modalActive = _this$state2.modalActive;
      var modal_content = Modal.getContent(typeof this.props.children === 'function' ? Object.freeze(_extends({}, this.props, {
        close: this.close
      })) : this.props);

      var render = function render(suffixProps) {
        var modalProps = {};
        var triggerAttributes = trigger_attributes ? _extends({}, trigger_attributes) : {};

        for (var prop in props) {
          if (prop.includes('trigger_') && props[prop] !== null) {
            var name = String(prop).replace('trigger_', '');

            if (name !== 'props' && prop !== 'element') {
              triggerAttributes[name] = props[prop];
            }
          }
        }

        var isHelpButton = !isTrue(trigger_hidden) && (!!suffixProps || !(trigger_text && trigger_variant !== 'tertiary') && (!(triggerAttributes.icon || trigger_icon) || ['question', 'information'].includes(triggerAttributes.icon || trigger_icon)));

        if (isTrue(disabled)) {
          triggerAttributes.disabled = true;
        }

        if (triggerAttributes.id) {
          _this2._id = triggerAttributes.id;
        }

        if (!rest.title && triggerAttributes.title) {
          modalProps.title = triggerAttributes.title;
        } else if (!rest.title && isHelpButton && suffixProps) {
            modalProps.title = _this2.context.translation.HelpButton.title;
          }

        if (isHelpButton) {
          triggerAttributes.title = props['aria-label'] || triggerAttributes.title || props.title || modalProps.title;
        } else {
          triggerAttributes['aria-roledescription'] = null;
        }

        var TriggerButton = trigger ? trigger : HelpButtonInstance;
        return React.createElement(React.Fragment, null, TriggerButton && !isTrue(trigger_hidden) && React.createElement(TriggerButton, _extends({
          id: _this2._id,
          onClick: _this2.toggleOpenClose
        }, triggerAttributes, {
          innerRef: _this2._triggerRef,
          className: classnames('dnb-modal__trigger', createSpacingClasses(props), triggerAttributes.class, triggerAttributes.className)
        })), modalActive && modal_content && React.createElement(ModalRoot, _extends({}, rest, {
          id: _this2._id,
          root_id: root_id,
          content_id: content_id || "dnb-modal-".concat(_this2._id),
          labelled_by: labelled_by,
          focus_selector: focus_selector,
          modal_content: modal_content,
          spacing: spacing,
          closeModal: _this2.close,
          hide: hide,
          toggleOpenClose: _this2.toggleOpenClose
        }, modalProps)));
      };

      return React.createElement(SuffixContext.Consumer, null, render);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Modal.tagName, Modal, Modal.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (typeof props.modal_content === 'string') {
        return props.modal_content;
      } else if (typeof props.modal_content === 'function') {
        return props.modal_content(props);
      }

      return processChildren(props);
    }
  }, {
    key: "insertModalRoot",
    value: function insertModalRoot(id) {
      if (typeof window === 'undefined') {
        return false;
      }

      try {
        id = "dnb-modal-".concat(id || 'root');
        window.__modalRoot = document.getElementById(id);

        if (!window.__modalRoot) {
          window.__modalRoot = document.createElement('div');

          window.__modalRoot.setAttribute('id', id);

          document.body.insertBefore(window.__modalRoot, document.body.firstChild);
        }
      } catch (e) {
        warn('Modal: Could not insert dnb-modal-root', e);
      }

      return window.__modalRoot;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.open_state !== state._open_state) {
          switch (props.open_state) {
            case 'opened':
            case true:
              state.hide = false;

              if (isTrue(props.no_animation)) {
                state.modalActive = true;
              }

              break;

            case 'closed':
            case false:
              state.hide = true;

              if (isTrue(props.no_animation)) {
                state.modalActive = false;
              }

              break;
          }
        }
      }

      state._listenForPropChanges = true;
      state._open_state = props.open_state;
      return state;
    }
  }]);

  return Modal;
}(React.PureComponent);

Modal.tagName = 'dnb-modal';
Modal.contextType = Context;
Modal.Inner = ModalInner;
Modal.defaultProps = {
  id: null,
  root_id: 'root',
  mode: 'modal',
  focus_selector: null,
  labelled_by: null,
  title: null,
  disabled: null,
  spacing: true,
  open_delay: null,
  content_id: null,
  close_title: 'Lukk',
  hide_close_button: false,
  prevent_close: false,
  prevent_core_style: false,
  animation_duration: 300,
  no_animation: false,
  no_animation_on_mobile: false,
  fullscreen: 'auto',
  min_width: null,
  max_width: null,
  align_content: null,
  container_placement: null,
  open_state: null,
  direct_dom_return: false,
  class: null,
  className: null,
  children: null,
  on_open: null,
  on_close: null,
  on_close_prevent: null,
  open_modal: null,
  close_modal: null,
  trigger: null,
  trigger_attributes: null,
  trigger_hidden: false,
  trigger_disabled: null,
  trigger_variant: 'secondary',
  trigger_text: null,
  trigger_title: null,
  trigger_size: null,
  trigger_icon: null,
  trigger_icon_position: 'left',
  trigger_class: null,
  overlay_class: null,
  content_class: null,
  modal_content: null
};
export { Modal as default };
process.env.NODE_ENV !== "production" ? Modal.propTypes = _extends({
  id: PropTypes.string,
  root_id: PropTypes.string,
  mode: PropTypes.oneOf(['modal', 'drawer']),
  focus_selector: PropTypes.string,
  labelled_by: PropTypes.string,
  title: PropTypes.node,
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  spacing: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  open_delay: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  content_id: PropTypes.string,
  close_title: PropTypes.string,
  hide_close_button: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_close: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_core_style: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  animation_duration: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  no_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_animation_on_mobile: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  fullscreen: PropTypes.oneOf(['auto', true, false, 'true', 'false']),
  min_width: PropTypes.string,
  max_width: PropTypes.string,
  align_content: PropTypes.oneOf(['left', 'center', 'centered', 'right']),
  container_placement: PropTypes.oneOf(['left', 'right', 'top', 'bottom']),
  open_state: PropTypes.oneOfType([PropTypes.oneOf(['opened', 'closed']), PropTypes.bool]),
  direct_dom_return: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  on_open: PropTypes.func,
  on_close: PropTypes.func,
  on_close_prevent: PropTypes.func,
  open_modal: PropTypes.func,
  close_modal: PropTypes.func,
  trigger: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  trigger_attributes: PropTypes.object,
  trigger_hidden: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  trigger_disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  trigger_variant: buttonVariantPropType.variant,
  trigger_text: PropTypes.string,
  trigger_title: PropTypes.string,
  trigger_size: PropTypes.string,
  trigger_icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  trigger_icon_position: PropTypes.oneOf(['left', 'right']),
  trigger_class: PropTypes.string,
  overlay_class: PropTypes.string,
  content_class: PropTypes.string,
  modal_content: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
}) : void 0;

var ModalRoot = function (_React$PureComponent2) {
  _inherits(ModalRoot, _React$PureComponent2);

  var _super2 = _createSuper(ModalRoot);

  function ModalRoot() {
    var _this3;

    _classCallCheck(this, ModalRoot);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    _this3.state = {
      isMounted: false
    };
    return _this3;
  }

  _createClass(ModalRoot, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!isTrue(this.props.direct_dom_return)) {
        Modal.insertModalRoot(this.props.root_id);

        try {
          if (!this.portalElem) {
            this.portalElem = document.createElement('div');
            this.portalElem.className = 'dnb-modal-root__inner';
          }

          if (this.portalElem && typeof window !== 'undefined' && window.__modalRoot) {
            window.__modalRoot.appendChild(this.portalElem);
          }
        } catch (e) {
          warn(e);
        }

        this.setState({
          isMounted: true
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      try {
        if (this.portalElem && typeof window !== 'undefined' && window.__modalRoot && window.__modalRoot.removeChild) {
          window.__modalRoot.removeChild(this.portalElem);

          this.portalElem = null;
        }
      } catch (e) {
        warn(e);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          direct_dom_return = _this$props.direct_dom_return,
          props = _objectWithoutProperties(_this$props, ["children", "direct_dom_return"]);

      if (isTrue(direct_dom_return)) {
        return React.createElement(ModalContent, props, children);
      }

      if (this.portalElem && typeof window !== 'undefined' && window.__modalRoot && this.state.isMounted) {
        return ReactDOM.createPortal(React.createElement(ModalContent, props, children), this.portalElem);
      }

      return null;
    }
  }]);

  return ModalRoot;
}(React.PureComponent);

ModalRoot.defaultProps = {
  id: null,
  root_id: null,
  direct_dom_return: false,
  children: null
};
process.env.NODE_ENV !== "production" ? ModalRoot.propTypes = {
  id: PropTypes.string,
  root_id: PropTypes.string,
  direct_dom_return: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;
export { CloseButton };