import "core-js/modules/es.array.find.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _extends from "@babel/runtime/helpers/esm/extends";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import PaginationContext from './PaginationContext';
import PaginationProvider from './PaginationProvider';
import { registerElement, validateDOMAttributes, extendPropsWithContext } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { PaginationIndicator } from './PaginationHelpers';
import InfinityScroller from './PaginationInfinity';
import PaginationBar from './PaginationBar';
var paginationPropTypes = process.env.NODE_ENV !== "production" ? _extends({
  startup_page: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  current_page: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  page_count: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  startup_count: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  parallel_load_count: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  place_maker_before_content: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  min_wait_time: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  mode: PropTypes.oneOf(['pagination', 'infinity']),
  use_load_button: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  items: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
  hide_progress_indicator: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  set_content_handler: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  reset_content_handler: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  reset_pagination_handler: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  end_infinity_handler: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  page_element: PropTypes.oneOfType([PropTypes.object, PropTypes.node, PropTypes.func, PropTypes.string]),
  fallback_element: PropTypes.oneOfType([PropTypes.object, PropTypes.node, PropTypes.func, PropTypes.string]),
  marker_element: PropTypes.oneOfType([PropTypes.object, PropTypes.node, PropTypes.func, PropTypes.string]),
  indicator_element: PropTypes.oneOfType([PropTypes.node, PropTypes.func, PropTypes.string]),
  align: PropTypes.string,
  button_title: PropTypes.string,
  prev_title: PropTypes.string,
  next_title: PropTypes.string,
  more_pages: PropTypes.string,
  is_loading_text: PropTypes.string,
  load_button_text: PropTypes.string
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  on_change: PropTypes.func,
  on_startup: PropTypes.func,
  on_load: PropTypes.func,
  on_end: PropTypes.func
}) : {};
var paginationDefaultProps = {
  startup_page: null,
  current_page: null,
  page_count: null,
  mode: 'pagination',
  use_load_button: false,
  items: null,
  hide_progress_indicator: false,
  set_content_handler: null,
  reset_content_handler: null,
  page_element: undefined,
  fallback_element: undefined,
  marker_element: undefined,
  indicator_element: undefined,
  align: 'left',
  button_title: null,
  prev_title: null,
  next_title: null,
  more_pages: null,
  is_loading_text: null,
  load_button_text: null,
  startup_count: 1,
  parallel_load_count: 1,
  place_maker_before_content: false,
  min_wait_time: 400,
  class: null,
  className: null,
  children: null,
  on_change: null,
  on_startup: null,
  on_load: null,
  on_end: null
};

var Pagination = function (_React$PureComponent) {
  _inherits(Pagination, _React$PureComponent);

  var _super = _createSuper(Pagination);

  function Pagination() {
    _classCallCheck(this, Pagination);

    return _super.apply(this, arguments);
  }

  _createClass(Pagination, [{
    key: "render",
    value: function render() {
      return React.createElement(PaginationProvider, _extends({
        tagName: Pagination.tagName
      }, this.props), React.createElement(PaginationInstance, this.props));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Pagination.tagName, Pagination, paginationDefaultProps);
    }
  }]);

  return Pagination;
}(React.PureComponent);

Pagination.tagName = 'dnb-pagination';
Pagination.defaultProps = paginationDefaultProps;
export { Pagination as default };
process.env.NODE_ENV !== "production" ? Pagination.propTypes = _extends({}, paginationPropTypes) : void 0;

var _ref2 = React.createElement(InfinityScroller, null);

var PaginationInstance = function (_React$PureComponent2) {
  _inherits(PaginationInstance, _React$PureComponent2);

  var _super2 = _createSuper(PaginationInstance);

  function PaginationInstance(props) {
    var _this;

    _classCallCheck(this, PaginationInstance);

    _this = _super2.call(this, props);
    _this._contentRef = React.createRef();
    return _this;
  }

  _createClass(PaginationInstance, [{
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, paginationDefaultProps, this.context.getTranslation(this.props).Pagination, this.context.FormRow, this.context.Pagination);

      var align = props.align,
          children = props.children,
          className = props.className,
          _className = props.class,
          _tagName = props.tagName,
          _page_count = props.page_count,
          _current_page = props.current_page,
          _startup_page = props.startup_page,
          _mode = props.mode,
          _hide_progress_indicator = props.hide_progress_indicator,
          _use_load_button = props.use_load_button,
          attributes = _objectWithoutProperties(props, ["align", "children", "className", "class", "tagName", "page_count", "current_page", "startup_page", "mode", "hide_progress_indicator", "use_load_button"]);

      var _this$context$paginat = this.context.pagination,
          currentPage = _this$context$paginat.currentPage,
          items = _this$context$paginat.items,
          fallback_element = _this$context$paginat.fallback_element,
          indicator_element = _this$context$paginat.indicator_element;

      if (this.context.pagination.mode === 'pagination') {
        var _items$find;

        var mainParams = _extends({
          className: classnames('dnb-pagination', createSpacingClasses(props), className, _className, align && "dnb-pagination--".concat(align))
        }, attributes);

        validateDOMAttributes(props, mainParams);
        var content = (_items$find = items.find(function (_ref) {
          var pageNo = _ref.pageNo;
          return pageNo === currentPage;
        })) === null || _items$find === void 0 ? void 0 : _items$find.content;
        return React.createElement(React.Fragment, null, this.context.pagination.mode === 'infinity' && typeof children !== 'function' && children, React.createElement("div", mainParams, React.createElement(PaginationBar, {
          contentRef: this._contentRef
        }, children), items.length > 0 && React.createElement(PaginationContent, {
          ref: this._contentRef
        }, content || React.createElement(PaginationIndicator, {
          indicator_element: indicator_element || fallback_element
        }))));
      }

      return _ref2;
    }
  }]);

  return PaginationInstance;
}(React.PureComponent);

PaginationInstance.defaultProps = paginationDefaultProps;
PaginationInstance.contextType = PaginationContext;
process.env.NODE_ENV !== "production" ? PaginationInstance.propTypes = _extends({}, paginationPropTypes) : void 0;
export var InfinityMarker = function (_React$PureComponent3) {
  _inherits(InfinityMarker, _React$PureComponent3);

  var _super3 = _createSuper(InfinityMarker);

  function InfinityMarker() {
    _classCallCheck(this, InfinityMarker);

    return _super3.apply(this, arguments);
  }

  _createClass(InfinityMarker, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          props = _objectWithoutProperties(_this$props, ["children"]);

      return React.createElement(PaginationProvider, _extends({
        useMarkerOnly: true,
        tagName: InfinityMarker.tagName
      }, props), React.createElement(InfinityScroller, props, children));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(InfinityMarker.tagName, InfinityMarker, paginationDefaultProps);
    }
  }]);

  return InfinityMarker;
}(React.PureComponent);
InfinityMarker.tagName = 'dnb-infinity-marker';
InfinityMarker.defaultProps = paginationDefaultProps;
process.env.NODE_ENV !== "production" ? InfinityMarker.propTypes = _extends({}, paginationPropTypes) : void 0;
var PaginationContent = React.forwardRef(function (_ref3, ref) {
  var children = _ref3.children,
      props = _objectWithoutProperties(_ref3, ["children"]);

  return React.createElement("div", _extends({
    className: "dnb-pagination__content dnb-no-focus",
    tabIndex: "-1"
  }, props, {
    ref: ref
  }), children);
});
process.env.NODE_ENV !== "production" ? PaginationContent.propTypes = {
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired
} : void 0;
Pagination.Bar = PaginationBar;
Pagination.Content = PaginationContent;
var PaginationWrapper = Pagination;
var InfinityMarkerWrapper = InfinityMarker;
export var createPagination = function createPagination() {
  var initProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var store = React.createRef({});
  var rerender = React.createRef(null);

  var _setContent = React.createRef(null);

  var _resetContent = React.createRef(null);

  var _resetInfinity = React.createRef(null);

  var _endInfinity = React.createRef(null);

  var setContent = function setContent(pageNo, content) {
    if (pageNo > 0) {
      store.current = _extends({}, store.current, {
        pageNo: pageNo,
        content: content
      });
      rerender.current && rerender.current(store);
    }
  };

  var resetContent = function resetContent() {
    _resetContent.current && _resetContent.current();
  };

  var resetInfinity = function resetInfinity() {
    _resetInfinity.current && _resetInfinity.current();
  };

  var endInfinity = function endInfinity() {
    _endInfinity.current && _endInfinity.current();
  };

  var args = function args(props) {
    return _extends({}, _extends({}, initProps, props), {
      store: store,
      rerender: rerender,
      set_content_handler: function set_content_handler(fn) {
        return _setContent.current = fn;
      },
      reset_content_handler: function reset_content_handler(fn) {
        return _resetContent.current = fn;
      },
      reset_pagination_handler: function reset_pagination_handler(fn) {
        return _resetInfinity.current = fn;
      },
      end_infinity_handler: function end_infinity_handler(fn) {
        return _endInfinity.current = fn;
      }
    });
  };

  var Pagination = function Pagination(props) {
    return React.createElement(PaginationWrapper, _extends({
      tagName: PaginationWrapper.tagName
    }, args(props)));
  };

  var InfinityMarker = function InfinityMarker(props) {
    return React.createElement(InfinityMarkerWrapper, _extends({
      tagName: InfinityMarkerWrapper.tagName
    }, args(props)));
  };

  return {
    Pagination: Pagination,
    InfinityMarker: InfinityMarker,
    setContent: setContent,
    resetContent: resetContent,
    resetInfinity: resetInfinity,
    endInfinity: endInfinity
  };
};