import _extends from "@babel/runtime/helpers/esm/extends";
import _typeof from "@babel/runtime/helpers/esm/typeof";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import ProgressIndicator from '../progress-indicator/ProgressIndicator';

var _ref = React.createElement(ProgressIndicator, null);

export var PaginationIndicator = function (_React$PureComponent) {
  _inherits(PaginationIndicator, _React$PureComponent);

  var _super = _createSuper(PaginationIndicator);

  function PaginationIndicator() {
    _classCallCheck(this, PaginationIndicator);

    return _super.apply(this, arguments);
  }

  _createClass(PaginationIndicator, [{
    key: "render",
    value: function render() {
      var indicator_element = this.props.indicator_element;
      var Element = preparePageElement(indicator_element);
      var ElementChild = isTrElement(Element) ? 'td' : 'div';
      return React.createElement(Element, null, React.createElement(ElementChild, {
        className: "dnb-pagination__indicator"
      }, React.createElement("div", {
        className: "dnb-pagination__indicator__inner"
      }, _ref, this.context.getTranslation(this.props).Pagination.is_loading_text)));
    }
  }]);

  return PaginationIndicator;
}(React.PureComponent);
PaginationIndicator.contextType = Context;
PaginationIndicator.defaultProps = {
  indicator_element: 'div'
};
process.env.NODE_ENV !== "production" ? PaginationIndicator.propTypes = {
  indicator_element: PropTypes.oneOfType([PropTypes.object, PropTypes.node, PropTypes.func, PropTypes.string])
} : void 0;
export var ContentObject = function () {
  function ContentObject(_ref2) {
    var pageNo = _ref2.pageNo,
        props = _objectWithoutProperties(_ref2, ["pageNo"]);

    _classCallCheck(this, ContentObject);

    this.content = null;
    this.pageNo = pageNo;
    this.hasContent = false;

    for (var k in props) {
      this[k] = props[k];
    }
  }

  _createClass(ContentObject, [{
    key: "insert",
    value: function insert(content) {
      this.hasContent = true;
      this.content = content;

      if (typeof this.onInsert === 'function') {
        this.onInsert(this);
      }

      return this;
    }
  }, {
    key: "update",
    value: function update(content) {
      this.hasContent = true;
      this.content = content;

      if (typeof this.onUpdate === 'function') {
        this.onUpdate(this);
      }

      return this;
    }
  }]);

  return ContentObject;
}();
export function isTrElement(Element) {
  var isTr = false;

  if (Element === 'tr') {
    isTr = true;
  } else if (Element && (_typeof(Element) === 'object' || React.isValidElement(Element))) {
    if ((Element.__emotion_base || Element.target) === 'tr') {
      isTr = true;
    }
  }

  return isTr;
}
export function preparePageElement(Element) {
  var includeClassName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'dnb-pagination__page';

  if (String(Element) === 'Symbol(react.fragment)') {
    return Element;
  }

  if (includeClassName) {
    var isTr = isTrElement(Element);
    return React.forwardRef(function (_ref3, ref) {
      var className = _ref3.className,
          children = _ref3.children,
          props = _objectWithoutProperties(_ref3, ["className", "children"]);

      var params = _extends({}, props, {
        className: classnames(includeClassName, className),
        ref: ref
      });

      return isTr ? React.createElement("td", null, React.createElement("div", params, children)) : React.createElement(Element, params, children);
    });
  }

  return Element;
}