import "core-js/modules/es.array.concat.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import { isTrue, registerElement, validateDOMAttributes, dispatchCustomElementEvent, extendPropsWithContext } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import ProgressIndicatorCircular from './ProgressIndicatorCircular';

var ProgressIndicator = function (_React$PureComponent) {
  _inherits(ProgressIndicator, _React$PureComponent);

  var _super = _createSuper(ProgressIndicator);

  function ProgressIndicator() {
    var _this;

    _classCallCheck(this, ProgressIndicator);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      _listenForPropChanges: true
    };

    _this.callOnCompleteHandler = function () {
      _this.completeTimeout = setTimeout(function () {
        _this.setState({
          complete: true
        });

        if (typeof _this.props.on_complete === 'function') {
          _this.fadeOutTimeout = setTimeout(function () {
            dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_complete');
          }, 600);
        }
      }, 200);
    };

    return _this;
  }

  _createClass(ProgressIndicator, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.completeTimeout);
      clearTimeout(this.fadeOutTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, ProgressIndicator.defaultProps, this.context.getTranslation(this.props).ProgressIndicator, this.context.FormRow, this.context.ProgressIndicator);

      var type = props.type,
          size = props.size,
          no_animation = props.no_animation,
          on_complete = props.on_complete,
          label = props.label,
          indicator_label = props.indicator_label,
          label_direction = props.label_direction,
          show_label = props.show_label,
          className = props.className,
          _className = props.class,
          children = props.children,
          _progress = props.progress,
          _visible = props.visible,
          _complete = props.complete,
          attributes = _objectWithoutProperties(props, ["type", "size", "no_animation", "on_complete", "label", "indicator_label", "label_direction", "show_label", "className", "class", "children", "progress", "visible", "complete"]);

      var _this$state = this.state,
          progress = _this$state.progress,
          visible = _this$state.visible,
          complete = _this$state.complete;

      var params = _extends({}, attributes);

      var hasProgressIndicator = parseFloat(progress) > -1;

      if (visible && !hasProgressIndicator) {
        params.role = 'alert';
        params['aria-busy'] = true;
      }

      var indicatorLabel = label || children || isTrue(show_label) && indicator_label;
      validateDOMAttributes(this.props, params);
      return React.createElement("div", _extends({
        className: classnames('dnb-progress-indicator', createSpacingClasses(props), className, _className, visible && 'dnb-progress-indicator--visible', complete && 'dnb-progress-indicator--complete', label_direction && "dnb-progress-indicator--".concat(label_direction), isTrue(no_animation) && 'dnb-progress-indicator--no-animation')
      }, params), type === 'circular' && React.createElement(ProgressIndicatorCircular, {
        size: size,
        progress: progress,
        visible: visible,
        complete: complete,
        onComplete: on_complete,
        callOnCompleteHandler: this.callOnCompleteHandler
      }), indicatorLabel && React.createElement("div", {
        className: "dnb-progress-indicator__label"
      }, React.createElement("p", {
        className: "dnb-p"
      }, indicatorLabel)));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(ProgressIndicator.tagName, ProgressIndicator, ProgressIndicator.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        state.visible = isTrue(props.visible);

        if (state.visible) {
          state.complete = false;
        }

        if (parseFloat(props.progress) > -1) {
          state.progress = props.progress;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return ProgressIndicator;
}(React.PureComponent);

ProgressIndicator.tagName = 'dnb-progress-indicator';
ProgressIndicator.contextType = Context;
ProgressIndicator.defaultProps = {
  visible: true,
  type: 'circular',
  no_animation: false,
  size: 'default',
  progress: null,
  label: null,
  label_direction: 'horizontal',
  show_label: false,
  indicator_label: null,
  section_style: null,
  section_spacing: null,
  class: null,
  className: null,
  children: null,
  on_complete: null
};
export { ProgressIndicator as default };
process.env.NODE_ENV !== "production" ? ProgressIndicator.propTypes = _extends({
  visible: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  type: PropTypes.oneOf(['circular']),
  no_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  size: PropTypes.oneOf(['default', 'small', 'medium', 'large', 'huge']),
  progress: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  label: PropTypes.node,
  label_direction: PropTypes.string,
  show_label: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  indicator_label: PropTypes.string,
  section_style: PropTypes.string,
  section_spacing: PropTypes.string
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  on_complete: PropTypes.func
}) : void 0;