import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { validateDOMAttributes } from '../../shared/component-helper';
import { IS_IE11, IS_EDGE } from '../../shared/helpers';

var ProgressIndicatorCircular = function (_React$PureComponent) {
  _inherits(ProgressIndicatorCircular, _React$PureComponent);

  var _super = _createSuper(ProgressIndicatorCircular);

  function ProgressIndicatorCircular(props) {
    var _this;

    _classCallCheck(this, ProgressIndicatorCircular);

    _this = _super.call(this, props);
    _this.useAnimationFrame = typeof props.onComplete === 'function' || IS_IE11 || IS_EDGE;
    _this._refDark = React.createRef();
    _this._refLight = React.createRef();
    _this.state = {
      animate: false
    };
    return _this;
  }

  _createClass(ProgressIndicatorCircular, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.useAnimationFrame) {
        this.startAnimationFirstTime();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.stopAnimation();
    }
  }, {
    key: "stopAnimation",
    value: function stopAnimation() {
      this.setState({
        animate: false
      });

      if (this.startupTimeout) {
        clearTimeout(this.startupTimeout);
      }
    }
  }, {
    key: "startAnimationFirstTime",
    value: function startAnimationFirstTime() {
      var _this2 = this;

      this.setState({
        animate: false
      });
      this.startupTimeout = setTimeout(function () {
        return _this2.startAnimation();
      }, 300);
    }
  }, {
    key: "startAnimation",
    value: function startAnimation() {
      var _this3 = this;

      this.setState({
        animate: true
      }, function () {
        if (_this3._refDark.current) {
          _this3.animate(_this3._refDark.current, true, _this3.props.callOnCompleteHandler);
        }

        if (_this3._refLight.current) {
          _this3.animate(_this3._refLight.current, false);
        }
      });
    }
  }, {
    key: "animate",
    value: function animate(element) {
      var _this4 = this;

      var animateOnStart = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var min = 1;
      var max = 88;
      var start = 0,
          ms = 0,
          prog = max,
          setProg = animateOnStart,
          animate = true,
          completeCalled = false,
          stopNextRound = false;

      var step = function step(timestamp) {
        if (!start) {
          start = timestamp;
        }

        ms = timestamp - start;

        if (animate) {
          if (!_this4.state.visible && prog < 5) {
            prog = min;
          }

          if (setProg) {
            element.style['stroke-dashoffset'] = prog;
          } else if (!animateOnStart) {
            element.style['stroke-dashoffset'] = max;
          }
        }

        if (stopNextRound) {
          animate = false;

          if (!completeCalled) {
            completeCalled = true;

            if (animateOnStart && typeof callback === 'function') {
              callback();
            }
          } else if (_this4.state.visible && ms % 1e3 > 950) {
            stopNextRound = false;
          }
        } else {
          stopNextRound = !_this4.state.visible && prog === min;
          animate = true;
          completeCalled = false;
        }

        prog = Math.round(max - max / 1e3 * (ms % 1e3));
        setProg = animateOnStart ? Math.ceil(ms / 1e3) % 2 === 1 || ms === 0 : Math.ceil(ms / 1e3) % 2 === 0 && ms !== 0;

        if (_this4.state.animate) {
          window.requestAnimationFrame(step);
        }
      };

      if (typeof window !== 'undefined' && window.requestAnimationFrame) {
        window.requestAnimationFrame(step);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          size = _this$props.size,
          maxOffset = _this$props.maxOffset,
          _progress = _this$props.progress,
          visible = _this$props.visible,
          complete = _this$props.complete,
          onComplete = _this$props.onComplete,
          callOnCompleteHandler = _this$props.callOnCompleteHandler,
          rest = _objectWithoutProperties(_this$props, ["size", "maxOffset", "progress", "visible", "complete", "onComplete", "callOnCompleteHandler"]);

      var progress = this.state.progress;
      var strokeDashoffset = maxOffset - maxOffset / 100 * progress;
      var hasProgressIndicator = parseFloat(progress) > -1;

      var params = _extends({}, rest);

      if (hasProgressIndicator) {
        params['title'] = "".concat(progress, "%");
        params['aria-label'] = "".concat(progress, "%");
      } else {
        params['aria-hidden'] = true;
      }

      validateDOMAttributes(this.props, params);
      return React.createElement("div", _extends({
        className: classnames('dnb-progress-indicator__circular', size && "dnb-progress-indicator__circular--".concat(size), hasProgressIndicator && 'dnb-progress-indicator__circular--has-progress-indicator')
      }, params), _ref, React.createElement(Circle, {
        className: "dnb-progress-indicator__circular__line dark dark" + (hasProgressIndicator || this.useAnimationFrame ? " paused" : ""),
        style: hasProgressIndicator ? {
          strokeDashoffset: strokeDashoffset
        } : {},
        ref: this._refDark
      }), !hasProgressIndicator && React.createElement(Circle, {
        className: "dnb-progress-indicator__circular__line light" + (this.useAnimationFrame ? " paused" : ""),
        ref: this._refLight
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      state.progress = parseFloat(props.progress);
      state.visible = props.visible;
      state.complete = props.complete;
      return state;
    }
  }]);

  return ProgressIndicatorCircular;
}(React.PureComponent);

ProgressIndicatorCircular.defaultProps = {
  size: null,
  visible: true,
  complete: false,
  progress: null,
  maxOffset: 88,
  onComplete: null,
  callOnCompleteHandler: null
};
export { ProgressIndicatorCircular as default };
process.env.NODE_ENV !== "production" ? ProgressIndicatorCircular.propTypes = {
  size: PropTypes.string,
  visible: PropTypes.bool,
  complete: PropTypes.bool,
  progress: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  maxOffset: PropTypes.number,
  onComplete: PropTypes.func,
  callOnCompleteHandler: PropTypes.func
} : void 0;

var _ref3 = React.createElement("circle", {
  className: "dnb-progress-indicator__circular__circle",
  fill: "none",
  strokeWidth: "4",
  cx: "16",
  cy: "16",
  r: "14"
});

var Circle = React.forwardRef(function (_ref2, ref) {
  var className = _ref2.className,
      rest = _objectWithoutProperties(_ref2, ["className"]);

  return React.createElement("svg", _extends({
    className: className,
    viewBox: "0 0 32 32",
    shapeRendering: "geometricPrecision",
    ref: ref
  }, rest), _ref3);
}),
    _ref = React.createElement(Circle, {
  className: "dnb-progress-indicator__circular__line light paused"
});

process.env.NODE_ENV !== "production" ? Circle.propTypes = {
  className: PropTypes.string.isRequired
} : void 0;