import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import { isTrue, registerElement, validateDOMAttributes, processChildren, extendPropsWithContext } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';

var Section = function (_React$PureComponent) {
  _inherits(Section, _React$PureComponent);

  var _super = _createSuper(Section);

  function Section(props) {
    var _this;

    _classCallCheck(this, Section);

    _this = _super.call(this, props);
    _this._ref = React.createRef();
    return _this;
  }

  _createClass(Section, [{
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, Section.defaultProps, this.context.FormRow, this.context.Section);

      var element = props.element,
          style_type = props.style_type,
          spacing = props.spacing,
          className = props.className,
          _className = props.class,
          attributes = _objectWithoutProperties(props, ["element", "style_type", "spacing", "className", "class"]);

      var content = Section.getContent(this.props);

      var params = _extends({
        className: classnames("dnb-section dnb-section--".concat(style_type || 'mint-green-12'), (isTrue(spacing) || spacing) && "dnb-section--spacing".concat(!/true|false/.test(String(spacing)) ? '-' + spacing : ''), createSpacingClasses(props), className, _className)
      }, attributes);

      validateDOMAttributes(this.props, params);
      var Element = element || 'section';
      return React.createElement(Element, _extends({}, params, {
        ref: this._ref
      }), content);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Section.tagName, Section, Section.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.text) return props.text;
      return processChildren(props);
    }
  }]);

  return Section;
}(React.PureComponent);

Section.tagName = 'dnb-section';
Section.contextType = Context;
Section.defaultProps = {
  style_type: null,
  spacing: null,
  element: 'section',
  class: null,
  className: null,
  children: null
};
export { Section as default };
process.env.NODE_ENV !== "production" ? Section.propTypes = _extends({
  style_type: PropTypes.string,
  spacing: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  element: PropTypes.string
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node])
}) : void 0;