import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.fill.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.reverse.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import Context from '../../../shared/Context';

var SkeletonArticle = function (_React$PureComponent) {
  _inherits(SkeletonArticle, _React$PureComponent);

  var _super = _createSuper(SkeletonArticle);

  function SkeletonArticle(props) {
    var _this;

    _classCallCheck(this, SkeletonArticle);

    _this = _super.call(this, props);
    var rows = props.rows;
    var fill = [70, 80, 60, 40, 50, 20, 0];
    _this.rowsLength = new Array(rows).fill(true).map(function (_, i) {
      var c = i % fill.length;

      if (c === fill.length - 1) {
        fill.concat(fill.reverse());
      }

      return fill[c];
    });
    return _this;
  }

  _createClass(SkeletonArticle, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          rows = _this$props.rows,
          children = _this$props.children,
          rest = _objectWithoutProperties(_this$props, ["rows", "children"]);

      return React.createElement("div", _extends({
        className: "dnb-skeleton__figure dnb-skeleton__figure--show",
        "aria-busy": true
      }, rest), React.createElement("div", {
        className: "dnb-h--xx-large dnb-skeleton dnb-skeleton--shape dnb-space__bottom--large",
        style: {
          width: '50%'
        }
      }, "\u200C"), this.rowsLength.map(function (p, i) {
        return React.createElement("div", {
          key: i,
          className: "dnb-p dnb-skeleton dnb-skeleton--shape dnb-space__top--x-small",
          style: {
            width: "".concat(p, "%")
          }
        }, "\u200C");
      }), children);
    }
  }]);

  return SkeletonArticle;
}(React.PureComponent);

SkeletonArticle.contextType = Context;
SkeletonArticle.defaultProps = {
  rows: 3,
  children: null
};
export { SkeletonArticle as default };
process.env.NODE_ENV !== "production" ? SkeletonArticle.propTypes = {
  rows: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node])
} : void 0;