import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.includes.js";
import "core-js/modules/es.string.replace.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { isTrue, dispatchCustomElementEvent } from '../../shared/component-helper';
import { IS_MAC } from '../../shared/helpers';

var StepItem = function (_React$PureComponent) {
  _inherits(StepItem, _React$PureComponent);

  var _super = _createSuper(StepItem);

  function StepItem(props) {
    var _this;

    _classCallCheck(this, StepItem);

    _this = _super.call(this, props);

    _this.onClickHandler = function (_ref) {
      var event = _ref.event,
          item = _ref.item,
          currentItem = _ref.currentItem;
      var _this$props = _this.props,
          use_navigation = _this$props.use_navigation,
          on_click = _this$props.on_click,
          setActimeItem = _this$props.setActimeItem;
      var params = {
        event: event,
        item: item,
        currentItem: currentItem
      };

      if (isTrue(use_navigation) && typeof setActimeItem === 'function') {
        setActimeItem(currentItem);
      }

      var res = dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_click', params);

      if (typeof on_click === 'function' && res === false) {
        return;
      }

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', params);

      if (_this._ref.current) {
        _this._ref.current.blur();
      }
    };

    _this._ref = React.createRef();
    return _this;
  }

  _createClass(StepItem, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          activeItem = _this$props2.activeItem,
          currentItem = _this$props2.currentItem,
          countSteps = _this$props2.countSteps,
          is_active = _this$props2.is_active,
          is_current = _this$props2.is_current,
          _url = _this$props2.url,
          url_future = _this$props2.url_future,
          url_passed = _this$props2.url_passed,
          hide_numbers = _this$props2.hide_numbers,
          title = _this$props2.title,
          step_title = _this$props2.step_title,
          use_navigation = _this$props2.use_navigation,
          on_item_render = _this$props2.on_item_render,
          on_render = _this$props2.on_render,
          on_click = _this$props2.on_click,
          on_change = _this$props2.on_change,
          setActimeItem = _this$props2.setActimeItem,
          hasReached = _this$props2.hasReached,
          rest = _objectWithoutProperties(_this$props2, ["activeItem", "currentItem", "countSteps", "is_active", "is_current", "url", "url_future", "url_passed", "hide_numbers", "title", "step_title", "use_navigation", "on_item_render", "on_render", "on_click", "on_change", "setActimeItem", "hasReached"]);

      var hasPassedAndIsCurrent = isTrue(is_active);
      var url = _url;

      if (_url) {
        if (currentItem > activeItem) {
          url = url_future;
          hasPassedAndIsCurrent = true;
        }

        if (url_passed && currentItem < activeItem) {
          url = url_passed;
          hasPassedAndIsCurrent = true;
        }
      }

      if (currentItem <= activeItem) {
        hasPassedAndIsCurrent = true;
      }

      if (hasReached.includes(currentItem)) {
        hasPassedAndIsCurrent = true;
      }

      var interactiveParams = _extends({}, rest);

      if (!hasPassedAndIsCurrent && currentItem > activeItem && !isTrue(is_active)) {
        interactiveParams['disabled'] = true;
        interactiveParams['aria-disabled'] = true;
      }

      interactiveParams.className = "dnb-anchor dnb-step-indicator__item-content dnb-step-indicator__item-content--link" + (interactiveParams['disabled'] ? " dnb-anchor--no-style" : "");
      var aria = step_title.replace('%step', currentItem + 1).replace('%count', countSteps);

      var StepItemWrapper = function StepItemWrapper(props) {
        return React.createElement(React.Fragment, null, !isTrue(hide_numbers) && React.createElement("span", _extends({
          className: "dnb-step-indicator__item-content--number",
          "aria-label": aria
        }, props), "".concat(currentItem + 1, ". ")), React.createElement("span", _extends({
          className: "dnb-step-indicator__item-content--text"
        }, props), title));
      };

      var itemComponent = React.createElement(StepItemWrapper, null);
      var props = {
        StepItem: StepItemWrapper,
        itemComponent: itemComponent,
        params: rest,
        props: this.props
      };

      if (typeof on_render === 'function') {
        itemComponent = on_render(props);
      } else if (typeof on_item_render === 'function') {
        itemComponent = on_item_render(props);
      }

      var child = null;

      if (isTrue(use_navigation)) {
        child = React.createElement("button", _extends({
          type: "button",
          onClick: function onClick(event) {
            return _this2.onClickHandler({
              event: event,
              item: _this2.props,
              currentItem: currentItem
            });
          }
        }, interactiveParams, {
          ref: this._ref
        }), itemComponent);
      } else if (url) {
        child = React.createElement("a", _extends({
          href: url,
          onClick: function onClick(event) {
            return _this2.onClickHandler({
              event: event,
              item: _this2.props,
              currentItem: currentItem
            });
          }
        }, interactiveParams), itemComponent);
      } else {
        var contentParams = {};

        if (IS_MAC) {
          contentParams.role = 'text';
        }

        child = React.createElement("span", _extends({
          className: "dnb-step-indicator__item-content dnb-step-indicator__item-content--static"
        }, contentParams), itemComponent);
      }

      var itemParams = {};

      if (currentItem === activeItem || isTrue(is_current)) {
        itemParams['aria-current'] = 'step';
      }

      return React.createElement("li", _extends({
        className: classnames('dnb-step-indicator__item', (currentItem === activeItem || isTrue(is_current)) && 'dnb-step-indicator--active', currentItem < activeItem && 'dnb-step-indicator--visited')
      }, itemParams), child);
    }
  }]);

  return StepItem;
}(React.PureComponent);

StepItem.defaultProps = {
  step_title: '%step',
  on_item_render: null,
  on_render: null,
  on_click: null,
  on_change: null,
  setActimeItem: null,
  hasReached: [],
  countSteps: null,
  hide_numbers: false,
  use_navigation: false,
  is_active: null,
  is_current: null,
  url: null,
  url_future: null,
  url_passed: null,
  activeItem: null
};
export { StepItem as default };
process.env.NODE_ENV !== "production" ? StepItem.propTypes = {
  title: PropTypes.string.isRequired,
  step_title: PropTypes.string,
  activeItem: PropTypes.number,
  currentItem: PropTypes.number.isRequired,
  hide_numbers: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  use_navigation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  on_item_render: PropTypes.func,
  on_render: PropTypes.func,
  on_click: PropTypes.func,
  on_change: PropTypes.func,
  setActimeItem: PropTypes.func,
  hasReached: PropTypes.array,
  countSteps: PropTypes.number,
  is_active: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  is_current: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  url: PropTypes.string,
  url_future: PropTypes.string,
  url_passed: PropTypes.string
} : void 0;