import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import { isTrue, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, getStatusState, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import AlignmentHelper from '../../shared/AlignmentHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';
import Context from '../../shared/Context';
import Suffix from '../../shared/helpers/Suffix';
import FormLabel from '../form-label/FormLabel';
import FormStatus from '../form-status/FormStatus';

var _ref = React.createElement(AlignmentHelper, null);

var _ref2 = React.createElement("span", {
  className: "dnb-switch__focus"
}, React.createElement("span", {
  className: "dnb-switch__focus__inner"
}));

var Switch = function (_React$PureComponent) {
  _inherits(Switch, _React$PureComponent);

  var _super = _createSuper(Switch);

  function Switch(props) {
    var _this;

    _classCallCheck(this, Switch);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      switch (keycode(event)) {
        case 'enter':
          _this.onChangeHandler(event);

          break;
      }
    };

    _this.onChangeHandler = function (event) {
      if (isTrue(_this.props.readOnly)) {
        return event.preventDefault();
      }

      var checked = !_this.state.checked;

      _this.setState({
        checked: checked,
        _listenForPropChanges: false
      });

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        checked: checked,
        event: event
      });

      if (_this.props.on_change_end) {
        clearTimeout(_this._onChangeEndId);

        if (event && event.persist) {
          event.persist();
        }

        _this._onChangeEndId = setTimeout(function () {
          return dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change_end', {
            checked: checked,
            event: event
          });
        }, 500);
      }

      if (_this._refInput.current) {
        _this._refInput.current.focus();
      }
    };

    _this._refInput = React.createRef();
    _this._id = props.id || makeUniqueId();
    _this.state = {
      _listenForPropChanges: true
    };
    _this.helperParams = {
      onMouseDown: function onMouseDown(e) {
        return e.preventDefault();
      }
    };
    return _this;
  }

  _createClass(Switch, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._onChangeEndId);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = extendPropsWithContext(this.props, Switch.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Switch, this.context.FormRow, this.context.Switch);

      var value = props.value,
          size = props.size,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          label = props.label,
          label_position = props.label_position,
          label_sr_only = props.label_sr_only,
          title = props.title,
          disabled = props.disabled,
          readOnly = props.readOnly,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _id = props.id,
          _checked = props.checked,
          attributes = props.attributes,
          children = props.children,
          on_change = props.on_change,
          on_state_update = props.on_state_update,
          custom_method = props.custom_method,
          custom_element = props.custom_element,
          rest = _objectWithoutProperties(props, ["value", "size", "status", "status_state", "status_animation", "global_status_id", "suffix", "label", "label_position", "label_sr_only", "title", "disabled", "readOnly", "skeleton", "className", "class", "id", "checked", "attributes", "children", "on_change", "on_state_update", "custom_method", "custom_element"]);

      var checked = this.state.checked;
      var id = this._id;
      var showStatus = getStatusState(status);
      var mainParams = {
        className: classnames("dnb-switch dnb-switch--label-position-".concat(label_position || 'right', " dnb-form-component"), createSkeletonClass(null, skeleton), createSpacingClasses(props), className, _className, size && "dnb-switch--".concat(size), status && "dnb-switch__status--".concat(status_state))
      };

      var inputParams = _extends({
        disabled: isTrue(disabled),
        checked: checked
      }, rest);

      skeletonDOMAttributes(inputParams, skeleton, this.context);

      if (showStatus || suffix) {
        inputParams['aria-describedby'] = combineDescribedBy(inputParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (readOnly) {
        inputParams['aria-readonly'] = inputParams.readOnly = true;
      }

      validateDOMAttributes(this.props, inputParams);
      var labelComp = label && React.createElement(FormLabel, {
        id: id + '-label',
        for_id: id,
        text: label,
        disabled: disabled,
        skeleton: skeleton,
        sr_only: label_sr_only
      });
      return React.createElement("span", mainParams, React.createElement("span", {
        className: "dnb-switch__order"
      }, label_position === 'left' && labelComp, React.createElement("span", {
        className: "dnb-switch__inner"
      }, _ref, showStatus && React.createElement(FormStatus, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        width_selector: id + ', ' + id + '-label',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), React.createElement("span", {
        className: "dnb-switch__shell"
      }, (label_position === 'right' || !label_position) && labelComp, React.createElement("span", {
        className: "dnb-switch__row"
      }, React.createElement("input", _extends({
        id: id,
        name: id,
        type: "checkbox",
        role: "switch",
        title: title,
        "aria-checked": checked,
        className: "dnb-switch__input",
        value: checked ? value || '' : '',
        ref: this._refInput
      }, inputParams, {
        onChange: this.onChangeHandler,
        onKeyDown: this.onKeyDownHandler
      })), React.createElement("span", _extends({
        draggable: true,
        "aria-hidden": true,
        className: "dnb-switch__background",
        onDragStart: this.onChangeHandler
      }, this.helperParams)), React.createElement("span", {
        className: classnames('dnb-switch__button', createSkeletonClass('shape', skeleton, this.context)),
        "aria-hidden": true
      }, _ref2)), suffix && React.createElement(Suffix, {
        className: "dnb-switch__suffix",
        id: id + '-suffix',
        context: props
      }, suffix)))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Switch.tagName, Switch, Switch.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.checked !== state._checked) {
          if (props.default_state !== null && typeof state.checked === 'undefined') {
            state.checked = Switch.parseChecked(props.default_state);
          } else {
            state.checked = Switch.parseChecked(props.checked);
          }
        }
      }

      state._listenForPropChanges = true;

      if (state.checked !== state.__checked) {
        dispatchCustomElementEvent({
          props: props
        }, 'on_state_update', {
          checked: state.checked
        });
      }

      state._checked = props.checked;
      state.__checked = state.checked;
      return state;
    }
  }]);

  return Switch;
}(React.PureComponent);

Switch.tagName = 'dnb-switch';
Switch.contextType = Context;
Switch.defaultProps = {
  label: null,
  label_position: null,
  title: null,
  default_state: null,
  checked: null,
  disabled: null,
  id: null,
  size: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  value: null,
  attributes: null,
  readOnly: false,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_change_end: null,
  on_state_update: null
};

Switch.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

export { Switch as default };
process.env.NODE_ENV !== "production" ? Switch.propTypes = _extends({
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_position: PropTypes.oneOf(['left', 'right']),
  title: PropTypes.string,
  default_state: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  checked: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  id: PropTypes.string,
  size: PropTypes.oneOf(['default', 'medium', 'large']),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  value: PropTypes.string,
  attributes: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  readOnly: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_change: PropTypes.func,
  on_change_end: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;