import "core-js/modules/es.array.concat.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { validateDOMAttributes } from '../../shared/component-helper';
import { createSpacingClasses } from '../space/SpacingHelper';

var ContentWrapper = function (_React$PureComponent) {
  _inherits(ContentWrapper, _React$PureComponent);

  var _super = _createSuper(ContentWrapper);

  function ContentWrapper() {
    _classCallCheck(this, ContentWrapper);

    return _super.apply(this, arguments);
  }

  _createClass(ContentWrapper, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          children = _this$props.children,
          key = _this$props.selected_key,
          rest = _objectWithoutProperties(_this$props, ["id", "children", "selected_key"]);

      if (!children) {
        return React.createElement(React.Fragment, null);
      }

      var params = rest;

      if (key) {
        params['aria-labelledby'] = "".concat(id, "-tab-").concat(key);
      }

      validateDOMAttributes(this.props, params);
      return React.createElement("div", _extends({
        role: "tabpanel",
        tabIndex: "0",
        id: "".concat(id, "-content"),
        className: classnames('dnb-tabs__content dnb-no-focus', createSpacingClasses(rest))
      }, params), children);
    }
  }]);

  return ContentWrapper;
}(React.PureComponent);

ContentWrapper.defaultProps = {
  selected_key: null
};
export { ContentWrapper as default };
process.env.NODE_ENV !== "production" ? ContentWrapper.propTypes = {
  id: PropTypes.string.isRequired,
  selected_key: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  children: PropTypes.node.isRequired
} : void 0;