import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.function.name.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.string.includes.js";
import "core-js/modules/web.dom-collections.iterator.js";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import { warn, isTrue, makeUniqueId, registerElement, extendPropsWithContext, validateDOMAttributes, getStatusState, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import AlignmentHelper from '../../shared/AlignmentHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import Radio from '../radio/Radio';
import Checkbox from '../checkbox/Checkbox';
import Button from '../button/Button';
import FormLabel from '../form-label/FormLabel';
import FormStatus from '../form-status/FormStatus';
import ToggleButtonGroup from './ToggleButtonGroup';
import ToggleButtonGroupContext from './ToggleButtonGroupContext';
import Context from '../../shared/Context';
import Suffix from '../../shared/helpers/Suffix';

var _ref3 = React.createElement(AlignmentHelper, null);

var ToggleButton = function (_React$PureComponent) {
  _inherits(ToggleButton, _React$PureComponent);

  var _super = _createSuper(ToggleButton);

  function ToggleButton(props, context) {
    var _this;

    _classCallCheck(this, ToggleButton);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      switch (keycode(event)) {
        case 'enter':
          _this.onClickHandler(event);

          break;
      }
    };

    _this.onKeyUpHandler = function (event) {
      switch (keycode(event)) {
        case 'enter':
          _this.onClickHandler(event);

          break;
      }
    };

    _this.onClickHandler = function (_ref) {
      var event = _ref.event;

      if (isTrue(_this.props.readOnly)) {
        return event.preventDefault();
      }

      event.persist();

      if (!isTrue(_this.context.multiselect) && _this.props.value === _this.context.value) {
        return;
      }

      var checked = !_this.state.checked;

      _this.setState({
        checked: checked,
        _listenForPropChanges: false
      });

      _this.callOnChange({
        checked: checked,
        event: event
      });

      if (_this._refButton.current && checked) {
        try {
          _this._refButton.current._ref.current.focus();
        } catch (e) {
          warn(e);
        }
      }
    };

    _this.callOnChange = function (_ref2) {
      var checked = _ref2.checked,
          event = _ref2.event;
      var value = _this.props.value;

      if (_this.context.onChange) {
        _this.context.onChange({
          value: value,
          event: event
        });
      }

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        checked: checked,
        value: value,
        event: event
      });
    };

    _this._id = props.id || makeUniqueId();
    _this._refButton = React.createRef();
    _this.state = {
      _listenForPropChanges: true
    };

    if (context.name && typeof props.value !== 'undefined') {
      if (typeof context.value !== 'undefined') {
        _this.state.checked = context.value === props.value;
        _this.state._listenForPropChanges = false;
      } else if (context.values && Array.isArray(context.values)) {
        _this.state.checked = context.values.includes(props.value);
        _this.state._listenForPropChanges = false;
      } else if (ToggleButton.parseChecked(props.checked)) {
        if (context.setContext) {
          if (context.multiselect) {
            context.setContext(function (tmp) {
              return {
                values: tmp && Array.isArray(tmp.values) ? [].concat(_toConsumableArray(tmp.values), [props.value]) : [props.value]
              };
            });
          } else {
            context.setContext({
              value: props.value
            });
          }
        }
      }
    }

    return _this;
  }

  _createClass(ToggleButton, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(Context.Consumer, null, function (context) {
        var _componentParams;

        var props = extendPropsWithContext(_this2.props, ToggleButton.defaultProps, _this2.context, context.translation.ToggleButton, context.FormRow, context.ToggleButton);

        var status = props.status,
            status_state = props.status_state,
            status_animation = props.status_animation,
            global_status_id = props.global_status_id,
            suffix = props.suffix,
            label = props.label,
            label_direction = props.label_direction,
            label_sr_only = props.label_sr_only,
            text = props.text,
            title = props.title,
            readOnly = props.readOnly,
            className = props.className,
            _className = props.class,
            disabled = props.disabled,
            skeleton = props.skeleton,
            variant = props.variant,
            left_component = props.left_component,
            icon = props.icon,
            icon_size = props.icon_size,
            icon_position = props.icon_position,
            propValue = props.value,
            _id = props.id,
            _checked = props.checked,
            attributes = props.attributes,
            children = props.children,
            on_change = props.on_change,
            on_state_update = props.on_state_update,
            custom_method = props.custom_method,
            custom_element = props.custom_element,
            rest = _objectWithoutProperties(props, ["status", "status_state", "status_animation", "global_status_id", "suffix", "label", "label_direction", "label_sr_only", "text", "title", "readOnly", "className", "class", "disabled", "skeleton", "variant", "left_component", "icon", "icon_size", "icon_position", "value", "id", "checked", "attributes", "children", "on_change", "on_state_update", "custom_method", "custom_element"]);

        var checked = _this2.state.checked;

        if (!isTrue(_this2.context.multiselect) && typeof _this2.context.value !== 'undefined') {
          var contextValue = _this2.context.value;

          if (typeof propValue === 'string' || typeof propValue === 'number') {
            checked = propValue === contextValue;
          } else if (typeof JSON !== 'undefined') {
            checked = JSON.stringify(propValue) === JSON.stringify(contextValue);
          }
        }

        var id = _this2._id;
        var showStatus = getStatusState(status);
        var mainParams = {
          className: classnames('dnb-toggle-button', createSpacingClasses(props), className, _className, status && "dnb-toggle-button__status--".concat(status_state), checked && "dnb-toggle-button--checked", label_direction && "dnb-toggle-button--".concat(label_direction))
        };
        validateDOMAttributes(_this2.props, rest);

        var buttonParams = _extends(_defineProperty({
          id: id,
          disabled: disabled,
          skeleton: skeleton,
          text: text || children,
          title: title,
          icon: icon,
          icon_size: icon_size,
          icon_position: icon_position
        }, 'aria-pressed', String(checked)), rest);

        var componentParams = (_componentParams = {
          checked: checked,
          disabled: disabled
        }, _defineProperty(_componentParams, 'aria-hidden', true), _defineProperty(_componentParams, "tabIndex", '-1'), _componentParams);

        if (status) {
          if (status_state === 'info') {
            componentParams.status_state = 'info';
          } else {
            componentParams.status = 'error';
          }
        }

        if (showStatus || suffix) {
          buttonParams['aria-describedby'] = combineDescribedBy(buttonParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
        }

        if (readOnly) {
          buttonParams['aria-readonly'] = buttonParams.readOnly = true;
        }

        var leftComponent = null;

        switch (variant) {
          case 'radio':
            leftComponent = React.createElement(Radio, _extends({
              id: "".concat(id, "-radio")
            }, componentParams));
            break;

          case 'checkbox':
            leftComponent = React.createElement(Checkbox, _extends({
              id: "".concat(id, "-checkbox")
            }, componentParams));
            break;

          case 'default':
          default:
            leftComponent = left_component;
            break;
        }

        return React.createElement("span", mainParams, label && React.createElement(FormLabel, {
          id: id + '-label',
          for_id: id,
          text: label,
          disabled: disabled,
          skeleton: skeleton,
          label_direction: label_direction,
          sr_only: label_sr_only
        }), React.createElement("span", {
          className: "dnb-toggle-button__inner"
        }, showStatus && React.createElement(FormStatus, {
          id: id + '-form-status',
          global_status_id: global_status_id,
          label: label,
          text_id: id + '-status',
          text: status,
          status: status_state,
          animation: status_animation,
          skeleton: skeleton
        }), React.createElement("span", {
          className: "dnb-toggle-button__shell"
        }, _ref3, React.createElement(Button, _extends({
          variant: "secondary",
          className: "dnb-toggle-button__button"
        }, buttonParams, {
          ref: _this2._refButton,
          onClick: _this2.onClickHandler,
          onKeyDown: _this2.onKeyDownHandler,
          onKeyUp: _this2.onKeyUpHandler
        }), leftComponent && React.createElement("span", {
          className: "dnb-toggle-button__component"
        }, leftComponent)), suffix && React.createElement(Suffix, {
          className: "dnb-toggle-button__suffix",
          id: id + '-suffix',
          context: props
        }, suffix))));
      });
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(ToggleButton.tagName, ToggleButton, ToggleButton.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.checked !== state._checked) {
          state.checked = ToggleButton.parseChecked(props.checked);
        }
      }

      state._listenForPropChanges = true;

      if (state.checked !== state.__checked) {
        dispatchCustomElementEvent({
          props: props
        }, 'on_state_update', {
          checked: state.checked
        });
      }

      state._checked = props.checked;
      state.__checked = state.checked;
      return state;
    }
  }]);

  return ToggleButton;
}(React.PureComponent);

ToggleButton.Group = ToggleButtonGroup;
ToggleButton.tagName = 'dnb-toggle-button';
ToggleButton.contextType = ToggleButtonGroupContext;
ToggleButton.defaultProps = {
  text: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  title: null,
  checked: undefined,
  variant: null,
  left_component: null,
  disabled: null,
  skeleton: null,
  id: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  value: '',
  icon: null,
  icon_position: 'right',
  icon_size: null,
  attributes: null,
  readOnly: false,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_state_update: null
};

ToggleButton.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

export { ToggleButton as default };
process.env.NODE_ENV !== "production" ? ToggleButton.propTypes = _extends({
  text: PropTypes.string,
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_direction: PropTypes.oneOf(['horizontal', 'vertical']),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  title: PropTypes.string,
  checked: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  variant: PropTypes.oneOf(['default', 'checkbox', 'radio']),
  left_component: PropTypes.node,
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  id: PropTypes.string,
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number, PropTypes.object, PropTypes.array]),
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  icon_position: PropTypes.oneOf(['left', 'right']),
  icon_size: PropTypes.string,
  attributes: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  readOnly: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_change: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;