import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.array.index-of.js";
import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.array.splice.js";
import "core-js/modules/es.function.name.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.string.includes.js";
import "core-js/modules/web.dom-collections.iterator.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { isTrue, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, getStatusState, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import FormRow from '../form-row/FormRow';
import FormStatus from '../form-status/FormStatus';
import Context from '../../shared/Context';
import Suffix from '../../shared/helpers/Suffix';
import ToggleButtonGroupContext from './ToggleButtonGroupContext';

var ToggleButtonGroup = function (_React$PureComponent) {
  _inherits(ToggleButtonGroup, _React$PureComponent);

  var _super = _createSuper(ToggleButtonGroup);

  function ToggleButtonGroup(props) {
    var _this;

    _classCallCheck(this, ToggleButtonGroup);

    _this = _super.call(this, props);

    _this.onChangeHandler = function (_ref) {
      var value = _ref.value,
          event = _ref.event;
      var multiselect = _this.props.multiselect;
      var values = _this.state.values || [];

      if (isTrue(multiselect)) {
        if (!values.includes(value)) {
          values.push(value);
        } else {
          values.splice(values.indexOf(value), 1);
        }
      }

      _this.setState({
        value: value,
        values: values,
        _listenForPropChanges: false
      });

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        value: value,
        values: values,
        event: event
      });
    };

    _this._refInput = React.createRef();
    _this._id = props.id || makeUniqueId();
    _this._name = props.name || makeUniqueId();
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(ToggleButtonGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = extendPropsWithContext(this.props, ToggleButtonGroup.defaultProps, this.context.getTranslation(this.props).ToggleButton, this.context.FormRow, this.context.ToggleButtonGroup);

      var status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          vertical = props.vertical,
          layout_direction = props.layout_direction,
          label = props.label,
          variant = props.variant,
          left_component = props.left_component,
          no_fieldset = props.no_fieldset,
          disabled = props.disabled,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          multiselect = props.multiselect,
          _id = props.id,
          _name = props.name,
          _value = props.value,
          _values = props.values,
          attributes = props.attributes,
          children = props.children,
          on_change = props.on_change,
          custom_method = props.custom_method,
          custom_element = props.custom_element,
          rest = _objectWithoutProperties(props, ["status", "status_state", "status_animation", "global_status_id", "suffix", "label_direction", "label_sr_only", "vertical", "layout_direction", "label", "variant", "left_component", "no_fieldset", "disabled", "skeleton", "className", "class", "multiselect", "id", "name", "value", "values", "attributes", "children", "on_change", "custom_method", "custom_element"]);

      var _this$state = this.state,
          value = _this$state.value,
          values = _this$state.values;
      var id = this._id;
      var showStatus = getStatusState(status);
      var classes = classnames("dnb-toggle-button-group dnb-toggle-button-group--".concat(layout_direction, " dnb-form-component"), createSpacingClasses(props), className, _className, status && "dnb-toggle-button-group__status--".concat(status_state), !label && 'dnb-toggle-button-group--no-label');

      var params = _extends({}, rest);

      if (showStatus || suffix) {
        params['aria-describedby'] = combineDescribedBy(params, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (label) {
        params['aria-labelledby'] = id + '-label';
      }

      validateDOMAttributes(this.props, params);
      var context = {
        name: this._name,
        value: value,
        values: values,
        multiselect: isTrue(multiselect),
        variant: variant,
        left_component: left_component,
        disabled: disabled,
        skeleton: skeleton,
        setContext: function setContext(context) {
          if (typeof context === 'function') {
            context = context(_this2._tmp);
          }

          _this2._tmp = _extends({}, _this2._tmp, context);

          _this2.setState(_extends({}, context, {
            _listenForPropChanges: false
          }));
        },
        onChange: this.onChangeHandler
      };
      var formRowParams = {
        id: id,
        label: label,
        label_id: id + '-label',
        label_direction: label_direction,
        label_sr_only: label_sr_only,
        direction: label_direction,
        vertical: vertical,
        disabled: disabled,
        skeleton: skeleton,
        no_fieldset: no_fieldset,
        skipContentWrapperIfNested: true
      };
      return React.createElement(ToggleButtonGroupContext.Provider, {
        value: context
      }, React.createElement("div", {
        className: classes
      }, React.createElement(FormRow, formRowParams, React.createElement("span", _extends({
        id: id,
        className: "dnb-toggle-button-group__shell",
        role: "group"
      }, params), showStatus && React.createElement(FormStatus, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), React.createElement("span", {
        className: "dnb-toggle-button-group__children"
      }, children, suffix && React.createElement(Suffix, {
        className: "dnb-toggle-button-group__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(ToggleButtonGroup.tagName, ToggleButtonGroup, ToggleButtonGroup.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (typeof props.value !== 'undefined' && props.value !== state.value) {
          state.value = props.value;
        }

        if (typeof props.values !== 'undefined' && props.values !== state.values) {
          state.values = ToggleButtonGroup.getValues(props);
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }, {
    key: "getValues",
    value: function getValues(props) {
      if (typeof props.values === 'string' && props.values[0] === '[') {
        return JSON.parse(props.values);
      }

      return props.values;
    }
  }]);

  return ToggleButtonGroup;
}(React.PureComponent);

ToggleButtonGroup.tagName = 'dnb-toggle-button-group';
ToggleButtonGroup.contextType = Context;
ToggleButtonGroup.defaultProps = {
  label: null,
  label_direction: null,
  label_sr_only: null,
  title: null,
  multiselect: null,
  variant: null,
  left_component: null,
  no_fieldset: null,
  disabled: null,
  skeleton: null,
  id: null,
  name: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  vertical: null,
  layout_direction: 'row',
  value: undefined,
  values: undefined,
  attributes: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null
};
export { ToggleButtonGroup as default };
process.env.NODE_ENV !== "production" ? ToggleButtonGroup.propTypes = _extends({
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_direction: PropTypes.oneOf(['horizontal', 'vertical']),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  title: PropTypes.string,
  multiselect: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  variant: PropTypes.oneOf(['default', 'checkbox', 'radio']),
  left_component: PropTypes.node,
  no_fieldset: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  id: PropTypes.string,
  name: PropTypes.string,
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  vertical: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  layout_direction: PropTypes.oneOf(['column', 'row']),
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number, PropTypes.object, PropTypes.array]),
  values: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
  attributes: PropTypes.oneOfType([PropTypes.string, PropTypes.object])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_change: PropTypes.func
}) : void 0;