import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import { makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import TooltipWithEvents from './TooltipWithEvents';
import TooltipPortal from './TooltipPortal';

var Tooltip = function (_React$PureComponent) {
  _inherits(Tooltip, _React$PureComponent);

  var _super = _createSuper(Tooltip);

  function Tooltip(props) {
    var _this;

    _classCallCheck(this, Tooltip);

    _this = _super.call(this, props);
    _this._id = props.id || makeUniqueId();
    return _this;
  }

  _createClass(Tooltip, [{
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, Tooltip.defaultProps, this.context.getTranslation(this.props).Tooltip, this.context.FormRow, this.context.Tooltip);

      var component = props.component,
          target = props.target,
          class_name = props.class,
          className = props.className,
          group = props.group,
          animate_position = props.animate_position,
          show_delay = props.show_delay,
          hide_delay = props.hide_delay,
          active = props.active,
          position = props.position,
          arrow = props.arrow,
          align = props.align,
          params = _objectWithoutProperties(props, ["component", "target", "class", "className", "group", "animate_position", "show_delay", "hide_delay", "active", "position", "arrow", "align"]);

      var content = Tooltip.getContent(this.props);
      var classes = classnames("dnb-tooltip dnb-core-style", createSpacingClasses(props), class_name, className);

      var attributes = _extends({
        className: classes
      }, params);

      validateDOMAttributes(this.props, attributes);

      var newProps = _extends({}, this.props, {
        internal_id: this._id,
        group: this.props.id || group
      });

      if (typeof newProps.active === 'undefined') {
        delete newProps.active;
      }

      return React.createElement(React.Fragment, null, component ? React.createElement(TooltipWithEvents, _extends({
        target: component,
        attributes: attributes
      }, newProps), content) : target && React.createElement(TooltipPortal, _extends({
        target: target,
        attributes: attributes
      }, newProps), content));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Tooltip.tagName, Tooltip, Tooltip.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      return processChildren(props);
    }
  }]);

  return Tooltip;
}(React.PureComponent);

Tooltip.tagName = 'dnb-tooltip';
Tooltip.contextType = Context;
Tooltip.defaultProps = {
  id: null,
  group: 'main',
  active: undefined,
  position: 'top',
  arrow: 'center',
  align: null,
  animate_position: false,
  show_delay: 300,
  hide_delay: 500,
  class: null,
  className: null,
  children: null,
  onClick: null,
  on_click: null
};
export { Tooltip as default };
process.env.NODE_ENV !== "production" ? Tooltip.propTypes = _extends({
  id: PropTypes.string,
  group: PropTypes.string,
  active: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  position: PropTypes.oneOf(['top', 'right', 'bottom', 'left']),
  arrow: PropTypes.oneOf([null, 'center', 'top', 'right', 'bottom', 'left']),
  align: PropTypes.oneOf([null, 'center', 'right', 'left']),
  animate_position: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  show_delay: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  hide_delay: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  onClick: PropTypes.func,
  on_click: PropTypes.oneOfType([PropTypes.string, PropTypes.func])
}) : void 0;