import "core-js/modules/es.array.concat.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { isTrue } from '../../shared/component-helper';
import classnames from 'classnames';

var TooltipContainer = function (_React$PureComponent) {
  _inherits(TooltipContainer, _React$PureComponent);

  var _super = _createSuper(TooltipContainer);

  function TooltipContainer() {
    var _this;

    _classCallCheck(this, TooltipContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this._rootRef = React.createRef();
    _this.offset = 16;
    _this.state = {
      hide: null,
      hover: null,
      width: 0,
      height: 0
    };

    _this.handleMouseEnter = function () {
      isTrue(_this.props.active) && _this.props.useHover && _this.setState({
        hover: true
      });
    };

    _this.handleMouseLeave = function () {
      _this.props.useHover && _this.setState({
        hover: false
      });
    };

    return _this;
  }

  _createClass(TooltipContainer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (isTrue(this.props.active)) {
        this.updateSize();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props !== prevProps) {
        this.updateSize();
      }
    }
  }, {
    key: "getGlobalStyle",
    value: function getGlobalStyle() {
      if (!this.props.targetElement) {
        return {
          display: 'none'
        };
      }

      var style = _extends({}, this.makeStyle(this.props.position, this.props.arrow));

      return style;
    }
  }, {
    key: "makeStyle",
    value: function makeStyle(position, arrow) {
      var _this2 = this;

      if (typeof window === 'undefined') {
        return {};
      }

      var alignOffset = 0;
      var target = this.props.targetElement;
      var align = this.props.align;
      var tooltipPosition = target.getBoundingClientRect();
      var scrollY = window.scrollY !== undefined ? window.scrollY : window.pageYOffset;
      var scrollX = window.scrollX !== undefined ? window.scrollX : window.pageXOffset;

      var _top = scrollY + tooltipPosition.top;

      var _left = scrollX + tooltipPosition.left;

      var style = {};
      var targetSize = {
        width: target.offsetWidth,
        height: target.offsetHeight
      };

      if (!target.offsetHeight && target.getBoundingClientRect) {
        targetSize.width = target.getBoundingClientRect().width;
        targetSize.height = target.getBoundingClientRect().height;
      }

      if (align === 'left') {
        alignOffset = -targetSize.width / 2;
      } else if (align === 'right') {
        alignOffset = targetSize.width / 2;
      }

      var stylesFromPosition = {
        left: function left() {
          style.top = _top + targetSize.height / 2 - _this2.state.height / 2;
          style.left = _left - _this2.state.width - _this2.offset;
        },
        right: function right() {
          style.top = _top + targetSize.height / 2 - _this2.state.height / 2;
          style.left = _left + targetSize.width + _this2.offset;
        },
        top: function top() {
          style.left = _left - _this2.state.width / 2 + targetSize.width / 2 + alignOffset;
          style.top = _top - _this2.state.height - _this2.offset;
        },
        bottom: function bottom() {
          style.left = _left - _this2.state.width / 2 + targetSize.width / 2 + alignOffset;
          style.top = _top + targetSize.height + _this2.offset;
        }
      };
      var stylesFromArrow = {
        left: function left() {
          style.left = _left + targetSize.width / 2 - _this2.offset + alignOffset;
        },
        right: function right() {
          style.left = _left - _this2.state.width + targetSize.width / 2 + _this2.offset + alignOffset;
        },
        top: function top() {
          style.top = _top + targetSize.height / 2 - _this2.offset;
        },
        bottom: function bottom() {
          style.top = _top + targetSize.height / 2 - _this2.state.height + _this2.offset;
        }
      };

      if (stylesFromPosition[position]) {
        stylesFromPosition[position]();
      }

      if (stylesFromArrow[arrow]) {
        stylesFromArrow[arrow]();
      }

      return style;
    }
  }, {
    key: "checkWindowPosition",
    value: function checkWindowPosition(style) {
      if (style.left < 0) {
        style.left = this.offset;
      } else {
        try {
          var rightOffset = style.left + this.state.width - window.innerWidth;

          if (rightOffset > 0) {
            style.left = window.innerWidth - this.state.width - this.offset;
          }
        } catch (e) {}
      }

      return style;
    }
  }, {
    key: "updateSize",
    value: function updateSize() {
      var width = this._rootRef.current.offsetWidth;
      var height = this._rootRef.current.offsetHeight;

      if (width !== this.state.width || height !== this.state.height) {
        this.setState({
          width: width,
          height: height,
          _listenForPropChanges: false
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          internal_id = _this$props.internal_id,
          active = _this$props.active,
          attributes = _this$props.attributes,
          arrow = _this$props.arrow,
          position = _this$props.position,
          animate_position = _this$props.animate_position,
          children = _this$props.children;
      var _this$state = this.state,
          hover = _this$state.hover,
          hide = _this$state.hide;
      var style = this.checkWindowPosition(this.getGlobalStyle());
      var isActive = isTrue(active) || hover;
      return React.createElement("div", _extends({
        role: "tooltip",
        "aria-hidden": true,
        style: style,
        ref: this._rootRef,
        onMouseEnter: this.handleMouseEnter,
        onMouseLeave: this.handleMouseLeave
      }, attributes, {
        className: classnames(attributes.className, isActive ? 'dnb-tooltip--active' : hide && 'dnb-tooltip--hide', isTrue(animate_position) && 'dnb-tooltip--animate_position')
      }), arrow && React.createElement("span", {
        className: "dnb-tooltip__arrow dnb-tooltip__arrow__arrow--".concat(arrow, " dnb-tooltip__arrow__position--").concat(position)
      }), React.createElement("div", {
        id: internal_id,
        className: "dnb-tooltip__content"
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (state.wasActive && !props.active && !state.hover) {
          state.hide = true;
        }

        if (props.active || state.hover) {
          state.wasActive = true;
          state.hide = false;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return TooltipContainer;
}(React.PureComponent);

TooltipContainer.defaultProps = {
  internal_id: null,
  targetElement: null,
  active: false,
  position: 'center',
  arrow: null,
  align: null,
  animate_position: null,
  useHover: true,
  attributes: null,
  children: null
};
export { TooltipContainer as default };
process.env.NODE_ENV !== "production" ? TooltipContainer.propTypes = {
  internal_id: PropTypes.string,
  targetElement: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.object, PropTypes.node]),
  active: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  position: PropTypes.string,
  arrow: PropTypes.string,
  align: PropTypes.string,
  animate_position: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  useHover: PropTypes.bool,
  attributes: PropTypes.object,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node])
} : void 0;