import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.index-of.js";
import "core-js/modules/es.array.join.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.split.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import TooltipContainer from './TooltipContainer';
var tooltipPortal;

if (typeof window !== 'undefined') {
  window.tooltipPortal = window.tooltipPortal || {};
  tooltipPortal = window.tooltipPortal;
} else {
  tooltipPortal = {};
}

var TooltipPortal = function (_React$PureComponent) {
  _inherits(TooltipPortal, _React$PureComponent);

  var _super = _createSuper(TooltipPortal);

  function TooltipPortal() {
    _classCallCheck(this, TooltipPortal);

    return _super.apply(this, arguments);
  }

  _createClass(TooltipPortal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.renderPortal();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(props) {
      if (!tooltipPortal[this.props.group] || this.props.active && props.active) {
        return;
      }

      this.renderPortal({
        active: true
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (tooltipPortal[this.props.group]) {
        ReactDOM.unmountComponentAtNode(tooltipPortal[this.props.group].node);
        clearTimeout(tooltipPortal[this.props.group].timeout);

        try {
          document.body.removeChild(tooltipPortal[this.props.group].node);
        } catch (e) {}

        tooltipPortal[this.props.group] = null;
      }
    }
  }, {
    key: "createPortal",
    value: function createPortal() {
      if (typeof document !== 'undefined') {
        try {
          tooltipPortal[this.props.group] = {
            node: document.createElement('div'),
            timeout: null
          };
          tooltipPortal[this.props.group].node.className = 'TooltipPortal';
          document.body.insertBefore(tooltipPortal[this.props.group].node, document.body.firstChild);
        } catch (e) {
          console.warn('Could not create TooltipPortal!', e);
        }
      }
    }
  }, {
    key: "handleAria",
    value: function handleAria(elem) {
      if (elem && this.props.internal_id) {
        try {
          var describedby = makeArrayUnique(String(elem.getAttribute('aria-describedby') || '').split(' '));
          describedby.push(this.props.internal_id);
          elem.setAttribute('aria-describedby', describedby.join(' '));
        } catch (e) {}
      }
    }
  }, {
    key: "renderPortal",
    value: function renderPortal() {
      var _this = this;

      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (typeof document === 'undefined') {
        return;
      }

      if (!tooltipPortal[this.props.group]) {
        this.createPortal();
      }

      var _this$props = this.props,
          group = _this$props.group,
          target = _this$props.target;
      var targetElement = typeof target === 'string' ? document.querySelector(target) : target;

      if (tooltipPortal[group].timeout) {
        clearTimeout(tooltipPortal[group].timeout);
      }

      if (!this.props.active && props.active) {
        tooltipPortal[group].timeout = setTimeout(function () {
          _this.renderPortal({
            active: false
          });
        }, parseFloat(this.props.hide_delay));
      }

      ReactDOM.render(React.createElement(TooltipContainer, _extends({
        targetElement: targetElement
      }, this.props, props)), tooltipPortal[this.props.group].node);
      this.handleAria(targetElement);
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return TooltipPortal;
}(React.PureComponent);

TooltipPortal.defaultProps = {
  internal_id: null,
  active: false,
  group: 'main',
  hide_delay: 500
};
export { TooltipPortal as default };
process.env.NODE_ENV !== "production" ? TooltipPortal.propTypes = {
  internal_id: PropTypes.string,
  target: PropTypes.oneOfType([PropTypes.string, PropTypes.object]).isRequired,
  active: PropTypes.bool,
  group: PropTypes.string,
  hide_delay: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
} : void 0;

var makeArrayUnique = function makeArrayUnique(array) {
  return array.filter(Boolean).filter(function (value, index, self) {
    return self.indexOf(value) === index;
  });
};