import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';
import classnames from 'classnames';

var Hr = function Hr() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var fullscreen = _ref.fullscreen,
      light = _ref.light,
      medium = _ref.medium,
      props = _objectWithoutProperties(_ref, ["fullscreen", "light", "medium"]);

  if (fullscreen) {
    props.className = classnames(props.className, 'dnb-hr--fullscreen');
  }

  if (light) {
    props.className = classnames(props.className, 'dnb-hr--light');
  }

  if (medium) {
    props.className = classnames(props.className, 'dnb-hr--medium');
  }

  return React.createElement(E, _extends({
    is: "hr"
  }, props));
};

Hr.tagName = 'dnb-hr';
process.env.NODE_ENV !== "production" ? Hr.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string,
  light: PropTypes.bool,
  medium: PropTypes.bool,
  fullscreen: PropTypes.bool
}) : void 0;
Hr.defaultProps = {
  className: null,
  light: null,
  medium: null,
  fullscreen: null
};
export default Hr;