import * as React from 'react';
export type LeadSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type LeadTop = string | number | boolean;
export type LeadRight = string | number | boolean;
export type LeadBottom = string | number | boolean;
export type LeadLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface LeadProps extends React.HTMLProps<HTMLElement> {
  space?: LeadSpace;
  top?: LeadTop;
  right?: LeadRight;
  bottom?: LeadBottom;
  left?: LeadLeft;
  children?: React.ReactNode;
}
declare const Lead: React.FC<LeadProps>;
export default Lead;
