import "core-js/modules/es.array.for-each.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';
import Ul from './Ul';
import Ol from './Ol';

var Li = function Li() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var className = _ref.className,
      p = _objectWithoutProperties(_ref, ["className"]);

  if (Array.isArray(p.children)) {
    p.children.forEach(function (Comp) {
      if (Comp && (Comp.type === Ul || Comp.type === Ol)) {
        className = classnames(className, 'is-nested');
      }
    });
  }

  return React.createElement(E, _extends({
    is: "li"
  }, p, {
    className: className
  }));
};

Li.tagName = 'dnb-li';
process.env.NODE_ENV !== "production" ? Li.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string
}) : void 0;
Li.defaultProps = {
  className: null
};
export default Li;