import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

var Ol = function Ol() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var nested = _ref.nested,
      inside = _ref.inside,
      outside = _ref.outside,
      p = _objectWithoutProperties(_ref, ["nested", "inside", "outside"]);

  if (nested) {
    p.className = classnames(p.className, 'dnb-ol--nested');
  }

  if (inside) {
    p.className = classnames(p.className, 'dnb-ol--inside');
  }

  if (outside) {
    p.className = classnames(p.className, 'dnb-ol--outside');
  }

  return React.createElement(E, _extends({
    is: "ol"
  }, p, {
    skeleton: false
  }));
};

Ol.tagName = 'dnb-ol';
process.env.NODE_ENV !== "production" ? Ol.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string,
  inside: PropTypes.bool,
  outside: PropTypes.bool,
  nested: PropTypes.bool
}) : void 0;
Ol.defaultProps = {
  className: null,
  inside: null,
  outside: null,
  nested: null
};
export default Ol;