import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.split.js";
import "core-js/modules/es.string.bold.js";
import "core-js/modules/es.string.small.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

var P = function P(_ref) {
  var style_type = _ref.style_type,
      modifier = _ref.modifier,
      element = _ref.element,
      className = _ref.className,
      small = _ref.small,
      medium = _ref.medium,
      bold = _ref.bold,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ["style_type", "modifier", "element", "className", "small", "medium", "bold", "size"]);

  if (typeof modifier === 'string' && / /.test(modifier)) {
    modifier = modifier.split(/ /g);
  } else if (!Array.isArray(modifier)) {
    modifier = [modifier];
  }

  if (style_type) {
    modifier.push(style_type);
  }

  if (medium === true) {
    modifier.push('medium');
  } else if (bold === true) {
    modifier.push('bold');
  }

  modifier = modifier.filter(Boolean).reduce(function (acc, cur) {
    if (['x-small', 'small'].includes(cur)) {
      return "".concat(acc, " dnb-p__size--").concat(cur);
    }

    return "".concat(acc, " dnb-p--").concat(cur);
  }, '');

  if (size) {
    className = classnames(className, "dnb-p__size--".concat(size));
  } else if (small === true) {
    className = classnames(className, 'dnb-p__size--small');
  }

  return React.createElement(E, _extends({
    is: element
  }, props, {
    className: classnames('dnb-p', modifier, className)
  }));
};

P.tagName = 'dnb-p';
process.env.NODE_ENV !== "production" ? P.propTypes = _extends({}, spacingPropTypes, {
  element: PropTypes.node,
  className: PropTypes.string,
  small: PropTypes.bool,
  medium: PropTypes.bool,
  bold: PropTypes.bool,
  size: PropTypes.oneOf(['x-small', 'small', 'basis', 'medium', 'large', 'x-large', 'xx-large']),
  style_type: PropTypes.string,
  modifier: PropTypes.string,
  children: PropTypes.node
}) : void 0;
P.defaultProps = {
  element: 'p',
  className: null,
  small: null,
  medium: null,
  bold: null,
  size: null,
  style_type: null,
  modifier: null,
  children: null
};
export default P;