import * as React from 'react';
export type TdSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type TdTop = string | number | boolean;
export type TdRight = string | number | boolean;
export type TdBottom = string | number | boolean;
export type TdLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface TdProps extends React.HTMLProps<HTMLElement> {
  space?: TdSpace;
  top?: TdTop;
  right?: TdRight;
  bottom?: TdBottom;
  left?: TdLeft;
  children?: React.ReactNode;
}
declare const Td: React.FC<TdProps>;
export default Td;
