import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

var Ul = function Ul() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var nested = _ref.nested,
      inside = _ref.inside,
      outside = _ref.outside,
      p = _objectWithoutProperties(_ref, ["nested", "inside", "outside"]);

  if (nested) {
    p.className = classnames(p.className, 'dnb-ul--nested');
  }

  if (inside) {
    p.className = classnames(p.className, 'dnb-ul--inside');
  }

  if (outside) {
    p.className = classnames(p.className, 'dnb-ul--outside');
  }

  return React.createElement(E, _extends({
    is: "ul"
  }, p, {
    skeleton: false
  }));
};

Ul.tagName = 'dnb-ul';
process.env.NODE_ENV !== "production" ? Ul.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string,
  inside: PropTypes.bool,
  outside: PropTypes.bool,
  nested: PropTypes.bool,
  children: PropTypes.node
}) : void 0;
Ul.defaultProps = {
  className: null,
  inside: null,
  outside: null,
  nested: null,
  children: null
};
export default Ul;