import * as React from 'react';
export type AccordionGroupExpanded = string | boolean;
export type AccordionGroupNoAnimation = string | boolean;
export type AccordionGroupExpandedSsr = string | boolean;
export type AccordionGroupPrerender = string | boolean;
export type AccordionGroupPreventRerender = string | boolean;
export type AccordionGroupPreventRerenderConditional = string | boolean;
export type AccordionGroupRememberState = string | boolean;
export type AccordionGroupFlushRememberedState = string | boolean;
export type AccordionGroupSingleContainer = string | boolean;
export type AccordionGroupVariant = 'default' | 'outlined' | 'filled';
export type AccordionGroupAllowCloseAll = string | boolean;
export type AccordionGroupDisabled = string | boolean;
export type AccordionGroupSkeleton = string | boolean;
export type AccordionGroupHeading = boolean | React.ReactNode;
export type AccordionGroupHeadingLevel = string | number;
export type AccordionGroupIconPosition = 'left' | 'right';
export type AccordionGroupAttributes = string | Object;
export type AccordionGroupSpace =
  | string
  | number
  | boolean
  | {
      /**
       * Use spacing values like: `small`, `1rem`, `1` or , `16px`. Will use `margin-top`.
       */
      top?: string | number | boolean;

      /**
       * Use spacing values like: `small`, `1rem`, `1` or , `16px`. will use `margin-right`.
       */
      right?: string | number | boolean;

      /**
       * Use spacing values like: `small`, `1rem`, `1` or , `16px`. will use `margin-bottom`.
       */
      bottom?: string | number | boolean;

      /**
       * Use spacing values like: `small`, `1rem`, `1` or , `16px`. will use `margin-left`.
       */
      left?: string | number | boolean;
    };
export type AccordionGroupTop = string | number | boolean;
export type AccordionGroupRight = string | number | boolean;
export type AccordionGroupBottom = string | number | boolean;
export type AccordionGroupLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface AccordionGroupProps extends React.HTMLProps<HTMLElement> {
  label?: React.ReactNode;
  title?: string;
  expanded?: AccordionGroupExpanded;
  no_animation?: AccordionGroupNoAnimation;
  expanded_ssr?: AccordionGroupExpandedSsr;
  prerender?: AccordionGroupPrerender;
  prevent_rerender?: AccordionGroupPreventRerender;
  prevent_rerender_conditional?: AccordionGroupPreventRerenderConditional;
  remember_state?: AccordionGroupRememberState;
  flush_remembered_state?: AccordionGroupFlushRememberedState;
  single_container?: AccordionGroupSingleContainer;
  variant?: AccordionGroupVariant;
  left_component?: React.ReactNode;
  allow_close_all?: AccordionGroupAllowCloseAll;
  disabled?: AccordionGroupDisabled;
  skeleton?: AccordionGroupSkeleton;

  /**
   * Docs.
   */
  id?: string;
  group?: string;
  element?: React.ReactNode;
  heading?: AccordionGroupHeading;
  heading_level?: AccordionGroupHeadingLevel;
  icon?: React.ReactNode;
  icon_position?: AccordionGroupIconPosition;
  icon_size?: string;
  attributes?: AccordionGroupAttributes;
  class?: string;
  className?: string;
  children?: React.ReactNode;

  /**
   * Has to be an object with either: `top`, `right`, `bottom` or `left`. Use spacing values like: `small`, `1rem`, `1` or , `16px`.
   */
  space?: AccordionGroupSpace;

  /**
   * Use spacing values like: `small`, `1rem`, `1` or , `16px`. Will use `margin-top`.
   */
  top?: AccordionGroupTop;

  /**
   * Use spacing values like: `small`, `1rem`, `1` or , `16px`. will use `margin-right`.
   */
  right?: AccordionGroupRight;

  /**
   * Use spacing values like: `small`, `1rem`, `1` or , `16px`. will use `margin-bottom`.
   */
  bottom?: AccordionGroupBottom;

  /**
   * Use spacing values like: `small`, `1rem`, `1` or , `16px`. will use `margin-left`.
   */
  left?: AccordionGroupLeft;
  custom_element?: Object;
  custom_method?: (...args: any[]) => any;

  /**
   * Will be called by user click interaction. Returns an object with a boolean state `expanded` inside `{ expanded, id, event, ...event }`.
   */
  on_change?: (...args: any[]) => any;
  on_state_update?: (...args: any[]) => any;

  /**
   * Expanded_id docs.
   */
  expanded_id?: string;
  onInit?: (...args: any[]) => any;
}
export default class AccordionGroup extends React.Component<
  AccordionGroupProps,
  any
> {
  render(): JSX.Element;
}
