import * as React from 'react';
export type DatePickerDate = Date | string;
export type DatePickerStartDate = Date | string;
export type DatePickerEndDate = Date | string;
export type DatePickerMonth = Date | string;
export type DatePickerStartMonth = Date | string;
export type DatePickerEndMonth = Date | string;
export type DatePickerMinDate = Date | string;
export type DatePickerMaxDate = Date | string;
export type DatePickerCorrectInvalidDate = string | boolean;
export type DatePickerHideNavigation = string | boolean;
export type DatePickerHideNavigationButtons = string | boolean;
export type DatePickerHideDays = string | boolean;
export type DatePickerOnlyMonth = string | boolean;
export type DatePickerHideLastWeek = string | boolean;
export type DatePickerDisableAutofocus = string | boolean;
export type DatePickerEnableKeyboardNav = string | boolean;
export type DatePickerShowInput = string | boolean;
export type DatePickerShowSubmitButton = string | boolean;
export type DatePickerShowCancelButton = string | boolean;
export type DatePickerShowResetButton = string | boolean;
export type DatePickerResetDate = string | boolean;
export type DatePickerRange = string | boolean;
export type DatePickerLink = string | boolean;
export type DatePickerSync = string | boolean;
export type DatePickerLabel =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type DatePickerLabelDirection = 'horizontal' | 'vertical';
export type DatePickerLabelSrOnly = string | boolean;
export type DatePickerInputElement =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type DatePickerAddonElement = string | React.ReactNode;
export type DatePickerShortcuts = any[] | ((...args: any[]) => any);
export type DatePickerDisabled = string | boolean;
export type DatePickerStretch = string | boolean;
export type DatePickerSkeleton = string | boolean;
export type DatePickerStatus =
  | string
  | boolean
  | ((...args: any[]) => any)
  | React.ReactNode;
export type DatePickerSuffix =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type DatePickerOpened = string | boolean;
export type DatePickerPreventClose = string | boolean;
export type DatePickerNoAnimation = string | boolean;
export type DatePickerDirection = 'auto' | 'top' | 'bottom';
export type DatePickerAlignPicker = 'auto' | 'left' | 'right';
export type DatePickerSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type DatePickerTop = string | number | boolean;
export type DatePickerRight = string | number | boolean;
export type DatePickerBottom = string | number | boolean;
export type DatePickerLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DatePickerProps extends React.HTMLProps<HTMLElement> {
  id?: string;
  title?: string;
  date?: DatePickerDate;
  start_date?: DatePickerStartDate;
  end_date?: DatePickerEndDate;
  month?: DatePickerMonth;
  start_month?: DatePickerStartMonth;
  end_month?: DatePickerEndMonth;
  min_date?: DatePickerMinDate;
  max_date?: DatePickerMaxDate;
  correct_invalid_date?: DatePickerCorrectInvalidDate;
  mask_order?: string;
  mask_placeholder?: string;
  date_format?: string;
  return_format?: string;
  hide_navigation?: DatePickerHideNavigation;
  hide_navigation_buttons?: DatePickerHideNavigationButtons;
  hide_days?: DatePickerHideDays;
  only_month?: DatePickerOnlyMonth;
  hide_last_week?: DatePickerHideLastWeek;
  disable_autofocus?: DatePickerDisableAutofocus;
  enable_keyboard_nav?: DatePickerEnableKeyboardNav;
  show_input?: DatePickerShowInput;
  show_submit_button?: DatePickerShowSubmitButton;
  show_cancel_button?: DatePickerShowCancelButton;
  show_reset_button?: DatePickerShowResetButton;
  submit_button_text?: string;
  cancel_button_text?: string;
  reset_button_text?: string;
  reset_date?: DatePickerResetDate;
  first_day?: string;
  locale?: Object;
  range?: DatePickerRange;
  link?: DatePickerLink;
  sync?: DatePickerSync;
  label?: DatePickerLabel;
  label_direction?: DatePickerLabelDirection;
  label_sr_only?: DatePickerLabelSrOnly;
  input_element?: DatePickerInputElement;
  addon_element?: DatePickerAddonElement;
  shortcuts?: DatePickerShortcuts;
  disabled?: DatePickerDisabled;
  stretch?: DatePickerStretch;
  skeleton?: DatePickerSkeleton;
  status?: DatePickerStatus;
  status_state?: string;
  status_animation?: string;
  global_status_id?: string;
  suffix?: DatePickerSuffix;
  opened?: DatePickerOpened;
  prevent_close?: DatePickerPreventClose;
  no_animation?: DatePickerNoAnimation;
  direction?: DatePickerDirection;
  align_picker?: DatePickerAlignPicker;
  class?: string;
  className?: string;
  space?: DatePickerSpace;
  top?: DatePickerTop;
  right?: DatePickerRight;
  bottom?: DatePickerBottom;
  left?: DatePickerLeft;
  custom_element?: Object;
  custom_method?: (...args: any[]) => any;
  on_days_render?: (...args: any[]) => any;
  on_change?: (...args: any[]) => any;
  on_type?: (...args: any[]) => any;
  on_show?: (...args: any[]) => any;
  on_hide?: (...args: any[]) => any;
  on_submit?: (...args: any[]) => any;
  on_cancel?: (...args: any[]) => any;
  on_reset?: (...args: any[]) => any;
}
export default class DatePicker extends React.Component<
  DatePickerProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
