import * as React from 'react';
export type DatePickerInputStatus =
  | string
  | boolean
  | ((...args: any[]) => any)
  | React.ReactNode;
export type DatePickerInputInputElement =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DatePickerInputProps
  extends React.HTMLProps<HTMLElement> {
  id?: string;
  title?: string;
  selectedDateTitle?: string;
  maskOrder?: string;
  maskPlaceholder?: string;
  separatorRexExp?: RegExp;
  submitAttributes?: Object;
  isRange?: boolean;
  status?: DatePickerInputStatus;
  status_state?: string;
  input_element?: DatePickerInputInputElement;
  locale?: Object;
  disabled?: boolean;
  skeleton?: boolean;
  opened?: boolean;
  showInput?: boolean;
  onChange?: (...args: any[]) => any;
  onSubmit?: (...args: any[]) => any;
  onFocus?: (...args: any[]) => any;
}
export default class DatePickerInput extends React.Component<
  DatePickerInputProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
