import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { Space, Button, IconPrimary, DatePicker, Textarea, Autocomplete, Dropdown, Slider, Checkbox, Radio, ToggleButton, Switch, Input } from '../';

var _ref = React.createElement(ToggleButton, {
  text: "Toggle A",
  value: "a"
});

var _ref2 = React.createElement(ToggleButton, {
  text: "Toggle B",
  value: "b"
});

const AllComponents = ({
  horizontal,
  vertical,
  showText,
  hideLabel
}) => {
  const params = {
    left: horizontal ? 'small' : null,
    top: !horizontal || vertical ? 'small' : null
  };
  let labels = {
    datePicker: 'DatePicker:',
    dropdown: 'Dropdown:',
    autocomplete: 'Autocomplete:',
    checkbox: 'Checkbox',
    radio: 'Radio',
    radioGroup: 'Radio Group:',
    toggleButton: 'Toggle:',
    toggleButtonGroup: 'Toggle Group:',
    switch: 'Switch',
    input: 'Input:',
    textarea: 'Textarea:',
    slider: 'Slider:'
  };

  if (hideLabel) {
    labels = Object.entries(labels).reduce((acc, [k]) => {
      acc[k] = '';
      return acc;
    }, {});
  }

  return React.createElement(React.Fragment, null, showText && React.createElement(React.Fragment, null, React.createElement(Space, _extends({}, params, {
    inline: true
  }), React.createElement("p", {
    className: "dnb-p"
  }, "paragraph", ' ', React.createElement(IconPrimary, _extends({
    icon: "bell",
    size: "medium"
  }, params, {
    style: {
      margin: 0
    }
  })))), "text"), React.createElement(Button, _extends({
    text: "Button"
  }, params)), React.createElement(Button, _extends({
    icon: "add"
  }, params)), React.createElement(Input, _extends({
    label: labels.input
  }, params)), React.createElement(Input, _extends({
    label: labels.input
  }, params)), React.createElement(Dropdown, _extends({
    label: labels.dropdown,
    data: ['Item A', 'Item B', 'Item C']
  }, params)), React.createElement(Autocomplete, _extends({
    label: labels.autocomplete,
    data: ['Item A', 'Item B', 'Item C']
  }, params)), React.createElement(DatePicker, _extends({
    label: labels.datePicker
  }, params)), React.createElement(IconPrimary, _extends({
    icon: "bell",
    size: "medium"
  }, params, {
    style: {
      marginTop: 0
    }
  })), React.createElement(Checkbox, _extends({
    label: labels.checkbox
  }, params)), React.createElement(Radio, _extends({
    label: labels.radio
  }, params)), React.createElement(Radio.Group, _extends({
    label: labels.radioGroup
  }, params), React.createElement(Radio, {
    label: labels.radio,
    value: "a"
  }), React.createElement(Radio, {
    label: labels.radio,
    value: "b"
  })), React.createElement(ToggleButton, _extends({
    label: labels.toggleButton,
    text: "Toggle"
  }, params)), React.createElement(ToggleButton.Group, _extends({
    label: labels.toggleButtonGroup
  }, params), _ref, _ref2), React.createElement(Switch, _extends({
    label: labels.switch
  }, params)), React.createElement(Textarea, _extends({
    label: labels.textarea,
    rows: "5"
  }, params)), React.createElement(Textarea, _extends({
    label: labels.textarea,
    rows: "5"
  }, params)), React.createElement(Slider, _extends({
    label: labels.slider,
    value: 50
  }, params)));
};

process.env.NODE_ENV !== "production" ? AllComponents.propTypes = {
  horizontal: PropTypes.bool,
  vertical: PropTypes.bool,
  showText: PropTypes.bool,
  hideLabel: PropTypes.bool
} : void 0;
AllComponents.defaultProps = {
  horizontal: null,
  vertical: null,
  showText: null,
  hideLabel: null
};
export default AllComponents;