import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import styled from '@emotion/styled';
import { FormSet, FormRow, Space, DatePicker, Textarea, Autocomplete, Dropdown, Slider, Input } from '../';
export default function AllStretchComponents() {
  return _ref;
}

function StretchTemplate(_ref2) {
  let {
    element: Comp
  } = _ref2,
      props = _objectWithoutPropertiesLoose(_ref2, ["element"]);

  return React.createElement(React.Fragment, null, React.createElement(Box, null, React.createElement(FormSet, {
    direction: "vertical"
  }, React.createElement(FormRow, null, React.createElement(Comp, _extends({
    label: "FormSet direction=\"vertical\"",
    stretch: true
  }, props))))), React.createElement(Box, null, React.createElement(FormSet, {
    vertical: true
  }, React.createElement(FormRow, null, React.createElement(Comp, _extends({
    label: "FormSet vertical",
    stretch: true
  }, props))))), React.createElement(Box, null, React.createElement(FormRow, {
    direction: "horizontal"
  }, React.createElement(Comp, _extends({
    label: "FormRow direction=\"horizontal\"",
    stretch: true
  }, props)))), React.createElement(Box, null, React.createElement(Comp, _extends({
    label: "label_direction=\"vertical\"",
    label_direction: "vertical",
    stretch: true
  }, props))));
}

var _ref = React.createElement(Wrapper, null, React.createElement(StretchTemplate, {
  element: Input
}), React.createElement(StretchTemplate, {
  element: Textarea
}), React.createElement(StretchTemplate, {
  element: Autocomplete
}), React.createElement(StretchTemplate, {
  element: DatePicker,
  show_input: true
}), React.createElement(StretchTemplate, {
  element: Dropdown
}), React.createElement(StretchTemplate, {
  element: Slider
}));

export const Box = styled(Space)`
  position: relative;

  margin: 0;
  padding: 1rem;

  @media screen and (min-width: 40em) {
    padding: 1rem;
  }

  &::after {
    content: '';
    position: absolute;
    left: -50vw;
    right: -50vw;
    bottom: -1px;
    width: 200vw;
    border-bottom: dashed 1px rgb(0, 200, 200);
  }
`;
const Wrapper = styled.div`
  display: block;
`;