import * as React from 'react';
export type FormRowLabel =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type FormRowLabelDirection = 'vertical' | 'horizontal';
export type FormRowLabelSrOnly = string | boolean;
export type FormRowNoLabel = string | boolean;
export type FormRowNoFieldset = string | boolean;
export type FormRowIndent = string | boolean;
export type FormRowWrap = string | boolean;
export type FormRowDirection = 'vertical' | 'horizontal';
export type FormRowVertical = string | boolean;
export type FormRowCentered = string | boolean;
export type FormRowSectionSpacing = string | boolean;
export type FormRowResponsive = string | boolean;
export type FormRowDisabled = string | boolean;
export type FormRowSkeleton = string | boolean;
export type FormRowSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type FormRowTop = string | number | boolean;
export type FormRowRight = string | number | boolean;
export type FormRowBottom = string | number | boolean;
export type FormRowLeft = string | number | boolean;
export type FormRowChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface FormRowProps extends React.HTMLProps<HTMLElement> {
  id?: string;
  label?: FormRowLabel;
  label_direction?: FormRowLabelDirection;
  label_sr_only?: FormRowLabelSrOnly;
  label_id?: string;
  label_class?: string;
  no_label?: FormRowNoLabel;
  no_fieldset?: FormRowNoFieldset;
  indent?: FormRowIndent;
  wrap?: FormRowWrap;
  direction?: FormRowDirection;
  vertical?: FormRowVertical;
  centered?: FormRowCentered;
  indent_offset?: string;
  section_style?: string;
  section_spacing?: FormRowSectionSpacing;
  global_status_id?: string;
  responsive?: FormRowResponsive;
  disabled?: FormRowDisabled;
  skeleton?: FormRowSkeleton;
  class?: string;
  skipContentWrapperIfNested?: boolean;
  space?: FormRowSpace;
  top?: FormRowTop;
  right?: FormRowRight;
  bottom?: FormRowBottom;
  left?: FormRowLeft;
  className?: string;
  children?: FormRowChildren;
  custom_element?: Object;
  custom_method?: (...args: any[]) => any;
}
export default class FormRow extends React.Component<FormRowProps, any> {
  static defaultProps: object;
  render(): JSX.Element;
}
