import * as React from 'react';
export type FormStatusText =
  | string
  | boolean
  | ((...args: any[]) => any)
  | React.ReactNode;
export type FormStatusIcon =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type FormStatusState = boolean | string | 'error' | 'warn' | 'info';
export type FormStatusVariant = 'flat' | 'outlined';
export type FormStatusSize = 'default' | 'large';
export type FormStatusStatus =
  | boolean
  | string
  | 'error'
  | 'warn'
  | 'info';
export type FormStatusHidden = string | boolean;
export type FormStatusSkeleton = string | boolean;
export type FormStatusSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type FormStatusTop = string | number | boolean;
export type FormStatusRight = string | number | boolean;
export type FormStatusBottom = string | number | boolean;
export type FormStatusLeft = string | number | boolean;
export type FormStatusChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface FormStatusProps extends React.HTMLProps<HTMLElement> {
  id?: string;
  title?: string;
  text?: FormStatusText;
  label?: React.ReactNode;
  icon?: FormStatusIcon;
  icon_size?: string;
  state?: FormStatusState;
  variant?: FormStatusVariant;
  size?: FormStatusSize;
  status?: FormStatusStatus;
  global_status_id?: string;
  hidden?: FormStatusHidden;
  text_id?: string;
  width_selector?: string;
  width_element?: Object;
  class?: string;
  animation?: string;
  skeleton?: FormStatusSkeleton;
  space?: FormStatusSpace;
  top?: FormStatusTop;
  right?: FormStatusRight;
  bottom?: FormStatusBottom;
  left?: FormStatusLeft;
  className?: string;
  children?: FormStatusChildren;
}
export default class FormStatus extends React.Component<
  FormStatusProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ErrorIconProps {
  title?: string;
}
export const ErrorIcon: React.FC<ErrorIconProps>;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface WarnIconProps {
  title?: string;
}
export const WarnIcon: React.FC<WarnIconProps>;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface InfoIconProps {
  title?: string;
}
export const InfoIcon: React.FC<InfoIconProps>;
