import * as React from 'react';
export type GlobalErrorStatusContent = string | Object;
export type GlobalErrorTitle = string | React.ReactNode;
export type GlobalErrorText = string | React.ReactNode;
export type GlobalErrorBack = string | React.ReactNode;
export type GlobalErrorSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type GlobalErrorTop = string | number | boolean;
export type GlobalErrorRight = string | number | boolean;
export type GlobalErrorBottom = string | number | boolean;
export type GlobalErrorLeft = string | number | boolean;
export type GlobalErrorChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface GlobalErrorProps extends React.HTMLProps<HTMLElement> {
  status?: string;
  status_content?: GlobalErrorStatusContent;
  title?: GlobalErrorTitle;
  text?: GlobalErrorText;
  back?: GlobalErrorBack;
  href?: string;
  alt?: string;
  space?: GlobalErrorSpace;
  top?: GlobalErrorTop;
  right?: GlobalErrorRight;
  bottom?: GlobalErrorBottom;
  left?: GlobalErrorLeft;
  className?: string;
  children?: GlobalErrorChildren;
  class?: string;
}
export default class GlobalError extends React.Component<
  GlobalErrorProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
