import * as React from 'react';
export type HelpButtonText = string | React.ReactNode;
export type HelpButtonSize = 'default' | 'small' | 'medium' | 'large';
export type HelpButtonIconSize = string | number;
export type HelpButtonTooltip =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type HelpButtonStatus =
  | string
  | boolean
  | ((...args: any[]) => any)
  | React.ReactNode;
export type HelpButtonWrap = string | boolean;
export type HelpButtonBounding = string | boolean;
export type HelpButtonSkeleton = string | boolean;
export type HelpButtonDisabled = string | boolean;
export type HelpButtonChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type HelpButtonSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type HelpButtonTop = string | number | boolean;
export type HelpButtonRight = string | number | boolean;
export type HelpButtonBottom = string | number | boolean;
export type HelpButtonLeft = string | number | boolean;
export type HelpButtonOnClick = string | ((...args: any[]) => any);
export type HelpButtonIcon =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type HelpButtonIconPosition = 'left' | 'right';

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface HelpButtonProps extends React.HTMLProps<HTMLElement> {
  text?: HelpButtonText;
  type?: string;
  title?: string;
  variant?: any;
  size?: HelpButtonSize;
  icon_size?: HelpButtonIconSize;
  tooltip?: HelpButtonTooltip;
  status?: HelpButtonStatus;
  status_state?: string;
  status_animation?: string;
  global_status_id?: string;
  id?: string;
  class?: string;
  href?: string;
  wrap?: HelpButtonWrap;
  bounding?: HelpButtonBounding;
  skeleton?: HelpButtonSkeleton;
  disabled?: HelpButtonDisabled;
  inner_ref?: Object;
  className?: string;
  innerRef?: Object;
  children?: HelpButtonChildren;
  element?: React.ReactNode;
  space?: HelpButtonSpace;
  top?: HelpButtonTop;
  right?: HelpButtonRight;
  bottom?: HelpButtonBottom;
  left?: HelpButtonLeft;
  custom_element?: Object;
  custom_method?: (...args: any[]) => any;
  onClick?: (...args: any[]) => any;
  on_click?: HelpButtonOnClick;
  icon?: HelpButtonIcon;
  icon_position?: HelpButtonIconPosition;
  modal_content?: React.ReactNode;
  modal_props?: Object;
}
export default class HelpButton extends React.Component<
  HelpButtonProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
