import * as React from 'react';
export type HelpButtonInstanceVariant =
  | 'primary'
  | 'secondary'
  | 'tertiary'
  | 'signal';
export type HelpButtonInstanceIcon =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type HelpButtonInstanceIconPosition = 'left' | 'right';
export type HelpButtonInstanceSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type HelpButtonInstanceTop = string | number | boolean;
export type HelpButtonInstanceRight = string | number | boolean;
export type HelpButtonInstanceBottom = string | number | boolean;
export type HelpButtonInstanceLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface HelpButtonInstanceProps
  extends React.HTMLProps<HTMLElement> {
  id?: string;
  variant?: HelpButtonInstanceVariant;
  icon?: HelpButtonInstanceIcon;
  icon_position?: HelpButtonInstanceIconPosition;
  space?: HelpButtonInstanceSpace;
  top?: HelpButtonInstanceTop;
  right?: HelpButtonInstanceRight;
  bottom?: HelpButtonInstanceBottom;
  left?: HelpButtonInstanceLeft;
  className?: string;
  class?: string;
}
export default class HelpButtonInstance extends React.Component<
  HelpButtonInstanceProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
