import * as React from 'react';
export type IconPrimaryIcon =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type IconPrimarySize =
  | number
  | string
  | 'default'
  | 'medium'
  | 'large';
export type IconPrimarySpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type IconPrimaryTop = string | number | boolean;
export type IconPrimaryRight = string | number | boolean;
export type IconPrimaryBottom = string | number | boolean;
export type IconPrimaryLeft = string | number | boolean;
export type IconPrimaryWidth = string | number;
export type IconPrimaryHeight = string | number;
export type IconPrimaryBorder = string | boolean;
export type IconPrimaryInheritColor = string | boolean;
export type IconPrimarySkeleton = string | boolean;
export type IconPrimaryAttributes = string | Object;
export type IconPrimaryChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface IconPrimaryProps extends React.HTMLProps<HTMLElement> {
  icon?: IconPrimaryIcon;
  modifier?: string;
  size?: IconPrimarySize;
  space?: IconPrimarySpace;
  top?: IconPrimaryTop;
  right?: IconPrimaryRight;
  bottom?: IconPrimaryBottom;
  left?: IconPrimaryLeft;
  width?: IconPrimaryWidth;
  height?: IconPrimaryHeight;
  border?: IconPrimaryBorder;
  color?: string;
  inherit_color?: IconPrimaryInheritColor;
  alt?: string;
  title?: string;
  skeleton?: IconPrimarySkeleton;
  attributes?: IconPrimaryAttributes;
  className?: string;
  children?: IconPrimaryChildren;
}
export default class IconPrimary extends React.Component<
  IconPrimaryProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
