import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import Context from '../../shared/Context';
import { extendPropsWithContext } from '../../shared/component-helper';
import DefaultIcon, { iconPropTypes, DefaultIconSize, prerenderIcon, prepareIcon } from '../icon/Icon';
import * as primary_icons from '../../icons/primary_icons.js';
import * as primary_icons_medium from '../../icons/primary_icons_medium.js';

const icons = _extends({}, primary_icons, primary_icons_medium);

export { DefaultIconSize };
export default class IconPrimary extends React.PureComponent {
  static enableWebComponent() {
    DefaultIcon.enableWebComponent(IconPrimary.tagName, IconPrimary);
  }

  static getIcon(props) {
    return DefaultIcon.getIcon(props);
  }

  render() {
    var _this$context;

    const props = extendPropsWithContext(this.props, IconPrimary.defaultProps, {
      skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
    }, this.context.FormRow, this.context.Icon, this.context.IconPrimary);
    const {
      icon,
      size,
      wrapperParams,
      iconParams,
      alt
    } = prepareIcon(props, this.context);
    const IconContainer = prerenderIcon({
      icon,
      size,
      alt,
      listOfIcons: icons
    });
    if (!IconContainer) return React.createElement(React.Fragment, null);
    return React.createElement("span", wrapperParams, React.createElement(IconContainer, iconParams));
  }

}
IconPrimary.tagName = 'dnb-icon-primary';
IconPrimary.contextType = Context;
IconPrimary.defaultProps = _extends({}, DefaultIcon.defaultProps);
process.env.NODE_ENV !== "production" ? IconPrimary.propTypes = _extends({}, iconPropTypes) : void 0;