import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';

var _ref = React.createElement("span", {
  className: "dnb-line-title__mask",
  "aria-hidden": "true"
});

var _ref2 = React.createElement("span", {
  className: "dnb-line-title__line",
  "aria-hidden": "true"
});

export default class LineTitle extends React.PureComponent {
  static enableWebComponent() {
    registerElement(LineTitle.tagName, LineTitle, LineTitle.defaultProps);
  }

  static getContent(props) {
    if (typeof props.content === 'string') {
      return props.content;
    }

    return processChildren(props);
  }

  render() {
    const {
      tag,
      modifier,
      className,
      class: _className
    } = this.props;
    const content = LineTitle.getContent(this.props);
    const params = {
      className: classnames('dnb-line-title', className, _className, modifier && `dnb-line-title--${modifier}`)
    };
    validateDOMAttributes(this.props, params);
    const Tag = `${tag}`;
    return React.createElement(Tag, params, React.createElement("span", {
      className: "dnb-line-title__title dnb-typo-light"
    }, _ref, React.createElement("span", {
      className: "dnb-line-title__text"
    }, content)), _ref2);
  }

}
LineTitle.tagName = 'dnb-line-title';
LineTitle.defaultProps = {
  content: null,
  modifier: null,
  tag: 'h2',
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? LineTitle.propTypes = {
  content: PropTypes.string,
  modifier: PropTypes.string,
  tag: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;