import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes } from '../../shared/component-helper';
import Icon from '../../components/icon-primary/IconPrimary';

var _ref = React.createElement("span", {
  className: "dnb-notification__icon"
}, React.createElement(Icon, {
  className: "dnb-notification__icon",
  icon: "bell"
}));

export default class Notification extends React.PureComponent {
  static enableWebComponent() {
    registerElement(Notification.tagName, Notification, Notification.defaultProps);
  }

  render() {
    const {
      notification_amount,
      title_text,
      className,
      class: _className
    } = this.props;
    const params = {
      className: classnames('dnb-notification', className, _className, notification_amount > 0 && 'dnb-notification--has-notification')
    };
    const buttonParams = {
      title: title_text.replace(/{amount}/, notification_amount)
    };
    validateDOMAttributes(this.props, params);
    return React.createElement("div", params, React.createElement("button", _extends({
      type: "button",
      className: "dnb-notification__button"
    }, buttonParams), React.createElement("span", {
      className: "dnb-notification__inner"
    }, _ref, notification_amount > 0 && React.createElement("span", {
      className: "dnb-notification__amount"
    }, React.createElement("span", {
      className: "dnb-notification__amount__inner"
    }, notification_amount)))));
  }

}
Notification.tagName = 'dnb-notification';
Notification.defaultProps = {
  notification_amount: 0,
  title_text: null,
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Notification.propTypes = {
  notification_amount: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  title_text: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;