import * as React from 'react';
export type PaginationBarChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface PaginationBarProps extends React.HTMLProps<HTMLElement> {
  /**
   * The title used in every button shown in the bar. Defaults to `Side %s`.
   */
  button_title?: string;

  /**
   * The title used in the previous page button. Defaults to `Forrige side`.
   */
  prev_title?: string;

  /**
   * The title used in the next page button. Defaults to `Neste side`.
   */
  next_title?: string;

  /**
   * The title used in the dots. Relevant for screen-readers. Defaults to `%s flere sider`.
   */
  more_pages?: string;
  contentRef?: Object;

  /**
   * The given content can be either a function or a React node, depending on your needs. A function contains several helper functions. More details down below and have a look at the examples in the demos section.
   */
  children?: PaginationBarChildren;
}
export default class PaginationBar extends React.Component<
  PaginationBarProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
