import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import ProgressIndicator from '../progress-indicator/ProgressIndicator';

var _ref = React.createElement(ProgressIndicator, null);

export class PaginationIndicator extends React.PureComponent {
  render() {
    const {
      indicator_element
    } = this.props;
    const Element = preparePageElement(indicator_element);
    const ElementChild = isTrElement(Element) ? 'td' : 'div';
    return React.createElement(Element, null, React.createElement(ElementChild, {
      className: "dnb-pagination__indicator"
    }, React.createElement("div", {
      className: "dnb-pagination__indicator__inner"
    }, _ref, this.context.getTranslation(this.props).Pagination.is_loading_text)));
  }

}
PaginationIndicator.contextType = Context;
PaginationIndicator.defaultProps = {
  indicator_element: 'div'
};
process.env.NODE_ENV !== "production" ? PaginationIndicator.propTypes = {
  indicator_element: PropTypes.oneOfType([PropTypes.object, PropTypes.node, PropTypes.func, PropTypes.string])
} : void 0;
export class ContentObject {
  constructor(_ref2) {
    let {
      pageNo
    } = _ref2,
        props = _objectWithoutPropertiesLoose(_ref2, ["pageNo"]);

    this.content = null;
    this.pageNo = pageNo;
    this.hasContent = false;

    for (let k in props) {
      this[k] = props[k];
    }
  }

  insert(content) {
    this.hasContent = true;
    this.content = content;

    if (typeof this.onInsert === 'function') {
      this.onInsert(this);
    }

    return this;
  }

  update(content) {
    this.hasContent = true;
    this.content = content;

    if (typeof this.onUpdate === 'function') {
      this.onUpdate(this);
    }

    return this;
  }

}
export function isTrElement(Element) {
  let isTr = false;

  if (Element === 'tr') {
    isTr = true;
  } else if (Element && (typeof Element === 'object' || React.isValidElement(Element))) {
    if ((Element.__emotion_base || Element.target) === 'tr') {
      isTr = true;
    }
  }

  return isTr;
}
export function preparePageElement(Element, includeClassName = 'dnb-pagination__page') {
  if (String(Element) === 'Symbol(react.fragment)') {
    return Element;
  }

  if (includeClassName) {
    const isTr = isTrElement(Element);
    return React.forwardRef((_ref3, ref) => {
      let {
        className,
        children
      } = _ref3,
          props = _objectWithoutPropertiesLoose(_ref3, ["className", "children"]);

      const params = _extends({}, props, {
        className: classnames(includeClassName, className),
        ref
      });

      return isTr ? React.createElement("td", null, React.createElement("div", params, children)) : React.createElement(Element, params, children);
    });
  }

  return Element;
}