import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import { convertJsxToString, isTrue } from '../../shared/component-helper';
import classnames from 'classnames';
import { IS_IE11 } from '../../shared/helpers';
export const skeletonDOMAttributes = (params, skeleton, context = null) => {
  if (isTrue(skeleton) || context !== null && context !== void 0 && context.skeleton) {
    var _context$translation, _context$translation$;

    params.disabled = true;
    params['aria-disabled'] = true;
    params['aria-label'] = context === null || context === void 0 ? void 0 : (_context$translation = context.translation) === null || _context$translation === void 0 ? void 0 : (_context$translation$ = _context$translation.Skeleton) === null || _context$translation$ === void 0 ? void 0 : _context$translation$.aria_bussy;
  }

  return params;
};
export const createSkeletonClass = (method, skeleton, context = null) => {
  if (isTrue(skeleton) || context !== null && context !== void 0 && context.skeleton) {
    return 'dnb-skeleton' + (method ? ` dnb-skeleton--${method}` : "");
  }

  return null;
};
export class AutoSize extends React.PureComponent {
  render() {
    const _this$props = this.props,
          {
      className,
      children,
      __element: Comp,
      style
    } = _this$props,
          props = _objectWithoutPropertiesLoose(_this$props, ["className", "children", "__element", "style"]);

    const string = convertJsxToString(children);

    if (typeof string === 'string') {
      const countChars = string.trim().length;

      if (countChars > 0) {
        return React.createElement(Comp, _extends({
          className: classnames("dnb-skeleton dnb-skeleton--font", className),
          'data-skeleton-chars': String(countChars),
          style: _extends({}, style || {}, {
            [IS_IE11 ? 'maxWidth' : '--skeleton-chars']: `${countChars}ch`
          })
        }, props), children);
      }
    }

    return React.createElement(Comp, _extends({}, props, {
      className: className,
      style: style
    }));
  }

}
AutoSize.defaultProps = {
  __element: null,
  children: null,
  className: null,
  style: null
};
process.env.NODE_ENV !== "production" ? AutoSize.propTypes = {
  __element: PropTypes.node,
  children: PropTypes.node,
  className: PropTypes.string,
  style: PropTypes.object
} : void 0;