import * as React from 'react';
export type StepItemHideNumbers = string | boolean;
export type StepItemUseNavigation = string | boolean;
export type StepItemIsActive = string | boolean;
export type StepItemIsCurrent = string | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface StepItemProps extends React.HTMLProps<HTMLElement> {
  title: string;
  step_title?: string;
  activeItem?: number;
  currentItem: number;
  hide_numbers?: StepItemHideNumbers;
  use_navigation?: StepItemUseNavigation;
  on_item_render?: (...args: any[]) => any;
  on_render?: (...args: any[]) => any;
  on_click?: (...args: any[]) => any;
  on_change?: (...args: any[]) => any;
  setActimeItem?: (...args: any[]) => any;
  hasReached?: any[];
  countSteps?: number;
  is_active?: StepItemIsActive;
  is_current?: StepItemIsCurrent;
  url?: string;
  url_future?: string;
  url_passed?: string;
}
export default class StepItem extends React.Component<StepItemProps, any> {
  render(): JSX.Element;
}
