import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { validateDOMAttributes } from '../../shared/component-helper';
import { createSpacingClasses } from '../space/SpacingHelper';
export default class ContentWrapper extends React.PureComponent {
  render() {
    const _this$props = this.props,
          {
      id,
      children,
      selected_key: key
    } = _this$props,
          rest = _objectWithoutPropertiesLoose(_this$props, ["id", "children", "selected_key"]);

    if (!children) {
      return React.createElement(React.Fragment, null);
    }

    const params = rest;

    if (key) {
      params['aria-labelledby'] = `${id}-tab-${key}`;
    }

    validateDOMAttributes(this.props, params);
    return React.createElement("div", _extends({
      role: "tabpanel",
      tabIndex: "0",
      id: `${id}-content`,
      className: classnames('dnb-tabs__content dnb-no-focus', createSpacingClasses(rest))
    }, params), children);
  }

}
ContentWrapper.defaultProps = {
  selected_key: null
};
process.env.NODE_ENV !== "production" ? ContentWrapper.propTypes = {
  id: PropTypes.string.isRequired,
  selected_key: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  children: PropTypes.node.isRequired
} : void 0;