import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
export default class CustomContent extends React.PureComponent {
  render() {
    const _this$props = this.props,
          {
      children,
      className,
      class: _className
    } = _this$props,
          rest = _objectWithoutPropertiesLoose(_this$props, ["children", "displayName", "title", "hash", "selected", "disabled", "className", "class"]);

    return React.createElement("div", {
      className: classnames('dnb-tabs__content__inner', createSpacingClasses(rest), className, _className)
    }, children);
  }

}
CustomContent.defaultProps = {
  displayName: 'CustomContent',
  title: null,
  hash: null,
  selected: null,
  disabled: null,
  className: null,
  class: null
};
process.env.NODE_ENV !== "production" ? CustomContent.propTypes = _extends({
  displayName: PropTypes.string,
  title: PropTypes.oneOfType([PropTypes.object, PropTypes.node, PropTypes.func]),
  hash: PropTypes.string,
  selected: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  class: PropTypes.string
}) : void 0;