import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';
const Anchor = React.forwardRef((_ref, ref) => {
  let props = _extends({}, _ref);

  if (props.target === '_blank' && typeof props.children !== 'string') {
    props.className = classnames(props.className, 'dnb-anchor--no-icon');
  }

  return React.createElement(E, _extends({
    ref: ref,
    is: "a",
    class: "dnb-anchor",
    className: props.className
  }, props));
});
process.env.NODE_ENV !== "production" ? Anchor.propTypes = _extends({}, spacingPropTypes, {
  href: PropTypes.string,
  target: PropTypes.string,
  className: PropTypes.oneOfType([PropTypes.string, PropTypes.object, PropTypes.array]),
  children: PropTypes.node
}) : void 0;
Anchor.defaultProps = {
  href: null,
  target: null,
  className: null,
  children: null
};
Anchor.tagName = 'dnb-anchor';
export default Anchor;