import * as React from 'react';
export type ElementSkeleton = string | boolean;
export type ElementSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type ElementTop = string | number | boolean;
export type ElementRight = string | number | boolean;
export type ElementBottom = string | number | boolean;
export type ElementLeft = string | number | boolean;
export type ElementClassName = string | Object | any[];
export type ElementCss = string | Object;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ElementProps extends React.HTMLProps<HTMLElement> {
  is: string;
  skeleton?: ElementSkeleton;
  skeleton_method?: string;
  space?: ElementSpace;
  top?: ElementTop;
  right?: ElementRight;
  bottom?: ElementBottom;
  left?: ElementLeft;
  className?: ElementClassName;
  class?: string;
  internalClass?: string;
  css?: ElementCss;
  _ref?: Object;
  children?: React.ReactNode;
}
declare const Element: React.FC<ElementProps>;
export default Element;
