import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';
import { setNextLevel } from '../components/heading/HeadingHelpers';
export default class H extends React.PureComponent {
  constructor(props) {
    super(props);

    if (props.level === 'use') {
      setNextLevel(parseFloat(props.is.substr(1)));
    }
  }

  render() {
    let _this$props = this.props,
        {
      is,
      style_type,
      size,
      className
    } = _this$props,
        props = _objectWithoutPropertiesLoose(_this$props, ["is", "level", "style_type", "size", "className"]);

    if (style_type) {
      size = style_type;
    }

    return React.createElement(E, _extends({
      is: is,
      internalClass: classnames(className, size && `dnb-h--${size}`)
    }, props));
  }

}
H.defaultProps = {
  className: null,
  level: null,
  is: 'h1',
  size: 'xx-large',
  style_type: null,
  children: null
};
process.env.NODE_ENV !== "production" ? H.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string,
  is: PropTypes.string,
  level: PropTypes.string,
  size: PropTypes.oneOf(['xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  style_type: PropTypes.string,
  children: PropTypes.node
}) : void 0;