import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';
import Ul from './Ul';
import Ol from './Ol';

const Li = (_ref = {}) => {
  let {
    className
  } = _ref,
      p = _objectWithoutPropertiesLoose(_ref, ["className"]);

  if (Array.isArray(p.children)) {
    p.children.forEach(Comp => {
      if (Comp && (Comp.type === Ul || Comp.type === Ol)) {
        className = classnames(className, 'is-nested');
      }
    });
  }

  return React.createElement(E, _extends({
    is: "li"
  }, p, {
    className: className
  }));
};

Li.tagName = 'dnb-li';
process.env.NODE_ENV !== "production" ? Li.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string
}) : void 0;
Li.defaultProps = {
  className: null
};
export default Li;