import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Ol = (_ref = {}) => {
  let {
    nested,
    inside,
    outside
  } = _ref,
      p = _objectWithoutPropertiesLoose(_ref, ["nested", "inside", "outside"]);

  if (nested) {
    p.className = classnames(p.className, 'dnb-ol--nested');
  }

  if (inside) {
    p.className = classnames(p.className, 'dnb-ol--inside');
  }

  if (outside) {
    p.className = classnames(p.className, 'dnb-ol--outside');
  }

  return React.createElement(E, _extends({
    is: "ol"
  }, p, {
    skeleton: false
  }));
};

Ol.tagName = 'dnb-ol';
process.env.NODE_ENV !== "production" ? Ol.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string,
  inside: PropTypes.bool,
  outside: PropTypes.bool,
  nested: PropTypes.bool
}) : void 0;
Ol.defaultProps = {
  className: null,
  inside: null,
  outside: null,
  nested: null
};
export default Ol;