import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const P = (_ref) => {
  let {
    style_type,
    modifier,
    element,
    className,
    small,
    medium,
    bold,
    size
  } = _ref,
      props = _objectWithoutPropertiesLoose(_ref, ["style_type", "modifier", "element", "className", "small", "medium", "bold", "size"]);

  if (typeof modifier === 'string' && / /.test(modifier)) {
    modifier = modifier.split(/ /g);
  } else if (!Array.isArray(modifier)) {
    modifier = [modifier];
  }

  if (style_type) {
    modifier.push(style_type);
  }

  if (medium === true) {
    modifier.push('medium');
  } else if (bold === true) {
    modifier.push('bold');
  }

  modifier = modifier.filter(Boolean).reduce((acc, cur) => {
    if (['x-small', 'small'].includes(cur)) {
      return `${acc} dnb-p__size--${cur}`;
    }

    return `${acc} dnb-p--${cur}`;
  }, '');

  if (size) {
    className = classnames(className, `dnb-p__size--${size}`);
  } else if (small === true) {
    className = classnames(className, 'dnb-p__size--small');
  }

  return React.createElement(E, _extends({
    is: element
  }, props, {
    className: classnames('dnb-p', modifier, className)
  }));
};

P.tagName = 'dnb-p';
process.env.NODE_ENV !== "production" ? P.propTypes = _extends({}, spacingPropTypes, {
  element: PropTypes.node,
  className: PropTypes.string,
  small: PropTypes.bool,
  medium: PropTypes.bool,
  bold: PropTypes.bool,
  size: PropTypes.oneOf(['x-small', 'small', 'basis', 'medium', 'large', 'x-large', 'xx-large']),
  style_type: PropTypes.string,
  modifier: PropTypes.string,
  children: PropTypes.node
}) : void 0;
P.defaultProps = {
  element: 'p',
  className: null,
  small: null,
  medium: null,
  bold: null,
  size: null,
  style_type: null,
  modifier: null,
  children: null
};
export default P;