import * as React from 'react';
export type ThSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type ThTop = string | number | boolean;
export type ThRight = string | number | boolean;
export type ThBottom = string | number | boolean;
export type ThLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ThProps extends React.HTMLProps<HTMLElement> {
  space?: ThSpace;
  top?: ThTop;
  right?: ThRight;
  bottom?: ThBottom;
  left?: ThLeft;
  children?: React.ReactNode;
}
declare const Th: React.FC<ThProps>;
export default Th;
