import * as React from 'react';
export type TrSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type TrTop = string | number | boolean;
export type TrRight = string | number | boolean;
export type TrBottom = string | number | boolean;
export type TrLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface TrProps extends React.HTMLProps<HTMLElement> {
  space?: TrSpace;
  top?: TrTop;
  right?: TrRight;
  bottom?: TrBottom;
  left?: TrLeft;
  children?: React.ReactNode;
}
declare const Tr: React.FC<TrProps>;
export default Tr;
