import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Ul = (_ref = {}) => {
  let {
    nested,
    inside,
    outside
  } = _ref,
      p = _objectWithoutPropertiesLoose(_ref, ["nested", "inside", "outside"]);

  if (nested) {
    p.className = classnames(p.className, 'dnb-ul--nested');
  }

  if (inside) {
    p.className = classnames(p.className, 'dnb-ul--inside');
  }

  if (outside) {
    p.className = classnames(p.className, 'dnb-ul--outside');
  }

  return React.createElement(E, _extends({
    is: "ul"
  }, p, {
    skeleton: false
  }));
};

Ul.tagName = 'dnb-ul';
process.env.NODE_ENV !== "production" ? Ul.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string,
  inside: PropTypes.bool,
  outside: PropTypes.bool,
  nested: PropTypes.bool,
  children: PropTypes.node
}) : void 0;
Ul.defaultProps = {
  className: null,
  inside: null,
  outside: null,
  nested: null,
  children: null
};
export default Ul;