import { registerElement } from '../shared/component-helper';
import DrawerList from './drawer-list/DrawerList';
import ScrollView from './scroll-view/ScrollView';
export { DrawerList, ScrollView };
export const getFragments = () => {
  return {
    DrawerList,
    ScrollView
  };
};
let webFragmentsAreEnabled = false;
export const enableWebFragments = () => {
  if (webFragmentsAreEnabled) return false;
  webFragmentsAreEnabled = true;
  const fragments = getFragments();

  for (const c in fragments) {
    if (fragments[c] && fragments[c].tagName) {
      registerElement(fragments[c].tagName, fragments[c], fragments[c].defaultProps);
    }
  }
};
export default {
  enableWebFragments
};