import React from 'react';
import PropTypes from 'prop-types';
import { registerElement, validateDOMAttributes } from '../../shared/component-helper';
export default class FieldsetDescription extends React.PureComponent {
  static enableWebComponent() {
    registerElement(FieldsetDescription.tagName, FieldsetDescription, FieldsetDescription.defaultProps);
  }

  render() {
    const {
      text,
      className,
      class: _className
    } = this.props;
    const params = {
      className: `dnb-fieldset-description ${className || _className || ''}`
    };
    validateDOMAttributes(this.props, params);
    return React.createElement("div", params, React.createElement("p", {
      className: "dnb-fieldset-description__text"
    }, text));
  }

}
FieldsetDescription.tagName = 'dnb-fieldset-description';
FieldsetDescription.defaultProps = {
  text: null,
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? FieldsetDescription.propTypes = {
  text: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;