import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes } from '../../shared/component-helper';
export default class Form extends React.PureComponent {
  static enableWebComponent() {
    registerElement(Form.tagName, Form, Form.defaultProps);
  }

  constructor(props) {
    super(props);
    this.state = {
      value: null
    };
    this.state.value = props.range_val;
  }

  render() {
    const {
      children,
      className,
      class: _className
    } = this.props;
    const params = {
      className: classnames('dnb-form', className, _className)
    };
    validateDOMAttributes(this.props, params);
    return React.createElement("form", params, children);
  }

}
Form.tagName = 'dnb-form';
Form.defaultProps = {
  class: null,
  range_val: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Form.propTypes = {
  class: PropTypes.string,
  range_val: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
} : void 0;