import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';
export default class Grid extends React.PureComponent {
  static enableWebComponent() {
    registerElement(Grid.tagName, Grid, Grid.defaultProps);
  }

  static getContent(props) {
    return processChildren(props);
  }

  render() {
    const {
      className,
      class: _className
    } = this.props;
    const content = Grid.getContent(this.props);
    const params = {
      className: classnames('dnb-grid', className, _className)
    };
    validateDOMAttributes(this.props, params);
    return React.createElement("div", params, content);
  }

}
Grid.tagName = 'dnb-grid';
Grid.defaultProps = {
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Grid.propTypes = {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;