import { registerElement } from '../shared/component-helper';
import ActionNav from './action-nav/ActionNav';
import DescriptionList from './description-list/DescriptionList';
import FieldsetDescription from './fieldset-description/FieldsetDescription';
import Footer from './footer/Footer';
import Form from './form/Form';
import FormSummary from './form-summary/FormSummary';
import Grid from './grid/Grid';
import MainNav from './main-nav/MainNav';
import PaymentCard from './payment-card/PaymentCard';
import RangeSlider from './range-slider/RangeSlider';
import SummaryTable from './summary-table/SummaryTable';
import ViewTitle from './view-title/ViewTitle';
export { ActionNav, DescriptionList, FieldsetDescription, Footer, Form, FormSummary, Grid, MainNav, PaymentCard, RangeSlider, SummaryTable, ViewTitle };
export const getPatterns = () => {
  return {
    ActionNav,
    DescriptionList,
    FieldsetDescription,
    Footer,
    Form,
    FormSummary,
    Grid,
    MainNav,
    PaymentCard,
    RangeSlider,
    SummaryTable,
    ViewTitle
  };
};
let webComponentsAreEnabled = false;
export const enableWebComponents = () => {
  if (webComponentsAreEnabled) return false;
  webComponentsAreEnabled = true;
  const components = getPatterns();

  for (const c in components) {
    if (components[c] && components[c].tagName) {
      registerElement(components[c].tagName, components[c], components[c].defaultProps);
    }
  }
};