import React from 'react';
import BankAxept from './BankAxept';
import DNB from './DNB';
import DNBMetalic from './DNBMetalic';
import Expired from './Clock';
import Blocked from './Padlock';
import MastercardDefault from './MastercardDefault';
import MastercardMetalic from './MastercardMetalic';
import MastercardMetalicBlack from './MastercardMetalicBlack';
import Pluss from './Pluss';
import PB from './PB';
import PBPlatinum from './PBPlatinum';
import SagaGold from './SagaGold';
import SagaPlatinum from './SagaPlatinum';
import SagaVisaPlatinum from './SagaVisaPlatinum';
import VisaDefault from './VisaDefault';
import VisaMetalic from './VisaMetalic';

const BankLogo = ({
  logoType,
  height
}) => logoType.cata({
  Colored: color => React.createElement(DNB, {
    height: height,
    fill: color,
    className: "dnb-payment-card__card__bank-logo"
  }),
  Metalic: () => React.createElement(DNBMetalic, {
    height: height,
    className: "dnb-payment-card__card__bank-logo"
  })
});

const ProductLogo = ({
  productType,
  cardDesign
}) => {
  const id = 'dnb-payment-card__card__product-type';

  var _ref = React.createElement(BankAxept, {
    className: id,
    fill: "#ffffff"
  });

  var _ref2 = React.createElement(BankAxept, {
    className: id,
    fill: "#757575"
  });

  var _ref3 = React.createElement(SagaGold, {
    className: id
  });

  var _ref4 = React.createElement(SagaPlatinum, {
    className: id
  });

  var _ref5 = React.createElement(SagaVisaPlatinum, {
    className: id
  });

  var _ref6 = React.createElement(Pluss, {
    className: id,
    fill: "#A5E1D2"
  });

  var _ref7 = React.createElement(PB, {
    className: id
  });

  var _ref8 = React.createElement(PBPlatinum, {
    className: id
  });

  return productType.cata({
    BankAxept: () => cardDesign.bankAxept.cata({
      White: () => _ref,
      Black: () => _ref2
    }),
    Saga: () => cardDesign.saga.cata({
      Gold: () => _ref3,
      Platinum: () => _ref4,
      VisaPlatinum: () => _ref5,
      None: () => null
    }),
    Pluss: () => _ref6,
    PrivateBanking: () => cardDesign.privateBanking.cata({
      Default: () => _ref7,
      Platinum: () => _ref8,
      None: () => null
    }),
    None: () => null
  });
};

var _ref9 = React.createElement(Expired, null);

var _ref10 = React.createElement(Blocked, null);

const StatusIcon = ({
  status
}) => {
  switch (status) {
    case 'expired':
      return _ref9;

    case 'blocked':
      return _ref10;

    case 'active':
    default:
      return null;
  }
};

const TypeLogo = ({
  cardType,
  cardDesign
}) => {
  const id = 'dnb-payment-card__card__credit-type';

  var _ref11 = React.createElement(VisaMetalic, {
    className: id
  });

  var _ref12 = React.createElement(MastercardDefault, {
    className: id
  });

  var _ref13 = React.createElement(MastercardDefault, {
    className: id,
    textFill: "#ffffff"
  });

  var _ref14 = React.createElement(MastercardMetalic, {
    className: id
  });

  var _ref15 = React.createElement(MastercardMetalicBlack, {
    className: id
  });

  return cardType.cata({
    Visa: () => cardDesign.visa.cata({
      Colored: color => React.createElement(VisaDefault, {
        className: id,
        fill: color
      }),
      Metalic: () => _ref11
    }),
    Mastercard: () => cardDesign.mastercard.cata({
      Default: () => _ref12,
      DefaultWhite: () => _ref13,
      Metalic: () => _ref14,
      BlackMetalic: () => _ref15
    }),
    None: () => null
  });
};

export { BankLogo, ProductLogo, StatusIcon, TypeLogo };