import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';
export default class ViewTitle extends React.PureComponent {
  static enableWebComponent() {
    registerElement(ViewTitle.tagName, ViewTitle, ViewTitle.defaultProps);
  }

  static getText(props) {
    if (typeof props.text === 'string') {
      return props.text;
    }

    return processChildren(props);
  }

  render() {
    const {
      tag: Component,
      className,
      class: _className
    } = this.props;
    const text = ViewTitle.getText(this.props);
    const params = {
      className: classnames('dnb-view-title', className, _className)
    };
    validateDOMAttributes(this.props, params);
    return React.createElement(Component, params, text);
  }

}
ViewTitle.tagName = 'dnb-view-title';
ViewTitle.defaultProps = {
  text: null,
  tag: 'h1',
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? ViewTitle.propTypes = {
  text: PropTypes.string,
  tag: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;