import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
export const SuffixContext = React.createContext();

const Suffix = (_ref) => {
  let {
    className,
    children,
    context
  } = _ref,
      props = _objectWithoutPropertiesLoose(_ref, ["className", "children", "context"]);

  const content = React.createElement("span", _extends({
    className: classnames('dnb-suffix', className)
  }, props), children);

  if (typeof children !== 'string' && context) {
    return React.createElement(SuffixContext.Provider, {
      value: context
    }, content);
  }

  return content;
};

process.env.NODE_ENV !== "production" ? Suffix.propTypes = {
  className: PropTypes.string,
  children: PropTypes.node
} : void 0;
Suffix.defaultProps = {
  className: null,
  children: null
};
export default Suffix;