import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import Context from './Context';
export function getTranslation(id, params) {
  return React.createElement(Translation, _extends({
    id: id
  }, params));
}
export default function useTranslation(id, params) {
  const {
    translation
  } = React.useContext(Context);
  return prepareTrans(id, params, translation);
}
export class Translation extends React.PureComponent {
  render() {
    const _this$props = this.props,
          {
      id,
      children
    } = _this$props,
          params = _objectWithoutPropertiesLoose(_this$props, ["id", "children"]);

    return prepareTrans(id || children, params, this.context.translation);
  }

}
Translation.contextType = Context;
Translation.defaultProps = {
  id: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Translation.propTypes = {
  id: PropTypes.string,
  children: PropTypes.string
} : void 0;

function prepareTrans(id, params, trans) {
  let str = null;

  if (trans[id]) {
    str = trans[id];

    for (let t in params) {
      str = str.replace(new RegExp(`{${t}}`, 'g'), params[t]);
    }
  }

  return str;
}