import { matchAll } from '../shared/component-helper';
import properties from './properties';
import { IS_IE11 } from '../shared/helpers';
const findRegExp = /var\(([^)]*)\)/g;

const stylisPlugin = (context, content, props = null) => {
  if (context !== 1 || props === null && !IS_IE11) {
    return false;
  }

  const matches = matchAll(content, findRegExp);
  const varsToFill = Array.from(matches).reduce((acc, [k, v]) => {
    if (props && props[v]) {
      acc[v] = props[v];
    } else if (properties[v]) {
      acc[v] = properties[v];
    }

    return acc;
  }, {});
  return Object.entries(varsToFill).reduce((acc, [k, v]) => acc.replace(new RegExp(`var\\(${k}\\)`, 'g'), v), content);
};

export default stylisPlugin;
export const withProperties = properties => (context, content) => stylisPlugin(context, content, properties);