import "core-js/modules/es.symbol.js";
import "core-js/modules/es.symbol.description.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.find-index.js";
import "core-js/modules/es.array.for-each.js";
import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.string.includes.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { warn, isTrue, makeUniqueId, registerElement, extendPropsWithContext, validateDOMAttributes, dispatchCustomElementEvent } from '../../shared/component-helper';
import { createSpacingClasses } from '../space/SpacingHelper';
import AccordionProvider from './AccordionProvider';
import AccordionHeader from './AccordionHeader';
import AccordionContent from './AccordionContent';
import AccordionContext from './AccordionContext';
import AccordionProviderContext from './AccordionProviderContext';
import Context from '../../shared/Context';
import { accordionPropTypes, accordionDefaultProps } from './AccordionPropTypes';

var AccordionStore = function () {
  function AccordionStore(id) {
    _classCallCheck(this, AccordionStore);

    this._id = id;
    this._instances = [];
  }

  _createClass(AccordionStore, [{
    key: "onChange",
    value: function onChange(_ref) {
      var id = _ref.id;

      this._instances.forEach(function (inst) {
        if (inst._id !== id) {
          inst.close();
        }
      });
    }
  }, {
    key: "addInstance",
    value: function addInstance(instance) {
      this._instances.push(instance);
    }
  }, {
    key: "removeInstance",
    value: function removeInstance(instance) {
      this._instances = this._instances.filter(function (inst) {
        return inst !== instance;
      });
    }
  }]);

  return AccordionStore;
}();

var _ref3 = React.createElement(AccordionHeader, null);

var Accordion = function (_React$PureComponent) {
  _inherits(Accordion, _React$PureComponent);

  var _super = _createSuper(Accordion);

  function Accordion(props, context) {
    var _this;

    _classCallCheck(this, Accordion);

    _this = _super.call(this, props);

    _this.handleDisabledClick = function (e) {
      e.preventDefault();
      return false;
    };

    _this.callOnChangeHandler = function () {
      var _this2, _this$context;

      for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
        params[_key] = arguments[_key];
      }

      (_this2 = _this).callOnChange.apply(_this2, params);

      if ((_this$context = _this.context) !== null && _this$context !== void 0 && _this$context.onChange) {
        var _this$context2;

        (_this$context2 = _this.context) === null || _this$context2 === void 0 ? void 0 : _this$context2.onChange.apply(_this$context2, params);
      }

      if (_this.state.group && typeof window !== 'undefined') {
        var _window, _window$__dnbAccordio;

        (_window = window) === null || _window === void 0 ? void 0 : (_window$__dnbAccordio = _window.__dnbAccordion[_this.state.group]) === null || _window$__dnbAccordio === void 0 ? void 0 : _window$__dnbAccordio.onChange.apply(_window$__dnbAccordio, params);
      }
    };

    _this.callOnChange = function (_ref2) {
      var expanded = _ref2.expanded,
          event = _ref2.event;

      _this.changeOpened(expanded, event);

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        expanded: expanded,
        event: event
      });
    };

    _this._id = props.id || makeUniqueId();
    _this.state = {
      _expanded: props.expanded,
      expanded: props.expanded !== null ? isTrue(props.expanded) : isTrue(context === null || context === void 0 ? void 0 : context.expanded),
      group: props.group || (context === null || context === void 0 ? void 0 : context.group),
      no_animation: isTrue(props.no_animation || (context === null || context === void 0 ? void 0 : context.no_animation)),
      _listenForPropChanges: false
    };

    if (typeof window === 'undefined' && isTrue(props.expanded_ssr || (context === null || context === void 0 ? void 0 : context.expanded_ssr))) {
      _this.state.expanded = true;
    }

    if (_this.state.group && typeof window !== 'undefined') {
      window.__dnbAccordion = window.__dnbAccordion || {};
      window.__dnbAccordion[_this.state.group] = window.__dnbAccordion[_this.state.group] || new AccordionStore(_this.state.group);

      window.__dnbAccordion[_this.state.group].addInstance(_assertThisInitialized(_this));
    }

    _this.store = new Store({
      id: props.id,
      group: _this.state.group
    });

    if (isTrue(props.remember_state || context.remember_state) && isTrue(props.expanded)) {
      var expanded = _this.store.getState();

      if (expanded === false) {
        _this.state.expanded = false;
      }
    }

    if (context && typeof (context === null || context === void 0 ? void 0 : context.onInit) === 'function') {
      context.onInit(_assertThisInitialized(_this));
    }

    if (typeof window !== 'undefined' && isTrue(props.expanded_ssr || (context === null || context === void 0 ? void 0 : context.expanded_ssr))) {
      _this.state.expanded = false;
    }

    if (isTrue(_this.props.remember_state || context.remember_state)) {
      var _expanded2 = _this.store.getState();

      if (_expanded2) {
        _this.state.expanded = true;
      }
    }

    return _this;
  }

  _createClass(Accordion, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
      clearTimeout(this._animationState);
      clearTimeout(this._openTimeout);
      clearTimeout(this._changeOpenState);

      if (this.state.group && typeof window !== 'undefined') {
        var _window2, _window2$__dnbAccordi;

        (_window2 = window) === null || _window2 === void 0 ? void 0 : (_window2$__dnbAccordi = _window2.__dnbAccordion[this.state.group]) === null || _window2$__dnbAccordi === void 0 ? void 0 : _window2$__dnbAccordi.removeInstance(this);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(props) {
      var _this$context3;

      if (isTrue(this.context.flush_remembered_state)) {
        this.store.flush();
        this.setState({
          expanded: isTrue(this.props.expanded)
        });
      }

      if ((_this$context3 = this.context) !== null && _this$context3 !== void 0 && _this$context3.expanded_id && this.context.expanded_id === props.id) {
        this.setState({
          expanded: true
        });
      }
    }
  }, {
    key: "setExpandedState",
    value: function setExpandedState(expanded) {
      this.setState({
        expanded: expanded,
        _listenForPropChanges: false
      });
    }
  }, {
    key: "close",
    value: function close() {
      this.changeOpened(false);
    }
  }, {
    key: "changeOpened",
    value: function changeOpened(expanded) {
      if (!this._isMounted) {
        return;
      }

      this.setState({
        expanded: expanded,
        _listenForPropChanges: false
      });

      if (isTrue(this.props.remember_state) || isTrue(this.context.remember_state)) {
        this.store.saveState(expanded);
      }
    }
  }, {
    key: "hasAccordionHeader",
    value: function hasAccordionHeader(children) {
      if (!Array.isArray(children)) {
        children = [children];
      }

      return children.findIndex(function (cur) {
        return React.isValidElement(cur) && cur.type === AccordionHeader;
      }) !== -1;
    }
  }, {
    key: "hasAccordionContent",
    value: function hasAccordionContent(children) {
      if (!Array.isArray(children)) {
        children = [children];
      }

      return children.findIndex(function (cur) {
        return React.isValidElement(cur) && cur.type === AccordionContent;
      }) !== -1;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return React.createElement(Context.Consumer, null, function (globalContext) {
        return React.createElement(AccordionContext.Consumer, null, function (nestedContext) {
          var no_animation = _this3.state.no_animation;
          var expanded = _this3.state.expanded;
          var props = extendPropsWithContext(_this3.props, Accordion.defaultProps, _this3.context, nestedContext, {
            skeleton: globalContext === null || globalContext === void 0 ? void 0 : globalContext.skeleton
          }, globalContext.accordion, globalContext.translation.Accordion);

          if (expanded === null && globalContext.accordion) {
            if (globalContext.accordion.expanded) {
              expanded = isTrue(props.expanded);
            }
          }

          var variant = props.variant,
              className = props.className,
              _className = props.class,
              prerender = props.prerender,
              prevent_rerender = props.prevent_rerender,
              prevent_rerender_conditional = props.prevent_rerender_conditional,
              single_container = props.single_container,
              remember_state = props.remember_state,
              disabled = props.disabled,
              skeleton = props.skeleton,
              _no_animation = props.no_animation,
              _expanded_ssr = props.expanded_ssr,
              children = props.children,
              _id = props.id,
              _group = props.group,
              _expanded = props.expanded,
              title = props.title,
              description = props.description,
              left_component = props.left_component,
              icon = props.icon,
              icon_position = props.icon_position,
              icon_size = props.icon_size,
              attributes = props.attributes,
              on_change = props.on_change,
              on_state_update = props.on_state_update,
              custom_method = props.custom_method,
              custom_element = props.custom_element,
              rest = _objectWithoutProperties(props, ["variant", "className", "class", "prerender", "prevent_rerender", "prevent_rerender_conditional", "single_container", "remember_state", "disabled", "skeleton", "no_animation", "expanded_ssr", "children", "id", "group", "expanded", "title", "description", "left_component", "icon", "icon_position", "icon_size", "attributes", "on_change", "on_state_update", "custom_method", "custom_element"]);

          var id = _this3._id;
          var mainParams = {
            id: id,
            className: classnames('dnb-accordion', createSpacingClasses(props), className, _className, expanded && 'dnb-accordion--expanded', no_animation && 'dnb-accordion--no-animation', variant && "dnb-accordion__variant--".concat(variant), isTrue(prerender) && 'dnb-accordion--prerender')
          };

          if (_this3.state.open) {
            mainParams.open = true;
          }

          validateDOMAttributes(_this3.props, rest);
          var extendProps = extendPropsWithContext(_this3.props, Accordion.defaultProps, _this3.state, _this3.context);

          var context = _extends({}, extendProps, {
            id: id,
            expanded: expanded,
            prerender: isTrue(prerender),
            prevent_rerender: isTrue(prevent_rerender),
            prevent_rerender_conditional: isTrue(prevent_rerender_conditional),
            single_container: isTrue(single_container),
            remember_state: isTrue(remember_state),
            disabled: isTrue(disabled),
            skeleton: isTrue(skeleton),
            callOnChange: _this3.callOnChangeHandler
          });

          if (isTrue(disabled)) {
            mainParams.onClick = _this3.handleDisabledClick;
          }

          return React.createElement(AccordionContext.Provider, {
            value: context
          }, React.createElement("div", mainParams, _this3.hasAccordionHeader(children) ? null : _ref3, _this3.hasAccordionContent(children) ? children : React.createElement(AccordionContent, null, children)));
        });
      });
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Accordion.tagName, Accordion, Accordion.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.expanded !== state._expanded) {
          state.expanded = isTrue(props.expanded);
          state._expanded = props.expanded;
        }

        if (props.group && !state.group) {
          state.group = props.group;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return Accordion;
}(React.PureComponent);

Accordion.tagName = 'dnb-accordion';
Accordion.contextType = AccordionProviderContext;
Accordion.Provider = AccordionProvider;
Accordion.Header = AccordionHeader;
Accordion.Content = AccordionContent;
Accordion.defaultProps = _extends({}, accordionDefaultProps);
export { Accordion as default };
process.env.NODE_ENV !== "production" ? Accordion.propTypes = _extends({}, accordionPropTypes) : void 0;

var Group = function (_React$PureComponent2) {
  _inherits(Group, _React$PureComponent2);

  var _super2 = _createSuper(Group);

  function Group(props) {
    var _this4;

    _classCallCheck(this, Group);

    _this4 = _super2.call(this, props);
    _this4.state = {};

    _this4.onInit = function (instance) {
      if (instance.props.id && !_this4._IDs.includes(instance.props.id)) {
        _this4._IDs.push(instance.props.id);
      }
    };

    var group;

    if (props.id) {
      group = props.id;
    } else if (!props.group) {
      group = '#' + makeUniqueId();
    }

    _this4.state.group = group;
    _this4.store = new Store({
      group: group
    });
    _this4._IDs = [];

    if (isTrue(props.remember_state) && !props.id) {
      rememberWarning('accordion group');
    }

    return _this4;
  }

  _createClass(Group, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this5 = this;

      var storedData = this.store.getData();

      if (storedData !== null && storedData !== void 0 && storedData.id) {
        if (!this._IDs.includes(storedData.id)) {
          var expanded_id = this._IDs[0];

          if (expanded_id) {
            this.setState({
              expanded_id: expanded_id
            }, function () {
              _this5.store.saveState(true, expanded_id);

              _this5.setState({
                expanded_id: null
              });
            });
          }
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(AccordionProvider, _extends({
        onInit: this.onInit
      }, this.props, this.state));
    }
  }]);

  return Group;
}(React.PureComponent);

Group.defaultProps = {
  id: null,
  group: null,
  remember_state: null
};
process.env.NODE_ENV !== "production" ? Group.propTypes = {
  id: PropTypes.string,
  group: PropTypes.string,
  remember_state: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
} : void 0;
Accordion.Group = Group;

Accordion.Group.Store = function (group) {
  var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  return new Store({
    group: group,
    id: id
  });
};

Accordion.Store = function (id) {
  return new Store({
    id: id
  });
};

function rememberWarning() {
  var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'accordion';
  warn("Missing \"id\" prop the ".concat(type, "! \"remember_state\" is enabled."));
}

var Store = function () {
  function Store(_ref4) {
    var id = _ref4.id,
        group = _ref4.group;

    _classCallCheck(this, Store);

    this.id = id;
    this.group = group;
    return this;
  }

  _createClass(Store, [{
    key: "storeId",
    value: function storeId() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.id;

      if (this.group) {
        if (this.group[0] === '#') {
          return null;
        }

        id = this.group;
      }

      return "dnb-accordion-".concat(id);
    }
  }, {
    key: "saveState",
    value: function saveState(expanded) {
      var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.id;
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (id) {
        try {
          var store = this.getData() || {};

          if (this.group) {
            if (expanded) {
              store.id = id;
            } else if (opts && opts.force) {
              store.id = null;
            }
          } else {
            store.expanded = expanded;
          }

          var storeId = this.storeId(id);

          if (storeId) {
            window.localStorage.setItem(storeId, JSON.stringify(store));
          }
        } catch (e) {}
      } else {
        rememberWarning();
      }
    }
  }, {
    key: "getData",
    value: function getData() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.id;
      var storeId = this.storeId(id);

      if (storeId) {
        try {
          if (Object.prototype.hasOwnProperty.call(window.localStorage, storeId)) {
            return JSON.parse(window.localStorage.getItem(storeId));
          }
        } catch (e) {}
      }

      return null;
    }
  }, {
    key: "getState",
    value: function getState() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.id;
      var state = null;
      var store = this.getData(id);

      if (store) {
        if (typeof store.id !== 'undefined') {
          state = id === store.id;
        } else if (store.expanded !== 'undefined') {
          state = isTrue(store.expanded);
        }
      }

      return state;
    }
  }, {
    key: "flush",
    value: function flush() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.id;

      if (id) {
        try {
          var storeId = this.storeId(id);

          if (storeId) {
            window.localStorage.setItem(storeId, null);
          }
        } catch (e) {}
      }
    }
  }]);

  return Store;
}();