import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { isTrue, validateDOMAttributes, processChildren, getPreviousSibling, AnimateHeight } from '../../shared/component-helper';
import classnames from 'classnames';
import AccordionContext from './AccordionContext';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';

var AccordionContent = function (_React$PureComponent) {
  _inherits(AccordionContent, _React$PureComponent);

  var _super = _createSuper(AccordionContent);

  function AccordionContent(props, context) {
    var _this;

    _classCallCheck(this, AccordionContent);

    _this = _super.call(this, props);
    _this._ref = React.createRef();
    _this.state = {
      isInitial: !context.expanded,
      isAnimating: false,
      keepContentInDom: null
    };
    _this.anim = new AnimateHeight();

    _this.anim.onStart(function () {
      _this.setState({
        isAnimating: true
      });
    });

    _this.anim.onEnd(function () {
      _this.setState({
        isAnimating: false
      });

      _this.setState({
        keepContentInDom: _this.context.expanded
      });
    });

    if (props.instance && Object.prototype.hasOwnProperty.call(props.instance, 'current')) {
      props.instance.current = _assertThisInitialized(_this);
    }

    return _this;
  }

  _createClass(AccordionContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.anim.setElem(this._ref.current, getPreviousSibling('dnb-accordion-group--single-container', this._ref.current));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.anim.remove();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      var _this$context = this.context,
          expanded = _this$context.expanded,
          single_container = _this$context.single_container;

      if (expanded !== this.state._expanded) {
        var isInitial = !expanded && this.state.isInitial;
        this.setState({
          _expanded: expanded,
          isInitial: false,
          keepContentInDom: true
        }, function () {
          if (expanded) {
            _this2.anim.open({
              animate: !isInitial
            });
          } else {
            _this2.anim.close({
              animate: !isInitial
            });
          }
        });
      }

      if (isTrue(single_container) && AccordionContent.getContent(prevProps) !== AccordionContent.getContent(this.props)) {
        this.anim.setContainerHeight();
      }
    }
  }, {
    key: "setContainerHeight",
    value: function setContainerHeight() {
      var _this$anim;

      (_this$anim = this.anim) === null || _this$anim === void 0 ? void 0 : _this$anim.setContainerHeight();
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var children = AccordionContent.getContent(this.props);
      var _this$context2 = this.context,
          expanded = _this$context2.expanded,
          prerender = _this$context2.prerender,
          prevent_rerender = _this$context2.prevent_rerender,
          prevent_rerender_conditional = _this$context2.prevent_rerender_conditional;
      var content = children;

      if (typeof content === 'string') {
        content = React.createElement("p", {
          className: "dnb-p"
        }, content);
      }

      content = expanded || prerender || this.state.keepContentInDom || this.state.isAnimating ? children : null;

      if (isTrue(prevent_rerender)) {
        if (isTrue(prevent_rerender_conditional) && this._cache !== content) {
          this._cache = content;
        }

        if (this._cache) {
          content = this._cache;
        } else {
          this._cache = content;
        }
      }

      return content;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          instance = _this$props.instance,
          rest = _objectWithoutProperties(_this$props, ["className", "instance"]);

      var _this$state = this.state,
          keepContentInDom = _this$state.keepContentInDom,
          isAnimating = _this$state.isAnimating;
      var _this$context3 = this.context,
          id = _this$context3.id,
          expanded = _this$context3.expanded,
          disabled = _this$context3.disabled;
      var content = this.renderContent();

      var wrapperParams = _extends({
        className: classnames('dnb-accordion__content', className, !expanded && !keepContentInDom && 'dnb-accordion__content--hidden', isAnimating && 'dnb-accordion__content--is-animating')
      }, rest);

      var innerParams = {
        id: "".concat(id, "-content"),
        role: 'region',
        'aria-labelledby': "".concat(id, "-header"),
        className: classnames('dnb-accordion__content__inner', createSpacingClasses(rest), keepContentInDom === false && 'dnb-accordion__content__inner--remove-content')
      };

      if (expanded) {
        innerParams['aria-expanded'] = true;
      }

      if (!expanded || disabled) {
        innerParams.disabled = true;
        innerParams['aria-hidden'] = true;
      }

      validateDOMAttributes(this.props, wrapperParams);
      validateDOMAttributes(null, innerParams);
      return React.createElement("div", _extends({}, wrapperParams, {
        ref: this._ref
      }), React.createElement("div", innerParams, content));
    }
  }], [{
    key: "getContent",
    value: function getContent(props) {
      return processChildren(props);
    }
  }]);

  return AccordionContent;
}(React.PureComponent);

AccordionContent.contextType = AccordionContext;
AccordionContent.defaultProps = {
  instance: null,
  className: null,
  children: null
};
export { AccordionContent as default };
process.env.NODE_ENV !== "production" ? AccordionContent.propTypes = _extends({
  instance: PropTypes.object
}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
}) : void 0;