import * as React from 'react';
export type AccordionHeaderTitle =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type AccordionHeaderDescription =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type AccordionHeaderLeftComponent =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type AccordionHeaderElement =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type AccordionHeaderHeading =
  | boolean
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type AccordionHeaderHeadingLevel = string | number;
export type AccordionHeaderIcon =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type AccordionHeaderIconPosition = 'left' | 'right';
export type AccordionHeaderDisabled = string | boolean;
export type AccordionHeaderSkeleton = string | boolean;
export type AccordionHeaderSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type AccordionHeaderTop = string | number | boolean;
export type AccordionHeaderRight = string | number | boolean;
export type AccordionHeaderBottom = string | number | boolean;
export type AccordionHeaderLeft = string | number | boolean;
export type AccordionHeaderChildren =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface AccordionHeaderProps
  extends React.HTMLProps<HTMLElement> {
  title?: AccordionHeaderTitle;
  description?: AccordionHeaderDescription;
  left_component?: AccordionHeaderLeftComponent;
  element?: AccordionHeaderElement;
  heading?: AccordionHeaderHeading;
  heading_level?: AccordionHeaderHeadingLevel;
  icon?: AccordionHeaderIcon;
  icon_position?: AccordionHeaderIconPosition;
  icon_size?: string;
  disabled?: AccordionHeaderDisabled;
  skeleton?: AccordionHeaderSkeleton;
  space?: AccordionHeaderSpace;
  top?: AccordionHeaderTop;
  right?: AccordionHeaderRight;
  bottom?: AccordionHeaderBottom;
  left?: AccordionHeaderLeft;
  className?: string;
  children?: AccordionHeaderChildren;
}
export default class AccordionHeader extends React.Component<
  AccordionHeaderProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
