import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { isTrue, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, dispatchCustomElementEvent } from '../../shared/component-helper';
import { createSpacingClasses } from '../space/SpacingHelper';
import { accordionPropTypes, accordionDefaultProps } from './AccordionPropTypes';
import Context from '../../shared/Context';
import AccordionGroupContext from './AccordionProviderContext';

var AccordionGroup = function (_React$PureComponent) {
  _inherits(AccordionGroup, _React$PureComponent);

  var _super = _createSuper(AccordionGroup);

  function AccordionGroup(props) {
    var _this;

    _classCallCheck(this, AccordionGroup);

    _this = _super.call(this, props);

    _this.onChangeHandler = function (event) {
      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        id: event.id,
        expanded: event.expanded,
        event: event
      });
    };

    _this._id = props.id || makeUniqueId();
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(AccordionGroup, [{
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, AccordionGroup.defaultProps, this.context.FormRow, this.context.Accordion, this.context.getTranslation(this.props).Accordion);

      var expanded = props.expanded,
          expanded_id = props.expanded_id,
          prerender = props.prerender,
          prevent_rerender = props.prevent_rerender,
          single_container = props.single_container,
          allow_close_all = props.allow_close_all,
          remember_state = props.remember_state,
          flush_remembered_state = props.flush_remembered_state,
          disabled = props.disabled,
          group = props.group,
          onInit = props.onInit,
          className = props.className,
          _className = props.class,
          _id = props.id,
          children = props.children,
          rest = _objectWithoutProperties(props, ["expanded", "expanded_id", "prerender", "prevent_rerender", "single_container", "allow_close_all", "remember_state", "flush_remembered_state", "disabled", "group", "onInit", "className", "class", "id", "children"]);

      var id = this._id;
      var classes = classnames('dnb-accordion-group', createSpacingClasses(props), className, _className, isTrue(single_container) && 'dnb-accordion-group--single-container');

      var params = _extends({}, rest);

      validateDOMAttributes(this.props, params);

      if (!props.group && isTrue(props.single_container)) {
        props.group = makeUniqueId();
      }

      var context = _extends({}, props, {
        id: id,
        onChange: this.onChangeHandler
      });

      return React.createElement(AccordionGroupContext.Provider, {
        value: context
      }, React.createElement("div", {
        className: classes
      }, React.createElement("span", _extends({
        id: id,
        className: "dnb-accordion-group__shell",
        role: "group"
      }, params), React.createElement("span", {
        className: "dnb-accordion-group__children"
      }, children))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(AccordionGroup.tagName, AccordionGroup, AccordionGroup.defaultProps);
    }
  }]);

  return AccordionGroup;
}(React.PureComponent);

AccordionGroup.tagName = 'dnb-accordion-group';
AccordionGroup.contextType = Context;
AccordionGroup.defaultProps = _extends({}, accordionDefaultProps, {
  expanded_id: null,
  onInit: null
});
export { AccordionGroup as default };
process.env.NODE_ENV !== "production" ? AccordionGroup.propTypes = _extends({}, accordionPropTypes, {
  expanded_id: PropTypes.string,
  onInit: PropTypes.func
}) : void 0;