import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.for-each.js";
import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.array.slice.js";
import "core-js/modules/es.array.sort.js";
import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.string.includes.js";
import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.string.split.js";
import "core-js/modules/es.string.trim.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import { warn, isTrue, isTouchDevice, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, dispatchCustomElementEvent, getStatusState, combineDescribedBy, convertJsxToString } from '../../shared/component-helper';
import { IS_MAC, IS_WIN, IS_IE11, IS_EDGE, debounce as _debounce } from '../../shared/helpers';
import AlignmentHelper from '../../shared/AlignmentHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import Suffix from '../../shared/helpers/Suffix';
import FormLabel from '../form-label/FormLabel';
import FormStatus from '../form-status/FormStatus';
import IconPrimary from '../icon-primary/IconPrimary';
import Input, { SubmitButton } from '../input/Input';
import ProgressIndicator from '../progress-indicator/ProgressIndicator';
import DrawerList from '../../fragments/drawer-list/DrawerList';
import DrawerListContext from '../../fragments/drawer-list/DrawerListContext';
import DrawerListProvider from '../../fragments/drawer-list/DrawerListProvider';
import { parseContentTitle, getCurrentData } from '../../fragments/drawer-list/DrawerListHelpers';

var Autocomplete = function (_React$PureComponent) {
  _inherits(Autocomplete, _React$PureComponent);

  var _super = _createSuper(Autocomplete);

  function Autocomplete() {
    _classCallCheck(this, Autocomplete);

    return _super.apply(this, arguments);
  }

  _createClass(Autocomplete, [{
    key: "render",
    value: function render() {
      return React.createElement(DrawerListProvider, _extends({}, this.props, {
        data: this.props.data || this.props.children,
        opened: null,
        tagName: "dnb-autocomplete",
        ignore_events: false,
        prevent_focus: true,
        skip_keysearch: true
      }), React.createElement(AutocompleteInstance, this.props));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Autocomplete.tagName, Autocomplete, Autocomplete.defaultProps);
    }
  }]);

  return Autocomplete;
}(React.PureComponent);

Autocomplete.tagName = 'dnb-autocomplete';
Autocomplete.defaultProps = {
  id: null,
  mode: 'sync',
  title: 'Option Menu',
  placeholder: null,
  no_options: null,
  show_all: null,
  aria_live_options: null,
  indicator_label: null,
  submit_button_title: null,
  submit_button_icon: 'chevron_down',
  input_ref: null,
  icon_size: null,
  icon_position: 'left',
  triangle_position: null,
  input_icon: 'loupe',
  label: null,
  label_direction: null,
  label_sr_only: null,
  keep_value: null,
  keep_value_and_selection: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  disable_filter: false,
  disable_reorder: false,
  scrollable: true,
  focusable: false,
  disable_highlighting: false,
  max_height: null,
  direction: 'auto',
  skip_portal: null,
  no_animation: false,
  no_scroll_animation: false,
  show_submit_button: false,
  submit_element: null,
  prevent_selection: false,
  size: 'default',
  align_autocomplete: null,
  options_render: null,
  data: null,
  search_in_word_index: 3,
  default_value: null,
  value: 'initval',
  input_value: 'initval',
  icon: null,
  open_on_focus: false,
  prevent_close: false,
  keep_open: false,
  opened: null,
  disabled: null,
  stretch: null,
  skeleton: null,
  drawer_class: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_show: null,
  on_hide: null,
  on_type: null,
  on_focus: null,
  on_blur: null,
  on_change: null,
  on_select: null,
  on_state_update: null,
  input_component: null
};
export { Autocomplete as default };
process.env.NODE_ENV !== "production" ? Autocomplete.propTypes = _extends({
  id: PropTypes.string,
  mode: PropTypes.oneOf(['sync', 'async']),
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  placeholder: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  no_options: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  show_all: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  aria_live_options: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  indicator_label: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  submit_button_title: PropTypes.string,
  submit_button_icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  input_ref: PropTypes.oneOfType([PropTypes.func, PropTypes.object]),
  icon_size: PropTypes.string,
  icon_position: PropTypes.oneOf(['left', 'right']),
  triangle_position: PropTypes.oneOf(['left', 'right']),
  input_icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_direction: PropTypes.oneOf(['horizontal', 'vertical']),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  keep_value: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  keep_value_and_selection: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  disable_filter: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disable_reorder: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  scrollable: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  focusable: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disable_highlighting: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  direction: PropTypes.oneOf(['auto', 'top', 'bottom']),
  max_height: PropTypes.number,
  skip_portal: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_scroll_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  show_submit_button: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  submit_element: PropTypes.node,
  prevent_selection: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  size: PropTypes.oneOf(['default', 'small', 'medium', 'large']),
  align_autocomplete: PropTypes.oneOf(['left', 'right']),
  options_render: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.node]),
  input_component: PropTypes.oneOfType([PropTypes.func, PropTypes.node]),
  data: PropTypes.oneOfType([PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node, PropTypes.object]), PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.oneOfType([PropTypes.string, PropTypes.node]), PropTypes.shape({
    selected_value: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
    content: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.arrayOf(PropTypes.string)])
  })]))]),
  search_in_word_index: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  default_value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  input_value: PropTypes.string,
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  open_on_focus: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_close: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  keep_open: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  opened: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  stretch: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  drawer_class: PropTypes.string
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node, PropTypes.object, PropTypes.array]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_show: PropTypes.func,
  on_type: PropTypes.func,
  on_focus: PropTypes.func,
  on_blur: PropTypes.func,
  on_hide: PropTypes.func,
  on_change: PropTypes.func,
  on_select: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;

var _ref4 = React.createElement(IconPrimary, {
  icon: "arrow_down"
});

var _ref16 = React.createElement(AlignmentHelper, null);

var AutocompleteInstance = function (_React$PureComponent2) {
  _inherits(AutocompleteInstance, _React$PureComponent2);

  var _super2 = _createSuper(AutocompleteInstance);

  function AutocompleteInstance(_props, context) {
    var _this;

    _classCallCheck(this, AutocompleteInstance);

    _this = _super2.call(this, _props);

    _this.setVisible = function () {
      _this.context.drawerList.setWrapperElement(_this._refShell.current).setVisible();
    };

    _this.setHidden = function () {
      _this.context.drawerList.setHidden();
    };

    _this.toggleVisible = function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$hasFilter = _ref.hasFilter,
          hasFilter = _ref$hasFilter === void 0 ? false : _ref$hasFilter;

      if (!hasFilter && !isTrue(_this.props.prevent_close) && !_this.context.drawerList.hidden && _this.context.drawerList.opened) {
        _this.setHidden();
      } else {
        _this.setVisibleByContext();
      }
    };

    _this.setVisibleByContext = function () {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var skipFilter = _this.state.showAllNextTime;

      if (skipFilter) {
        _this.setState({
          showAllNextTime: false,
          _listenForPropChanges: false
        });
      }

      _this.runFilterToHighlight(_extends({
        fillDataIfEmpty: true,
        skipFilter: skipFilter
      }, options));

      _this.setVisible();
    };

    _this.scrollToActiveItem = function (active_item) {
      _this.context.drawerList.scrollToItem(active_item, {
        scrollTo: false
      });
    };

    _this.scrollToSelectedItem = function (selected_item) {
      _this.context.drawerList.scrollToAndSetActiveItem(selected_item, {
        scrollTo: false
      });
    };

    _this.onInputChangeHandler = function (_ref2) {
      var value = _ref2.value,
          event = _ref2.event;
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      _this.setState({
        typedInputValue: value,
        inputValue: value,
        _listenForPropChanges: false
      });

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_type', _extends({
        value: value,
        event: event
      }, _this.getEventObjects('on_type')));
      value = String(value).trim();

      if (value !== _this.state.inputValue) {
        _this.runFilterWithSideEffects(value, options);
      }
    };

    _this.runFilterWithSideEffects = function (value) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var data = _this.runFilter(value, options);

      var count = _this.countData(data);

      if (value && value.length > 0) {
        if (count === 0) {
          if (_this.state.mode !== 'async') {
            _this.showNoOptionsItem();
          }
        } else if (count > 0) {
          _this.context.drawerList.setData(_this.wrapWithShowAll(data));

          _this.context.drawerList.setState({
            cache_hash: value + count
          });

          if (count === 1) {
            _this.context.drawerList.setState({
              active_item: data[0].__id
            });
          }
        }
      } else {
        _this.totalReset();

        _this.showAllItems();
      }

      _this.setVisible();

      _this.setAriaLiveUpdate();

      return data;
    };

    _this.runFilterToHighlight = function () {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.state.inputValue;

      var _ref3$fillDataIfEmpty = _ref3.fillDataIfEmpty,
          fillDataIfEmpty = _ref3$fillDataIfEmpty === void 0 ? false : _ref3$fillDataIfEmpty,
          options = _objectWithoutProperties(_ref3, ["fillDataIfEmpty"]);

      var possibleTitle = AutocompleteInstance.getCurrentDataTitle(_this.context.drawerList.selected_item, _this.context.drawerList.original_data);

      if (value === possibleTitle) {
        return;
      }

      value = String(value || '').trim();

      _this.setState({
        skipHighlight: false,
        _listenForPropChanges: false
      });

      var data = _this.runFilter(value, options);

      if (fillDataIfEmpty && data.length === 0 && value === '') {
        data = _this.context.drawerList.original_data;
      }

      _this.context.drawerList.setData(_this.wrapWithShowAll(data));

      _this.context.drawerList.setState({
        cache_hash: value + _this.countData(data)
      });

      _this.setAriaLiveUpdate();

      return data;
    };

    _this.wrapWithShowAll = function (data) {
      if (!_this.hasFilterActive(data)) {
        return data;
      }

      var lastItem = data.slice(-1)[0];

      if (lastItem && !lastItem.show_all) {
        var show_all = _this._props.show_all;
        data.push({
          __id: lastItem.__id + 1,
          class_name: 'dnb-autocomplete__show-all',
          show_all: true,
          active_item: false,
          selected_item: false,
          content: React.createElement(React.Fragment, null, _ref4, show_all)
        });
      }

      return data;
    };

    _this.setInputValue = function (inputValue) {
      _this.setState({
        inputValue: inputValue,
        _listenForPropChanges: false
      });
    };

    _this.emptyData = function () {
      _this._rC = {};

      _this.setState({
        inputValue: '',
        typedInputValue: null,
        _listenForPropChanges: false
      });

      _this.context.drawerList.setData(function () {
        return [];
      }, function () {
        _this.setSearchIndex({
          overwriteSearchIndex: true
        });

        _this.resetSelections();

        _this.totalReset();
      }, {
        overwriteOriginalData: true
      });
    };

    _this.showNoOptionsItem = function () {
      _this.resetSelections();

      _this.ignoreEvents();

      _this.context.drawerList.setData([{
        class_name: 'dnb-autocomplete__no-options',
        content: _this._props.no_options,
        ignore_events: true,
        __id: 'no_options'
      }]);

      _this.context.drawerList.setState({
        cache_hash: 'no_options'
      });

      _this.setVisible();
    };

    _this.showIndicatorItem = function () {
      _this.resetSelections();

      _this.ignoreEvents();

      _this.context.drawerList.setData([{
        class_name: 'dnb-autocomplete__indicator',
        content: React.createElement(ProgressIndicator, {
          label: _this._props.indicator_label
        }),
        ignore_events: true,
        __id: 'indicator'
      }]);

      _this.context.drawerList.setState({
        cache_hash: 'indicator'
      });

      _this.setVisible();
    };

    _this.showIndicator = function () {
      if (!_this.state.visibleIndicator) {
        _this.setState({
          visibleIndicator: true,
          _listenForPropChanges: false
        });
      }
    };

    _this.hideIndicator = function () {
      _this.setState({
        visibleIndicator: false,
        _listenForPropChanges: false
      });
    };

    _this.setMode = function (mode) {
      _this.setState({
        mode: mode,
        _listenForPropChanges: false
      });
    };

    _this.updateData = function (rawData) {
      _this.context.drawerList.setState({
        cache_hash: 'updateData'
      });

      _this.context.drawerList.setData(function () {
        return rawData;
      }, function (newData) {
        _this.setSearchIndex({
          overwriteSearchIndex: true,
          data: newData
        }, function () {
          var typedInputValue = _this.state.typedInputValue;

          if (typedInputValue && typedInputValue.length > 0) {
            var filteredData = _this.runFilterWithSideEffects(typedInputValue);

            if (_this.countData(filteredData) === 0) {
              _this.showNoOptionsItem();
            }
          } else {
            _this.resetSelections();

            if (_this.context.drawerList.opened) {
              _this.showAllItems();
            }
          }
        });
      }, {
        overwriteOriginalData: true
      });

      return _assertThisInitialized(_this);
    };

    _this.onInputKeyDownHandler = function (_ref5) {
      var e = _ref5.event;
      var key = keycode(e);

      switch (key) {
        case 'page up':
        case 'page down':
        case 'home':
        case 'end':
        case 'down':
        case 'up':
          e.preventDefault();
          break;
      }
    };

    _this.onInputClickHandler = function (e) {
      var value = e.target.value;

      _this.setVisibleByContext({
        value: value
      });
    };

    _this.onInputFocusHandler = function (event) {
      if (_this.state.skipFocusDuringChange) {
        return;
      }

      var _this$props = _this.props,
          open_on_focus = _this$props.open_on_focus,
          keep_value_and_selection = _this$props.keep_value_and_selection;

      if (!_this.state.hasFocus) {
        if (isTrue(open_on_focus)) {
          var value = event.target.value;

          _this.setVisibleByContext({
            value: value
          });
        } else {
          _this.setSearchIndex();
        }

        if (isTrue(keep_value_and_selection)) {
          _this.showAll();
        }

        dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_focus', _extends({
          event: event
        }, _this.getEventObjects('on_focus')));

        _this.setState({
          hasFocus: true,
          hasBlur: false
        });
      }
    };

    _this.onBlurHandler = function (event) {
      var _this$props2 = _this.props,
          input_value = _this$props2.input_value,
          open_on_focus = _this$props2.open_on_focus,
          keep_value = _this$props2.keep_value,
          keep_value_and_selection = _this$props2.keep_value_and_selection,
          prevent_selection = _this$props2.prevent_selection;

      if (!isTrue(keep_value_and_selection)) {
        _this.setState({
          typedInputValue: null,
          _listenForPropChanges: false
        });
      }

      if (isTrue(open_on_focus)) {
        _this.setHidden();
      }

      if (!isTrue(prevent_selection) && !isTrue(keep_value_and_selection)) {
        var inputValue = AutocompleteInstance.getCurrentDataTitle(_this.context.drawerList.selected_item, _this.context.drawerList.original_data);
        clearTimeout(_this._selectTimeout);
        _this._selectTimeout = setTimeout(function () {
          if (parseFloat(_this.context.drawerList.selected_item) > -1) {
            _this.setState({
              inputValue: inputValue,
              _listenForPropChanges: false
            });
          } else if (!(input_value !== 'initval' && input_value.length > 0) && !isTrue(keep_value)) {
            _this.setState({
              inputValue: '',
              _listenForPropChanges: false
            });
          }
        }, 1);
      }

      if (!_this.state.hasBlur) {
        dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_blur', _extends({
          event: event
        }, _this.getEventObjects('on_blur')));

        _this.setState({
          hasBlur: true,
          hasFocus: false
        });
      }
    };

    _this.onTriggerKeyDownHandler = function (e) {
      var key = keycode(e);

      switch (key) {
        case 'space':
          {
            _this.setVisible();
          }
          break;
      }

      switch (key) {
        case 'space':
        case 'enter':
        case 'page up':
        case 'page down':
        case 'down':
        case 'up':
          {
            e.preventDefault();

            try {
              _this._refInput.current._ref.current.focus();
            } catch (e) {
              warn(e);
            }
          }
          break;
      }
    };

    _this.onSubmit = function () {
      _this.toggleVisible();
    };

    _this.onShellKeyDownHandler = function (e) {
      var key = keycode(e);

      switch (key) {
        case 'up':
        case 'down':
          if (!_this.context.drawerList.opened) {
            e.preventDefault();

            _this.setVisible();
          }

          break;

        case 'esc':
          _this.setState({
            showAllNextTime: true,
            _listenForPropChanges: false
          });

          break;

        case 'enter':
          e.preventDefault();

          if (!_this.context.drawerList.opened && _this.hasFilterActive()) {
            _this.ignoreEvents();

            _this.showAll();
          }

          if ((!_this.hasValidData() || !_this.hasSelectedItem()) && !_this.hasActiveItem()) {
            clearTimeout(_this._toggleVisibleTimeout);
            _this._toggleVisibleTimeout = setTimeout(_this.toggleVisible, 1);
          } else {
            _this.setVisible();
          }

          break;
      }
    };

    _this.getEventObjects = function (key) {
      var attributes = _this.attributes;
      return {
        attributes: attributes,
        dataList: _this.context.drawerList.data,
        updateData: _this.updateData,
        showAllItems: _this.showAllItems,
        setVisible: _this.setVisible,
        setHidden: _this.setHidden,
        emptyData: _this.emptyData,
        setInputValue: _this.setInputValue,
        showNoOptionsItem: _this.showNoOptionsItem,
        showIndicatorItem: _this.showIndicatorItem,
        showIndicator: _this.showIndicator,
        hideIndicator: _this.hideIndicator,
        setMode: _this.setMode,
        debounce: function debounce(func) {
          var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
          var wait = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 250;
          _this.dbf = _this.dbf || {};
          return (_this.dbf[key] || (_this.dbf[key] = _debounce(func, wait, {
            context: _assertThisInitialized(_this)
          })))(props);
        }
      };
    };

    _this.hasShowMore = function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.context.drawerList.data;
      var lastItem = data.slice(-1)[0];
      return lastItem && lastItem.show_all === true;
    };

    _this.countData = function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.context.drawerList.data;
      var count = data.length;
      return count > 0 && _this.hasShowMore(data) ? count - 1 : count;
    };

    _this.hasValidData = function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.context.drawerList.data;

      if (_this.countData(data) > 0) {
        var first = data[0];

        if (!first.show_all && !['no_options', 'indicator'].includes(first.__id)) {
          return true;
        }
      }

      return false;
    };

    _this.hasSelectedItem = function () {
      return parseFloat(_this.context.drawerList.selected_item) > -1;
    };

    _this.hasActiveItem = function () {
      return parseFloat(_this.context.drawerList.active_item) > -1;
    };

    _this.hasFilterActive = function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.context.drawerList.data;
      return !(_this.context.drawerList.original_data && _this.context.drawerList.original_data.length === _this.countData(data));
    };

    _this.ignoreEvents = function () {
      clearTimeout(_this.showAllTimeout);

      _this.context.drawerList.setState({
        ignore_events: true
      }, function () {
        _this.showAllTimeout = setTimeout(function () {
          _this.context && _this.context.drawerList && _this.context.drawerList.setState({
            ignore_events: false
          });
        }, 10);
      });
    };

    _this.showAll = function () {
      _this.resetFilter();

      _this.context.drawerList.setState({
        cache_hash: 'all'
      });

      _this.runFilterToHighlight({
        skipFilter: true,
        fillDataIfEmpty: true
      });
    };

    _this.showAllItems = function () {
      _this.resetFilter();

      _this.context.drawerList.setState({
        cache_hash: 'all'
      });

      _this.scrollToSelectedItem(_this.context.drawerList.selected_item);
    };

    _this.totalReset = function () {
      if (!isTrue(_this.props.keep_value) && !isTrue(_this.props.keep_value_and_selection)) {
        _this.setState({
          inputValue: null
        });
      }

      _this.setState({
        typedInputValue: null,
        _listenForPropChanges: false
      });

      _this.context.drawerList.setState({
        selected_item: null
      });
    };

    _this.resetSelections = function () {
      _this.context.drawerList.setState({
        active_item: null
      });
    };

    _this.resetFilter = function () {
      _this.context.drawerList.setData(_this.context.drawerList.original_data);
    };

    _this.runFilter = function (value) {
      var _ref6 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref6$data = _ref6.data,
          data = _ref6$data === void 0 ? null : _ref6$data,
          _ref6$searchIndex = _ref6.searchIndex,
          searchIndex = _ref6$searchIndex === void 0 ? _this.state.searchIndex : _ref6$searchIndex,
          _ref6$skipHighlight = _ref6.skipHighlight,
          skipHighlight = _ref6$skipHighlight === void 0 ? false : _ref6$skipHighlight,
          _ref6$skipFilter = _ref6.skipFilter,
          skipFilter = _ref6$skipFilter === void 0 ? false : _ref6$skipFilter,
          _ref6$skipReorder = _ref6.skipReorder,
          skipReorder = _ref6$skipReorder === void 0 ? false : _ref6$skipReorder;

      var words = value.split(/\s+/g).filter(Boolean);
      var wordsCount = words.length;
      var wordCond = '^|\\s';

      var findWords = function findWords(item) {
        return words.map(function (word, wordIndex) {
          return {
            word: word,
            wordIndex: wordIndex,
            score: wordsCount - wordIndex
          };
        }).filter(function (_ref7) {
          var word = _ref7.word,
              wordIndex = _ref7.wordIndex;
          return typeof item === 'string' && new RegExp(wordIndex > _this.inWordIndex ? "".concat(word) : "(".concat(wordCond, ")").concat(word), 'i').test(item);
        });
      };

      if (data) {
        searchIndex = _this.setSearchIndex({
          data: data
        });
      } else if (!searchIndex) {
          searchIndex = _this.setSearchIndex();
        }

      if (typeof searchIndex === 'undefined') {
        return [];
      }

      var S = "\uFFFE";
      var E = "\uFFFF";
      var tagS = '<span class="dnb-drawer-list__option__item--highlight">';
      var tagE = '</span>';
      searchIndex = searchIndex.map(function (item) {
        var listOfFoundWords = findWords(item.searchChunk);

        if (typeof item.dataItem === 'string') {
          item.dataItem = {
            content: item.dataItem
          };
        }

        if (!item.dataItem.render) {
          item.dataItem = _extends({}, item.dataItem);
        }

        item.dataItem.render = function (children, id) {
          var cacheHash = id + value;
          _this._rC = _this._rC || {};

          if (_this._rC[cacheHash]) {
            return _this._rC[cacheHash];
          }

          var Component = null;

          if (typeof children !== 'string') {
            if (!Array.isArray(children)) {
              children = [children];
            }

            Component = children;
            children = children.map(function (child) {
              return convertJsxToString(child);
            });
          }

          if (typeof children === 'string') {
            children = [children];
          }

          children = children.map(function (segment, sIndex) {
            if (skipHighlight || _this.state.skipHighlight) {
              return segment;
            }

            listOfFoundWords.forEach(function (_ref8) {
              var word = _ref8.word,
                  wordIndex = _ref8.wordIndex;

              if (wordIndex > _this.inWordIndex) {
                segment = segment.replace(new RegExp("(".concat(word, ")"), 'gi'), "".concat(S, "$1").concat(E));
              } else {
                segment = segment.replace(new RegExp("(".concat(wordCond, ")(").concat(word, ")"), 'gi'), "$1".concat(S, "$2").concat(E));
              }
            });

            if (segment.includes(S)) {
              var __html = segment.replace(new RegExp("(".concat(S, ")+"), 'g'), S).replace(new RegExp("(".concat(E, ")+"), 'g'), E).replace(new RegExp("(".concat(E).concat(S, ")"), 'g'), '').replace(new RegExp(S, 'g'), tagS).replace(new RegExp(E, 'g'), tagE);

              return React.createElement("span", {
                key: cacheHash + sIndex,
                dangerouslySetInnerHTML: {
                  __html: __html
                }
              });
            }

            return segment;
          }).map(function (c, i, a) {
            return i < a.length - 1 ? [c, ' '] : c;
          });

          if (Component) {
            children = Array.isArray(Component) ? Component.map(function (Comp, i) {
              return React.cloneElement(Comp, {
                key: 'clone' + cacheHash + i
              }, children[i]);
            }) : React.cloneElement(Component, {
              key: 'clone' + cacheHash
            }, children);
          }

          return _this._rC[cacheHash] = children;
        };

        var totalScore = listOfFoundWords.reduce(function (acc, _ref9) {
          var score = _ref9.score;
          return acc += score;
        }, 0);

        if (_this.skipFilter || skipFilter) {
          return item.dataItem;
        }

        return {
          countFindings: listOfFoundWords.length + totalScore,
          item: item
        };
      });

      if (!_this.skipFilter && !skipFilter) {
        searchIndex = searchIndex.filter(function (_ref10) {
          var countFindings = _ref10.countFindings;
          return countFindings;
        });

        if (!_this.skipReorder && !skipReorder) {
          searchIndex = searchIndex.sort(function (_ref11, _ref12) {
            var a = _ref11.countFindings;
            var b = _ref12.countFindings;
            return b - a;
          });
        }

        searchIndex = searchIndex.map(function (_ref13) {
          var item = _ref13.item;
          return item.dataItem;
        });
      }

      return searchIndex;
    };

    _this.onHideHandler = function () {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var res = dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_hide', _extends({}, args, _this.getEventObjects('on_hide')));

      if (res !== false) {
        _this.setFocusOnInput();
      }

      return res;
    };

    _this.onSelectHandler = function (args) {
      if (parseFloat(args.active_item) > -1) {
        dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_select', _extends({}, args, _this.getEventObjects('on_select')));
      }
    };

    _this.onPreChangeHandler = function (_ref14) {
      var data = _ref14.data,
          selected_item = _ref14.selected_item;

      if (data && data.show_all) {
        _this.showAll();

        if (parseFloat(selected_item) > -1) {
          var active_item = selected_item - 1;

          _this.context.drawerList.setState({
            active_item: active_item
          });

          _this.scrollToActiveItem(active_item);
        }

        return false;
      }
    };

    _this.onChangeHandler = function (args) {
      var selected_item = args.selected_item;
      var _this$props3 = _this.props,
          prevent_selection = _this$props3.prevent_selection,
          keep_open = _this$props3.keep_open;

      if (!isTrue(prevent_selection)) {
        if (!isTrue(keep_open)) {
          _this.setState({
            skipFocusDuringChange: true,
            skipHighlight: true,
            _listenForPropChanges: false
          });

          _this.setHidden();

          try {
            _this.context.drawerList._refUl.current.focus({
              preventScroll: true
            });
          } catch (e) {}

          clearTimeout(_this._selectTimeout);
          _this._selectTimeout = setTimeout(function () {
            _this.setState({
              inputValue: AutocompleteInstance.getCurrentDataTitle(selected_item, _this.context.drawerList.data),
              skipFocusDuringChange: false,
              _listenForPropChanges: false
            });

            _this.setFocusOnInput();
          }, 200);
        } else {
          _this.setState({
            inputValue: AutocompleteInstance.getCurrentDataTitle(selected_item, _this.context.drawerList.data),
            _listenForPropChanges: false
          });
        }
      }

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', _extends({}, args, _this.getEventObjects('on_change')));
    };

    _this._id = _props.id || makeUniqueId();
    _this.attributes = {};
    _this.state = _this.state || {};
    _this.state._listenForPropChanges = true;
    _this.state.mode = _props.mode;
    _this.state.init_data = _props.data;
    _this.state.updateData = _this.updateData;

    if (context.drawerList && context.drawerList.current_title) {
      _this.state.inputValue = context.drawerList.current_title;
    }

    _this._ref = React.createRef();
    _this._refShell = React.createRef();
    _this._refInput = React.createRef();
    _this.isTouchDevice = isTouchDevice();
    _this.skipFilter = isTrue(_props.disable_filter);
    _this.skipReorder = isTrue(_props.disable_reorder);
    _this.inWordIndex = (parseFloat(_props.search_in_word_index) || 3) - 2;
    return _this;
  }

  _createClass(AutocompleteInstance, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (isTrue(this.props.opened)) {
        this.runFilterToHighlight({
          fillDataIfEmpty: true
        });
        this.setVisible();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.value !== this.props.value) {
        var inputValue = AutocompleteInstance.getCurrentDataTitle(this.context.drawerList.selected_item, this.context.drawerList.original_data);
        this.setState({
          inputValue: inputValue
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.setHidden();
      clearTimeout(this._hideTimeout);
      clearTimeout(this._selectTimeout);
      clearTimeout(this._ariaLiveUpdateTiemout);
      clearTimeout(this._focusTimeout);
      clearTimeout(this._toggleVisibleTimeout);
    }
  }, {
    key: "setSearchIndex",
    value: function setSearchIndex() {
      var _ref15 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref15$overwriteSearc = _ref15.overwriteSearchIndex,
          overwriteSearchIndex = _ref15$overwriteSearc === void 0 ? false : _ref15$overwriteSearc,
          _ref15$data = _ref15.data,
          data = _ref15$data === void 0 ? this.context.drawerList.original_data : _ref15$data;

      var cb = arguments.length > 1 ? arguments[1] : undefined;
      this._rC = {};

      if (!overwriteSearchIndex && this.state.searchIndex) {
        return this.state.searchIndex;
      }

      var searchIndex = AutocompleteInstance.createSearchIndex(data);
      this.setState({
        searchIndex: searchIndex,
        _listenForPropChanges: false
      }, cb);
      return searchIndex;
    }
  }, {
    key: "setFocusOnInput",
    value: function setFocusOnInput() {
      var _this2 = this;

      this.setState({
        hasFocus: true
      }, function () {
        try {
          _this2._refInput.current._ref.current.focus({
            preventScroll: true
          });
        } catch (e) {}

        clearTimeout(_this2._focusTimeout);
        _this2._focusTimeout = setTimeout(function () {
          _this2.setState({
            hasFocus: false
          });
        }, 1);
      });
    }
  }, {
    key: "setAriaLiveUpdate",
    value: function setAriaLiveUpdate() {
      var _this3 = this;

      var opened = this.context.drawerList.opened;
      var _this$_props = this._props,
          aria_live_options = _this$_props.aria_live_options,
          no_options = _this$_props.no_options;
      clearTimeout(this._ariaLiveUpdateTiemout);
      this._ariaLiveUpdateTiemout = setTimeout(function () {
        if (opened) {
          var newString = null;

          var count = _this3.countData();

          if (count > 0) {
            newString = String(aria_live_options).replace('%s', count);
          } else {
            newString = no_options;
          }

          if (newString) {
            _this3.setState({
              ariaLiveUpdate: newString,
              _listenForPropChanges: false
            });

            _this3._ariaLiveUpdateTiemout = setTimeout(function () {
              _this3.setState({
                ariaLiveUpdate: null,
                _listenForPropChanges: false
              });
            }, 1e3);
          }
        }
      }, 1e3);
    }
  }, {
    key: "render",
    value: function render() {
      var props = this._props = extendPropsWithContext(this.props, Autocomplete.defaultProps, this.context.getTranslation(this.props).Autocomplete, this.context.FormRow, this.context.Autocomplete);

      var title = props.title,
          placeholder = props.placeholder,
          label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          icon_size = props.icon_size,
          input_icon = props.input_icon,
          size = props.size,
          align_autocomplete = props.align_autocomplete,
          fixed_position = props.fixed_position,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          scrollable = props.scrollable,
          focusable = props.focusable,
          keep_open = props.keep_open,
          prevent_close = props.prevent_close,
          no_animation = props.no_animation,
          no_scroll_animation = props.no_scroll_animation,
          show_submit_button = props.show_submit_button,
          submit_element = props.submit_element,
          CustomInput = props.input_component,
          options_render = props.options_render,
          prevent_selection = props.prevent_selection,
          max_height = props.max_height,
          default_value = props.default_value,
          submit_button_title = props.submit_button_title,
          submit_button_icon = props.submit_button_icon,
          drawer_class = props.drawer_class,
          input_ref = props.input_ref,
          className = props.className,
          _className = props.class,
          disabled = props.disabled,
          stretch = props.stretch,
          skeleton = props.skeleton,
          triangle_position = props.triangle_position,
          icon_position = props.icon_position,
          skip_portal = props.skip_portal,
          _mode = props.mode,
          _data = props.data,
          _children = props.children,
          _direction = props.direction,
          _id = props.id,
          _opened = props.opened,
          _value = props.value,
          _input_value = props.input_value,
          indicator_label = props.indicator_label,
          no_options = props.no_options,
          show_all = props.show_all,
          aria_live_options = props.aria_live_options,
          disable_highlighting = props.disable_highlighting,
          attributes = _objectWithoutProperties(props, ["title", "placeholder", "label", "label_direction", "label_sr_only", "icon_size", "input_icon", "size", "align_autocomplete", "fixed_position", "status", "status_state", "status_animation", "global_status_id", "suffix", "scrollable", "focusable", "keep_open", "prevent_close", "no_animation", "no_scroll_animation", "show_submit_button", "submit_element", "input_component", "options_render", "prevent_selection", "max_height", "default_value", "submit_button_title", "submit_button_icon", "drawer_class", "input_ref", "className", "class", "disabled", "stretch", "skeleton", "triangle_position", "icon_position", "skip_portal", "mode", "data", "children", "direction", "id", "opened", "value", "input_value", "indicator_label", "no_options", "show_all", "aria_live_options", "disable_highlighting"]);

      var id = this._id;
      var showStatus = getStatusState(status);
      var _this$state = this.state,
          inputValue = _this$state.inputValue,
          visibleIndicator = _this$state.visibleIndicator,
          ariaLiveUpdate = _this$state.ariaLiveUpdate;
      var _this$context$drawerL = this.context.drawerList,
          hidden = _this$context$drawerL.hidden,
          selected_item = _this$context$drawerL.selected_item,
          active_item = _this$context$drawerL.active_item,
          direction = _this$context$drawerL.direction,
          opened = _this$context$drawerL.opened;
      var isExpanded = Boolean(opened) && this.hasValidData();

      _extends(this.context.drawerList.attributes, validateDOMAttributes(null, attributes));

      var mainParams = {
        className: classnames("dnb-autocomplete dnb-autocomplete--".concat(direction, " dnb-form-component"), createSpacingClasses(props), _className, className, opened && 'dnb-autocomplete--opened', label_direction && "dnb-autocomplete--".concat(label_direction), icon_position && "dnb-autocomplete--icon-position-".concat(icon_position), align_autocomplete && "dnb-autocomplete--".concat(align_autocomplete), visibleIndicator && 'dnb-autocomplete--show-indicator', size && "dnb-autocomplete--".concat(size), isTrue(stretch) && "dnb-autocomplete--stretch", status && "dnb-autocomplete__status--".concat(status_state), showStatus && 'dnb-autocomplete__form-status')
      };
      var shellParams = {
        className: 'dnb-autocomplete__shell dnb-no-focus',
        ref: this._refShell,
        onKeyDown: this.onShellKeyDownHandler
      };

      var inputParams = _extends({
        className: 'dnb-autocomplete__input' + (opened ? " dnb-button--active" : ""),
        id: id,
        value: inputValue,
        autoCapitalize: 'none',
        spellCheck: 'false',
        autoCorrect: 'off',
        autoComplete: 'off',
        role: 'combobox',
        'aria-autocomplete': 'both',
        'aria-controls': "".concat(id, "-ul"),
        'aria-haspopup': 'listbox',
        'aria-expanded': isExpanded,
        onMouseDown: this.onInputClickHandler,
        onTouchStart: this.onInputClickHandler,
        onKeyDown: this.onInputKeyDownHandler,
        onChange: this.onInputChangeHandler,
        onFocus: this.onInputFocusHandler,
        onBlur: this.onBlurHandler,
        icon_position: icon_position,
        inner_ref: input_ref,
        disabled: disabled,
        skeleton: skeleton
      }, attributes);

      if (!(parseFloat(selected_item) > -1)) {
        inputParams.placeholder = placeholder || title;

        if (!(IS_WIN && (IS_IE11 || IS_EDGE))) {
          inputParams['aria-placeholder'] = undefined;
        }
      }

      if (!hidden) {
        if (parseFloat(active_item) > -1) {
          inputParams['aria-activedescendant'] = "option-".concat(id, "-").concat(active_item);
        } else if (!isTrue(prevent_selection) && parseFloat(selected_item) > -1) {
          inputParams['aria-activedescendant'] = "option-".concat(id, "-").concat(selected_item);
        }
      }

      if (showStatus || suffix) {
        inputParams['aria-describedby'] = combineDescribedBy(inputParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      var submitButton = false;

      if (submit_element && React.isValidElement(submit_element) || isTrue(show_submit_button)) {
        var triggerParams = {
          id: id + '-submit-button',
          disabled: disabled,
          status: !opened && status ? status_state : null,
          onKeyDown: this.onTriggerKeyDownHandler,
          onSubmit: this.onSubmit,
          'aria-haspopup': 'listbox',
          'aria-expanded': isExpanded
        };

        if (submit_element && React.isValidElement(submit_element)) {
          submitButton = React.cloneElement(submit_element, triggerParams);
        } else if (isTrue(show_submit_button)) {
          submitButton = React.createElement(SubmitButton, _extends({
            icon: submit_button_icon,
            icon_size: icon_size || (size === 'large' ? 'medium' : 'default'),
            title: submit_button_title,
            variant: "secondary",
            size: size === 'default' ? 'medium' : size
          }, triggerParams));
        }
      }

      validateDOMAttributes(null, mainParams);
      validateDOMAttributes(null, shellParams);
      this.attributes = validateDOMAttributes(null, attributes);
      return React.createElement("span", mainParams, label && React.createElement(FormLabel, {
        id: id + '-label',
        for_id: id,
        text: label,
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton,
        onMouseDown: this.toggleVisible
      }), React.createElement("span", {
        className: "dnb-autocomplete__inner",
        ref: this._ref
      }, _ref16, showStatus && React.createElement(FormStatus, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), React.createElement("span", {
        className: "dnb-autocomplete__row"
      }, React.createElement("span", shellParams, CustomInput ? React.createElement(CustomInput, inputParams) : React.createElement(Input, _extends({
        icon: visibleIndicator ? React.createElement(ProgressIndicator, {
          size: size === 'large' ? 'medium' : 'small'
        }) : input_icon,
        icon_size: icon_size || (size === 'large' ? 'medium' : 'default'),
        size: size,
        status: !opened && status ? status_state : null,
        status_state: status_state,
        type: null,
        submit_element: submitButton,
        input_state: this.state.skipFocusDuringChange ? 'focus' : undefined,
        ref: this._refInput
      }, inputParams)), React.createElement(DrawerList, {
        id: id,
        className: classnames('dnb-autocomplete__root', drawer_class),
        inner_class: "dnb-autocomplete__list",
        value: selected_item,
        default_value: default_value,
        scrollable: scrollable,
        focusable: focusable,
        no_animation: no_animation,
        no_scroll_animation: no_scroll_animation,
        skip_portal: skip_portal,
        prevent_selection: prevent_selection,
        triangle_position: triangle_position || icon_position,
        keep_open: keep_open,
        prevent_close: prevent_close,
        align_drawer: align_autocomplete,
        fixed_position: fixed_position,
        disabled: disabled,
        max_height: max_height,
        direction: direction,
        size: size,
        options_render: options_render,
        on_change: this.onChangeHandler,
        on_select: this.onSelectHandler,
        on_hide: this.onHideHandler,
        on_pre_change: this.onPreChangeHandler
      })), suffix && React.createElement(Suffix, {
        className: "dnb-autocomplete__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))), IS_MAC && React.createElement("span", {
        className: "dnb-sr-only",
        "aria-live": "assertive"
      }, AutocompleteInstance.getCurrentDataTitle(active_item, this.context.drawerList.original_data)), React.createElement("span", {
        className: "dnb-sr-only",
        "aria-live": "assertive"
      }, ariaLiveUpdate));
    }
  }], [{
    key: "parseDataItem",
    value: function parseDataItem(dataItem) {
      var toParse = parseContentTitle(dataItem, {
        separator: ' '
      });

      if (typeof toParse !== 'string' && Array.isArray(toParse)) {
        return AutocompleteInstance.parseDataItem(toParse);
      }

      return toParse;
    }
  }, {
    key: "createSearchIndex",
    value: function createSearchIndex(data) {
      return data.map(function (dataItem) {
        var searchChunk = AutocompleteInstance.parseDataItem(dataItem);
        return {
          dataItem: dataItem,
          searchChunk: searchChunk
        };
      });
    }
  }, {
    key: "getCurrentDataTitle",
    value: function getCurrentDataTitle(selected_item, data) {
      var currentData = getCurrentData(selected_item, data);
      return parseContentTitle(currentData, {
        separator: ' ',
        preferSelectedValue: true
      });
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        state.skipHighlight = isTrue(props.disable_highlighting);

        if (props.input_value !== 'initval' && typeof state.inputValue === 'undefined' && props.input_value && props.input_value.length > 0) {
          state.inputValue = props.input_value;
        }

        if (props.data !== state.init_data) {
          state.updateData(props.data);
          state.init_data = props.data;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return AutocompleteInstance;
}(React.PureComponent);

AutocompleteInstance.defaultProps = Autocomplete.defaultProps;
AutocompleteInstance.contextType = DrawerListContext;
process.env.NODE_ENV !== "production" ? AutocompleteInstance.propTypes = Autocomplete.propTypes : void 0;
Autocomplete.HorizontalItem = DrawerList.HorizontalItem;