import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _extends from "@babel/runtime/helpers/esm/extends";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import { warn, makeUniqueId, isTrue, extendPropsWithContext, registerElement, validateDOMAttributes, processChildren, getStatusState, dispatchCustomElementEvent } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';
import IconPrimary from '../icon-primary/IconPrimary';
import FormStatus from '../form-status/FormStatus';
import Tooltip from '../tooltip/Tooltip';
export var buttonVariantPropType = {
  variant: PropTypes.oneOf(['primary', 'secondary', 'tertiary', 'signal'])
};
export var buttonPropTypes = _extends({
  text: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  type: PropTypes.string,
  title: PropTypes.string,
  variant: buttonVariantPropType.variant,
  size: PropTypes.oneOf(['default', 'small', 'medium', 'large']),
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  icon_position: PropTypes.oneOf(['left', 'right']),
  icon_size: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  tooltip: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  id: PropTypes.string,
  class: PropTypes.string,
  href: PropTypes.string,
  wrap: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  bounding: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  inner_ref: PropTypes.object,
  className: PropTypes.string,
  innerRef: PropTypes.object,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  element: PropTypes.node
}, spacingPropTypes, {
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  onClick: PropTypes.func,
  on_click: PropTypes.oneOfType([PropTypes.string, PropTypes.func])
});

var Button = function (_React$PureComponent) {
  _inherits(Button, _React$PureComponent);

  var _super = _createSuper(Button);

  function Button(props) {
    var _this;

    _classCallCheck(this, Button);

    _this = _super.call(this, props);

    _this.onClickHandler = function (event) {
      var afterContent = dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_click', {
        event: event
      });

      if (afterContent && React.isValidElement(afterContent)) {
        _this.setState({
          afterContent: afterContent
        });
      }
    };

    _this._id = props.id || (props.status || props.tooltip) && makeUniqueId();
    _this._ref = React.createRef();
    _this.state = {
      afterContent: null
    };
    return _this;
  }

  _createClass(Button, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.innerRef) {
        this.props.innerRef.current = this._ref.current;
      }

      if (this.props.inner_ref) {
        this.props.inner_ref.current = this._ref.current;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = extendPropsWithContext(this.props, Button.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.FormRow, this.context.Button);

      var class_name = props.class,
          className = props.className,
          type = props.type,
          variant = props.variant,
          size = props.size,
          title = props.title,
          tooltip = props.tooltip,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          id = props.id,
          disabled = props.disabled,
          _text = props.text,
          _icon = props.icon,
          _icon_position = props.icon_position,
          icon_size = props.icon_size,
          href = props.href,
          wrap = props.wrap,
          bounding = props.bounding,
          skeleton = props.skeleton,
          element = props.element,
          inner_ref = props.inner_ref,
          innerRef = props.innerRef,
          attributes = _objectWithoutProperties(props, ["class", "className", "type", "variant", "size", "title", "tooltip", "status", "status_state", "status_animation", "global_status_id", "id", "disabled", "text", "icon", "icon_position", "icon_size", "href", "wrap", "bounding", "skeleton", "element", "inner_ref", "innerRef"]);

      var showStatus = getStatusState(status);
      var text = props.text,
          icon = props.icon,
          iconPosition = props.icon_position;
      var usedVariant = variant;
      var usedSize = size;
      var iconSize = icon_size;
      var content = Button.getContent(this.props);

      if (variant === 'tertiary' && (content || text) && !icon && icon !== false) {
        warn("A Tertiary Button requires an icon. Please declare an icon to: ".concat(content));
      }

      var isIconOnly = Boolean(!text && !content && icon);

      if (isIconOnly) {
        if (!usedVariant) {
          usedVariant = 'secondary';
        }

        if (!iconSize && (usedSize === 'default' || usedSize === 'large')) {
          iconSize = 'medium';
        }

        if (!usedSize) {
          usedSize = 'medium';
        }
      } else if (content) {
        if (!usedVariant) {
          usedVariant = 'primary';
        }

        if (!usedSize) {
          usedSize = 'default';
        }
      }

      var classes = classnames("dnb-button dnb-button--".concat(usedVariant || 'primary'), (text || content) && 'dnb-button--has-text', createSkeletonClass(variant === 'tertiary' ? 'font' : 'shape', skeleton, this.context), createSpacingClasses(props), class_name, className, icon && "dnb-button--icon-position-".concat(iconPosition, " dnb-button--has-icon") + (iconSize ? " dnb-button--icon-size-".concat(iconSize) : ""), usedSize && usedSize !== 'default' && "dnb-button--size-".concat(usedSize), wrap && 'dnb-button--wrap', status && "dnb-button__status--".concat(status_state));

      var params = _extends({
        className: classes,
        type: type,
        title: title,
        id: this._id,
        disabled: isTrue(disabled)
      }, attributes, {
        onClick: this.onClickHandler
      });

      if (href) {
        params.href = href;
      }

      skeletonDOMAttributes(params, skeleton, this.context);
      validateDOMAttributes(this.props, params);
      var Element = element ? element : href ? 'a' : 'button';
      return React.createElement(React.Fragment, null, React.createElement(Element, _extends({
        ref: this._ref
      }, params), React.createElement(Content, _extends({}, this.props, {
        icon: icon,
        text: text,
        icon_size: iconSize,
        content: content,
        isIconOnly: isIconOnly,
        skeleton: isTrue(skeleton)
      }))), this.state.afterContent, showStatus && React.createElement(FormStatus, {
        id: this._id + '-form-status',
        global_status_id: global_status_id,
        label: text,
        text: status,
        status: status_state,
        text_id: this._id + '-status',
        animation: status_animation,
        skeleton: skeleton
      }), tooltip && this._ref && React.createElement(Tooltip, _extends({
        id: this._id + '-tooltip',
        component: this._ref
      }, React.isValidElement(tooltip) && tooltip.props ? tooltip.props : {
        children: tooltip
      })));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Button.tagName, Button, Button.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      return processChildren(props);
    }
  }]);

  return Button;
}(React.PureComponent);

Button.tagName = 'dnb-button';
Button.contextType = Context;
Button.defaultProps = {
  type: 'button',
  text: null,
  variant: null,
  size: null,
  title: null,
  icon: null,
  icon_position: 'right',
  icon_size: null,
  href: null,
  id: null,
  class: null,
  wrap: false,
  bounding: false,
  skeleton: null,
  disabled: null,
  tooltip: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  inner_ref: null,
  className: null,
  innerRef: null,
  children: null,
  element: null,
  custom_element: null,
  custom_method: null,
  onClick: null,
  on_click: null
};
export { Button as default };
process.env.NODE_ENV !== "production" ? Button.propTypes = _extends({}, buttonPropTypes) : void 0;

var _ref = React.createElement("span", {
  key: "button-bounding",
  className: "dnb-button__bounding"
});

var _ref2 = React.createElement("span", {
  key: "button-text-empty",
  className: "dnb-button__alignment"
}, "\u200C");

var _ref3 = React.createElement("span", {
  key: "button-text-empty",
  className: "dnb-button__alignment"
}, "\u200C");

var Content = function (_React$PureComponent2) {
  _inherits(Content, _React$PureComponent2);

  var _super2 = _createSuper(Content);

  function Content() {
    _classCallCheck(this, Content);

    return _super2.apply(this, arguments);
  }

  _createClass(Content, [{
    key: "render",
    value: function render() {
      var text = this.props.text;
      var _this$props = this.props,
          title = _this$props.title,
          content = _this$props.content,
          icon = _this$props.icon,
          icon_size = _this$props.icon_size,
          bounding = _this$props.bounding,
          skeleton = _this$props.skeleton,
          isIconOnly = _this$props.isIconOnly;
      var ret = [];

      if (isTrue(bounding)) {
        ret.push(_ref);
      }

      if (typeof content === 'string') {
        text = content;
      } else if (content) {
        ret.push(content);
      }

      if (text) {
        ret.push(_ref2, React.createElement("span", {
          key: "button-text",
          className: "dnb-button__text dnb-skeleton--show-font"
        }, text));
      } else if (icon) {
        ret.push(_ref3);
      }

      if (icon) {
        ret.push(React.isValidElement(icon) && /Icon/i.test(String(icon.type)) ? React.cloneElement(icon, {
          key: 'button-icon',
          className: "dnb-button__icon ".concat(icon.props.className || '')
        }) : React.createElement(IconPrimary, {
          key: "button-icon",
          className: "dnb-button__icon",
          icon: icon,
          size: icon_size,
          "aria-hidden": isIconOnly && !title ? null : true,
          skeleton: skeleton
        }));
      }

      return ret;
    }
  }]);

  return Content;
}(React.PureComponent);

Content.defaultProps = {
  text: null,
  title: null,
  content: null,
  icon: null,
  icon_size: 'default',
  bounding: false,
  skeleton: null,
  isIconOnly: null
};
process.env.NODE_ENV !== "production" ? Content.propTypes = {
  title: PropTypes.string,
  text: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.array]),
  content: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  icon_size: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  bounding: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.bool,
  isIconOnly: PropTypes.bool
} : void 0;