import "core-js/modules/es.array.concat.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import { isTrue, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, getStatusState, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import AlignmentHelper from '../../shared/AlignmentHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';
import Context from '../../shared/Context';
import Suffix from '../../shared/helpers/Suffix';
import FormLabel from '../form-label/FormLabel';
import FormStatus from '../form-status/FormStatus';

var _ref = React.createElement(AlignmentHelper, null);

var _ref2 = React.createElement("span", {
  className: "dnb-checkbox__focus"
});

var Checkbox = function (_React$PureComponent) {
  _inherits(Checkbox, _React$PureComponent);

  var _super = _createSuper(Checkbox);

  function Checkbox(props) {
    var _this;

    _classCallCheck(this, Checkbox);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      switch (keycode(event)) {
        case 'enter':
          _this.onChangeHandler(event);

          break;
      }
    };

    _this.onChangeHandler = function (event) {
      if (isTrue(_this.props.readOnly)) {
        return event.preventDefault();
      }

      var checked = !_this.state.checked;

      _this.setState({
        checked: checked,
        _listenForPropChanges: false
      });

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        checked: checked,
        event: event
      });

      if (_this._refInput.current) {
        _this._refInput.current.focus();
      }
    };

    _this._refInput = React.createRef();
    _this._id = props.id || makeUniqueId();
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(Checkbox, [{
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, Checkbox.defaultProps, {
        skeleton: this.context && this.context.skeleton
      }, this.context.getTranslation(this.props).Checkbox, this.context.FormRow, this.context.Checkbox);

      var value = props.value,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          size = props.size,
          label = props.label,
          label_position = props.label_position,
          label_sr_only = props.label_sr_only,
          title = props.title,
          disabled = props.disabled,
          readOnly = props.readOnly,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _id = props.id,
          _default_state = props.default_state,
          _checked = props.checked,
          attributes = props.attributes,
          children = props.children,
          on_change = props.on_change,
          on_state_update = props.on_state_update,
          custom_method = props.custom_method,
          custom_element = props.custom_element,
          rest = _objectWithoutProperties(props, ["value", "status", "status_state", "status_animation", "global_status_id", "suffix", "size", "label", "label_position", "label_sr_only", "title", "disabled", "readOnly", "skeleton", "className", "class", "id", "default_state", "checked", "attributes", "children", "on_change", "on_state_update", "custom_method", "custom_element"]);

      var checked = this.state.checked;
      var id = this._id;
      var showStatus = getStatusState(status);
      var mainParams = {
        className: classnames("dnb-checkbox dnb-form-component", createSkeletonClass(null, skeleton), createSpacingClasses(props), className, _className, status && "dnb-checkbox__status--".concat(status_state), size && "dnb-checkbox--".concat(size), label && "dnb-checkbox--label-position-".concat(label_position || 'right'))
      };

      var inputParams = _extends({
        disabled: disabled,
        checked: checked
      }, rest);

      if (showStatus || suffix) {
        inputParams['aria-describedby'] = combineDescribedBy(inputParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (readOnly) {
        inputParams['aria-readonly'] = inputParams.readOnly = true;
      }

      skeletonDOMAttributes(inputParams, skeleton, this.context);
      validateDOMAttributes(this.props, inputParams);
      var statusComp = showStatus && React.createElement(FormStatus, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        width_selector: id + ', ' + id + '-label',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      });
      return React.createElement("span", mainParams, React.createElement("span", {
        className: "dnb-checkbox__order"
      }, label && React.createElement(FormLabel, {
        id: id + '-label',
        for_id: id,
        text: label,
        disabled: disabled,
        skeleton: skeleton,
        sr_only: label_sr_only
      }), React.createElement("span", {
        className: "dnb-checkbox__inner"
      }, _ref, label_position === 'left' && statusComp, React.createElement("span", {
        className: "dnb-checkbox__shell"
      }, React.createElement("input", _extends({
        id: id,
        name: id,
        type: "checkbox",
        title: title,
        "aria-checked": checked,
        className: "dnb-checkbox__input",
        value: checked ? value || '' : '',
        disabled: isTrue(disabled)
      }, inputParams, {
        onChange: this.onChangeHandler,
        onKeyDown: this.onKeyDownHandler,
        ref: this._refInput
      })), React.createElement("span", {
        className: classnames('dnb-checkbox__button', createSkeletonClass('shape', skeleton, this.context)),
        "aria-hidden": true
      }, _ref2), React.createElement(CheckIcon, {
        size: size
      }))), suffix && React.createElement(Suffix, {
        className: "dnb-checkbox__suffix",
        id: id + '-suffix',
        context: props
      }, suffix)), (label_position === 'right' || !label_position) && statusComp);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Checkbox.tagName, Checkbox, Checkbox.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.checked !== state._checked) {
          if (props.default_state !== null && typeof state.checked === 'undefined') {
            state.checked = Checkbox.parseChecked(props.default_state);
          } else {
            state.checked = Checkbox.parseChecked(props.checked);
          }
        }
      }

      state._listenForPropChanges = true;

      if (state.checked !== state.__checked) {
        dispatchCustomElementEvent({
          props: props
        }, 'on_state_update', {
          checked: state.checked
        });
      }

      state._checked = props.checked;
      state.__checked = state.checked;
      return state;
    }
  }]);

  return Checkbox;
}(React.PureComponent);

Checkbox.tagName = 'dnb-checkbox';
Checkbox.contextType = Context;
Checkbox.defaultProps = {
  label: null,
  label_position: null,
  title: null,
  default_state: null,
  checked: null,
  disabled: null,
  id: null,
  size: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  value: null,
  attributes: null,
  readOnly: false,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_state_update: null
};

Checkbox.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

export { Checkbox as default };
process.env.NODE_ENV !== "production" ? Checkbox.propTypes = _extends({
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_position: PropTypes.oneOf(['left', 'right']),
  title: PropTypes.string,
  default_state: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  checked: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  id: PropTypes.string,
  size: PropTypes.oneOf(['default', 'medium', 'large']),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  value: PropTypes.string,
  attributes: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  readOnly: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  class: PropTypes.string
}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_change: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;
export var CheckIcon = function CheckIcon(_ref3) {
  var size = _ref3.size,
      props = _objectWithoutProperties(_ref3, ["size"]);

  var vB = 16;

  if (size === 'large') {
    vB = 24;
  }

  return React.createElement("svg", _extends({
    width: vB,
    height: vB,
    viewBox: "0 0 ".concat(vB, " ").concat(vB),
    fill: "none",
    className: "dnb-checkbox__gfx",
    "aria-hidden": true
  }, props), React.createElement("path", {
    d: size === 'large' ? 'M1.5 15L7.5 21L22.5 3' : 'M1 10L5 14L15 2',
    stroke: "currentColor",
    strokeWidth: "1.5",
    strokeLinecap: "round",
    strokeLinejoin: "round"
  }));
};
process.env.NODE_ENV !== "production" ? CheckIcon.propTypes = {
  size: PropTypes.string
} : void 0;
CheckIcon.defaultProps = {
  size: 'default'
};