import "core-js/modules/es.array.find.js";
import "core-js/modules/es.array.join.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.object.values.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.replace.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import format from 'date-fns/format';
import subMonths from 'date-fns/subMonths';
import addMonths from 'date-fns/addMonths';
import addWeeks from 'date-fns/addWeeks';
import addDays from 'date-fns/addDays';
import isSameDay from 'date-fns/isSameDay';
import isSameMonth from 'date-fns/isSameMonth';
import startOfDay from 'date-fns/startOfDay';
import endOfDay from 'date-fns/endOfDay';
import differenceInCalendarDays from 'date-fns/differenceInCalendarDays';
import differenceInMonths from 'date-fns/differenceInMonths';
import lastDayOfMonth from 'date-fns/lastDayOfMonth';
import setDate from 'date-fns/setDate';
import keycode from 'keycode';
import nbLocale from 'date-fns/locale/nb';
import { isDisabled, makeDayObject, toRange, getWeek, dayOffset, getCalendar } from './DatePickerCalc';
import Button from '../button/Button';
import DatePickerContext from './DatePickerContext';

var DatePickerCalendar = function (_React$PureComponent) {
  _inherits(DatePickerCalendar, _React$PureComponent);

  var _super = _createSuper(DatePickerCalendar);

  function DatePickerCalendar(props) {
    var _this;

    _classCallCheck(this, DatePickerCalendar);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      var _event$target;

      if (String(event === null || event === void 0 ? void 0 : (_event$target = event.target) === null || _event$target === void 0 ? void 0 : _event$target.nodeName).toLowerCase() === 'td') {
        try {
          _this._listRef.current.focus({
            preventScroll: true
          });
        } catch (e) {}
      }

      var _this$props = _this.props,
          nr = _this$props.nr,
          isRange = _this$props.isRange,
          onlyMonth = _this$props.onlyMonth,
          hideNav = _this$props.hideNav,
          onKeyDown = _this$props.onKeyDown;

      if (typeof onKeyDown === 'function') {
        return onKeyDown(event, _this._listRef, nr);
      }

      var keyCode = keycode(event);

      switch (keyCode) {
        case 'enter':
        case 'space':
        case 'left':
        case 'right':
        case 'up':
        case 'down':
          event.preventDefault();
          event.persist();
          break;

        default:
          return;
      }

      var type = nr === 0 ? 'start' : 'end';

      if (!isRange) {
        type = 'start';
      }

      var newDate = _this.context["".concat(type, "Date")];

      if (newDate) {
        newDate = _this.keyNavCalc(newDate, keyCode);
      } else {
        newDate = _this.context["".concat(type, "Month")] || (isRange && nr === 1 ? addMonths(new Date(), 1) : new Date());
      }

      if (newDate === _this.context["".concat(type, "Date")]) {
        switch (keyCode) {
          case 'enter':
          case 'space':
            _this.callOnSelect({
              event: event,
              nr: nr,
              hidePicker: true
            });

            break;
        }
      } else {
        var state = {};

        var currentMonth = _this.context["".concat(type, "Month")];

        if (currentMonth && !_this.context["".concat(type, "Date")] || currentMonth && Math.abs(differenceInMonths(newDate, currentMonth)) > 1) {
          if (!isRange) {
            newDate = currentMonth;
          } else {
            newDate = nr === 0 ? setDate(currentMonth, 1) : lastDayOfMonth(currentMonth);
          }
        } else if (currentMonth && !isSameMonth(_this.context["".concat(type, "Date")], currentMonth)) {
          state["".concat(type, "Month")] = newDate;
        }

        newDate = _this.findValid(newDate, keyCode);

        if (_this.hasReachedEnd(newDate)) {
          return;
        }

        state["".concat(type, "Date")] = newDate;

        if (!isRange) {
          state.endDate = newDate;
        } else {
          if (!_this.context.startDate) {
            state.startDate = newDate;
          }

          if (!_this.context.endDate) {
            state.endDate = newDate;
          }
        }

        if (onlyMonth || hideNav) {
          if (!isSameMonth(state.startDate, _this.context.startDate) || !isSameMonth(state.endDate, _this.context.startDate)) {
              return;
            }
        }

        state.changeMonthViews = true;

        _this.context.setDate(state, function () {
          _this.callOnSelect({
            event: event,
            nr: nr,
            hidePicker: false
          });

          if (_this._listRef && _this._listRef.current) {
            _this._listRef.current.focus({
              preventScroll: true
            });
          }
        });
      }
    };

    _this.hasReachedEnd = function (date) {
      return isDisabled(date, _this.context.minDate, _this.context.maxDate);
    };

    _this.buildClassNames = function (day) {
      return classnames(day.className, day.isStartDate && 'dnb-date-picker__day--start-date', day.isEndDate && 'dnb-date-picker__day--end-date', day.isPreview && 'dnb-date-picker__day--preview', day.isWithinSelection && 'dnb-date-picker__day--within-selection', day.isSelectable && 'dnb-date-picker__day--selectable', day.isInactive && 'dnb-date-picker__day--inactive', day.isDisabled && 'dnb-date-picker__day--disabled', day.isToday && 'dnb-date-picker__day--today');
    };

    _this._listRef = React.createRef();
    _this._labelRef = React.createRef();
    _this._days = {};
    _this._cache = {};
    return _this;
  }

  _createClass(DatePickerCalendar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.props.noAutofocus && this.props.nr === 0) {
        if (this._listRef.current) {
          this._listRef.current.focus({
            preventScroll: true
          });
        }
      }
    }
  }, {
    key: "callOnSelect",
    value: function callOnSelect(args) {
      this.props.onSelect && this.props.onSelect(args);
    }
  }, {
    key: "keyNavCalc",
    value: function keyNavCalc(date, keyCode) {
      switch (keyCode) {
        case 'left':
          date = addDays(date, -1);
          break;

        case 'right':
          date = addDays(date, 1);
          break;

        case 'up':
          date = addWeeks(date, -1);
          break;

        case 'down':
          date = addWeeks(date, 1);
          break;
      }

      return date;
    }
  }, {
    key: "findValid",
    value: function findValid(date, keyCode) {
      if (this.context.props.on_days_render) {
        var month = format(date, 'yyyy-MM');

        if (!this._days) {
          return date;
        }

        if (!this._days[month]) {
          this.getDays(date);
        }

        if (Array.isArray(this._days[month])) {
          var foundDate = this._days[month].find(function (cur) {
            return isSameDay(cur.date, date);
          });

          if (foundDate && foundDate.date && (foundDate.isDisabled || foundDate.isSelectable === false || foundDate.isInactive)) {
            var nextDate = this.keyNavCalc(foundDate.date, keyCode);
            foundDate.date = this.findValid(nextDate, keyCode);
          }

          if (foundDate && foundDate.date) {
            return foundDate.date;
          }
        }
      }

      return date;
    }
  }, {
    key: "getCacheKey",
    value: function getCacheKey() {
      var _this$props2 = this.props,
          nr = _this$props2.nr,
          month = _this$props2.month,
          firstDayOfWeek = _this$props2.firstDayOfWeek,
          onlyMonth = _this$props2.onlyMonth,
          hideNextMonthWeek = _this$props2.hideNextMonthWeek;
      var _this$context = this.context,
          startDate = _this$context.startDate,
          endDate = _this$context.endDate,
          hoverDate = _this$context.hoverDate,
          maxDate = _this$context.maxDate,
          minDate = _this$context.minDate;
      return [nr, month, firstDayOfWeek, onlyMonth, hideNextMonthWeek, startDate, endDate, hoverDate, maxDate, minDate].join('|');
    }
  }, {
    key: "getMemorizedDays",
    value: function getMemorizedDays(month) {
      var key = this.getCacheKey();

      if (this._cache[key]) {
        return this._cache[key];
      } else {
        var count = 0;
        return this._cache[key] = Object.values(this.getDays(month).reduce(function (acc, cur, i) {
          acc[count] = acc[count] || [];
          acc[count].push(cur);

          if (i % 7 === 6) {
            count++;
          }

          return acc;
        }, {}));
      }
    }
  }, {
    key: "getDays",
    value: function getDays(month) {
      var _this$props3 = this.props,
          nr = _this$props3.nr,
          firstDayOfWeek = _this$props3.firstDayOfWeek,
          onlyMonth = _this$props3.onlyMonth,
          hideNextMonthWeek = _this$props3.hideNextMonthWeek;
      var _this$context2 = this.context,
          startDate = _this$context2.startDate,
          endDate = _this$context2.endDate,
          hoverDate = _this$context2.hoverDate,
          maxDate = _this$context2.maxDate,
          minDate = _this$context2.minDate;
      var days = getCalendar(month || new Date(), dayOffset(firstDayOfWeek), {
        onlyMonth: onlyMonth,
        hideNextMonthWeek: hideNextMonthWeek
      }).map(function (date) {
        return makeDayObject(date, {
          startDate: startDate,
          endDate: endDate,
          hoverDate: hoverDate,
          minDate: minDate,
          maxDate: maxDate,
          month: month
        });
      });

      if (this.context.props.on_days_render) {
        var changedDays = this.context.props.on_days_render(days, nr);

        if (Array.isArray(changedDays)) {
          days = changedDays;
        }
      }

      this._days[format(month, 'yyyy-MM')] = days;
      return days;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          id = _this$props4.id,
          nr = _this$props4.nr,
          rtl = _this$props4.rtl,
          month = _this$props4.month,
          isRange = _this$props4.isRange,
          titleFormat = _this$props4.titleFormat,
          locale = _this$props4.locale,
          firstDayOfWeek = _this$props4.firstDayOfWeek,
          dayOfWeekFormat = _this$props4.dayOfWeekFormat,
          hideNav = _this$props4.hideNav,
          hideDays = _this$props4.hideDays,
          onPrev = _this$props4.onPrev,
          onNext = _this$props4.onNext,
          resetDate = _this$props4.resetDate,
          onHover = _this$props4.onHover,
          prevBtn = _this$props4.prevBtn,
          nextBtn = _this$props4.nextBtn;
      var _this$context3 = this.context,
          startDate = _this$context3.startDate,
          endDate = _this$context3.endDate,
          hoverDate = _this$context3.hoverDate,
          maxDate = _this$context3.maxDate,
          minDate = _this$context3.minDate,
          selected_month = _this$context3.translation.DatePicker.selected_month;
      var weekDays = this.getMemorizedDays(month);
      return React.createElement("div", {
        className: 'dnb-date-picker__calendar' + (rtl ? " rtl" : ""),
        lang: locale === null || locale === void 0 ? void 0 : locale.code
      }, !hideNav && React.createElement("div", {
        className: "dnb-date-picker__header"
      }, React.createElement("div", {
        className: "dnb-date-picker__header__nav"
      }, React.createElement(PrevButton, {
        nr: nr,
        minDate: minDate,
        month: month,
        locale: locale,
        context: this.context,
        prevBtn: prevBtn,
        onPrev: onPrev
      })), React.createElement("label", {
        id: "".concat(id, "--title"),
        className: "dnb-date-picker__header__title dnb-no-focus",
        title: selected_month.replace(/%s/, format(month, titleFormat, {
          locale: locale
        })),
        tabIndex: "-1",
        ref: this._labelRef
      }, format(month, titleFormat, {
        locale: locale
      })), React.createElement("div", {
        className: "dnb-date-picker__header__nav"
      }, React.createElement(NextButton, {
        nr: nr,
        maxDate: maxDate,
        month: month,
        locale: locale,
        context: this.context,
        nextBtn: nextBtn,
        onNext: onNext
      }))), React.createElement("table", {
        role: "grid",
        className: "dnb-no-focus",
        tabIndex: "0",
        "aria-labelledby": "".concat(id, "--title"),
        onKeyDown: this.onKeyDownHandler,
        ref: this._listRef
      }, !hideDays && React.createElement("thead", {
        "aria-hidden": true
      }, React.createElement("tr", {
        role: "row",
        className: "dnb-date-picker__labels"
      }, getWeek(dayOffset(firstDayOfWeek)).map(function (day, i) {
        return React.createElement("th", {
          key: i,
          role: "columnheader",
          scope: "col",
          className: "dnb-date-picker__labels__day dnb-date-picker__labels__day--".concat(format(day, 'i', {
            locale: locale
          })),
          "aria-label": format(day, 'EEEE', {
            locale: locale
          })
        }, format(day, dayOfWeekFormat, {
          locale: locale
        }));
      }))), React.createElement("tbody", null, weekDays.map(function (week, i) {
        return React.createElement("tr", {
          key: 'week' + i,
          role: "row",
          className: "dnb-date-picker__days"
        }, week.map(function (day, i) {
          var title = format(day.date, 'PPPP', {
            locale: locale
          });
          var handleAsDisabled = day.isLastMonth || day.isNextMonth || day.isDisabled || day.isInactive;
          var paramsCell = {};
          paramsCell.tabIndex = '-1';

          if (day.isStartDate) {
            paramsCell.id = id + '--button-start';
          } else if (day.isEndDate) {
            paramsCell.id = id + '--button-end';
          }

          var paramsButton = {};

          if (nr === 0 ? day.isStartDate : day.isEndDate) {
            paramsButton['aria-current'] = 'date';
            paramsCell['aria-selected'] = true;
          }

          return React.createElement("td", _extends({
            key: 'day' + i,
            role: "gridcell",
            className: classnames("dnb-date-picker__day dnb-no-focus", _this2.buildClassNames(day)),
            onFocus: _this2.onKeyDownHandler
          }, paramsCell), React.createElement(Button, _extends({
            size: "medium",
            variant: "secondary",
            text: format(day.date, 'd', {
              locale: locale
            }),
            bounding: true,
            disabled: handleAsDisabled,
            tabIndex: handleAsDisabled ? '0' : '-1',
            "aria-disabled": handleAsDisabled,
            "aria-label": title
          }, paramsButton, {
            onClick: handleAsDisabled ? undefined : function (_ref) {
              var event = _ref.event;
              return onSelectRange({
                day: day,
                isRange: isRange,
                startDate: startDate,
                endDate: endDate,
                resetDate: resetDate,
                event: event,
                onSelect: function onSelect(state) {
                  return _this2.context.setDate(state, function () {
                    return _this2.callOnSelect({
                      event: event,
                      nr: nr,
                      hidePicker: !isRange
                    });
                  });
                }
              });
            },
            onMouseOver: handleAsDisabled ? undefined : function () {
              return onHoverDay({
                day: day,
                hoverDate: hoverDate,
                onHover: onHover
              });
            },
            onFocus: handleAsDisabled ? undefined : function () {
              return onHoverDay({
                day: day,
                hoverDate: hoverDate,
                onHover: onHover
              });
            }
          })));
        }));
      }))));
    }
  }]);

  return DatePickerCalendar;
}(React.PureComponent);

DatePickerCalendar.contextType = DatePickerContext;
DatePickerCalendar.defaultProps = {
  id: null,
  nr: null,
  month: null,
  prevBtn: true,
  nextBtn: true,
  titleFormat: 'MMMM yyyy',
  dayOfWeekFormat: 'EEEEEE',
  firstDayOfWeek: 'monday',
  hideNav: false,
  hideDays: false,
  onlyMonth: false,
  hideNextMonthWeek: false,
  noAutofocus: false,
  locale: nbLocale,
  rtl: false,
  onHover: null,
  onSelect: null,
  onPrev: null,
  onNext: null,
  isRange: null,
  resetDate: true,
  onKeyDown: null
};
export { DatePickerCalendar as default };
process.env.NODE_ENV !== "production" ? DatePickerCalendar.propTypes = {
  id: PropTypes.string,
  nr: PropTypes.number,
  month: PropTypes.instanceOf(Date),
  prevBtn: PropTypes.bool,
  nextBtn: PropTypes.bool,
  titleFormat: PropTypes.string,
  dayOfWeekFormat: PropTypes.string,
  firstDayOfWeek: PropTypes.string,
  hideNav: PropTypes.bool,
  hideDays: PropTypes.bool,
  onlyMonth: PropTypes.bool,
  hideNextMonthWeek: PropTypes.bool,
  noAutofocus: PropTypes.bool,
  onHover: PropTypes.func,
  onSelect: PropTypes.func,
  onPrev: PropTypes.func,
  onNext: PropTypes.func,
  locale: PropTypes.object,
  rtl: PropTypes.bool,
  isRange: PropTypes.bool,
  resetDate: PropTypes.bool,
  onKeyDown: PropTypes.func
} : void 0;

var PrevButton = function PrevButton(_ref2) {
  var nr = _ref2.nr,
      minDate = _ref2.minDate,
      month = _ref2.month,
      locale = _ref2.locale,
      context = _ref2.context,
      prevBtn = _ref2.prevBtn,
      onPrev = _ref2.onPrev,
      onKeyDown = _ref2.onKeyDown;

  if (!prevBtn) {
    return React.createElement(React.Fragment, null);
  }

  var disabled = minDate && isSameMonth(month, minDate);

  var onClick = function onClick() {
    return onPrev && !disabled && onPrev({
      nr: nr
    });
  };

  var prev_month = context.translation.DatePicker.prev_month;
  var title = prev_month.replace(/%s/, format(subMonths(month, 1), 'MMMM yyyy', {
    locale: locale
  }));
  return React.createElement(Button, {
    className: 'dnb-date-picker__prev' + (disabled ? " disabled" : ""),
    icon: "chevron_left",
    size: "small",
    "aria-label": title,
    onClick: onClick,
    onKeyDown: onKeyDown
  });
};

process.env.NODE_ENV !== "production" ? PrevButton.propTypes = {
  nr: PropTypes.number.isRequired,
  minDate: PropTypes.instanceOf(Date),
  month: PropTypes.object.isRequired,
  locale: PropTypes.object.isRequired,
  context: PropTypes.object.isRequired,
  prevBtn: PropTypes.bool.isRequired,
  onPrev: PropTypes.func.isRequired,
  onKeyDown: PropTypes.func
} : void 0;
PrevButton.defaultProps = {
  minDate: null,
  onKeyDown: null
};

var NextButton = function NextButton(_ref3) {
  var nr = _ref3.nr,
      maxDate = _ref3.maxDate,
      month = _ref3.month,
      locale = _ref3.locale,
      context = _ref3.context,
      nextBtn = _ref3.nextBtn,
      onNext = _ref3.onNext,
      onKeyDown = _ref3.onKeyDown;

  if (!nextBtn) {
    return React.createElement(React.Fragment, null);
  }

  var disabled = maxDate && isSameMonth(month, maxDate);

  var onClick = function onClick() {
    return onNext && !disabled && onNext({
      nr: nr
    });
  };

  var next_month = context.translation.DatePicker.next_month;
  var title = next_month.replace(/%s/, format(addMonths(month, 1), 'MMMM yyyy', {
    locale: locale
  }));
  return nextBtn && React.createElement(Button, {
    className: 'dnb-date-picker__next' + (disabled ? " disabled" : ""),
    icon: "chevron_right",
    size: "small",
    "aria-label": title,
    onClick: onClick,
    onKeyDown: onKeyDown
  });
};

process.env.NODE_ENV !== "production" ? NextButton.propTypes = {
  nr: PropTypes.number.isRequired,
  maxDate: PropTypes.instanceOf(Date),
  month: PropTypes.object.isRequired,
  locale: PropTypes.object.isRequired,
  context: PropTypes.object.isRequired,
  nextBtn: PropTypes.bool.isRequired,
  onNext: PropTypes.func.isRequired,
  onKeyDown: PropTypes.func
} : void 0;
NextButton.defaultProps = {
  maxDate: null,
  onKeyDown: null
};

var onSelectRange = function onSelectRange(_ref4) {
  var day = _ref4.day,
      isRange = _ref4.isRange,
      startDate = _ref4.startDate,
      endDate = _ref4.endDate,
      onSelect = _ref4.onSelect,
      resetDate = _ref4.resetDate,
      event = _ref4.event;
  event.persist();

  if (!isRange) {
    onSelect({
      startDate: startOfDay(day.date),
      endDate: endOfDay(day.date),
      event: event
    });
  } else if (!startDate || resetDate && startDate && endDate) {
    onSelect({
      startDate: startOfDay(day.date),
      endDate: undefined,
      event: event
    });
  } else {
    var hasEndDate = endDate;
    var daysToStartDate = Math.abs(differenceInCalendarDays(startDate, day.date));
    var daysToEndDate = Math.abs(differenceInCalendarDays(endDate, day.date));
    var range = toRange(startDate, day.date);

    if (hasEndDate && !resetDate && daysToStartDate < daysToEndDate) {
      range = toRange(endDate, day.date);
    }

    onSelect({
      startDate: startOfDay(range.startDate),
      endDate: endOfDay(range.endDate),
      event: event
    });
  }
};

var onHoverDay = function onHoverDay(_ref5) {
  var day = _ref5.day,
      hoverDate = _ref5.hoverDate,
      onHover = _ref5.onHover;

  if (!isSameDay(day.date, hoverDate)) {
    onHover && onHover(day.date);
  }
};