import "core-js/modules/es.array.concat.js";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import Button from '../button/Button';
import DatePickerContext from './DatePickerContext';
import { isTrue } from '../../shared/component-helper';
import { convertStringToDate } from './DatePickerCalc';

var _ref = React.createElement("span", null);

var _ref2 = React.createElement("span", null);

var _ref3 = React.createElement("span", null);

var DatePickerFooter = function (_React$PureComponent) {
  _inherits(DatePickerFooter, _React$PureComponent);

  var _super = _createSuper(DatePickerFooter);

  function DatePickerFooter() {
    var _this;

    _classCallCheck(this, DatePickerFooter);

    for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
      _args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(_args));

    _this.onSubmitHandler = function (args) {
      var onSubmit = _this.props.onSubmit;

      if (onSubmit) {
        onSubmit(args);
      }
    };

    _this.onCancelHandler = function (args) {
      var date_format = _this.context.props.date_format;
      var startDate = _this.context._startDate ? convertStringToDate(_this.context._startDate, {
        date_format: date_format
      }) : null;
      var endDate = _this.context._endDate ? convertStringToDate(_this.context._endDate, {
        date_format: date_format
      }) : startDate;

      if (args && args.event) {
        args.event.persist();
      }

      _this.context.setDate({
        startDate: startDate,
        endDate: endDate
      }, function () {
        var onCancel = _this.props.onCancel;

        if (onCancel) {
          onCancel(args);
        }
      });
    };

    _this.onResetHandler = function (args) {
      if (args && args.event) {
        args.event.persist();
      }

      _this.context.setDate({
        date: undefined,
        startDate: undefined,
        endDate: undefined
      }, function () {
        var onReset = _this.props.onReset;

        if (onReset) {
          onReset(args);
        }
      });
    };

    return _this;
  }

  _createClass(DatePickerFooter, [{
    key: "render",
    value: function render() {
      var isRange = this.props.isRange;
      var _this$context$props = this.context.props,
          show_reset_button = _this$context$props.show_reset_button,
          show_cancel_button = _this$context$props.show_cancel_button,
          show_submit_button = _this$context$props.show_submit_button;

      if (!isRange && !isTrue(show_submit_button) && !isTrue(show_cancel_button)) {
        return React.createElement(React.Fragment, null);
      }

      var _this$context$transla = this.context.translation.DatePicker,
          submit_button_text = _this$context$transla.submit_button_text,
          cancel_button_text = _this$context$transla.cancel_button_text,
          reset_button_text = _this$context$transla.reset_button_text;
      return React.createElement("div", {
        className: "dnb-date-picker__footer"
      }, (isRange || isTrue(show_submit_button)) && React.createElement(Button, {
        text: submit_button_text,
        onClick: this.onSubmitHandler
      }) || _ref, React.createElement("span", null, isTrue(show_reset_button) && React.createElement(Button, {
        text: reset_button_text,
        icon: "reset",
        icon_position: "left",
        variant: "tertiary",
        onClick: this.onResetHandler
      }) || _ref2, (isRange || isTrue(show_cancel_button)) && React.createElement(Button, {
        text: cancel_button_text,
        icon: "close",
        icon_position: "left",
        variant: "tertiary",
        onClick: this.onCancelHandler
      }) || _ref3));
    }
  }]);

  return DatePickerFooter;
}(React.PureComponent);

DatePickerFooter.contextType = DatePickerContext;
DatePickerFooter.defaultProps = {
  onSubmit: null,
  onCancel: null,
  onReset: null
};
export { DatePickerFooter as default };
process.env.NODE_ENV !== "production" ? DatePickerFooter.propTypes = {
  isRange: PropTypes.bool.isRequired,
  onSubmit: PropTypes.func,
  onCancel: PropTypes.func,
  onReset: PropTypes.func
} : void 0;