import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.find-index.js";
import "core-js/modules/es.array.for-each.js";
import "core-js/modules/es.array.index-of.js";
import "core-js/modules/es.array.join.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.array.reverse.js";
import "core-js/modules/es.array.slice.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.promise.js";
import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.string.match.js";
import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.string.split.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _extends from "@babel/runtime/helpers/esm/extends";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import "regenerator-runtime/runtime.js";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import addDays from 'date-fns/addDays';
import addMonths from 'date-fns/addMonths';
import addYears from 'date-fns/addYears';
import isValid from 'date-fns/isValid';
import parseISO from 'date-fns/parseISO';
import classnames from 'classnames';
import MaskedInput from 'react-text-mask';
import Input, { SubmitButton } from '../input/Input';
import keycode from 'keycode';
import { warn, validateDOMAttributes, dispatchCustomElementEvent } from '../../shared/component-helper';
import { convertStringToDate } from './DatePickerCalc';
import DatePickerContext from './DatePickerContext';

var _ref8 = React.createElement("span", {
  className: "dnb-date-picker--separator",
  "aria-hidden": true
}, ' – ');

var DatePickerInput = function (_React$PureComponent) {
  _inherits(DatePickerInput, _React$PureComponent);

  var _super = _createSuper(DatePickerInput);

  function DatePickerInput(props) {
    var _this;

    _classCallCheck(this, DatePickerInput);

    _this = _super.call(this, props);
    _this.state = {
      _listenForPropChanges: true,
      focusState: 'virgin'
    };

    _this.shortcutHandler = function () {
      var _ref = _asyncToGenerator(_regeneratorRuntime.mark(function _callee(e) {
        var _window, success, separators, possibleFormats, date, i, l, mode;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!_this.focusMode) {
                  _context.next = 24;
                  break;
                }

                success = (e.clipboardData || ((_window = window) === null || _window === void 0 ? void 0 : _window.clipboardData)).getData('text');

                if (!success) {
                  _context.next = 24;
                  break;
                }

                e.preventDefault();
                _context.prev = 4;
                separators = ['.', '/'];
                possibleFormats = ['yyyy-MM-dd'];
                possibleFormats.forEach(function (date) {
                  separators.forEach(function (sep) {
                    possibleFormats.push(date.replace(/-/g, sep));
                  });
                });
                possibleFormats.forEach(function (date) {
                  possibleFormats.push(date.split('').reverse().join(''));
                });
                i = 0, l = possibleFormats.length;

              case 10:
                if (!(i < l)) {
                  _context.next = 17;
                  break;
                }

                date = convertStringToDate(success, {
                  date_format: possibleFormats[i]
                });

                if (!date) {
                  _context.next = 14;
                  break;
                }

                return _context.abrupt("break", 17);

              case 14:
                ++i;
                _context.next = 10;
                break;

              case 17:
                mode = _this.focusMode === 'start' ? 'startDate' : 'endDate';

                if (date && !_this.state[mode]) {
                  _this.context.setState(_defineProperty({}, mode, date));
                }

                _context.next = 24;
                break;

              case 21:
                _context.prev = 21;
                _context.t0 = _context["catch"](4);
                warn(_context.t0);

              case 24:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[4, 21]]);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    _this.callOnChangeAsInvalid = function (state) {
      var _this$context$state = _extends({}, _this.context, state),
          startDate = _this$context$state.startDate,
          endDate = _this$context$state.endDate,
          event = _this$context$state.event;

      _this.context.updateState({
        hoverDate: null
      });

      if (_this.context.hasHadValidDate) {
        _this.context.callOnChangeHandler({
          startDate: startDate,
          endDate: endDate,
          event: event
        });

        _this.context.updateState({
          hasHadValidDate: false
        });
      }
    };

    _this.callOnChange = function (_ref2) {
      var startDate = _ref2.startDate,
          endDate = _ref2.endDate,
          event = _ref2.event;
      var state = {
        changeMonthViews: true,
        hasHadValidDate: false
      };

      if (typeof startDate !== 'undefined' && isValid(startDate)) {
        state.startDate = startDate;
      }

      if (!_this.props.isRange) {
        endDate = startDate;
      }

      if (typeof endDate !== 'undefined' && isValid(endDate)) {
        state.endDate = endDate;
      }

      _this.context.setDate(state, function () {
        if (typeof startDate !== 'undefined' && isValid(startDate) || typeof endDate !== 'undefined' && isValid(endDate)) {
          _this.context.callOnChangeHandler({
            event: event
          });
        }
      });
    };

    _this.callOnType = function (_ref3) {
      var event = _ref3.event;

      var getDates = function getDates() {
        return ['start', 'end'].reduce(function (acc, mode) {
          acc["".concat(mode, "Date")] = [_this["_".concat(mode, "Year")] || _this.context["__".concat(mode, "Year")] || 'yyyy', _this["_".concat(mode, "Month")] || _this.context["__".concat(mode, "Month")] || 'mm', _this["_".concat(mode, "Day")] || _this.context["__".concat(mode, "Day")] || 'dd'].join('-');
          return acc;
        }, {});
      };

      var _getDates = getDates(),
          startDate = _getDates.startDate,
          endDate = _getDates.endDate;

      startDate = parseISO(startDate);
      endDate = parseISO(endDate);

      if (!isValid(startDate)) {
        startDate = null;
      }

      if (!isValid(endDate)) {
        endDate = null;
      }

      var returnObject = _this.context.getReturnObject({
        startDate: startDate,
        endDate: endDate,
        event: event
      });

      if (returnObject.is_valid === false || returnObject.is_valid_start_date === false || returnObject.is_valid_end_date === false) {
        var _getDates2 = getDates(),
            _startDate = _getDates2.startDate,
            _endDate = _getDates2.endDate;

        var typedDates = _this.props.isRange ? {
          start_date: _startDate,
          end_date: _endDate
        } : {
          date: _startDate
        };
        returnObject = _extends({}, returnObject, typedDates);
      }

      dispatchCustomElementEvent(_this.context, 'on_type', returnObject);
    };

    _this.prepareCounting = function () {
      var _ref5 = _asyncToGenerator(_regeneratorRuntime.mark(function _callee2(_ref4) {
        var _this$callOnChange;

        var keyCode, target, event, isDate, isInRange, date, count, endPos;
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                keyCode = _ref4.keyCode, target = _ref4.target, event = _ref4.event;
                isDate = target.getAttribute('class').match(/__input--([day|month|year]+)($|\s)/)[1];
                isInRange = target.getAttribute('id').match(/[0-9]-([start|end]+)-/)[1];
                date = isInRange === 'start' ? _this.context.startDate : _this.context.endDate;

                if (date) {
                  _context2.next = 6;
                  break;
                }

                return _context2.abrupt("return");

              case 6:
                count = keyCode === 'up' ? 1 : -1;

                if (!(keyCode === 'up' || keyCode === 'down')) {
                  _context2.next = 17;
                  break;
                }

                _context2.t0 = isDate;
                _context2.next = _context2.t0 === 'day' ? 11 : _context2.t0 === 'month' ? 13 : _context2.t0 === 'year' ? 15 : 17;
                break;

              case 11:
                date = addDays(date, count);
                return _context2.abrupt("break", 17);

              case 13:
                date = addMonths(date, count);
                return _context2.abrupt("break", 17);

              case 15:
                date = addYears(date, count);
                return _context2.abrupt("break", 17);

              case 17:
                _this.callOnChange((_this$callOnChange = {}, _defineProperty(_this$callOnChange, isInRange === 'start' ? 'startDate' : 'endDate', date), _defineProperty(_this$callOnChange, "event", event), _this$callOnChange));

                _context2.next = 20;
                return wait(1);

              case 20:
                endPos = target.value.length;
                target.focus();
                target.setSelectionRange(0, endPos);

              case 23:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x2) {
        return _ref5.apply(this, arguments);
      };
    }();

    _this.onFocusHandler = function (event) {
      try {
        var target = event.target;
        var endPos = target.value.length;
        target.focus();
        target.setSelectionRange(0, endPos);
      } catch (e) {
        warn(e);
      }

      _this.setState({
        focusState: 'focus',
        _listenForPropChanges: false
      });
    };

    _this.onBlurHandler = function () {
      _this.focusMode = null;

      _this.setState({
        focusState: 'blur',
        _listenForPropChanges: false
      });
    };

    _this.onKeyDownHandler = function () {
      var _ref6 = _asyncToGenerator(_regeneratorRuntime.mark(function _callee3(event) {
        var keyCode, target, size, firstSelectionStart, secondSelectionStart, isValid, index, nextSibling, prevSibling, endPos;
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                keyCode = keycode(event);
                target = event.target;
                _context3.t0 = keyCode;
                _context3.next = _context3.t0 === 'up' ? 5 : _context3.t0 === 'down' ? 5 : _context3.t0 === 'tab' ? 9 : 10;
                break;

              case 5:
                event.persist();
                event.preventDefault();

                _this.prepareCounting({
                  event: event,
                  keyCode: keyCode,
                  target: target
                });

                return _context3.abrupt("return", false);

              case 9:
                return _context3.abrupt("return", false);

              case 10:
                size = parseFloat(target.getAttribute('size'));
                firstSelectionStart = target.selectionStart;
                _context3.next = 14;
                return wait(1);

              case 14:
                secondSelectionStart = target.selectionStart;
                isValid = /[0-9]/.test(keyCode);
                index = _this.refList.findIndex(function (_ref7) {
                  var current = _ref7.current;
                  return current.inputElement === target;
                });

                if (!(index < _this.refList.length - 1 && (secondSelectionStart === size && isValid && keyCode !== 'left' && keyCode !== 'backspace' || firstSelectionStart === size && keyCode === 'right'))) {
                  _context3.next = 30;
                  break;
                }

                _context3.prev = 18;

                if (_this.refList[index + 1].current) {
                  _context3.next = 21;
                  break;
                }

                return _context3.abrupt("return");

              case 21:
                nextSibling = _this.refList[index + 1].current.inputElement;

                if (nextSibling) {
                  nextSibling.focus();
                  nextSibling.setSelectionRange(0, 0);
                }

                _context3.next = 28;
                break;

              case 25:
                _context3.prev = 25;
                _context3.t1 = _context3["catch"](18);
                warn(_context3.t1);

              case 28:
                _context3.next = 36;
                break;

              case 30:
                if (!(firstSelectionStart === 0 && index > 0)) {
                  _context3.next = 36;
                  break;
                }

                _context3.t2 = keyCode;
                _context3.next = _context3.t2 === 'left' ? 34 : _context3.t2 === 'backspace' ? 34 : 36;
                break;

              case 34:
                try {
                  prevSibling = _this.refList[index - 1].current.inputElement;

                  if (prevSibling) {
                    endPos = prevSibling.value.length;
                    prevSibling.focus();
                    prevSibling.setSelectionRange(endPos, endPos);
                  }
                } catch (e) {
                  warn(e);
                }

                return _context3.abrupt("break", 36);

              case 36:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, null, [[18, 25]]);
      }));

      return function (_x3) {
        return _ref6.apply(this, arguments);
      };
    }();

    _this.set_startDay = function (event) {
      _this.setDate(event, 'start', 'Day');
    };

    _this.set_startMonth = function (event) {
      _this.setDate(event, 'start', 'Month');
    };

    _this.set_startYear = function (event) {
      _this.setDate(event, 'start', 'Year');
    };

    _this.set_endDay = function (event) {
      _this.setDate(event, 'end', 'Day');
    };

    _this.set_endMonth = function (event) {
      _this.setDate(event, 'end', 'Month');
    };

    _this.set_endYear = function (event) {
      _this.setDate(event, 'end', 'Year');
    };

    _this.setDate = function (event, mode, type) {
      event.persist();
      var value = event.target.value;
      _this["_".concat(mode).concat(type)] = value;

      if (_this.context["".concat(mode, "Date")]) {
        _this["tmp_".concat(mode, "Date")] = _this.context["".concat(mode, "Date")];
      }

      var fallback = _this["tmp_".concat(mode, "Date")];

      var year = _this["_".concat(mode, "Year")] || fallback && fallback.getFullYear();
      var month = _this["_".concat(mode, "Month")] || fallback && fallback.getMonth() + 1;
      var day = _this["_".concat(mode, "Day")] || fallback && fallback.getDate();
      var date = new Date(parseFloat(year), parseFloat(month) - 1, parseFloat(day));
      var isValidDate = !/[^0-9]/.test(day) && !/[^0-9]/.test(month) && !/[^0-9]/.test(year) && isValid(date) && date.getDate() == parseFloat(day) && date.getMonth() + 1 == parseFloat(month) && date.getFullYear() == parseFloat(year);

      if (isValidDate) {
        var _this$callOnChange2;

        _this.callOnChange((_this$callOnChange2 = {}, _defineProperty(_this$callOnChange2, "".concat(mode, "Date"), date), _defineProperty(_this$callOnChange2, "event", event), _this$callOnChange2));
      } else {
        var _this$callOnChangeAsI;

        _this.context.setDate(_defineProperty({}, "".concat(mode, "Date"), null));

        _this.context.updateState(_defineProperty({}, "__".concat(mode).concat(type), value));

        _this.callOnChangeAsInvalid((_this$callOnChangeAsI = {}, _defineProperty(_this$callOnChangeAsI, "".concat(mode, "Date"), null), _defineProperty(_this$callOnChangeAsI, "event", event), _this$callOnChangeAsI));
      }

      _this.callOnType({
        event: event
      });
    };

    _this.renderInputElement = function (params) {
      var _this$props = _this.props,
          id = _this$props.id,
          isRange = _this$props.isRange;
      _this.refList = [];

      var startDateList = _this.generateDateList(params, 'start');

      var endDateList = _this.generateDateList(params, 'end');

      return React.createElement("span", {
        id: "".concat(id, "-input"),
        className: "dnb-date-picker__input__wrapper"
      }, startDateList, isRange && _ref8, isRange && endDateList);
    };

    var _separators = props.maskOrder.match(props.separatorRexExp);

    _this.maskList = props.maskOrder.split(props.separatorRexExp).reduce(function (acc, cur) {
      if (cur) {
        acc.push(cur);

        if (_separators.length > 0) {
          acc.push(_separators.shift());
        }
      }

      return acc;
    }, []);
    _this._startDayRef = React.createRef();
    _this._startMonthRef = React.createRef();
    _this._startYearRef = React.createRef();
    _this._endDayRef = React.createRef();
    _this._endMonthRef = React.createRef();
    _this._endYearRef = React.createRef();
    return _this;
  }

  _createClass(DatePickerInput, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this._shortcuts) {
        this._shortcuts.remove(this.osShortcut);
      }
    }
  }, {
    key: "getPlaceholderChar",
    value: function getPlaceholderChar(value) {
      var index = this.props.maskOrder.indexOf(value);
      return this.props.maskPlaceholder[index];
    }
  }, {
    key: "generateDateList",
    value: function generateDateList(params, mode) {
      var _this2 = this;

      return this.maskList.map(function (value, i) {
        var state = value.slice(0, 1);

        var placeholderChar = _this2.getPlaceholderChar(value);

        var _this2$props = _this2.props,
            input_element = _this2$props.input_element,
            separatorRexExp = _this2$props.separatorRexExp,
            isRange = _this2$props.isRange;
        var _this2$context$transl = _this2.context.translation.DatePicker,
            day = _this2$context$transl.day,
            month = _this2$context$transl.month,
            year = _this2$context$transl.year;
        var isRangeLabe = isRange ? "".concat(_this2.context.translation.DatePicker[mode], " ") : '';

        if (!separatorRexExp.test(value)) {
          if (!input_element) {
            params = _extends({}, params, {
              onKeyDown: _this2.onKeyDownHandler,
              onMouseUp: selectInput,
              onPaste: _this2.shortcutHandler,
              onFocus: function onFocus(e) {
                _this2.focusMode = mode;

                _this2.onFocusHandler(e);
              },
              onBlur: _this2.onBlurHandler,
              placeholderChar: placeholderChar
            });
          }

          var _Input = typeof input_element === 'string' ? input_element : InputElement;

          switch (state) {
            case 'd':
              _this2.refList.push(_this2["_".concat(mode, "DayRef")]);

              return React.createElement(React.Fragment, {
                key: 'dd' + i
              }, React.createElement(_Input, _extends({}, params, {
                id: "".concat(_this2.props.id, "-").concat(mode, "-day"),
                key: 'di' + i,
                className: classnames("dnb-date-picker__input dnb-date-picker__input--day", params.className),
                size: "2",
                mask: [/[0-3]/, /[0-9]/],
                ref: _this2["_".concat(mode, "DayRef")],
                onChange: _this2["set_".concat(mode, "Day")],
                value: _this2.context["__".concat(mode, "Day")],
                "aria-labelledby": "".concat(_this2.props.id, "-").concat(mode, "-day-label")
              })), React.createElement("label", {
                key: 'dl' + i,
                hidden: true,
                id: "".concat(_this2.props.id, "-").concat(mode, "-day-label")
              }, isRangeLabe + day));

            case 'm':
              _this2.refList.push(_this2["_".concat(mode, "MonthRef")]);

              return React.createElement(React.Fragment, {
                key: 'mm' + i
              }, React.createElement(_Input, _extends({}, params, {
                id: "".concat(_this2.props.id, "-").concat(mode, "-month"),
                key: 'mi' + i,
                className: classnames("dnb-date-picker__input dnb-date-picker__input--month", params.className),
                size: "2",
                mask: [/[0-1]/, /[0-9]/],
                ref: _this2["_".concat(mode, "MonthRef")],
                onChange: _this2["set_".concat(mode, "Month")],
                value: _this2.context["__".concat(mode, "Month")],
                "aria-labelledby": "".concat(_this2.props.id, "-").concat(mode, "-month-label")
              })), React.createElement("label", {
                key: 'ml' + i,
                hidden: true,
                id: "".concat(_this2.props.id, "-").concat(mode, "-month-label")
              }, isRangeLabe + month));

            case 'y':
              _this2.refList.push(_this2["_".concat(mode, "YearRef")]);

              return React.createElement(React.Fragment, {
                key: 'yy' + i
              }, React.createElement(_Input, _extends({}, params, {
                id: "".concat(_this2.props.id, "-").concat(mode, "-year"),
                key: 'yi' + i,
                className: classnames("dnb-date-picker__input dnb-date-picker__input--year", params.className),
                size: "4",
                mask: [/[1-2]/, /[0-9]/, /[0-9]/, /[0-9]/],
                ref: _this2["_".concat(mode, "YearRef")],
                onChange: _this2["set_".concat(mode, "Year")],
                value: _this2.context["__".concat(mode, "Year")],
                "aria-labelledby": "".concat(_this2.props.id, "-").concat(mode, "-year-label")
              })), React.createElement("label", {
                key: 'yl' + i,
                hidden: true,
                id: "".concat(_this2.props.id, "-").concat(mode, "-year-label")
              }, isRangeLabe + year));
          }
        }

        return React.createElement("span", {
          key: 's' + i,
          className: "dnb-date-picker--separator",
          "aria-hidden": true
        }, placeholderChar);
      });
    }
  }, {
    key: "formatDate",
    value: function formatDate() {
      var open_picker_text = this.context.translation.DatePicker.open_picker_text;
      var selectedDateTitle = this.props.selectedDateTitle;
      return selectedDateTitle ? "".concat(selectedDateTitle, ", ").concat(open_picker_text) : open_picker_text;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          id = _this$props2.id,
          title = _this$props2.title,
          submitAttributes = _this$props2.submitAttributes,
          isRange = _this$props2.isRange,
          maskOrder = _this$props2.maskOrder,
          maskPlaceholder = _this$props2.maskPlaceholder,
          separatorRexExp = _this$props2.separatorRexExp,
          onChange = _this$props2.onChange,
          onFocus = _this$props2.onFocus,
          onSubmit = _this$props2.onSubmit,
          selectedDateTitle = _this$props2.selectedDateTitle,
          showInput = _this$props2.showInput,
          input_element = _this$props2.input_element,
          locale = _this$props2.locale,
          disabled = _this$props2.disabled,
          skeleton = _this$props2.skeleton,
          opened = _this$props2.opened,
          status = _this$props2.status,
          status_state = _this$props2.status_state,
          attributes = _objectWithoutProperties(_this$props2, ["id", "title", "submitAttributes", "isRange", "maskOrder", "maskPlaceholder", "separatorRexExp", "onChange", "onFocus", "onSubmit", "selectedDateTitle", "showInput", "input_element", "locale", "disabled", "skeleton", "opened", "status", "status_state"]);

      var focusState = this.state.focusState;
      validateDOMAttributes(this.props, attributes);
      validateDOMAttributes(null, submitAttributes);
      return React.createElement("fieldset", {
        className: "dnb-date-picker__fieldset",
        lang: locale === null || locale === void 0 ? void 0 : locale.code
      }, this.context.props.label && React.createElement("legend", {
        className: "dnb-sr-only"
      }, this.context.props.label), React.createElement(Input, _extends({
        id: "".concat(id, "__input"),
        input_state: disabled ? 'disabled' : focusState,
        input_element: input_element && typeof input_element !== 'string' ? typeof input_element === 'function' ? input_element(this.props) : input_element : this.renderInputElement,
        disabled: disabled || skeleton,
        skeleton: skeleton,
        status: !opened ? status : null,
        status_state: status_state,
        submit_element: React.createElement(SubmitButton, _extends({
          id: id,
          disabled: disabled,
          skeleton: skeleton,
          className: opened ? 'dnb-button--active' : null,
          "aria-label": this.formatDate(),
          title: title,
          type: "button",
          icon: "calendar",
          variant: "secondary",
          on_submit: onSubmit
        }, submitAttributes)),
        lang: locale === null || locale === void 0 ? void 0 : locale.code
      }, attributes)), ' ');
    }
  }]);

  return DatePickerInput;
}(React.PureComponent);

DatePickerInput.contextType = DatePickerContext;
DatePickerInput.defaultProps = {
  id: null,
  title: null,
  selectedDateTitle: null,
  maskOrder: 'dd/mm/yyyy',
  maskPlaceholder: 'dd/mm/åååå',
  separatorRexExp: /[-/ ]/g,
  submitAttributes: null,
  isRange: null,
  status: null,
  status_state: 'error',
  input_element: null,
  disabled: null,
  locale: null,
  skeleton: null,
  opened: false,
  showInput: null,
  onChange: null,
  onSubmit: null,
  onFocus: null
};
export { DatePickerInput as default };
process.env.NODE_ENV !== "production" ? DatePickerInput.propTypes = {
  id: PropTypes.string,
  title: PropTypes.string,
  selectedDateTitle: PropTypes.string,
  maskOrder: PropTypes.string,
  maskPlaceholder: PropTypes.string,
  separatorRexExp: PropTypes.instanceOf(RegExp),
  submitAttributes: PropTypes.object,
  isRange: PropTypes.bool,
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  input_element: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  locale: PropTypes.object,
  disabled: PropTypes.bool,
  skeleton: PropTypes.bool,
  opened: PropTypes.bool,
  showInput: PropTypes.bool,
  onChange: PropTypes.func,
  onSubmit: PropTypes.func,
  onFocus: PropTypes.func
} : void 0;

var selectInput = function selectInput(e) {
  e.target.focus();
  e.target.select();
};

var InputElement = React.forwardRef(function (props, innerRef) {
  return React.createElement(MaskedInput, _extends({
    guide: true,
    showMask: true,
    keepCharPositions: false,
    autoComplete: "off",
    autoCapitalize: "none",
    spellCheck: false,
    autoCorrect: "off",
    ref: innerRef
  }, props));
});

var wait = function wait(t) {
  return new Promise(function (r) {
    return setTimeout(r, t);
  });
};