import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import isSameMonth from 'date-fns/isSameMonth';
import isValid from 'date-fns/isValid';
import format from 'date-fns/format';
import differenceInCalendarDays from 'date-fns/differenceInCalendarDays';
import Context from '../../shared/Context';
import { isTrue, dispatchCustomElementEvent } from '../../shared/component-helper';
import { convertStringToDate, correctV1Format, isDisabled } from './DatePickerCalc';
import DatePickerContext from './DatePickerContext';
import { getViews } from './DatePickerRange';

var DatePickerProvider = function (_React$PureComponent) {
  _inherits(DatePickerProvider, _React$PureComponent);

  var _super = _createSuper(DatePickerProvider);

  function DatePickerProvider(props) {
    var _this;

    _classCallCheck(this, DatePickerProvider);

    _this = _super.call(this, props);
    _this.state = {
      _listenForPropChanges: true,
      changeMonthViews: false
    };

    _this.setViews = function (views) {
      var cb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.setState({
        views: views,
        _listenForPropChanges: false
      }, cb);
    };

    _this.updateState = function (state) {
      var cb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.setState(_extends({}, state, {
        _listenForPropChanges: false
      }), cb);
    };

    _this.setDate = function (state) {
      var cb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.setState(_extends({}, state, {
        _listenForPropChanges: false
      }), cb);

      var startDateIsValid = Boolean(state.startDate && isValid(state.startDate));
      var endDateIsValid = Boolean(state.endDate && isValid(state.endDate));

      _this.setState({
        hasHadValidDate: startDateIsValid || endDateIsValid
      });
    };

    _this.callOnChangeHandler = function (args) {
      var eventData = _this.getReturnObject(args);

      if (_this.eventData) {
        if (isTrue(_this.props.range)) {
          if (_this.eventData.start_date === eventData.start_date && _this.eventData.end_date === eventData.end_date) {
            return;
          }
        } else {
          if (_this.eventData.date === eventData.date) {
            return;
          }
        }
      }

      _this.eventData = eventData;
      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', eventData);
    };

    _this.getReturnObject = function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var _ref$event = _ref.event,
          event = _ref$event === void 0 ? null : _ref$event,
          rest = _objectWithoutProperties(_ref, ["event"]);

      var _this$state$rest = _extends({}, _this.state, rest),
          startDate = _this$state$rest.startDate,
          endDate = _this$state$rest.endDate;

      var attributes = _this.props.attributes || {};
      var returnFormat = correctV1Format(_this.props.return_format);
      var startDateIsValid = Boolean(startDate && isValid(startDate));
      var endDateIsValid = Boolean(endDate && isValid(endDate));
      var ret = null;

      if (isTrue(_this.props.range)) {
        ret = {
          event: event,
          attributes: attributes,
          days_between: startDateIsValid && endDateIsValid ? differenceInCalendarDays(endDate, startDate) : null,
          start_date: startDateIsValid ? format(startDate, returnFormat) : null,
          end_date: endDateIsValid ? format(endDate, returnFormat) : null,
          is_valid_start_date: startDateIsValid,
          is_valid_end_date: endDateIsValid
        };
      } else {
        ret = {
          event: event,
          attributes: attributes,
          date: startDateIsValid ? format(startDate, returnFormat) : null,
          is_valid: startDateIsValid
        };
      }

      if (_this.props.min_date || _this.props.max_date) {
        if (isTrue(_this.props.range)) {
          if (startDateIsValid && isDisabled(startDate, _this.state.minDate, _this.state.maxDate)) {
            ret.is_valid_start_date = false;
          }

          if (endDateIsValid && isDisabled(endDate, _this.state.minDate, _this.state.maxDate)) {
            ret.is_valid_end_date = false;
          }
        } else {
          if (startDateIsValid && isDisabled(startDate, _this.state.minDate, _this.state.maxDate)) {
            ret.is_valid = false;
          }
        }
      }

      return ret;
    };

    if (typeof props.setReturnObject === 'function') {
      props.setReturnObject(_this.getReturnObject);
    }

    return _this;
  }

  _createClass(DatePickerProvider, [{
    key: "render",
    value: function render() {
      var children = this.props.children;
      return React.createElement(DatePickerContext.Provider, {
        value: _extends({
          translation: this.context.translation,
          setViews: this.setViews,
          setDate: this.setDate,
          updateState: this.updateState,
          getReturnObject: this.getReturnObject,
          callOnChangeHandler: this.callOnChangeHandler,
          props: this.props
        }, this.props.enhanceWithMethods, this.state)
      }, children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var isRange = isTrue(props.range);

      if (state._listenForPropChanges) {
        var startDate = undefined;
        var date_format = props.date_format;

        if (typeof props.date !== 'undefined' && props.date !== state._date) {
          startDate = props.date;
        }

        if (typeof props.start_date !== 'undefined' && props.start_date !== state._startDate) {
          startDate = props.start_date;
        }

        if (typeof startDate !== 'undefined' && startDate !== state.startDate) {
          state.startDate = convertStringToDate(startDate, {
            date_format: date_format
          }) || undefined;

          if (!isTrue(props.range)) {
            state.endDate = state.startDate;
          }
        }

        if (typeof props.end_date !== 'undefined' && isTrue(props.range) && props.end_date !== state._endDate) {
          state.endDate = convertStringToDate(props.end_date, {
            date_format: date_format
          }) || undefined;
        }

        if (typeof props.start_month !== 'undefined' && props.start_month !== state._startMonth) {
          state.startMonth = convertStringToDate(props.start_month, {
            date_format: date_format
          });
        }

        if (typeof props.end_month !== 'undefined' && props.end_month !== state._endMonth) {
          state.endMonth = convertStringToDate(props.end_month, {
            date_format: date_format
          });
        }

        if (typeof props.min_date !== 'undefined' && props.min_date !== state._minDate) {
          state.minDate = convertStringToDate(props.min_date, {
            date_format: date_format
          });
        }

        if (typeof props.max_date !== 'undefined' && props.max_date !== state._maxDate) {
          state.maxDate = convertStringToDate(props.max_date, {
            date_format: date_format
          });
        }

        if (isTrue(props.correct_invalid_date)) {
          if (isDisabled(state.startDate, state.minDate, state.maxDate)) {
            state.startDate = state.minDate;
          }

          if (isDisabled(state.endDate, state.minDate, state.maxDate)) {
            state.endDate = state.maxDate;
          }
        }
      }

      if (isValid(state.startDate)) {
        state.__startDay = pad(format(state.startDate, 'dd'), 2);
        state.__startMonth = pad(format(state.startDate, 'MM'), 2);
        state.__startYear = format(state.startDate, 'yyyy');
      } else if (state.startDate === undefined) {
        state.__startDay = null;
        state.__startMonth = null;
        state.__startYear = null;
      }

      if (isValid(state.endDate)) {
        state.__endDay = pad(format(state.endDate, 'dd'), 2);
        state.__endMonth = pad(format(state.endDate, 'MM'), 2);
        state.__endYear = format(state.endDate, 'yyyy');
      } else if (state.endDate === undefined) {
        state.__endDay = null;
        state.__endMonth = null;
        state.__endYear = null;
      }

      if (!state.startMonth || state.changeMonthViews && !isSameMonth(state.startMonth, state.startDate)) {
        state.startMonth = state.startDate;
      }

      if (!state.endMonth || isRange && state.changeMonthViews && !isSameMonth(state.endMonth, state.endDate)) {
        state.endMonth = state.endDate || state.startMonth;
      }

      state.views = getViews(state, isRange);

      if (!state.startMonth) {
        state.startMonth = state.views[0].month;

        if (isRange && !state.endMonth && typeof state.views[1] !== 'undefined') {
          state.endMonth = state.views[1].month;
        }
      }

      state.changeMonthViews = false;
      state._listenForPropChanges = true;
      state._date = props.date;
      state._startDate = props.start_date || props.date;
      state._endDate = props.end_date;
      state._startMonth = props.start_month;
      state._endMonth = props.end_month;
      state._month = props.month;
      state._minDate = props.min_date;
      state._maxDate = props.max_date;
      return state;
    }
  }]);

  return DatePickerProvider;
}(React.PureComponent);

DatePickerProvider.contextType = Context;
DatePickerProvider.defaultProps = {
  min_date: null,
  max_date: null,
  return_format: 'yyyy-MM-dd',
  attributes: null,
  enhanceWithMethods: null
};
export { DatePickerProvider as default };
process.env.NODE_ENV !== "production" ? DatePickerProvider.propTypes = {
  min_date: PropTypes.oneOfType([PropTypes.instanceOf(Date), PropTypes.string]),
  max_date: PropTypes.oneOfType([PropTypes.instanceOf(Date), PropTypes.string]),
  return_format: PropTypes.string,
  range: PropTypes.oneOfType([PropTypes.bool, PropTypes.string]).isRequired,
  setReturnObject: PropTypes.func.isRequired,
  enhanceWithMethods: PropTypes.object,
  attributes: PropTypes.object,
  children: PropTypes.node.isRequired
} : void 0;
export var pad = function pad(num, size) {
  return ('000000000' + num).substr(-size);
};