import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.fill.js";
import "core-js/modules/es.array.map.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import addMonths from 'date-fns/addMonths';
import subMonths from 'date-fns/subMonths';
import DatePickerCalendar from './DatePickerCalendar';
import DatePickerContext from './DatePickerContext';

var DatePickerRange = function (_React$PureComponent) {
  _inherits(DatePickerRange, _React$PureComponent);

  var _super = _createSuper(DatePickerRange);

  function DatePickerRange() {
    var _this;

    _classCallCheck(this, DatePickerRange);

    for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
      _args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(_args));

    _this.onSelectHandler = function (args) {
      _this.context.callOnChangeHandler(args);

      _this.props.onChange && _this.props.onChange(_extends({
        hidePicker: !_this.props.isRange
      }, args));
    };

    _this.callOnNav = function () {
      _this.props.onNav && _this.props.onNav(_this.context.views);
    };

    _this.setNavState = function (state) {
      _this.context.updateState(state);
    };

    _this.onNext = function (_ref) {
      var nr = _ref.nr;

      var views = _this.context.views.map(function (c) {
        if (c.nr === nr) {
          var month = addMonths(c.month, 1);

          _this.setNavState(_defineProperty({
            nr: nr
          }, "".concat(nr === 0 ? 'start' : 'end', "Month"), month));

          return _extends({}, c, {
            month: month
          });
        }

        if (_this.props.isLink && c.nr === 1) {
          var _month = addMonths(c.month, 1);

          _this.setNavState(_defineProperty({
            nr: nr
          }, "".concat(nr !== 0 ? 'start' : 'end', "Month"), _month));

          return _extends({}, c, {
            month: _month
          });
        }

        return c;
      });

      _this.context.setViews(views, _this.callOnNav);
    };

    _this.onPrev = function (_ref2) {
      var nr = _ref2.nr;

      var views = _this.context.views.map(function (c) {
        if (c.nr === nr) {
          var month = subMonths(c.month, 1);

          _this.setNavState(_defineProperty({
            nr: nr
          }, "".concat(nr === 0 ? 'start' : 'end', "Month"), month));

          return _extends({}, c, {
            month: month
          });
        }

        if (_this.props.isLink && c.nr === 1) {
          var _month2 = subMonths(c.month, 1);

          _this.setNavState(_defineProperty({
            nr: nr
          }, "".concat(nr !== 0 ? 'start' : 'end', "Month"), _month2));

          return _extends({}, c, {
            month: _month2
          });
        }

        return c;
      });

      _this.context.setViews(views, _this.callOnNav);
    };

    _this.onHover = function (hoverDate) {
      _this.context.updateState({
        hoverDate: hoverDate
      });
    };

    return _this;
  }

  _createClass(DatePickerRange, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          id = _this$props.id,
          props = _objectWithoutProperties(_this$props, ["id"]);

      return React.createElement("div", {
        className: "dnb-date-picker__views"
      }, this.context.views.map(function (calendar, i) {
        return React.createElement(DatePickerCalendar, _extends({
          key: calendar.nr,
          id: "".concat(id, "-").concat(i, "-")
        }, props, calendar, {
          onSelect: _this2.onSelectHandler,
          onHover: _this2.onHover,
          onPrev: _this2.onPrev,
          onNext: _this2.onNext
        }));
      }));
    }
  }]);

  return DatePickerRange;
}(React.PureComponent);

DatePickerRange.contextType = DatePickerContext;
DatePickerRange.defaultProps = {
  id: null,
  isRange: null,
  isLink: null,
  isSync: null,
  onlyMonth: null,
  hideNav: null,
  views: null,
  onChange: null,
  onNav: null
};
export { DatePickerRange as default };
process.env.NODE_ENV !== "production" ? DatePickerRange.propTypes = {
  id: PropTypes.string,
  isRange: PropTypes.bool,
  isLink: PropTypes.bool,
  isSync: PropTypes.bool,
  onlyMonth: PropTypes.bool,
  hideNav: PropTypes.bool,
  views: PropTypes.oneOfType([PropTypes.number, PropTypes.arrayOf(PropTypes.object)]),
  onChange: PropTypes.func,
  onNav: PropTypes.func
} : void 0;
export var getViews = function getViews(state, isRange) {
  return (Array.isArray(state.views) ? state.views : Array(isRange ? 2 : state.views).fill(1)).map(function (view, nr) {
    return _extends({}, view, {
      month: getMonthView(state, nr),
      nr: nr
    });
  });
};

var getMonthView = function getMonthView(state, nr) {
  if ((state.startMonth || state.startDate) && nr === 0) {
    return state.startMonth || state.startDate;
  }

  if ((state.endMonth || state.endDate) && nr === 1) {
    return state.endMonth || state.endDate;
  }

  return addMonths(getFallbackMonth(state), nr);
};

var getFallbackMonth = function getFallbackMonth(state) {
  return state.startMonth || state.startDate || new Date();
};