import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.join.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import { warn, isTrue, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, getStatusState, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import AlignmentHelper from '../../shared/AlignmentHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import Suffix from '../../shared/helpers/Suffix';
import Icon from '../icon-primary/IconPrimary';
import FormLabel from '../form-label/FormLabel';
import FormStatus from '../form-status/FormStatus';
import Button from '../button/Button';
import DrawerList from '../../fragments/drawer-list/DrawerList';
import DrawerListContext from '../../fragments/drawer-list/DrawerListContext';
import DrawerListProvider from '../../fragments/drawer-list/DrawerListProvider';
import { parseContentTitle, getCurrentData } from '../../fragments/drawer-list/DrawerListHelpers';

var Dropdown = function (_React$PureComponent) {
  _inherits(Dropdown, _React$PureComponent);

  var _super = _createSuper(Dropdown);

  function Dropdown() {
    _classCallCheck(this, Dropdown);

    return _super.apply(this, arguments);
  }

  _createClass(Dropdown, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          more_menu = _this$props.more_menu,
          action_menu = _this$props.action_menu,
          prevent_selection = _this$props.prevent_selection,
          children = _this$props.children,
          data = _this$props.data;
      return React.createElement(DrawerListProvider, _extends({}, this.props, {
        data: data || children,
        opened: null,
        tagName: "dnb-dropdown",
        ignore_events: false,
        prevent_selection: isTrue(more_menu) || isTrue(action_menu) || isTrue(prevent_selection)
      }), React.createElement(DropdownInstance, this.props));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Dropdown.tagName, Dropdown, Dropdown.defaultProps);
    }
  }]);

  return Dropdown;
}(React.PureComponent);

Dropdown.tagName = 'dnb-dropdown';
Dropdown.defaultProps = {
  id: null,
  title: 'Option Menu',
  icon: null,
  icon_size: null,
  icon_position: null,
  triangle_position: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  scrollable: true,
  focusable: false,
  max_height: null,
  direction: 'auto',
  skip_portal: null,
  no_animation: false,
  no_scroll_animation: false,
  prevent_selection: false,
  more_menu: false,
  action_menu: false,
  independent_width: false,
  size: 'default',
  align_dropdown: null,
  trigger_component: null,
  data: null,
  default_value: null,
  value: 'initval',
  open_on_focus: false,
  prevent_close: false,
  keep_open: false,
  opened: false,
  disabled: null,
  stretch: null,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_show: null,
  on_hide: null,
  on_change: null,
  on_select: null,
  on_state_update: null
};
export { Dropdown as default };
process.env.NODE_ENV !== "production" ? Dropdown.propTypes = _extends({
  id: PropTypes.string,
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  icon_size: PropTypes.string,
  icon_position: PropTypes.oneOf(['left', 'right']),
  triangle_position: PropTypes.oneOf(['left', 'right']),
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_direction: PropTypes.oneOf(['horizontal', 'vertical']),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  scrollable: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  focusable: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  direction: PropTypes.oneOf(['auto', 'top', 'bottom']),
  max_height: PropTypes.number,
  skip_portal: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_scroll_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_selection: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  more_menu: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  action_menu: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  independent_width: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  size: PropTypes.oneOf(['default', 'small', 'medium', 'large']),
  align_dropdown: PropTypes.oneOf(['left', 'right']),
  trigger_component: PropTypes.oneOfType([PropTypes.func, PropTypes.node]),
  data: PropTypes.oneOfType([PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node, PropTypes.object]), PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.oneOfType([PropTypes.string, PropTypes.node]), PropTypes.shape({
    selected_value: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
    content: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.arrayOf(PropTypes.string)])
  })]))]),
  default_value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  open_on_focus: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_close: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  keep_open: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  opened: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  stretch: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  class: PropTypes.string
}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node, PropTypes.object, PropTypes.array]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_show: PropTypes.func,
  on_hide: PropTypes.func,
  on_change: PropTypes.func,
  on_select: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;

var _ref = React.createElement(AlignmentHelper, null);

var DropdownInstance = function (_React$PureComponent2) {
  _inherits(DropdownInstance, _React$PureComponent2);

  var _super2 = _createSuper(DropdownInstance);

  function DropdownInstance(props) {
    var _this;

    _classCallCheck(this, DropdownInstance);

    _this = _super2.call(this, props);

    _this.setVisible = function () {
      _this.context.drawerList.setWrapperElement(_this._refShell.current).setVisible();
    };

    _this.setHidden = function () {
      var _this$context$drawerL;

      (_this$context$drawerL = _this.context.drawerList).setHidden.apply(_this$context$drawerL, arguments);
    };

    _this.onFocusHandler = function () {
      if (isTrue(_this.props.open_on_focus)) {
        _this.setVisible();
      }
    };

    _this.onBlurHandler = function () {
      if (isTrue(_this.props.open_on_focus)) {
        _this.setHidden();
      }
    };

    _this.toggleVisible = function () {
      if (!_this.context.drawerList.hidden && _this.context.drawerList.opened) {
        _this.setHidden();
      } else {
        _this.setVisible();
      }
    };

    _this.onMouseDownHandler = function () {
      if (!_this.context.drawerList.hidden && _this.context.drawerList.opened) {
        _this.setHidden();
      } else {
        _this.setVisible();
      }
    };

    _this.onTriggerKeyDownHandler = function (e) {
      switch (keycode(e)) {
        case 'enter':
        case 'space':
        case 'up':
        case 'down':
          e.preventDefault();

          _this.setVisible();

          break;

        case 'esc':
          _this.setHidden();

          break;

        case 'home':
        case 'end':
        case 'page down':
        case 'page up':
          e.preventDefault();
          break;
      }
    };

    _this.onHideHandler = function () {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var attributes = _this.attributes || {};
      var res = dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_hide', _extends({}, args, {
        attributes: attributes
      }));

      if (res !== false) {
        clearTimeout(_this._focusTimeout);
        _this._focusTimeout = setTimeout(function () {
          try {
            var element = _this._refButton.current._ref.current;

            if (element && typeof element.focus === 'function') {
              element.focus({
                preventScroll: true
              });
              dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_hide_focus', {
                element: element
              });
            }
          } catch (e) {}
        }, 1);
      }

      return res;
    };

    _this.onSelectHandler = function (args) {
      if (parseFloat(args.active_item) > -1) {
        var attributes = _this.attributes || {};
        dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_select', _extends({}, args, {
          attributes: attributes
        }));
      }
    };

    _this.onChangeHandler = function (args) {
      var attributes = _this.attributes || {};
      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', _extends({}, args, {
        attributes: attributes
      }));
    };

    _this._id = props.id || makeUniqueId();
    _this.attributes = {};
    _this.state = _this.state || {};
    _this._ref = React.createRef();
    _this._refShell = React.createRef();
    _this._refButton = React.createRef();
    var dep = 'selected_item';

    if (typeof props[dep] !== 'undefined') {
      warn("Dropdown: Please use \"value\" instead of \"".concat(dep, "\"."));
    }

    return _this;
  }

  _createClass(DropdownInstance, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (isTrue(this.props.opened)) {
        this.setVisible();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.setHidden();
      clearTimeout(this._hideTimeout);
      clearTimeout(this._focusTimeout);
    }
  }, {
    key: "getTitle",
    value: function getTitle() {
      var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var data = this.context.drawerList.data;

      if (data && data.length > 0) {
        var currentOptionData = getCurrentData(this.context.drawerList.selected_item, data);

        if (currentOptionData) {
          title = currentOptionData.selected_value || parseContentTitle(currentOptionData);
        }
      }

      return title;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = extendPropsWithContext(this.props, Dropdown.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Dropdown, this.context.FormRow, this.context.Dropdown);

      var label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          icon_size = props.icon_size,
          size = props.size,
          fixed_position = props.fixed_position,
          use_drawer_on_mobile = props.use_drawer_on_mobile,
          enable_body_lock = props.enable_body_lock,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          scrollable = props.scrollable,
          focusable = props.focusable,
          keep_open = props.keep_open,
          prevent_close = props.prevent_close,
          no_animation = props.no_animation,
          no_scroll_animation = props.no_scroll_animation,
          triangle_position = props.triangle_position,
          skip_portal = props.skip_portal,
          CustomTrigger = props.trigger_component,
          more_menu = props.more_menu,
          action_menu = props.action_menu,
          independent_width = props.independent_width,
          prevent_selection = props.prevent_selection,
          max_height = props.max_height,
          default_value = props.default_value,
          className = props.className,
          _className = props.class,
          disabled = props.disabled,
          stretch = props.stretch,
          skeleton = props.skeleton,
          _title = props.title,
          _icon = props.icon,
          _align_dropdown = props.align_dropdown,
          _icon_position = props.icon_position,
          _data = props.data,
          _children = props.children,
          _direction = props.direction,
          _id = props.id,
          _opened = props.opened,
          _value = props.value,
          attributes = _objectWithoutProperties(props, ["label", "label_direction", "label_sr_only", "icon_size", "size", "fixed_position", "use_drawer_on_mobile", "enable_body_lock", "status", "status_state", "status_animation", "global_status_id", "suffix", "scrollable", "focusable", "keep_open", "prevent_close", "no_animation", "no_scroll_animation", "triangle_position", "skip_portal", "trigger_component", "more_menu", "action_menu", "independent_width", "prevent_selection", "max_height", "default_value", "className", "class", "disabled", "stretch", "skeleton", "title", "icon", "align_dropdown", "icon_position", "data", "children", "direction", "id", "opened", "value"]);

      var icon = props.icon,
          icon_position = props.icon_position,
          align_dropdown = props.align_dropdown;
      var id = this._id;
      var handleAsMenu = isTrue(action_menu) || isTrue(more_menu) || isTrue(prevent_selection);
      var isPopupMenu = isTrue(more_menu) || !(_title && _title.length > 0);

      if (isPopupMenu) {
        icon = icon || (isTrue(more_menu) ? 'more' : 'chevron_down');
      }

      if (isPopupMenu || isTrue(action_menu)) {
        if (icon_position !== 'right' && align_dropdown !== 'right') {
          icon_position = 'left';
          align_dropdown = 'left';
        }
      }

      var _this$context$drawerL2 = this.context.drawerList,
          selected_item = _this$context$drawerL2.selected_item,
          direction = _this$context$drawerL2.direction,
          opened = _this$context$drawerL2.opened;
      var showStatus = getStatusState(status);
      var title = this.getTitle(_title);

      _extends(this.context.drawerList.attributes, validateDOMAttributes(null, attributes));

      var mainParams = {
        className: classnames("dnb-dropdown dnb-dropdown--".concat(direction, " dnb-dropdown--icon-position-").concat(icon_position || 'right', " dnb-dropdown--").concat(align_dropdown || 'right', " dnb-form-component"), (isTrue(independent_width) || isTrue(action_menu)) && 'dnb-dropdown--independent-width', createSpacingClasses(props), _className, className, opened && 'dnb-dropdown--opened', label_direction && "dnb-dropdown--".concat(label_direction), isPopupMenu && 'dnb-dropdown--is-popup', isTrue(action_menu) && "dnb-dropdown--action-menu", size && "dnb-dropdown--".concat(size), isTrue(stretch) && "dnb-dropdown--stretch", status && "dnb-dropdown__status--".concat(status_state), showStatus && 'dnb-dropdown__form-status')
      };

      var triggerParams = _extends({
        className: 'dnb-dropdown__trigger' + (opened ? " dnb-button--active" : ""),
        id: id,
        disabled: disabled,
        'aria-haspopup': handleAsMenu ? true : 'listbox',
        'aria-expanded': opened
      }, attributes, {
        onFocus: this.onFocusHandler,
        onBlur: this.onBlurHandler,
        onMouseDown: this.onMouseDownHandler,
        onKeyDown: this.onTriggerKeyDownHandler
      });

      if (opened) {
        triggerParams['aria-controls'] = "".concat(id, "-drawer-list");
      }

      if (showStatus || suffix) {
        triggerParams['aria-describedby'] = combineDescribedBy(triggerParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (label) {
        triggerParams['aria-labelledby'] = [triggerParams['aria-labelledby'], id + '-label', id].filter(Boolean).join(' ');
      }

      validateDOMAttributes(null, mainParams);
      validateDOMAttributes(this.props, triggerParams);
      this.attributes = validateDOMAttributes(null, attributes);
      return React.createElement("span", mainParams, label && React.createElement(FormLabel, {
        id: id + '-label',
        for_id: id,
        text: label,
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton,
        onMouseDown: this.toggleVisible
      }), React.createElement("span", {
        className: "dnb-dropdown__inner",
        ref: this._ref
      }, _ref, showStatus && React.createElement(FormStatus, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), React.createElement("span", {
        className: "dnb-dropdown__row"
      }, React.createElement("span", {
        className: "dnb-dropdown__shell",
        ref: this._refShell
      }, CustomTrigger ? React.createElement(CustomTrigger, triggerParams) : React.createElement(Button, _extends({
        variant: "secondary",
        icon: false,
        size: size === 'default' ? 'medium' : size,
        ref: this._refButton
      }, triggerParams), !isPopupMenu && React.createElement("span", {
        className: "dnb-dropdown__text dnb-button__text"
      }, React.createElement("span", {
        className: "dnb-dropdown__text__inner"
      }, title)), React.createElement("span", {
        "aria-hidden": true,
        className: 'dnb-dropdown__icon' + (parseFloat(selected_item) === 0 ? " dnb-dropdown__icon--first" : "")
      }, icon !== false && React.createElement(Icon, {
        icon: icon || 'chevron_down',
        size: icon_size || (size === 'large' ? 'medium' : 'default')
      }))), React.createElement(DrawerList, {
        id: id,
        role: handleAsMenu ? 'menu' : 'listbox',
        inner_class: "dnb-dropdown__list",
        value: selected_item,
        default_value: default_value,
        scrollable: scrollable,
        focusable: focusable,
        no_animation: no_animation,
        no_scroll_animation: no_scroll_animation,
        skip_portal: skip_portal,
        prevent_selection: handleAsMenu,
        action_menu: action_menu,
        triangle_position: triangle_position || icon_position || 'right',
        keep_open: keep_open,
        prevent_close: prevent_close,
        independent_width: isTrue(independent_width) || isPopupMenu || action_menu,
        is_popup: isPopupMenu || action_menu,
        align_drawer: align_dropdown || 'right',
        fixed_position: fixed_position,
        use_drawer_on_mobile: use_drawer_on_mobile || action_menu,
        enable_body_lock: enable_body_lock,
        disabled: disabled,
        max_height: max_height,
        direction: direction,
        size: size,
        on_change: this.onChangeHandler,
        on_select: this.onSelectHandler,
        on_hide: this.onHideHandler
      })), suffix && React.createElement(Suffix, {
        className: "dnb-dropdown__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))));
    }
  }]);

  return DropdownInstance;
}(React.PureComponent);

DropdownInstance.defaultProps = Dropdown.defaultProps;
DropdownInstance.contextType = DrawerListContext;
process.env.NODE_ENV !== "production" ? DropdownInstance.propTypes = Dropdown.propTypes : void 0;
Dropdown.HorizontalItem = DrawerList.HorizontalItem;