import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";

var _templateObject, _templateObject2;

import React from 'react';
import styled from '@emotion/styled';
import { FormSet, FormRow, Space, DatePicker, Textarea, Autocomplete, Dropdown, Slider, Input } from '../';
export default function AllStretchComponents() {
  return _ref;
}

function StretchTemplate(_ref2) {
  var Comp = _ref2.element,
      props = _objectWithoutProperties(_ref2, ["element"]);

  return React.createElement(React.Fragment, null, React.createElement(Box, null, React.createElement(FormSet, {
    direction: "vertical"
  }, React.createElement(FormRow, null, React.createElement(Comp, _extends({
    label: "FormSet direction=\"vertical\"",
    stretch: true
  }, props))))), React.createElement(Box, null, React.createElement(FormSet, {
    vertical: true
  }, React.createElement(FormRow, null, React.createElement(Comp, _extends({
    label: "FormSet vertical",
    stretch: true
  }, props))))), React.createElement(Box, null, React.createElement(FormRow, {
    direction: "horizontal"
  }, React.createElement(Comp, _extends({
    label: "FormRow direction=\"horizontal\"",
    stretch: true
  }, props)))), React.createElement(Box, null, React.createElement(Comp, _extends({
    label: "label_direction=\"vertical\"",
    label_direction: "vertical",
    stretch: true
  }, props))));
}

var _ref = React.createElement(Wrapper, null, React.createElement(StretchTemplate, {
  element: Input
}), React.createElement(StretchTemplate, {
  element: Textarea
}), React.createElement(StretchTemplate, {
  element: Autocomplete
}), React.createElement(StretchTemplate, {
  element: DatePicker,
  show_input: true
}), React.createElement(StretchTemplate, {
  element: Dropdown
}), React.createElement(StretchTemplate, {
  element: Slider
}));

export var Box = styled(Space)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  position: relative;\n\n  margin: 0;\n  padding: 1rem;\n\n  @media screen and (min-width: 40em) {\n    padding: 1rem;\n  }\n\n  &::after {\n    content: '';\n    position: absolute;\n    left: -50vw;\n    right: -50vw;\n    bottom: -1px;\n    width: 200vw;\n    border-bottom: dashed 1px rgb(0, 200, 200);\n  }\n"])));
var Wrapper = styled.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  display: block;\n"])));