import * as React from 'react';
export type GlobalStatusTitle = string | boolean;
export type GlobalStatusText =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type GlobalStatusItems = string | ((...args: any[]) => any) | any[];
export type GlobalStatusIcon =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type GlobalStatusState = 'error' | 'info';
export type GlobalStatusShow = string | boolean;
export type GlobalStatusAutoscroll = string | boolean;
export type GlobalStatusAutoclose = string | boolean;
export type GlobalStatusNoAnimation = string | boolean;
export type GlobalStatusDelay = string | number;
export type GlobalStatusHideCloseButton = string | boolean;
export type GlobalStatusOmitSetFocus = string | boolean;
export type GlobalStatusOmitSetFocusOnUpdate = string | boolean;
export type GlobalStatusSkeleton = string | boolean;
export type GlobalStatusSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type GlobalStatusTop = string | number | boolean;
export type GlobalStatusRight = string | number | boolean;
export type GlobalStatusBottom = string | number | boolean;
export type GlobalStatusLeft = string | number | boolean;
export type GlobalStatusChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface GlobalStatusProps extends React.HTMLProps<HTMLElement> {
  id?: string;
  status_id?: string;
  title?: GlobalStatusTitle;
  default_title?: string;
  text?: GlobalStatusText;
  items?: GlobalStatusItems;
  icon?: GlobalStatusIcon;
  icon_size?: string;
  state?: GlobalStatusState;
  show?: GlobalStatusShow;
  autoscroll?: GlobalStatusAutoscroll;
  autoclose?: GlobalStatusAutoclose;
  no_animation?: GlobalStatusNoAnimation;
  delay?: GlobalStatusDelay;
  close_text?: string;
  hide_close_button?: GlobalStatusHideCloseButton;
  omit_set_focus?: GlobalStatusOmitSetFocus;
  omit_set_focus_on_update?: GlobalStatusOmitSetFocusOnUpdate;
  status_anchor_text?: string;
  skeleton?: GlobalStatusSkeleton;
  space?: GlobalStatusSpace;
  top?: GlobalStatusTop;
  right?: GlobalStatusRight;
  bottom?: GlobalStatusBottom;
  left?: GlobalStatusLeft;
  class?: string;
  className?: string;
  children?: GlobalStatusChildren;
  on_adjust?: (...args: any[]) => any;
  on_open?: (...args: any[]) => any;
  on_show?: (...args: any[]) => any;
  on_close?: (...args: any[]) => any;
  on_hide?: (...args: any[]) => any;
}
export default class GlobalStatus extends React.Component<
  GlobalStatusProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
