import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.replace.js";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _construct from "@babel/runtime/helpers/esm/construct";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import Context from '../../shared/Context';
import { warn, isTrue, AnimateHeight, makeUniqueId, registerElement, validateDOMAttributes, dispatchCustomElementEvent, convertJsxToString, processChildren, extendPropsWithContext } from '../../shared/component-helper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import GlobalStatusController, { GlobalStatusInterceptor } from './GlobalStatusController';
import GlobalStatusProvider from './GlobalStatusProvider';
import Icon from '../icon/Icon';
import Button from '../button/Button';
import Section from '../section/Section';
import { IS_IE11 } from '../../shared/helpers';

var GlobalStatus = function (_React$PureComponent) {
  _inherits(GlobalStatus, _React$PureComponent);

  var _super = _createSuper(GlobalStatus);

  function GlobalStatus(props) {
    var _this;

    _classCallCheck(this, GlobalStatus);

    _this = _super.call(this, props);
    _this.state = {
      globalStatus: null,
      isActive: false,
      isAnimating: false,
      keepContentVisible: false,
      _listenForPropChanges: false
    };

    _this.setVisible = function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$delay = _ref.delay,
          delay = _ref$delay === void 0 ? parseFloat(_this.props.delay) : _ref$delay;

      var _this$state = _this.state,
          isActive = _this$state.isActive,
          initialOpened = _this$state.initialOpened;

      if (isActive === true && initialOpened) {
        if (!_this.adjustHeight) {
          _this.adjustHeight = _this.anim.adjustFrom();
        }

        _this.setState({
          keepContentVisible: true,
          _listenForPropChanges: false
        }, function () {
          _this.anim.adjustTo(_this.adjustHeight);

          _this.adjustHeight = null;
        });

        return;
      }

      var run = function run() {
        _this.setState({
          isActive: true,
          initialOpened: true,
          _listenForPropChanges: false
        }, function () {
          _this.anim.open();
        });
      };

      if (delay > 0) {
        clearTimeout(_this._visibleTimeout);
        _this._visibleTimeout = setTimeout(function () {
          run();
        }, delay);
      } else {
        run();
      }
    };

    _this.setHidden = function () {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref2$delay = _ref2.delay,
          delay = _ref2$delay === void 0 ? parseFloat(_this.props.delay) : _ref2$delay;

      var isActive = _this.state.isActive;

      if (isActive === false) {
        return;
      }

      var run = function run() {
        _this.setState({
          isActive: false,
          initialOpened: false,
          _listenForPropChanges: false
        }, function () {
          _this.anim.close();
        });
      };

      if (delay > 0) {
        clearTimeout(_this._hiddenTimeout);
        _this._hiddenTimeout = setTimeout(function () {
          run();
        }, delay);
      } else {
        run();
      }
    };

    _this.onKeyDownHandler = function (e) {
      switch (keycode(e)) {
        case 'esc':
          e.preventDefault();

          _this.closeHandler();

          break;
      }
    };

    _this.closeHandler = function () {
      _this.provider.add({
        status_id: 'internal-close',
        show: false
      });

      if (_this.initialActiveElement) {
        try {
          _this.initialActiveElement.focus();

          _this.initialActiveElement = null;
        } catch (e) {
          warn(e);
        }
      }

      dispatchCustomElementEvent(_this._globalStatus, 'on_hide', _this._globalStatus);
    };

    _this.gotoItem = function (event, item) {
      event.persist();
      var keyCode = keycode(event);

      if (item.status_id && typeof document !== 'undefined' && typeof window !== 'undefined' && keyCode === 'space' || keyCode === 'enter' || typeof keyCode === 'undefined') {
        event.preventDefault();

        try {
          var element = document.getElementById(item.status_id);

          if (!element) {
            return;
          }

          isElementVisible(element, function (elem) {
            try {
              elem.addEventListener('blur', function (e) {
                if (e.target.classList) {
                  e.target.removeAttribute('tabindex');
                }
              });
              elem.classList.add('dnb-no-focus');
              elem.setAttribute('tabindex', '-1');
              elem.focus({
                preventScroll: true
              });
            } catch (e) {
              warn(e);
            }
          });

          if (IS_IE11) {
            window.scrollTop = element.offsetTop;
          } else if (typeof element.scrollIntoView === 'function') {
            element.scrollIntoView({
              block: 'center',
              behavior: 'smooth'
            });
          }
        } catch (e) {
          warn(e);
        }
      }
    };

    _this._mainRef = React.createRef();
    _this._wrapperRef = React.createRef();
    _this._shellRef = React.createRef();
    _this.anim = new AnimateHeight({
      animate: !isTrue(props.no_animation)
    });

    _this.anim.onStart(function (state) {
      _this.setState({
        isAnimating: true,
        _listenForPropChanges: false
      });

      if (state === 'opening') {
        _this.scrollToStatus();
      }
    });

    _this.anim.onEnd(function (state) {
      _this.setState({
        isAnimating: false,
        _listenForPropChanges: false
      });

      if (_this.state.isActive) {
        _this.setState({
          keepContentVisible: true,
          _listenForPropChanges: false
        });

        dispatchCustomElementEvent(_this._globalStatus, 'on_show', _this._globalStatus);

        if (state === 'opened') {
          _this.setFocus();

          dispatchCustomElementEvent(_this._globalStatus, 'on_open', _this._globalStatus);
        }

        if (state === 'adjusted') {
          if (!isTrue(_this.props.omit_set_focus_on_update)) {
            _this.setFocus();
          }

          dispatchCustomElementEvent(_this._globalStatus, 'on_adjust', _this._globalStatus);
        }
      } else {
        _this.setState({
          keepContentVisible: false,
          _listenForPropChanges: false
        });

        dispatchCustomElementEvent(_this._globalStatus, 'on_close', _this._globalStatus);
      }
    });

    _this.provider = GlobalStatusProvider.create(props.id);
    _this.state.globalStatus = _this._globalStatus = _this.provider.init(props);

    if (isTrue(props.show)) {
      if (isTrue(props.no_animation)) {
        _this.state.isActive = true;
      }
    }

    _this.provider.onUpdate(function (globalStatus) {
      if (globalStatus.on_close) {
        _this._globalStatus = globalStatus;
      }

      _this.adjustHeight = _this.anim.adjustFrom();

      _this.setState({
        globalStatus: globalStatus,
        _listenForPropChanges: false
      });

      var isActive = isTrue(globalStatus.show);

      if (isActive) {
        _this.setState({
          isActive: isActive,
          _listenForPropChanges: false
        });
      }

      if (isTrue(_this.props.autoclose) && _this.hadContent && !_this.hasContent(globalStatus) && !isTrue(_this.props.show) || typeof globalStatus.show !== 'undefined' && !isTrue(globalStatus.show)) {
        _this.setHidden({
          delay: 0
        });
      } else if (isTrue(_this.props.show) || typeof globalStatus.show !== 'undefined' && isTrue(globalStatus.show)) {
        _this.hadContent = _this.hasContent(globalStatus);

        _this.setVisible({
          delay: 0
        });
      }
    });

    _this.initialActiveElement = null;
    return _this;
  }

  _createClass(GlobalStatus, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.anim.setElem(this._shellRef.current);

      if (isTrue(this.props.show)) {
        var isActive = isTrue(this.props.show);

        if (isActive) {
          this.setVisible();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.anim.remove();
      clearTimeout(this._scrollToStatusTimeout);
      clearTimeout(this._visibleTimeout);
      clearTimeout(this._hiddenTimeout);
      this.provider.empty();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        var globalStatus = extendPropsWithContext(this.props, GlobalStatus.defaultProps, this.state.globalStatus);
        this.setState({
          globalStatus: globalStatus
        });
      }

      if (prevProps.show !== this.props.show) {
        var isActive = isTrue(this.props.show);

        if (isActive) {
          this.setVisible();
        } else {
          this.setHidden();
        }
      }
    }
  }, {
    key: "hasContent",
    value: function hasContent(globalStatus) {
      var _globalStatus$items;

      return ((_globalStatus$items = globalStatus.items) === null || _globalStatus$items === void 0 ? void 0 : _globalStatus$items.length) > 0 || globalStatus.text;
    }
  }, {
    key: "correctStatus",
    value: function correctStatus(state) {
      switch (state) {
        case 'information':
          state = 'info';
          break;
      }

      return state;
    }
  }, {
    key: "setFocus",
    value: function setFocus() {
      if (typeof document !== 'undefined' && document.activeElement !== this._wrapperRef.current) {
        this.initialActiveElement = document.activeElement;
      }

      if (this._wrapperRef.current && !isTrue(this.props.omit_set_focus)) {
        this._wrapperRef.current.focus({
          preventScroll: true
        });
      }
    }
  }, {
    key: "scrollToStatus",
    value: function scrollToStatus() {
      var isDone = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (typeof window === 'undefined' || isTrue(this.state.globalStatus.autoscroll) === false) {
        return;
      }

      try {
        var element = this._wrapperRef.current;
        this._scrollToStatusTimeout = isElementVisible(element, isDone);

        if (element && !IS_IE11 && typeof element.scrollIntoView === 'function') {
          element.scrollIntoView({
            block: 'center',
            behavior: 'smooth'
          });
        } else {
          var top = element.offsetTop;

          if (window.scrollTo) {
            window.scrollTo({
              top: top,
              behavior: 'smooth'
            });
          } else {
            window.scrollTop = top;
          }
        }
      } catch (e) {
        warn('GlobalStatus: Could not scroll into view!', e);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state2 = this.state,
          isActive = _this$state2.isActive,
          isAnimating = _this$state2.isAnimating,
          keepContentVisible = _this$state2.keepContentVisible;
      var fallbackProps = extendPropsWithContext(this.props, GlobalStatus.defaultProps, this.context.getTranslation(this.props).GlobalStatus);
      var props = extendPropsWithContext(GlobalStatusProvider.combineMessages([this.context.globalStatus, this.state.globalStatus]), GlobalStatus.defaultProps, fallbackProps);
      var lang = this.context.locale;

      var title = props.title,
          default_title = props.default_title,
          rawState = props.state,
          className = props.className,
          no_animation = props.no_animation,
          hide_close_button = props.hide_close_button,
          close_text = props.close_text,
          _className = props.class,
          status_anchor_text = props.status_anchor_text,
          skeleton = props.skeleton,
          id = props.id,
          item = props.item,
          items = props.items,
          autoclose = props.autoclose,
          show = props.show,
          delay = props.delay,
          autoscroll = props.autoscroll,
          text = props.text,
          icon = props.icon,
          icon_size = props.icon_size,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["title", "default_title", "state", "className", "no_animation", "hide_close_button", "close_text", "class", "status_anchor_text", "skeleton", "id", "item", "items", "autoclose", "show", "delay", "autoscroll", "text", "icon", "icon_size", "children"]);

      var wrapperParams = {
        key: 'global-status',
        className: classnames("dnb-global-status__wrapper dnb-no-focus", createSkeletonClass('font', skeleton, this.context), createSpacingClasses(props), className, _className),
        'aria-live': isActive ? 'assertive' : 'off',
        onKeyDown: this.onKeyDownHandler,
        tabIndex: '-1'
      };
      var state = this.correctStatus(rawState);
      var iconToRender = GlobalStatus.getIcon({
        state: state,
        icon: icon || fallbackProps.icon,
        icon_size: icon_size || fallbackProps.icon_size
      });
      var titleToRender = title || fallbackProps.title || fallbackProps.default_title;
      var noAnimation = isTrue(no_animation);
      var itemsToRender = props.items || [];
      var contentToRender = GlobalStatus.getContent(props);
      var style = state === 'info' ? null : 'fire-red';

      var params = _extends({
        element: 'div',
        className: classnames("dnb-global-status dnb-global-status--".concat(state), isActive ? keepContentVisible && 'dnb-global-status--visible' : 'dnb-global-status--hidden', isAnimating && 'dnb-global-status--is-animating', noAnimation && 'dnb-global-status--no-animation')
      }, attributes);

      skeletonDOMAttributes(params, skeleton, this.context);
      validateDOMAttributes(this.props, params);
      var renderedItems = itemsToRender.length > 0 && React.createElement("ul", {
        className: "dnb-ul"
      }, itemsToRender.map(function (item, i) {
        var id = item.id || item.status_id ? "".concat(item.status_id, "-").concat(i) : makeUniqueId();
        var text = item && item.text || item;
        var label = React.isValidElement(item.status_anchor_label) ? convertJsxToString(item.status_anchor_label) : item.status_anchor_label || '';
        var anchorText = String(item.status_anchor_text || status_anchor_text).replace('%s', label).replace(/[: ]$/g, '');
        var useAutolink = item.status_id && isTrue(item.status_anchor_url);
        return React.createElement("li", {
          key: i
        }, React.createElement("p", {
          id: id,
          className: "dnb-p"
        }, text), item && (useAutolink || item.status_anchor_url) && React.createElement("a", {
          className: "dnb-anchor",
          "aria-describedby": id,
          lang: lang,
          href: useAutolink ? "#".concat(item.status_id) : item.status_anchor_url,
          onClick: function onClick(e) {
            return _this2.gotoItem(e, item);
          },
          onKeyDown: function onKeyDown(e) {
            return _this2.gotoItem(e, item);
          }
        }, anchorText));
      }));
      var hasContent = renderedItems || contentToRender;
      var renderedContent = React.createElement("div", {
        className: "dnb-global-status__content"
      }, title !== false && React.createElement("p", {
        className: "dnb-p dnb-global-status__title",
        lang: lang
      }, React.createElement("span", {
        className: "dnb-global-status__icon"
      }, iconToRender), titleToRender, !isTrue(hide_close_button) && React.createElement(CloseButton, {
        on_click: this.closeHandler,
        text: close_text,
        title: close_text
      })), hasContent && React.createElement(Section, {
        element: "div",
        style_type: "white",
        className: "dnb-global-status__message"
      }, React.createElement("div", {
        className: "dnb-global-status__message__content"
      }, typeof contentToRender === 'string' ? React.createElement("p", {
        className: "dnb-p"
      }, contentToRender) : contentToRender, renderedItems)));
      return React.createElement("div", _extends({}, wrapperParams, {
        ref: this._wrapperRef
      }), React.createElement(Section, _extends({
        style_type: style
      }, params, {
        ref: this._mainRef
      }), React.createElement("div", {
        className: "dnb-global-status__shell",
        ref: this._shellRef
      }, (isAnimating || keepContentVisible || isActive) && renderedContent)));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(GlobalStatus.tagName, GlobalStatus, GlobalStatus.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.text) return props.text;
      return processChildren(props);
    }
  }, {
    key: "getIcon",
    value: function getIcon(_ref3) {
      var state = _ref3.state,
          icon = _ref3.icon,
          icon_size = _ref3.icon_size;

      if (typeof icon === 'string') {
        var IconToLoad = icon;

        switch (state) {
          case 'info':
          case 'information':
            IconToLoad = InfoIcon;
            break;

          case 'error':
          default:
            IconToLoad = ErrorIcon;
        }

        icon = React.createElement(Icon, {
          icon: React.createElement(IconToLoad, {
            title: null
          }),
          size: icon_size
        });
      }

      return icon;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (state._items !== props.items) {
          state.globalStatus = GlobalStatusProvider.combineMessages([state.globalStatus, props]);
        }
      }

      state._items = props.items;
      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return GlobalStatus;
}(React.PureComponent);

GlobalStatus.tagName = 'dnb-global-status';
GlobalStatus.contextType = Context;
GlobalStatus.defaultProps = {
  id: 'main',
  status_id: 'status-main',
  title: null,
  default_title: null,
  text: null,
  items: [],
  icon: 'error',
  icon_size: 'large',
  state: 'error',
  show: null,
  autoscroll: true,
  autoclose: true,
  no_animation: false,
  close_text: 'Lukk',
  hide_close_button: false,
  omit_set_focus: false,
  omit_set_focus_on_update: true,
  delay: 0,
  status_anchor_text: null,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  on_adjust: null,
  on_open: null,
  on_show: null,
  on_close: null,
  on_hide: null
};
export { GlobalStatus as default };
process.env.NODE_ENV !== "production" ? GlobalStatus.propTypes = _extends({
  id: PropTypes.string,
  status_id: PropTypes.string,
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  default_title: PropTypes.string,
  text: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  items: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.array]),
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  icon_size: PropTypes.string,
  state: PropTypes.oneOf(['error', 'info']),
  show: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  autoscroll: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  autoclose: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  delay: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  close_text: PropTypes.string,
  hide_close_button: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  omit_set_focus: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  omit_set_focus_on_update: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  status_anchor_text: PropTypes.string,
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  on_adjust: PropTypes.func,
  on_open: PropTypes.func,
  on_show: PropTypes.func,
  on_close: PropTypes.func,
  on_hide: PropTypes.func
}) : void 0;

var CloseButton = function CloseButton(_ref4) {
  var on_click = _ref4.on_click,
      text = _ref4.text,
      _ref4$className = _ref4.className,
      className = _ref4$className === void 0 ? null : _ref4$className;
  return React.createElement(Button, {
    type: "button",
    variant: "tertiary",
    size: "medium",
    className: classnames('dnb-global-status__close-button', className),
    icon: "close",
    icon_size: "medium",
    icon_position: "left",
    "aria-label": text,
    text: text,
    on_click: on_click
  });
};

process.env.NODE_ENV !== "production" ? CloseButton.propTypes = {
  on_click: PropTypes.func.isRequired,
  className: PropTypes.string,
  text: PropTypes.string
} : void 0;
CloseButton.defaultProps = {
  className: null,
  text: GlobalStatus.defaultProps.close_text
};

GlobalStatus.create = function () {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return _construct(GlobalStatusInterceptor, args);
};

GlobalStatus.Set = GlobalStatus.create;
GlobalStatus.AddStatus = GlobalStatus.create;
GlobalStatus.Update = GlobalStatus.create;
GlobalStatus.Add = GlobalStatusController;
GlobalStatus.Remove = GlobalStatusController.Remove;

var isElementVisible = function isElementVisible(elem, callback) {
  var delayFallback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1e3;

  if (typeof IntersectionObserver !== 'undefined') {
    var intersectionObserver = new IntersectionObserver(function (entries) {
      var _entries = _slicedToArray(entries, 1),
          entry = _entries[0];

      if (entry.isIntersecting) {
        intersectionObserver.unobserve(elem);

        if (typeof callback === 'function') {
          callback(elem);
        }
      }
    });
    intersectionObserver.observe(elem);
  } else {
    if (typeof callback === 'function') {
      return setTimeout(function () {
        return callback(elem);
      }, delayFallback);
    }
  }

  return null;
};

var _ref5 = React.createElement("path", {
  d: "M16 25a.5.5 0 100 1 .5.5 0 000-1v0",
  stroke: "#000",
  strokeWidth: "1.5",
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

var _ref6 = React.createElement("path", {
  d: "M16 21V11",
  stroke: "#000",
  strokeWidth: "1.5",
  strokeLinecap: "round"
});

var _ref7 = React.createElement("path", {
  clipRule: "evenodd",
  d: "M18.161 2.347a2.408 2.408 0 00-4.322 0L1.208 28.077A2.028 2.028 0 003.029 31h25.942a2.028 2.028 0 001.821-2.923l-12.63-25.73z",
  stroke: "#000",
  strokeWidth: "1.5",
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

var ErrorIcon = function ErrorIcon(props) {
  return React.createElement("svg", _extends({
    width: "32",
    height: "32",
    viewBox: "0 0 32 32",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg",
    role: "presentation"
  }, props), props && props.title && React.createElement("title", null, props.title), _ref5, _ref6, _ref7);
};

process.env.NODE_ENV !== "production" ? ErrorIcon.propTypes = {
  title: PropTypes.string
} : void 0;
ErrorIcon.defaultProps = {
  title: 'error'
};

var _ref8 = React.createElement("path", {
  fillRule: "evenodd",
  clipRule: "evenodd",
  d: "M10.1 1.08A14.75 14.75 0 00.26 15.01a14.73 14.73 0 0022.16 12.74l8.27 3.94a.75.75 0 001-1l-3.94-8.27A14.75 14.75 0 0010.1 1.08zM1.76 15.01a13.25 13.25 0 1124.5 6.97.75.75 0 00-.04.72l3.2 6.73-6.72-3.2a.75.75 0 00-.72.04A13.23 13.23 0 011.76 15zM13.38 7.9a1.31 1.31 0 112.63 0 1.31 1.31 0 01-2.63 0zm-1.13 5.07c0-.41.34-.75.75-.75h1.13c1.04 0 1.88.85 1.88 1.88v5.64c0 .84.67 1.51 1.5 1.51h1.13a.75.75 0 110 1.5h-1.13a3 3 0 01-3-3V14.1c0-.2-.17-.38-.38-.38H13a.75.75 0 01-.75-.75z",
  fill: "#000"
});

var InfoIcon = function InfoIcon(props) {
  return React.createElement("svg", _extends({
    width: "32",
    height: "32",
    viewBox: "0 0 32 32",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg",
    role: "presentation"
  }, props), props && props.title && React.createElement("title", null, props.title), _ref8);
};

process.env.NODE_ENV !== "production" ? InfoIcon.propTypes = {
  title: PropTypes.string
} : void 0;
InfoIcon.defaultProps = {
  title: 'info'
};