import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import GlobalStatusProvider from './GlobalStatusProvider';
import { isTrue } from '../../shared/component-helper';
export var GlobalStatusInterceptor = function () {
  function GlobalStatusInterceptor(props) {
    var _this = this;

    _classCallCheck(this, GlobalStatusInterceptor);

    var GSP = null;

    try {
      GSP = GlobalStatusProvider;
    } catch (e) {}

    if (!GSP && typeof window !== 'undefined') {
      GSP = window.GlobalStatusProvider;
    }

    this.provider = GSP.init(props.id || 'main', function (provider) {
      var _provider$add = provider.add(props),
          status_id = _provider$add.status_id;

      _this.status_id = status_id;
    });
    return this;
  }

  _createClass(GlobalStatusInterceptor, [{
    key: "add",
    value: function add(props) {
      return this.provider.add(_extends({
        status_id: this.status_id
      }, props));
    }
  }, {
    key: "update",
    value: function update(props) {
      return this.provider.update(this.status_id, props);
    }
  }, {
    key: "remove",
    value: function remove() {
      return this.provider.remove(this.status_id);
    }
  }]);

  return GlobalStatusInterceptor;
}();

var GlobalStatusController = function (_React$PureComponent) {
  _inherits(GlobalStatusController, _React$PureComponent);

  var _super = _createSuper(GlobalStatusController);

  function GlobalStatusController(props) {
    var _this2;

    _classCallCheck(this, GlobalStatusController);

    _this2 = _super.call(this, props);
    _this2.state = {};
    var GSP = null;

    try {
      GSP = GlobalStatusProvider;
    } catch (e) {}

    if (!GSP && typeof window !== 'undefined') {
      GSP = window.GlobalStatusProvider;
    }

    _this2.state.provider = GSP.init(props.id);
    _this2.state._props = props;
    return _possibleConstructorReturn(_this2, _assertThisInitialized(_this2));
  }

  _createClass(GlobalStatusController, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$state$provider$ = this.state.provider.add(this.props),
          status_id = _this$state$provider$.status_id;

      this.setState({
        status_id: status_id
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.state.provider && isTrue(this.props.remove_on_unmount)) {
        this.state.provider.remove(this.state.status_id);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._props !== props) {
        state.provider.update(state.status_id, props);
      }

      return state;
    }
  }]);

  return GlobalStatusController;
}(React.PureComponent);

GlobalStatusController.defaultProps = {
  id: 'main',
  status_id: null,
  remove_on_unmount: false
};
process.env.NODE_ENV !== "production" ? GlobalStatusController.propTypes = {
  id: PropTypes.string,
  status_id: PropTypes.string,
  remove_on_unmount: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
} : void 0;

var GlobalStatusRemove = function (_React$PureComponent2) {
  _inherits(GlobalStatusRemove, _React$PureComponent2);

  var _super2 = _createSuper(GlobalStatusRemove);

  function GlobalStatusRemove(props) {
    var _this3;

    _classCallCheck(this, GlobalStatusRemove);

    _this3 = _super2.call(this, props);
    _this3.state = {};
    var GSP = null;

    try {
      GSP = GlobalStatusProvider;
    } catch (e) {}

    if (!GSP && typeof window !== 'undefined') {
      GSP = window.GlobalStatusProvider;
    }

    _this3.state.provider = GSP.init(props.id);
    _this3.state._props = props;
    return _this3;
  }

  _createClass(GlobalStatusRemove, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.state.provider.remove(this.props.status_id, this.props);
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._props !== props) {
        state.provider.update(props.status_id, props);
      }

      return state;
    }
  }]);

  return GlobalStatusRemove;
}(React.PureComponent);

GlobalStatusRemove.defaultProps = {
  id: 'main'
};
process.env.NODE_ENV !== "production" ? GlobalStatusRemove.propTypes = {
  id: PropTypes.string,
  status_id: PropTypes.string.isRequired
} : void 0;
GlobalStatusController.Remove = GlobalStatusRemove;
GlobalStatusController.Update = GlobalStatusController;
export default GlobalStatusController;
export { GlobalStatusRemove };