import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { registerElement } from '../../shared/component-helper';
import Context from '../../shared/Context';
import Modal from '../modal/Modal';
import HelpButtonInstance from './HelpButtonInstance';
import { buttonPropTypes } from '../button/Button';

var HelpButton = function (_React$PureComponent) {
  _inherits(HelpButton, _React$PureComponent);

  var _super = _createSuper(HelpButton);

  function HelpButton() {
    _classCallCheck(this, HelpButton);

    return _super.apply(this, arguments);
  }

  _createClass(HelpButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          modal_content = _this$props.modal_content,
          children = _this$props.children,
          modal_props = _this$props.modal_props,
          params = _objectWithoutProperties(_this$props, ["modal_content", "children", "modal_props"]);

      var content = HelpButton.getContent(this.props);

      if (params.icon === null) {
        params.icon = 'question';
      }

      if (content) {
        if (!params.title) {
          params.title = this.context.getTranslation(this.props).HelpButton.title;
        }

        return React.createElement(Modal, _extends({
          trigger_attributes: params
        }, modal_props), content);
      }

      return React.createElement(HelpButtonInstance, params);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(HelpButton.tagName, HelpButton, HelpButton.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.modal_content) {
        return props.modal_content;
      }

      return typeof props.children === 'function' ? props.children(props) : props.children;
    }
  }]);

  return HelpButton;
}(React.PureComponent);

HelpButton.contextType = Context;
HelpButton.tagName = 'dnb-help-button';
HelpButton.defaultProps = {
  variant: 'secondary',
  icon: null,
  icon_position: 'left',
  modal_content: null,
  modal_props: null
};
export { HelpButton as default };
process.env.NODE_ENV !== "production" ? HelpButton.propTypes = _extends({}, buttonPropTypes, {
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  icon_position: PropTypes.oneOf(['left', 'right']),
  modal_content: PropTypes.node,
  modal_props: PropTypes.object
}) : void 0;