import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { convertJsxToString, extendPropsWithContext } from '../../shared/component-helper';
import Context from '../../shared/Context';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import Button, { buttonVariantPropType } from '../button/Button';

var HelpButtonInstance = function (_React$PureComponent) {
  _inherits(HelpButtonInstance, _React$PureComponent);

  var _super = _createSuper(HelpButtonInstance);

  function HelpButtonInstance() {
    _classCallCheck(this, HelpButtonInstance);

    return _super.apply(this, arguments);
  }

  _createClass(HelpButtonInstance, [{
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, HelpButtonInstance.defaultProps, this.context.FormRow, this.context.HelpButton);

      var size = props.size,
          icon = props.icon,
          on_click = props.on_click,
          className = props.className,
          _className = props.class,
          attributes = props.attributes,
          rest = _objectWithoutProperties(props, ["size", "icon", "on_click", "className", "class", "attributes"]);

      var params = _extends({
        className: classnames('dnb-help-button', createSpacingClasses(props), className, _className),
        size: size,
        'aria-label': props.title ? convertJsxToString(props.title) : this.context.getTranslation(this.props).HelpButton.title,
        icon: icon
      }, attributes, rest);

      if (typeof params['aria-roledescription'] === 'undefined') {
        params['aria-roledescription'] = this.context.getTranslation(this.props).HelpButton.aria_role;
      }

      if ((!params.text || params.variant === 'tertiary') && params.icon === null) {
        params.icon = 'question';
      }

      if (icon === 'information' && !size) {
        params.icon_size = 'medium';
      }

      return React.createElement(Button, _extends({
        on_click: on_click
      }, params));
    }
  }]);

  return HelpButtonInstance;
}(React.PureComponent);

HelpButtonInstance.contextType = Context;
HelpButtonInstance.defaultProps = {
  id: null,
  variant: 'secondary',
  icon: null,
  icon_position: 'left',
  className: null,
  class: null
};
export { HelpButtonInstance as default };
process.env.NODE_ENV !== "production" ? HelpButtonInstance.propTypes = _extends({
  id: PropTypes.string
}, buttonVariantPropType, {
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  icon_position: PropTypes.oneOf(['left', 'right'])
}, spacingPropTypes, {
  className: PropTypes.string,
  class: PropTypes.string
}) : void 0;