import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.array.reverse.js";
import "core-js/modules/es.function.name.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.includes.js";
import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.string.split.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _extends from "@babel/runtime/helpers/esm/extends";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { ErrorHandler } from '../../shared/error-helper';
import { isTrue, registerElement, validateDOMAttributes, processChildren, extendPropsWithContext } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { createSkeletonClass } from '../skeleton/SkeletonHelper';
import Context from '../../shared/Context';
export var DefaultIconSize = 16;
export var DefaultIconSizes = {
  default: 16,
  medium: 24
};
export var ListDefaultIconSizes = [['default', 16], ['medium', 24]];
export var ValidIconSizes = ['small', 'default', 'medium', 'large', 'x-large', 'xx-large'];
export var iconPropTypes = _extends({
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func]),
  modifier: PropTypes.string,
  size: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.oneOf(['default', 'medium', 'large'])])
}, spacingPropTypes, {
  width: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  height: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  border: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  color: PropTypes.string,
  inherit_color: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  alt: PropTypes.string,
  title: PropTypes.string,
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  attributes: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
});

var Icon = function (_React$PureComponent) {
  _inherits(Icon, _React$PureComponent);

  var _super = _createSuper(Icon);

  function Icon() {
    _classCallCheck(this, Icon);

    return _super.apply(this, arguments);
  }

  _createClass(Icon, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = extendPropsWithContext(this.props, Icon.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.FormRow, this.context.Icon);

      var _prepareIcon = prepareIcon(props, this.context),
          icon = _prepareIcon.icon,
          size = _prepareIcon.size,
          wrapperParams = _prepareIcon.wrapperParams,
          iconParams = _prepareIcon.iconParams,
          alt = _prepareIcon.alt;

      var IconContainer = prerenderIcon({
        icon: icon,
        size: size,
        alt: alt
      });
      if (!IconContainer) return React.createElement(React.Fragment, null);
      return React.createElement("span", wrapperParams, React.createElement(IconContainer, iconParams));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      var tag = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Icon.tagName;
      var inst = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Icon;
      var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Icon.defaultProps;
      registerElement(tag, inst, props);
    }
  }, {
    key: "getIcon",
    value: function getIcon(props) {
      if (props.icon) {
        return props.icon;
      }

      return processChildren(props);
    }
  }]);

  return Icon;
}(React.PureComponent);

Icon.tagName = 'dnb-icon';
Icon.contextType = Context;
Icon.defaultProps = {
  icon: null,
  modifier: null,
  size: null,
  width: null,
  height: null,
  border: null,
  color: null,
  inherit_color: true,
  alt: null,
  title: null,
  skeleton: null,
  attributes: null,
  className: null,
  children: null
};
export { Icon as default };
process.env.NODE_ENV !== "production" ? Icon.propTypes = _extends({}, iconPropTypes) : void 0;
export var getIconNameFromComponent = function getIconNameFromComponent(icon) {
  var name = typeof icon === 'string' ? icon : icon && (icon.displayName || icon.name);

  if (/^data:image\//.test(name)) {
    return null;
  }

  return name;
};
export var calcSize = function calcSize(props) {
  var icon = props.icon,
      size = props.size,
      width = props.width,
      height = props.height;
  var sizeAsInt = -1;
  var sizeAsString = null;

  if (!size || size === DefaultIconSize) {
    var name = getIconNameFromComponent(icon);
    var nameParts = String(name || '').split('_');

    if (nameParts.length > 1) {
      var lastPartOfIconName = nameParts.reverse()[0];
      var potentialSize = ListDefaultIconSizes.filter(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 1),
            key = _ref2[0];

        return key === lastPartOfIconName;
      }).reduce(function (acc, _ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            key = _ref4[0],
            value = _ref4[1];

        return key && value;
      }, null);

      if (potentialSize) {
        sizeAsInt = potentialSize;
      }

      if (ValidIconSizes.includes(lastPartOfIconName)) {
        sizeAsString = lastPartOfIconName;
      }
    } else {
      if (typeof icon === 'function') {
        var elem = icon();

        if (elem.props) {
          var _potentialSize = -1;

          if (elem.props.width) {
            _potentialSize = elem.props.width;
          }

          if (!_potentialSize && elem.props.viewBox) {
            _potentialSize = /[0-9]+ [0-9]+ ([0-9]+)/.exec(elem.props.viewBox)[1];
          }

          if (_potentialSize) {
            sizeAsInt = _potentialSize;
          }
        }
      }
    }
  } else if (typeof size === 'string' && !(parseFloat(size) > 0)) {
      sizeAsInt = ListDefaultIconSizes.filter(function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 1),
            key = _ref6[0];

        return key === size;
      }).reduce(function (acc, _ref7) {
        var _ref8 = _slicedToArray(_ref7, 2),
            key = _ref8[0],
            value = _ref8[1];

        return key && value;
      }, -1);

      if (ValidIconSizes.includes(size)) {
        sizeAsString = size;
      }
    } else if (parseFloat(size) > 0) {
        sizeAsInt = ListDefaultIconSizes.filter(function (_ref9) {
          var _ref10 = _slicedToArray(_ref9, 2),
              key = _ref10[0],
              value = _ref10[1];

          return key && value === parseFloat(size);
        }).reduce(function (acc, _ref11) {
          var _ref12 = _slicedToArray(_ref11, 2),
              key = _ref12[0],
              value = _ref12[1];

          if (key && value) return value;
          return acc;
        }, -1);

        if (sizeAsInt === -1) {
          sizeAsInt = parseFloat(size);
          sizeAsString = 'custom-size';
        }
      }

  if (!sizeAsString && sizeAsInt > 0) {
    var potentialSizeAsString = ListDefaultIconSizes.reduce(function (acc, _ref13) {
      var _ref14 = _slicedToArray(_ref13, 2),
          key = _ref14[0],
          value = _ref14[1];

      if (key && value === sizeAsInt) {
        return key;
      }

      return acc;
    }, null);

    if (potentialSizeAsString) {
      sizeAsString = potentialSizeAsString;
    }
  }

  var _prepareIconParams = prepareIconParams({
    sizeAsString: sizeAsString,
    sizeAsInt: sizeAsInt,
    size: size,
    width: width,
    height: height
  }),
      isCustomSize = _prepareIconParams.sizeAsString,
      iconParams = _prepareIconParams.params;

  if (isCustomSize) {
    sizeAsString = isCustomSize;
  }

  if (!(sizeAsInt > 0)) {
    sizeAsInt = DefaultIconSize;
  }

  if (size === 'auto') {
    iconParams.width = '100%';
    iconParams.height = '100%';
    sizeAsString = 'auto';
  }

  return {
    iconParams: iconParams,
    sizeAsInt: sizeAsInt,
    sizeAsString: sizeAsString
  };
};

var prepareIconParams = function prepareIconParams(_ref15) {
  var sizeAsString = _ref15.sizeAsString,
      rest = _objectWithoutProperties(_ref15, ["sizeAsString"]);

  var size = rest.size,
      width = rest.width,
      height = rest.height,
      sizeAsInt = rest.sizeAsInt;
  var params = {};

  if (!sizeAsString && !(sizeAsInt > 0) && parseFloat(size) > -1) {
    params.width = params.height = parseFloat(size);
  } else if (sizeAsString === 'custom-size') {
    params.width = params.height = parseFloat(sizeAsInt);
  }

  if (parseFloat(width) > -1) {
    sizeAsString = 'custom-size';
    params.width = parseFloat(width);
  }

  if (parseFloat(height) > -1) {
    sizeAsString = 'custom-size';
    params.height = parseFloat(height);
  }

  validateDOMAttributes({}, params);
  return {
    params: params,
    sizeAsString: sizeAsString
  };
};

export var prepareIcon = function prepareIcon(props, context) {
  var icon = props.icon,
      size = props.size,
      width = props.width,
      height = props.height,
      border = props.border,
      color = props.color,
      inherit_color = props.inherit_color,
      modifier = props.modifier,
      alt = props.alt,
      title = props.title,
      skeleton = props.skeleton,
      _className = props.class,
      className = props.className,
      attributes = _objectWithoutProperties(props, ["icon", "size", "width", "height", "border", "color", "inherit_color", "modifier", "alt", "title", "skeleton", "class", "className"]);

  var _calcSize = calcSize({
    icon: icon,
    size: size,
    width: width,
    height: height
  }),
      sizeAsString = _calcSize.sizeAsString,
      iconParams = _calcSize.iconParams;

  if (color) {
    iconParams.color = color;
  }

  var label = icon ? getIconNameFromComponent(icon) : null;
  var wrapperParams = validateDOMAttributes(props, _extends({
    role: alt ? 'img' : 'presentation',
    alt: alt,
    'aria-label': label ? label.replace(/_/g, ' ') + ' icon' : null,
    title: title
  }, attributes));

  if (!alt && typeof wrapperParams['aria-hidden'] === 'undefined') {
    wrapperParams['aria-hidden'] = true;
  }

  wrapperParams.className = classnames('dnb-icon', sizeAsString ? "dnb-icon--".concat(sizeAsString) : "dnb-icon--default", createSkeletonClass(null, skeleton, context), createSpacingClasses(props), _className, className, modifier && "dnb-icon--".concat(modifier), isTrue(border) && 'dnb-icon--border', isTrue(inherit_color) && 'dnb-icon--inherit-color');
  var iconToRender = Icon.getIcon(props);

  if (typeof iconToRender.defaultProps !== 'undefined') {
    iconToRender = React.createElement(iconToRender, validateDOMAttributes({}, {
      color: color,
      icon: icon,
      size: size,
      width: width,
      height: height
    }));
  }

  return _extends({}, props, {
    icon: iconToRender,
    alt: alt,
    iconParams: iconParams,
    wrapperParams: wrapperParams
  });
};
export var prerenderIcon = function prerenderIcon() {
  var _ref16 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      icon = _ref16.icon,
      _ref16$size = _ref16.size,
      size = _ref16$size === void 0 ? null : _ref16$size,
      _ref16$listOfIcons = _ref16.listOfIcons,
      listOfIcons = _ref16$listOfIcons === void 0 ? null : _ref16$listOfIcons,
      _ref16$alt = _ref16.alt,
      alt = _ref16$alt === void 0 ? null : _ref16$alt;

  if (typeof icon === 'string' && /^data:image\//.test(icon)) {
    return function () {
      return React.createElement("img", {
        src: icon,
        alt: alt || 'no-alt'
      });
    };
  }

  if (typeof icon === 'function') {
    var elem = icon();

    if (React.isValidElement(elem)) {
      return icon;
    }

    return elem;
  }

  if (React.isValidElement(icon) || Array.isArray(icon)) {
    return function () {
      return icon;
    };
  }

  try {
    icon = iconCase(icon);

    if (size && DefaultIconSizes[size] && size !== 'default' && !(parseFloat(size) > 0) && !icon.includes(size)) {
      icon = "".concat(icon, "_").concat(size);
    }

    var mod = (listOfIcons.dnbIcons ? listOfIcons.dnbIcons : listOfIcons)[icon];
    return mod && mod.default ? mod.default : mod;
  } catch (e) {
    new ErrorHandler("Icon '".concat(icon, "' did not exist!"));
    return null;
  }
};
export var iconCase = function iconCase(name) {
  return name.replace(/((?!^)[A-Z])/g, '_$1').toLowerCase().replace(/^[0-9]/g, '$1').replace(/[^a-z0-9_]/gi, '_');
};