import * as React from 'react';
export type InputMaskedMask = Object | any[] | ((...args: any[]) => any);
export type InputMaskedNumberMask = string | boolean | Object;
export type InputMaskedCurrencyMask = string | boolean | Object;
export type InputMaskedShowMask = string | boolean;
export type InputMaskedShowGuide = string | boolean;
export type InputMaskedKeepCharPositions = string | boolean;
export type InputMaskedSize =
  | 'default'
  | 'small'
  | 'medium'
  | 'large'
  | number;
export type InputMaskedValue = string | number;
export type InputMaskedLabel =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type InputMaskedLabelDirection = 'horizontal' | 'vertical';
export type InputMaskedLabelSrOnly = string | boolean;
export type InputMaskedStatus =
  | string
  | boolean
  | ((...args: any[]) => any)
  | React.ReactNode;
export type InputMaskedKeepPlaceholder = string | boolean;
export type InputMaskedSuffix =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type InputMaskedAlign = 'left' | 'center' | 'right';
export type InputMaskedSelectall = string | boolean;
export type InputMaskedStretch = string | boolean;
export type InputMaskedDisabled = string | boolean;
export type InputMaskedSkeleton = string | boolean;
export type InputMaskedInputAttributes = string | Object;
export type InputMaskedInputElement =
  | ((...args: any[]) => any)
  | React.ReactNode;
export type InputMaskedIcon =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type InputMaskedIconSize = string | number;
export type InputMaskedIconPosition = 'left' | 'right';
export type InputMaskedInnerRef = ((...args: any[]) => any) | Object;
export type InputMaskedReadOnly = string | boolean;
export type InputMaskedSubmitElement =
  | ((...args: any[]) => any)
  | React.ReactNode;
export type InputMaskedSubmitButtonIcon =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);
export type InputMaskedSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type InputMaskedTop = string | number | boolean;
export type InputMaskedRight = string | number | boolean;
export type InputMaskedBottom = string | number | boolean;
export type InputMaskedLeft = string | number | boolean;
export type InputMaskedChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface InputMaskedProps extends React.HTMLProps<HTMLElement> {
  mask?: InputMaskedMask;
  number_mask?: InputMaskedNumberMask;
  currency_mask?: InputMaskedCurrencyMask;
  show_mask?: InputMaskedShowMask;
  show_guide?: InputMaskedShowGuide;
  pipe?: (...args: any[]) => any;
  keep_char_positions?: InputMaskedKeepCharPositions;
  placeholder_char?: string;
  on_change?: (...args: any[]) => any;
  on_submit?: (...args: any[]) => any;
  on_focus?: (...args: any[]) => any;
  on_blur?: (...args: any[]) => any;
  on_submit_focus?: (...args: any[]) => any;
  on_submit_blur?: (...args: any[]) => any;
  type?: string;
  size?: InputMaskedSize;
  value?: InputMaskedValue;
  id?: string;
  label?: InputMaskedLabel;
  label_direction?: InputMaskedLabelDirection;
  label_sr_only?: InputMaskedLabelSrOnly;
  status?: InputMaskedStatus;
  status_state?: string;
  status_animation?: string;
  input_state?: string;
  global_status_id?: string;
  autocomplete?: string;
  submit_button_title?: string;
  placeholder?: string;
  keep_placeholder?: InputMaskedKeepPlaceholder;
  suffix?: InputMaskedSuffix;
  align?: InputMaskedAlign;
  selectall?: InputMaskedSelectall;
  stretch?: InputMaskedStretch;
  disabled?: InputMaskedDisabled;
  skeleton?: InputMaskedSkeleton;
  class?: string;
  input_class?: string;
  input_attributes?: InputMaskedInputAttributes;
  input_element?: InputMaskedInputElement;
  icon?: InputMaskedIcon;
  icon_size?: InputMaskedIconSize;
  icon_position?: InputMaskedIconPosition;
  inner_ref?: InputMaskedInnerRef;
  readOnly?: InputMaskedReadOnly;
  submit_element?: InputMaskedSubmitElement;
  submit_button_variant?: any;
  submit_button_icon?: InputMaskedSubmitButtonIcon;
  submit_button_status?: string;
  space?: InputMaskedSpace;
  top?: InputMaskedTop;
  right?: InputMaskedRight;
  bottom?: InputMaskedBottom;
  left?: InputMaskedLeft;
  className?: string;
  children?: InputMaskedChildren;
  custom_element?: Object;
  custom_method?: (...args: any[]) => any;
  on_state_update?: (...args: any[]) => any;
}
export default class InputMasked extends React.Component<
  InputMaskedProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
