import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.string.replace.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import Input, { inputPropTypes } from '../input/Input';
import { isTrue, registerElement, dispatchCustomElementEvent } from '../../shared/component-helper';
import MaskedInput from 'react-text-mask';
import createNumberMask from './addons/createNumberMask';
import classnames from 'classnames';

var InputMasked = function (_React$PureComponent) {
  _inherits(InputMasked, _React$PureComponent);

  var _super = _createSuper(InputMasked);

  function InputMasked() {
    _classCallCheck(this, InputMasked);

    return _super.apply(this, arguments);
  }

  _createClass(InputMasked, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._selectionTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          mask = _this$props.mask,
          number_mask = _this$props.number_mask,
          currency_mask = _this$props.currency_mask,
          show_mask = _this$props.show_mask,
          show_guide = _this$props.show_guide,
          pipe = _this$props.pipe,
          keep_char_positions = _this$props.keep_char_positions,
          placeholderChar = _this$props.placeholder_char,
          props = _objectWithoutProperties(_this$props, ["mask", "number_mask", "currency_mask", "show_mask", "show_guide", "pipe", "keep_char_positions", "placeholder_char"]);

      if (number_mask) {
        if (isTrue(number_mask)) {
          number_mask = {};
        } else {
          if (typeof number_mask === 'string' && number_mask[0] === '{') {
            number_mask = JSON.parse(number_mask);
          }
        }

        mask = createNumberMask(number_mask);
      } else if (currency_mask) {
        if (isTrue(currency_mask)) {
          currency_mask = {};
        } else {
          if (typeof number_mask === 'string' && number_mask[0] === '{') {
            number_mask = JSON.parse(number_mask);
          }
        }

        show_mask = true;
        placeholderChar = null;
        props.align = props.align || 'right';

        var maskParams = _extends({
          allowDecimal: true
        }, currency_mask);

        var fix = typeof currency_mask === 'string' ? currency_mask : typeof currency_mask.currency === 'string' ? currency_mask.currency : 'kr';

        if (props.align === 'left') {
          maskParams.prefix = "".concat(fix, " ");
        } else {
          maskParams.suffix = " ".concat(fix);
        }

        mask = createNumberMask(maskParams);
      }

      if (!props.input_element) {
        if (placeholderChar === '' || placeholderChar === null) {
          placeholderChar = "\u200B";
        }

        if (mask.instanceOf === 'createNumberMask') {
          var callEvent = function callEvent(_ref, name) {
            var event = _ref.event,
                value = _ref.value;
            value = value || event.target.value;
            var cleaned_value = clean(value);
            return dispatchCustomElementEvent(_this, name, {
              event: event,
              value: value,
              cleaned_value: cleaned_value
            });
          };

          props.onMouseUp = function (event) {
            fixPositionIssue(event.target, props);
            callEvent({
              event: event
            }, 'on_mouse_up');
          };

          props.onTouchEnd = function (event) {
            fixPositionIssue(event.target, props);
            callEvent({
              event: event
            }, 'on_touch_end');
          };

          props.on_focus = function (params) {
            fixPositionIssue(params.event.target, props);
            callEvent(params, 'on_focus');
          };

          props.on_key_down = function (params) {
            return callEvent(params, 'on_key_down');
          };

          props.on_submit = function (params) {
            return callEvent(params, 'on_submit');
          };

          props.on_blur = function (params) {
            return callEvent(params, 'on_blur');
          };

          props.on_change = function (params) {
            return callEvent(params, 'on_change');
          };
        }

        props.input_element = function (params, innerRef) {
          params = _extends({}, params, {
            pipe: pipe,
            mask: mask,
            showMask: isTrue(show_mask),
            guide: isTrue(show_guide),
            keepCharPositions: isTrue(keep_char_positions),
            placeholderChar: placeholderChar
          });
          return React.createElement(MaskedInput, _extends({
            render: function render(setRef, props) {
              return React.createElement("input", _extends({
                ref: function ref(_ref2) {
                  return setRef(innerRef.current = _ref2);
                }
              }, props));
            }
          }, params));
        };
      }

      props.className = classnames('dnb-input-masked', props.className, show_mask && show_guide && placeholderChar === '_' && 'dnb-input-masked--guide');
      return React.createElement(Input, props);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(InputMasked.tagName, InputMasked, InputMasked.defaultProps);
    }
  }]);

  return InputMasked;
}(React.PureComponent);

InputMasked.tagName = 'dnb-input-masked';
InputMasked.defaultProps = _extends({}, Input.defaultProps, {
  mask: [],
  number_mask: null,
  currency_mask: null,
  show_mask: false,
  show_guide: true,
  pipe: null,
  keep_char_positions: false,
  placeholder_char: '_',
  on_change: null,
  on_submit: null,
  on_focus: null,
  on_blur: null,
  on_submit_focus: null,
  on_submit_blur: null
});
export { InputMasked as default };
process.env.NODE_ENV !== "production" ? InputMasked.propTypes = _extends({
  mask: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.func]),
  number_mask: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.object]),
  currency_mask: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.object]),
  show_mask: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  show_guide: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  pipe: PropTypes.func,
  keep_char_positions: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  placeholder_char: PropTypes.string,
  on_change: PropTypes.func,
  on_submit: PropTypes.func,
  on_focus: PropTypes.func,
  on_blur: PropTypes.func,
  on_submit_focus: PropTypes.func,
  on_submit_blur: PropTypes.func
}, inputPropTypes) : void 0;

var clean = function clean(v) {
  return String(v).replace(new RegExp('[^\\d,.-]', 'g'), '');
};

var _selectionTimeout;

export var fixPositionIssue = function fixPositionIssue(elem) {
  var _ref3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref3$align = _ref3.align,
      align = _ref3$align === void 0 ? 'right' : _ref3$align;

  clearTimeout(_selectionTimeout);
  _selectionTimeout = setTimeout(function () {
    var cleaned_value = clean(elem.value);

    if (cleaned_value.length > 0) {
      return;
    }

    try {
      var end = elem.selectionEnd;

      if (elem.selectionStart === end && end === elem.value.length) {
        var pos = 0;

        if (align === 'left') {
          pos = end - 1;
        }

        elem.setSelectionRange(pos, pos);
      }
    } catch (e) {}
  }, 1);
};