import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.for-each.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import { disableBodyScroll, enableBodyScroll, clearAllBodyScrollLocks } from '../../shared/libs/bodyScrollLock';
import { warn, isTrue, makeUniqueId, InteractionInvalidation, extendPropsWithContext, combineLabelledBy, combineDescribedBy, validateDOMAttributes, dispatchCustomElementEvent } from '../../shared/component-helper';
import Button from '../button/Button';
import ScrollView from '../../fragments/scroll-view/ScrollView';
import Context from '../../shared/Context';

var ModalContent = function (_React$PureComponent) {
  _inherits(ModalContent, _React$PureComponent);

  var _super = _createSuper(ModalContent);

  function ModalContent(props) {
    var _this;

    _classCallCheck(this, ModalContent);

    _this = _super.call(this, props);
    _this.state = {
      triggeredBy: null,
      triggeredByEvent: null
    };

    _this._androidFocusHelper = function () {
      clearTimeout(_this._androidFocusTimeout);
      _this._androidFocusTimeout = setTimeout(function () {
        try {
          if (document.activeElement.tagName == 'INPUT' || document.activeElement.tagName == 'TEXTAREA') {
            document.activeElement.scrollIntoView();
          }
        } catch (e) {}
      }, 100);
    };

    _this.preventClick = function (e) {
      if (e) {
        e.stopPropagation();
      }
    };

    _this.onCloseClickHandler = function (e) {
      _this.closeModal(e, {
        triggeredBy: 'button'
      });
    };

    _this.onContentClickHandler = function (e) {
      _this.closeModal(e, {
        triggeredBy: 'overlay',
        ifIsLatest: false
      });
    };

    _this.onKeyDownHandler = function (e) {
      switch (keycode(e)) {
        case 'esc':
          {
            var mostCurrent = _toConsumableArray(getListOfModalRoots()).pop();

            if (mostCurrent === _assertThisInitialized(_this)) {
              e.preventDefault();

              _this.closeModal(e, {
                triggeredBy: 'keyboard'
              });
            }

            break;
          }
      }
    };

    _this._contentRef = React.createRef();
    _this._id = makeUniqueId();
    _this._ii = new InteractionInvalidation();

    _this._ii.setBypassSelector(['.dnb-modal__content', "#dnb-modal-".concat(props.root_id || 'root')]);

    return _this;
  }

  _createClass(ModalContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.addToIndex();
      var modalRoots = getListOfModalRoots();
      var firstLevel = modalRoots[0];

      if (firstLevel === this) {
        this.removeScrollPossibility();

        this._ii.activate();
      } else {
        modalRoots.forEach(function (modal) {
          if (modal !== _this2 && typeof modal._iiLocal === 'undefined' && typeof modal._contentRef !== 'undefined') {
            modal._iiLocal = new InteractionInvalidation();

            modal._iiLocal.activate(modal._contentRef.current);
          }
        });
      }

      this.setAndroidFocusHelper();
      this.setFocus();
      var id = this.props.id;
      dispatchCustomElementEvent(this, 'on_open', {
        id: id
      });

      if (typeof document !== 'undefined') {
        document.addEventListener('keydown', this.onKeyDownHandler);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._focusTimeout);
      var modalRoots = getListOfModalRoots();
      var firstLevel = modalRoots[0];
      this.removeFromIndex();

      if (firstLevel === this) {
        this._ii.revert();

        this.revertScrollPossibility();
      } else {
        try {
          var modal = modalRoots[modalRoots.length - 2];

          if (modal !== this && modal._iiLocal) {
            modal._iiLocal.revert();

            delete modal._iiLocal;
          }
        } catch (e) {
          warn(e);
        }
      }

      this.removeAndroidFocusHelper();
      var id = this.props.id;
      var _this$state = this.state,
          triggeredBy = _this$state.triggeredBy,
          triggeredByEvent = _this$state.triggeredByEvent;
      dispatchCustomElementEvent(this, 'on_close', {
        id: id,
        event: triggeredByEvent,
        triggeredBy: triggeredBy || 'unmount'
      });

      if (typeof document !== 'undefined') {
        document.removeEventListener('keydown', this.onKeyDownHandler);
      }
    }
  }, {
    key: "setAndroidFocusHelper",
    value: function setAndroidFocusHelper() {
      if (typeof window !== 'undefined' && typeof navigator !== 'undefined' && /Android/.test(navigator.appVersion)) {
        window.addEventListener('resize', this._androidFocusHelper);
      }
    }
  }, {
    key: "removeAndroidFocusHelper",
    value: function removeAndroidFocusHelper() {
      window.removeEventListener('resize', this._androidFocusHelper);
      clearTimeout(this._androidFocusTimeout);
    }
  }, {
    key: "addToIndex",
    value: function addToIndex() {
      if (typeof window !== 'undefined') {
        try {
          window.__modalStack = window.__modalStack || [];

          window.__modalStack.push(this);
        } catch (e) {
          warn(e);
        }
      }
    }
  }, {
    key: "removeFromIndex",
    value: function removeFromIndex() {
      var _this3 = this;

      if (typeof window !== 'undefined') {
        try {
          window.__modalStack = window.__modalStack || [];
          window.__modalStack = window.__modalStack.filter(function (cur) {
            return cur !== _this3;
          });

          if (!window.__modalStack.length) {
            delete window.__modalStack;
          }
        } catch (e) {
          warn(e);
        }
      }
    }
  }, {
    key: "setFocus",
    value: function setFocus() {
      var _this$props = this.props,
          focus_selector = _this$props.focus_selector,
          animation_duration = _this$props.animation_duration;
      var elem = this._contentRef.current;

      if (elem) {
        clearTimeout(this._focusTimeout);
        this._focusTimeout = setTimeout(function () {
          try {
            var focusElement;

            if (typeof focus_selector === 'string') {
              focusElement = elem.querySelector(focus_selector);
            } else if (focus_selector === false) {
              return;
            }

            if (!focusElement) {
              focusElement = elem.querySelector('h1:first-of-type, h2:first-of-type, .dnb-modal__close-button:not([disabled])');
            }

            if (!focusElement) {
              focusElement = elem;
            }

            if (focusElement) {
              focusElement.focus();
            }
          } catch (e) {
            warn(e);
          }
        }, parseFloat(animation_duration));
      }
    }
  }, {
    key: "removeScrollPossibility",
    value: function removeScrollPossibility() {
      if (this._contentRef.current) {
        disableBodyScroll(this._contentRef.current);
      }
    }
  }, {
    key: "revertScrollPossibility",
    value: function revertScrollPossibility() {
      enableBodyScroll(this._contentRef.current);
      clearAllBodyScrollLocks();
    }
  }, {
    key: "closeModal",
    value: function closeModal(event, _ref) {
      var _event$persist,
          _this4 = this;

      var triggeredBy = _ref.triggeredBy,
          params = _objectWithoutProperties(_ref, ["triggeredBy"]);

      event === null || event === void 0 ? void 0 : (_event$persist = event.persist) === null || _event$persist === void 0 ? void 0 : _event$persist.call(event);
      this.setState({
        triggeredBy: triggeredBy,
        triggeredByEvent: event
      }, function () {
        _this4.props.closeModal(event, _extends({
          triggeredBy: triggeredBy
        }, params));
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          mode = _this$props2.mode,
          hide = _this$props2.hide,
          title = _this$props2.title,
          labelled_by = _this$props2.labelled_by,
          modal_content = _this$props2.modal_content,
          close_title = _this$props2.close_title,
          hide_close_button = _this$props2.hide_close_button,
          spacing = _this$props2.spacing,
          prevent_close = _this$props2.prevent_close,
          open_delay = _this$props2.open_delay,
          prevent_core_style = _this$props2.prevent_core_style,
          animation_duration = _this$props2.animation_duration,
          no_animation = _this$props2.no_animation,
          no_animation_on_mobile = _this$props2.no_animation_on_mobile,
          min_width = _this$props2.min_width,
          max_width = _this$props2.max_width,
          fullscreen = _this$props2.fullscreen,
          align_content = _this$props2.align_content,
          container_placement = _this$props2.container_placement,
          closeModal = _this$props2.closeModal,
          className = _this$props2.className,
          _className = _this$props2.class,
          content_class = _this$props2.content_class,
          overlay_class = _this$props2.overlay_class,
          content_id = _this$props2.content_id,
          toggleOpenClose = _this$props2.toggleOpenClose,
          children = _this$props2.children,
          rest = _objectWithoutProperties(_this$props2, ["mode", "hide", "title", "labelled_by", "modal_content", "close_title", "hide_close_button", "spacing", "prevent_close", "open_delay", "prevent_core_style", "animation_duration", "no_animation", "no_animation_on_mobile", "min_width", "max_width", "fullscreen", "align_content", "container_placement", "closeModal", "className", "class", "content_class", "overlay_class", "content_id", "toggleOpenClose", "children"]);

      var id = content_id || this._id;
      var minWidth = min_width;
      var maxWidth = max_width;

      if (minWidth && !maxWidth && parseFloat(minWidth) > 0) {
        maxWidth = 0;
      } else if (maxWidth && !minWidth && parseFloat(maxWidth) > 0) {
        minWidth = 0;
      }

      var contentParams = {
        role: 'main',
        'aria-modal': 'true',
        'aria-labelledby': combineLabelledBy(this.props, title ? id + '-title' : null, labelled_by),
        'aria-describedby': combineDescribedBy(this.props, id + '-content'),
        className: classnames('dnb-modal__content', (container_placement || mode === 'drawer') && "dnb-modal__content--".concat(container_placement || 'right'), isTrue(fullscreen) ? 'dnb-modal__content--fullscreen' : fullscreen === 'auto' && 'dnb-modal__content--auto-fullscreen', content_class, mode && "dnb-modal__content--".concat(mode), isTrue(hide) && 'dnb-modal__content--hide', isTrue(spacing) && 'dnb-modal__content--spacing', align_content && "dnb-modal__content__align--".concat(align_content), isTrue(no_animation) && 'dnb-modal__content--no-animation', isTrue(no_animation_on_mobile) && 'dnb-modal__content--no-animation-on-mobile'),
        onClick: this.onContentClickHandler
      };

      var innerParams = _extends({
        className: classnames('dnb-modal__content__inner', className, _className, !isTrue(prevent_core_style) && 'dnb-core-style'),
        style: (minWidth || maxWidth) && {
          minWidth: minWidth,
          maxWidth: maxWidth
        },
        onClick: this.preventClick,
        onTouchStart: this.preventClick,
        onKeyDown: this.onKeyDownHandler
      }, rest);

      var spacingParams = {
        tabIndex: -1,
        className: "dnb-modal__content__spacing dnb-no-focus"
      };
      var overlayParams = {
        className: classnames('dnb-modal__overlay', overlay_class, hide && 'dnb-modal__overlay--hide', mode && "dnb-modal__overlay--".concat(mode), isTrue(no_animation) && 'dnb-modal__overlay--no-animation', isTrue(no_animation_on_mobile) && 'dnb-modal__overlay--no-animation-on-mobile')
      };
      validateDOMAttributes(this.props, innerParams);
      return React.createElement(React.Fragment, null, React.createElement("div", _extends({
        id: id
      }, contentParams), React.createElement(ScrollView, innerParams, React.createElement("div", _extends({}, spacingParams, {
        ref: this._contentRef
      }), title && React.createElement("h1", {
        id: id + '-title',
        className: "dnb-modal__title " + (mode === 'drawer' ? 'dnb-h--x-large' : 'dnb-h--large')
      }, title), !isTrue(hide_close_button) && React.createElement(CloseButton, {
        on_click: this.onCloseClickHandler,
        close_title: close_title
      }), React.createElement("div", {
        id: id + '-content',
        className: "dnb-modal__wrapper"
      }, modal_content)))), React.createElement("span", _extends({}, overlayParams, {
        "aria-hidden": "true"
      })));
    }
  }]);

  return ModalContent;
}(React.PureComponent);

ModalContent.defaultProps = {
  mode: null,
  hide: null,
  id: null,
  root_id: null,
  labelled_by: null,
  focus_selector: null,
  content_id: null,
  title: null,
  close_title: null,
  hide_close_button: null,
  spacing: null,
  prevent_close: null,
  prevent_core_style: null,
  animation_duration: null,
  no_animation: null,
  no_animation_on_mobile: null,
  min_width: null,
  max_width: null,
  fullscreen: null,
  align_content: null,
  container_placement: null,
  class: null,
  overlay_class: null,
  content_class: null,
  closeModal: null,
  className: null,
  children: null
};
export { ModalContent as default };
process.env.NODE_ENV !== "production" ? ModalContent.propTypes = {
  modal_content: PropTypes.node.isRequired,
  mode: PropTypes.oneOf(['modal', 'drawer']),
  hide: PropTypes.bool,
  id: PropTypes.string,
  root_id: PropTypes.string,
  labelled_by: PropTypes.string,
  focus_selector: PropTypes.string,
  content_id: PropTypes.string,
  title: PropTypes.node,
  close_title: PropTypes.string,
  hide_close_button: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  spacing: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_close: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_core_style: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  animation_duration: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  no_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_animation_on_mobile: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  min_width: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  max_width: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  fullscreen: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  align_content: PropTypes.string,
  container_placement: PropTypes.string,
  class: PropTypes.string,
  content_class: PropTypes.string,
  overlay_class: PropTypes.string,
  closeModal: PropTypes.func.isRequired,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;
export var CloseButton = function (_React$PureComponent2) {
  _inherits(CloseButton, _React$PureComponent2);

  var _super2 = _createSuper(CloseButton);

  function CloseButton() {
    _classCallCheck(this, CloseButton);

    return _super2.apply(this, arguments);
  }

  _createClass(CloseButton, [{
    key: "render",
    value: function render() {
      var _extendPropsWithConte = extendPropsWithContext(this.props, CloseButton.defaultProps, this.context.getTranslation(this.props).Modal, this.context.FormRow, this.context.ModalContent),
          on_click = _extendPropsWithConte.on_click,
          style_type = _extendPropsWithConte.style_type,
          close_title = _extendPropsWithConte.close_title,
          _extendPropsWithConte2 = _extendPropsWithConte.className,
          className = _extendPropsWithConte2 === void 0 ? null : _extendPropsWithConte2,
          rest = _objectWithoutProperties(_extendPropsWithConte, ["on_click", "style_type", "close_title", "className"]);

      if (style_type === 'cross') {
        rest.icon_size = 'medium';
      } else {
        rest.size = 'large';
        rest.icon_size = 'basis';
        rest.text = close_title;
      }

      return React.createElement(Button, _extends({
        type: "button",
        variant: "secondary",
        className: classnames('dnb-modal__close-button', className, style_type && "dnb-modal__close-button--".concat(style_type)),
        icon: "close",
        on_click: on_click
      }, rest));
    }
  }]);

  return CloseButton;
}(React.PureComponent);
CloseButton.contextType = Context;
CloseButton.defaultProps = {
  style_type: null,
  close_title: null,
  className: null
};
process.env.NODE_ENV !== "production" ? CloseButton.propTypes = {
  style_type: PropTypes.oneOf(['button', 'cross']),
  on_click: PropTypes.func.isRequired,
  close_title: PropTypes.string,
  className: PropTypes.string
} : void 0;
export function getListOfModalRoots() {
  var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

  if (typeof window !== 'undefined') {
    try {
      var stack = window.__modalStack || [];

      if (index !== null) {
        if (index === -1 && stack.length) {
          return stack[stack.length - 1];
        } else if (index > -1) {
          return stack[index];
        }
      }

      return stack;
    } catch (e) {
      warn(e);
    }
  }

  return [];
}