import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.replace.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes } from '../../shared/component-helper';
import Icon from '../../components/icon-primary/IconPrimary';

var _ref = React.createElement("span", {
  className: "dnb-notification__icon"
}, React.createElement(Icon, {
  className: "dnb-notification__icon",
  icon: "bell"
}));

var Notification = function (_React$PureComponent) {
  _inherits(Notification, _React$PureComponent);

  var _super = _createSuper(Notification);

  function Notification() {
    _classCallCheck(this, Notification);

    return _super.apply(this, arguments);
  }

  _createClass(Notification, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          notification_amount = _this$props.notification_amount,
          title_text = _this$props.title_text,
          className = _this$props.className,
          _className = _this$props.class;
      var params = {
        className: classnames('dnb-notification', className, _className, notification_amount > 0 && 'dnb-notification--has-notification')
      };
      var buttonParams = {
        title: title_text.replace(/{amount}/, notification_amount)
      };
      validateDOMAttributes(this.props, params);
      return React.createElement("div", params, React.createElement("button", _extends({
        type: "button",
        className: "dnb-notification__button"
      }, buttonParams), React.createElement("span", {
        className: "dnb-notification__inner"
      }, _ref, notification_amount > 0 && React.createElement("span", {
        className: "dnb-notification__amount"
      }, React.createElement("span", {
        className: "dnb-notification__amount__inner"
      }, notification_amount)))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Notification.tagName, Notification, Notification.defaultProps);
    }
  }]);

  return Notification;
}(React.PureComponent);

Notification.tagName = 'dnb-notification';
Notification.defaultProps = {
  notification_amount: 0,
  title_text: null,
  class: null,
  className: null,
  children: null
};
export { Notification as default };
process.env.NODE_ENV !== "production" ? Notification.propTypes = {
  notification_amount: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  title_text: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;