import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.index-of.js";
import "core-js/modules/es.array.join.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.string.split.js";
import "core-js/modules/es.string.trim.js";
import "core-js/modules/es.string.link.js";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import "regenerator-runtime/runtime.js";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import { LOCALE, CURRENCY, CURRENCY_DISPLAY } from '../../shared/defaults';
import { warn, isTrue, makeUniqueId, validateDOMAttributes, registerElement, convertJsxToString, extend } from '../../shared/component-helper';
import { getSelectedText, copyToClipboard, insertElementBeforeSelection, hasSelectedText, IS_IOS, IS_MAC, IS_WIN, IS_IE11 } from '../../shared/helpers';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
var NUMBER_CHARS = '-0-9,.';

var Number = function (_React$PureComponent) {
  _inherits(Number, _React$PureComponent);

  var _super = _createSuper(Number);

  function Number(props) {
    var _this;

    _classCallCheck(this, Number);

    _this = _super.call(this, props);

    _this.shortcutHandler = function () {
      var fx = createSelectionFX(_this.cleanedValue);
      fx.run();
    };

    _this.onBlurHandler = function () {
      _this.setState({
        selected: false
      });
    };

    _this.onContextMenuHandler = function () {
      if (!hasSelectedText()) {
        clearTimeout(_this._selectAllTimeout);
        _this._selectAllTimeout = setTimeout(function () {
          _this.setFocus();
        }, 1);
      }
    };

    _this.onClickHandler = function () {
      if (!hasSelectedText()) {
        _this.setFocus();
      }
    };

    _this._ref = React.createRef();
    _this._selectionRef = React.createRef();
    _this._id = props.id || makeUniqueId();
    _this.state = {
      selected: false
    };
    return _this;
  }

  _createClass(Number, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      clearTimeout(this._selectAllTimeout);

      if (IS_IOS && !hasiOSFix) {
        hasiOSFix = true;
        runIOSSelectionFix();
      }
    }
  }, {
    key: "setFocus",
    value: function setFocus() {
      var _this2 = this;

      this.setState({
        selected: true
      }, function () {
        if (_this2._selectionRef.current) {
          _this2._selectionRef.current.focus();
        }

        _this2.selectAll();
      });
    }
  }, {
    key: "selectAll",
    value: function selectAll() {
      try {
        var elem = this._selectionRef.current || this._ref.current;

        if (elem) {
          var selection = window.getSelection();
          var range = document.createRange();
          range.selectNodeContents(elem);
          selection.removeAllRanges();
          selection.addRange(range);
        }
      } catch (e) {
        warn(e);
      }
    }
  }, {
    key: "runFix",
    value: function runFix(comp, className) {
      if (typeof comp === 'function') {
        comp = comp();
      }

      if (React.isValidElement(comp)) {
        return React.cloneElement(comp, {
          className: classnames(comp.props.className, className)
        });
      }

      return React.createElement("span", {
        className: className
      }, comp);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          _value = _this$props.value,
          prefix = _this$props.prefix,
          suffix = _this$props.suffix,
          children = _this$props.children,
          currency = _this$props.currency,
          currency_display = _this$props.currency_display,
          currency_position = _this$props.currency_position,
          ban = _this$props.ban,
          nin = _this$props.nin,
          phone = _this$props.phone,
          org = _this$props.org,
          _link = _this$props.link,
          options = _this$props.options,
          locale = _this$props.locale,
          decimals = _this$props.decimals,
          omit_rounding = _this$props.omit_rounding,
          clean = _this$props.clean,
          selectall = _this$props.selectall,
          copy_selection = _this$props.copy_selection,
          element = _this$props.element,
          _className = _this$props.class,
          className = _this$props.className,
          rest = _objectWithoutProperties(_this$props, ["id", "value", "prefix", "suffix", "children", "currency", "currency_display", "currency_position", "ban", "nin", "phone", "org", "link", "options", "locale", "decimals", "omit_rounding", "clean", "selectall", "copy_selection", "element", "class", "className"]);

      var link = _link;
      var value = _value;

      if (children !== null) {
        value = children;
      }

      var formatOptions = {
        locale: locale,
        currency: currency,
        currency_display: currency_display,
        currency_position: currency_position,
        ban: ban,
        nin: nin,
        phone: phone,
        org: org,
        decimals: decimals,
        omit_rounding: isTrue(omit_rounding),
        options: options,
        clean: isTrue(clean),
        returnAria: true
      };

      if (this.context) {
        var useContext = extend(true, {
          locale: null,
          currency: null
        }, this.context, this.context.getTranslation(this.props).Number);

        if (useContext) {
          if (useContext.locale && !locale) {
            formatOptions.locale = useContext.locale;
          }

          if (useContext.currency && isTrue(currency)) {
            formatOptions.options = formatOptions.options ? _extends({}, formatOptions.options) : {};
            formatOptions.options.currency = useContext.currency;
          }
        }
      }

      var _format = format(value, formatOptions),
          cleanedValue = _format.cleanedValue,
          display = _format.number,
          aria = _format.aria,
          lang = _format.locale;

      this.cleanedValue = cleanedValue;

      var attributes = _extends({
        ref: this._ref,
        className: classnames('dnb-number', className, _className, (isTrue(currency) || typeof currency === 'string') && 'dnb-number--currency', createSpacingClasses(this.props), isTrue(selectall) && 'dnb-number--selectall', this.state.selected && 'dnb-number--selected', link && 'dnb-anchor')
      }, rest);

      attributes['role'] = 'text';
      var displayParams = {};

      if (isTrue(selectall) || isTrue(copy_selection)) {
        displayParams.onClick = this.onClickHandler;
        displayParams.onContextMenu = this.onContextMenuHandler;
      }

      validateDOMAttributes(this.props, attributes);

      if (prefix) {
        display = React.createElement(React.Fragment, null, this.runFix(prefix, 'dnb-number__prefix'), " ", display);
        aria = String("".concat(convertJsxToString(this.runFix(prefix, 'dnb-number__prefix')), " ").concat(aria));
      }

      if (suffix) {
        display = React.createElement(React.Fragment, null, display, " ", this.runFix(suffix, 'dnb-number__suffix'));
        aria = "".concat(aria, " ").concat(convertJsxToString(this.runFix(suffix, 'dnb-number__suffix')));
      }

      if (link) {
        if (isTrue(link)) {
          link = 'tel';
        }

        return React.createElement("a", _extends({
          href: "".concat(link, ":").concat(display)
        }, attributes), display);
      }

      var Element = element;
      return React.createElement(Element, _extends({
        lang: lang
      }, attributes), React.createElement("span", _extends({
        className: "dnb-number__visible",
        "aria-describedby": this._id,
        "aria-hidden": true
      }, displayParams), display), React.createElement("span", {
        id: this._id,
        className: "dnb-number__sr-only dnb-sr-only--inline"
      }, aria), isTrue(copy_selection) && React.createElement("span", {
        className: "dnb-number__selection dnb-no-focus",
        ref: this._selectionRef,
        tabIndex: -1,
        onBlur: this.onBlurHandler,
        onCopy: this.shortcutHandler,
        "aria-hidden": true
      }, cleanedValue));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Number.tagName, Number, Number.defaultProps);
    }
  }]);

  return Number;
}(React.PureComponent);

Number.tagName = 'dnb-number';
Number.contextType = Context;
Number.defaultProps = {
  id: null,
  value: null,
  locale: null,
  prefix: null,
  suffix: null,
  currency: null,
  currency_display: null,
  currency_position: null,
  ban: null,
  nin: null,
  phone: null,
  org: null,
  link: null,
  options: null,
  decimals: null,
  selectall: true,
  copy_selection: true,
  omit_rounding: null,
  clean: null,
  element: 'span',
  class: null,
  className: null,
  children: null
};
export { Number as default };
process.env.NODE_ENV !== "production" ? Number.propTypes = _extends({
  id: PropTypes.string,
  value: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  locale: PropTypes.string,
  prefix: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  suffix: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  currency: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  currency_display: PropTypes.string,
  currency_position: PropTypes.oneOf(['auto', 'before', 'after']),
  ban: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  nin: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  phone: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  org: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  link: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  options: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),
  decimals: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  selectall: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  copy_selection: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  omit_rounding: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  clean: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  element: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
}) : void 0;
export var format = function format(value) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$locale = _ref.locale,
      locale = _ref$locale === void 0 ? null : _ref$locale,
      _ref$clean = _ref.clean,
      clean = _ref$clean === void 0 ? false : _ref$clean,
      _ref$phone = _ref.phone,
      phone = _ref$phone === void 0 ? null : _ref$phone,
      _ref$org = _ref.org,
      org = _ref$org === void 0 ? null : _ref$org,
      _ref$ban = _ref.ban,
      ban = _ref$ban === void 0 ? null : _ref$ban,
      _ref$nin = _ref.nin,
      nin = _ref$nin === void 0 ? null : _ref$nin,
      _ref$currency = _ref.currency,
      currency = _ref$currency === void 0 ? null : _ref$currency,
      _ref$currency_display = _ref.currency_display,
      currency_display = _ref$currency_display === void 0 ? CURRENCY_DISPLAY : _ref$currency_display,
      _ref$currency_positio = _ref.currency_position,
      currency_position = _ref$currency_positio === void 0 ? null : _ref$currency_positio,
      _ref$decimals = _ref.decimals,
      decimals = _ref$decimals === void 0 ? null : _ref$decimals,
      _ref$omit_rounding = _ref.omit_rounding,
      omit_rounding = _ref$omit_rounding === void 0 ? null : _ref$omit_rounding,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? null : _ref$options,
      _ref$returnAria = _ref.returnAria,
      returnAria = _ref$returnAria === void 0 ? false : _ref$returnAria;

  var display = value;
  var aria = null;
  var type = 'number';
  var isCurrency = isTrue(currency) || typeof currency === 'string';

  if (!locale) {
    locale = LOCALE;
  } else if (locale === 'auto') {
    try {
      locale = window.navigator.language;
    } catch (e) {
      warn(e);
    }
  }

  var opts = (typeof options === 'string' && options[0] === '{' ? JSON.parse(options) : options) || {};
  var deci = parseFloat(decimals);

  if (isCurrency && isNaN(deci)) {
    deci = 2;
  }

  if (deci >= 0) {
    var isNumber = typeof value === 'number';
    opts.minimumFractionDigits = deci;
    opts.maximumFractionDigits = deci;
    value = String(clean ? cleanNumber(value) : value);
    var pos = value.indexOf('.');

    if (pos > 0 && omit_rounding === true) {
      value = String(value).substr(0, pos + 1 + deci);
    }

    if (isNumber) {
      value = parseFloat(value);
    }
  } else {
    opts.maximumFractionDigits = 20;
  }

  if (isTrue(phone)) {
    type = 'phone';

    var _formatPhone = formatPhone(value, locale),
        _number = _formatPhone.number,
        _aria = _formatPhone.aria;

    value = cleanNumber(value);
    display = _number;
    aria = _aria;
  } else if (isTrue(ban)) {
    type = 'ban';

    var _formatBAN = formatBAN(value, locale),
        _number2 = _formatBAN.number,
        _aria2 = _formatBAN.aria;

    display = _number2;
    aria = _aria2;
  } else if (isTrue(nin)) {
    type = 'nin';

    var _formatNIN = formatNIN(value, locale),
        _number3 = _formatNIN.number,
        _aria3 = _formatNIN.aria;

    display = _number3;
    aria = _aria3;
  } else if (isTrue(org)) {
    type = 'org';

    var _formatORG = formatORG(value, locale),
        _number4 = _formatORG.number,
        _aria4 = _formatORG.aria;

    display = _number4;
    aria = _aria4;
  } else if (isCurrency) {
    type = 'currency';
    var cleanedNumber = deci >= 0 ? value : clean ? cleanNumber(value) : value;
    opts.currency = opts.currency || (isTrue(currency) ? CURRENCY : currency);
    opts.style = 'currency';
    opts.currencyDisplay = opts.currencyDisplay || currency_display || CURRENCY_DISPLAY;

    if (typeof opts.minimumFractionDigits === 'undefined' && String(value).indexOf('.') === -1 && cleanedNumber % 1 === 0) {
      opts.minimumFractionDigits = 0;
    }

    display = formatNumber(cleanedNumber, locale, opts);
    display = cleanupMinus(display);
    display = prepareCurrencyPosition(display, currency_position, locale);
    aria = formatNumber(cleanedNumber, locale, _extends({
      minimumFractionDigits: 0,
      maximumFractionDigits: 2
    }, opts, {
      currencyDisplay: 'name'
    }));
    aria = enhanceSR(cleanedNumber, aria, locale);

    if (IS_IE11) {
      display = display.replace(/^\((.*)\)$/, '-$1');
      aria = aria.replace(/^\((.*)\)$/, '-$1');
      display = cleanupMinus(display);
      aria = cleanupMinus(aria);
    }
  } else {
    display = formatNumber(value, locale, opts);
    display = cleanupMinus(display);
    aria = formatNumber(value, locale, _extends({}, opts, {
      minimumFractionDigits: 1,
      maximumFractionDigits: 20
    }));
    aria = enhanceSR(value, aria, locale);
  }

  if (aria === null) {
    aria = display;
  }

  var cleanedValue = formatNumber(value, locale, opts, function (_ref2) {
    var type = _ref2.type,
        value = _ref2.value;

    switch (type) {
      case 'currency':
      case 'group':
      case 'literal':
        return '';

      default:
        return value;
    }
  });
  return returnAria ? {
    value: value,
    cleanedValue: cleanedValue,
    number: display,
    aria: aria,
    locale: locale,
    type: type
  } : display;
};

var prepareCurrencyPosition = function prepareCurrencyPosition(display) {
  var position = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var locale = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (!position && locale && /no$/i.test(locale)) {
    position = 'after';
  }

  if (position) {
    var sign = String(display).replace(new RegExp("([".concat(NUMBER_CHARS, "])"), 'g'), '').trim();
    var signPos = String(display).indexOf(sign);
    var start = 0;
    var end = 0;

    if (signPos === 0) {
      start = sign.length;
      end = display.length;
    } else {
        end = signPos;
      }

    if (!(end > 0)) {
      return display;
    }

    var num = String(display).substr(start, end).trim();

    switch (position) {
      case 'before':
        display = "".concat(sign, " ").concat(num);
        break;

      case 'after':
        display = "".concat(num, " ").concat(sign);
        break;
    }
  }

  return display;
};

var cleanupMinus = function cleanupMinus(display) {
  var reg = '^(-|−|‐|‒|–|—|―)';
  var first = display[0];
  var second = display[1];

  if (new RegExp(reg).test(first)) {
    if (parseFloat(second) > 0) {
      display = display.replace(new RegExp(reg + '(.*)'), '-$2');
    } else {
      display = display.replace(new RegExp(reg + '([^0-9]+)(.*)'), '$2-$3');
    }
  }

  return display;
};

var enhanceSR = function enhanceSR(value, aria) {
  if (IS_MAC && Math.abs(parseFloat(value)) <= 99999) {
    aria = String(aria).replace(/\s([0-9])/g, '$1');
  }

  aria = cleanupMinus(aria);
  return aria;
};

export var formatNumber = function formatNumber(number, locale) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var formatter = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

  try {
    if (typeof Intl !== 'undefined' && typeof Intl.NumberFormat === 'function') {
      var inst = Intl.NumberFormat(locale, options);

      if (formatter) {
        return inst.formatToParts(number).map(function (val) {
          return formatter(val);
        }).reduce(function (str, part) {
          return str + part;
        });
      } else {
        return inst.format(number);
      }
    } else if (typeof Number !== 'undefined' && typeof Number.toLocaleString === 'function') {
      return parseFloat(number).toLocaleString(locale, options);
    }
  } catch (e) {
    warn("Number could not be formatted: ".concat(JSON.stringify([number, locale, options])), e);
  }

  return number;
};
export var formatPhone = function formatPhone(number) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var display = number;
  var aria = null;

  switch (locale) {
    default:
      {
        number = String(number).replace(/[^+0-9]/g, '');
        var code = '';

        if (number.length > 8 && number.substr(0, 2) !== '00') {
          number = '+' + number;
          number = number.replace(/^\+{2,}/, '+');
        }

        if (number[0] === '+') {
          code = number.substr(0, 3) + ' ';
          number = number.substr(3);
        } else if (number.substr(0, 2) === '00') {
          code = number.substr(0, 4) + ' ';
          number = number.substr(4);
        }

        code = code.replace('+', '00');
        var length = number.length;

        if (length === 8 && number[0] === '8') {
          display = code + number.split(/([0-9]{3})([0-9]{2})/).filter(function (s) {
            return s;
          }).join(' ');
        } else {
          if (length < 6) {
            display = code + number;
          } else {
            display = code + number.split(length === 6 ? /^(\+[0-9]{2})|([0-9]{3})/ : /^(\+[0-9]{2})|([0-9]{2})/).filter(function (s) {
              return s;
            }).join(' ');
          }
        }

        aria = code + number.split(/([0-9]{2})/).filter(function (s) {
          return s;
        }).join(' ');
      }
  }

  if (aria === null) {
    aria = display;
  }

  return {
    number: display,
    aria: aria
  };
};
export var formatBAN = function formatBAN(number) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  number = String(number).replace(/[^0-9]/g, '');
  var display = number;
  var aria = null;

  switch (locale) {
    default:
      {
        display = number.split(/([0-9]{4})([0-9]{2})([0-9]{1,})/).filter(function (s) {
          return s;
        }).join(' ');
        aria = number.split(/([0-9]{2})/).filter(function (s) {
          return s;
        }).join(' ');
      }
  }

  if (aria === null) {
    aria = display;
  }

  return {
    number: display,
    aria: aria
  };
};
export var formatORG = function formatORG(number) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  number = String(number).replace(/[^0-9]/g, '');
  var display = number;
  var aria = null;

  switch (locale) {
    default:
      {
        display = number.split(/([0-9]{3})/).filter(function (s) {
          return s;
        }).join(' ');
        aria = number.split(/([0-9]{1})/).filter(function (s) {
          return s;
        }).join(' ');
      }
  }

  if (aria === null) {
    aria = display;
  }

  return {
    number: display,
    aria: aria
  };
};
export var formatNIN = function formatNIN(number) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  number = String(number).replace(/[^0-9]/g, '');
  var display = number;
  var aria = null;

  switch (locale) {
    default:
      {
        display = number.split(/([0-9]{6})/).filter(function (s) {
          return s;
        }).join(' ');
        aria = display.split(/([0-9]{2})([0-9]{2})([0-9]{2}) ([0-9]{1})([0-9]{1})([0-9]{1})([0-9]{1})([0-9]{1})/).filter(function (s) {
          return s;
        }).join(IS_WIN ? '. ' : ' ');
      }
  }

  if (aria === null) {
    aria = display;
  }

  return {
    number: display,
    aria: aria
  };
};
export function cleanNumber(num) {
  if (typeof num === 'number') {
    return num;
  }

  num = String(num).trim();

  if (/^[^0-9-]/.test(num)) {
    num.replace(/^(^[^0-9-]+)/, '');
  }

  var usesThousand = ',';
  var usesDecimal = '\\.';

  if (/(\s)([0-9]{3})/.test(num)) {
    usesThousand = '\\s';
    usesDecimal = ',';
  } else if (/(\.)([0-9]{3})/.test(num) && !/([,'][0-9]{3})(\.)([0-9]{3})/.test(num)) {
        usesThousand = '\\.';
        usesDecimal = ",|·|'";
      } else if (/(,)([0-9]{3})/.test(num)) {
        usesThousand = ',';
        usesDecimal = '\\.|·';
      } else if (/(')([0-9]{3})/.test(num)) {
          usesThousand = "'";
          usesDecimal = '\\.|,';
        }

  var thousandReg = new RegExp("([0-9]|)(".concat(usesThousand, ")([0-9]{3})"), 'g');

  if (thousandReg.test(num)) {
    num = num.replace(thousandReg, '$1$3');
  }

  var decimalReg = new RegExp("(".concat(usesDecimal, ")([0-9]{1,2})"), 'g');

  if (decimalReg.test(num)) {
    num = num.replace(decimalReg, '.$2');
  }

  var decimalBackup = new RegExp("(".concat(usesDecimal, ")([0-9]{3,})"), 'g');

  if (decimalBackup.test(num)) {
    num = num.replace(decimalBackup, '.$2');
  }

  return num.replace(new RegExp("([^".concat(NUMBER_CHARS, "])"), 'g'), '');
}
var hasiOSFix = false;
export function runIOSSelectionFix() {
  try {
    var selection = window.getSelection();
    var range = document.createRange();
    selection.removeAllRanges();
    selection.addRange(range);
  } catch (e) {}
}
export function copyWithEffect(_x) {
  return _copyWithEffect.apply(this, arguments);
}

function _copyWithEffect() {
  _copyWithEffect = _asyncToGenerator(_regeneratorRuntime.mark(function _callee(string) {
    var success, fx;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            success = null;

            if (!string) {
              _context.next = 14;
              break;
            }

            _context.prev = 2;
            fx = createSelectionFX(string);
            _context.next = 6;
            return copyToClipboard(string);

          case 6:
            success = _context.sent;

            if (success === true) {
              fx.run();
            }

            _context.next = 14;
            break;

          case 10:
            _context.prev = 10;
            _context.t0 = _context["catch"](2);
            warn(_context.t0);
            success = _context.t0;

          case 14:
            return _context.abrupt("return", success);

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[2, 10]]);
  }));
  return _copyWithEffect.apply(this, arguments);
}

export function createSelectionFX(string) {
  var height = 32;
  var left = 0;
  var top = 0;
  var elem;

  try {
    var _cR$, _cR$2, _cR$3;

    var cR = window.getSelection().getRangeAt(0).getClientRects();
    height = (_cR$ = cR[0]) === null || _cR$ === void 0 ? void 0 : _cR$.height;
    left = (_cR$2 = cR[0]) === null || _cR$2 === void 0 ? void 0 : _cR$2.left;
    top = (_cR$3 = cR[0]) === null || _cR$3 === void 0 ? void 0 : _cR$3.top;
  } catch (e) {}

  try {
    if (!(top > 0) && !(left > 0)) {
      var posElem = document.createElement('span');
      posElem.setAttribute('class', 'dnb-number__fx__selection');
      insertElementBeforeSelection(posElem);

      var _posElem$getBoundingC = posElem.getBoundingClientRect();

      top = _posElem$getBoundingC.top;
      left = _posElem$getBoundingC.left;
      top -= height / 1.333;
      posElem.parentElement.removeChild(posElem);
    }

    elem = document.createElement('span');
    elem.textContent = String(string);
    elem.setAttribute('class', 'dnb-number__fx dnb-core-style');
    elem.style.top = "".concat(top, "px");
    elem.style.left = "".concat(left + getSelectedText().length / 2, "px");
  } catch (e) {
    warn(e);
  }

  return new (function () {
    function SelectionFx() {
      _classCallCheck(this, SelectionFx);
    }

    _createClass(SelectionFx, [{
      key: "remove",
      value: function remove() {
        try {
          document.body.removeChild(elem);
        } catch (e) {}
      }
    }, {
      key: "run",
      value: function run() {
        try {
          document.body.appendChild(elem);
          setTimeout(this.remove, 800);
        } catch (e) {
          warn(e);
        }
      }
    }]);

    return SelectionFx;
  }())();
}