import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.slice.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.replace.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { dispatchCustomElementEvent, extendPropsWithContext } from '../../shared/component-helper';
import { calculatePagination, getDotsAriaLabel } from './PaginationCalculation';
import PaginationContext from './PaginationContext';
import Button from '../button/Button';

var _ref3 = React.createElement("div", {
  key: "dot-1"
});

var _ref4 = React.createElement("div", {
  key: "dot-2"
});

var _ref5 = React.createElement("div", {
  key: "dot-3"
});

var PaginationBar = function (_React$PureComponent) {
  _inherits(PaginationBar, _React$PureComponent);

  var _super = _createSuper(PaginationBar);

  function PaginationBar() {
    var _this;

    _classCallCheck(this, PaginationBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.setPage = function (currentPage) {
      var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.keepPageHeight();

      _this.focusPage();

      _this.context.pagination.setState({
        currentPage: currentPage
      });

      _this.preparePageContent(currentPage);

      dispatchCustomElementEvent(_this.context.pagination, 'on_change', _extends({
        page: currentPage,
        pageNo: currentPage
      }, _this.context.pagination, {
        event: event
      }));
    };

    _this.setPrevPage = function () {
      _this.setPage(_this.context.pagination.currentPage - 1);
    };

    _this.setNextPage = function () {
      _this.setPage(_this.context.pagination.currentPage + 1);
    };

    _this.clickHandler = function (_ref) {
      var pageNo = _ref.pageNo,
          event = _ref.event;

      _this.setPage(pageNo, event);
    };

    return _this;
  }

  _createClass(PaginationBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var pgn = this.context.pagination;
      var currentPage = pgn.startupPage || pgn.currentPage;
      pgn.setState({
        currentPage: currentPage
      }, function () {
        return _this2.preparePageContent(currentPage);
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(_ref2) {
      var children = _ref2.children;

      if (this.props.children !== children) {
        this.updatePageContent();
      }
    }
  }, {
    key: "hasChildrenCallabck",
    value: function hasChildrenCallabck() {
      return typeof this.props.children === 'function';
    }
  }, {
    key: "preparePageContent",
    value: function preparePageContent(pageNo) {
      var potentialElement = this.props.children;
      var items = this.context.pagination.prefillItems(this.context.pagination.currentPage, {
        skipObserver: true
      });
      this.context.pagination.setState({
        items: items
      });

      if (this.hasChildrenCallabck()) {
        potentialElement = this.props.children(_extends({
          pageNo: pageNo,
          page: pageNo
        }, this.context.pagination));
      }

      if (potentialElement && React.isValidElement(potentialElement)) {
        this.context.pagination.setContent([pageNo, potentialElement]);
      }
    }
  }, {
    key: "updatePageContent",
    value: function updatePageContent() {
      var pageNo = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.context.pagination.currentPage;
      var potentialElement = this.props.children;

      if (this.hasChildrenCallabck()) {
        potentialElement = this.props.children(_extends({
          pageNo: pageNo,
          page: pageNo
        }, this.context.pagination));
      }

      if (potentialElement && React.isValidElement(potentialElement)) {
        this.context.pagination.setContent([pageNo, potentialElement]);
      }
    }
  }, {
    key: "focusPage",
    value: function focusPage() {
      var _this3 = this;

      this.context.pagination.onPageUpdate(function () {
        try {
          var elem = _this3.props.contentRef.current;
          elem.focus();
        } catch (e) {}
      });
    }
  }, {
    key: "keepPageHeight",
    value: function keepPageHeight() {
      var _this4 = this;

      try {
        var elem = this.props.contentRef.current;
        var pageHeight = elem.offsetHeight;
        elem.style.height = "".concat(pageHeight / 16, "rem");
        elem.style.minHeight = elem.style.height;
      } catch (e) {}

      this.context.pagination.onPageUpdate(function () {
        try {
          var _elem = _this4.props.contentRef.current;
          _elem.style.height = 'auto';
          _elem.style.minHeight = _elem.style.height;
        } catch (e) {}
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var props = extendPropsWithContext(this.props, PaginationBar.defaultProps, this.context.getTranslation(this.props).Pagination);
      var button_title = props.button_title,
          prev_title = props.prev_title,
          next_title = props.next_title,
          more_pages = props.more_pages;
      var _this$context$paginat = this.context.pagination,
          pageCount = _this$context$paginat.pageCount,
          currentPage = _this$context$paginat.currentPage;
      var prevIsDisabled = currentPage === 1;
      var nextIsDisabled = currentPage === pageCount || pageCount === 0;
      var pages = calculatePagination(pageCount, currentPage);
      return React.createElement("div", {
        className: 'dnb-pagination__bar' + (pageCount >= 8 ? " dnb-pagination--many-pages" : "")
      }, React.createElement(Button, {
        key: "left-arrow",
        className: "dnb-pagination__button",
        disabled: prevIsDisabled,
        size: "small",
        icon: "chevron_left",
        on_click: this.setPrevPage,
        title: prevIsDisabled ? null : prev_title
      }), React.createElement("div", {
        className: "dnb-pagination__bar__inner"
      }, pages[0].map(function (pageNo) {
        return React.createElement(Button, {
          key: pageNo,
          className: "dnb-pagination__button",
          size: "medium",
          text: String(pageNo),
          "aria-label": button_title.replace('%s', pageNo),
          variant: pageNo === currentPage ? 'primary' : 'secondary',
          "aria-current": pageNo === currentPage ? 'page' : null,
          on_click: function on_click(event) {
            return _this5.clickHandler({
              pageNo: pageNo,
              event: event
            });
          }
        });
      }), pages.slice(1).map(function (list, idx) {
        return React.createElement(React.Fragment, {
          key: idx
        }, React.createElement("div", {
          key: "dots-".concat(idx),
          className: "dnb-pagination__dots",
          "aria-label": getDotsAriaLabel({
            more_pages: more_pages,
            list: list,
            pages: pages
          })
        }, _ref3, _ref4, _ref5), list.map(function (pageNo) {
          return React.createElement(Button, {
            key: pageNo,
            className: "dnb-pagination__button",
            size: "medium",
            text: String(pageNo),
            "aria-label": button_title.replace('%s', pageNo),
            variant: pageNo === currentPage ? 'primary' : 'secondary',
            "aria-current": pageNo === currentPage ? 'page' : null,
            on_click: function on_click(event) {
              return _this5.clickHandler({
                pageNo: pageNo,
                event: event
              });
            }
          });
        }));
      })), React.createElement(Button, {
        key: "right-arrow",
        className: "dnb-pagination__button",
        disabled: nextIsDisabled,
        size: "small",
        icon: "chevron_right",
        on_click: this.setNextPage,
        title: nextIsDisabled ? null : next_title
      }));
    }
  }]);

  return PaginationBar;
}(React.PureComponent);

PaginationBar.contextType = PaginationContext;
PaginationBar.defaultProps = {
  button_title: null,
  prev_title: null,
  next_title: null,
  more_pages: null,
  contentRef: null,
  children: null
};
export { PaginationBar as default };
process.env.NODE_ENV !== "production" ? PaginationBar.propTypes = {
  button_title: PropTypes.string,
  prev_title: PropTypes.string,
  next_title: PropTypes.string,
  more_pages: PropTypes.string,
  contentRef: PropTypes.object,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
} : void 0;