import "core-js/modules/es.function.name.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import { isTrue, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, getStatusState, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import AlignmentHelper from '../../shared/AlignmentHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';
import FormLabel from '../form-label/FormLabel';
import FormStatus from '../form-status/FormStatus';
import RadioGroup from './RadioGroup';
import RadioGroupContext from './RadioGroupContext';
import Context from '../../shared/Context';
import Suffix from '../../shared/helpers/Suffix';

var _ref2 = React.createElement(AlignmentHelper, null);

var _ref3 = React.createElement("span", {
  className: "dnb-radio__focus",
  "aria-hidden": true
});

var _ref4 = React.createElement("span", {
  className: "dnb-radio__dot",
  "aria-hidden": true
});

var Radio = function (_React$PureComponent) {
  _inherits(Radio, _React$PureComponent);

  var _super = _createSuper(Radio);

  function Radio(props) {
    var _this;

    _classCallCheck(this, Radio);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      var key = keycode(event);

      if (_this.isInNoGroup()) {
        switch (key) {
          case 'enter':
            _this.onChangeHandler(event);

            break;
        }
      } else if (_this.isContextGroupOrSingle()) {
        switch (key) {
          case 'space':
          case 'enter':
            {
              var value = _this.context.value;

              if (value !== null && typeof value !== 'undefined') {
                event.preventDefault();
              }

              if (key === 'enter') {
                var checked = !_this.state.checked;

                _this.setState({
                  checked: checked,
                  _listenForPropChanges: false
                });
              }

              break;
            }
        }
      } else {
        switch (key) {
          case 'space':
            {
              event.preventDefault();
              break;
            }
        }
      }

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_key_down', {
        event: event
      });
    };

    _this.onChangeHandler = function (_event) {
      var event = _event;

      if (isTrue(_this.props.readOnly)) {
        return event.preventDefault();
      }

      var value = event.target.value;
      var checked = !_this.state.checked;

      if (_this.isPlainGroup()) {
        setTimeout(function () {
          _this.setState({
            checked: checked,
            _listenForPropChanges: false
          }, function () {
            return _this.callOnChange({
              value: value,
              checked: checked,
              event: event
            });
          });
        }, 1);
      } else {
        _this.setState({
          checked: checked,
          _listenForPropChanges: false
        });

        _this.callOnChange({
          value: value,
          checked: checked,
          event: event
        });
      }
    };

    _this.isContextGroupOrSingle = function () {
      return typeof _this.context.value !== 'undefined' && !_this.props.group;
    };

    _this.isPlainGroup = function () {
      return typeof _this.context.value === 'undefined' && _this.props.group;
    };

    _this.isInNoGroup = function () {
      return typeof _this.context.value === 'undefined' && !_this.props.group;
    };

    _this.onClickHandler = function (event) {
      if (isTrue(_this.props.readOnly)) {
        return event.preventDefault();
      }

      if (!_this.isPlainGroup()) {
        return;
      }

      var value = event.target.value;
      var checked = event.target.checked;

      _this.callOnChange({
        value: value,
        checked: checked,
        event: event
      });
    };

    _this.callOnChange = function (_ref) {
      var value = _ref.value,
          checked = _ref.checked,
          event = _ref.event;
      var group = _this.props.group;

      if (_this.context.onChange) {
        _this.context.onChange({
          value: value
        });
      }

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        group: group,
        checked: checked,
        value: value,
        event: event
      });

      if (_this._refInput.current) {
        _this._refInput.current.focus();
      }
    };

    _this._refInput = React.createRef();
    _this._id = props.id || makeUniqueId();
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(Radio, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(Context.Consumer, null, function (context) {
        var props = extendPropsWithContext(_this2.props, Radio.defaultProps, _this2.context, {
          skeleton: context === null || context === void 0 ? void 0 : context.skeleton
        }, context.FormRow, context.Radio);

        var status = props.status,
            status_state = props.status_state,
            status_animation = props.status_animation,
            global_status_id = props.global_status_id,
            suffix = props.suffix,
            label = props.label,
            label_sr_only = props.label_sr_only,
            label_position = props.label_position,
            size = props.size,
            readOnly = props.readOnly,
            skeleton = props.skeleton,
            className = props.className,
            _className = props.class,
            _id = props.id,
            _group = props.group,
            _value = props.value,
            _checked = props.checked,
            _disabled = props.disabled,
            attributes = props.attributes,
            children = props.children,
            on_change = props.on_change,
            on_state_update = props.on_state_update,
            custom_method = props.custom_method,
            custom_element = props.custom_element,
            rest = _objectWithoutProperties(props, ["status", "status_state", "status_animation", "global_status_id", "suffix", "label", "label_sr_only", "label_position", "size", "readOnly", "skeleton", "className", "class", "id", "group", "value", "checked", "disabled", "attributes", "children", "on_change", "on_state_update", "custom_method", "custom_element"]);

        var checked = _this2.state.checked;
        var value = props.value,
            group = props.group,
            disabled = props.disabled;
        var hasContext = typeof _this2.context.name !== 'undefined';

        if (hasContext) {
          if (typeof _this2.context.value !== 'undefined') {
            checked = _this2.context.value === value;
          }

          group = _this2.context.name;
          disabled = isTrue(_this2.context.disabled);
        } else if (typeof rest.name !== 'undefined') {
          group = rest.name;
        }

        var id = _this2._id;
        var showStatus = getStatusState(status);
        var mainParams = {
          className: classnames('dnb-radio', createSpacingClasses(props), className, _className, status && "dnb-radio__status--".concat(status_state), size && "dnb-radio--".concat(size), label && "dnb-radio--label-position-".concat(label_position || 'right'))
        };

        var inputParams = _extends({
          role: hasContext || group ? 'radio' : null,
          type: hasContext || group ? 'radio' : 'checkbox'
        }, rest);

        if (showStatus || suffix) {
          inputParams['aria-describedby'] = combineDescribedBy(inputParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
        }

        if (readOnly) {
          inputParams['aria-readonly'] = inputParams.readOnly = true;
        }

        if (!group) {
          inputParams.type = 'checkbox';
          inputParams.role = 'radio';
        }

        skeletonDOMAttributes(inputParams, skeleton, _this2.context);
        validateDOMAttributes(_this2.props, inputParams);
        var labelComp = label && React.createElement(FormLabel, {
          id: id + '-label',
          for_id: id,
          text: label,
          disabled: disabled,
          skeleton: skeleton,
          sr_only: label_sr_only
        });
        return React.createElement("span", mainParams, React.createElement("span", {
          className: "dnb-radio__order"
        }, label_position === 'left' && labelComp, React.createElement("span", {
          className: "dnb-radio__inner"
        }, _ref2, showStatus && React.createElement(FormStatus, {
          id: id + '-form-status',
          global_status_id: global_status_id,
          label: label,
          text_id: id + '-status',
          width_selector: id + ', ' + id + '-label',
          text: status,
          status: status_state,
          animation: status_animation,
          skeleton: skeleton
        }), React.createElement("span", {
          className: "dnb-radio__row"
        }, React.createElement("span", {
          className: "dnb-radio__shell"
        }, React.createElement("input", _extends({
          type: "radio",
          value: value,
          id: id,
          name: group,
          className: "dnb-radio__input",
          checked: checked,
          "aria-checked": checked,
          disabled: isTrue(disabled),
          ref: _this2._refInput
        }, inputParams, {
          onChange: _this2.onChangeHandler,
          onClick: _this2.onClickHandler,
          onKeyDown: _this2.onKeyDownHandler
        })), React.createElement("span", {
          className: classnames('dnb-radio__button', createSkeletonClass('shape', skeleton, _this2.context)),
          "aria-hidden": true
        }), _ref3, _ref4), label_position !== 'left' && labelComp, suffix && React.createElement(Suffix, {
          className: "dnb-radio__suffix",
          id: id + '-suffix',
          context: props
        }, suffix)))));
      });
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Radio.tagName, Radio, Radio.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.checked !== state._checked) {
          state.checked = Radio.parseChecked(props.checked);
        }
      }

      state._listenForPropChanges = true;

      if (state.checked !== state.__checked) {
        dispatchCustomElementEvent({
          props: props
        }, 'on_state_update', {
          checked: state.checked
        });
      }

      state._checked = props.checked;
      state.__checked = state.checked;
      return state;
    }
  }]);

  return Radio;
}(React.PureComponent);

Radio.tagName = 'dnb-radio';
Radio.contextType = RadioGroupContext;
Radio.defaultProps = {
  label: null,
  label_sr_only: null,
  label_position: null,
  checked: null,
  disabled: false,
  id: null,
  size: null,
  group: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  value: '',
  attributes: null,
  readOnly: false,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_state_update: null
};
Radio.Group = RadioGroup;

Radio.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

export { Radio as default };
process.env.NODE_ENV !== "production" ? Radio.propTypes = _extends({
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  label_position: PropTypes.oneOf(['left', 'right']),
  checked: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  id: PropTypes.string,
  group: PropTypes.string,
  size: PropTypes.oneOf(['default', 'medium', 'large']),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  value: PropTypes.string,
  attributes: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  readOnly: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_change: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;