import "core-js/modules/es.function.name.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { extendPropsWithContext, makeUniqueId, registerElement, validateDOMAttributes, getStatusState, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import FormRow from '../form-row/FormRow';
import FormStatus from '../form-status/FormStatus';
import Context from '../../shared/Context';
import Suffix from '../../shared/helpers/Suffix';
import RadioGroupContext from './RadioGroupContext';

var RadioGroup = function (_React$PureComponent) {
  _inherits(RadioGroup, _React$PureComponent);

  var _super = _createSuper(RadioGroup);

  function RadioGroup(props) {
    var _this;

    _classCallCheck(this, RadioGroup);

    _this = _super.call(this, props);

    _this.onChangeHandler = function (_ref) {
      var value = _ref.value,
          event = _ref.event;

      _this.setState({
        value: value,
        _listenForPropChanges: false
      });

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        value: value,
        event: event
      });
    };

    _this._refInput = React.createRef();
    _this._id = props.id || makeUniqueId();
    _this._name = props.name || _this._id;
    _this.state = {
      _listenForPropChanges: true
    };
    return _this;
  }

  _createClass(RadioGroup, [{
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, RadioGroup.defaultProps, this.context.FormRow, this.context.RadioGroup);

      var status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          label_position = props.label_position,
          vertical = props.vertical,
          layout_direction = props.layout_direction,
          no_fieldset = props.no_fieldset,
          size = props.size,
          disabled = props.disabled,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _id = props.id,
          _name = props.name,
          _value = props.value,
          attributes = props.attributes,
          children = props.children,
          on_change = props.on_change,
          custom_method = props.custom_method,
          custom_element = props.custom_element,
          rest = _objectWithoutProperties(props, ["status", "status_state", "status_animation", "global_status_id", "suffix", "label", "label_direction", "label_sr_only", "label_position", "vertical", "layout_direction", "no_fieldset", "size", "disabled", "skeleton", "className", "class", "id", "name", "value", "attributes", "children", "on_change", "custom_method", "custom_element"]);

      var value = this.state.value;
      var id = this._id;
      var showStatus = getStatusState(status);
      var classes = classnames("dnb-radio-group dnb-radio-group--".concat(layout_direction, " dnb-form-component"), createSpacingClasses(props), className, _className, status && "dnb-radio-group__status--".concat(status_state));

      var params = _extends({}, rest);

      if (showStatus || suffix) {
        params['aria-describedby'] = combineDescribedBy(params, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (label) {
        params['aria-labelledby'] = id + '-label';
      }

      validateDOMAttributes(this.props, params);
      var context = {
        name: this._name,
        value: value,
        size: size,
        disabled: disabled,
        label_position: label_position,
        onChange: this.onChangeHandler
      };
      var formRowParams = {
        id: id,
        label: label,
        label_id: id + '-label',
        label_direction: label_direction,
        label_sr_only: label_sr_only,
        direction: label_direction,
        vertical: vertical,
        disabled: disabled,
        skeleton: skeleton,
        no_fieldset: no_fieldset,
        skipContentWrapperIfNested: true
      };
      return React.createElement(RadioGroupContext.Provider, {
        value: context
      }, React.createElement("div", {
        className: classes
      }, React.createElement(FormRow, formRowParams, React.createElement("span", _extends({
        id: id,
        className: "dnb-radio-group__shell",
        role: "radiogroup"
      }, params), children, suffix && React.createElement(Suffix, {
        className: "dnb-radio-group__suffix",
        id: id + '-suffix',
        context: props
      }, suffix), showStatus && React.createElement(FormStatus, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text: status,
        status: status_state,
        text_id: id + '-status',
        width_selector: id + ', ' + id + '-label',
        animation: status_animation,
        skeleton: skeleton
      })))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(RadioGroup.tagName, RadioGroup, RadioGroup.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.value !== state._value) {
          state.value = props.value;
        }

        if (typeof props.value !== 'undefined') {
          state._value = props.value;
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return RadioGroup;
}(React.PureComponent);

RadioGroup.tagName = 'dnb-radio-group';
RadioGroup.contextType = Context;
RadioGroup.defaultProps = {
  label: null,
  label_direction: null,
  label_sr_only: null,
  label_position: null,
  title: null,
  no_fieldset: null,
  disabled: null,
  skeleton: null,
  id: null,
  name: null,
  size: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  vertical: null,
  layout_direction: 'row',
  value: undefined,
  attributes: null,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null
};

RadioGroup.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

export { RadioGroup as default };
process.env.NODE_ENV !== "production" ? RadioGroup.propTypes = _extends({
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_direction: PropTypes.oneOf(['horizontal', 'vertical']),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  label_position: PropTypes.oneOf(['left', 'right']),
  title: PropTypes.string,
  no_fieldset: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  id: PropTypes.string,
  name: PropTypes.string,
  size: PropTypes.oneOf(['default', 'medium', 'large']),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  layout_direction: PropTypes.oneOf(['column', 'row']),
  vertical: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  value: PropTypes.string,
  attributes: PropTypes.oneOfType([PropTypes.string, PropTypes.object])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_change: PropTypes.func
}) : void 0;