import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { extendPropsWithContext, validateDOMAttributes, isTrue } from '../../shared/component-helper';
import { LOCALE } from '../../shared/defaults';
import Space from '../space/Space';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import Context from '../../shared/Context';
import Provider from '../../shared/Provider';

var Skeleton = function (_React$PureComponent) {
  _inherits(Skeleton, _React$PureComponent);

  var _super = _createSuper(Skeleton);

  function Skeleton(props) {
    var _this;

    _classCallCheck(this, Skeleton);

    _this = _super.call(this, props);
    _this.state = {
      ariaLiveUpdate: null
    };
    return _this;
  }

  _createClass(Skeleton, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._ariaLiveUpdateTiemout);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.show !== this.props.show) {
        this.setAriaLiveUpdate();
      }
    }
  }, {
    key: "getProps",
    value: function getProps() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.context;
      return extendPropsWithContext(props, Skeleton.defaultProps, {
        skeleton: context.Skeleton || context.skeleton,
        style_type: context.skeleton_style_type,
        no_animation: context.skeleton_no_animation
      }, context.getTranslation(props).Skeleton);
    }
  }, {
    key: "setAriaLiveUpdate",
    value: function setAriaLiveUpdate() {
      var _this2 = this;

      clearTimeout(this._ariaLiveUpdateTiemout);
      this._ariaLiveUpdateTiemout = setTimeout(function () {
        var _this2$getProps = _this2.getProps(),
            aria_bussy = _this2$getProps.aria_bussy,
            aria_ready = _this2$getProps.aria_ready;

        var newString = null;

        if (isTrue(_this2.props.show)) {
          newString = aria_bussy;
        } else {
          newString = aria_ready;
        }

        if (newString) {
          _this2.setState({
            ariaLiveUpdate: newString
          });

          _this2._ariaLiveUpdateTiemout = setTimeout(function () {
            _this2.setState({
              ariaLiveUpdate: null
            });
          }, 1e3);
        }
      }, 1e3);
    }
  }, {
    key: "render",
    value: function render() {
      var props = this.getProps();

      var show = props.show,
          style_type = props.style_type,
          no_animation = props.no_animation,
          figure = props.figure,
          skeleton = props.skeleton,
          aria_bussy = props.aria_bussy,
          aria_ready = props.aria_ready,
          className = props.className,
          _className = props.class,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["show", "style_type", "no_animation", "figure", "skeleton", "aria_bussy", "aria_ready", "className", "class", "children"]);

      var ariaLiveUpdate = this.state.ariaLiveUpdate;
      var showSkeleton = typeof show === 'boolean' || typeof show === 'string' ? isTrue(show) : skeleton;

      var params = _extends({
        className: classnames(figure ? 'dnb-skeleton__figure' : 'dnb-skeleton__root', createSpacingClasses(props), className, _className, isTrue(showSkeleton) && 'dnb-skeleton', showSkeleton && style_type && "dnb-skeleton--".concat(style_type), isTrue(no_animation) && 'dnb-skeleton--no-animation'),
        'aria-busy': showSkeleton,
        'aria-label': showSkeleton ? aria_bussy : undefined,
        lang: this.context.locale || LOCALE
      }, attributes);

      validateDOMAttributes(props, params);
      return React.createElement(Space, params, figure ? showSkeleton ? typeof figure === 'function' ? figure() : figure : children : React.createElement(Provider, {
        skeleton: showSkeleton,
        skeleton_style_type: style_type,
        skeleton_no_animation: no_animation
      }, children), React.createElement("span", {
        className: "dnb-sr-only",
        "aria-live": "assertive"
      }, ariaLiveUpdate));
    }
  }]);

  return Skeleton;
}(React.PureComponent);

Skeleton.contextType = Context;
Skeleton.defaultProps = {
  show: null,
  skeleton: null,
  style_type: null,
  no_animation: null,
  figure: null,
  aria_bussy: null,
  aria_ready: null,
  element: null,
  class: null,
  className: null,
  children: null
};
export { Skeleton as default };
process.env.NODE_ENV !== "production" ? Skeleton.propTypes = _extends({
  show: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  style_type: PropTypes.oneOfType([PropTypes.oneOf(['lines']), PropTypes.string]),
  figure: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  element: PropTypes.node
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node])
}) : void 0;

function Exclude(props) {
  return React.createElement(Provider, _extends({
    skeleton: false
  }, props));
}

Skeleton.Exclude = Exclude;