import "core-js/modules/es.string.trim.js";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { convertJsxToString, isTrue } from '../../shared/component-helper';
import classnames from 'classnames';
import { IS_IE11 } from '../../shared/helpers';
export var skeletonDOMAttributes = function skeletonDOMAttributes(params, skeleton) {
  var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (isTrue(skeleton) || context !== null && context !== void 0 && context.skeleton) {
    var _context$translation, _context$translation$;

    params.disabled = true;
    params['aria-disabled'] = true;
    params['aria-label'] = context === null || context === void 0 ? void 0 : (_context$translation = context.translation) === null || _context$translation === void 0 ? void 0 : (_context$translation$ = _context$translation.Skeleton) === null || _context$translation$ === void 0 ? void 0 : _context$translation$.aria_bussy;
  }

  return params;
};
export var createSkeletonClass = function createSkeletonClass(method, skeleton) {
  var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (isTrue(skeleton) || context !== null && context !== void 0 && context.skeleton) {
    return 'dnb-skeleton' + (method ? " dnb-skeleton--".concat(method) : "");
  }

  return null;
};
export var AutoSize = function (_React$PureComponent) {
  _inherits(AutoSize, _React$PureComponent);

  var _super = _createSuper(AutoSize);

  function AutoSize() {
    _classCallCheck(this, AutoSize);

    return _super.apply(this, arguments);
  }

  _createClass(AutoSize, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          children = _this$props.children,
          Comp = _this$props.__element,
          style = _this$props.style,
          props = _objectWithoutProperties(_this$props, ["className", "children", "__element", "style"]);

      var string = convertJsxToString(children);

      if (typeof string === 'string') {
        var countChars = string.trim().length;

        if (countChars > 0) {
          return React.createElement(Comp, _extends({
            className: classnames("dnb-skeleton dnb-skeleton--font", className),
            'data-skeleton-chars': String(countChars),
            style: _extends({}, style || {}, _defineProperty({}, IS_IE11 ? 'maxWidth' : '--skeleton-chars', "".concat(countChars, "ch")))
          }, props), children);
        }
      }

      return React.createElement(Comp, _extends({}, props, {
        className: className,
        style: style
      }));
    }
  }]);

  return AutoSize;
}(React.PureComponent);
AutoSize.defaultProps = {
  __element: null,
  children: null,
  className: null,
  style: null
};
process.env.NODE_ENV !== "production" ? AutoSize.propTypes = {
  __element: PropTypes.node,
  children: PropTypes.node,
  className: PropTypes.string,
  style: PropTypes.object
} : void 0;