import "core-js/modules/es.array.reverse.js";
import "core-js/modules/es.number.to-fixed.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.replace.js";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { warn, isTrue, makeUniqueId, registerElement, validateDOMAttributes, processChildren, extendPropsWithContext, getStatusState, combineLabelledBy, combineDescribedBy, dispatchCustomElementEvent } from '../../shared/component-helper';
import AlignmentHelper from '../../shared/AlignmentHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { format } from '../number/Number';
import { createSkeletonClass, skeletonDOMAttributes } from '../skeleton/SkeletonHelper';
import Context from '../../shared/Context';
import Suffix from '../../shared/helpers/Suffix';
import Button from '../button/Button';
import FormLabel from '../form-label/FormLabel';
import FormStatus from '../form-status/FormStatus';

var _ref = React.createElement(AlignmentHelper, null);

var _ref2 = React.createElement("span", {
  className: "dnb-slider__line dnb-slider__line__after"
});

var Slider = function (_React$PureComponent) {
  _inherits(Slider, _React$PureComponent);

  var _super = _createSuper(Slider);

  function Slider(props) {
    var _this;

    _classCallCheck(this, Slider);

    _this = _super.call(this, props);
    _this.state = {
      currentState: 'initial',
      value: null
    };

    _this.onFocusHandler = function () {
      _this.setState({
        _listenForPropChanges: false,
        currentState: 'focused'
      });
    };

    _this.onBlurHandler = function () {
      _this.setState({
        _listenForPropChanges: false,
        currentState: 'normal'
      });
    };

    _this.onClickHandler = function (event) {
      var _this$state = _this.state,
          min = _this$state.min,
          max = _this$state.max,
          reverse = _this$state.reverse,
          vertical = _this$state.vertical;
      var percent = calculatePercent(_this._trackRef.current, event, vertical, reverse);
      var value = percentToValue(percent, min, max);

      _this.emitChange(event, value);

      _this.setJumpedState();
    };

    _this.onSubtractClickHandler = function (event) {
      var step = _this.props.step;
      var _this$state2 = _this.state,
          min = _this$state2.min,
          max = _this$state2.max,
          value = _this$state2.value;

      _this.emitChange(event, clamp(value - (step || 1), min, max));
    };

    _this.onAddClickHandler = function (event) {
      var step = _this.props.step;
      var _this$state3 = _this.state,
          min = _this$state3.min,
          max = _this$state3.max,
          value = _this$state3.value;

      _this.emitChange(event, clamp(value + (step || 1), min, max));
    };

    _this.onMouseDownHandler = function (event) {
      if (typeof document !== 'undefined') {
        try {
          document.body.addEventListener('touchmove', _this.onTouchMoveHandler);
          document.body.addEventListener('touchend', _this.onTouchEndHandler);
          document.body.addEventListener('mousemove', _this.onMouseMoveHandler);
          document.body.addEventListener('mouseup', _this.onMouseUpHandler);
        } catch (e) {
          warn(e);
        }
      }

      _this.setState({
        _listenForPropChanges: false,
        currentState: 'activated'
      });

      if (typeof _this.props.on_drag_start === 'function') {
        dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_drag_start', {
          event: event
        });
      }
    };

    _this.onTouchEndHandler = function (event) {
      return _this.onMouseUpHandler(event);
    };

    _this.onMouseUpHandler = function (event) {
      if (typeof document !== 'undefined') {
        try {
          document.body.removeEventListener('touchmove', _this.onTouchMoveHandler);
          document.body.removeEventListener('touchend', _this.onTouchEndHandler);
          document.body.removeEventListener('mousemove', _this.onMouseMoveHandler);
          document.body.removeEventListener('mouseup', _this.onMouseUpHandler);
        } catch (e) {
          warn(e);
        }
      }

      _this.setState({
        _listenForPropChanges: false,
        currentState: 'normal'
      });

      if (typeof _this.props.on_drag_end === 'function') {
        dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_drag_end', {
          event: event
        });
      }
    };

    _this.onRangeChangeHandler = function (event) {
      var value = parseFloat(event.currentTarget.value);

      _this.setState({
        value: value,
        _listenForPropChanges: false
      }, function () {});

      _this.emitChange(event, value);
    };

    _this.onTouchMoveHandler = function (event) {
      return _this.onMouseMoveHandler(event);
    };

    _this.onMouseMoveHandler = function (event) {
      var elem = _this._trackRef.current;

      if (event && event.detail && typeof event.detail.height !== 'undefined') {
        elem = createMockDiv(event.detail);
        event = event.detail;
      }

      var _this$state4 = _this.state,
          min = _this$state4.min,
          max = _this$state4.max,
          vertical = _this$state4.vertical,
          reverse = _this$state4.reverse;
      var percent = calculatePercent(elem, event, vertical, reverse);
      var value = percentToValue(percent, min, max);

      _this.emitChange(event, value);
    };

    _this._id = props.id || makeUniqueId();
    _this._trackRef = React.createRef();

    var _value2 = Slider.getValue(props);

    _this.state = {
      _listenForPropChanges: true,
      value: _value2,
      _value: _value2,
      __value: _value2
    };
    return _this;
  }

  _createClass(Slider, [{
    key: "roundValue",
    value: function roundValue(value) {
      var step = this.props.step;
      return parseFloat(step) > 0 ? roundToStep(value, step) : parseFloat(value).toFixed(3);
    }
  }, {
    key: "emitChange",
    value: function emitChange(event, rawValue, callback) {
      var _this$context;

      var _this$state5 = this.state,
          previousValue = _this$state5.value,
          disabled = _this$state5.disabled;

      if (disabled || isTrue(this.props.skeleton) || isTrue((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton)) {
        return;
      }

      var value = this.roundValue(rawValue);

      if (value > -1) {
        if (typeof this.props.on_change === 'function' && value !== this.roundValue(previousValue)) {
          var obj = {
            value: value,
            rawValue: rawValue,
            raw_value: rawValue,
            event: event
          };

          if (this.props.number_format) {
            obj.number = formatNumber(value, this.props.number_format);
          }

          dispatchCustomElementEvent(this, 'on_change', obj);

          if (typeof callback === 'function') {
            callback();
          }
        }

        this.setState({
          value: rawValue,
          _listenForPropChanges: false
        });
      }
    }
  }, {
    key: "setJumpedState",
    value: function setJumpedState() {
      var _this2 = this;

      this.setState({
        currentState: 'jumped',
        _listenForPropChanges: false
      }, function () {
        clearTimeout(_this2.jumpedTimeout);
        _this2.jumpedTimeout = setTimeout(function () {
          return _this2.setState({
            currentState: 'normal',
            _listenForPropChanges: false
          });
        }, 100);
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;

      if (this._trackRef.current) {
        if (isTrue(this.props.use_scrollwheel)) {
          var _this$state6 = this.state,
              min = _this$state6.min,
              max = _this$state6.max,
              reverse = _this$state6.reverse,
              vertical = _this$state6.vertical;

          this._trackRef.current.addEventListener('wheel', function (event) {
            event.preventDefault();

            _this3.emitChange(event, clamp(_this3.state.value + (!vertical && reverse || vertical && !reverse ? -event.deltaY / 10 : event.deltaY / 10), min, max));
          });
        }
      }

      if (typeof this.props.on_init === 'function') {
        var value = this.state.value;
        var obj = {
          value: value
        };

        if (this.props.number_format) {
          obj.number = formatNumber(value, this.props.number_format);
        }

        dispatchCustomElementEvent(this, 'on_init', obj);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (typeof document !== 'undefined') {
        try {
          document.body.removeEventListener('touchmove', this.onTouchMoveHandler);
          document.body.removeEventListener('touchend', this.onTouchEndHandler);
          document.body.removeEventListener('mousemove', this.onMouseMoveHandler);
          document.body.removeEventListener('mouseup', this.onMouseUpHandler);
        } catch (e) {
          warn(e);
        }
      }

      clearTimeout(this.jumpedTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context2;

      var props = extendPropsWithContext(this.props, Slider.defaultProps, {
        skeleton: (_this$context2 = this.context) === null || _this$context2 === void 0 ? void 0 : _this$context2.skeleton
      }, this.context.getTranslation(this.props).Slider, this.context.FormRow, this.context.Slider);

      var label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          stretch = props.stretch,
          suffix = props.suffix,
          title = props.thump_title,
          subtract_title = props.subtract_title,
          add_title = props.add_title,
          hide_buttons = props.hide_buttons,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _max = props.max,
          _min = props.min,
          _disabled = props.disabled,
          _reverse = props.reverse,
          _vertical = props.vertical,
          _id = props.id,
          _step = props.step,
          _value = props.value,
          _children = props.children,
          _use_scrollwheel = props.use_scrollwheel,
          attributes = _objectWithoutProperties(props, ["label", "label_direction", "label_sr_only", "status", "status_state", "status_animation", "global_status_id", "stretch", "suffix", "thump_title", "subtract_title", "add_title", "hide_buttons", "skeleton", "className", "class", "max", "min", "disabled", "reverse", "vertical", "id", "step", "value", "children", "use_scrollwheel"]);

      var _this$state7 = this.state,
          min = _this$state7.min,
          max = _this$state7.max,
          reverse = _this$state7.reverse,
          vertical = _this$state7.vertical,
          value = _this$state7.value,
          currentState = _this$state7.currentState,
          disabled = _this$state7.disabled;
      var showStatus = getStatusState(status);
      var showButtons = !isTrue(hide_buttons);
      var id = this._id;
      var mainParams = {
        className: classnames("dnb-slider dnb-form-component", createSkeletonClass(null, skeleton), createSpacingClasses(props), className, _className, reverse && 'dnb-slider--reverse', vertical && 'dnb-slider--vertical', isTrue(stretch) && 'dnb-slider--stretch', label && label_direction && "dnb-slider__label--".concat(label_direction), showStatus && 'dnb-slider__form-status', status && "dnb-slider__status--".concat(status_state))
      };
      var percent = clamp((value - min) * 100 / (max - min));

      var _formatNumber = formatNumber(value, _extends({
        returnAria: true
      }, this.props.number_format)),
          humanNumber = _formatNumber.aria;

      var hasHumanNumber = value !== humanNumber;

      var inlineStyleBefore = _defineProperty({}, "".concat(vertical ? 'height' : 'width'), "".concat(percent, "%"));

      var inlineThumbStyles = _defineProperty({}, "".concat(vertical ? 'top' : 'left'), "".concat(percent, "%"));

      skeletonDOMAttributes(mainParams, skeleton, this.context);
      var helperParams = {};
      var trackParams = {
        className: 'dnb-slider__track' + (currentState ? " dnb-slider__state--".concat(currentState) : ""),
        onTouchStart: this.onClickHandler,
        onTouchStartCapture: this.onMouseDownHandler,
        onMouseDown: this.onClickHandler,
        onMouseDownCapture: this.onMouseDownHandler
      };

      var thumbParams = _extends({
        title: title
      }, attributes, {
        onBlur: this.onBlurHandler,
        onFocus: this.onFocusHandler
      });

      if (label || hasHumanNumber) {
        helperParams['aria-labelledby'] = combineLabelledBy(helperParams, hasHumanNumber ? id + '-human' : null, label ? id + '-label' : null);
      }

      if (showStatus || suffix) {
        helperParams['aria-describedby'] = combineDescribedBy(helperParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      var subtractParams = {};
      var addParams = {};

      if (typeof thumbParams['aria-hidden'] !== 'undefined') {
        helperParams['aria-hidden'] = addParams['aria-hidden'] = subtractParams['aria-hidden'] = thumbParams['aria-hidden'];
      }

      validateDOMAttributes(this.props, thumbParams);
      validateDOMAttributes(null, trackParams);
      validateDOMAttributes(null, helperParams);
      var subtractButton = React.createElement(Button, {
        className: "dnb-slider__button dnb-slider__button--subtract",
        variant: "secondary",
        icon: "subtract",
        size: "small",
        "aria-label": subtract_title.replace('%s', humanNumber),
        on_click: this.onSubtractClickHandler,
        disabled: disabled,
        skeleton: skeleton
      });
      var addButton = React.createElement(Button, {
        className: "dnb-slider__button dnb-slider__button--add",
        variant: "secondary",
        icon: "add",
        size: "small",
        "aria-label": add_title.replace('%s', humanNumber),
        on_click: this.onAddClickHandler,
        disabled: disabled,
        skeleton: skeleton
      });
      return React.createElement("span", mainParams, label && React.createElement(FormLabel, {
        id: id + '-label',
        text: label,
        disabled: disabled,
        skeleton: skeleton,
        label_direction: label_direction,
        sr_only: label_sr_only
      }), React.createElement("span", {
        className: "dnb-slider__wrapper"
      }, _ref, showStatus && React.createElement(FormStatus, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), React.createElement("span", {
        className: "dnb-slider__inner"
      }, showButtons && (reverse ? addButton : subtractButton), React.createElement("span", _extends({
        id: this._id,
        ref: this._trackRef
      }, trackParams), React.createElement("span", {
        className: "dnb-slider__thumb",
        style: inlineThumbStyles
      }, React.createElement("input", _extends({
        type: "range",
        className: "dnb-slider__button-helper",
        min: min,
        max: max,
        step: _step,
        value: value,
        disabled: disabled,
        orientation: vertical ? 'vertical' : 'horizontal',
        onChange: this.onRangeChangeHandler
      }, helperParams)), React.createElement(Button, _extends({
        tabIndex: "-1",
        "aria-hidden": true,
        variant: "secondary",
        disabled: disabled,
        skeleton: skeleton,
        onMouseDown: this.onMouseDownHandler
      }, thumbParams))), React.createElement("span", {
        className: "dnb-slider__line dnb-slider__line__before",
        style: inlineStyleBefore
      }), _ref2, hasHumanNumber && React.createElement("span", {
        id: id + '-human',
        className: "dnb-sr-only",
        "aria-hidden": true
      }, humanNumber)), showButtons && (reverse ? subtractButton : addButton), suffix && React.createElement(Suffix, {
        className: "dnb-slider__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Slider.tagName, Slider, Slider.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        state.reverse = isTrue(props.reverse);

        if (isTrue(props.vertical)) {
          state.reverse = !state.reverse;
        }

        state.vertical = isTrue(props.vertical);
        state.min = parseFloat(props.min);
        state.max = parseFloat(props.max);
        var value = Slider.getValue(props);

        if (value !== state._value && value >= -1) {
          state.value = value;

          if (typeof props.on_state_update === 'function') {
            var obj = {
              value: value
            };

            if (props.number_format) {
              obj.number = formatNumber(value, props.number_format);
            }

            dispatchCustomElementEvent(_extends({}, props), 'on_state_update', obj);
          }
        }

        state._value = value;
      }

      state._listenForPropChanges = true;
      state.disabled = isTrue(props.disabled);

      if (isTrue(props.skeleton)) {
        state.disabled = true;
      }

      if (state.disabled) {
        state.currentState = 'disabled';
      } else if (state.currentState === 'disabled') {
        state.currentState = 'normal';
      }

      return state;
    }
  }, {
    key: "getValue",
    value: function getValue(props) {
      if (props.value >= -1) {
        return props.value;
      }

      return processChildren(props);
    }
  }]);

  return Slider;
}(React.PureComponent);

Slider.tagName = 'dnb-slider';
Slider.contextType = Context;
Slider.defaultProps = {
  id: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  thump_title: null,
  add_title: '+',
  subtract_title: '−',
  min: 0,
  max: 100,
  value: -1,
  step: null,
  vertical: false,
  reverse: false,
  stretch: false,
  number_format: null,
  disabled: false,
  hide_buttons: false,
  use_scrollwheel: false,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  on_init: null,
  on_change: null,
  on_drag_start: null,
  on_drag_end: null,
  on_state_update: null
};
export { Slider as default };
process.env.NODE_ENV !== "production" ? Slider.propTypes = _extends({
  id: PropTypes.string,
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_direction: PropTypes.oneOf(['horizontal', 'vertical']),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  thump_title: PropTypes.string,
  add_title: PropTypes.string,
  subtract_title: PropTypes.string,
  min: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  max: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  step: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  vertical: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  reverse: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  stretch: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  number_format: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  hide_buttons: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  use_scrollwheel: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  on_init: PropTypes.func,
  on_change: PropTypes.func,
  on_drag_start: PropTypes.func,
  on_drag_end: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;

var percentToValue = function percentToValue(percent, min, max) {
  return (max - min) * percent / 100 + min;
};

var roundToStep = function roundToStep(number, step) {
  return Math.round(number / step) * step;
};

var getOffset = function getOffset(node) {
  var _global = global,
      pageYOffset = _global.pageYOffset,
      pageXOffset = _global.pageXOffset;

  var _node$getBoundingClie = node.getBoundingClientRect(),
      left = _node$getBoundingClie.left,
      top = _node$getBoundingClie.top;

  return {
    top: top + pageYOffset,
    left: left + pageXOffset
  };
};

var getMousePosition = function getMousePosition(event) {
  if (event.changedTouches && event.changedTouches[0]) {
    return {
      x: event.changedTouches[0].pageX,
      y: event.changedTouches[0].pageY
    };
  }

  return {
    x: event.pageX,
    y: event.pageY
  };
};

var calculatePercent = function calculatePercent(node, event, isVertical, isReverted) {
  var _node$getBoundingClie2 = node.getBoundingClientRect(),
      width = _node$getBoundingClie2.width,
      height = _node$getBoundingClie2.height;

  var _getOffset = getOffset(node),
      top = _getOffset.top,
      left = _getOffset.left;

  var _getMousePosition = getMousePosition(event),
      x = _getMousePosition.x,
      y = _getMousePosition.y;

  var value = isVertical ? y - top : x - left;
  var onePercent = (isVertical ? height : width) / 100;
  return isReverted ? 100 - clamp(value / onePercent) : clamp(value / onePercent);
};

var clamp = function clamp(value) {
  var min = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var max = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 100;
  return Math.min(Math.max(value, min), max);
};

var createMockDiv = function createMockDiv(_ref3) {
  var width = _ref3.width,
      height = _ref3.height;
  var div = document.createElement('div');

  _extends(div.style, {
    width: "".concat(width, "px"),
    height: "".concat(height, "px")
  });

  div.getBoundingClientRect = function () {
    return {
      width: width,
      height: height,
      top: 0,
      left: 0,
      right: width,
      bottom: height
    };
  };

  return div;
};

function formatNumber(value) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  if (opts) {
    return format(value, opts);
  }

  return value;
}