import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { isTrue, extendPropsWithContext, registerElement, processChildren, validateDOMAttributes } from '../../shared/component-helper';
import Context from '../../shared/Context';
import { createSpacingClasses, isInline, spacingPropTypes, spacingDefaultProps } from './SpacingHelper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';
export { spacingPropTypes };

var Space = function (_React$PureComponent) {
  _inherits(Space, _React$PureComponent);

  var _super = _createSuper(Space);

  function Space() {
    _classCallCheck(this, Space);

    return _super.apply(this, arguments);
  }

  _createClass(Space, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = this.context.space ? extendPropsWithContext(this.props, Space.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.space) : this.props;

      var element = props.element,
          inline = props.inline,
          no_collapse = props.no_collapse,
          top = props.top,
          right = props.right,
          bottom = props.bottom,
          left = props.left,
          space = props.space,
          skeleton = props.skeleton,
          _id = props.id,
          className = props.className,
          _className = props.class,
          attributes = _objectWithoutProperties(props, ["element", "inline", "no_collapse", "top", "right", "bottom", "left", "space", "skeleton", "id", "className", "class"]);

      var children = Space.getContent(this.props);

      var params = _extends({
        className: classnames('dnb-space', createSkeletonClass(null, skeleton), createSpacingClasses({
          top: top,
          right: right,
          bottom: bottom,
          left: left,
          space: space
        }), className, _className, isTrue(inline) && 'dnb-space--inline')
      }, attributes);

      skeletonDOMAttributes(params, skeleton);
      validateDOMAttributes(this.props, params);
      return React.createElement(Element, _extends({
        element: element,
        no_collapse: no_collapse
      }, params), children);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Space.tagName, Space, Space.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      return processChildren(props);
    }
  }]);

  return Space;
}(React.PureComponent);

Space.tagName = 'dnb-space';
Space.contextType = Context;
Space.defaultProps = _extends({
  id: null,
  element: 'div',
  inline: null,
  no_collapse: null
}, spacingDefaultProps, {
  skeleton: null,
  class: null,
  className: null,
  children: null
});
export { Space as default };
process.env.NODE_ENV !== "production" ? Space.propTypes = _extends({
  id: PropTypes.string,
  element: PropTypes.string,
  inline: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_collapse: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node])
}) : void 0;

var Element = function Element(_ref) {
  var E = _ref.element,
      no_collapse = _ref.no_collapse,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ["element", "no_collapse", "children"]);

  if (isTrue(no_collapse)) {
    var R = E === 'span' || isInline(Element) ? 'span' : 'div';
    return React.createElement(R, {
      className: 'dnb-space--no-collapse' + (isInline(Element) ? " dnb-space--inline" : "")
    }, React.createElement(E, props, children));
  }

  return React.createElement(E, props, children);
};

process.env.NODE_ENV !== "production" ? Element.propTypes = {
  children: PropTypes.node,
  element: PropTypes.string,
  no_collapse: PropTypes.bool
} : void 0;
Element.defaultProps = {
  children: null,
  element: 'div',
  no_collapse: true
};