import * as React from 'react';
export type StepIndicatorData =
  | string
  | string[]
  | {
      title: string;
      url?: string;
      is_active?: string | boolean;
      is_current?: string | boolean;
      url_future?: string;
      url_passed?: string;
      on_click?: (...args: any[]) => any;
      on_render?: (...args: any[]) => any;
    }[];
export type StepIndicatorActiveItem = string | number;
export type StepIndicatorHideNumbers = string | boolean;
export type StepIndicatorUseNavigation = string | boolean;
export type StepIndicatorSkeleton = string | boolean;
export type StepIndicatorSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type StepIndicatorTop = string | number | boolean;
export type StepIndicatorRight = string | number | boolean;
export type StepIndicatorBottom = string | number | boolean;
export type StepIndicatorLeft = string | number | boolean;
export type StepIndicatorChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface StepIndicatorProps extends React.HTMLProps<HTMLElement> {
  data: StepIndicatorData;
  step_title?: string;
  active_item?: StepIndicatorActiveItem;
  active_url?: string;
  hide_numbers?: StepIndicatorHideNumbers;
  use_navigation?: StepIndicatorUseNavigation;
  on_item_render?: (...args: any[]) => any;
  skeleton?: StepIndicatorSkeleton;
  space?: StepIndicatorSpace;
  top?: StepIndicatorTop;
  right?: StepIndicatorRight;
  bottom?: StepIndicatorBottom;
  left?: StepIndicatorLeft;
  class?: string;
  className?: string;
  children?: StepIndicatorChildren;
  on_change?: (...args: any[]) => any;
}
export default class StepIndicator extends React.Component<
  StepIndicatorProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
