import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.string.includes.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../../shared/Context';
import { warn, registerElement, validateDOMAttributes, processChildren, extendPropsWithContext } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';
import StepItem from './StepIndicatorItem';

var StepIndicator = function (_React$PureComponent) {
  _inherits(StepIndicator, _React$PureComponent);

  var _super = _createSuper(StepIndicator);

  function StepIndicator(props) {
    var _this;

    _classCallCheck(this, StepIndicator);

    _this = _super.call(this, props);

    _this.setActimeItem = function (activeItem) {
      _this.setState({
        activeItem: activeItem,
        _listenForPropChanges: false
      });
    };

    _this.state = {
      hasReached: [],
      _listenForPropChanges: true
    };
    var sn = 'show_numbers';

    if (typeof props[sn] !== 'undefined') {
      warn('StepIndicator: "show_numbers" is deprecated. Use "hide_numbers" instead.');
    }

    return _this;
  }

  _createClass(StepIndicator, [{
    key: "render",
    value: function render() {
      var _this$context,
          _this2 = this;

      var props = extendPropsWithContext(this.props, StepIndicator.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).StepIndicator, this.context.FormRow, this.context.StepIndicator);

      var active_item = props.active_item,
          active_url = props.active_url,
          hide_numbers = props.hide_numbers,
          use_navigation = props.use_navigation,
          on_item_render = props.on_item_render,
          step_title = props.step_title,
          on_change = props.on_change,
          skeleton = props.skeleton,
          className = props.className,
          _className = props.class,
          _data = props.data,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["active_item", "active_url", "hide_numbers", "use_navigation", "on_item_render", "step_title", "on_change", "skeleton", "className", "class", "data", "children"]);

      var data = StepIndicator.getData(this.props);
      var activeItem = this.state.activeItem;

      var params = _extends({
        'aria-label': 'progress',
        className: classnames('dnb-step-indicator', createSkeletonClass('font', skeleton, this.context), createSpacingClasses(props), className, _className)
      }, attributes);

      skeletonDOMAttributes(params, skeleton, this.context);
      validateDOMAttributes(this.props, params);

      if (!this.state.hasReached.includes(activeItem)) {
        this.state.hasReached.push(activeItem);
      }

      var countSteps = data.length;
      return React.createElement("nav", params, countSteps > 0 && React.createElement("ol", {
        className: "dnb-step-indicator__list"
      }, data.map(function (props, i) {
        if (typeof props === 'string') {
          props = {
            title: props
          };
        }

        var params = _extends({
          countSteps: countSteps,
          currentItem: i,
          activeItem: activeItem,
          hide_numbers: hide_numbers,
          use_navigation: use_navigation,
          on_item_render: on_item_render,
          step_title: step_title,
          on_change: on_change
        }, props);

        return React.createElement(StepItem, _extends({
          key: i
        }, params, {
          setActimeItem: _this2.setActimeItem,
          hasReached: _this2.state.hasReached
        }));
      })));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(StepIndicator.tagName, StepIndicator, StepIndicator.defaultProps);
    }
  }, {
    key: "getData",
    value: function getData(props) {
      var res = [];
      if (props.data) res = props.data;else res = processChildren(props);
      if (typeof res === 'string') return res[0] === '[' ? JSON.parse(res) : [];
      return res || [];
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.data) {
          if (state._data !== props.data) {
            state._data = props.data;
            state.data = StepIndicator.getData(props);
          }
        }

        if (state.activeItem !== props.active_item) {
          state.activeItem = parseFloat(props.active_item);
        }

        if (props.active_url && state.activeUrl !== props.active_url) {
          state.activeUrl = props.active_url;
        }

        if ((state.activeUrl || !(parseFloat(state.activeItem) > 0)) && state.data.length > 0) {
          state.activeItem = state.data.reduce(function (acc, _ref, i) {
            var url = _ref.url;
            return url && (url === state.activeItem || url === state.activeUrl) ? i : acc;
          }, parseFloat(props.active_item));

          if (!(state.activeItem > -1)) {
            state.activeItem = null;
          }
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return StepIndicator;
}(React.PureComponent);

StepIndicator.tagName = 'dnb-step-indicator';
StepIndicator.contextType = Context;
StepIndicator.defaultProps = {
  data: [],
  step_title: '%step',
  active_item: null,
  active_url: null,
  hide_numbers: false,
  use_navigation: false,
  on_item_render: null,
  skeleton: false,
  class: null,
  className: null,
  children: null,
  on_change: null
};
export { StepIndicator as default };
process.env.NODE_ENV !== "production" ? StepIndicator.propTypes = _extends({
  data: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string), PropTypes.arrayOf(PropTypes.shape({
    title: PropTypes.string.isRequired,
    url: PropTypes.string,
    is_active: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
    is_current: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
    url_future: PropTypes.string,
    url_passed: PropTypes.string,
    on_click: PropTypes.func,
    on_render: PropTypes.func
  }))]).isRequired,
  step_title: PropTypes.string,
  active_item: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  active_url: PropTypes.string,
  hide_numbers: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  use_navigation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  on_item_render: PropTypes.func,
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  on_change: PropTypes.func
}) : void 0;