import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import FormLabel from '../form-label/FormLabel';
import FormStatus from '../form-status/FormStatus';
import { isTrue, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, processChildren, getStatusState, combineDescribedBy, warn, dispatchCustomElementEvent } from '../../shared/component-helper';
import AlignmentHelper from '../../shared/AlignmentHelper';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';
import { skeletonDOMAttributes, createSkeletonClass } from '../skeleton/SkeletonHelper';
import Context from '../../shared/Context';
import Suffix from '../../shared/helpers/Suffix';

var _ref = React.createElement(AlignmentHelper, null);

var Textarea = function (_React$PureComponent) {
  _inherits(Textarea, _React$PureComponent);

  var _super = _createSuper(Textarea);

  function Textarea(props) {
    var _this;

    _classCallCheck(this, Textarea);

    _this = _super.call(this, props);
    _this.state = {
      textareaState: 'virgin',
      value: null,
      _value: null
    };

    _this.onFocusHandler = function (event) {
      var value = _this._ref.current.value;

      _this.setState({
        value: value,
        _listenForPropChanges: false,
        textareaState: 'focus'
      });

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_focus', {
        value: value,
        event: event
      });
    };

    _this.onBlurHandler = function (event) {
      var value = event.target.value;

      _this.setState({
        value: value,
        _listenForPropChanges: false,
        textareaState: Textarea.hasValue(value) ? 'dirty' : 'initial'
      });

      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_blur', {
        value: value,
        event: event
      });
    };

    _this.onChangeHandler = function (event) {
      var value = event.target.value;

      var rows = _this.getRows(value);

      var ret = dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_change', {
        value: value,
        rows: rows,
        event: event
      });

      if (ret !== false) {
        _this.setState({
          value: value,
          _listenForPropChanges: false
        });

        if (isTrue(_this.props.autoresize)) {
          _this.setAutosize(rows);
        }
      }
    };

    _this.onKeyDownHandler = function (event) {
      var rows = _this.getRows();

      var value = event.target.value;
      dispatchCustomElementEvent(_assertThisInitialized(_this), 'on_key_down', {
        value: value,
        rows: rows,
        event: event
      });
    };

    _this.setAutosize = function () {
      var rows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var elem = _this._ref.current;

      if (!elem) {
        return;
      }

      rows = typeof rows === 'number' ? rows : _this.getRows();

      try {
        if (typeof _this._heightOffset === 'undefined') {
          _this._heightOffset = elem.offsetHeight - elem.clientHeight;
        }

        elem.style.height = 'auto';
        var newHeight = elem.scrollHeight + _this._heightOffset;
        var maxRows = parseFloat(_this.props.autoresize_max_rows);

        if (maxRows > 0) {
          var maxHeight = maxRows * _this.getLineHeight();

          if (rows > maxRows || newHeight > maxHeight) {
            newHeight = maxHeight;
          }
        }

        elem.style.height = newHeight + 'px';
      } catch (e) {
        warn(e);
      }
    };

    _this._ref = props.inner_ref || React.createRef();
    _this._id = props.id || makeUniqueId();
    _this.state._listenForPropChanges = true;

    if (props.textarea_state) {
      _this.state.textareaState = props.textarea_state;
    }

    _this.state._value = props.value;
    return _this;
  }

  _createClass(Textarea, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (isTrue(this.props.autoresize) && typeof window !== 'undefined') {
        this.setAutosize();
        window.addEventListener('resize', this.setAutosize);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (isTrue(this.props.autoresize) && typeof window !== 'undefined') {
        window.removeEventListener('resize', this.setAutosize);
      }
    }
  }, {
    key: "getRows",
    value: function getRows() {
      return Math.floor(this._ref.current.scrollHeight / this.getLineHeight()) || 1;
    }
  }, {
    key: "getLineHeight",
    value: function getLineHeight() {
      return parseFloat(getComputedStyle(this._ref.current).lineHeight) || 0;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context;

      var props = extendPropsWithContext(this.props, Textarea.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.getTranslation(this.props).Textarea, this.context.FormRow, this.context.Textarea);

      var label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          status = props.status,
          status_state = props.status_state,
          status_animation = props.status_animation,
          global_status_id = props.global_status_id,
          suffix = props.suffix,
          disabled = props.disabled,
          skeleton = props.skeleton,
          stretch = props.stretch,
          placeholder = props.placeholder,
          align = props.align,
          textarea_class = props.textarea_class,
          readOnly = props.readOnly,
          textarea_attributes = props.textarea_attributes,
          _className = props.class,
          className = props.className,
          autoresize = props.autoresize,
          autoresize_max_rows = props.autoresize_max_rows,
          _id = props.id,
          children = props.children,
          _value = props.value,
          _textarea_element = props.textarea_element,
          attributes = _objectWithoutProperties(props, ["label", "label_direction", "label_sr_only", "status", "status_state", "status_animation", "global_status_id", "suffix", "disabled", "skeleton", "stretch", "placeholder", "align", "textarea_class", "readOnly", "textarea_attributes", "class", "className", "autoresize", "autoresize_max_rows", "id", "children", "value", "textarea_element"]);

      var _this$state = this.state,
          value = _this$state.value,
          textareaState = _this$state.textareaState;
      var id = this._id;
      var showStatus = getStatusState(status);
      var hasValue = Textarea.hasValue(value);
      var TextareaElement = props.textarea_element;
      var textareaAttributes = textarea_attributes ? typeof textarea_attributes === 'string' ? JSON.parse(textarea_attributes) : textarea_attributes : {};

      var textareaParams = _extends({
        className: classnames('dnb-textarea__textarea', textarea_class),
        role: 'textbox',
        value: hasValue ? value : '',
        id: id,
        disabled: isTrue(disabled) || isTrue(skeleton),
        name: id,
        'aria-placeholder': placeholder
      }, attributes, textareaAttributes, {
        onChange: this.onChangeHandler,
        onFocus: this.onFocusHandler,
        onBlur: this.onBlurHandler,
        onKeyDown: this.onKeyDownHandler
      });

      if (showStatus || suffix) {
        textareaParams['aria-describedby'] = combineDescribedBy(textareaParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
      }

      if (readOnly) {
        textareaParams['aria-readonly'] = textareaParams.readOnly = true;
      }

      var mainParams = {
        className: classnames("dnb-textarea dnb-textarea--".concat(textareaState, " dnb-form-component"), createSkeletonClass(null, skeleton), createSpacingClasses(props), _className, className, hasValue && 'dnb-textarea--has-content', align && "dnb-textarea__align--".concat(align), status && "dnb-textarea__status--".concat(status_state), autoresize && 'dnb-textarea__autoresize', label_direction && "dnb-textarea--".concat(label_direction), isTrue(stretch) && "dnb-textarea--stretch")
      };
      var innerParams = {
        className: classnames('dnb-textarea__inner', createSkeletonClass('shape', skeleton, this.context))
      };
      var shellParams = {
        className: 'dnb-textarea__shell'
      };

      if (isTrue(disabled) || isTrue(skeleton)) {
        shellParams['aria-disabled'] = true;
      }

      var placeholderStyle = parseFloat(this.props.rows) > 0 ? {
        '--textarea-rows': parseFloat(this.props.rows)
      } : null;
      skeletonDOMAttributes(innerParams, skeleton, this.context);
      validateDOMAttributes(this.props, textareaParams);
      validateDOMAttributes(null, innerParams);
      validateDOMAttributes(null, shellParams);

      if (TextareaElement && typeof TextareaElement === 'function') {
        TextareaElement = TextareaElement(textareaParams, this._ref);
      } else if (!TextareaElement && _textarea_element) {
        TextareaElement = _textarea_element;
      }

      return React.createElement("span", mainParams, label && React.createElement(FormLabel, {
        id: id + '-label',
        for_id: id,
        text: label,
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton
      }), React.createElement("span", innerParams, _ref, showStatus && React.createElement(FormStatus, {
        id: id + '-form-status',
        global_status_id: global_status_id,
        label: label,
        text_id: id + '-status',
        text: status,
        status: status_state,
        animation: status_animation,
        skeleton: skeleton
      }), React.createElement("span", {
        className: "dnb-textarea__row"
      }, React.createElement("span", shellParams, TextareaElement || React.createElement("textarea", _extends({
        ref: this._ref
      }, textareaParams)), placeholder && React.createElement("span", {
        "aria-hidden": true,
        className: 'dnb-textarea__placeholder' + (align ? " dnb-textarea__align--".concat(align) : ""),
        style: placeholderStyle
      }, placeholder)), suffix && React.createElement(Suffix, {
        className: "dnb-textarea__suffix",
        id: id + '-suffix',
        context: props
      }, suffix))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Textarea.tagName, Textarea, Textarea.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = Textarea.getValue(props);

      if (state._listenForPropChanges && value !== 'initval' && value !== state.value) {
        if (value !== state.value && value !== state._value && typeof props.on_state_update === 'function') {
          dispatchCustomElementEvent({
            props: props
          }, 'on_state_update', {
            value: value
          });
        }

        state.value = value;
      }

      if (props.textarea_state) {
        state.textareaState = props.textarea_state;
      }

      state._listenForPropChanges = true;
      return state;
    }
  }, {
    key: "hasValue",
    value: function hasValue(value) {
      return (typeof value === 'string' || typeof value === 'number') && String(value).length > 0 || false;
    }
  }, {
    key: "getValue",
    value: function getValue(props) {
      var value = processChildren(props);

      if (value === '' || Textarea.hasValue(value)) {
        return value;
      }

      return props.value;
    }
  }]);

  return Textarea;
}(React.PureComponent);

Textarea.tagName = 'dnb-textarea';
Textarea.contextType = Context;
Textarea.defaultProps = {
  value: 'initval',
  id: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  status: null,
  textarea_state: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  placeholder: null,
  align: null,
  stretch: null,
  disabled: null,
  skeleton: null,
  autoresize: null,
  autoresize_max_rows: null,
  textarea_class: null,
  class: null,
  textarea_attributes: null,
  readOnly: false,
  rows: null,
  cols: null,
  inner_ref: null,
  className: null,
  textarea_element: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_focus: null,
  on_blur: null,
  on_key_down: null,
  on_state_update: null
};
export { Textarea as default };
process.env.NODE_ENV !== "production" ? Textarea.propTypes = _extends({
  value: PropTypes.string,
  id: PropTypes.string,
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  label_direction: PropTypes.oneOf(['horizontal', 'vertical']),
  label_sr_only: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  status: PropTypes.oneOfType([PropTypes.string, PropTypes.bool, PropTypes.func, PropTypes.node]),
  textarea_state: PropTypes.string,
  status_state: PropTypes.string,
  status_animation: PropTypes.string,
  global_status_id: PropTypes.string,
  suffix: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  placeholder: PropTypes.string,
  align: PropTypes.oneOf(['left', 'right']),
  stretch: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  autoresize: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  autoresize_max_rows: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  class: PropTypes.string,
  textarea_class: PropTypes.string,
  textarea_attributes: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  readOnly: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  rows: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  cols: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  inner_ref: PropTypes.oneOfType([PropTypes.func, PropTypes.object])
}, spacingPropTypes, {
  className: PropTypes.string,
  textarea_element: PropTypes.oneOfType([PropTypes.func, PropTypes.node]),
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_change: PropTypes.func,
  on_focus: PropTypes.func,
  on_blur: PropTypes.func,
  on_key_down: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;