import * as React from 'react';
export type ToggleButtonGroupLabel =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type ToggleButtonGroupLabelDirection = 'horizontal' | 'vertical';
export type ToggleButtonGroupLabelSrOnly = string | boolean;
export type ToggleButtonGroupMultiselect = string | boolean;
export type ToggleButtonGroupVariant = 'default' | 'checkbox' | 'radio';
export type ToggleButtonGroupNoFieldset = string | boolean;
export type ToggleButtonGroupDisabled = string | boolean;
export type ToggleButtonGroupSkeleton = string | boolean;
export type ToggleButtonGroupStatus =
  | string
  | boolean
  | ((...args: any[]) => any)
  | React.ReactNode;
export type ToggleButtonGroupSuffix =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type ToggleButtonGroupVertical = string | boolean;
export type ToggleButtonGroupLayoutDirection = 'column' | 'row';
export type ToggleButtonGroupValue = string | number | Object | any[];
export type ToggleButtonGroupValues = string | any[];
export type ToggleButtonGroupAttributes = string | Object;
export type ToggleButtonGroupSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type ToggleButtonGroupTop = string | number | boolean;
export type ToggleButtonGroupRight = string | number | boolean;
export type ToggleButtonGroupBottom = string | number | boolean;
export type ToggleButtonGroupLeft = string | number | boolean;
export type ToggleButtonGroupChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ToggleButtonGroupProps
  extends React.HTMLProps<HTMLElement> {
  label?: ToggleButtonGroupLabel;
  label_direction?: ToggleButtonGroupLabelDirection;
  label_sr_only?: ToggleButtonGroupLabelSrOnly;
  title?: string;
  multiselect?: ToggleButtonGroupMultiselect;
  variant?: ToggleButtonGroupVariant;
  left_component?: React.ReactNode;
  no_fieldset?: ToggleButtonGroupNoFieldset;
  disabled?: ToggleButtonGroupDisabled;
  skeleton?: ToggleButtonGroupSkeleton;
  id?: string;
  name?: string;
  status?: ToggleButtonGroupStatus;
  status_state?: string;
  status_animation?: string;
  global_status_id?: string;
  suffix?: ToggleButtonGroupSuffix;
  vertical?: ToggleButtonGroupVertical;
  layout_direction?: ToggleButtonGroupLayoutDirection;
  value?: ToggleButtonGroupValue;

  /**
   * function values() { [native code] }
   */
  values?: ToggleButtonGroupValues;
  attributes?: ToggleButtonGroupAttributes;
  space?: ToggleButtonGroupSpace;
  top?: ToggleButtonGroupTop;
  right?: ToggleButtonGroupRight;
  bottom?: ToggleButtonGroupBottom;
  left?: ToggleButtonGroupLeft;
  class?: string;
  className?: string;
  children?: ToggleButtonGroupChildren;
  custom_element?: Object;
  custom_method?: (...args: any[]) => any;
  on_change?: (...args: any[]) => any;
}
export default class ToggleButtonGroup extends React.Component<
  ToggleButtonGroupProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
