import * as React from 'react';
export type TooltipActive = string | boolean;
export type TooltipPosition = 'top' | 'right' | 'bottom' | 'left';
export type TooltipArrow =
  | any
  | 'center'
  | 'top'
  | 'right'
  | 'bottom'
  | 'left';
export type TooltipAlign = any | 'center' | 'right' | 'left';
export type TooltipAnimatePosition = string | boolean;
export type TooltipShowDelay = string | number;
export type TooltipHideDelay = string | number;
export type TooltipSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type TooltipTop = string | number | boolean;
export type TooltipRight = string | number | boolean;
export type TooltipBottom = string | number | boolean;
export type TooltipLeft = string | number | boolean;
export type TooltipChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;
export type TooltipOnClick = string | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface TooltipProps extends React.HTMLProps<HTMLElement> {
  id?: string;
  group?: string;
  active?: TooltipActive;
  position?: TooltipPosition;
  arrow?: TooltipArrow;
  align?: TooltipAlign;
  animate_position?: TooltipAnimatePosition;
  show_delay?: TooltipShowDelay;
  hide_delay?: TooltipHideDelay;
  space?: TooltipSpace;
  top?: TooltipTop;
  right?: TooltipRight;
  bottom?: TooltipBottom;
  left?: TooltipLeft;
  class?: string;
  className?: string;
  children?: TooltipChildren;
  onClick?: (...args: any[]) => any;
  on_click?: TooltipOnClick;
}
export default class Tooltip extends React.Component<TooltipProps, any> {
  static defaultProps: object;
  render(): JSX.Element;
}
