import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.join.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import TooltipPortal from './TooltipPortal';

var TooltipWithEvents = function (_React$PureComponent) {
  _inherits(TooltipWithEvents, _React$PureComponent);

  var _super = _createSuper(TooltipWithEvents);

  function TooltipWithEvents() {
    var _this;

    _classCallCheck(this, TooltipWithEvents);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      isActive: false
    };

    _this.onMouseEnter = function () {
      clearTimeout(_this._onEnterTimeout);
      _this._onEnterTimeout = setTimeout(function () {
        _this.setState({
          isActive: true
        });
      }, _this.props.show_delay || 1);
    };

    _this.onMouseLeave = function () {
      clearTimeout(_this._onEnterTimeout);

      _this.setState({
        isActive: false
      });
    };

    return _this;
  }

  _createClass(TooltipWithEvents, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._onEnterTimeout);
      clearTimeout(this._targetTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          target = _this$props.target,
          props = _objectWithoutProperties(_this$props, ["children", "className", "target"]);

      if (!this.state.target && typeof target.current !== 'undefined') {
        this._targetTimeout = setTimeout(function () {
          if (!target.current) return;

          try {
            var elem = target.current;
            elem.addEventListener('mouseenter', _this2.onMouseEnter);
            elem.addEventListener('mouseleave', _this2.onMouseLeave);
            var describedby = [_this2.props.internal_id];
            var db = elem.getAttribute('aria-describedby');

            if (db) {
              describedby.unshift(db);
            }

            elem.setAttribute('aria-describedby', describedby.join(' '));
          } catch (e) {
            console.warn('Tooltip: Could not add event listeners', e);
          }

          _this2.setState({
            target: target.current
          });
        }, 1);
        return null;
      }

      var componentWrapper;

      if (React.isValidElement(target)) {
        var describedby = [this.props.internal_id];

        if (target.props && target.props['aria-describedby']) {
          describedby.unshift(target.props['aria-describedby']);
        }

        componentWrapper = React.createElement("span", {
          key: "target-wrapper",
          ref: function ref(target) {
            return _this2.setState({
              target: target
            });
          },
          className: className,
          onMouseEnter: this.onMouseEnter,
          onMouseLeave: this.onMouseLeave
        }, React.cloneElement(target, {
          'aria-describedby': describedby.join(' ')
        }));
      }

      return React.createElement(React.Fragment, null, componentWrapper, this.state.target && React.createElement(TooltipPortal, _extends({
        key: "tooltip",
        active: this.state.isActive,
        target: this.state.target
      }, props), children));
    }
  }]);

  return TooltipWithEvents;
}(React.PureComponent);

TooltipWithEvents.defaultProps = {
  className: '',
  internal_id: null,
  show_delay: 1,
  target: null,
  children: null
};
export { TooltipWithEvents as default };
process.env.NODE_ENV !== "production" ? TooltipWithEvents.propTypes = {
  className: PropTypes.string,
  internal_id: PropTypes.string,
  show_delay: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  target: PropTypes.oneOfType([PropTypes.string, PropTypes.object, PropTypes.func, PropTypes.node]),
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node])
} : void 0;