import * as React from 'react';
export type DlSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type DlTop = string | number | boolean;
export type DlRight = string | number | boolean;
export type DlBottom = string | number | boolean;
export type DlLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DlProps extends React.HTMLProps<HTMLElement> {
  space?: DlSpace;
  top?: DlTop;
  right?: DlRight;
  bottom?: DlBottom;
  left?: DlLeft;
  children?: React.ReactNode;
}
declare const Dl: React.FC<DlProps>;
export default Dl;
