import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Context from '../shared/Context';
import { validateDOMAttributes, extendPropsWithContext } from '../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../components/space/SpacingHelper';
import { createSkeletonClass, skeletonDOMAttributes } from '../components/skeleton/SkeletonHelper';

var Elem = function (_React$PureComponent) {
  _inherits(Elem, _React$PureComponent);

  var _super = _createSuper(Elem);

  function Elem(props) {
    _classCallCheck(this, Elem);

    return _super.call(this, props);
  }

  _createClass(Elem, [{
    key: "render",
    value: function render() {
      var _this$context, _this$context2;

      var props = this.props.skeleton !== false && typeof ((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton) !== 'undefined' ? extendPropsWithContext(this.props, Elem.defaultProps, {
        skeleton: (_this$context2 = this.context) === null || _this$context2 === void 0 ? void 0 : _this$context2.skeleton
      }) : this.props;

      var className = props.className,
          _className = props.class,
          internalClass = props.internalClass,
          css = props.css,
          Tag = props.is,
          _ref = props._ref,
          skeleton = props.skeleton,
          skeleton_method = props.skeleton_method,
          rest = _objectWithoutProperties(props, ["className", "class", "internalClass", "css", "is", "_ref", "skeleton", "skeleton_method"]);

      var tagClass = internalClass || "dnb-".concat(Tag);
      rest.className = classnames(className, _className, css, createSkeletonClass(skeleton_method, skeleton, this.context), createSpacingClasses(rest, Tag), !new RegExp("".concat(tagClass, "(\\s|$)")).test(String(className)) && tagClass);
      validateDOMAttributes(null, rest);
      skeletonDOMAttributes(rest, skeleton, this.context);
      return React.createElement(Tag, _extends({
        ref: _ref
      }, rest));
    }
  }]);

  return Elem;
}(React.PureComponent);

Elem.contextType = Context;
Elem.defaultProps = {
  skeleton: null,
  skeleton_method: 'font',
  className: null,
  class: null,
  internalClass: null,
  css: null,
  _ref: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Elem.propTypes = _extends({
  is: PropTypes.string.isRequired,
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skeleton_method: PropTypes.string
}, spacingPropTypes, {
  className: PropTypes.oneOfType([PropTypes.string, PropTypes.object, PropTypes.array]),
  class: PropTypes.string,
  internalClass: PropTypes.string,
  css: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  _ref: PropTypes.object,
  children: PropTypes.node
}) : void 0;
var Element = React.forwardRef(function (props, ref) {
  return React.createElement(Elem, _extends({
    _ref: ref
  }, props));
});
process.env.NODE_ENV !== "production" ? Element.propTypes = Elem.propTypes : void 0;
Element.defaultProps = Elem.defaultProps;
export default Element;