import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import E from './Element';
import { spacingPropTypes, createSpacingClasses, removeSpaceProps } from '../components/space/SpacingHelper';
import classnames from 'classnames';

var Img = function Img(_ref) {
  var caption = _ref.caption,
      alt = _ref.alt,
      element = _ref.element,
      skeleton = _ref.skeleton,
      img_class = _ref.img_class,
      className = _ref.className,
      _class = _ref.class,
      p = _objectWithoutProperties(_ref, ["caption", "alt", "element", "skeleton", "img_class", "className", "class"]);

  return React.createElement(E, {
    is: element,
    internalClass: "dnb-img",
    className: classnames(className, _class, createSpacingClasses(p, p.is)),
    skeleton: skeleton,
    skeleton_method: "shape"
  }, React.createElement(E, _extends({
    is: "img",
    alt: alt,
    internalClass: "dnb-img__img",
    className: img_class,
    skeleton: skeleton
  }, removeSpaceProps(p))), caption && React.createElement("figcaption", null, caption));
};

Img.tagName = 'dnb-img';
process.env.NODE_ENV !== "production" ? Img.propTypes = _extends({}, spacingPropTypes, {
  src: PropTypes.string.isRequired,
  alt: PropTypes.string.isRequired,
  skeleton: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  className: PropTypes.oneOfType([PropTypes.string, PropTypes.object, PropTypes.array]),
  class: PropTypes.string,
  img_class: PropTypes.string,
  element: PropTypes.node,
  caption: PropTypes.string,
  children: PropTypes.node
}) : void 0;
Img.defaultProps = {
  skeleton: null,
  className: null,
  class: null,
  img_class: null,
  element: 'figure',
  css: null,
  caption: null,
  children: null
};
export default Img;