import * as React from 'react';
export type LiSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type LiTop = string | number | boolean;
export type LiRight = string | number | boolean;
export type LiBottom = string | number | boolean;
export type LiLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface LiProps extends React.HTMLProps<HTMLElement> {
  space?: LiSpace;
  top?: LiTop;
  right?: LiRight;
  bottom?: LiBottom;
  left?: LiLeft;
  className?: string;
}
declare const Li: React.FC<LiProps>;
export default Li;
