import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.string.includes.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import { warn, isTrue, registerElement } from '../shared/component-helper';
import E from './Element';

var _ref = React.createElement("tr", {
  className: "dnb-table__sticky-helper"
}, React.createElement("td", null));

export var StickyHelper = function StickyHelper() {
  return _ref;
};

var Table = function (_React$PureComponent) {
  _inherits(Table, _React$PureComponent);

  var _super = _createSuper(Table);

  function Table(props) {
    var _this;

    _classCallCheck(this, Table);

    _this = _super.call(this, props);

    _this.init = function () {
      if (_this._isMounted && isTrue(_this.props.sticky)) {
        _this.enableStickyHeader();

        if (_this.intersectionObserver && _this._ref.current) {
          try {
            var tableElem = _this._ref.current;
            var trElem = tableElem.querySelector('thead > tr:first-of-type');
            trElem.classList.add('sticky');

            var tdElem = tableElem.querySelector('tbody > tr.dnb-table__sticky-helper > td:first-of-type') || _this.getTdElement(tableElem);

            if (tdElem) {
              var _this$intersectionObs;

              (_this$intersectionObs = _this.intersectionObserver) === null || _this$intersectionObs === void 0 ? void 0 : _this$intersectionObs.observe(tdElem);
            }
          } catch (e) {
            _this.stickyWarning(e);
          }
        }
      }
    };

    _this._ref = React.createRef();
    return _this;
  }

  _createClass(Table, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;

      if (document.readyState === 'complete') {
        this.init();
      } else if (typeof window !== 'undefined') {
        window.addEventListener('load', this.init);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$intersectionObs2;

      this._isMounted = false;

      if (typeof window !== 'undefined') {
        window.removeEventListener('load', this.init);
      }

      (_this$intersectionObs2 = this.intersectionObserver) === null || _this$intersectionObs2 === void 0 ? void 0 : _this$intersectionObs2.disconnect();
    }
  }, {
    key: "getTdElement",
    value: function getTdElement(e) {
      return e.querySelector('tbody > tr:not(.dnb-table__sticky-helper):first-of-type > td:first-of-type, tbody > .dnb-table__tr:first-of-type > .dnb-table__td:first-of-type');
    }
  }, {
    key: "getThElement",
    value: function getThElement(e) {
      return e.querySelector('thead > tr:first-of-type > th:first-of-type, thead > .dnb-table__tr:first-of-type > .dnb-table__th:first-of-type');
    }
  }, {
    key: "enableStickyHeader",
    value: function enableStickyHeader() {
      var _this2 = this;

      if (!(typeof window !== 'undefined' && typeof IntersectionObserver !== 'undefined' && this._ref.current)) {
        return;
      }

      var tableElem = this._ref.current;
      var trElem;
      var thElem;
      var tdElem;
      var thHeight = 80;
      var tdHeight = 64;
      var offsetTop = 0;

      try {
        trElem = tableElem.querySelector('thead > tr:first-of-type, thead > .dnb-table__tr:first-of-type');
        thElem = this.getThElement(tableElem);
        tdElem = this.getTdElement(tableElem);
        offsetTop = parseFloat(this.props.sticky_offset) || offsetTop;

        if (offsetTop > 0) {
          if (typeof this.props.sticky_offset === 'string' && String(this.props.sticky_offset).includes('em')) {
            offsetTop = offsetTop * 16;
          }

          trElem.style.top = this.props.sticky_offset;
        }

        thHeight = thElem && parseFloat(window.getComputedStyle(thElem).height) || thHeight;
        tdHeight = tdElem && parseFloat(window.getComputedStyle(tdElem).height) || tdHeight;
      } catch (e) {
        this.stickyWarning(e);
      }

      var marginTop = thHeight + tdHeight + offsetTop;
      this.intersectionObserver = new IntersectionObserver(function (entries) {
        var _entries = _slicedToArray(entries, 1),
            entry = _entries[0];

        try {
          if (entry.isIntersecting) {
            trElem.classList.remove('show-shadow');
          } else {
            trElem.classList.add('show-shadow');
          }
        } catch (e) {
          _this2.stickyWarning(e);
        }
      }, {
        rootMargin: "-".concat(marginTop, "px 0px 0px 0px")
      });
    }
  }, {
    key: "stickyWarning",
    value: function stickyWarning() {
      var e = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      warn('Could not enable Sticky mode in table:', e);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          sticky = _this$props.sticky,
          props = _objectWithoutProperties(_this$props, ["sticky"]);

      return React.createElement(E, _extends({
        is: "table"
      }, props, {
        ref: this._ref
      }));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(Table.tagName, Table, Table.defaultProps);
    }
  }]);

  return Table;
}(React.PureComponent);

Table.tagName = 'dnb-table';
Table.defaultProps = {
  sticky: false,
  sticky_offset: null,
  children: null
};
export { Table as default };
process.env.NODE_ENV !== "production" ? Table.propTypes = _extends({}, spacingPropTypes, {
  sticky: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  sticky_offset: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  children: PropTypes.node
}) : void 0;
Table.StickyHelper = StickyHelper;