import * as React from 'react';
export type UlSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type UlTop = string | number | boolean;
export type UlRight = string | number | boolean;
export type UlBottom = string | number | boolean;
export type UlLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface UlProps extends React.HTMLProps<HTMLElement> {
  space?: UlSpace;
  top?: UlTop;
  right?: UlRight;
  bottom?: UlBottom;
  left?: UlLeft;
  className?: string;
  inside?: boolean;
  outside?: boolean;
  nested?: boolean;
  children?: React.ReactNode;
}
declare const Ul: React.FC<UlProps>;
export default Ul;
