import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { warn, isInsideScrollView } from '../../shared/component-helper';
var drawerListPortal;

if (typeof window !== 'undefined') {
  window.drawerListPortal = window.drawerListPortal || {};
  drawerListPortal = window.drawerListPortal;
} else {
  drawerListPortal = {};
}

var DrawerListPortal = function (_React$PureComponent) {
  _inherits(DrawerListPortal, _React$PureComponent);

  var _super = _createSuper(DrawerListPortal);

  function DrawerListPortal(props) {
    var _this;

    _classCallCheck(this, DrawerListPortal);

    _this = _super.call(this, props);

    _this.init = function () {
      if (_this._isMounted && !_this.props.inactive) {
        _this.renderPortal();
      }
    };

    _this.ref = props.innerRef || React.createRef();
    return _this;
  }

  _createClass(DrawerListPortal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;

      if (document.readyState === 'complete') {
        this.init();
      } else if (typeof window !== 'undefined') {
        window.addEventListener('load', this.init);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;

      if (typeof window !== 'undefined') {
        window.removeEventListener('load', this.init);
      }

      var id = this.props.id;

      if (drawerListPortal[id]) {
        ReactDOM.unmountComponentAtNode(drawerListPortal[id].node);

        try {
          document.body.removeChild(drawerListPortal[id].node);
        } catch (e) {}

        drawerListPortal[id] = null;
      }

      this.removePositionObserver();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props !== prevProps) {
        this.renderPortal();
      }
    }
  }, {
    key: "createPortal",
    value: function createPortal() {
      if (typeof document !== 'undefined') {
        try {
          var elem = drawerListPortal[this.props.id] = {
            node: document.createElement('div')
          };
          elem.node.setAttribute('role', 'presentation');
          elem.node.className = 'dnb-drawer-list__portal dnb-core-style';
          document.body.insertBefore(elem.node, document.body.firstChild);
        } catch (e) {
          warn('Could not create DrawerListPortal!', e);
        }
      }
    }
  }, {
    key: "makeStyle",
    value: function makeStyle() {
      if (typeof window === 'undefined') {
        return;
      }

      try {
        var _this$props = this.props,
            rootRef = _this$props.rootRef,
            include_owner_width = _this$props.include_owner_width,
            independent_width = _this$props.independent_width,
            fixed_position = _this$props.fixed_position;
        var rootElem = rootRef.current;
        var ownerElem = rootElem.parentElement;
        var width = 64;
        var ownerWidth = window.getComputedStyle(ownerElem).width;

        if (independent_width || parseFloat(ownerWidth) < 64) {
          var minWidth = parseFloat(window.getComputedStyle(document.documentElement).getPropertyValue('--drawer-list-width'));
          width = minWidth * 16;
        }

        var customWidth = rootElem.getBoundingClientRect().width;

        if (parseFloat(customWidth || 0) >= 64) {
          width = customWidth;
        }

        var rect = rootElem.getBoundingClientRect();
        var scrollY = fixed_position ? 0 : window.scrollY !== undefined ? window.scrollY : window.pageYOffset;
        var scrollX = fixed_position ? 0 : window.scrollX !== undefined ? window.scrollX : window.pageXOffset;
        var top = scrollY + rect.top;
        var left = scrollX + rect.left + (include_owner_width ? parseFloat(ownerWidth || 0) : 0);

        if (width > window.innerWidth) {
          width = window.innerWidth;
        }

        var style = {
          width: width,
          '--drawer-list-width': "".concat(width / 16, "rem"),
          top: top,
          left: left
        };
        return style;
      } catch (e) {
        warn('Could not create makeStyle in DrawerListPortal!', e);
      }
    }
  }, {
    key: "addPositionObserver",
    value: function addPositionObserver() {
      var _this2 = this;

      if (typeof window === 'undefined' || this.setPosition) {
        return;
      }

      var renderPosition = function renderPosition() {
        _this2.renderPortal();
      };

      this.setPosition = function () {
        clearTimeout(_this2._ddt);
        _this2._ddt = setTimeout(renderPosition, 30);
      };

      window.addEventListener('resize', this.setPosition);
      this.customElem = isInsideScrollView(this.props.rootRef.current, true);

      if (this.customElem) {
        this.customElem.addEventListener('scroll', this.setPosition);
      }
    }
  }, {
    key: "removePositionObserver",
    value: function removePositionObserver() {
      clearTimeout(this._ddt);

      if (typeof window !== 'undefined' && this.setPosition) {
        if (this.customElem) {
          this.customElem.addEventListener('scroll', this.setPosition);
        }

        window.removeEventListener('resize', this.setPosition);
      }
    }
  }, {
    key: "renderPortal",
    value: function renderPortal() {
      var _this$props2 = this.props,
          inactive = _this$props2.inactive,
          id = _this$props2.id,
          opened = _this$props2.opened,
          fixed_position = _this$props2.fixed_position,
          use_drawer_on_mobile = _this$props2.use_drawer_on_mobile,
          children = _this$props2.children;

      if (inactive) {
        return;
      }

      if (!drawerListPortal[id]) {
        this.createPortal();
      }

      if (opened) {
        this.addPositionObserver();
      }

      var style = opened ? this.makeStyle() : {};
      ReactDOM.render(React.createElement("span", {
        className: classnames('dnb-drawer-list__portal__style', fixed_position && 'dnb-drawer-list__portal__style--fixed', use_drawer_on_mobile && 'dnb-drawer-list__portal__style--mobile-view'),
        style: style,
        ref: this.ref
      }, children), drawerListPortal[id].node);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          inactive = _this$props3.inactive,
          children = _this$props3.children;
      return inactive ? children : null;
    }
  }]);

  return DrawerListPortal;
}(React.PureComponent);

DrawerListPortal.defaultProps = {
  rootRef: {
    current: null
  },
  innerRef: null,
  include_owner_width: false,
  independent_width: false,
  fixed_position: false,
  use_drawer_on_mobile: false,
  inactive: false
};
process.env.NODE_ENV !== "production" ? DrawerListPortal.propTypes = {
  id: PropTypes.string.isRequired,
  children: PropTypes.node.isRequired,
  opened: PropTypes.bool.isRequired,
  innerRef: PropTypes.shape({
    current: PropTypes.oneOfType([PropTypes.node, PropTypes.object])
  }),
  rootRef: PropTypes.shape({
    current: PropTypes.oneOfType([PropTypes.node, PropTypes.object])
  }).isRequired,
  include_owner_width: PropTypes.bool,
  independent_width: PropTypes.bool,
  fixed_position: PropTypes.bool,
  use_drawer_on_mobile: PropTypes.bool,
  inactive: PropTypes.bool
} : void 0;
export default React.forwardRef(function DrawerListPortalRef(props, ref) {
  return React.createElement(DrawerListPortal, _extends({
    innerRef: ref
  }, props));
});