import "core-js/modules/es.array.map.js";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';

var DescriptionList = function (_React$PureComponent) {
  _inherits(DescriptionList, _React$PureComponent);

  var _super = _createSuper(DescriptionList);

  function DescriptionList(props) {
    var _this;

    _classCallCheck(this, DescriptionList);

    _this = _super.call(this, props);
    _this.state = {
      _listenForPropChanges: true,
      _data: props.data || props.children,
      data: DescriptionList.getData(props)
    };
    return _this;
  }

  _createClass(DescriptionList, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          info = _this$props.info,
          className = _this$props.className,
          _className = _this$props.class;
      var data = DescriptionList.getData(this.props);
      var params = {
        className: classnames('dnb-description-list', className, _className)
      };
      validateDOMAttributes(this.props, params);
      return React.createElement("div", params, data.length > 0 && React.createElement("dl", {
        className: "dnb-description-list__dl typo-light"
      }, data.map(function (_ref, i) {
        var title = _ref.title,
            value = _ref.value;
        return React.createElement(React.Fragment, {
          key: "dl".concat(i)
        }, React.createElement("dt", {
          className: "dnb-description-list__dt"
        }, title), React.createElement("dd", {
          className: "dnb-description-list__dd"
        }, value));
      })), info && React.createElement("p", {
        className: "dnb-description-list__info dnb-typo-regular"
      }, info));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(DescriptionList.tagName, DescriptionList, DescriptionList.defaultProps);
    }
  }, {
    key: "getData",
    value: function getData(props) {
      var res = [];
      if (props.data) res = props.data;else res = processChildren(props);
      if (typeof res === 'string') return res[0] === '[' ? JSON.parse(res) : [];
      return res || [];
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.data) {
          if (state._data !== props.data) {
            state._data = props.data;
            state.data = DescriptionList.getData(props);
          }
        }
      }

      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return DescriptionList;
}(React.PureComponent);

DescriptionList.tagName = 'dnb-description-list';
DescriptionList.defaultProps = {
  data: [],
  info: null,
  class: null,
  className: null,
  children: null
};
export { DescriptionList as default };
process.env.NODE_ENV !== "production" ? DescriptionList.propTypes = {
  data: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.exact({
    title: PropTypes.string.isRequired,
    value: PropTypes.string.isRequired
  }))]).isRequired,
  info: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
} : void 0;