import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes } from '../../shared/component-helper';
import DescriptionList from '../description-list/DescriptionList';

var FormSummary = function (_React$PureComponent) {
  _inherits(FormSummary, _React$PureComponent);

  var _super = _createSuper(FormSummary);

  function FormSummary() {
    _classCallCheck(this, FormSummary);

    return _super.apply(this, arguments);
  }

  _createClass(FormSummary, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          title = _this$props.title,
          text = _this$props.text,
          descriptionListData = _this$props.descriptionListData,
          descriptionListInfo = _this$props.descriptionListInfo,
          className = _this$props.className,
          _className = _this$props.class;
      var params = {
        className: classnames('dnb-form-summary', className, _className)
      };
      validateDOMAttributes(this.props, params);
      return React.createElement("div", params, React.createElement("div", {
        className: "dnb-belt"
      }, React.createElement("div", {
        className: "dnb-width-limit"
      }, React.createElement("div", {
        className: "dnb-grid dnb-grid--gutters"
      }, React.createElement("div", {
        className: "dnb-grid__cell u-1of3"
      }, React.createElement("div", {
        className: "dnb-form-summary__header"
      }, React.createElement("h2", {
        className: "dnb-form-summary__title typo-light"
      }, title), React.createElement("p", {
        className: "dnb-form-summary__info dnb-typo-regular"
      }, text))), React.createElement("div", {
        className: "dnb-grid__cell"
      }, React.createElement("div", {
        className: "dnb-form-summary__list"
      }, React.createElement(DescriptionList, {
        data: descriptionListData,
        info: descriptionListInfo
      })))))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(FormSummary.tagName, FormSummary, FormSummary.defaultProps);
    }
  }]);

  return FormSummary;
}(React.PureComponent);

FormSummary.tagName = 'dnb-form-summary';
FormSummary.defaultProps = {
  title: null,
  text: null,
  descriptionListData: null,
  descriptionListInfo: null,
  class: null,
  className: null,
  children: null
};
export { FormSummary as default };
process.env.NODE_ENV !== "production" ? FormSummary.propTypes = {
  title: PropTypes.string,
  text: PropTypes.string,
  descriptionListData: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
  descriptionListInfo: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
} : void 0;