import React from 'react';
import _BankAxept from './BankAxept';
import DNB from './DNB';
import DNBMetalic from './DNBMetalic';
import Expired from './Clock';
import Blocked from './Padlock';
import MastercardDefault from './MastercardDefault';
import MastercardMetalic from './MastercardMetalic';
import MastercardMetalicBlack from './MastercardMetalicBlack';
import _Pluss from './Pluss';
import PB from './PB';
import PBPlatinum from './PBPlatinum';
import SagaGold from './SagaGold';
import SagaPlatinum from './SagaPlatinum';
import SagaVisaPlatinum from './SagaVisaPlatinum';
import VisaDefault from './VisaDefault';
import VisaMetalic from './VisaMetalic';

var BankLogo = function BankLogo(_ref) {
  var logoType = _ref.logoType,
      height = _ref.height;

  var _ref2 = React.createElement(DNBMetalic, {
    height: height,
    className: "dnb-payment-card__card__bank-logo"
  });

  return logoType.cata({
    Colored: function Colored(color) {
      return React.createElement(DNB, {
        height: height,
        fill: color,
        className: "dnb-payment-card__card__bank-logo"
      });
    },
    Metalic: function Metalic() {
      return _ref2;
    }
  });
};

var ProductLogo = function ProductLogo(_ref3) {
  var productType = _ref3.productType,
      cardDesign = _ref3.cardDesign;
  var id = 'dnb-payment-card__card__product-type';

  var _ref4 = React.createElement(_BankAxept, {
    className: id,
    fill: "#ffffff"
  });

  var _ref5 = React.createElement(_BankAxept, {
    className: id,
    fill: "#757575"
  });

  var _ref6 = React.createElement(SagaGold, {
    className: id
  });

  var _ref7 = React.createElement(SagaPlatinum, {
    className: id
  });

  var _ref8 = React.createElement(SagaVisaPlatinum, {
    className: id
  });

  var _ref9 = React.createElement(_Pluss, {
    className: id,
    fill: "#A5E1D2"
  });

  var _ref10 = React.createElement(PB, {
    className: id
  });

  var _ref11 = React.createElement(PBPlatinum, {
    className: id
  });

  return productType.cata({
    BankAxept: function BankAxept() {
      return cardDesign.bankAxept.cata({
        White: function White() {
          return _ref4;
        },
        Black: function Black() {
          return _ref5;
        }
      });
    },
    Saga: function Saga() {
      return cardDesign.saga.cata({
        Gold: function Gold() {
          return _ref6;
        },
        Platinum: function Platinum() {
          return _ref7;
        },
        VisaPlatinum: function VisaPlatinum() {
          return _ref8;
        },
        None: function None() {
          return null;
        }
      });
    },
    Pluss: function Pluss() {
      return _ref9;
    },
    PrivateBanking: function PrivateBanking() {
      return cardDesign.privateBanking.cata({
        Default: function Default() {
          return _ref10;
        },
        Platinum: function Platinum() {
          return _ref11;
        },
        None: function None() {
          return null;
        }
      });
    },
    None: function None() {
      return null;
    }
  });
};

var _ref13 = React.createElement(Expired, null);

var _ref14 = React.createElement(Blocked, null);

var StatusIcon = function StatusIcon(_ref12) {
  var status = _ref12.status;

  switch (status) {
    case 'expired':
      return _ref13;

    case 'blocked':
      return _ref14;

    case 'active':
    default:
      return null;
  }
};

var TypeLogo = function TypeLogo(_ref15) {
  var cardType = _ref15.cardType,
      cardDesign = _ref15.cardDesign;
  var id = 'dnb-payment-card__card__credit-type';

  var _ref16 = React.createElement(VisaMetalic, {
    className: id
  });

  var _ref17 = React.createElement(MastercardDefault, {
    className: id
  });

  var _ref18 = React.createElement(MastercardDefault, {
    className: id,
    textFill: "#ffffff"
  });

  var _ref19 = React.createElement(MastercardMetalic, {
    className: id
  });

  var _ref20 = React.createElement(MastercardMetalicBlack, {
    className: id
  });

  return cardType.cata({
    Visa: function Visa() {
      return cardDesign.visa.cata({
        Colored: function Colored(color) {
          return React.createElement(VisaDefault, {
            className: id,
            fill: color
          });
        },
        Metalic: function Metalic() {
          return _ref16;
        }
      });
    },
    Mastercard: function Mastercard() {
      return cardDesign.mastercard.cata({
        Default: function Default() {
          return _ref17;
        },
        DefaultWhite: function DefaultWhite() {
          return _ref18;
        },
        Metalic: function Metalic() {
          return _ref19;
        },
        BlackMetalic: function BlackMetalic() {
          return _ref20;
        }
      });
    },
    None: function None() {
      return null;
    }
  });
};

export { BankLogo, ProductLogo, StatusIcon, TypeLogo };