import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.for-each.js";
import "core-js/modules/es.array.index-of.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.function.name.js";
import "core-js/modules/es.number.constructor.js";
import "core-js/modules/es.object.entries.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.split.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _wrapNativeSuper from "@babel/runtime/helpers/esm/wrapNativeSuper";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import ReactDOM from 'react-dom';
import { ErrorHandler } from './error-helper';
import customElementPolyfill from './custom-element-polyfill';
var isTest = process.env.NODE_ENV === 'test';
var hasPolyfill = isTest;
export var registeredElements = typeof window !== 'undefined' && (window.registeredElements = window.registeredElements || []) || [];
export var registerElement = function registerElement(tagName, ReactComponent) {
  var propNames = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  var _ref = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
      _ref$attributesExclud = _ref.attributesExcludelist,
      attributesExcludelist = _ref$attributesExclud === void 0 ? ['id'] : _ref$attributesExclud;

  if (!tagName) tagName = ReactComponent.displayName || ReactComponent.name;
  if (registeredElements.indexOf(tagName) !== -1) return;
  registeredElements.push(tagName);

  if (typeof document === 'undefined' || typeof window === 'undefined') {
    return null;
  }

  if (!hasPolyfill) {
    hasPolyfill = true;
    customElementPolyfill(window);
  }

  if (propNames) {
    propNames = prepareDefaultProps(propNames);
  }

  var HtmlClass = function (_HTMLElement) {
    _inherits(HtmlClass, _HTMLElement);

    var _super = _createSuper(HtmlClass);

    function HtmlClass(props) {
      var _this;

      _classCallCheck(this, HtmlClass);

      _this = _super.call(this, props);
      _this._elementRef = React.createRef();
      _this._customMethodes = {};
      _this._customEvents = [];
      _this._isConnected = false;
      _this._props = {};
      return _this;
    }

    _createClass(HtmlClass, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        this.updateChildren();
        this.renderElement();
        this._isConnected = true;
      }
    }, {
      key: "attributeChangedCallback",
      value: function attributeChangedCallback(attrName, oldAttr, newAttr) {
        if (!this._isConnected || oldAttr === newAttr) {
          return false;
        }

        this.renderElement();
        return newAttr;
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        if (!isTest) {
          ReactDOM.unmountComponentAtNode(this);
        }

        if (this._children) delete this._children;
        if (this._isConnected) delete this._isConnected;
        if (this._elementRef) delete this._elementRef;
        if (this._customMethodes) delete this._customMethodes;
        if (this._customEvents) delete this._customEvents;
        this._props = null;
        this._ref = null;
      }
    }, {
      key: "updateChildren",
      value: function updateChildren() {
        this._children = [];
        var i,
            cn = this.childNodes,
            v;

        for (i = cn.length; i--;) {
          v = toVdom(cn[i]);

          if (v) {
            this._children.push(v);
          }
        }
      }
    }, {
      key: "connectEvents",
      value: function connectEvents() {
        var props = {};

        for (var i = this.attributes.length; i--;) {
          props[this.attributes[i].name] = this.attributes[i].value;
        }

        if (props.events) {
          props.event = props.events;
          delete props.events;
        }

        var events = [].concat(_toConsumableArray(props.event ? props.event.split(',') : []), _toConsumableArray(Object.entries(props).map(function (_ref2) {
          var _ref3 = _slicedToArray(_ref2, 2),
              key = _ref3[0],
              value = _ref3[1];

          if (key && /^(on_|on[A-Z]|render_)/.test(key)) {
            return key + '=' + value;
          }

          return null;
        }).filter(Boolean)));

        if (events.length > 0) {
          events.forEach(function (eventDef) {
            var _eventDef$split = eventDef.split('='),
                _eventDef$split2 = _slicedToArray(_eventDef$split, 2),
                type = _eventDef$split2[0],
                func = _eventDef$split2[1];

            type = EVENT_TRANSLATIONS[type] || type;

            props[type] = function () {
              try {
                var _func$split = func.split('.'),
                    _func$split2 = _slicedToArray(_func$split, 2),
                    scope = _func$split2[0],
                    fn = _func$split2[1];

                fn = fn ? window[scope][fn] : window[scope];

                for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = arguments[_key];
                }

                var component = fn.apply(scope, [].concat(args));

                if (component instanceof HTMLElement) {
                  var children = [],
                      cn = component.childNodes,
                      a = component.attributes,
                      _props = {};

                  for (var _i = cn.length; _i--;) {
                    children.push(toVdom(cn[_i]));
                  }

                  for (var _i2 = a.length; _i2--;) {
                    _props[PROP_TRANSLATIONS[a[_i2].name] || a[_i2].name] = a[_i2].value;
                  }

                  var nodeName = component.nodeName.toLowerCase();
                  component.remove();
                  return React.createElement(nodeName, _props, children);
                }

                return component;
              } catch (error) {
                new ErrorHandler("The '".concat(type, "' event has failed. '").concat(func, "' has to exist on a 'window' scope!"), error);
              }
            };
          });
          delete props.event;
        }

        return props;
      }
    }, {
      key: "setProps",
      value: function setProps(props, value) {
        if (typeof props === 'string') {
          props = _defineProperty({}, props, value);
        }

        return this.renderElement(props);
      }
    }, {
      key: "getRef",
      value: function getRef() {
        return this._ref;
      }
    }, {
      key: "addEvent",
      value: function addEvent(eventName, eventCallback) {
        var _this2 = this,
            _this$_customEvents;

        var eventWrapper = function eventWrapper(event) {
          return eventCallback.apply(_this2, [event]);
        };

        (_this$_customEvents = this._customEvents) === null || _this$_customEvents === void 0 ? void 0 : _this$_customEvents.push({
          eventName: eventName,
          eventCallback: eventCallback,
          eventWrapper: eventWrapper
        });
        return eventWrapper;
      }
    }, {
      key: "removeEvent",
      value: function removeEvent(eventId) {
        var removeCallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        this._customEvents = this._customEvents.reduce(function (accumulator, current) {
          if (removeCallback) {
            var eventWrapper = current.eventCallback;

            if (eventWrapper !== removeCallback) {
              accumulator.push(current);
            }
          } else {
            var _eventWrapper = current.eventWrapper;

            if (_eventWrapper !== eventId) {
              accumulator.push(current);
            }
          }

          return accumulator;
        }, []);
      }
    }, {
      key: "fireEvent",
      value: function fireEvent(eventName) {
        var _this3 = this;

        for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        this._customEvents.forEach(function (_ref4) {
          var name = _ref4.eventName,
              eventCallback = _ref4.eventCallback;

          if (name === eventName && typeof eventCallback === 'function') {
            eventCallback.apply(_this3, [].concat(args));
          }
        });
      }
    }, {
      key: "renderElement",
      value: function renderElement() {
        var _this4 = this;

        var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        props = _extends({}, this._props, this.connectEvents(), props);

        for (var p in props) {
          if (props[p] === 'true') {
            props[p] = true;
          } else if (props[p] === 'false') {
            props[p] = false;
          } else if (typeof props[p] !== 'undefined' && props[p] !== null && !isNaN(Number(props[p]))) {
            props[p] = Number(props[p]);
          }
        }

        for (var i = attributesExcludelist.length; i--;) {
          if (props[attributesExcludelist[i]]) {
            this.removeAttribute(attributesExcludelist[i]);
          }
        }

        if (this._children && this._children.length > 0) {
          props.children = this._children;
        }

        if (this._elementRef) {
          props.ref = this._elementRef;
        }

        if (!props.custom_element) {
          props.custom_element = this;
        }

        if (!props.custom_method) {
          props.custom_method = function (methodName, methodFunc) {
            _this4[methodName] = _this4._customMethodes[methodName] = methodFunc;
          };
        }

        this._props = props;
        this._ref = React.createElement(ReactComponent, props);
        ReactDOM.render(this._ref, this);
        return this;
      }
    }], [{
      key: "observedAttributes",
      get: function get() {
        return propNames || [];
      }
    }]);

    return HtmlClass;
  }(_wrapNativeSuper(HTMLElement));

  return window.customElements.define(tagName, HtmlClass);
};

var filterProps = function filterProps(key) {
  return key && !/[A-Z]/.test(key) && !/children/.test(key);
};

export var prepareDefaultProps = function prepareDefaultProps(defaultProps) {
  return Array.isArray(defaultProps) ? defaultProps.filter(filterProps) : Object.entries(defaultProps || {}).reduce(function (props, _ref5) {
    var _ref6 = _slicedToArray(_ref5, 1),
        key = _ref6[0];

    props.push(key);
    return props;
  }, []).filter(filterProps);
};

var toVdom = function toVdom(elem) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  if (elem.nodeType === 3) return elem.nodeValue;
  if (elem.nodeType !== 1) return null;
  var children = [],
      props = {},
      i = 0,
      a = elem.attributes,
      cn = elem.childNodes;

  for (i = a.length; i--;) {
    props[a[i].name] = a[i].value;
  }

  for (i = cn.length; i--;) {
    children[i] = toVdom(cn[i]);
  }

  props.key = "key".concat(Math.random() * 1000);
  return React.createElement(name || elem.nodeName.toLowerCase(), props, children);
};

var PROP_TRANSLATIONS = {
  class: 'className',
  for: 'htmlFor'
};
var EVENT_TRANSLATIONS = {
  onclick: 'onClick'
};