import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
export var SuffixContext = React.createContext();

var Suffix = function Suffix(_ref) {
  var className = _ref.className,
      children = _ref.children,
      context = _ref.context,
      props = _objectWithoutProperties(_ref, ["className", "children", "context"]);

  var content = React.createElement("span", _extends({
    className: classnames('dnb-suffix', className)
  }, props), children);

  if (typeof children !== 'string' && context) {
    return React.createElement(SuffixContext.Provider, {
      value: context
    }, content);
  }

  return content;
};

process.env.NODE_ENV !== "production" ? Suffix.propTypes = {
  className: PropTypes.string,
  children: PropTypes.node
} : void 0;
Suffix.defaultProps = {
  className: null,
  children: null
};
export default Suffix;