import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.object.entries.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import keycode from 'keycode';
import { isTrue, makeUniqueId, extendPropsWithContext, registerElement, validateDOMAttributes, dispatchCustomElementEvent } from '../../shared/component-helper';
import { spacingPropTypes, createSpacingClasses } from '../../components/space/SpacingHelper';
import DrawerListContext from './DrawerListContext';
import DrawerListProvider from './DrawerListProvider';
import DrawerListPortal from './DrawerListPortal';
var propsToFilterOut = {
  on_show: null,
  on_hide: null,
  on_change: null,
  on_pre_change: null,
  on_resize: null,
  on_select: null,
  on_state_update: null,
  options_render: null,
  wrapper_element: null
};

var DrawerList = function (_React$PureComponent) {
  _inherits(DrawerList, _React$PureComponent);

  var _super = _createSuper(DrawerList);

  function DrawerList() {
    _classCallCheck(this, DrawerList);

    return _super.apply(this, arguments);
  }

  _createClass(DrawerList, [{
    key: "render",
    value: function render() {
      var _this$context;

      var hasProvider = (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.drawerList;

      if (hasProvider) {
        return React.createElement(DrawerListInstance, this.props);
      }

      return React.createElement(DrawerListProvider, _extends({}, this.props, {
        data: this.props.data || this.props.children
      }), React.createElement(DrawerListInstance, this.props));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(DrawerList.tagName, DrawerList, DrawerList.defaultProps);
    }
  }]);

  return DrawerList;
}(React.PureComponent);

DrawerList.tagName = 'dnb-drawer-list';
DrawerList.contextType = DrawerListContext;
DrawerList.defaultProps = {
  id: null,
  role: 'listbox',
  cache_hash: null,
  triangle_position: 'left',
  scrollable: true,
  focusable: false,
  max_height: null,
  direction: 'auto',
  size: 'default',
  no_animation: false,
  no_scroll_animation: false,
  use_drawer_on_mobile: false,
  prevent_selection: false,
  action_menu: false,
  is_popup: false,
  align_drawer: 'left',
  wrapper_element: null,
  default_value: null,
  value: 'initval',
  skip_portal: null,
  prevent_close: false,
  keep_open: false,
  prevent_focus: false,
  fixed_position: false,
  independent_width: false,
  skip_keysearch: false,
  opened: null,
  class: null,
  data: null,
  prepared_data: null,
  raw_data: null,
  ignore_events: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_show: null,
  on_hide: null,
  on_change: null,
  on_pre_change: null,
  on_resize: null,
  on_select: null,
  on_state_update: null,
  options_render: null
};
export { DrawerList as default };
process.env.NODE_ENV !== "production" ? DrawerList.propTypes = _extends({
  id: PropTypes.string,
  role: PropTypes.string,
  cache_hash: PropTypes.string,
  triangle_position: PropTypes.string,
  scrollable: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  focusable: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  direction: PropTypes.oneOf(['auto', 'top', 'bottom']),
  size: PropTypes.oneOf(['default', 'small', 'medium', 'large']),
  max_height: PropTypes.number,
  no_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  no_scroll_animation: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  use_drawer_on_mobile: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_selection: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  action_menu: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  is_popup: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  align_drawer: PropTypes.oneOf(['left', 'right']),
  options_render: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.node]),
  wrapper_element: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.node]),
  default_value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  skip_portal: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_close: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  independent_width: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  fixed_position: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  keep_open: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  prevent_focus: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  skip_keysearch: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  opened: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  class: PropTypes.string,
  data: PropTypes.oneOfType([PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node, PropTypes.object]), PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.oneOfType([PropTypes.string, PropTypes.node]), PropTypes.shape({
    selected_value: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
    content: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.arrayOf(PropTypes.string)])
  })]))]),
  prepared_data: PropTypes.array,
  raw_data: PropTypes.oneOfType([PropTypes.array, PropTypes.object, PropTypes.func]),
  ignore_events: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node, PropTypes.object, PropTypes.array]),
  custom_element: PropTypes.object,
  custom_method: PropTypes.func,
  on_show: PropTypes.func,
  on_hide: PropTypes.func,
  on_change: PropTypes.func,
  on_pre_change: PropTypes.func,
  on_resize: PropTypes.func,
  on_select: PropTypes.func,
  on_state_update: PropTypes.func
}) : void 0;

var DrawerListInstance = function (_React$PureComponent2) {
  _inherits(DrawerListInstance, _React$PureComponent2);

  var _super2 = _createSuper(DrawerListInstance);

  function DrawerListInstance(props, context) {
    var _this;

    _classCallCheck(this, DrawerListInstance);

    _this = _super2.call(this, props);

    _this.preventTab = function (e) {
      switch (keycode(e)) {
        case 'tab':
          _this.context.drawerList.setHidden();

          break;

        case 'page down':
        case 'page up':
          e.preventDefault();
          break;
      }
    };

    _this.selectItemHandler = function (event) {
      var selected_item = parseFloat(event.currentTarget.getAttribute('data-item'));

      if (selected_item > -1) {
        _this.context.drawerList.selectItem(selected_item, {
          fireSelectEvent: true,
          event: event
        });
      }
    };

    _this._id = props.id || makeUniqueId();
    _this.state = _this.state || {};
    context.drawerList.setState(Object.entries(propsToFilterOut).reduce(function (acc, _ref) {
      var _ref2 = _slicedToArray(_ref, 1),
          key = _ref2[0];

      if (props[key]) {
        acc[key] = props[key];
      }

      return acc;
    }, {}));
    context.drawerList.setState({
      triangle_position: props.triangle_position
    });
    return _this;
  }

  _createClass(DrawerListInstance, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = extendPropsWithContext(this.props, DrawerList.defaultProps, this.context.getTranslation(this.props).DrawerList, this.context.FormRow, this.context.DrawerList);

      var role = props.role,
          align_drawer = props.align_drawer,
          fixed_position = props.fixed_position,
          use_drawer_on_mobile = props.use_drawer_on_mobile,
          independent_width = props.independent_width,
          scrollable = props.scrollable,
          focusable = props.focusable,
          size = props.size,
          no_animation = props.no_animation,
          no_scroll_animation = props.no_scroll_animation,
          prevent_selection = props.prevent_selection,
          action_menu = props.action_menu,
          is_popup = props.is_popup,
          inner_class = props.inner_class,
          ignore_events = props.ignore_events,
          options_render = props.options_render,
          className = props.className,
          _className = props.class,
          _cache_hash = props.cache_hash,
          _wrapper_element = props.wrapper_element,
          _triangle_position = props.triangle_position,
          _direction = props.direction,
          _max_height = props.max_height,
          _id = props.id,
          _data = props.data,
          _prepared_data = props.prepared_data,
          _raw_data = props.raw_data,
          _opened = props.opened,
          _value = props.value,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["role", "align_drawer", "fixed_position", "use_drawer_on_mobile", "independent_width", "scrollable", "focusable", "size", "no_animation", "no_scroll_animation", "prevent_selection", "action_menu", "is_popup", "inner_class", "ignore_events", "options_render", "className", "class", "cache_hash", "wrapper_element", "triangle_position", "direction", "max_height", "id", "data", "prepared_data", "raw_data", "opened", "value", "children"]);

      var id = this._id;
      var _this$context$drawerL = this.context.drawerList,
          data = _this$context$drawerL.data,
          opened = _this$context$drawerL.opened,
          hidden = _this$context$drawerL.hidden,
          triangle_position = _this$context$drawerL.triangle_position,
          direction = _this$context$drawerL.direction,
          max_height = _this$context$drawerL.max_height,
          cache_hash = _this$context$drawerL.cache_hash,
          selected_item = _this$context$drawerL.selected_item,
          active_item = _this$context$drawerL.active_item,
          closestToTop = _this$context$drawerL.closestToTop,
          closestToBottom = _this$context$drawerL.closestToBottom,
          assignObservers = _this$context$drawerL.assignObservers,
          _refShell = _this$context$drawerL._refShell,
          _refTriangle = _this$context$drawerL._refTriangle,
          _refUl = _this$context$drawerL._refUl,
          usePortal = _this$context$drawerL.usePortal,
          _refRoot = _this$context$drawerL._refRoot;

      var mainParams = _extends({
        id: "".concat(id, "-drawer-list"),
        className: classnames("dnb-drawer-list dnb-drawer-list--".concat(direction), isTrue(independent_width) || isTrue(action_menu) && 'dnb-drawer-list--independent-width', createSpacingClasses(props), _className, className, opened && 'dnb-drawer-list--opened', hidden && 'dnb-drawer-list--hidden', triangle_position && "dnb-drawer-list--triangle-position-".concat(triangle_position), align_drawer && "dnb-drawer-list--".concat(align_drawer), size && "dnb-drawer-list--".concat(size), isTrue(action_menu) && "dnb-drawer-list--action-menu", isTrue(is_popup) && 'dnb-drawer-list--is-popup', isTrue(scrollable) && 'dnb-drawer-list--scroll', isTrue(no_scroll_animation) && 'dnb-drawer-list--no-scroll-animation', isTrue(use_drawer_on_mobile) && 'dnb-drawer-list--mobile-view')
      }, attributes);

      var listParams = {
        id: "".concat(id, "-listbox"),
        className: classnames('dnb-drawer-list__list', inner_class, isTrue(no_animation) && 'dnb-drawer-list__list--no-animation')
      };
      var ulParams = {
        role: role,
        id: "".concat(id, "-ul"),
        'aria-expanded': opened,
        'aria-labelledby': "".concat(id, "-label"),
        tabIndex: '-1',
        style: {
          maxHeight: max_height > 0 ? "".concat(max_height, "rem") : null
        },
        ref: _refUl
      };

      if (!hidden && parseFloat(active_item) > -1) {
        ulParams['aria-activedescendant'] = "option-".concat(id, "-").concat(active_item);
      } else if (!isTrue(prevent_selection) && !hidden && parseFloat(selected_item) > -1) {
        ulParams['aria-activedescendant'] = "option-".concat(id, "-").concat(selected_item);
      }

      if (isTrue(focusable)) {
        ulParams.tabIndex = '0';
      }

      validateDOMAttributes(this.props, mainParams);
      validateDOMAttributes(null, listParams);
      validateDOMAttributes(null, ulParams);

      _extends(this.context.drawerList.attributes, validateDOMAttributes(null, attributes));

      var ignoreEvents = isTrue(ignore_events);

      var Items = function Items() {
        return data.map(function (dataItem, i) {
          var _id = dataItem.__id;
          var hash = "option-".concat(id, "-").concat(_id, "-").concat(i);
          var liParams = {
            role: role === 'menu' ? 'menuitem' : 'option',
            'data-item': _id,
            id: "option-".concat(id, "-").concat(_id),
            hash: hash,
            className: classnames(ignoreEvents || dataItem.ignore_events && 'ignore-events', dataItem.class_name, i === closestToTop && 'closest-to-top', i === closestToBottom && 'closest-to-bottom', i === 0 && 'first-of-type', i === data.length - 1 && 'last-of-type'),
            active: _id == active_item,
            selected: !dataItem.ignore_events && _id == selected_item,
            onClick: _this2.selectItemHandler,
            onKeyDown: _this2.preventTab
          };

          if (ignoreEvents) {
            liParams.active = null;
            liParams.selected = null;
            liParams.onClick = null;
            liParams.onKeyDown = null;
            liParams.className = classnames(liParams.className, 'dnb-drawer-list__option--ignore');
          }

          return React.createElement(DrawerList.Item, _extends({
            key: hash
          }, liParams), dataItem);
        });
      };

      var mainList = React.createElement("span", _extends({}, mainParams, {
        ref: _refShell
      }), React.createElement("span", listParams, hidden === false && data && data.length > 0 ? React.createElement(React.Fragment, null, React.createElement(DrawerList.Options, _extends({
        cache_hash: cache_hash + active_item + selected_item + closestToTop + closestToBottom + direction + max_height
      }, ulParams, {
        triangleRef: _refTriangle
      }), typeof options_render === 'function' ? options_render({
        data: data,
        Items: Items,
        Item: DrawerList.Item
      }) : React.createElement(Items, null)), React.createElement(OnMounted, {
        assignObservers: assignObservers
      })) : children && React.createElement("span", {
        className: "dnb-drawer-list__content"
      }, children, React.createElement("span", {
        className: "dnb-drawer-list__triangle",
        ref: _refTriangle
      }))));
      return React.createElement("span", {
        className: 'dnb-drawer-list__root' + (usePortal ? " dnb-drawer-list__root--portal" : ""),
        ref: _refRoot
      }, usePortal ? React.createElement(DrawerListPortal, {
        id: this._id,
        rootRef: _refRoot,
        opened: hidden === false,
        include_owner_width: align_drawer === 'right',
        independent_width: isTrue(independent_width),
        fixed_position: isTrue(fixed_position),
        use_drawer_on_mobile: isTrue(use_drawer_on_mobile)
      }, mainList) : mainList);
    }
  }]);

  return DrawerListInstance;
}(React.PureComponent);

DrawerListInstance.defaultProps = DrawerList.defaultProps;
DrawerListInstance.contextType = DrawerListContext;
process.env.NODE_ENV !== "production" ? DrawerListInstance.propTypes = DrawerList.propTypes : void 0;
DrawerList.Options = React.memo(React.forwardRef(function (props, ref) {
  var children = props.children,
      className = props.className,
      _className = props.class,
      _props$triangleRef = props.triangleRef,
      triangleRef = _props$triangleRef === void 0 ? null : _props$triangleRef,
      cache_hash = props.cache_hash,
      rest = _objectWithoutProperties(props, ["children", "className", "class", "triangleRef", "cache_hash"]);

  return React.createElement("ul", _extends({
    className: classnames('dnb-drawer-list__options', className, _className)
  }, rest, {
    ref: ref
  }), children, React.createElement("li", {
    className: "dnb-drawer-list__triangle",
    "aria-hidden": true,
    ref: triangleRef
  }));
}), function (prevProps, nextProps) {
  if (!prevProps.cache_hash) {
    return null;
  }

  return prevProps.cache_hash === nextProps.cache_hash;
});
DrawerList.Options.displayName = 'DrawerList.Options';
DrawerList.Options.propTypes = {
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  className: PropTypes.string,
  class: PropTypes.string,
  triangleRef: PropTypes.object
};
DrawerList.Options.defaultProps = {
  children: null,
  className: null,
  class: null,
  triangleRef: null
};
DrawerList.Item = React.forwardRef(function (props, ref) {
  var role = props.role,
      hash = props.hash,
      children = props.children,
      className = props.className,
      _className = props.class,
      on_click = props.on_click,
      selected = props.selected,
      active = props.active,
      value = props.value,
      rest = _objectWithoutProperties(props, ["role", "hash", "children", "className", "class", "on_click", "selected", "active", "value"]);

  var params = {
    className: classnames(className, _className, 'dnb-drawer-list__option', selected && 'dnb-drawer-list__option--selected', active && 'dnb-drawer-list__option--focus'),
    role: role,
    tabIndex: selected ? '0' : '-1',
    'aria-selected': active
  };

  if (selected) {
    params['aria-current'] = true;
  }

  if (on_click) {
    params.onClick = function () {
      return dispatchCustomElementEvent({
        props: _extends({}, props, {
          displayName: DrawerList.Item.displayName
        })
      }, 'on_click', _extends({
        selected: selected,
        value: value
      }, rest));
    };
  }

  return React.createElement("li", _extends({}, params, rest, {
    ref: ref,
    key: 'li' + hash
  }), React.createElement("span", {
    className: "dnb-drawer-list__option__inner"
  }, React.createElement(ItemContent, {
    hash: hash
  }, children)));
});
DrawerList.Item.displayName = 'DrawerList.Item';
DrawerList.Item.propTypes = {
  role: PropTypes.string,
  hash: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func, PropTypes.object]).isRequired,
  className: PropTypes.string,
  class: PropTypes.string,
  on_click: PropTypes.func,
  selected: PropTypes.bool,
  active: PropTypes.bool,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
};
DrawerList.Item.defaultProps = {
  role: 'option',
  hash: '',
  className: null,
  class: null,
  on_click: null,
  selected: null,
  active: null,
  value: null
};

var ItemContent = function ItemContent(_ref3) {
  var hash = _ref3.hash,
      children = _ref3.children;

  if (Array.isArray(children.content || children)) {
    return (children.content || children).map(function (item, n) {
      return React.createElement("span", {
        key: hash + n,
        className: "dnb-drawer-list__option__item"
      }, children.render ? children.render(item, hash + n) : item);
    });
  } else if (children.content) {
    return children.render ? children.render(children.content, hash) : children.content;
  }

  return children;
};

process.env.NODE_ENV !== "production" ? ItemContent.propTypes = {
  hash: PropTypes.string.isRequired,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func, PropTypes.object]).isRequired
} : void 0;

DrawerList.HorizontalItem = function (_ref4) {
  var className = _ref4.className,
      props = _objectWithoutProperties(_ref4, ["className"]);

  return React.createElement("span", _extends({
    className: classnames('dnb-drawer-list__option__inner__item', className)
  }, props));
};

DrawerList.HorizontalItem.propTypes = {
  className: PropTypes.string
};
DrawerList.HorizontalItem.defaultProps = {
  className: null
};

var OnMounted = function (_React$PureComponent3) {
  _inherits(OnMounted, _React$PureComponent3);

  var _super3 = _createSuper(OnMounted);

  function OnMounted() {
    _classCallCheck(this, OnMounted);

    return _super3.apply(this, arguments);
  }

  _createClass(OnMounted, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.assignObservers();
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return OnMounted;
}(React.PureComponent);

process.env.NODE_ENV !== "production" ? OnMounted.propTypes = {
  assignObservers: PropTypes.func.isRequired
} : void 0;