import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { extendPropsWithContext, registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';
import Context from '../../shared/Context';
import { spacingPropTypes, createSpacingClasses } from '../../components/space/SpacingHelper';

var ScrollView = function (_React$PureComponent) {
  _inherits(ScrollView, _React$PureComponent);

  var _super = _createSuper(ScrollView);

  function ScrollView(props) {
    var _this;

    _classCallCheck(this, ScrollView);

    _this = _super.call(this, props);
    _this.ref = props.innerRef || React.createRef();
    return _this;
  }

  _createClass(ScrollView, [{
    key: "render",
    value: function render() {
      var props = extendPropsWithContext(this.props, ScrollView.defaultProps, this.context.FormRow, this.context.ScrollView);

      var className = props.className,
          _className = props.class,
          innerRef = props.innerRef,
          attributes = _objectWithoutProperties(props, ["className", "class", "innerRef"]);

      var contentToRender = ScrollView.getContent(props);

      var mainParams = _extends({
        className: classnames('dnb-scroll-view', createSpacingClasses(props), _className, className)
      }, attributes);

      validateDOMAttributes(this.props, mainParams);
      return React.createElement("div", _extends({}, mainParams, {
        ref: this.ref
      }), contentToRender);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(ScrollView.tagName, ScrollView, ScrollView.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.text) return props.text;
      return processChildren(props);
    }
  }]);

  return ScrollView;
}(React.PureComponent);

ScrollView.tagName = 'dnb-scroll-view';
ScrollView.contextType = Context;
ScrollView.defaultProps = {
  className: null,
  children: null,
  innerRef: null,
  class: null
};
process.env.NODE_ENV !== "production" ? ScrollView.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.func, PropTypes.node]),
  innerRef: PropTypes.object,
  class: PropTypes.string
}) : void 0;
export default React.forwardRef(function ScrollViewRef(props, ref) {
  return React.createElement(ScrollView, _extends({
    innerRef: ref
  }, props));
});