import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes } from '../../shared/component-helper';
import Button from '../../components/button/Button';

var ActionNav = function (_React$PureComponent) {
  _inherits(ActionNav, _React$PureComponent);

  var _super = _createSuper(ActionNav);

  function ActionNav() {
    _classCallCheck(this, ActionNav);

    return _super.apply(this, arguments);
  }

  _createClass(ActionNav, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          prev_href = _this$props.prev_href,
          next_href = _this$props.next_href,
          prev_text = _this$props.prev_text,
          next_text = _this$props.next_text,
          prev_title = _this$props.prev_title,
          next_title = _this$props.next_title,
          className = _this$props.className,
          _className = _this$props.class;
      var params = {
        className: classnames("dnb-action-nav dnb-belt", className, _className)
      };
      var hasNavAttributes = prev_href && next_href;
      validateDOMAttributes(this.props, params);
      return React.createElement("div", params, React.createElement("div", {
        className: "dnb-width-limit"
      }, React.createElement("div", {
        className: "dnb-action-nav__inner"
      }, hasNavAttributes && React.createElement(React.Fragment, null, React.createElement("div", {
        className: "dnb-action-nav__left"
      }, prev_href && React.createElement("div", {
        className: "dnb-action-nav__item"
      }, React.createElement(Button, {
        type: "button",
        text: prev_text,
        title: prev_title,
        variant: "secondary",
        icon_position: "left",
        icon: "chevron_left",
        href: prev_href
      })), next_href && React.createElement("div", {
        className: "dnb-action-nav__item"
      }, React.createElement(Button, {
        text: next_text,
        title: next_title,
        variant: "primary",
        icon: "chevron_right",
        href: next_href
      }))), React.createElement("div", {
        className: "dnb-action-nav__right"
      }, children)) || children)));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(ActionNav.tagName, ActionNav, ActionNav.defaultProps);
    }
  }]);

  return ActionNav;
}(React.PureComponent);

ActionNav.tagName = 'dnb-action-nav';
ActionNav.defaultProps = {
  prev_href: null,
  next_href: null,
  prev_text: 'Back',
  next_text: 'Next',
  prev_title: 'Go back',
  next_title: 'Go next',
  class: null,
  className: null,
  children: null
};
export { ActionNav as default };
process.env.NODE_ENV !== "production" ? ActionNav.propTypes = {
  prev_href: PropTypes.string,
  next_href: PropTypes.string,
  prev_text: PropTypes.string,
  next_text: PropTypes.string,
  prev_title: PropTypes.string,
  next_title: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
} : void 0;