import "core-js/modules/es.array.map.js";
import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';
import Input from '../../components/input/Input';
import Icon from '../../components/icon-primary/IconPrimary';
import Button from '../../components/button/Button';
import Logo from '../../components/logo/Logo';
import Notification from '../../components/notification/Notification';

var _ref2 = React.createElement(Logo, {
  height: 80
});

var _ref3 = React.createElement(Logo, {
  height: 80
});

var _ref4 = React.createElement("div", {
  className: "dnb-main-nav__item"
}, React.createElement(Button, {
  variant: "secondary",
  text: "Logg ut"
}));

var MainNav = function (_React$PureComponent) {
  _inherits(MainNav, _React$PureComponent);

  var _super = _createSuper(MainNav);

  function MainNav(props) {
    var _this;

    _classCallCheck(this, MainNav);

    _this = _super.call(this, props);
    _this.state = {
      isSubNavActive: false
    };

    _this.toggleNavHandler = function () {
      var isSubNavActive = !_this.state.isSubNavActive;

      _this.setState({
        isSubNavActive: isSubNavActive
      });

      if (_this._innerRef) {
        _this._innerRef.current.setAttribute('tabindex', isSubNavActive ? '0' : '-1');

        if (isSubNavActive) {
          _this._innerRef.current.focus();
        }
      }
    };

    _this._innerRef = React.createRef();
    return _this;
  }

  _createClass(MainNav, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.setState({
        isSubNavActive: false
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _params;

      var _this$props = this.props,
          baseurl = _this$props.baseurl,
          notification_amount = _this$props.notification_amount,
          className = _this$props.className,
          _className = _this$props.class;
      var data = MainNav.getData(this.props);
      var params = (_params = {
        role: 'navigation'
      }, _defineProperty(_params, 'aria-label', 'Main Menu'), _defineProperty(_params, 'data-nav-active', this.state.isSubNavActive), _defineProperty(_params, "className", classnames('dnb-main-nav', className, _className)), _params);
      validateDOMAttributes(this.props, params);
      return React.createElement("nav", params, React.createElement("div", {
        className: "dnb-main-nav__inner"
      }, React.createElement("div", {
        className: "dnb-main-nav__inner__inner"
      }, React.createElement("div", {
        className: "dnb-main-nav__left"
      }, React.createElement("div", {
        className: "dnb-main-nav__item"
      }, React.createElement(MainNavTrigger, {
        text: "Meny",
        onTrigger: this.toggleNavHandler
      })), _ref), React.createElement("div", {
        className: "dnb-main-nav__item dnb-main-nav__logo"
      }, baseurl && React.createElement("a", {
        href: baseurl,
        title: "Links back to front page"
      }, _ref2) || _ref3), React.createElement("div", {
        className: "dnb-main-nav__right"
      }, React.createElement("div", {
        className: "dnb-main-nav__item"
      }, notification_amount && React.createElement(Notification, {
        notification_amount: notification_amount,
        title_text: "Du har ".concat(notification_amount, " notifications")
      })), _ref4)), React.createElement("div", {
        className: "dnb-main-nav__nav"
      }, React.createElement("div", {
        className: "dnb-main-nav__nav__inner"
      }, _ref5, React.createElement("div", {
        className: "dnb-main-nav__links dnb-width-limit dnb-tab-focus",
        tabIndex: "-1",
        ref: this._innerRef
      }, data.length > 0 && React.createElement("ul", {
        className: "dnb-grid dnb-grid--gutters dnb-grid--center"
      }, data.map(function (_ref6, i) {
        var title = _ref6.title,
            url = _ref6.url;
        return React.createElement("li", {
          key: "mn".concat(i),
          className: "dnb-grid__cell"
        }, React.createElement("a", {
          href: url,
          className: "dnb-main-nav__link",
          tabIndex: "-1"
        }, React.createElement("span", null, title)));
      })))))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(MainNav.tagName, MainNav, MainNav.defaultProps);
    }
  }, {
    key: "getData",
    value: function getData(props) {
      var res = [];
      if (props.data) res = props.data;else res = processChildren(props);
      if (typeof res === 'string') return res[0] === '[' ? JSON.parse(res) : [];
      return res || [];
    }
  }]);

  return MainNav;
}(React.PureComponent);

MainNav.tagName = 'dnb-main-nav';
MainNav.defaultProps = {
  data: [],
  baseurl: '/uilib/demos',
  notification_amount: 0,
  class: null,
  className: null,
  children: null
};
export { MainNav as default };
process.env.NODE_ENV !== "production" ? MainNav.propTypes = {
  data: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
  baseurl: PropTypes.string,
  notification_amount: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
} : void 0;

var _ref7 = React.createElement("span", {
  className: "dnb-main-nav-trigger__icon"
}, React.createElement(Icon, {
  icon: "hamburger"
}));

var MainNavTrigger = function MainNavTrigger(props) {
  var text = props.text,
      className = props.className,
      modifier = props.modifier;
  var params = {
    className: classnames('dnb-main-nav-trigger', className, modifier && "dnb-main-nav-trigger--".concat(modifier))
  };

  var onTriggerHandle = function onTriggerHandle() {
    if (typeof props.onTrigger === 'function') {
      props.onTrigger();
    }
  };

  return React.createElement("button", _extends({
    onClick: onTriggerHandle
  }, params), _ref7, React.createElement("span", {
    className: "dnb-main-nav-trigger__text"
  }, text));
};

process.env.NODE_ENV !== "production" ? MainNavTrigger.propTypes = {
  text: PropTypes.string,
  className: PropTypes.string,
  modifier: PropTypes.string,
  onTrigger: PropTypes.func
} : void 0;
MainNavTrigger.defaultProps = {
  text: null,
  className: null,
  modifier: null,
  onTrigger: null
};

var Search = function Search(props) {
  return React.createElement(Input, _extends({
    type: "search",
    id: "nav_search",
    label: "Label text",
    placeholder: "S\xF8k"
  }, props));
},
    _ref5 = React.createElement("div", {
  className: "dnb-mobile-exclusive"
}, React.createElement(Search, {
  id: "nav_search_mobile"
})),
    _ref = React.createElement("div", {
  className: "dnb-main-nav__item dnb-hide-on-mobile"
}, React.createElement(Search, null));