import * as React from 'react';
export type PaymentCardCardStatus = 'active' | 'blocked' | 'expired';
export type PaymentCardVariant = 'normal' | 'compact';
export type PaymentCardDigits = string | number;
export type PaymentCardSkeleton = string | boolean;
export type PaymentCardSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type PaymentCardTop = string | number | boolean;
export type PaymentCardRight = string | number | boolean;
export type PaymentCardBottom = string | number | boolean;
export type PaymentCardLeft = string | number | boolean;
export type PaymentCardChildren =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface PaymentCardProps extends React.HTMLProps<HTMLElement> {
  product_code: string;
  card_number: string;
  card_status?: PaymentCardCardStatus;
  variant?: PaymentCardVariant;
  digits?: PaymentCardDigits;
  raw_data?: any;
  id?: string;
  locale?: string;
  skeleton?: PaymentCardSkeleton;
  space?: PaymentCardSpace;
  top?: PaymentCardTop;
  right?: PaymentCardRight;
  bottom?: PaymentCardBottom;
  left?: PaymentCardLeft;
  class?: string;
  className?: string;
  children?: PaymentCardChildren;
}
export default class PaymentCard extends React.Component<
  PaymentCardProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
