import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes } from '../../shared/component-helper';
import Slider from '../../components/slider/Slider';
import Input from '../../components/input/Input';
import Modal from '../../components/modal/Modal';
import FormLabel from '../../components/form-label/FormLabel';

var RangeSlider = function (_React$PureComponent) {
  _inherits(RangeSlider, _React$PureComponent);

  var _super = _createSuper(RangeSlider);

  function RangeSlider(props) {
    var _this;

    _classCallCheck(this, RangeSlider);

    _this = _super.call(this, props);
    _this.state = {
      value: null
    };
    _this.state.value = props.range_val;
    return _this;
  }

  _createClass(RangeSlider, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          range_min = _this$props.range_min,
          range_max = _this$props.range_max,
          range_step = _this$props.range_step,
          label_text = _this$props.label_text,
          range_output_description = _this$props.range_output_description,
          range_output_extra_information = _this$props.range_output_extra_information,
          range_trigger_text = _this$props.range_trigger_text,
          range_modal_text = _this$props.range_modal_text,
          className = _this$props.className,
          _className = _this$props.class;
      var params = {
        className: classnames('dnb-range-slider', className, _className)
      };
      validateDOMAttributes(this.props, params);
      return React.createElement("div", params, React.createElement("div", {
        className: "dnb-range-slider__label"
      }, React.createElement("div", {
        className: "dnb-range-slider__label__inner"
      }, React.createElement(FormLabel, {
        for_id: "range-slider",
        text: label_text
      }))), React.createElement("div", {
        className: "dnb-range-slider__slider"
      }, React.createElement("div", {
        className: "dnb-range-slider__input-container"
      }, React.createElement(Slider, {
        id: "range-slider",
        min: range_min,
        max: range_max,
        value: this.state.value,
        step: range_step,
        on_init: function on_init(_ref) {
          var value = _ref.value;

          _this2.setState({
            value: value
          });
        },
        on_change: function on_change(_ref2) {
          var value = _ref2.value;

          _this2.setState({
            value: value
          });
        }
      })), React.createElement("div", {
        className: "dnb-range-slider__output-container"
      }, React.createElement(Input, {
        type: "text",
        size: "large",
        value: this.state.value,
        description: range_output_description,
        status: range_output_extra_information,
        status_state: "info",
        on_change: function on_change(_ref3) {
          var value = _ref3.value;

          _this2.setState({
            value: parseFloat(value)
          });
        }
      })), React.createElement("div", {
        className: "dnb-range-slider__slider__modal"
      }, React.createElement(Modal, {
        type: "button",
        trigger_text: range_trigger_text,
        modal_content: range_modal_text
      }))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(RangeSlider.tagName, RangeSlider, RangeSlider.defaultProps);
    }
  }]);

  return RangeSlider;
}(React.PureComponent);

RangeSlider.tagName = 'dnb-range-slider';
RangeSlider.defaultProps = {
  title: null,
  text: null,
  descriptionListData: null,
  descriptionListInfo: null,
  class: null,
  className: null,
  children: null
};
export { RangeSlider as default };
process.env.NODE_ENV !== "production" ? RangeSlider.propTypes = {
  label_text: PropTypes.string.isRequired,
  range_min: PropTypes.number.isRequired,
  range_max: PropTypes.number.isRequired,
  range_val: PropTypes.number.isRequired,
  range_step: PropTypes.number.isRequired,
  range_output_description: PropTypes.string.isRequired,
  range_output_extra_information: PropTypes.string.isRequired,
  range_trigger_text: PropTypes.string.isRequired,
  range_modal_text: PropTypes.string.isRequired,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
} : void 0;