import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';
import Button from '../../components/button/Button';

var SummaryTable = function (_React$PureComponent) {
  _inherits(SummaryTable, _React$PureComponent);

  var _super = _createSuper(SummaryTable);

  function SummaryTable() {
    _classCallCheck(this, SummaryTable);

    return _super.apply(this, arguments);
  }

  _createClass(SummaryTable, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          prev_href = _this$props.prev_href,
          next_href = _this$props.next_href,
          prev_text = _this$props.prev_text,
          next_text = _this$props.next_text,
          prev_title = _this$props.prev_title,
          next_title = _this$props.next_title,
          className = _this$props.className,
          _className = _this$props.class;
      var leftContent = SummaryTable.getLeftContent(this.props);
      var rightContent = SummaryTable.getRightContent(this.props);
      var params = {
        className: "dnb-summary-table ".concat(className || _className || '')
      };
      validateDOMAttributes(this.props, params);
      return React.createElement("div", params, React.createElement("div", {
        className: "dnb-width-limit"
      }, React.createElement("div", {
        className: "dnb-summary-table__inner"
      }, leftContent && React.createElement("div", {
        className: "dnb-summary-table__left"
      }, leftContent) || React.createElement("div", {
        className: "dnb-summary-table__left"
      }, prev_href && React.createElement("div", {
        className: "dnb-summary-table__item"
      }, React.createElement(Button, {
        type: "button",
        text: prev_text,
        title: prev_title,
        variant: "secondary",
        icon_position: "left",
        icon: "chevron_left",
        href: prev_href
      })), next_href && React.createElement("div", {
        className: "dnb-summary-table__item"
      }, React.createElement(Button, {
        text: next_text,
        title: next_title,
        variant: "primary",
        icon: "chevron_right",
        href: next_href
      }))), rightContent && React.createElement("div", {
        className: "dnb-summary-table__right"
      }, rightContent))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(SummaryTable.tagName, SummaryTable, SummaryTable.defaultProps);
    }
  }, {
    key: "getLeftContent",
    value: function getLeftContent(props) {
      if (typeof props.render_left_content === 'function') {
        return props.render_left_content(props);
      }

      return null;
    }
  }, {
    key: "getRightContent",
    value: function getRightContent(props) {
      if (typeof props.render_right_content === 'function') {
        return props.render_right_content(props);
      }

      return processChildren(props);
    }
  }]);

  return SummaryTable;
}(React.PureComponent);

SummaryTable.tagName = 'dnb-summary-table';
SummaryTable.defaultProps = {
  prev_href: null,
  next_href: null,
  prev_text: 'Back',
  next_text: 'Next',
  prev_title: 'Go back',
  next_title: 'Go next',
  class: null,
  className: null,
  children: null,
  render_left_content: null,
  render_right_content: null
};
export { SummaryTable as default };
process.env.NODE_ENV !== "production" ? SummaryTable.propTypes = {
  prev_href: PropTypes.string,
  next_href: PropTypes.string,
  prev_text: PropTypes.string,
  next_text: PropTypes.string,
  prev_title: PropTypes.string,
  next_title: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  render_left_content: PropTypes.func,
  render_right_content: PropTypes.func
} : void 0;