import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import Context, { prepareContext } from './Context';
import { makeUniqueId } from './component-helper';
import { prepareFormRowContext } from '../components/form-row/FormRow';

var Provider = function (_React$PureComponent) {
  _inherits(Provider, _React$PureComponent);

  var _super = _createSuper(Provider);

  function Provider(props, context) {
    var _this;

    _classCallCheck(this, Provider);

    _this = _super.call(this, props);

    var children = props.children,
        value = props.value,
        startupProps = _objectWithoutProperties(props, ["children", "value"]);

    if (typeof startupProps.formRow !== 'undefined') {
      startupProps.FormRow = startupProps.formRow;
    }

    var newContext = _extends({}, value, context, startupProps);

    var isRoot = !(newContext && newContext.__providerId);
    newContext.__providerId = makeUniqueId();
    var pC = isRoot ? prepareContext(newContext) : newContext;

    pC.updateCurrent = function (props) {
      return _this.setNewContext(props);
    };

    pC.setCurrentLocale = function (locale) {
      return _this.setNewContext({
        locale: locale
      });
    };

    pC.update = function (props) {
      if (typeof context.update === 'function') {
        context.update(props);
      }

      _this.setNewContext(props);
    };

    pC.setLocale = function (locale) {
      if (typeof context.update === 'function') {
        context.update({
          locale: locale
        });
      }

      _this.setNewContext({
        locale: locale
      });
    };

    _this.state = pC;
    _this.state.isRoot = isRoot;
    _this.state._listenForPropChanges = true;
    _this.state._startupProps = startupProps;
    return _this;
  }

  _createClass(Provider, [{
    key: "setNewContext",
    value: function setNewContext(__newContext) {
      this.setState({
        _listenForPropChanges: false
      });
      this.setState({
        __newContext: __newContext
      });
    }
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      var context = !this.state.isRoot ? _extends({}, this.context, this.state) : this.state;
      this.context.updateTranslation(context.locale, context.translation);
      return React.createElement(Context.Provider, {
        value: context
      }, children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        var children = props.children,
            updatedProps = _objectWithoutProperties(props, ["children"]);

        var newContext = state;

        if (state._startupProps !== updatedProps) {
          var hasChanges = false;

          for (var i in updatedProps) {
            if (state._startupProps[i] !== updatedProps[i] || typeof updatedProps[i] === 'boolean') {
              hasChanges = true;
              break;
            }
          }

          if (hasChanges) {
            newContext = _extends(state, updatedProps);
            state._startupProps = updatedProps;
          }
        }

        if (newContext.FormRow) {
          newContext.FormRow = prepareFormRowContext(newContext.FormRow);
        }

        state = newContext;
      }

      state._listenForPropChanges = true;
      return prepareContext(state);
    }
  }]);

  return Provider;
}(React.PureComponent);

Provider.contextType = Context;
Provider.defaultProps = {};
export { Provider as default };
process.env.NODE_ENV !== "production" ? Provider.propTypes = {
  value: PropTypes.object,
  locale: PropTypes.string,
  skeleton: PropTypes.bool,
  children: PropTypes.node.isRequired
} : void 0;