import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.string.replace.js";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import "regenerator-runtime/runtime.js";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _typeof from "@babel/runtime/helpers/esm/typeof";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { warn, PLATFORM_MAC, PLATFORM_WIN, PLATFORM_LINUX, PLATFORM_IOS } from './component-helper';
export var IS_IE11 = false;
export var IS_EDGE = false;
export var IS_IOS = false;
export var IS_SAFARI = false;
export var IS_WIN = false;
export var IS_MAC = false;
export var IS_LINUX = false;
export var isMac = function isMac() {
  var _navigator;

  return IS_MAC = typeof navigator !== 'undefined' && new RegExp(PLATFORM_MAC, 'i').test((_navigator = navigator) === null || _navigator === void 0 ? void 0 : _navigator.platform);
};
export var isWin = function isWin() {
  var _navigator2;

  return IS_WIN = typeof navigator !== 'undefined' && new RegExp(PLATFORM_WIN, 'i').test((_navigator2 = navigator) === null || _navigator2 === void 0 ? void 0 : _navigator2.platform);
};
export var isLinux = function isLinux() {
  var _navigator3;

  return IS_LINUX = typeof navigator !== 'undefined' && new RegExp(PLATFORM_LINUX, 'i').test((_navigator3 = navigator) === null || _navigator3 === void 0 ? void 0 : _navigator3.platform);
};
export var isiOS = function isiOS() {
  var _navigator4;

  return IS_IOS = typeof navigator !== 'undefined' && new RegExp(PLATFORM_IOS, 'i').test((_navigator4 = navigator) === null || _navigator4 === void 0 ? void 0 : _navigator4.platform);
};
export var isSafari = function isSafari() {
  var _navigator5, _navigator6;

  return IS_SAFARI = typeof navigator !== 'undefined' && /safari/i.test((_navigator5 = navigator) === null || _navigator5 === void 0 ? void 0 : _navigator5.userAgent) && !/chrome/i.test((_navigator6 = navigator) === null || _navigator6 === void 0 ? void 0 : _navigator6.userAgent);
};
export var isIE11 = function isIE11() {
  return IS_IE11 = typeof window !== 'undefined' && typeof document !== 'undefined' ? !!window.MSInputMethodContext && !!document.documentMode : false;
};
export var isEdge = function isEdge() {
  var _navigator7;

  return IS_EDGE = typeof navigator !== 'undefined' && /edge/i.test((_navigator7 = navigator) === null || _navigator7 === void 0 ? void 0 : _navigator7.userAgent);
};
isIE11();
isEdge();
isiOS();
isSafari();
isWin();
isMac();
isLinux();
var pageFocusElements = {};
export function setPageFocusElement(selectorOrElement) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'default';
  return pageFocusElements[key] = selectorOrElement;
}
export function applyPageFocus() {
  var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';
  var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  try {
    var element = pageFocusElements[key];

    if (typeof element === 'string' && typeof document !== 'undefined') {
      element = document.querySelector(element);
    } else if (!element && typeof document !== 'undefined') {
      element = document.querySelector('.dnb-no-focus');
    }

    if (element instanceof HTMLElement) {
      if (['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'p', 'div', 'main', 'nav', 'header', 'footer', 'aside', 'section', 'article'].includes(String(element.nodeName).toLowerCase())) {
        if (!element.hasAttribute('tabindex')) {
          element.setAttribute('tabindex', '-1');
        }

        if (element.classList && !element.classList.contains('dnb-no-focus')) {
          element.classList.add('dnb-no-focus');
        }
      }

      element.focus({
        preventScroll: true
      });

      if (typeof callback === 'function') {
        callback(element);
      }
    }
  } catch (e) {
    warn('Error on applyPageFocus:', e);
  }
}
export function getOffsetTop(elem) {
  var offsetTop = 0;

  do {
    if (!isNaN(elem.offsetTop)) {
      offsetTop += elem.offsetTop;
    }
  } while (elem = elem.offsetParent);

  return offsetTop;
}
export function getOffsetLeft(elem) {
  var offsetLeft = 0;

  do {
    if (!isNaN(elem.offsetLeft)) {
      offsetLeft += elem.offsetLeft;
    }
  } while (elem = elem.offsetParent);

  return offsetLeft;
}
export function scrollToLocationHashId() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$offset = _ref.offset,
      offset = _ref$offset === void 0 ? 0 : _ref$offset,
      _ref$delay = _ref.delay,
      delay = _ref$delay === void 0 ? null : _ref$delay,
      _ref$onCompletion = _ref.onCompletion,
      onCompletion = _ref$onCompletion === void 0 ? null : _ref$onCompletion;

  if (typeof document !== 'undefined' && typeof window !== 'undefined' && window.location) {
    try {
      var _timeout;

      var id = String(window.location.hash).replace('#', '');

      if (id.length > 0) {
        var handleScroll = function handleScroll() {
          var runScroll = function runScroll() {
            var top = getOffsetTop(elem) - offset;

            try {
              if (typeof IntersectionObserver !== 'undefined') {
                var intersectionObserver = new IntersectionObserver(function (entries) {
                  var _entries = _slicedToArray(entries, 1),
                      entry = _entries[0];

                  if (entry.isIntersecting) {
                    intersectionObserver.unobserve(elem);

                    if (typeof onCompletion === 'function') {
                      onCompletion(elem);
                    }
                  }
                });
                intersectionObserver.observe(elem);
              }

              if (window.scrollTo) {
                window.scrollTo({
                  top: top,
                  behavior: 'smooth'
                });
              } else {
                window.scrollTop = top;
              }
            } catch (e) {
              warn('Error on scrollToLocationHashId:', e);
            }
          };

          if (delay > 0) {
            clearTimeout(_timeout);
            _timeout = setTimeout(runScroll, delay);
          } else {
            runScroll();
          }
        };

        var elem = document.getElementById(id);

        if (elem instanceof HTMLElement) {
          window.addEventListener('beforeunload', function () {
            return clearTimeout(_timeout);
          });

          if (document.readyState === 'loading') {
            document.addEventListener('DOMContentLoaded', handleScroll);
          } else {
            handleScroll();
          }
        }

        return elem;
      }
    } catch (e) {
      warn('Error on scrollToLocationHashId:', e);
    }
  }
}
export function debounce(func) {
  var wait = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 250;

  var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      _ref2$immediate = _ref2.immediate,
      immediate = _ref2$immediate === void 0 ? false : _ref2$immediate,
      _ref2$context = _ref2.context,
      context = _ref2$context === void 0 ? null : _ref2$context;

  var timeout;
  var recall;
  return function executedFunction() {
    var ctx = context || this;
    var args = arguments;

    if (typeof recall === 'function') {
      recall();
    }

    var later = function later() {
      timeout = null;

      if (!immediate) {
        recall = func.apply(ctx, args);
      }
    };

    var callNow = immediate && !timeout;
    clearTimeout(timeout);
    timeout = setTimeout(later, wait);

    if (callNow) {
      recall = func.apply(ctx, args);
    }
  };
}
export function insertElementBeforeSelection(elem) {
  try {
    var selection = window.getSelection();
    var range = selection.getRangeAt(0);
    range.cloneRange().insertNode(elem);
    selection.addRange(range);
  } catch (e) {}
}
export function getSelectedText() {
  try {
    return window.getSelection().toString();
  } catch (e) {}

  return '';
}
export function hasSelectedText() {
  return getSelectedText().length > 0;
}
export function getSelectedElement() {
  try {
    var selection = window.getSelection();

    if (selection.rangeCount > 0) {
      var elem = selection.getRangeAt(0).startContainer;

      if (elem && _typeof(elem) === 'object') {
        elem = elem.parentNode;
      }

      return elem;
    }
  } catch (e) {}

  return null;
}
export function copyToClipboard(_x) {
  return _copyToClipboard.apply(this, arguments);
}

function _copyToClipboard() {
  _copyToClipboard = _asyncToGenerator(_regeneratorRuntime.mark(function _callee(string) {
    var _navigator8;

    var selection, range, resetSelection, copyFallback, success, newTry;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(typeof window === 'undefined' || typeof document === 'undefined')) {
              _context.next = 2;
              break;
            }

            return _context.abrupt("return", false);

          case 2:
            selection = window.getSelection();
            range = selection.rangeCount > 0 ? selection.getRangeAt(0) : false;

            resetSelection = function resetSelection() {
              try {
                selection.removeAllRanges();
                selection.addRange(range);
              } catch (e) {}
            };

            copyFallback = function copyFallback() {
              try {
                var elem = document.createElement('textarea');
                elem.value = String(string);
                elem.contentEditable = true;
                elem.readOnly = false;
                elem.style.position = 'fixed';
                elem.style.top = '-1000px';
                document.body.appendChild(elem);

                var _success = document.execCommand('copy');

                document.body.removeChild(elem);
                resetSelection();

                if (_success) {
                  return true;
                }
              } catch (e) {
                return e;
              }

              return "Could not copy! Unknown reason. ".concat(string);
            };

            if (!(typeof navigator !== 'undefined' && (_navigator8 = navigator) !== null && _navigator8 !== void 0 && _navigator8.clipboard)) {
              _context.next = 21;
              break;
            }

            _context.prev = 7;
            _context.next = 10;
            return navigator.clipboard.writeText(String(string));

          case 10:
            success = true;
            resetSelection();
            _context.next = 19;
            break;

          case 14:
            _context.prev = 14;
            _context.t0 = _context["catch"](7);
            success = _context.t0;
            newTry = copyFallback();

            if (newTry === true) {
              success = newTry;
            }

          case 19:
            _context.next = 22;
            break;

          case 21:
            success = copyFallback();

          case 22:
            return _context.abrupt("return", success);

          case 23:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[7, 14]]);
  }));
  return _copyToClipboard.apply(this, arguments);
}