import "core-js/modules/es.array.for-each.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.split.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import keycode from 'keycode';
import { warn } from '../component-helper';
export var createShortcut = function () {
  function createShortcut() {
    _classCallCheck(this, createShortcut);

    this.eventTracker = [];
    this.shortcutExists = [];
  }

  _createClass(createShortcut, [{
    key: "add",
    value: function add(shortcut, callback, onDone) {
      var element = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

      if (typeof window === 'undefined' || typeof document === 'undefined' || this.shortcutExists[shortcut] === true) {
        return;
      }

      try {
        element = element || document;
        var timeout = {
          id: null
        };

        var keyDown = function keyDown(e) {
          try {
            var event = e || window.event;
            var code = keycode(event);
            var shortcuts = shortcut.split('+');
            var metaWanted = {
              cmd: false,
              ctrl: false,
              shift: false,
              alt: false
            };
            var metaPressed = {
              cmd: event.metaKey,
              ctrl: event.ctrlKey,
              shift: event.shiftKey,
              alt: event.altKey
            };
            var matches = 0;
            shortcuts.forEach(function (cut) {
              switch (cut) {
                case 'cmd':
                case 'ctrl':
                case 'shift':
                case 'alt':
                  {
                    metaWanted[cut] = true;
                    matches++;
                  }
                  break;

                default:
                  {
                    if (cut === code) {
                      matches++;
                    }
                  }
                  break;
              }
            });

            if (matches === shortcuts.length && metaWanted.cmd === metaPressed.cmd && metaWanted.ctrl === metaPressed.ctrl && metaWanted.shift === metaPressed.shift && metaWanted.alt === metaPressed.alt) {
              callback(event);

              if (typeof onDone === 'function') {
                clearTimeout(timeout.id);
                timeout.id = setTimeout(onDone, 10);
              }
            }
          } catch (e) {
            warn(e);
          }
        };

        var keyUp = function keyUp(e) {
          if (typeof onDone === 'function') {
            onDone(e);
          }
        };

        element.addEventListener('keydown', keyDown);
        element.addEventListener('keyup', keyUp);
        this.eventTracker[shortcut] = {
          timeout: timeout,
          element: element,
          keyDown: keyDown,
          keyUp: keyUp
        };
        this.shortcutExists[shortcut] = true;
      } catch (e) {
        warn(e);
      }
    }
  }, {
    key: "remove",
    value: function remove(shortcut) {
      try {
        shortcut = shortcut.toLowerCase();

        if (this.eventTracker[shortcut]) {
          var _this$eventTracker$sh = this.eventTracker[shortcut],
              timeout = _this$eventTracker$sh.timeout,
              element = _this$eventTracker$sh.element,
              keyDown = _this$eventTracker$sh.keyDown,
              keyUp = _this$eventTracker$sh.keyUp;
          element.removeEventListener('keydown', keyDown, false);
          element.removeEventListener('keyup', keyUp, false);
          clearTimeout(timeout.id);
          delete this.eventTracker[shortcut];
          this.shortcutExists[shortcut] = false;
        }
      } catch (e) {}
    }
  }]);

  return createShortcut;
}();