import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.string.replace.js";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _extends from "@babel/runtime/helpers/esm/extends";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import Context from './Context';
export function getTranslation(id, params) {
  return React.createElement(Translation, _extends({
    id: id
  }, params));
}
export default function useTranslation(id, params) {
  var _React$useContext = React.useContext(Context),
      translation = _React$useContext.translation;

  return prepareTrans(id, params, translation);
}
export var Translation = function (_React$PureComponent) {
  _inherits(Translation, _React$PureComponent);

  var _super = _createSuper(Translation);

  function Translation() {
    _classCallCheck(this, Translation);

    return _super.apply(this, arguments);
  }

  _createClass(Translation, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          children = _this$props.children,
          params = _objectWithoutProperties(_this$props, ["id", "children"]);

      return prepareTrans(id || children, params, this.context.translation);
    }
  }]);

  return Translation;
}(React.PureComponent);
Translation.contextType = Context;
Translation.defaultProps = {
  id: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Translation.propTypes = {
  id: PropTypes.string,
  children: PropTypes.string
} : void 0;

function prepareTrans(id, params, trans) {
  var str = null;

  if (trans[id]) {
    str = trans[id];

    for (var t in params) {
      str = str.replace(new RegExp("{".concat(t, "}"), 'g'), params[t]);
    }
  }

  return str;
}