import "core-js/modules/es.array.from.js";
import "core-js/modules/es.array.reduce.js";
import "core-js/modules/es.object.entries.js";
import "core-js/modules/es.regexp.constructor.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/es.string.replace.js";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { matchAll } from '../shared/component-helper';
import properties from './properties';
import { IS_IE11 } from '../shared/helpers';
var findRegExp = /var\(([^)]*)\)/g;

var stylisPlugin = function stylisPlugin(context, content) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (context !== 1 || props === null && !IS_IE11) {
    return false;
  }

  var matches = matchAll(content, findRegExp);
  var varsToFill = Array.from(matches).reduce(function (acc, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        k = _ref2[0],
        v = _ref2[1];

    if (props && props[v]) {
      acc[v] = props[v];
    } else if (properties[v]) {
      acc[v] = properties[v];
    }

    return acc;
  }, {});
  return Object.entries(varsToFill).reduce(function (acc, _ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        k = _ref4[0],
        v = _ref4[1];

    return acc.replace(new RegExp("var\\(".concat(k, "\\)"), 'g'), v);
  }, content);
};

export default stylisPlugin;
export var withProperties = function withProperties(properties) {
  return function (context, content) {
    return stylisPlugin(context, content, properties);
  };
};