import _extends from "@babel/runtime/helpers/esm/extends";
import { VuePlugin } from 'vuera';
import * as componentsIndex from './components/lib';
import * as elementsIndex from './elements/lib';
export * from './index';
export default {
  getComponents: function getComponents(Vue) {
    Vue.use(VuePlugin);
    var ret = {};

    var components = _extends({}, componentsIndex, elementsIndex);

    for (var c in components) {
      if (components[c] && components[c].tagName) {
        ret[components[c].tagName] = components[c];
      }
    }

    return ret;
  },
  setIgnoredPatterns: function setIgnoredPatterns(Vue) {
    var customPatterns = [];

    var components = _extends({}, componentsIndex, elementsIndex);

    for (var c in components) {
      if (components[c] && components[c].tagName) {
        customPatterns.push(components[c].tagName);
      }
    }

    try {
      Vue.config.ignoredPatterns = customPatterns;
    } catch (e) {
      console.log('setIgnoredPatterns failed on trying to set the "Vue.config.ignoredPatterns"', e);
    }

    return Vue;
  }
};